/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "AviUtils.h"

#include <nmr_string.h>

#include <CError.h>

#include <windows.h>

#include <vfw.h>



void RecalculateFramerate(const char *filename)

{

	int err;

	PAVIFILE	avi_file = 0;

	PAVISTREAM	aud_stream = 0;

	PAVISTREAM	vid_stream_static = 0;

	PAVISTREAM	vid_stream = 0;

	AVISTREAMINFO	aud_info;

	AVISTREAMINFO	vid_info;

	AVIFileInit();



	try {

		if (err = AVIFileOpen(&avi_file,filename,OF_READWRITE,NULL))

			throw CError("Error opening output file",err);

		AVIFileGetStream(avi_file,&vid_stream_static,streamtypeVIDEO,0);

		AVIFileGetStream(avi_file,&aud_stream,streamtypeAUDIO,0);

		if (err = CreateEditableStream(&vid_stream,vid_stream_static))

			throw CError("Could not created editable stream",err);

		if (vid_stream && aud_stream)

			{

			if (err = AVIStreamInfo(aud_stream,&aud_info,sizeof(aud_info)))

				throw CError("Error getting audio stream info",err);

			if (err = AVIStreamInfo(vid_stream,&vid_info,sizeof(vid_info)))

				throw CError("Error getting video stream info",err);

			WAVEFORMATEX	w;

			long siz = sizeof(w);

			AVIStreamReadFormat(aud_stream,0,&w,&siz);



			vid_info.dwRate = vid_info.dwLength * 

				w.nChannels * w.nSamplesPerSec * w.wBitsPerSample;

			vid_info.dwScale = aud_info.dwLength * 8;

			if (err = EditStreamSetInfo(vid_stream,&vid_info,sizeof(vid_info)))

				throw CError("Error setting video stream info",err);



			nmr_string fn = filename;

			fn += ".avi";

			PAVISTREAM ps[2] = {vid_stream,aud_stream};

			if (AVISaveV(fn,NULL,NULL,2,ps,NULL) != AVIERR_OK)

				throw CError("Error creating file",0);

			AVIStreamRelease(aud_stream);

			AVIStreamRelease(vid_stream_static);

			AVIStreamRelease(vid_stream);

			AVIFileRelease(avi_file);

			avi_file = 0;

			aud_stream = 0;

			vid_stream = 0;

			AVIFileExit();

			if (!DeleteFile(filename))

				throw CError("Could not delete file",0);

			if (!MoveFile(fn,filename))

				throw CError("Could not rename file",0);



			}

		}

	catch(...)

		{

		if (aud_stream) AVIStreamRelease(aud_stream);

		if (vid_stream) AVIStreamRelease(vid_stream);

		if (avi_file) AVIFileRelease(avi_file);

		AVIFileExit();



		throw;

		}

}

