/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CACTIVESINK_H_
#define CACTIVESINK_H_

#include <CCThread.h>
#include "CConnection.h"

class CPassiveSource;

// a sink that pulls data from a passive source
class CActiveSink: protected CCThread, public CConnection
{
private:
	int				mTerminate;

	void			GetStreamInfoFromSource(void);
	void			GetStreamFormatFromSource(void);

protected:
	CPassiveSource	*mSource;
	CActiveSink(void);
	virtual ~CActiveSink(void);

	virtual	void	Run(void);

	// returns true if processing should continue
	virtual	int		ProcessData(CPassiveSource *s) = 0;

public:
	virtual	void	Initialize(void);
	virtual	void	Go(void);
	virtual	void	Terminate(void);
	virtual	void	Wait(void);
	virtual	void	SetPassiveSource(CConnection *s);
	virtual	void	Connect(CConnection *c);
};

#endif
