/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CACTIVESOURCE_H_
#define CACTIVESOURCE_H_

#include <CCThread.h>
#include "CConnection.h"

class CPassiveSink;

// pushes data into a passive sink
class CActiveSource: protected CCThread, public CConnection
{
protected:
	int				mTerminate;
	CPassiveSink	*mSink;
	CActiveSource(void);

	virtual	void	Run(void);
	virtual	int		ProcessData(CPassiveSink *s) = 0;
	virtual	void	_SetInfo(void) = 0;


public:
	virtual ~CActiveSource(void);
	virtual	void	Initialize(void);
	virtual	void	Go(void);
	virtual	void	Terminate(void);
	virtual	void	Wait(void);
	virtual	void	SetPassiveSink(CConnection *s);
	virtual	void	Connect(CConnection *c);
};

#endif
