/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CAUTOLINKER_H_

#define CAUTOLINKER_H_



#include <vector.h>

#include "CComponent.h"

#include "NodeStuff.h"



class CWnd;



class CAutoLinker

{

public:

	typedef vector<CComponent *> ComponentList_t;

protected:



	ComponentList_t	mComponentList;

	typedef vector<CConnection *> ConnectionList_t;

	ConnectionList_t	mConnectionList;



	NodeList_t	mNodeList;

	MegaNodeList_t	mMegaNodeList;



	int CompatibleConnections(CConnection::Connection_t t1,

								   CConnection::Connection_t t2);	



	void	_Initiate(int mn);

	void	_Go(int mn);

	void	_Terminate(int mn);

	int		_Configure(int mn,CWnd *wnd);

	void	_Cleanup(int mn);



public:

	CAutoLinker(void) {}

	~CAutoLinker(void);





	void	LinkComponents(ComponentList_t l);

	void	Wait(void);

	void	Initiate(void);

	void	Terminate(void);

	int		Configure(CWnd *wnd);

	void	Cleanup(void);



	CERROR_SUBCLASS(AutoLinkerError);

};



#endif

