/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CCIRCULARBUFFERCOMPONENT_H_

#define CCIRCULARBUFFERCOMPONENT_H_



#include "CComponent.h"



class CCircularBuffer;



class CCircularBufferComponent: public CComponent

{

protected:

	CCircularBuffer	*mAudioBuffer,*mVideoBuffer;

	int			mAudioSinkGiven,mAudioSourceGiven;

	int			mVideoSinkGiven,mVideoSourceGiven;

	int			mAudioPoolSize,mAudioIndicies;

	int			mVideoPoolSize,mVideoIndicies;



public:

	CCircularBufferComponent(CGUIController *gui);

	virtual ~CCircularBufferComponent(void);



	virtual ConnectionTypeList_t	GetSupportedTypes(void) const;

	virtual nmr_string GetName(void) const;

	virtual CConnection *CreateConnection(CConnection::Connection_t t);

	virtual	void	ReturnConnection(CConnection *c,CConnection::Connection_t t);



	virtual	void	Initialize(void);

	virtual	void	Cleanup(void);

	virtual	void	Configure(CWnd *wnd) = 0;

	virtual	int		ConfigureIfNeeded(CWnd *wnd) = 0;



	int	GetPoolSize(CConnection::Connection_t t);

	int	GetIndicies(CConnection::Connection_t t);



};





#endif

