/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "CCircularBufferComponent_NC.h"

#include "CCBDialog.h"



CComponent *

CCircularBufferComponent_NC::CreatorFunc(CGUIController *gui)

{

	return new CCircularBufferComponent_NC(gui);

}



void	

CCircularBufferComponent_NC::Configure(CWnd *wnd)

{

	if (mAudioSinkGiven || mAudioSourceGiven)

		_ConfigureAudio(wnd);

	if (mVideoSinkGiven || mVideoSourceGiven ||

		(!mVideoSinkGiven && !mVideoSourceGiven && !mAudioSinkGiven && !mAudioSourceGiven))

		_ConfigureVideo(wnd);

}



int		

CCircularBufferComponent_NC::ConfigureIfNeeded(CWnd *wnd)

{

	return 1;

}



int

CCircularBufferComponent_NC::_ConfigureAudio(CWnd *wnd)

{

	CCBDialog dlog;



	dlog.mMemoryPool = mAudioPoolSize / 1024;

	dlog.mIndexPool = mAudioIndicies;

	dlog.mNewWindowTitle = "Audio Buffer Configuration";

	if (dlog.DoModal() != IDOK) return 0;



	mAudioPoolSize = dlog.mMemoryPool * 1024;

	mAudioIndicies = dlog.mIndexPool;



	return 1;

}



int

CCircularBufferComponent_NC::_ConfigureVideo(CWnd *wnd)

{

	CCBDialog dlog;



	dlog.mMemoryPool = mVideoPoolSize / 1024;

	dlog.mIndexPool = mVideoIndicies;

	dlog.mNewWindowTitle = "Video Buffer Configuration";

	if (dlog.DoModal() != IDOK) return 0;



	mVideoPoolSize = dlog.mMemoryPool * 1024;

	mVideoIndicies = dlog.mIndexPool;



	return 1;

}



