/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CCOMPONENT_H_

#define CCOMPONENT_H_



#include "CConnection.h"

#include <nmr_string.h>

#include <vector>
using namespace std;


class CGUIController;





class CComponent

{

protected:

	CGUIController	*mGUIController;



	CComponent(CGUIController *gui)

		{ mGUIController = gui;}

public:



	typedef CComponent* (*ComponentCreatorFunction_t)(CGUIController *gui);

	typedef vector<CConnection::Connection_t> ConnectionTypeList_t;



	virtual ~CComponent(void) {}

	virtual ConnectionTypeList_t	GetSupportedTypes(void) const = 0;

	virtual nmr_string GetName(void) const = 0;

	virtual CConnection *CreateConnection(CConnection::Connection_t t) = 0;

	virtual	void	ReturnConnection(CConnection *c,CConnection::Connection_t t);



	virtual	void	Initialize(void) {}

	virtual	void	Configure(CWnd *wnd) = 0;

	virtual	int		ConfigureIfNeeded(CWnd *wnd)= 0;

	virtual	void	Cleanup(void) {}

};





#endif