/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CCONNECTION_H_
#define CCONNECTION_H_

#define CONN_NONE			0
#define CONN_PASSIVE		1
#define CONN_ACTIVE			2
#define CONN_SEEKABLE		4
#define CONN_VIDEO			8
#define CONN_AUDIO			16
#define CONN_SINK			32
#define CONN_SOURCE			64
#define CONN_NEEDSSEEKABLE	128	// partner must be seekable

#include <CError.h>
#include "CStreamInfoObject.h"

class CWnd;

class CConnection
{
public:
	typedef unsigned long	Connection_t;

protected:
	Connection_t	mConnectionType;
	CStreamInfoObject	mStreamInfoObject;

	CConnection(void);

public:
	virtual	~CConnection(void){}
	virtual	Connection_t	GetConnectionType(void);
	virtual	void	Initialize(void){}
	virtual	void	Go(void) {}
	virtual	void	Terminate(void){}
	virtual	void	Wait(void) {}
	virtual	void	Connect(CConnection *c){}
	virtual	void	Cleanup(void) {}

	virtual	CStreamInfoObject&	GetStreamInfoObject();

	CERROR_SUBCLASS(BadConnection);
};



#endif