/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "CDistributedCompressor_NC.h"

#include "CDistributionSettingsDlog.h"



CComponent *

CDistributedCompressor_NC::CreatorFunc(CGUIController *gui)

{

	return new CDistributedCompressor_NC(gui);

}



int

CDistributedCompressor_NC::_Configure(CWnd *wnd)

{

	CDistributionSettingsDlog	dlog;



	struct in_addr	in;

	in.s_addr = htonl(mIPAddr);

	dlog.mChunkSize			= mChunkSize;

	dlog.mTempDir			= mTmpDir;

	dlog.mTCPPort			= mTCPPort;

	dlog.mUDPPort			= mUDPPort;

	dlog.mIPAddress			= inet_ntoa(in);

	dlog.mStartFrame		= mStartFrame;

	dlog.mEndFrame			= mEndFrame;



	if (dlog.DoModal() != IDOK) return 0;

	FILE *f = fopen(dlog.mTempDir + "\\foobar","wb");

	if (!f)

		{

		::MessageBox(NULL,"Bad temp directory","Error",MB_ICONWARNING | MB_OK | MB_APPLMODAL);

		return 0;

		}



	ClearStateMap();

	mChunkSize		= dlog.mChunkSize;

	mTmpDir			= dlog.mTempDir;

	mTCPPort		= dlog.mTCPPort;

	mUDPPort		= dlog.mUDPPort;

	mIPAddr			= ntohl(inet_addr(dlog.mIPAddress));

	mStartFrame		= dlog.mStartFrame;

	mEndFrame		= dlog.mEndFrame;

	mCompVars		= dlog.mCompVars;

	DuckStateBlock_t	dsb;

	dsb.mDuckState		= dlog.mDuckState;

	dsb.mDuckStateSize	= dlog.mDuckStateSize;

	mStateMap[0]		= dsb;

	mKeyFrameRate		= dlog.mKeyFrameRate;



	return LoadStateData();

}



void

CDistributedCompressor_NC::Configure(CWnd *wnd)

{

	if (_Configure(wnd))

		mConfigurationNeeded = 0;

}



int

CDistributedCompressor_NC::ConfigureIfNeeded(CWnd *wnd)

{

	if (!mConfigurationNeeded) return 1;

	return _Configure(wnd);

}



