/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// CDistributedGUI.cpp : implementation file

//



#include "stdafx.h"

#include "NeilCap.h"

#include "CDistributedGUI.h"

#include <stack_aids.h>



#ifdef _DEBUG

#define new DEBUG_NEW

#undef THIS_FILE

static char THIS_FILE[] = __FILE__;

#endif



#define MESS_CLEARSERVERS	1

#define MESS_DELETESERVER	2

#define MESS_ADDSERVER		3

#define MESS_UPDATESERVER	4



/////////////////////////////////////////////////////////////////////////////

// CDistributedGUI



IMPLEMENT_DYNCREATE(CDistributedGUI, CFrameWnd)



CDistributedGUI::CDistributedGUI()

{

	stack_MutexLock sml(&mInitialUpdateMutex);

	mInitialUpdateCalled = 0;

	mList = NULL;

	mFramesProcessed= -1;

	mStatus			= "";

	mActivity		= "";

	mFPS			= -1;

	mListFont.CreateFont(-12,0,0,0,400,FALSE,FALSE,0,ANSI_CHARSET,

		OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,

		DEFAULT_PITCH | FF_SWISS,"Courier");

	Create(AfxRegisterWndClass(CS_NOCLOSE),"Distributed Compressor", WS_OVERLAPPEDWINDOW | WS_VISIBLE);

}



CDistributedGUI::~CDistributedGUI()

{

	delete mList;

}



void

CDistributedGUI::DestroySelf(void)

{

	PostMessage(WM_CLOSE,0,0);

}



BEGIN_MESSAGE_MAP(CDistributedGUI, CFrameWnd)

	//{{AFX_MSG_MAP(CDistributedGUI)

	ON_WM_PAINT()

	ON_WM_ERASEBKGND()

	ON_WM_SIZE()

	//}}AFX_MSG_MAP

END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////

// CDistributedGUI message handlers



BOOL CDistributedGUI::PreCreateWindow(CREATESTRUCT& cs) 

{

	// TODO: Add your specialized code here and/or call the base class

	BOOL result = CFrameWnd::PreCreateWindow(cs);

	if (!result) return result;



	cs.style |= WS_VISIBLE;

	cs.cx = 450;

	cs.cy = 350;

	return TRUE;

}



void CDistributedGUI::OnPaint() 

{

	{

	stack_MutexLock sml(&mInitialUpdateMutex);

	if (!mInitialUpdateCalled)

		OnInitialUpdate();

	mInitialUpdateCalled = 1;

	mInitialUpdateWait.Signal();

	}



	CPaintDC dc(this); // device context for painting

	

	// TODO: Add your message handler code here

	CString	s;



	dc.SetBkColor(::GetSysColor(COLOR_WINDOW));

	dc.TextOut(10,10,"Frames Processed");

	dc.TextOut(10,30,"Average FPS");

	dc.TextOut(10,50,"Status");

	dc.TextOut(10,70,"Activity");

	dc.TextOut(10,90,"Error   Server                                       FPS                   DT");



	if (mFramesProcessed >= 0)

		{

		char buf[100];

		sprintf(buf,"%d",mFramesProcessed);

		dc.TextOut(200,10,buf);

		}

	if (mFPS >= 0)

		{

		char buf[100];

		sprintf(buf,"%f",mFPS);

		dc.TextOut(200,30,buf);

		}

	if (mStatus != "")

		{

		dc.TextOut(200,50,mStatus);

		}

	if (mActivity != "")

		{

		dc.TextOut(200,70,mActivity);

		}

	// Do not call CFrameWnd::OnPaint() for painting messages

}



BOOL CDistributedGUI::OnEraseBkgnd(CDC* pDC) 

{

	// TODO: Add your message handler code here and/or call default

	pDC->FillSolidRect(0,0,32000,32000,::GetSysColor(COLOR_WINDOW));

	return TRUE;

	//return CFrameWnd::OnEraseBkgnd(pDC);

}



void CDistributedGUI::OnSize(UINT nType, int cx, int cy) 

{

	CFrameWnd::OnSize(nType, cx, cy);

	

	// TODO: Add your message handler code here

	RECT r;	

	GetClientRect(&r);

	r.top += 110;

	r.left += 10;



	if (mList)

		mList->MoveWindow(&r);

}



void CDistributedGUI::OnInitialUpdate() 

{

	mList = new CListBox;



	RECT r;	

	GetClientRect(&r);

	r.top += 110;

	r.left += 10;

	mList->Create(WS_VSCROLL | WS_CHILD | WS_VISIBLE,r,this,69);

	mList->SetFont(&mListFont);

	//GetWindowRect(&r);

	//SetWindowPos(&wndTop,r.left,r.top,r.right - r.left,r.bottom - r.top,SWP_SHOWWINDOW);

}



void	

CDistributedGUI::Message_FramesProcessed(int frames)

{

	stack_MutexLock sml(&mInitialUpdateMutex);

	while (!mInitialUpdateCalled)

		mInitialUpdateWait.Wait(mInitialUpdateMutex);



	mFramesProcessed = frames;

	Invalidate();

}



void	

CDistributedGUI::Message_Status(const char *status)

{

	stack_MutexLock sml(&mInitialUpdateMutex);

	while (!mInitialUpdateCalled)

		mInitialUpdateWait.Wait(mInitialUpdateMutex);



	mStatus = status;

	Invalidate();

}



void	

CDistributedGUI::Message_AvgFPS(float fps)

{

	stack_MutexLock sml(&mInitialUpdateMutex);

	while (!mInitialUpdateCalled)

		mInitialUpdateWait.Wait(mInitialUpdateMutex);



	mFPS = fps;

	Invalidate();

}



CString

CDistributedGUI::FormatServer(CServerDesignation d,int err,float fps,int downlink)

{

	CString	s;

	struct in_addr	in;

	in.s_addr = htonl(d.mAddress);

	char buf[100];

	sprintf(buf,"%d",d.mPort);



	s = (err ? "E" : " ");

	s += "    ";



	CString ss;

	ss = inet_ntoa(in);

	ss += ":"; ss += buf;

	while (ss.GetLength() < 22)

		ss += " ";



	s += ss;

	s += "   ";



	sprintf(buf,"%f",fps);

	ss = buf;

	while (ss.GetLength() < 8)

		ss = CString(" ") + ss;



	s += ss;

	s += "     ";

	sprintf(buf,"%d",downlink);

	s += buf;

	return s;

}



void	

CDistributedGUI::Message_AddServer(CServerDesignation d)

{

	PostMessage(WM_USER,MESS_ADDSERVER,(long)new CServerDesignation(d));

}



void	

CDistributedGUI::Message_DeleteServer(CServerDesignation d)

{

	PostMessage(WM_USER,MESS_DELETESERVER,(long)new CServerDesignation(d));

}



class UpdateServerMessage

{

public:

	CServerDesignation	mServerDesignation;

	int					mError;

	float				mFPS;

	int					mDownlink;



	UpdateServerMessage(CServerDesignation &d,int err,float fps,int downlink)

	{ mServerDesignation = d;mError = err; mFPS = fps; mDownlink = downlink; }

};



/*

Listbox calls need to be done via messaging to avoid deadlocks. According

to Microsoft, all MFC calls need to be made from a MFC thread. This seems

to be a hard rule for ListBoxes, but for drawing calls it seems that we

can ignore it

*/



void	

CDistributedGUI::Message_UpdateServer(CServerDesignation d,int err,

														float fps,int downlink)

{

	PostMessage(WM_USER,MESS_UPDATESERVER,

		(long)new UpdateServerMessage(d,err,fps,downlink));

}



void

CDistributedGUI::Message_ClearServers(void)

{

	PostMessage(WM_USER,MESS_CLEARSERVERS,0);

}



void

CDistributedGUI::Message_Activity(const char *act)

{

	stack_MutexLock sml(&mInitialUpdateMutex);

	while (!mInitialUpdateCalled)

		mInitialUpdateWait.Wait(mInitialUpdateMutex);



	mActivity = act;

	Invalidate();

}







LRESULT CDistributedGUI::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 

{

	// TODO: Add your specialized code here and/or call the base class

	if (message == WM_USER)

		{

		switch(wParam)

			{

			case MESS_CLEARSERVERS:

				{

				stack_MutexLock sml(&mInitialUpdateMutex);

				while (!mInitialUpdateCalled)

					mInitialUpdateWait.Wait(mInitialUpdateMutex);



				mServerList.erase(mServerList.begin(),mServerList.end());

				mList->ResetContent();

				}

				break;

			case MESS_DELETESERVER:

				{

				CServerDesignation *d = (CServerDesignation *)lParam;

				stack_MutexLock sml(&mInitialUpdateMutex);

				while (!mInitialUpdateCalled)

					mInitialUpdateWait.Wait(mInitialUpdateMutex);



				ServerList_t::iterator i;

				int x = 0;

				for (x = 0,i = mServerList.begin(); i != mServerList.end(); ++i,++x)

					{

					if ((*i) == (*d))

						{

						mList->DeleteString(x);

						mServerList.erase(i);

						break;

						}

					}

				delete d;

				}

				break;

			case MESS_ADDSERVER:

				{

				CServerDesignation *d = (CServerDesignation *)lParam;

				stack_MutexLock sml(&mInitialUpdateMutex);

				while (!mInitialUpdateCalled)

					mInitialUpdateWait.Wait(mInitialUpdateMutex);



				CString s = FormatServer(*d,0,0,0);

				ServerList_t::iterator i;

				int found = 0;

				for (i = mServerList.begin(); i != mServerList.end(); ++i)

					{

					if ((*i) == (*d)) {found = 1; break; }

					}

				if (!found)

					{

					mList->AddString(s);

					mServerList.push_back(*d);

					}

				delete d;

				}

				break;

			case MESS_UPDATESERVER:

				{

				UpdateServerMessage *m = (UpdateServerMessage *)lParam;

				stack_MutexLock sml(&mInitialUpdateMutex);

				while (!mInitialUpdateCalled)

					mInitialUpdateWait.Wait(mInitialUpdateMutex);



				CString s = FormatServer(m->mServerDesignation,m->mError,

													m->mFPS,m->mDownlink);



				ServerList_t::iterator i;

				int x;

				for (x = 0,i = mServerList.begin(); i != mServerList.end(); ++i,++x)

					{

					if ((*i) == (m->mServerDesignation))

						{

						mList->DeleteString(x);

						mList->InsertString(x,s);

						break;

						}

					}

				delete m;

				}

				break;

			}

		return 0;

		}

	return CFrameWnd::WindowProc(message, wParam, lParam);



}

