/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// CDistributedGUI.h : header file

//



/////////////////////////////////////////////////////////////////////////////

// CDistributedGUI frame

#include <list.h>

#include "CServerDesignation.h"

#include "CCompressionCoordinator.h"

#include <CCMutex.h>

#include <CConditionVariable.h>



class CDistributedGUI : public CFrameWnd

{

	DECLARE_DYNCREATE(CDistributedGUI)

protected:

	CDistributedGUI();           // protected constructor used by dynamic creation



// Attributes

public:



// Operations

public:



// Overrides

	// ClassWizard generated virtual function overrides

	//{{AFX_VIRTUAL(CDistributedGUI)

	protected:

	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);

	//}}AFX_VIRTUAL



// Implementation

public:

	virtual ~CDistributedGUI();

	void	Message_FramesProcessed(int frames);

	void	Message_Status(const char *status);

	void	Message_AvgFPS(float fps);

	void	Message_AddServer(CServerDesignation d);

	void	Message_DeleteServer(CServerDesignation d);

	void	Message_UpdateServer(CServerDesignation d,int err,float fps,int downlink);

	void	Message_ClearServers(void);

	void	Message_Activity(const char *act);

	void	DestroySelf(void);

protected:

	CListBox	*mList;

	CFont		mListFont;



	int			mFramesProcessed;

	CString		mStatus;

	CString		mActivity;

	float		mFPS;

	typedef list<CServerDesignation> ServerList_t;

	ServerList_t			mServerList;

	int			mInitialUpdateCalled;

	CCMutex		mInitialUpdateMutex;

	CConditionVariable	mInitialUpdateWait;



	void OnInitialUpdate(void);



	CString	FormatServer(CServerDesignation d,int err,float fps,int downlink);



	// Generated message map functions

	//{{AFX_MSG(CDistributedGUI)

	afx_msg void OnPaint();

	afx_msg BOOL OnEraseBkgnd(CDC* pDC);

	afx_msg void OnSize(UINT nType, int cx, int cy);

	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

};



/////////////////////////////////////////////////////////////////////////////

