/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// CDistributedGUIThread.cpp : implementation file

//



#include "stdafx.h"

#include "NeilCap.h"

#include "CDistributedGUIThread.h"

#include "CDistributedGUI.h"

#include <stack_aids.h>



#ifdef _DEBUG

#define new DEBUG_NEW

#undef THIS_FILE

static char THIS_FILE[] = __FILE__;

#endif



/////////////////////////////////////////////////////////////////////////////

// CDistributedGUIThread



IMPLEMENT_DYNCREATE(CDistributedGUIThread, CWinThread)



CDistributedGUIThread::CDistributedGUIThread()

{

	stack_MutexLock sml(&mNoMoreMutex);



	mNoMoreMessages = 0;

}



CDistributedGUIThread::~CDistributedGUIThread()

{

}



BOOL CDistributedGUIThread::InitInstance()

{

	// TODO:  perform and per-thread initialization here

	mDistributedGUI = dynamic_cast<CDistributedGUI*>(

		RUNTIME_CLASS(CDistributedGUI)->CreateObject());

	

	RECT r;

	mDistributedGUI->ShowWindow(SW_RESTORE);

	mDistributedGUI->GetWindowRect(&r);

	mDistributedGUI->SetWindowPos(&CWnd::wndTopMost,r.left,r.top,r.right - r.left,r.bottom - r.top,SWP_SHOWWINDOW);

	mDistributedGUI->SetWindowPos(&CWnd::wndNoTopMost,r.left,r.top,r.right - r.left,r.bottom - r.top,SWP_SHOWWINDOW);

	assert(mDistributedGUI);

	m_pMainWnd = mDistributedGUI;



	return TRUE;

}



int CDistributedGUIThread::ExitInstance()

{

	// TODO:  perform any per-thread cleanup here

	return CWinThread::ExitInstance();

}



BEGIN_MESSAGE_MAP(CDistributedGUIThread, CWinThread)

	//{{AFX_MSG_MAP(CDistributedGUIThread)

		// NOTE - the ClassWizard will add and remove mapping macros here.

	//}}AFX_MSG_MAP

END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////

// CDistributedGUIThread message handlers

void	

CDistributedGUIThread::Message_FramesProcessed(int frames)

{

	stack_MutexLock sml2(&mNoMoreMutex);

	if (mNoMoreMessages) return;



	stack_MutexLock sml(&mMutex);

	while (!mDistributedGUI)

		mWait.Wait(mMutex);



	mDistributedGUI->Message_FramesProcessed(frames);

}



void	

CDistributedGUIThread::Message_Status(const char *status)

{

	stack_MutexLock sml2(&mNoMoreMutex);

	if (mNoMoreMessages) return;



	stack_MutexLock sml(&mMutex);

	while (!mDistributedGUI)

		mWait.Wait(mMutex);



	mDistributedGUI->Message_Status(status);

}



void	

CDistributedGUIThread::Message_AvgFPS(float fps)

{

	stack_MutexLock sml2(&mNoMoreMutex);

	if (mNoMoreMessages) return;



	stack_MutexLock sml(&mMutex);

	while (!mDistributedGUI)

		mWait.Wait(mMutex);



	mDistributedGUI->Message_AvgFPS(fps);

}



void	

CDistributedGUIThread::Message_AddServer(CServerDesignation d)

{

	stack_MutexLock sml2(&mNoMoreMutex);

	if (mNoMoreMessages) return;



	stack_MutexLock sml(&mMutex);

	while (!mDistributedGUI)

		mWait.Wait(mMutex);



	mDistributedGUI->Message_AddServer(d);

}



void	

CDistributedGUIThread::Message_DeleteServer(CServerDesignation d)

{

	stack_MutexLock sml2(&mNoMoreMutex);

	if (mNoMoreMessages) return;



	stack_MutexLock sml(&mMutex);

	while (!mDistributedGUI)

		mWait.Wait(mMutex);



	mDistributedGUI->Message_DeleteServer(d);

}



void	

CDistributedGUIThread::Message_UpdateServer(CServerDesignation d,int err,

											float fps,int downlink)

{

	stack_MutexLock sml2(&mNoMoreMutex);

	if (mNoMoreMessages) return;



	stack_MutexLock sml(&mMutex);

	while (!mDistributedGUI)

		mWait.Wait(mMutex);



	mDistributedGUI->Message_UpdateServer(d,err,fps,downlink);

}



void	

CDistributedGUIThread::Message_ClearServers(void)

{

	stack_MutexLock sml2(&mNoMoreMutex);

	if (mNoMoreMessages) return;



	stack_MutexLock sml(&mMutex);

	while (!mDistributedGUI)

		mWait.Wait(mMutex);



	mDistributedGUI->Message_ClearServers();

}



void	

CDistributedGUIThread::Message_Activity(const char *act)

{

	stack_MutexLock sml2(&mNoMoreMutex);

	if (mNoMoreMessages) return;



	stack_MutexLock sml(&mMutex);

	while (!mDistributedGUI)

		mWait.Wait(mMutex);



	mDistributedGUI->Message_Activity(act);

}



void	

CDistributedGUIThread::DestroySelf(void)

{

	stack_MutexLock sml2(&mNoMoreMutex);

	if (mNoMoreMessages) return;



	stack_MutexLock sml(&mMutex);

	while (!mDistributedGUI)

		mWait.Wait(mMutex);



	mDistributedGUI->DestroySelf();

}



