/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// CDistributedGUIThread.h : header file

//

class CDistributedGUI;

#include "CServerDesignation.h"

#include <CCMutex.h>

#include <CConditionVariable.h>





/////////////////////////////////////////////////////////////////////////////

// CDistributedGUIThread thread



class CDistributedGUIThread : public CWinThread

{

	DECLARE_DYNCREATE(CDistributedGUIThread)

protected:

	CDistributedGUIThread();           // protected constructor used by dynamic creation



	CDistributedGUI	*mDistributedGUI;

	CCMutex				mMutex;

	CConditionVariable mWait;

	int					mNoMoreMessages;

	CCMutex				mNoMoreMutex;



// Attributes

public:



// Operations

public:

	void	Message_FramesProcessed(int frames);

	void	Message_Status(const char *status);

	void	Message_AvgFPS(float fps);

	void	Message_AddServer(CServerDesignation d);

	void	Message_DeleteServer(CServerDesignation d);

	void	Message_UpdateServer(CServerDesignation d,int err,float fps,int downlink);

	void	Message_ClearServers(void);

	void	Message_Activity(const char *act);

	void	DestroySelf(void);



// Overrides

	// ClassWizard generated virtual function overrides

	//{{AFX_VIRTUAL(CDistributedGUIThread)

	public:

	virtual BOOL InitInstance();

	virtual int ExitInstance();

	//}}AFX_VIRTUAL



// Implementation

protected:

	virtual ~CDistributedGUIThread();



	// Generated message map functions

	//{{AFX_MSG(CDistributedGUIThread)

		// NOTE - the ClassWizard will add and remove member functions here.

	//}}AFX_MSG



	DECLARE_MESSAGE_MAP()

};



/////////////////////////////////////////////////////////////////////////////

