/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// CDistributionSettingsDlog.cpp : implementation file

//



#include "stdafx.h"

#include "NeilCap.h"

#include "CDistributionSettingsDlog.h"

#include <assert.h>



#ifdef _DEBUG

#define new DEBUG_NEW

#undef THIS_FILE

static char THIS_FILE[] = __FILE__;

#endif



/////////////////////////////////////////////////////////////////////////////

// CDistributionSettingsDlog dialog





CDistributionSettingsDlog::CDistributionSettingsDlog(CWnd* pParent /*=NULL*/)

	: CDialog(CDistributionSettingsDlog::IDD, pParent)

{

	//{{AFX_DATA_INIT(CDistributionSettingsDlog)

	mIPAddress = _T("");

	mTCPPort = 0;

	mUDPPort = 0;

	mTempDir = _T("");

	mEndFrame = 0;

	mStartFrame = 0;

	mChunkSize = 0;

	//}}AFX_DATA_INIT



	mCompressorChosen = 0;

	mDuckState = NULL;

	mDuckStateSize = 0;

}





void CDistributionSettingsDlog::DoDataExchange(CDataExchange* pDX)

{

	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CDistributionSettingsDlog)

	DDX_Text(pDX, IDC_IPADDRESS, mIPAddress);

	DDX_Text(pDX, IDC_TCPPORT, mTCPPort);

	DDX_Text(pDX, IDC_UDPPORT, mUDPPort);

	DDX_Text(pDX, IDC_TEMPDIRECTORY, mTempDir);

	DDX_Text(pDX, IDC_ENDFRAME, mEndFrame);

	DDX_Text(pDX, IDC_STARTFRAME, mStartFrame);

	DDX_Text(pDX, IDC_CHUNKSIZE, mChunkSize);

	//}}AFX_DATA_MAP

}





BEGIN_MESSAGE_MAP(CDistributionSettingsDlog, CDialog)

	//{{AFX_MSG_MAP(CDistributionSettingsDlog)

	ON_BN_CLICKED(IDC_SELECTCOMPRESSOR, OnSelectcompressor)

	//}}AFX_MSG_MAP

END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////

// CDistributionSettingsDlog message handlers



BOOL CDistributionSettingsDlog::OnInitDialog() 

{

	CDialog::OnInitDialog();

	



	// TODO: Add extra initialization here

	CButton *button = (CButton *)GetDlgItem(IDOK);

	assert(button);

	button->EnableWindow(mCompressorChosen);

	

	return TRUE;  // return TRUE unless you set the focus to a control

	              // EXCEPTION: OCX Property Pages should return FALSE

}



void CDistributionSettingsDlog::OnSelectcompressor() 

{

	// TODO: Add your control notification handler code here

	BOOL err;

	

	// try/catch because of TM2 bug

	try

		{

		while (1)

			{

			memset(&mCompVars,0,sizeof(mCompVars));

			mCompVars.cbSize = sizeof(mCompVars);

			mCompVars.fccHandler = MKFOURCC('T','M','2','0');

			mCompVars.dwFlags = ICMF_COMPVARS_VALID;

						

			err = ICCompressorChoose(AfxGetApp()->GetMainWnd()->m_hWnd,ICMF_CHOOSE_ALLCOMPRESSORS,

						NULL,NULL,&mCompVars,"Duck Distributed Compressor");

			if (mCompVars.fccHandler != MKFOURCC('T','M','2','0') &&

				mCompVars.fccHandler != MKFOURCC('t','m','2','0') && err)

				{

				::MessageBox(NULL,"You can only use TrueMotion 2.0","Error",MB_ICONWARNING | MB_OK | MB_APPLMODAL);

				ICCompressorFree(&mCompVars);			

				}

			else

				{

				break;

				}

			}

		}

	catch(...) 

		{

		}



	if (err != FALSE)

		{

		delete [] mDuckState;

		mDuckState = NULL;

		mDuckStateSize = 0;

		mKeyFrameRate = ICGetDefaultKeyFrameRate(mCompVars.hic);

		mDuckStateSize = ICGetState(mCompVars.hic,NULL,mDuckStateSize);

		mDuckState = new char[mDuckStateSize];

		ICGetState(mCompVars.hic,mDuckState,mDuckStateSize);

		ICCompressorFree(&mCompVars);

		}

	mCompressorChosen = err;	

	CButton *button = (CButton *)GetDlgItem(IDOK);

	assert(button);

	button->EnableWindow(mCompressorChosen);	

}

