/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CMONITORTHREAD_H_

#define CMONITORTHREAD_H_



#include <CCThread.h>

#include <CCMutex.h>

#include <CConditionVariable.h>

#include "CAutoLinker.h"

#include "CGUIController.h"





class CMonitorThread: public CCThread

{

protected:

	CWnd					*mWindow;

	CGUIController			mGUIController;

	int						mCanCleanup;

	CCMutex					mCanCleanupMutex;

	CConditionVariable		mCanCleanupWait;



	CAutoLinker				*mAutoLinker;

	CAutoLinker::ComponentList_t	mComponentList;

	CCMutex	mCleanupMutex;

	int		mNeedsCleanup;



	virtual void Run(void);

			void	Cleanup(void);



public:

	CMonitorThread(CWnd *main_window);

	virtual ~CMonitorThread(void);

	int	Prepare(void);

	void	Terminate(void);

};







#endif

