/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CPASSIVESINK_H_
#define CPASSIVESINK_H_

#include "CConnection.h"

class CPassiveSink;

class CPassiveSinkDataReference
{
protected:
	char	*mWritePtr;
	size_t	mSize;
	U32		mFlags;
	int		mOwnsData;

public:
	CPassiveSinkDataReference(void); 
	CPassiveSinkDataReference(char *ptr,size_t len,U32 flags,int owns_data);
	virtual ~CPassiveSinkDataReference(void);
	virtual	char	*GetWritePtr(void) const;
	virtual	void	SetWritePtr(char *w);
	virtual	size_t	GetSize(void) const;
	virtual	void	SetSize(size_t s);
	virtual	void	SetFlags(U32 flags);
	virtual	U32		GetFlags(void) const;

	virtual	void	Set(char *ptr,size_t len,U32 flags,int owns_data);
};


// an abstract class that can accept data chunks
class CPassiveSink: public CConnection
{
protected:
	CPassiveSink(void);
	virtual ~CPassiveSink(void){}
	virtual	void	_Initialize(void) {}

public:

	// get a place to put data
	virtual	CPassiveSinkDataReference *GetDataReference(size_t) = 0;
	virtual	void	ReturnDataReference(CPassiveSinkDataReference *r) = 0;
	virtual	int		ConsumeDataNow(const CPassiveSinkDataReference *r) = 0;
	virtual	void	DataComplete(void) = 0;

	virtual	void	Initialize(void);
	virtual	void	Go(void) {}
	virtual	void	Terminate(void) {}
};

#endif
