/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "CPassiveSource.h"


CPassiveSource::CPassiveSource(void)
{
	mConnectionType |= (CONN_SOURCE | CONN_PASSIVE);
}

void
CPassiveSource::Initialize(void)
{
	SetupStreamInfo();
	SetupStreamFormat();
}

////////////////////////////////

CPassiveSourceDataReference::CPassiveSourceDataReference(
	char *data,size_t len,U32 flags,int owns_data)
{
	mOwnsData 	= owns_data;
	mData 		= data;
	mDataLen 	= len;
	mFlags 	= flags;
}


CPassiveSourceDataReference::~CPassiveSourceDataReference(void)
{
	if (mOwnsData)
		delete [] mData;
}

void	
CPassiveSourceDataReference::RedeemData(const char * &data,size_t &len,U32 &flags)
{ 
	data = mData; 
	len = mDataLen; 
	flags = mFlags; 
}
