/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CPASSIVESOURCE_H_
#define CPASSIVESOURCE_H_

#include <CError.h>
#include "CConnection.h"

class CPassiveSource;

// class from which data is pulled is a linear fashion
class CPassiveSourceDataReference
{
protected:
	char		*mData;
	size_t		mDataLen;
	U32			mFlags;
	int			mOwnsData;

	CPassiveSourceDataReference(void) {}
public:
	CPassiveSourceDataReference(char *data,size_t len,U32 flags,int ownsdata);
	virtual ~CPassiveSourceDataReference(void);
	virtual	void	RedeemData(const char * &data,size_t &len,U32 &flags);
};

class CPassiveSource: public CConnection
{
protected:
	CPassiveSource(void);
	virtual ~CPassiveSource(void) {}

	virtual	void	SetupStreamInfo(void) = 0;
	virtual	void	SetupStreamFormat(void) = 0;

public:
	typedef enum { DIR_FORWARD,DIR_BACKWARD,DIR_ABSOLUTE } Direction_t;

	// return NULL if there is no more data to be had
	virtual CPassiveSourceDataReference* GetData(void) 
		{ return GetData(1,DIR_FORWARD); }
	virtual	CPassiveSourceDataReference* GetData(int index,Direction_t dir) = 0;
	virtual	void	ReturnData(CPassiveSourceDataReference *r) = 0;

	virtual	void	Initialize(void);
	virtual	void	Go(void) {}
	virtual	void	Terminate(void) {}
};

#endif
