/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CSERVERDESIGNATION_H_

#define CSERVERDESIGNATION_H_



#include <ostream.h>



class CServerDesignation

{

public:

	unsigned long	mAddress;

	int				mPort;

	CServerDesignation(unsigned long addr = 0,int port = 0)

	{ mAddress = addr; mPort = port; }

	CServerDesignation(const CServerDesignation &d)

	{ mAddress = d.mAddress; mPort = d.mPort;}

	CServerDesignation& operator=(const CServerDesignation &d)

	{ mAddress = d.mAddress; mPort = d.mPort; return *this; }

	int operator==(const CServerDesignation &d) const

	{ return ((mAddress == d.mAddress) && (mPort == d.mPort)); }

	int operator<(const CServerDesignation &d) const

	{ if (mAddress == d.mAddress) return (mPort < d.mPort);

	  return (mAddress < d.mAddress);

	}

};

ostream& operator<<(ostream &o,const CServerDesignation &d);



#endif

