/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CSTREAMINFOOBJECT_H_
#define CSTREAMINFOOBJECT_H_

#include <CCMutex.h>
#include <CConditionVariable.h>
#include <vfw.h>

class CStreamInfoObject
{
private:
	AVISTREAMINFO	mStreamInfo;
	char			*mStreamFormat;
	size_t			mStreamFormatSize;
	int				mStreamFormatSet,mStreamInfoSet;
	CCMutex			mStreamFormatMutex,mStreamInfoMutex;
	CConditionVariable	mStreamFormatWait,mStreamInfoWait;

public:
	CStreamInfoObject(void);
	CStreamInfoObject(const CStreamInfoObject &o);
	CStreamInfoObject &operator=(const CStreamInfoObject &o);

	~CStreamInfoObject(void);
	void			Clear(void);
	void			SetStreamInfo(AVISTREAMINFO &i);
	void			SetStreamFormat(const char *f,size_t s);
	AVISTREAMINFO	GetStreamInfo(void);
	size_t			GetStreamFormatSize(void);
	const char		*GetStreamFormat(void);
	int				IsStreamInfoSet(void);
	int				IsStreamFormatSet(void);
	void			WaitForStreamFormatSet(void);
	void			WaitForStreamInfoSet(void);	
};
#endif
