/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// NeilCap.cpp : Defines the class behaviors for the application.

//



#include "stdafx.h"

#include "NeilCap.h"



#include "MainFrm.h"

#include "NeilCapDoc.h"

#include "NeilCapView.h"

//#include "CMonitorThread.h"

#include <CLogger.h>



CLogger *gTraceLog;

CLogger *gErrorLog;

CLogger *gLogLog;



#ifndef NDEBUG

int gErrorLogF;

int gTraceLogF;

int gLogLogF;

#endif



#ifdef _DEBUG

#define new DEBUG_NEW

#undef THIS_FILE

static char THIS_FILE[] = __FILE__;

#endif



/////////////////////////////////////////////////////////////////////////////

// CNeilCapApp



BEGIN_MESSAGE_MAP(CNeilCapApp, CWinApp)

	//{{AFX_MSG_MAP(CNeilCapApp)

	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)

	ON_COMMAND(ID_APP_EXIT, OnAppExit)

	//}}AFX_MSG_MAP

	// Standard file based document commands

	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)

	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)

END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////

// CNeilCapApp construction



CNeilCapApp::CNeilCapApp()

{

	// TODO: add construction code here,

	// Place all significant initialization in InitInstance

}



/////////////////////////////////////////////////////////////////////////////

// The one and only CNeilCapApp object



CNeilCapApp theApp;



/////////////////////////////////////////////////////////////////////////////

// CNeilCapApp initialization





BOOL CNeilCapApp::InitInstance()

{

	// Standard initialization

	// If you are not using these features and wish to reduce the size

	//  of your final executable, you should remove from the following

	//  the specific initialization routines you do not need.



#ifdef _AFXDLL

	Enable3dControls();			// Call this when using MFC in a shared DLL

#else

	Enable3dControlsStatic();	// Call this when linking to MFC statically

#endif



	SetRegistryKey("The Duck Corporation");



	LoadStdProfileSettings();  // Load standard INI file options (including MRU)



	// Register the application's document templates.  Document templates

	//  serve as the connection between documents, frame windows and views.



	CSingleDocTemplate* pDocTemplate;

	pDocTemplate = new CSingleDocTemplate(

		IDR_MAINFRAME,

		RUNTIME_CLASS(CNeilCapDoc),

		RUNTIME_CLASS(CMainFrame),       // main SDI frame window

		RUNTIME_CLASS(CNeilCapView));

	AddDocTemplate(pDocTemplate);



	// Parse command line for standard shell commands, DDE, file open

	CCommandLineInfo cmdInfo;

	ParseCommandLine(cmdInfo);



	// Dispatch commands specified on the command line

	if (!ProcessShellCommand(cmdInfo))

		return FALSE;



	//mMonitorThread = 0;





#ifndef NDEBUG

	gErrorLogF = _open("C:\\errorlog.txt",

						_O_CREAT | _O_TRUNC | O_WRONLY, _S_IREAD | _S_IWRITE);

	gTraceLogF = _open("C:\\tracelog.txt",

						_O_CREAT | _O_TRUNC | O_WRONLY, _S_IREAD | _S_IWRITE);

	gLogLogF = _open("C:\\loglog.txt",

						_O_CREAT | _O_TRUNC | O_WRONLY, _S_IREAD | _S_IWRITE);

	gTraceLog = new CLogger(20,1,gTraceLogF,0,"neilcap");

	gLogLog = new CLogger(20,1,gLogLogF,0,"neilcap");

	gErrorLog = new CLogger(20,1,gErrorLogF,0,"neilcap");



#else

	gTraceLog = new CLogger(10,0,0,0,"neilcap");

	gLogLog = new CLogger(10,0,0,0,"neilcap");

	gErrorLog = new CLogger(10,0,0,0,"neilcap");

#endif

	gErrorLog->Start();

	gTraceLog->Start();

	gLogLog->Start();





	return TRUE;

}



/////////////////////////////////////////////////////////////////////////////

// CAboutDlg dialog used for App About



class CAboutDlg : public CDialog

{

public:

	CAboutDlg();



// Dialog Data

	//{{AFX_DATA(CAboutDlg)

	enum { IDD = IDD_ABOUTBOX };

	//}}AFX_DATA



	// ClassWizard generated virtual function overrides

	//{{AFX_VIRTUAL(CAboutDlg)

	protected:

	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	//}}AFX_VIRTUAL



// Implementation

protected:

	//{{AFX_MSG(CAboutDlg)

		// No message handlers

	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

};



CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)

{

	//{{AFX_DATA_INIT(CAboutDlg)

	//}}AFX_DATA_INIT

}



void CAboutDlg::DoDataExchange(CDataExchange* pDX)

{

	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CAboutDlg)

	//}}AFX_DATA_MAP

}



BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)

	//{{AFX_MSG_MAP(CAboutDlg)

		// No message handlers

	//}}AFX_MSG_MAP

END_MESSAGE_MAP()



// App command to run the dialog

void CNeilCapApp::OnAppAbout()

{

	CAboutDlg aboutDlg;

	aboutDlg.DoModal();

}



/////////////////////////////////////////////////////////////////////////////

// CNeilCapApp commands



void CNeilCapApp::OnAppExit() 

{

	// TODO: Add your command handler code here

	//TERMINATE_JOIN_DELETE_CLEAR(mMonitorThread);



	if (gLogLog)

		gLogLog->Terminate();

	if (gErrorLog)

		gErrorLog->Terminate();

	if (gTraceLog)

		gTraceLog->Terminate();

	if (gLogLog)

		gLogLog->Join();

	if (gErrorLog)

		gErrorLog->Join();

	if (gTraceLog)

		gTraceLog->Join();

	delete gLogLog;

	gLogLog = 0;

	delete gErrorLog;

	gErrorLog = 0;

	delete gTraceLog;

	gTraceLog = 0;

	

#ifndef NDEBUG

	close(gErrorLogF);

	close(gTraceLogF);

	close(gLogLogF);

#endif



	m_pMainWnd->SendMessage(WM_CLOSE);

}





