/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// NeilCapDoc.cpp : implementation of the CNeilCapDoc class

//



#include "stdafx.h"

#include "NeilCap.h"



#include "NeilCapDoc.h"

#include "NeilCapView.h"

#include "CGraphManager.h"

#include "CNeilCapGUIController.h"

#include "CAddComponentDialog.h"



#ifdef _DEBUG

#define new DEBUG_NEW

#undef THIS_FILE

static char THIS_FILE[] = __FILE__;

#endif



/////////////////////////////////////////////////////////////////////////////

// CNeilCapDoc



IMPLEMENT_DYNCREATE(CNeilCapDoc, CDocument)



BEGIN_MESSAGE_MAP(CNeilCapDoc, CDocument)

	//{{AFX_MSG_MAP(CNeilCapDoc)

	ON_COMMAND(ID_ADD_COMPONENT, OnAddComponent)

	ON_UPDATE_COMMAND_UI(ID_ADD_COMPONENT, OnUpdateAddComponent)

	ON_COMMAND(ID_DELETE_COMPONENT, OnDeleteComponent)

	ON_UPDATE_COMMAND_UI(ID_DELETE_COMPONENT, OnUpdateDeleteComponent)

	ON_COMMAND(ID_CONFIGURE_COMPONENT, OnConfigureComponent)

	ON_UPDATE_COMMAND_UI(ID_CONFIGURE_COMPONENT, OnUpdateConfigureComponent)

	ON_COMMAND(ID_HALT, OnHalt)

	ON_UPDATE_COMMAND_UI(ID_HALT, OnUpdateHalt)

	ON_COMMAND(ID_RUN, OnRun)

	ON_UPDATE_COMMAND_UI(ID_RUN, OnUpdateRun)

	//}}AFX_MSG_MAP

END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////

// CNeilCapDoc construction/destruction



CNeilCapDoc::CNeilCapDoc()

{

	// TODO: add one-time construction code here

	mGUIController	= 0;

	mGraphManager	= 0;



}



CNeilCapDoc::~CNeilCapDoc()

{

	ClearAll();

}



void

CNeilCapDoc::ClearAll(void)

{

	delete mGraphManager;

	mGraphManager	= 0;

	delete mGUIController;

	mGUIController	= 0;

}



void

CNeilCapDoc::SetMainView(CNeilCapView *view)

{

	mMainView = view;

	delete mGraphManager;

	mGraphManager = 0;

	delete mGUIController;

	mGUIController = 0;

	mGUIController = new CNeilCapGUIController(view);

	mGraphManager = new CGraphManager(mGUIController,mComponentFactory);

	mGUIController->SetGraphManager(mGraphManager);

	view->SetGUIController(mGUIController);

}



BOOL CNeilCapDoc::OnNewDocument()

{

	if (!CDocument::OnNewDocument())

		return FALSE;



	// TODO: add reinitialization code here

	// (SDI documents will reuse this document)

	return TRUE;

}



/////////////////////////////////////////////////////////////////////////////

// CNeilCapDoc serialization



void CNeilCapDoc::Serialize(CArchive& ar)

{

	if (ar.IsStoring())

	{

		// TODO: add storing code here

	}

	else

	{

		// TODO: add loading code here

	}

}



/////////////////////////////////////////////////////////////////////////////

// CNeilCapDoc diagnostics



#ifdef _DEBUG

void CNeilCapDoc::AssertValid() const

{

	CDocument::AssertValid();

}



void CNeilCapDoc::Dump(CDumpContext& dc) const

{

	CDocument::Dump(dc);

}

#endif //_DEBUG



/////////////////////////////////////////////////////////////////////////////

// CNeilCapDoc commands



void CNeilCapDoc::OnAddComponent() 

{

	// TODO: Add your command handler code here

	assert(mGraphManager);

	CAddComponentDialog dlog;

	dlog.SetListEntries(mGraphManager->GetComponentNameList());

	if (dlog.DoModal() != IDOK) return;

	mGraphManager->AddComponent(dlog.mList);

}



void CNeilCapDoc::OnUpdateAddComponent(CCmdUI* pCmdUI) 

{

	// TODO: Add your command update UI handler code here

	pCmdUI->Enable(FALSE);

	if (mGraphManager && !mGraphManager->IsRunning())

		{

		pCmdUI->Enable(TRUE);

		}

	

}



void CNeilCapDoc::OnDeleteComponent() 

{

	// TODO: Add your command handler code here

	if (mGUIController)

		mGUIController->DeleteSelectedComponent();

	

}



void CNeilCapDoc::OnUpdateDeleteComponent(CCmdUI* pCmdUI) 

{

	// TODO: Add your command update UI handler code here

	pCmdUI->Enable(FALSE);

	if (mGraphManager && !mGraphManager->IsRunning() && mGUIController

		&& mGUIController->GetSelectedComponent() > -1)

		{

		pCmdUI->Enable(TRUE);

		}

	

}



void

CNeilCapDoc::Do_ConfigureComponent(void)

{

	if (mGraphManager && !mGraphManager->IsRunning() && mGUIController)

		mGUIController->ConfigureSelectedComponent();

}



void CNeilCapDoc::OnConfigureComponent() 

{

	// TODO: Add your command handler code here

	Do_ConfigureComponent();

}



void CNeilCapDoc::OnUpdateConfigureComponent(CCmdUI* pCmdUI) 

{

	// TODO: Add your command update UI handler code here

	pCmdUI->Enable(FALSE);

	if (mGraphManager && !mGraphManager->IsRunning() && mGUIController)

		pCmdUI->Enable(mGUIController->GetSelectedComponent() == -1 ? FALSE : TRUE);



}



void CNeilCapDoc::OnHalt() 

{

	// TODO: Add your command handler code here

	if (!mGraphManager) return;

	mGraphManager->Halt();

}



void CNeilCapDoc::OnUpdateHalt(CCmdUI* pCmdUI) 

{

	// TODO: Add your command update UI handler code here

	pCmdUI->Enable(mGraphManager && mGraphManager->IsRunning());

}



void CNeilCapDoc::OnRun() 

{

	// TODO: Add your command handler code here

	try{

		if (mGraphManager)

			mGraphManager->Run(/*mMainView*/);

		}

	catch(CError &err)

		{

		char buff[1024];

		sprintf(buff,"%s %d",err.data(),err.code());



		::MessageBox(mMainView->m_hWnd,buff,"Error",MB_OK | MB_APPLMODAL);

		}

	catch(...)

		{

		::MessageBox(mMainView->m_hWnd,"Unknown Error","Error",MB_OK | MB_APPLMODAL);

		}

}



void CNeilCapDoc::OnUpdateRun(CCmdUI* pCmdUI) 

{

	// TODO: Add your command update UI handler code here

	pCmdUI->Enable(mGraphManager && !mGraphManager->IsRunning());	

}

