/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// NeilCapDoc.h : interface of the CNeilCapDoc class

//

/////////////////////////////////////////////////////////////////////////////



class CNeilCapGUIController;

class CGraphManager;

class CNeilCapView;



#include "CEveryComponentFactory.h"



class CNeilCapDoc : public CDocument

{

protected: // create from serialization only

	CNeilCapDoc();

	DECLARE_DYNCREATE(CNeilCapDoc)



// Attributes

public:



// Operations

public:



// Overrides

	// ClassWizard generated virtual function overrides

	//{{AFX_VIRTUAL(CNeilCapDoc)

	public:

	virtual BOOL OnNewDocument();

	virtual void Serialize(CArchive& ar);

	//}}AFX_VIRTUAL



// Implementation

public:

	virtual ~CNeilCapDoc();

#ifdef _DEBUG

	virtual void AssertValid() const;

	virtual void Dump(CDumpContext& dc) const;

#endif



	void	SetMainView(CNeilCapView *view);

	void	Do_ConfigureComponent(void);

	void	ClearAll(void);



protected:

	CNeilCapGUIController	*mGUIController;

	CGraphManager	*mGraphManager;

	CNeilCapView	*mMainView;

	CEveryComponentFactory	mComponentFactory;



// Generated message map functions

protected:

	//{{AFX_MSG(CNeilCapDoc)

	afx_msg void OnAddComponent();

	afx_msg void OnUpdateAddComponent(CCmdUI* pCmdUI);

	afx_msg void OnDeleteComponent();

	afx_msg void OnUpdateDeleteComponent(CCmdUI* pCmdUI);

	afx_msg void OnConfigureComponent();

	afx_msg void OnUpdateConfigureComponent(CCmdUI* pCmdUI);

	afx_msg void OnHalt();

	afx_msg void OnUpdateHalt(CCmdUI* pCmdUI);

	afx_msg void OnRun();

	afx_msg void OnUpdateRun(CCmdUI* pCmdUI);

	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

};



/////////////////////////////////////////////////////////////////////////////

