/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// NeilCapView.cpp : implementation of the CNeilCapView class

//



#include "stdafx.h"

#include "NeilCap.h"



#include "NeilCapDoc.h"

#include "NeilCapView.h"

#include "CNeilCapGUIController.h"



#ifdef _DEBUG

#define new DEBUG_NEW

#undef THIS_FILE

static char THIS_FILE[] = __FILE__;

#endif



/////////////////////////////////////////////////////////////////////////////

// CNeilCapView



IMPLEMENT_DYNCREATE(CNeilCapView, CView)



BEGIN_MESSAGE_MAP(CNeilCapView, CView)

	//{{AFX_MSG_MAP(CNeilCapView)

	ON_WM_CREATE()

	ON_WM_ERASEBKGND()

	ON_WM_LBUTTONDOWN()

	ON_WM_LBUTTONUP()

	ON_WM_MOUSEMOVE()

	ON_WM_LBUTTONDBLCLK()

	ON_WM_RBUTTONDOWN()

	ON_WM_KEYDOWN()

	ON_WM_DESTROY()

	//}}AFX_MSG_MAP

END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////

// CNeilCapView construction/destruction



CNeilCapView::CNeilCapView()

{

	// TODO: add construction code here

	mGUIController	= 0;

	mMouseDown		= 0;

	mDragging		= 0;

	mLastX			= 0;

	mLastY			= 0;



}



CNeilCapView::~CNeilCapView()

{

}



BOOL CNeilCapView::PreCreateWindow(CREATESTRUCT& cs)

{

	// TODO: Modify the Window class or styles here by modifying

	//  the CREATESTRUCT cs



	return CView::PreCreateWindow(cs);

}



/////////////////////////////////////////////////////////////////////////////

// CNeilCapView drawing



void CNeilCapView::OnDraw(CDC* pDC)

{

	CNeilCapDoc* pDoc = GetDocument();

	ASSERT_VALID(pDoc);



	// TODO: add draw code for native data here

	if (!mGUIController) return;

	mGUIController->Draw(pDC);

}



/////////////////////////////////////////////////////////////////////////////

// CNeilCapView diagnostics



#ifdef _DEBUG

void CNeilCapView::AssertValid() const

{

	CView::AssertValid();

}



void CNeilCapView::Dump(CDumpContext& dc) const

{

	CView::Dump(dc);

}



CNeilCapDoc* CNeilCapView::GetDocument() // non-debug version is inline

{

	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CNeilCapDoc)));

	return (CNeilCapDoc*)m_pDocument;

}

#endif //_DEBUG



/////////////////////////////////////////////////////////////////////////////

// CNeilCapView message handlers



int CNeilCapView::OnCreate(LPCREATESTRUCT lpCreateStruct) 

{

	if (CView::OnCreate(lpCreateStruct) == -1)

		return -1;

	

	// TODO: Add your specialized creation code here

	

	GetDocument()->SetMainView(this);

	return 0;

}



void

CNeilCapView::SetGUIController(CNeilCapGUIController *gui)

{

	mGUIController =gui;

}





BOOL CNeilCapView::OnEraseBkgnd(CDC* pDC) 

{

	// TODO: Add your message handler code here and/or call default

	

	CWnd	*w = pDC->GetWindow();

	RECT r;

	r.top = 0;

	r.left = 0;

	r.right = 32000;

	r.bottom = 32000;

	//w->GetWindowRect(&r);

	pDC->FillSolidRect(&r,::GetSysColor(COLOR_3DFACE));

	return 1;

//	return CView::OnEraseBkgnd(pDC);

}



void CNeilCapView::OnLButtonDown(UINT nFlags, CPoint point) 

{

	// TODO: Add your message handler code here and/or call default

	if (mGUIController)

		{

		mGUIController->SelectButtonDown(point.x,point.y);

		}

	else

		{

		CView::OnLButtonDown(nFlags, point);

		}

	mMouseDown = 1;

	mLastX	= point.x;

	mLastY	= point.y;

}



void CNeilCapView::OnLButtonUp(UINT nFlags, CPoint point) 

{

	// TODO: Add your message handler code here and/or call default

	if (mGUIController && mDragging)

		{

		mGUIController->EndDrag(point.x,point.y);

		}

	else

		{

		CView::OnLButtonUp(nFlags, point);

		}

	mDragging	= 0;

	mMouseDown	= 0;

}



void CNeilCapView::OnMouseMove(UINT nFlags, CPoint point) 

{

	// TODO: Add your message handler code here and/or call default

	if (mGUIController && mMouseDown)

		{

		if (mDragging)

			{

			mGUIController->Drag(point.x,point.y);

			}

		else

			{

			int xdiff = abs(mLastX - point.x);

			int ydiff = abs(mLastY - point.y);

			if (xdiff > 2 || ydiff > 2)

				{

				mDragging = mGUIController->BeginDrag(mLastX,mLastY);

				if (!mDragging)

					mMouseDown = 0;

				}

			}

		}

	else

		{

		CView::OnMouseMove(nFlags, point);

		}

}



void CNeilCapView::OnLButtonDblClk(UINT nFlags, CPoint point) 

{

	// TODO: Add your message handler code here and/or call default

	GetDocument()->Do_ConfigureComponent();

	//CView::OnLButtonDblClk(nFlags, point);

}



void CNeilCapView::OnRButtonDown(UINT nFlags, CPoint point) 

{

	// TODO: Add your message handler code here and/or call default

	

	CView::OnRButtonDown(nFlags, point);

}



void CNeilCapView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 

{

	// TODO: Add your message handler code here and/or call default

	switch(nChar)

		{

		case 8: // backspace

		case 46: // delete

			if (mGUIController)

				mGUIController->DeleteSelectedComponent();

			break;

		default:

			CView::OnKeyDown(nChar, nRepCnt, nFlags);

		}

}



void CNeilCapView::OnDestroy() 

{

	GetDocument()->ClearAll();

	CView::OnDestroy();

	

	// TODO: Add your message handler code here

	

}

