/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// NeilCapView.h : interface of the CNeilCapView class

//

/////////////////////////////////////////////////////////////////////////////



class CNeilCapGUIController;



class CNeilCapView : public CView

{

protected: // create from serialization only

	CNeilCapView();

	DECLARE_DYNCREATE(CNeilCapView)



// Attributes

public:

	CNeilCapDoc* GetDocument();



// Operations

public:

	void	SetGUIController(CNeilCapGUIController *gui);



// Overrides

	// ClassWizard generated virtual function overrides

	//{{AFX_VIRTUAL(CNeilCapView)

	public:

	virtual void OnDraw(CDC* pDC);  // overridden to draw this view

	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

	protected:

	//}}AFX_VIRTUAL



// Implementation

public:

	virtual ~CNeilCapView();

#ifdef _DEBUG

	virtual void AssertValid() const;

	virtual void Dump(CDumpContext& dc) const;

#endif



protected:

	CNeilCapGUIController	*mGUIController;

	int				mMouseDown;

	int				mDragging;

	int				mLastX,mLastY;



// Generated message map functions

protected:

	//{{AFX_MSG(CNeilCapView)

	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);

	afx_msg BOOL OnEraseBkgnd(CDC* pDC);

	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);

	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);

	afx_msg void OnMouseMove(UINT nFlags, CPoint point);

	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);

	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);

	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);

	afx_msg void OnDestroy();

	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

};



#ifndef _DEBUG  // debug version in NeilCapView.cpp

inline CNeilCapDoc* CNeilCapView::GetDocument()

   { return (CNeilCapDoc*)m_pDocument; }

#endif



/////////////////////////////////////////////////////////////////////////////

