/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// C3BitmapButton.cpp : implementation file

//



#include "stdafx.h"

#include "TrueCap.h"

#include "C3BitmapButton.h"

#include "MainFrm.h"

#include <assert.h>



#ifdef _DEBUG

#define new DEBUG_NEW

#undef THIS_FILE

static char THIS_FILE[] = __FILE__;

#endif





/////////////////////////////////////////////////////////////////////////////

// C3BitmapButton



C3BitmapButton::C3BitmapButton(int normal_bitmap,int hilite_bitmap,int active_bitmap)

{

	mSelected = 0;

	mUseAlt = 0;

	mAlt = 0;

	mNormalBitmap.LoadBitmap(normal_bitmap);

	mHiliteBitmap.LoadBitmap(hilite_bitmap);

	mActiveBitmap.LoadBitmap(active_bitmap);

}



C3BitmapButton::~C3BitmapButton()

{

	mNormalBitmap.DeleteObject();

	mHiliteBitmap.DeleteObject();

	mActiveBitmap.DeleteObject();

	if (mAlt)

		{

		mAltNormal.DeleteObject();

		mAltHilite.DeleteObject();

		mAltActive.DeleteObject();

		}

}



void

C3BitmapButton::UseAltSet(int a)

{

	assert(mAlt);

	int last = mUseAlt;

	mUseAlt = a;

	if (last != mUseAlt)

		Invalidate();

}



void	

C3BitmapButton::SetAltSet(int normal_bitmap,int hilite_bitmap,int active_bitmap)

{

	mAlt = 1;

	mAltNormal.LoadBitmap(normal_bitmap);

	mAltHilite.LoadBitmap(hilite_bitmap);

	mAltActive.LoadBitmap(active_bitmap);

}



BEGIN_MESSAGE_MAP(C3BitmapButton, CButton)

	//{{AFX_MSG_MAP(C3BitmapButton)

	ON_WM_MOUSEMOVE()

	ON_WM_ERASEBKGND()

	//}}AFX_MSG_MAP

END_MESSAGE_MAP()



void 

C3BitmapButton::DrawItem(LPDRAWITEMSTRUCT d)

{

	CDC	*cDC = CDC::FromHandle(d->hDC);



	CString	s;

	GetWindowText(s);

	CBitmap	*tmp = 0;

	CDC	 dcMem;

	dcMem.CreateCompatibleDC(cDC);



	if (d->itemState & ODS_SELECTED)

		{

		mSelected = 1;

		//cDC->FillSolidRect(&(d->rcItem),0x00ff00);

		tmp = dcMem.SelectObject(mUseAlt ? &mAltActive : &mActiveBitmap);

		}

	else

		{

		mSelected = 0;

		tmp = dcMem.SelectObject(mUseAlt ? &mAltNormal : &mNormalBitmap);

		//cDC->FillSolidRect(&(d->rcItem),0x00ff);

		}

	//cDC->DrawText(s,&(d->rcItem),DT_CENTER | DT_VCENTER);

	dcMem.SetMapMode(cDC->GetMapMode());

	cDC->BitBlt(d->rcItem.left,d->rcItem.top,

		d->rcItem.right - d->rcItem.left,d->rcItem.bottom - d->rcItem.top,

		&dcMem,0,0,SRCCOPY);

	dcMem.SelectObject(tmp);

}



/////////////////////////////////////////////////////////////////////////////

// C3BitmapButton message handlers



void C3BitmapButton::OnMouseMove(UINT nFlags, CPoint point) 

{

	// TODO: Add your message handler code here and/or call default

	CMainFrame *mf = dynamic_cast<CMainFrame*>(AfxGetMainWnd());

	assert(mf);



	if (!mSelected && mf->IsAppActive())

		{

		SetFocus();

		SetCapture();

		CDC *cDC = GetDC();



		CString	s;

		RECT	r;

		GetClientRect(&r);

		GetWindowText(s);

		CBitmap	*tmp = 0;

		CDC	dcMem;

		dcMem.CreateCompatibleDC(cDC);



		if (point.x >= r.left && point.x <= r.right && point.y >= r.top

			&& point.y <= r.bottom)

			{

			tmp = dcMem.SelectObject(mUseAlt ? &mAltHilite : &mHiliteBitmap);

			

			}

		else

			{

			tmp = dcMem.SelectObject(mUseAlt ? &mAltNormal : &mNormalBitmap);



			ReleaseCapture();

			}

		dcMem.SetMapMode(cDC->GetMapMode());

		cDC->BitBlt(r.left,r.top,r.right - r.left,r.bottom - r.top,

			&dcMem,0,0,SRCCOPY);

		dcMem.SelectObject(tmp);

		ReleaseDC(cDC);

		}

	//CButton::OnMouseMove(nFlags, point);

}



BOOL C3BitmapButton::OnEraseBkgnd(CDC* pDC) 

{

	// TODO: Add your message handler code here and/or call default

	RECT r;

	GetClientRect(&r);

	pDC->FillSolidRect(&r,0x666666);

	return 1;



	//return CButton::OnEraseBkgnd(pDC);

}









LRESULT C3BitmapButton::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 

{

	// TODO: Add your specialized code here and/or call the base class



	if (message == WM_KEYDOWN)

		{

		GetParent()->PostMessage(message,wParam,lParam);

		return 0;

		}



	return CButton::WindowProc(message, wParam, lParam);

}







BOOL C3BitmapButton::PreTranslateMessage(MSG* pMsg) 

{

	// TODO: Add your specialized code here and/or call the base class

	if (pMsg->message == WM_SYSKEYDOWN || pMsg->message == WM_SYSKEYUP ||

		pMsg->message == WM_SYSCOMMAND || pMsg->message == WM_SYSCHAR)

		{

		// allow menus to work

		ReleaseCapture();

		GetParent()->PostMessage(pMsg->message,pMsg->wParam,pMsg->lParam);

		return TRUE;

		}



	return CButton::PreTranslateMessage(pMsg);

}





