/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CAUDIOMIXER_H_

#define CAUDIOMIXER_H_



#include <windows.h>

#include <mmsystem.h>

#include <CError.h>



class CAudioMixer

{

	MIXERCAPS		mMixerCaps;

	HMIXER			mMixer;

	UINT			mMixerID;

	int				mLineInVolume;

	MIXERCONTROL	*mMixerControl;

	UINT			mMixerControlID;

	long			mMixerControlMax;

	long			mMixerControlMin;

	int				mMixerOK;



	void	FindLineIn(void);



public:

	CAudioMixer(int initial_line_in_volume = 75,UINT mixer_id = 0);

	~CAudioMixer(void);



	const MIXERCAPS*	GetMixerCaps(void) const

		{ return &mMixerCaps; }



	void	SetLineInVolume(int v);



	CERROR_SUBCLASS(CAudioMixerError);

};



#endif

