/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// CAudioSettingsDialog.cpp : implementation file

//



#include "stdafx.h"

#include "CAudioSettingsDialog.h"

#include <assert.h>



#ifdef _DEBUG

#define new DEBUG_NEW

#undef THIS_FILE

static char THIS_FILE[] = __FILE__;

#endif



/////////////////////////////////////////////////////////////////////////////

// CAudioSettingsDialog dialog





CAudioSettingsDialog::CAudioSettingsDialog(CWnd* pParent /*=NULL*/)

	: CDialog(CAudioSettingsDialog::IDD, pParent)

{

	//{{AFX_DATA_INIT(CAudioSettingsDialog)

	mFrequency = -1;

	mSampleSize = -1;

	mChannels = -1;

	//}}AFX_DATA_INIT



	mMinVolume = 0;

	mMaxVolume = 100;

	mVolume = 0;

	mVolumeSetOK = 0;

	mSupervisor = 0;

}





void CAudioSettingsDialog::DoDataExchange(CDataExchange* pDX)

{

	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CAudioSettingsDialog)

	DDX_Radio(pDX, IDC_11025, mFrequency);

	DDX_Radio(pDX, IDC_8BIT, mSampleSize);

	DDX_Radio(pDX, IDC_MONO, mChannels);

	//}}AFX_DATA_MAP



	if (pDX->m_bSaveAndValidate)

		{

		CSliderCtrl *s = (CSliderCtrl *)GetDlgItem(IDC_VOLUME_SLIDER);

		assert(s);

		mVolume = s->GetPos();

		}

	else

		{

		CSliderCtrl *s = (CSliderCtrl *)GetDlgItem(IDC_VOLUME_SLIDER);

		assert(s);

		s->SetRange(mMinVolume,mMaxVolume);

		s->SetPos(mVolume);

		mVolumeSetOK = 1;

		}

}





BEGIN_MESSAGE_MAP(CAudioSettingsDialog, CDialog)

	//{{AFX_MSG_MAP(CAudioSettingsDialog)

	//}}AFX_MSG_MAP

END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////

// CAudioSettingsDialog message handlers





BOOL CAudioSettingsDialog::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 

{

	// TODO: Add your specialized code here and/or call the base class

	if (mVolumeSetOK)

		{

		assert(mSupervisor);

		CSliderCtrl *s = (CSliderCtrl *)GetDlgItem(IDC_VOLUME_SLIDER);

		assert(s);

		int	volume = s->GetPos();

		mSupervisor->ChangeVolume(volume);

		}



	return CDialog::OnNotify(wParam, lParam, pResult);

}

