/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CCAP_H_

#define CCAP_H_



#include "CCaptureInterface.h"

#include "CTrueCapComponentFactory.h"

#include <nmr_string.h>

#include <CError.h>



class CGraphManager;

class CVidcapSource_TC;

class CCompressor_TC;

class CIvaPWriter_TC;

class CRTCompressor_TC;



class CCap: public CCaptureInterface

{



	CGraphManager	*mGraphManager;

	CTrueCapComponentFactory mTrueCapComponentFactory;



	nmr_string		mCaptureFile;



	CVidcapSource_TC *mVidcapSource;

	CCompressor_TC	 *mCompressor;

	CRTCompressor_TC *mRTCompressor;

	CIvaPWriter_TC	 *mWriter;



	int mAudio_SampleSize;

	int mAudio_Channels;

	int mAudio_Frequency;



	int	mVideo_Width;

	int	mVideo_Height;

	int mVideo_FPS;

	int mVideo_Quality;

	int	mVideo_SingleFieldInput;



public:

	HWND	GetCaptureWindow(void);

	CCap(void);

	virtual ~CCap(void);



	virtual void	Instantiate(HWND parent,CGUIController *g);

	virtual void	DestroyWindow(void);



	virtual	void	Run(void);

	virtual	int		IsRunning(void);

	virtual	void	Halt(void);

	virtual void	TempConfigure(void);



			void	SetCaptureFile(const char *filename);

			void	SetAudioParams(int sample_size,int channels,int frequency);

			void	SetVideoParams(int width,int height,int fps,int quality,

									int single_field_input);

			void	SetFreeSpaceDrive(const char *d);

			void	ConfigureCaptureDriverSource(void);

			void	ShowVideo(BOOL s);

			int		BigImage(void);

	BOOL	GrabFrameNoStop(void);

	BOOL	GrabFrame(void);

	BOOL	FileSaveDib(const char *name);



	CERROR_SUBCLASS(CCapException);

};



#endif

