/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// CChannelScanDialog.cpp : implementation file

//



#include "stdafx.h"

#include "TrueCap.h"

#include "CChannelScanDialog.h"

#include "CVideoSettingsDialog.h"

#include "CScanningDialog.h"

#include "TrueCapDoc.h"



#ifdef _DEBUG

#define new DEBUG_NEW

#undef THIS_FILE

static char THIS_FILE[] = __FILE__;

#endif



/////////////////////////////////////////////////////////////////////////////

// CChannelScanDialog dialog





CChannelScanDialog::CChannelScanDialog(CWnd* pParent /*=NULL*/)

	: CDialog(CChannelScanDialog::IDD, pParent)

{

	//{{AFX_DATA_INIT(CChannelScanDialog)

	mChannel = 0;

	//}}AFX_DATA_INIT

	mDocument = 0;

}





void CChannelScanDialog::DoDataExchange(CDataExchange* pDX)

{

	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CChannelScanDialog)

	DDX_Control(pDX, IDC_CS_CHANNELLIST, mcList);

	DDX_Text(pDX, IDC_CS_EDITADDCHANNEL, mChannel);

	//}}AFX_DATA_MAP

	if (pDX->m_bSaveAndValidate)

		{

		}

	else

		{

		char buf[256];

		mcList.ResetContent();

		IVideoTuner::ChannelList_t::iterator i;

		for (i = mChannelList.begin(); i != mChannelList.end(); ++i)

			mcList.AddString(itoa(*i,buf,10));

		}



}





BEGIN_MESSAGE_MAP(CChannelScanDialog, CDialog)

	//{{AFX_MSG_MAP(CChannelScanDialog)

	ON_BN_CLICKED(IDC_CS_ADD, OnCsAdd)

	ON_BN_CLICKED(IDC_CS_DELETE, OnCsDelete)

	ON_BN_CLICKED(IDC_CS_SCAN, OnCsScan)

	ON_BN_CLICKED(IDC_CS_VIDEOSETTINGS, OnCsVideosettings)

	//}}AFX_MSG_MAP

END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////

// CChannelScanDialog message handlers



void CChannelScanDialog::OnCsAdd() 

{

	// TODO: Add your control notification handler code here

	UpdateData(TRUE);

	bool added = false;

	if (mChannel > 0 && mChannel < 126)

		{

		IVideoTuner::ChannelList_t::iterator i;

		int x;

		for (i = mChannelList.begin(), x = 0; i != mChannelList.end(); ++i,++x)

			{

			if (mChannel < (*i))

				{

				char buf[256];

				mChannelList.insert(i,mChannel);

				mcList.InsertString(x,itoa(mChannel,buf,10));

				added = true;

				break;

				}

			}

		if (!added)

			{

			char buf[256];

			mChannelList.push_back(mChannel);

			mcList.AddString(itoa(mChannel,buf,10));

			}

		}	

}



void CChannelScanDialog::OnCsDelete() 

{

	// TODO: Add your control notification handler code here

	int sel = mcList.GetCurSel();

	if (sel == LB_ERR) return;

	mcList.DeleteString(sel);

	IVideoTuner::ChannelList_t::iterator i;

	for (i = mChannelList.begin(); i != mChannelList.end(); ++i)

		{

		if (!(sel--))

			{

			mChannelList.erase(i);

			break;

			}

		}

}





void CChannelScanDialog::OnCsScan() 

{

	// TODO: Add your control notification handler code here

	assert(mDocument);	

	mChannelList.erase(mChannelList.begin(),mChannelList.end());

	{

	CScanningDialog dlog;

	dlog.Create(IDD_SCANNING,this);

	mChannelList = mDocument->BuildScanList(dlog);

	}

	UpdateData(FALSE);

	if (mChannelList.size())

		mDocument->SetChannel(mChannelList[0]);

}



void CChannelScanDialog::OnCsVideosettings() 

{

	// TODO: Add your control notification handler code here

	assert(mDocument);	

	

	IVideoTuner::VideoSource_t source;

	U8 brightness,contrast,hue,saturation;



	mDocument->GetTunerState(source,brightness,contrast,hue,saturation);

	mDocument->ConfigureCaptureDriverSource(source,brightness,contrast,hue,saturation);	

}

