/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// CColorSlider.cpp : implementation file

//



#include "stdafx.h"

#include "TrueCap.h"

#include "CColorSlider.h"



#ifdef _DEBUG

#define new DEBUG_NEW

#undef THIS_FILE

static char THIS_FILE[] = __FILE__;

#endif



/////////////////////////////////////////////////////////////////////////////

// CColorSlider



CColorSlider::CColorSlider()

{

	mRealMin = mRealMax = mRealPos = 0;

}



CColorSlider::~CColorSlider()

{

}



void

CColorSlider::SetPosMessage(int mess)

{

	PostMessage(WM_USER,0,(long)mess);

}



BEGIN_MESSAGE_MAP(CColorSlider, CSliderCtrl)

	//{{AFX_MSG_MAP(CColorSlider)

	ON_WM_PAINT()

	ON_WM_CREATE()

	//}}AFX_MSG_MAP

END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////

// CColorSlider message handlers



void CColorSlider::OnPaint() 

{

	CPaintDC dc(this); // device context for painting

	

	// TODO: Add your message handler code here

	RECT	thumb_rect,client_rect,channel_rect;

	GetThumbRect(&thumb_rect);

	GetClientRect(&client_rect);

	GetChannelRect(&channel_rect);

	// make it a hair smaller

	channel_rect.top += 1;

	channel_rect.bottom -= 1;



	CRgn	thumb_rgn,client_rgn,channel_rgn;

	thumb_rgn.CreateRectRgn(thumb_rect.left,thumb_rect.top,thumb_rect.right,thumb_rect.bottom);

	channel_rgn.CreateRectRgn(channel_rect.left,channel_rect.top,channel_rect.right,channel_rect.bottom);

	client_rgn.CreateRectRgn(client_rect.left,client_rect.top,client_rect.right,client_rect.bottom);

	

	client_rgn.CombineRgn(&client_rgn,&channel_rgn,RGN_DIFF);

	client_rgn.CombineRgn(&client_rgn,&thumb_rgn,RGN_DIFF);

	channel_rgn.CombineRgn(&channel_rgn,&thumb_rgn,RGN_DIFF);



	CBrush client_brush(0x00666666);



	dc.FillRgn(&client_rgn,&client_brush);

	dc.Draw3dRect(channel_rect.left,channel_rect.top,

		thumb_rect.left+1 - channel_rect.left,channel_rect.bottom - channel_rect.top,

		0x00333333,0x00a0a0a0);

	dc.Draw3dRect(thumb_rect.right - 1,channel_rect.top,

		channel_rect.right - (thumb_rect.right - 1),channel_rect.bottom - channel_rect.top,

		0x00333333,0x00a0a0a0);



	dc.FillSolidRect(&thumb_rect,0x00808080);

	dc.Draw3dRect(thumb_rect.left,thumb_rect.top,

		thumb_rect.right - thumb_rect.left,

		thumb_rect.bottom - thumb_rect.top,

		0x00a0a0a0,0x00101010);



	//dc.FillRgn(&channel_rgn,&channel_brush);

	//dc.FillRgn(&thumb_rgn,&thumb_brush);

	

	// Do not call CSliderCtrl::OnPaint() for painting messages

}





LRESULT CColorSlider::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 

{

	// TODO: Add your specialized code here and/or call the base class

	// TODO: Add your specialized code here and/or call the base class

	if (message == WM_KEYDOWN)

		{

		GetParent()->PostMessage(message,wParam,lParam);

		return 0;

		}

	else if (message == WM_USER)

		{

		SetPos(lParam);

		return 0;

		}

	else

		return CSliderCtrl::WindowProc(message, wParam, lParam);

}



int CColorSlider::OnCreate(LPCREATESTRUCT lpCreateStruct) 

{

	if (CSliderCtrl::OnCreate(lpCreateStruct) == -1)

		return -1;

	

	// TODO: Add your specialized creation code here

	CSliderCtrl::SetRange(0,30000);

	FixupSlider();

	return 0;

}



void

CColorSlider::FixupSlider(void)

{

	int diff = mRealMax - mRealMin;

	if (diff == 0)

		CSliderCtrl::SetPos(0);

	else

		CSliderCtrl::SetPos((((_int64)30000) * mRealPos) / diff);

}



int 

CColorSlider::GetRangeMax() const

{

	return mRealMax;

}



int 

CColorSlider::GetRangeMin() const

{

	return mRealMin;

}



void 

CColorSlider::GetRange(int& nMin, int& nMax) const

{

	nMin = mRealMin;

	nMax = mRealMax;

}



void 

CColorSlider::SetRangeMin(int nMin, BOOL bRedraw)

{

	mRealMin = nMin;

	FixupSlider();

}



void 

CColorSlider::SetRangeMax(int nMax, BOOL bRedraw)

{

	mRealMax = nMax;

	FixupSlider();

}



void 

CColorSlider::SetRange(int nMin, int nMax, BOOL bRedraw)

{

	mRealMin = nMin;

	mRealMax = nMax;

	FixupSlider();

}



int

CColorSlider::GetPos(int bogus)

{

	int diff = (mRealMax - mRealMin);

	mRealPos = (int)((((_int64)bogus) * diff) / 30000);

	return mRealPos;

}



int 

CColorSlider::GetPos(void)

{

	int p = CSliderCtrl::GetPos();

	int diff = (mRealMax - mRealMin);

	mRealPos = (int)((((_int64)p) * diff) / 30000);

	return mRealPos;

}



void 

CColorSlider::SetPos(int nPos)

{

	mRealPos = nPos;

	FixupSlider();

}





