/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "CCompressor_TC.h"
#include "danbug.h"
#include "fourcc.h"

CComponent *

CCompressor_TC::CreatorFunc(CGUIController *gui)

{

	return new CCompressor_TC(gui);

}



void

CCompressor_TC::SetQuality(int quality)

{

	assert(quality >= 0 && quality <= 4);

	switch(quality)

		{

		case 0:

			mCompVars.lQ = 9000;

			break;

		case 1:

			mCompVars.lQ = 7000;

			break;

		case 2:

			mCompVars.lQ = 5000;

			break;

		case 3:

			mCompVars.lQ = 3000;

			break;

		case 4:

			mCompVars.lQ = 1000;

		}

}



void

CCompressor_TC::Configure(CWnd *wnd)

{

	if (mCompressorMustBeFreed)

		{

		ICCompressorFree(&mCompVars);

		mCompressorMustBeFreed = 0;

		}

	if (mCompressorMustBeClosed)

		{

		ICClose(mCompVars.hic);

		mCompressorMustBeClosed = 0;

		}



	mHIC = ICOpen(*(long *)(char *)"VIDC",*(long *)(char *)DEFAULT_FOURCC,ICMODE_COMPRESS);
 dprintf("ICOpen (fourcc=%s) returned with handle: %x",DEFAULT_FOURCC,(int)mHIC);
	mCompVars.hic = mHIC;

	mCompVars.fccHandler = *(long *)(char *)DEFAULT_FOURCC;

	//mCompVars.lQ = 10000;//7000;



	if (mHIC)

		{

		mCompressorMustBeClosed = 1;

		}

	else

		{

		AfxMessageBox("Could not find the TrueMotion Realtime codec");

		}

}



int

CCompressor_TC::ConfigureIfNeeded(CWnd *wnd)

{

	if (mCompressorMustBeFreed || mCompressorMustBeClosed) return 1;



	Configure(wnd);

	return (mHIC ? 1 : 0);

}



