/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// CEventListDialog.cpp : implementation file

//



#include "stdafx.h"

#include "CEventListDialog.h"

#include "CRecordingEventDialog.h"



#ifdef _DEBUG

#define new DEBUG_NEW

#undef THIS_FILE

static char THIS_FILE[] = __FILE__;

#endif



/////////////////////////////////////////////////////////////////////////////

// CEventListDialog dialog





CEventListDialog::CEventListDialog(CWnd* pParent /*=NULL*/)

	: CDialog(CEventListDialog::IDD, pParent)

{

	mEventLimit = -1;

	mEventTimeLimit = -1;

	//{{AFX_DATA_INIT(CEventListDialog)

	//}}AFX_DATA_INIT

	mSupervisor = 0;

	mFont.CreateFont(14,0,0,0,FW_NORMAL,0,0,0,

		DEFAULT_CHARSET,OUT_CHARACTER_PRECIS,CLIP_CHARACTER_PRECIS,

		DEFAULT_QUALITY,DEFAULT_PITCH | FF_DONTCARE,"Courier New");

//	mFont.CreateFont(-9,0,0,0,400,FALSE,FALSE,0,ANSI_CHARSET,

//		OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,

//		DEFAULT_PITCH | FF_SWISS,"Courier");

}



void

CEventListDialog::UpdateAddButton(void)

{

	assert(mEventLimit > -1);

	mAddButton.EnableWindow((!mEventLimit) || (mEventLimit > mList.size()));

}



void CEventListDialog::DoDataExchange(CDataExchange* pDX)

{

	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CEventListDialog)

	DDX_Control(pDX, IDC_EL_ADD, mAddButton);

	DDX_Control(pDX, IDC_EL_LIST, mcList);

	//}}AFX_DATA_MAP



	if (pDX->m_bSaveAndValidate)

		{

		}

	else

		{

		mcList.SetFont(&mFont);

		mcList.ResetContent();

		CTimeShiftManager::EventList_t::iterator i;

		for (i = mList.begin(); i != mList.end(); ++i)

			mcList.AddString((*i).CreateCondensedString());

		UpdateAddButton();

		}

}





BEGIN_MESSAGE_MAP(CEventListDialog, CDialog)

	//{{AFX_MSG_MAP(CEventListDialog)

	ON_BN_CLICKED(IDC_EL_ADD, OnElAdd)

	ON_BN_CLICKED(IDC_EL_DELETE, OnElDelete)

	ON_BN_CLICKED(IDC_EL_EDIT, OnElEdit)

	ON_LBN_DBLCLK(IDC_EL_LIST, OnDblclkElList)

	//}}AFX_MSG_MAP

END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////

// CEventListDialog message handlers



void CEventListDialog::OnElAdd() 

{

	// TODO: Add your control notification handler code here

	if ((mList.size() >= mEventLimit) && mEventLimit)

		{

		nmr_string s = "You are limited to ";

		s += mEventLimit;

		s += " events.";

		AfxMessageBox(s);

		return;

		}



	CRecordingEventDialog dlog;

	COleDateTime	dt = COleDateTime::GetCurrentTime();

	assert(mSupervisor);

	dlog.mSupervisor	= mSupervisor;

	dlog.mChannel = 2;

	assert(mEventTimeLimit > -1);

	dlog.mEventTimeLimit = mEventTimeLimit;

	IVideoTuner::Channel_t c;

	mSupervisor->GetTunerState(dlog.mVideoSource,

		dlog.mBrightness,dlog.mContrast,dlog.mHue,dlog.mSaturation,c);

	dlog.mChannel =c;

	dlog.mDay				= dt.GetDayOfWeek() - 1;

	dlog.mAppendDateAndTime	= AfxGetApp()->GetProfileInt("DuckVision","RecordEventAppend",0);	///	dbm

	dlog.mFilename			= AfxGetApp()->GetProfileString("DuckVision","RecordEventFilename","c:\\capture.vp3");

	dlog.mDate				= dt;

	dlog.mEndTime			= dt;

	dlog.mStartTime			= dt;

	dlog.mFPS				= 30;

	dlog.mQuality			= 1;

	dlog.mHeight			= 240;

	dlog.mWidth				= 320;

	dlog.mSampleSize		= 16;		///	dbm

	dlog.mChannels			= 1;

	dlog.mFrequency			= 44100;	/// dbm

	dlog.mVolume			= 50;

	if (dlog.DoModal() == IDOK)

		{

		CTimeShiftEvent e;

		e.mVideoSource	= dlog.mVideoSource;

		e.mHue			= dlog.mHue;

		e.mContrast		= dlog.mContrast;

		e.mBrightness	= dlog.mBrightness;

		e.mSaturation	= dlog.mSaturation;

		e.mChannel			= dlog.mChannel;

		e.mDay				= (CTimeShiftEvent::Day_t)dlog.mDay;

		e.mAppendDateAndTime	= dlog.mAppendDateAndTime;

		e.mFilename			= dlog.mFilename;

		e.mDate				= dlog.mDate;

		e.mEndTime			= dlog.mEndTime;

		e.mStartTime			= dlog.mStartTime;

		e.mFPS				= dlog.mFPS;

		e.mVideoQuality		= dlog.mQuality;

		e.mVideoHeight		= dlog.mHeight;

		e.mVideoWidth		= dlog.mWidth;

		e.mAudioBits			= dlog.mSampleSize;

		e.mAudioChannels		= dlog.mChannels;

		e.mAudioFrequency	= dlog.mFrequency;

		e.mVolume			= dlog.mVolume;

		mList.push_back(e);

		mcList.AddString(e.CreateCondensedString());

		AfxGetApp()->WriteProfileInt("DuckVision","RecordEventAppend",dlog.mAppendDateAndTime);

		AfxGetApp()->WriteProfileString("DuckVision","RecordEventFilename",dlog.mFilename);

		}

	UpdateAddButton();

}



void CEventListDialog::OnElDelete() 

{

	// TODO: Add your control notification handler code here

	int sel = mcList.GetCurSel();

	if (sel == LB_ERR) return;

	mcList.DeleteString(sel);

	CTimeShiftManager::EventList_t::iterator i;

	for (i = mList.begin(); i != mList.end(); ++i)

		{

		if (!(sel--))

			{

			mList.erase(i);

			break;

			}

		}

	UpdateAddButton();

}



void CEventListDialog::OnElEdit() 

{

	// TODO: Add your control notification handler code here

	int sel = mcList.GetCurSel();

	if (sel == LB_ERR) return;

	int tmpsel = sel;

	CRecordingEventDialog dlog;

	assert(mSupervisor);

	dlog.mSupervisor	= mSupervisor;

	assert(mEventTimeLimit > -1);

	dlog.mEventTimeLimit = mEventTimeLimit;

	CTimeShiftManager::EventList_t::iterator i;

	for (i = mList.begin(); i != mList.end(); ++i)

		{

		if (!(tmpsel--))

			{

			dlog.mVideoSource	= (*i).mVideoSource;

			dlog.mHue			= (*i).mHue;

			dlog.mContrast		= (*i).mContrast;

			dlog.mBrightness	= (*i).mBrightness;

			dlog.mSaturation	= (*i).mSaturation;

			dlog.mChannel			= (*i).mChannel;

			dlog.mDay				= (*i).mDay;

			dlog.mAppendDateAndTime	= (*i).mAppendDateAndTime;

			dlog.mFilename			= (*i).mFilename;

			dlog.mDate				= (*i).mDate;

			dlog.mEndTime			= (*i).mEndTime;

			dlog.mStartTime			= (*i).mStartTime;

			dlog.mFPS				= (*i).mFPS;

			dlog.mQuality			= (*i).mVideoQuality;

			dlog.mHeight			= (*i).mVideoHeight;

			dlog.mWidth				= (*i).mVideoWidth;

			dlog.mSampleSize		= (*i).mAudioBits;

			dlog.mChannels			= (*i).mAudioChannels;

			dlog.mFrequency			= (*i).mAudioFrequency;

			dlog.mVolume			= (*i).mVolume;



			break;

			}

		}



	if (dlog.DoModal() == IDOK)

		{

		if (i != mList.end())

			{

			(*i).mVideoSource	= dlog.mVideoSource;

			(*i).mHue			= dlog.mHue;

			(*i).mContrast		= dlog.mContrast;

			(*i).mBrightness	= dlog.mBrightness;

			(*i).mSaturation	= dlog.mSaturation;

			(*i).mChannel			= dlog.mChannel;

			(*i).mDay				= (CTimeShiftEvent::Day_t)dlog.mDay;

			(*i).mAppendDateAndTime	= dlog.mAppendDateAndTime;

			(*i).mFilename			= dlog.mFilename;

			(*i).mDate				= dlog.mDate;

			(*i).mEndTime			= dlog.mEndTime;

			(*i).mStartTime			= dlog.mStartTime;

			(*i).mFPS				= dlog.mFPS;

			(*i).mVideoQuality		= dlog.mQuality;

			(*i).mVideoHeight		= dlog.mHeight;

			(*i).mVideoWidth		= dlog.mWidth;

			(*i).mAudioBits			= dlog.mSampleSize;

			(*i).mAudioChannels		= dlog.mChannels;

			(*i).mAudioFrequency	= dlog.mFrequency;

			(*i).mVolume			= dlog.mVolume;

			mcList.DeleteString(sel);

			mcList.InsertString(sel,(*i).CreateCondensedString());

			}

		}

	

}



void CEventListDialog::OnDblclkElList() 

{

	// TODO: Add your control notification handler code here

	OnElEdit();	

}

