/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "CRTCompressor_TC.h"

#include <tmrtxx.h>

#include <tmrt.h>

#include "danbug.h"


CComponent *

CRTCompressor_TC::CreatorFunc(CGUIController *gui)

{

	return new CRTCompressor_TC(gui);

}



void

CRTCompressor_TC::SetQuality(int quality)

{

	assert(quality >= 0 && quality <= 4);

	switch(quality)

		{

		case 0:

			mBitRate = 4;

			mInterlace = 0;

			break;

		case 1:

			mBitRate = 3;

			mInterlace = 0;

			break;

		case 2:

			mBitRate = 4;

			mInterlace = 1;

			break;

		case 3:

			mBitRate = 3;

			mInterlace = 1;

			break;

		case 4:

			mBitRate = 2;

			mInterlace = 1;

			break;

		}

}



void

CRTCompressor_TC::Configure(CWnd *wnd)

{

	if (mDataMustBeFreed)

		{

		mDataMustBeFreed = 0;

 dprintf("CRTCompressor_TC.cpp: CRTCompressor_TC::Configure calls tmrtxx_free");
		tmrtxx_free(mXXParam);

		}

	if (mXXParam)

		{

		LocalFree(mXXParam);

		mXXParam = 0;

		}



 dprintf("CRTCompressor_TC.cpp: CRTCompressor_TC::Configure calls tmrtxx_query_paramsize");
	size_t data_size = tmrtxx_query_paramsize();

	mXXParam = LocalAlloc(LMEM_FIXED,data_size);

 dprintf("CRTCompressor_TC.cpp: CRTCompressor_TC::Configure calls tmrtxx_init");
	if (tmrtxx_init(mXXParam))

		{

		AfxMessageBox("Could not initialize TrueMotion Realtime compressor");

		LocalFree(mXXParam);

		mXXParam = 0;

		return;

		}

	mDataMustBeFreed = 1;

}



int

CRTCompressor_TC::ConfigureIfNeeded(CWnd *wnd)

{

	if (mDataMustBeFreed || mXXParam) return 1;



	Configure(wnd);

	return (mXXParam ? 1 : 0);

}



