/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// CRecordingEventDialog.h : header file

//

#include <afxdisp.h>

/////////////////////////////////////////////////////////////////////////////

// CRecordingEventDialog dialog

//{{AFX_INCLUDES()

#include "timecontrol.h"

//}}AFX_INCLUDES



#include "IVideoTuner.h"

#include "IEventEditSupervisor.h"

#include "resource.h"



class CRecordingEventDialog : public CDialog

{

// Construction

public:

	CRecordingEventDialog(CWnd* pParent = NULL);   // standard constructor

	double	CalculateDiskSpace(void);

	IEventEditSupervisor *mSupervisor;



	IVideoTuner::VideoSource_t	mVideoSource;

	U8		mBrightness;

	U8		mContrast;

	U8		mHue;

	U8		mSaturation;

	int		mEventTimeLimit;



// Dialog Data

	//{{AFX_DATA(CRecordingEventDialog)

	enum { IDD = IDD_RECORDEVENT };

	UINT	mChannel;

	int		mDay;

	CTimeControl	mcDate;

	CTimeControl	mcEndTime;

	CTimeControl	mcStartTime;

	BOOL	mAppendDateAndTime;

	CString	mFilename;

	CString	mAudioText;

	CString	mVideoText;

	//}}AFX_DATA



	COleDateTime	mDate;

	COleDateTime	mEndTime;

	COleDateTime	mStartTime;



	int		mFPS;

	int		mQuality;

	int		mHeight;

	int		mWidth;



	int		mSampleSize;

	int		mChannels;

	int		mFrequency;

	int		mVolume;



// Overrides

	// ClassWizard generated virtual function overrides

	//{{AFX_VIRTUAL(CRecordingEventDialog)

	protected:

	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	//}}AFX_VIRTUAL



// Implementation

protected:

	void	ShowDate(int show);

	int		mDateIsVisible;

	void	CreateAudioText(void);

	void	CreateVideoText(void);

	int		ValidateData(void);



	// Generated message map functions

	//{{AFX_MSG(CRecordingEventDialog)

	afx_msg void OnSelchangeReDay();

	afx_msg void OnReBrowse();

	afx_msg void OnChangedReDate(DATE datetime);

	afx_msg void OnChangedReStarttime(DATE datetime);

	afx_msg void OnChangedReEndtime(DATE datetime);

	virtual void OnOK();

	afx_msg void OnReAudio();

	afx_msg void OnReVideo();

	DECLARE_EVENTSINK_MAP()

	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

};

