/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "CTrueCapGUIController.h"

#include "TrueCapView.h"
#include "danbug.h"


CTrueCapGUIController::CTrueCapGUIController(CTrueCapView *view,CWnd *main_window,CMainFrame *s,

											 const char *filename)

: mLogStream(s),

#ifndef NDEBUG

mFileStream(filename),

#endif

mMessageBoxStream(main_window->m_hWnd,"DuckVision")
///	error box
{

	mEnableDialogs = 1;

	mMainWindow = main_window;

	mView = view;

}



CTrueCapGUIController::~CTrueCapGUIController(void)

{

}



void	

CTrueCapGUIController::AddComponent(int index)

{

	// no graph, do nothing

}



CWnd	*

CTrueCapGUIController::GetWindow(void)

{

	return mMainWindow;

}



void	

CTrueCapGUIController::GetVideoBoxXY(int &x,int &y,int width,int height)

{

	assert(mView);

	mView->GetVideoBoxXY(x,y,width,height);

}



void

CTrueCapGUIController::ClearMessages(void)

{

	mLogStream << CMessageStream::show;

}



#ifndef NDEBUG

CMessageStream&	

CTrueCapGUIController::Trace(void *who)

{

	return mFileStream;

}

#endif



CMessageStream&

CTrueCapGUIController::Log(void *who)

{

	return mLogStream;

}



CMessageStream&

CTrueCapGUIController::Error(void *who)

{
 dprintf("we've got an error, boys");
	if (mEnableDialogs)

		return mMessageBoxStream;

	else

		return mLogStream;

}



void	

CTrueCapGUIController::ErrorDialog(const char *message)

{

	AfxMessageBox(message);

}



void

CTrueCapGUIController::CleanupAfterStop(void)

{

	mView->CleanupAfterStop();

}



void

CTrueCapGUIController::EnableDialogs(int enable)

{

	mEnableDialogs = enable;

}

