/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CTRUECAPGUICONTROLLER_H_

#define CTRUECAPGUICONTROLLER_H_



#include "CGUIController.h"

#include "CStatusBarStream.h"

#include "CFileStream.h"

#include "CMessageBoxStream.h"



class CStatusBar;

class CTrueCapView;



class CTrueCapGUIController: public CGUIController

{

	int					mEnableDialogs;

	CStatusBarStream	mLogStream;

#ifndef NDEBUG

	CFileStream			mFileStream;

#endif

	CMessageBoxStream	mMessageBoxStream;

	CWnd				*mMainWindow;

	CTrueCapView		*mView;

public:

	CTrueCapGUIController(CTrueCapView *view,CWnd *main_window,CMainFrame *s,const char *tracefilename);

	virtual ~CTrueCapGUIController(void);



	// graph manipulation stuff

	virtual void	AddComponent(int index);



	// capture stuff

	virtual CWnd	*GetWindow(void);

	virtual void	GetVideoBoxXY(int &x,int &y,int width,int height);



	// general messaging

	virtual void	ClearMessages(void);

#ifndef NDEBUG

	virtual CMessageStream&	Trace(void *who);

#endif

	virtual CMessageStream&	Log(void *who);

	virtual CMessageStream&	Error(void *who);



	virtual void	ErrorDialog(const char *message);



	void	CleanupAfterStop(void);



	void	EnableDialogs(int enable);

};





#endif

