/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CVIDCAPSOURCE_TC_H_

#define CVIDCAPSOURCE_TC_H_



#include "CVidcapSource.h"



class CVidcapSource_TC: public CVidcapSource

{

	int	_ConfigureVideo(CWnd *wnd);

	int _ConfigureAudio(CWnd *wnd);

	int _VideoColorSpace(void);



///	size_t	mDiskSpaceRemaining;
	double mDiskSpaceRemaining;
	nmr_string	mFreeSpaceDrive;

	long		mStartTime;

	int			mVideoFrameSize;

	int			mSingleFieldInput;

public:

	static WNDPROC		mOldWndproc;

	HWND	GetCaptureWindow(void);

	static CComponent *CreatorFunc(CGUIController *gui);

	CVidcapSource_TC(CGUIController *gui);

	virtual	~CVidcapSource_TC(void);

	virtual	void	Configure(CWnd *wnd);

	virtual	int		ConfigureIfNeeded(CWnd *wnd);

	virtual	void	Initialize(void);

	virtual	void	Cleanup(void);

	virtual	void	VidcapInitialize(void);



			void	SetAudioParams(int sample_size,int channels,int frequency);

			void	SetVideoParams(int width,int height,int fps,int single_field_input);

			void	SetFreeSpaceDrive(const char *d);

			void	SetQuality(int quality);

			void	ConfigureCaptureDriverSource(void);



	virtual	void	LogFrames(int frames);

	virtual	void	Start(void);

	virtual	void	ShowVideo(BOOL s);

	virtual	void	ErrorMessage(int id,LPCSTR mess);

	BOOL	GrabFrameNoStop(void);

	BOOL	GrabFrame(void);

	BOOL	FileSaveDib(const char *name);

};





#endif

