/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// CVideoSettingsDialog.cpp : implementation file

//



#include "stdafx.h"

#include "CVideoSettingsDialog.h"

#include <assert.h>



#ifdef _DEBUG

#define new DEBUG_NEW

#undef THIS_FILE

static char THIS_FILE[] = __FILE__;

#endif



/////////////////////////////////////////////////////////////////////////////

// CVideoSettingsDialog dialog





CVideoSettingsDialog::CVideoSettingsDialog(CWnd* pParent /*=NULL*/)

	: CDialog(CVideoSettingsDialog::IDD, pParent)

{

	//{{AFX_DATA_INIT(CVideoSettingsDialog)

	mDimensions = -1;

	mQuality = -1;

	mFPS = -1;

	//}}AFX_DATA_INIT



	mSupervisor = 0;

	mVideoSource = 	IVideoTuner::BaseBand_Composite;

	mBrightness		= 128;

	mContrast		= 128;

	mHue			= 128;

	mSaturation		= 128;



}







void CVideoSettingsDialog::DoDataExchange(CDataExchange* pDX)

{

	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CVideoSettingsDialog)

	DDX_Radio(pDX, IDC_160x120, mDimensions);

	DDX_Radio(pDX, IDC_LOWESTQ, mQuality);

	DDX_Radio(pDX, IDC_10FPS, mFPS);

	//}}AFX_DATA_MAP

	if (pDX->m_bSaveAndValidate)

		{

		}

	else

		{

		assert(mSupervisor);

		mSupervisor->SetTunerState(mVideoSource,mBrightness,mContrast,mHue,mSaturation);

		}

}





BEGIN_MESSAGE_MAP(CVideoSettingsDialog, CDialog)

	//{{AFX_MSG_MAP(CVideoSettingsDialog)

		// NOTE: the ClassWizard will add message map macros here

	//}}AFX_MSG_MAP

END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////

// CVideoSettingsDialog message handlers



BOOL CVideoSettingsDialog::OnCommand(WPARAM wParam, LPARAM lParam) 

{

	// TODO: Add your specialized code here and/or call the base class

	if (wParam == IDC_VIDEO_SOURCE)

		{

		assert(mSupervisor);

		mSupervisor->ConfigureCaptureDriverSource(mVideoSource,

			mBrightness,mContrast,mHue,mSaturation);

		return TRUE;

		}

	else

		return CDialog::OnCommand(wParam, lParam);

}

