/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// CVideoSourceDialog.cpp : implementation file

//



#include "stdafx.h"

#include "CVideoSourceDialog.h"

#include <assert.h>



#ifdef _DEBUG

#define new DEBUG_NEW

#undef THIS_FILE

static char THIS_FILE[] = __FILE__;

#endif



/////////////////////////////////////////////////////////////////////////////

// CVideoSourceDialog dialog





CVideoSourceDialog::CVideoSourceDialog(CWnd* pParent /*=NULL*/)

	: CDialog(CVideoSourceDialog::IDD, pParent)

{

	//{{AFX_DATA_INIT(CVideoSourceDialog)

	mBrightness = 0;

	mContrast = 0;

	mHue = 0;

	mSaturation = 0;

	mSource = -1;

	//}}AFX_DATA_INIT

	mVideoTuner = 0;

	mUpdated = 0;

}





void CVideoSourceDialog::DoDataExchange(CDataExchange* pDX)

{

	mUpdated = 1;

	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CVideoSourceDialog)

	DDX_Control(pDX, IDC_SPIN5, mSaturationSpin);

	DDX_Control(pDX, IDC_SPIN4, mHueSpin);

	DDX_Control(pDX, IDC_SPIN3, mContrastSpin);

	DDX_Control(pDX, IDC_SPIN2, mBrightSpin);

	DDX_Text(pDX, IDC_VS_BRIGHTNESS, mBrightness);

	DDV_MinMaxUInt(pDX, mBrightness, 0, 255);

	DDX_Text(pDX, IDC_VS_CONTRAST, mContrast);

	DDV_MinMaxUInt(pDX, mContrast, 0, 255);

	DDX_Text(pDX, IDC_VS_HUE, mHue);

	DDV_MinMaxUInt(pDX, mHue, 0, 255);

	DDX_Text(pDX, IDC_VS_SATURATION, mSaturation);

	DDV_MinMaxUInt(pDX, mSaturation, 0, 255);

	DDX_Radio(pDX, IDC_VS_COMPOSITE, mSource);

	//}}AFX_DATA_MAP

	mSaturationSpin.SetRange(0,255);

	mHueSpin.SetRange(0,255);

	mContrastSpin.SetRange(0,255);

	mBrightSpin.SetRange(0,255);

}





BEGIN_MESSAGE_MAP(CVideoSourceDialog, CDialog)

	//{{AFX_MSG_MAP(CVideoSourceDialog)

	ON_BN_CLICKED(IDC_VS_ANTENNA, OnVsAntenna)

	ON_BN_CLICKED(IDC_VS_CABLE, OnVsCable)

	ON_BN_CLICKED(IDC_VS_CAMERA, OnVsCamera)

	ON_BN_CLICKED(IDC_VS_COMPOSITE, OnVsComposite)

	ON_BN_CLICKED(IDC_VS_SVIDEO, OnVsSvideo)

	ON_EN_CHANGE(IDC_VS_BRIGHTNESS, OnChangeVsBrightness)

	ON_EN_CHANGE(IDC_VS_CONTRAST, OnChangeVsContrast)

	ON_EN_CHANGE(IDC_VS_HUE, OnChangeVsHue)

	ON_EN_CHANGE(IDC_VS_SATURATION, OnChangeVsSaturation)

	//}}AFX_MSG_MAP

END_MESSAGE_MAP()





void

CVideoSourceDialog::SetVideoTuner(IVideoTuner *t)

{

	mVideoTuner = t;

}



/////////////////////////////////////////////////////////////////////////////

// CVideoSourceDialog message handlers



void CVideoSourceDialog::OnVsAntenna() 

{

	// TODO: Add your control notification handler code here

	if (!mVideoTuner) return;

	try {mVideoTuner->SetVideoSource(IVideoTuner::Tuner_Antenna);} catch(...){}	

}



void CVideoSourceDialog::OnVsCable() 

{

	// TODO: Add your control notification handler code here

	if (!mVideoTuner) return;

	try {mVideoTuner->SetVideoSource(IVideoTuner::Tuner_Cable);}catch(...){}	

}



void CVideoSourceDialog::OnVsCamera() 

{

	// TODO: Add your control notification handler code here

	if (!mVideoTuner) return;

	try {mVideoTuner->SetVideoSource(IVideoTuner::BaseBand_Camera);} catch(...){}

}



void CVideoSourceDialog::OnVsComposite() 

{

	// TODO: Add your control notification handler code here

	if (!mVideoTuner) return;

	try {mVideoTuner->SetVideoSource(IVideoTuner::BaseBand_Composite);} catch(...){}

}



void CVideoSourceDialog::OnVsSvideo() 

{

	// TODO: Add your control notification handler code here

	if (!mVideoTuner) return;

	try {mVideoTuner->SetVideoSource(IVideoTuner::BaseBand_SVideo);} catch(...){}

}





void CVideoSourceDialog::OnChangeVsBrightness() 

{

	// TODO: Add your control notification handler code here

	if (!mUpdated) return;

	if (!mVideoTuner) return;



	UpdateData(TRUE);

	try {mVideoTuner->SetBrightness(mBrightness);} catch(...){}

}







void CVideoSourceDialog::OnChangeVsContrast() 

{

	// TODO: Add your control notification handler code here

	if (!mUpdated) return;

	if (!mVideoTuner) return;



	UpdateData(TRUE);

	try {mVideoTuner->SetContrast(mContrast);} catch(...){}	

}



void CVideoSourceDialog::OnChangeVsHue() 

{

	// TODO: Add your control notification handler code here

	if (!mUpdated) return;

	if (!mVideoTuner) return;



	UpdateData(TRUE);

	try {mVideoTuner->SetHue(mHue);} catch(...){}

}



void CVideoSourceDialog::OnChangeVsSaturation() 

{

	// TODO: Add your control notification handler code here

	if (!mUpdated) return;

	if (!mVideoTuner) return;



	UpdateData(TRUE);

	try {mVideoTuner->SetSaturation(mSaturation);} catch(...){}

}

