/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// MainFrm.h : interface of the CMainFrame class

//

/////////////////////////////////////////////////////////////////////////////

#include <ddraw.h>

//#include <bool.h>

class CTrueCapDoc;



class CMainFrame : public CFrameWnd

{

protected: // create from serialization only

	CMainFrame();

	DECLARE_DYNCREATE(CMainFrame)



// Attributes

public:



// Operations

public:

	void	SetDocument(CTrueCapDoc *doc);

	bool	CaptureFullScreen(bool fullscreen);

	void	ViewDestroying(void);



// Overrides

	// ClassWizard generated virtual function overrides

	//{{AFX_VIRTUAL(CMainFrame)

	public:

	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

	protected:

	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);

	virtual LRESULT DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam);

	//}}AFX_VIRTUAL



	CStatusBar*	GetStatusBar(void);



// Implementation

public:

	virtual ~CMainFrame();

#ifdef _DEBUG

	virtual void AssertValid() const;

	virtual void Dump(CDumpContext& dc) const;

#endif



	void ShowStatusBar(int s);

	bool IsAppActive(void);



protected:  // control bar embedded members

	CStatusBar  m_wndStatusBar;

	CToolBar    m_wndToolBar;

	CTrueCapDoc	*mDocument;

	LPDIRECTDRAW2		mDDPointer;

	RECT				mPreviousWindowLocation;

	int mPreviousScreenWidth,mPreviousScreenHeight,mPreviousScreenDepth;

	HMENU mPreviousMenu;

	bool	mAppActive;

	bool	mHelpOK;

	bool	mStatusOK;



// Generated message map functions

protected:

	//{{AFX_MSG(CMainFrame)

	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);

	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);

	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);

	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);

	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);

	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);

	afx_msg void OnMove(int x, int y);

	afx_msg void OnActivateApp(BOOL bActive, HTASK hTask);

	afx_msg void OnUpdateHelp(CCmdUI* pCmdUI);

	afx_msg void OnPaint();

	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

};



/////////////////////////////////////////////////////////////////////////////

