/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// tmrtxx.h
//
// Copyright (c) 1997-1998 The Duck Corporation
// All rights reserved
//
// [TMR 1/98]

#ifndef _tmrtxx_h
#define _tmrtxx_h

#ifndef _tmrt_h
#include "tmrt.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

long tmrtxx_get_compressedsize(int width, int height, 
                               int bits, int ntrp);

int tmrtxx_query_paramsize(void);

int tmrtxx_init(void *param);

int tmrtxx_free(void *param);

int tmrtxx_begin_xx(void *param, int width, int height, 
                    int bits, int ntrp, int src_fmt, 
                    int pitch);
// This pitch arg is in bytes per dest surface row [TMR 12/97]

int tmrtxx_end_xx(void *param);

int tmrtxx_xx(void *param, void *src, void *dst);

#ifdef __cplusplus
}
#endif

#endif  // (#ifndef _tmrtxx_h)

