;   Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.
;
;   This file is part of VpVision.
;
;   VpVision is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License ver. 2,
;   as published by the Free Software Foundation (www.fsf.org).
;
;   Foobar is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with VpVision; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
        .386
        .MODEL  flat, c, os_dos
        .CODE

EXTRN c xxtbl
EXTRN c rgb2y
EXTRN c rgb2v
EXTRN c rgb2u
EXTRN c linebuf_xx
ifdef TIME_TEST
EXTRN c mrnvar1
endif
ifdef YVU9

 ifdef NTRP
PUBLIC c xxyvu9n_
PUBLIC c xxvyvu9n_
PUBLIC c xxuyvu9n_
 else
PUBLIC c xxyvu9_
PUBLIC c xxvyvu9_
PUBLIC c xxuyvu9_
 endif

else

 ifdef YUY2

  ifdef NTRP
PUBLIC c xxyuy2n_
PUBLIC c xxvyuy2n_
PUBLIC c xxuyuy2n_
  else
PUBLIC c xxyuy2_
PUBLIC c xxvyuy2_
PUBLIC c xxuyuy2_
  endif

 else

  ifdef NTRP
PUBLIC c xxn_
PUBLIC c xxvn_
PUBLIC c xxun_
  else
PUBLIC c xx_
PUBLIC c xxv_
PUBLIC c xxu_
PUBLIC c pack4a_            ;mrn
PUBLIC c pack3a_            ;mrn
PUBLIC c pack2a_            ;mrn
ifdef TIME_TEST
PUBLIC c GKA_               ;mrn
endif
PUBLIC c clear_linebuf_xx_
  endif

 endif

endif


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ifdef TIME_TEST
GKA_:

        push    edx
        push    eax

        db      0fh,31h                 ;the cool timer opcode
        shrd    eax,edx,10              ;divide by 1024
        mov     mrnvar1,eax             ;you must declare a var elsewere
                                        ;perhaps a '.c' file.
        pop     eax
        pop     edx
        ret
endif

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PACK 4 BITS, assumes multiple of 4 pix in frame
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pack4a_:

src4  equ esp+20
dest4 equ src4+4
size4 equ dest4+4

           push      ebp
           mov       ebp,esp
           push      ebx
           push      esi
           push      edi
           
           mov       edi,dword ptr [size4]  ;set ecx to hold size
           mov       edx,dword ptr [dest4]  ;set edx to hold dest
           mov       eax,dword ptr [src4]   ;set eax to hold src
           
           mov       esi,0

    Again4:
           cmp       esi,edi
           jge       Out4

           mov       ebx,dword ptr[eax+esi]
           mov       dword ptr[esi+edx],ebx
           add       esi,4

           jmp       Again4
    Out4:
           pop       edi
           pop       esi
           pop       ebx
           leave
           ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PACK 3 BITS, assumes multiple of 4 pix in frame
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pack3a_:

src3  equ esp+20
dest3 equ src3+4
size3 equ dest3+4

           push      ebp
           mov       ebp,esp
           push      ebx
           push      esi
           push      edi
           
           mov       edi,dword ptr [size3]  ;set ecx to hold size
           mov       edx,dword ptr [dest3]  ;set edx to hold dest
           mov       eax,dword ptr [src3]   ;set eax to hold src
           
           mov       esi,0
           shr       edi,2    ;size/4

    Again3:      
           cmp       esi,edi
           jge       Out3
           
           mov       ebx,dword ptr[eax] ;move 4 bytes, 8 pixles

           mov       ecx,ebx                  ;copy
           and       ebx,00f0f0f0fh
           and       ecx,0f0f0f0f0h
           shr       ecx,1
           or        ebx,ecx

           mov       ecx,ebx                  ;copy
           and       ebx,0ff00ff00h
           and       ecx,000ff00ffh
           shr       ebx,2
           or        ebx,ecx

           mov       ecx,ebx                  ;copy
           and       ebx,0ffff0000h
           and       ecx,00000ffffh
           shr       ebx,4
           or        ebx,ecx

           mov       dword ptr[edx],ebx
           add       edx,3
           add       eax,4
           inc       esi

           jmp       Again3
    Out3:
           pop       edi
           pop       esi
           pop       ebx
           leave
           ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PACK 2 BITS, assumes multiple of 4 pix in frame
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pack2a_:

src2  equ esp+20
dest2 equ src2+4
size2 equ dest2+4

           push      ebp
           mov       ebp,esp
           push      ebx
           push      esi
           push      edi
           
           mov       edi,dword ptr [size2]  ;set ecx to hold size
           mov       edx,dword ptr [dest2]  ;set edx to hold dest
           mov       eax,dword ptr [src2]   ;set eax to hold src
           
           mov       esi,0
           shr       edi,2    ;size/4

    Again2:
        
           cmp       esi,edi
           jge       Out2
       
           mov       ebx,dword ptr[eax] ;move 4 bytes, 8 pixles

           mov       ecx,ebx                  ;copy
           and       ebx,00f0f0f0fh
           and       ecx,0f0f0f0f0h
           shr       ecx,2
           or        ebx,ecx

           mov       ecx,ebx                  ;copy
           and       ebx,0ff00ff00h
           and       ecx,000ff00ffh
           shr       ebx,4
           or        ebx,ecx

           mov       ecx,ebx                  ;copy
           and       ebx,0ffff0000h
           and       ecx,00000ffffh
           shr       ebx,8
           or        ebx,ecx

           mov       word ptr[edx],bx
           add       eax,4
           add       edx,2
           inc       esi

           jmp       Again2
    Out2:
           pop       edi
           pop       esi
           pop       ebx
           leave
           ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


; esi=lastline
; ebp=input data (bytes)
; eax=top
; ebx=bot
; edx=last
; xxtbl=off to see the wizard (offset to look-up table)


XXLOOP	MACRO off
		shl 	edx,16						;need to sign-extend
        mov     bx,[ebp+off]                ;get bot pix (from input image)
                                            ;in the YUY2 mode, bl = Y
ifdef RGB555

        mov     bl,BYTE PTR[rgb2y+ebx];     ;convert to coveted Y val
        and     ebx,255                     ;is this really necessary?

 ifdef  NTRP
        push    ebx

        mov     bx,[ebp+off+2]              ;get bot pix (from input image)
        mov     bl,BYTE PTR[rgb2y+ebx];     ;convert to coveted Y val
        and     ebx,255                     ;is this really necessary?
        add     [esp],ebx                   ;average with pushed val
        pop     ebx
        shr     ebx,1
 endif

else
 ;YUY2 or YVU9
        and     ebx,255                     ;is this really necessary?
        mov     al,bl
        shr     al,2                        ;*.75
        shr     bl,1
        add     bl,al
        add     bl,35
 ifdef  NTRP
        push    ebx

 ifdef YVU9
        mov     bx,[ebp+off+1]              ;yvu9 next y is 1 over
                                           
 else
        mov     bx,[ebp+off+2]              ;yuy2 ys are interleaved with vu
 endif
        and     ebx,255                     ;is this really necessary?
        mov     al,bl
        shr     al,2                        ;*.75
        shr     bl,1
        add     bl,al
        add     bl,35

        add     [esp],ebx                   ;average with pushed val
        pop     ebx
        shr     ebx,1
 endif

endif

		mov		al,[esi+off]				;get top pix (from lastline)
		sar		edx,16						;extended
		sub		ebx,eax						;bot=bot-top (no range check)
		sub		ebx,edx						;ebx=(bot-top)-vp
											;note: ebx could be -510 to +510 ?
		mov		eax,[xxtbl+2048+ebx*4]		;ax=add, hi=bits
		add		dx,ax						;vp=vp+dvq (clamp here someday)

        ED_CLAMPIT off

        mov     [esi+off],al
        sub     ebx,ebx                     ;clear ebx
ENDM

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CLAMPIT MACRO lo,hi,reg
LOCAL   @@HI,@@OUT
        cmp     reg,lo
        jg      @@HI
        mov     reg,lo
        jmp     @@OUT
@@HI:
        cmp     reg,hi
        jl      @@OUT
        mov     reg,hi
        jmp     @@OUT
@@OUT:

ENDM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ED_CLAMPIT MACRO offset
LOCAL   @@NO_NEG,@@NO_POS

        sub     ax,ax
        mov     al,[esi+offset]
        add     ax,dx                       ;bot=top+vp (update lastline)
        jns     @@NO_NEG
        mov     ax,0
@@NO_NEG:
        cmp     ax,255
        jng     @@NO_POS
        mov     ax,255
@@NO_POS:

ENDM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

VULOOP  MACRO off,table
		shl 	edx,16						;need to sign-extend
ifdef YUY2

 ifdef NTRP
;average 1st and 4th VU values on top line (each spans 2 pixels)

;*** ECX is not set when doing YVU9 ***

        ; average 4 seperate pixel values in vu
        mov     al,[ebp+off]              ;get the V or U pixzel
        mov     bl,[ebp+off+12]             ;average next V or U value

        and     eax,255                     ;is this really necessary?
        and     ebx,255                     ;is this really necessary?
        add     ebx,eax
        mov     al,[ebp+ecx+off]            ;get the V or U pixzel
        and     eax,255
        add     ebx,eax
        mov     al,[ebp+ecx+off+4]          ;average next V or U val
        and     eax,255
        add     ebx,eax
        shr     ebx,2

 else
;average 1st and 2nd VU values on top line (each spans 2 pixels)
        ; average 4 seperate pixel values in vu
        mov     al,[ebp+off]              ;get the V or U pixzel
        mov     bl,[ebp+off+4]              ;average next V or U value

        and     eax,255                     ;is this really necessary?
        and     ebx,255                     ;is this really necessary?
        add     ebx,eax
        mov     al,[ebp+ecx+off]              ;get the V or U pixzel
        and     eax,255
        add     ebx,eax
        mov     al,[ebp+ecx+off+4]              ;average next V or U val
        and     eax,255
        add     ebx,eax
        shr     ebx,2
 endif

else

 ifdef YVU9

;take one value
        mov     bl,[ebp+off]              ;get the V or U pixzel

        and     ebx,255                     ;is this really necessary?

 else
;RGB555
  ifdef NTRP
;average 2nd and 7th pixels on top line
;        mov     bx,[ebp+off+2]                ;get bot pix (from input image)
;        mov     al,BYTE PTR[table+ebx]      ;convert to coveted V/U val
;        mov     bx,[ebp+off+12]              ;average with last pixel in block
;        mov     bl,BYTE PTR[table+ebx]      ;grab another color pix & avg
;        and     eax,255                     ;is this really necessary?
;        and     ebx,255                     ;is this really necessary?
;        add     ebx,eax
   
        mov     ax,[ebp+off+ecx+2]                ;get bot pix (from input image)
        mov     al,BYTE PTR[table+eax]      ;convert to coveted V/U val
        and     eax,255
        add     ebx,eax

        mov     ax,[ebp+off+ecx+12]                ;get bot pix (from input image)
        mov     al,BYTE PTR[table+eax]      ;convert to coveted V/U val
        and     eax,255
        add     ebx,eax

        shr     ebx,1


  else
;average 1st and 4th pixels on top line
;        mov     bx,[ebp+off]                ;get bot pix (from input image)
;        mov     al,BYTE PTR[table+ebx]      ;convert to coveted V/U val
;        mov     bx,[ebp+off+6]
;        mov     bl,BYTE PTR[table+ebx]      ;grab another color pix & avg
;        and     eax,255                     ;is this really necessary?
;        and     ebx,255                     ;is this really necessary?
;        add     ebx,eax
     
        mov     ax,[ebp+off+ecx]                ;get bot pix (from input image)
        mov     al,BYTE PTR[table+eax]      ;convert to coveted V/U val
        and     eax,255
        add     ebx,eax

        mov     ax,[ebp+off+ecx+6]                ;get bot pix (from input image)
        mov     al,BYTE PTR[table+eax]      ;convert to coveted V/U val
        and     eax,255
        add     ebx,eax

        shr     ebx,1

  endif

 endif

endif

        ;CLAMPIT 0,255,ebx

		mov		al,[esi+off]				;get top pix (from lastline)
		sar		edx,16						;extended
		sub		ebx,eax						;bot=bot-top (no range check)
		sub		ebx,edx						;ebx=(bot-top)-vp
											;note: ebx could be -510 to +510 ?
		mov		eax,[xxtbl+2048+ebx*4]		;ax=add, hi=bits
        add     dx,ax                       ;vp=vp+dvq (clamp here not)

        ED_CLAMPIT off

        mov     [esi+off],al                ;bot=top+vp
        sub     ebx,ebx                     ;clear ebx
ENDM

XXMAIN	MACRO
LOCAL	xloop,yloop

; MAIN LOOP:

ifdef YVU9

 ifdef NTRP
xxyvu9n_:
 else
xxyvu9_:
 endif

else

 ifdef YUY2

  ifdef NTRP
xxyuy2n_:
  else
xxyuy2_:
  endif

 else

  ifdef NTRP
xxn_:
  else
xx_:
  endif

 endif
endif

		push	ebx						; sFr
		push	ebp
		push	ecx
		push	edx
		push	edi
		push	esi

; on entry:

; imaddr (eax),
; compaddr (edx),
; width/height, (bx=width, bx>>16=height) (ebx)

        mov     eax,[esp+28]        ;imaddr
        mov     edx,[esp+32]        ;compaddr
        mov     ebx,[esp+36]        ;w/h
		mov		[imaddr],eax
		mov		[compaddr],edx
		mov		ecx,ebx
		shr		ebx,16
		mov		[height],ebx
		and		ecx,0ffffh
        mov     [width],ecx
		lea		eax,[linebuf_xx]
		mov		[lineaddr],eax
;		call	clear_linebuf_xx

; set up ptr regs:

; esi=lastline
; edi=output
; ebp=input data (bytes)

		mov		esi,[lineaddr]
		mov		edi,[compaddr]
		mov		ebp,[imaddr]

; set up y loop:

		mov		eax,[height]
		mov		[ycount],eax
yloop:

; set up x loop:

		sub		edx,edx						; vp=0
		sub		ebx,ebx						; this temp should be cleared
		sub		eax,eax						; so should this 'un
		mov		esi,[lineaddr]				; reset lineaddr
		mov		ecx,[width]
ifdef   NTRP
        shr     ecx,2                       ; 8 pix ata time
else
        shr     ecx,4
endif

xloop:
ifdef YVU9
 ifdef NTRP
		XXLOOP 0							;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi],al					;lo nyb=1st pix
        XXLOOP 2
		shr		eax,24						;new pix=hi nyb
		or		[edi],al					;hi nyb=2nd pix

        XXLOOP 4                            ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi+1],al					;lo nyb=1st pix
        XXLOOP 6
		shr		eax,24						;new pix=hi nyb
		or		[edi+1],al					;hi nyb=2nd pix

        ;XXLOOP 8                           ;eax: hi nybble, hi byte
        ;shr     eax,28
        ;mov     [edi+2],al                  ;lo nyb=1st pix
        ;XXLOOP 10
        ;shr     eax,24                      ;new pix=hi nyb
        ;or      [edi+2],al                  ;hi nyb=2nd pix

        ;XXLOOP 12                            ;eax: hi nybble, hi byte
        ;shr     eax,28
        ;mov     [edi+3],al                  ;lo nyb=1st pix
        ;XXLOOP 14
        ;shr     eax,24                      ;new pix=hi nyb
        ;or      [edi+3],al                  ;hi nyb=2nd pix

        ;XXLOOP 16                            ;eax: hi nybble, hi byte
        ;shr     eax,28
        ;mov     [edi+4],al                  ;lo nyb=1st pix
        ;XXLOOP 18
        ;shr     eax,24                      ;new pix=hi nyb
        ;or      [edi+4],al                  ;hi nyb=2nd pix

        ;XXLOOP 20                       ;eax: hi nybble, hi byte
        ;shr     eax,28
        ;mov     [edi+5],al                  ;lo nyb=1st pix
        ;XXLOOP 22
        ;shr     eax,24                      ;new pix=hi nyb
        ;or      [edi+5],al                  ;hi nyb=2nd pix

        ;XXLOOP 24                       ;eax: hi nybble, hi byte
        ;shr     eax,28
        ;mov     [edi+6],al                  ;lo nyb=1st pix
        ;XXLOOP 26
        ;shr     eax,24                      ;new pix=hi nyb
        ;or      [edi+6],al                  ;hi nyb=2nd pix

        ;XXLOOP 28                       ;eax: hi nybble, hi byte
        ;shr     eax,28
        ;mov     [edi+7],al                  ;lo nyb=1st pix
        ;XXLOOP 30
        ;shr     eax,24                      ;new pix=hi nyb
        ;or      [edi+7],al                  ;hi nyb=2nd pix

        add     esi,8 ;was 32
        add     ebp,8 ;was 32
 else
		XXLOOP 0							;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi],al					;lo nyb=1st pix
        XXLOOP 1
		shr		eax,24						;new pix=hi nyb
		or		[edi],al					;hi nyb=2nd pix

        XXLOOP 2                            ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi+1],al					;lo nyb=1st pix
        XXLOOP 3
		shr		eax,24						;new pix=hi nyb
		or		[edi+1],al					;hi nyb=2nd pix

        XXLOOP 4                            ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi+2],al					;lo nyb=1st pix
        XXLOOP 5
		shr		eax,24						;new pix=hi nyb
		or		[edi+2],al					;hi nyb=2nd pix

        XXLOOP 6                            ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi+3],al					;lo nyb=1st pix
        XXLOOP 7
		shr		eax,24						;new pix=hi nyb
		or		[edi+3],al					;hi nyb=2nd pix

        XXLOOP 8                            ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi+4],al					;lo nyb=1st pix
        XXLOOP 9
		shr		eax,24						;new pix=hi nyb
		or		[edi+4],al					;hi nyb=2nd pix

        XXLOOP 10                       ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi+5],al					;lo nyb=1st pix
        XXLOOP 11
		shr		eax,24						;new pix=hi nyb
		or		[edi+5],al					;hi nyb=2nd pix

        XXLOOP 12                       ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi+6],al					;lo nyb=1st pix
        XXLOOP 13
		shr		eax,24						;new pix=hi nyb
		or		[edi+6],al					;hi nyb=2nd pix

        XXLOOP 14                       ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi+7],al					;lo nyb=1st pix
        XXLOOP 15
		shr		eax,24						;new pix=hi nyb
		or		[edi+7],al					;hi nyb=2nd pix

        add     esi,16
        add     ebp,16
 endif
else
 ifdef NTRP
		XXLOOP 0							;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi],al					;lo nyb=1st pix
        XXLOOP 4
		shr		eax,24						;new pix=hi nyb
		or		[edi],al					;hi nyb=2nd pix

        XXLOOP 8                            ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi+1],al					;lo nyb=1st pix
        XXLOOP 12
		shr		eax,24						;new pix=hi nyb
		or		[edi+1],al					;hi nyb=2nd pix

        ;XXLOOP 16                            ;eax: hi nybble, hi byte
        ;shr     eax,28
        ;mov     [edi+2],al                  ;lo nyb=1st pix
        ;XXLOOP 20
        ;shr     eax,24                      ;new pix=hi nyb
        ;or      [edi+2],al                  ;hi nyb=2nd pix

        ;XXLOOP 24                            ;eax: hi nybble, hi byte
        ;shr     eax,28
        ;mov     [edi+3],al                  ;lo nyb=1st pix
        ;XXLOOP 28
        ;shr     eax,24                      ;new pix=hi nyb
        ;or      [edi+3],al                  ;hi nyb=2nd pix

        ;XXLOOP 32                            ;eax: hi nybble, hi byte
        ;shr     eax,28
        ;mov     [edi+4],al                  ;lo nyb=1st pix
        ;XXLOOP 36
        ;shr     eax,24                      ;new pix=hi nyb
        ;or      [edi+4],al                  ;hi nyb=2nd pix

        ;XXLOOP 40                       ;eax: hi nybble, hi byte
        ;shr     eax,28
        ;mov     [edi+5],al                  ;lo nyb=1st pix
        ;XXLOOP 44
        ;shr     eax,24                      ;new pix=hi nyb
        ;or      [edi+5],al                  ;hi nyb=2nd pix

        ;XXLOOP 48                       ;eax: hi nybble, hi byte
        ;shr     eax,28
        ;mov     [edi+6],al                  ;lo nyb=1st pix
        ;XXLOOP 52
        ;shr     eax,24                      ;new pix=hi nyb
        ;or      [edi+6],al                  ;hi nyb=2nd pix

        ;XXLOOP 56                       ;eax: hi nybble, hi byte
        ;shr     eax,28
        ;mov     [edi+7],al                  ;lo nyb=1st pix
        ;XXLOOP 60
        ;shr     eax,24                      ;new pix=hi nyb
        ;or      [edi+7],al                  ;hi nyb=2nd pix

        add     esi,16 ;was 64
        add     ebp,16 ;was 64
 else
		XXLOOP 0							;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi],al					;lo nyb=1st pix
        XXLOOP 2
		shr		eax,24						;new pix=hi nyb
		or		[edi],al					;hi nyb=2nd pix

        XXLOOP 4                            ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi+1],al					;lo nyb=1st pix
        XXLOOP 6
		shr		eax,24						;new pix=hi nyb
		or		[edi+1],al					;hi nyb=2nd pix

        XXLOOP 8                            ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi+2],al					;lo nyb=1st pix
        XXLOOP 10
		shr		eax,24						;new pix=hi nyb
		or		[edi+2],al					;hi nyb=2nd pix

        XXLOOP 12                            ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi+3],al					;lo nyb=1st pix
        XXLOOP 14
		shr		eax,24						;new pix=hi nyb
		or		[edi+3],al					;hi nyb=2nd pix

        XXLOOP 16                            ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi+4],al					;lo nyb=1st pix
        XXLOOP 18
		shr		eax,24						;new pix=hi nyb
		or		[edi+4],al					;hi nyb=2nd pix

        XXLOOP 20                       ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi+5],al					;lo nyb=1st pix
        XXLOOP 22
		shr		eax,24						;new pix=hi nyb
		or		[edi+5],al					;hi nyb=2nd pix

        XXLOOP 24                       ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi+6],al					;lo nyb=1st pix
        XXLOOP 26
		shr		eax,24						;new pix=hi nyb
		or		[edi+6],al					;hi nyb=2nd pix

        XXLOOP 28                       ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi+7],al					;lo nyb=1st pix
        XXLOOP 30
		shr		eax,24						;new pix=hi nyb
		or		[edi+7],al					;hi nyb=2nd pix

        add     esi,32
        add     ebp,32
 endif
endif

ifdef NTRP
        add     edi,2
else
        add     edi,8
endif
		dec		ecx
		jnz		xloop

ifdef NTRP

 ifdef RGB555
		mov		eax,[width]
        sub     ebp,eax                 ;ebp -= width*4 (16 bit pix)
        sub     ebp,eax
        sub     ebp,eax
        sub     ebp,eax
        sub     ebp,eax
        sub     ebp,eax
        sub     ebp,eax
        sub     ebp,eax
 endif

else
		
 ifdef RGB555
        mov     eax,[width]
        sub     ebp,eax                 ;ebp -= width*4 (16 bit pix)
        sub     ebp,eax                 
		sub		ebp,eax
		sub		ebp,eax
 endif

endif
        dec     [ycount]
		jnz		yloop

		pop		esi
		pop		edi
		pop		edx
		pop		ecx						; rFr
		pop		ebp
		pop		ebx
		ret

ENDM

		XXMAIN

XXMAINVU    MACRO vutable,funcname,off
LOCAL   xloopvu,yloopvu,VUNO,VULINE

; MAIN LOOP:

funcname:

		push	ebx						; sFr
		push	ebp
		push	ecx
		push	edx
		push	edi
		push	esi

; on entry:

; eax	=	imaddr
; edx	=	compaddr
; ebx 	=	width/height (bx=width, bx>>16=height)

		mov		eax,[esp+28]
		mov		edx,[esp+32]
		mov		ebx,[esp+36]
		mov		[imaddr],eax
		mov		[compaddr],edx
		mov		ecx,ebx
		shr		ebx,16
		mov		[height],ebx
		and		ecx,0ffffh
		mov		[width],ecx
		lea		eax,[linebuf_xx]
		mov		[lineaddr],eax
;		call	clear_linebuf_xx

; set up ptr regs:

; esi=lastline
; edi=output
; ebp=input data (bytes)

		mov		esi,[lineaddr]
		mov		edi,[compaddr]
		mov		ebp,[imaddr]

; set up y loop:

		mov		eax,[height]
		mov		[ycount],eax
yloopvu:

; set up x loop:

		sub		edx,edx						; vp=0
		sub		ebx,ebx						; this temp should be cleared
		sub		eax,eax						; so should this 'un
		mov		esi,[lineaddr]				; reset lineaddr
		mov		ecx,[width]
ifdef   NTRP
        shr     ecx,1                       ; 4 blox (16 pix) ata time
else
        shr     ecx,2
endif
        push   ecx


ifdef YUY2
        ; ecx is off set for vu averaging
        cmp     [ycount],1
        jg      VULINE
        mov     ecx,0
        jmp     VUNO
    VULINE:
        mov     ecx,[width]
        shl     ecx,5
    VUNO:
endif

ifdef RGB555
        ; ecx is off set for vu averaging
        ;mov     ecx,[ycount]
        ;sub     ecx,4
        ;cmp     [ycount],ecx

        cmp     [ycount],1
        jg      VULINE
        mov     ecx,0
        jmp     VUNO
    VULINE:
        mov     ecx,[width]
        shl     ecx,5
        neg     ecx
    VUNO:
endif


xloopvu:

ifdef YVU9
 ifdef NTRP
        VULOOP 0+off,vutable                            ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi],al					;lo nyb=1st pix
        VULOOP 2+off,vutable
		shr		eax,24						;new pix=hi nyb
		or		[edi],al					;hi nyb=2nd pix

 ;       VULOOP 4+off,vutable                            ;eax: hi nybble, hi byte
 ;       shr     eax,28
 ;       mov     [edi+1],al                  ;lo nyb=1st pix
 ;       VULOOP 6+off,vutable
 ;       shr     eax,24                      ;new pix=hi nyb
 ;       or      [edi+1],al                  ;hi nyb=2nd pix

        add     esi,4 ;was 8
        add     ebp,4 ;was 8
 else
        VULOOP 0+off,vutable                            ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi],al					;lo nyb=1st pix
        VULOOP 1+off,vutable
		shr		eax,24						;new pix=hi nyb
		or		[edi],al					;hi nyb=2nd pix

        VULOOP 2+off,vutable                            ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi+1],al					;lo nyb=1st pix
        VULOOP 3+off,vutable
		shr		eax,24						;new pix=hi nyb
		or		[edi+1],al					;hi nyb=2nd pix

        add     esi,4
        add     ebp,4
 endif
else
 ifdef NTRP
        VULOOP 0+off,vutable                            ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi],al					;lo nyb=1st pix
        VULOOP 16+off,vutable
		shr		eax,24						;new pix=hi nyb
		or		[edi],al					;hi nyb=2nd pix

;        VULOOP 32+off,vutable                            ;eax: hi nybble, hi byte
;        shr     eax,28
;        mov     [edi+1],al                  ;lo nyb=1st pix
;        VULOOP 48+off,vutable
;        shr     eax,24                      ;new pix=hi nyb
;        or      [edi+1],al                  ;hi nyb=2nd pix

        add     esi,32; was 64
        add     ebp,32; was 64
 else
        VULOOP 0+off,vutable                            ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi],al					;lo nyb=1st pix
        VULOOP 8+off,vutable
		shr		eax,24						;new pix=hi nyb
		or		[edi],al					;hi nyb=2nd pix

        VULOOP 16+off,vutable                            ;eax: hi nybble, hi byte
		shr		eax,28
		mov		[edi+1],al					;lo nyb=1st pix
        VULOOP 24+off,vutable
		shr		eax,24						;new pix=hi nyb
		or		[edi+1],al					;hi nyb=2nd pix

        add     esi,32
        add     ebp,32
 endif
endif

ifdef  NTRP
        add     edi,1
else
        add     edi,2
endif

  ;      dec     ecx
        dec     DWORD PTR[esp]
		jnz		xloopvu

; ok, we have to account for line just compressed, then subtract
; 4 lines worth, keeping in mind that width=real width/4, and pitch=2*width

ifndef YVU9
        mov     eax,[width]                
 ifdef NTRP
        shl     eax,4                       ;eax=pitch
 else
        shl     eax,3                       ;eax=pitch
 endif
        sub     ebp,eax                     ;point to beg of line
        shl     eax,2                       ;eax=pitch*4

 ifdef YUY2
        add     ebp,eax                     ;now we point to +(pitch*4)
 else
        sub     ebp,eax                     ;now we point to -(pitch*4)
 endif
endif
        pop     ecx
		dec		[ycount]
        jnz     yloopvu

		pop		esi
		pop		edi
		pop		edx
		pop		ecx						; rFr
		pop		ebp
		pop		ebx
		ret

ENDM

ifdef YVU9

 ifdef NTRP
        XXMAINVU rgb2v,xxvyvu9n_,0
        XXMAINVU rgb2u,xxuyvu9n_,0           ; switched, as usual
 else
        XXMAINVU rgb2v,xxvyvu9_,0
        XXMAINVU rgb2u,xxuyvu9_,0           ; switched, as usual
 endif

else
                                        ; +1 = U, +3 = V
 ifdef YUY2
  ifdef NTRP
        XXMAINVU rgb2v,xxvyuy2n_,1
        XXMAINVU rgb2u,xxuyuy2n_,3           ; switched, as usual
  else
        XXMAINVU rgb2v,xxvyuy2_,1
        XXMAINVU rgb2u,xxuyuy2_,3           ; switched, as usual
  endif
 else
  ifdef NTRP
        XXMAINVU rgb2v,xxvn_,0
        XXMAINVU rgb2u,xxun_,0
  else
        XXMAINVU rgb2v,xxv_,0
        XXMAINVU rgb2u,xxu_,0
  endif

 endif

endif

clear_linebuf_xx_:
		push	eax
		push	ecx
		push	esi

		mov		eax,[esp+16]
		mov		edx,[esp+20]
		mov		ecx,eax
		mov		al,dl
		shl		eax,8
		mov		al,dl
		shl		eax,8
		mov		al,dl
		shl		eax,8
		mov		al,dl
		lea		esi,[linebuf_xx]
		shr		ecx,2
cloop:
		mov		[esi],eax
		add		esi,4
		dec		ecx
		jnz		cloop

		pop		esi
		pop		ecx
		pop		eax
		ret

.DATA
ALIGN

width		LABEL	DWORD
			dd		0
height		LABEL	DWORD
			dd		0
imaddr		LABEL	DWORD
			dd		0
compaddr	LABEL	DWORD
			dd		0
lineaddr	LABEL	DWORD
			dd		0
ycount		LABEL	DWORD
			dd		0
END
