/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CTIMESHIFTEVENT_H_
#define CTIMESHIFTEVENT_H_

#include <afxdisp.h>

#include "nmr_string.h"
#include "IVideoTuner.h"
#include <iostream>
using namespace std;

//class istream;
//class ostream;

class CTimeShiftEvent
{
public:
	typedef enum {
		Sunday = 0, Monday = 1, Tuesday = 2, Wednesday = 3, Thursday = 4, 
		Friday = 5, Saturday = 6, MonThruFri = 7, EvSunday = 8, 
		EvMonday = 9, EvTuesday = 10, EvWednesday = 11,EvThursday = 12, 
		EvFriday = 13, EvSaturday = 14 } Day_t;

	int				mChannel;
 	COleDateTime	mStartTime;
	COleDateTime	mEndTime;
	Day_t			mDay;
	COleDateTime	mDate;
	nmr_string		mFilename;
	bool			mAppendDateAndTime;
	U32				mAudioFrequency;
	U16				mAudioBits;
	U16				mAudioChannels;
	U16				mVideoWidth;
	U16				mVideoHeight;
	U16				mFPS;
	U16				mVideoQuality;


	IVideoTuner::VideoSource_t	mVideoSource;

	U8		mBrightness;

	U8		mContrast;

	U8		mHue;

	U8		mSaturation;

	int		mVolume;


	CTimeShiftEvent(void);
	int operator==(const CTimeShiftEvent &e);
	COleDateTime NextActivationTime(void);
	COleDateTimeSpan Duration(void);


	nmr_string	CreateCondensedString(void);



friend ostream& operator<<(ostream &o,const CTimeShiftEvent &e);

friend istream& operator>>(istream &i,CTimeShiftEvent &e);

};



#endif
