/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// TrueCap.cpp : Defines the class behaviors for the application.

//



#include "stdafx.h"

#include "TrueCap.h"



#include "MainFrm.h"

#include "TrueCapDoc.h"

#include "TrueCapView.h"

#include "TruecapGlobals.h"


#ifdef _DEBUG

#define new DEBUG_NEW

#undef THIS_FILE

static char THIS_FILE[] = __FILE__;

#endif

#include "danbug.h"


int			g___ReportBufferUpdates = 0;

extern "C" {

	void Announcement(const char *c)

	{

	}

	extern int gForceCPUID;
}

extern int gForceRate;
extern int gForceScale;

int gUseCodec = 0;


/////////////////////////////////////////////////////////////////////////////

// CTrueCapApp



BEGIN_MESSAGE_MAP(CTrueCapApp, CWinApp)

	//{{AFX_MSG_MAP(CTrueCapApp)

	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)

		// NOTE - the ClassWizard will add and remove mapping macros here.

		//    DO NOT EDIT what you see in these blocks of generated code!

	//}}AFX_MSG_MAP

	// Standard file based document commands

	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)

	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)

	// Standard print setup command

	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)

END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////

// CTrueCapApp construction



CTrueCapApp::CTrueCapApp()

{

	// TODO: add construction code here,

	// Place all significant initialization in InitInstance

}



/////////////////////////////////////////////////////////////////////////////

// The one and only CTrueCapApp object



CTrueCapApp theApp;



/////////////////////////////////////////////////////////////////////////////

// CTrueCapApp initialization









BOOL CTrueCapApp::InitInstance()

{

	// Standard initialization

	// If you are not using these features and wish to reduce the size

	//  of your final executable, you should remove from the following

	//  the specific initialization routines you do not need.

	AfxOleInit();

	AfxEnableControlContainer();



#ifdef _AFXDLL

	Enable3dControls();			// Call this when using MFC in a shared DLL

#else

	Enable3dControlsStatic();	// Call this when linking to MFC statically

#endif



	LoadPrivateMessages();

	SetRegistryKey("DuckVision");



	LoadStdProfileSettings();  // Load standard INI file options (including MRU)



///	dbm -- try to use the codec:
	gUseCodec = 1;
///	gUseCodec = AfxGetApp()->GetProfileInt("DuckVision","UseCodec",0);
	
	gForceCPUID = AfxGetApp()->GetProfileInt("DuckVision","cpuID",-1);
	if(gForceCPUID >= 0) dprintf("  setting cpuID to %d\n",gForceCPUID);

	gForceRate = AfxGetApp()->GetProfileInt("DuckVision","forceRate",0);
	if(gForceRate) dprintf("  setting rate to %d\n",gForceRate);
	
	gForceScale = AfxGetApp()->GetProfileInt("DuckVision","forceScale",0);
	if(gForceScale) dprintf("  setting scale to %d\n",gForceScale);

	// Register the application's document templates.  Document templates

	//  serve as the connection between documents, frame windows and views.



	CSingleDocTemplate* pDocTemplate;

	pDocTemplate = new CSingleDocTemplate(

		IDR_MAINFRAME,

		RUNTIME_CLASS(CTrueCapDoc),

		RUNTIME_CLASS(CMainFrame),       // main SDI frame window

		RUNTIME_CLASS(CTrueCapView));

	AddDocTemplate(pDocTemplate);



#ifdef ROCKWELL

		MakeRockwellVersion();

#else

	if (gDuckVisionLite)

		{

		MakeLiteVersion();

		}

	else

		{

		MakeNormalVersion();

		}

#endif



	// Parse command line for standard shell commands, DDE, file open

	MyCommands cmdInfo;

	ParseCommandLine(cmdInfo);



	// Dispatch commands specified on the command line

	if (!ProcessShellCommand(cmdInfo))

		return FALSE;



	return TRUE;

}



/////////////////////////////////////////////////////////////////////////////

// CAboutDlg dialog used for App About



class CAboutDlg : public CDialog

{

public:

	CAboutDlg();



// Dialog Data

	//{{AFX_DATA(CAboutDlg)

	enum { IDD = IDD_ABOUTBOX };

	//}}AFX_DATA



	// ClassWizard generated virtual function overrides

	//{{AFX_VIRTUAL(CAboutDlg)

	protected:

	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	//}}AFX_VIRTUAL



// Implementation

protected:

	//{{AFX_MSG(CAboutDlg)

	afx_msg void OnPaint();

	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

	

	int mFirstTime;

};



CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)

{

	//{{AFX_DATA_INIT(CAboutDlg)

	//}}AFX_DATA_INIT



	mFirstTime = 1;

}



void CAboutDlg::DoDataExchange(CDataExchange* pDX)

{

	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CAboutDlg)

	//}}AFX_DATA_MAP

}



BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)

	//{{AFX_MSG_MAP(CAboutDlg)

	ON_WM_PAINT()

	//}}AFX_MSG_MAP

END_MESSAGE_MAP()



// App command to run the dialog

void CTrueCapApp::OnAppAbout()

{

	CAboutDlg aboutDlg;

	aboutDlg.DoModal();

}



/////////////////////////////////////////////////////////////////////////////

// CTrueCapApp commands



void CAboutDlg::OnPaint() 

{

	CPaintDC dc(this); // device context for painting

	

	// TODO: Add your message handler code here

#ifndef ROCKWELL

	if (gDuckVisionLite && mFirstTime)

		{

		CString s;

		GetDlgItemText(IDC_STATIC2,s);

		s += " Evaluation Version";

		SetDlgItemText(IDC_STATIC2,s);

		mFirstTime = 0;

		}

#endif

	// Do not call CDialog::OnPaint() for painting messages

}

