/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// TrueCapDoc.cpp : implementation of the CTrueCapDoc class

//

#include "stdafx.h"

#include "TrueCap.h"



#include "TrueCapDoc.h"

#include "TrueCapView.h"

#include "CTrueCapGUIController.h"

#include "MainFrm.h"

#include "nmr_string.h"

#include "TrueCapGlobals.h"

#include "CWin32VideoTunerFactory.h"

#include "CVideoSourceDialog.h"

#include "CTimeShiftEvent.h"

#include "CDialogNAG1.h"

#include <CLogger.h>

#include <assert.h>

#include <vfw.h>

#include <ddraw.h>

#include "danbug.h"


int gDirectDrawAvailable = 0;

int gNT = 0;



#define _WAIT 32514 // temp kludge

#define _NORMAL 32512



#ifdef _DEBUG

#define new DEBUG_NEW

#undef THIS_FILE

static char THIS_FILE[] = __FILE__;

#endif



/////////////////////////////////////////////////////////////////////////////

// CTrueCapDoc



IMPLEMENT_DYNCREATE(CTrueCapDoc, CDocument)



BEGIN_MESSAGE_MAP(CTrueCapDoc, CDocument)

	//{{AFX_MSG_MAP(CTrueCapDoc)

	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)

	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)

	ON_COMMAND(ID_OPTIONS_INVERTAUDIO, OnOptionsInvertaudio)

	ON_UPDATE_COMMAND_UI(ID_OPTIONS_INVERTAUDIO, OnUpdateOptionsInvertaudio)

	ON_COMMAND(ID_OPTIONS_HARDWARE_SINGLEFIELDINPUT, OnOptionsHardwareSinglefieldinput)

	ON_UPDATE_COMMAND_UI(ID_OPTIONS_HARDWARE_SINGLEFIELDINPUT, OnUpdateOptionsHardwareSinglefieldinput)

	ON_COMMAND(ID_OPTIONS_CLOSEDCAPTION_CHANNEL1, OnOptionsClosedcaptionChannel1)

	ON_UPDATE_COMMAND_UI(ID_OPTIONS_CLOSEDCAPTION_CHANNEL1, OnUpdateOptionsClosedcaptionChannel1)

	ON_COMMAND(ID_OPTIONS_CLOSEDCAPTION_CHANNEL2, OnOptionsClosedcaptionChannel2)

	ON_UPDATE_COMMAND_UI(ID_OPTIONS_CLOSEDCAPTION_CHANNEL2, OnUpdateOptionsClosedcaptionChannel2)

	ON_COMMAND(ID_OPTIONS_CLOSEDCAPTION_OFF, OnOptionsClosedcaptionOff)

	ON_UPDATE_COMMAND_UI(ID_OPTIONS_CLOSEDCAPTION_OFF, OnUpdateOptionsClosedcaptionOff)

	//}}AFX_MSG_MAP

END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////

// CTrueCapDoc construction/destruction



extern CLogger *gTraceLog = 0;



CTrueCapDoc::CTrueCapDoc()

{

	// TODO: add one-time construction code here

	mFullScreen = false;

	mSingleFieldInput = 0;



	OSVERSIONINFO osver;

	osver.dwOSVersionInfoSize = sizeof(osver);

	if (::GetVersionEx(&osver) && osver.dwPlatformId == VER_PLATFORM_WIN32_NT)

			gNT = 1;

	

	mKeyString				= AfxGetApp()->GetProfileString("DuckVision",KEYSTRING_KEY,"");

#ifndef ROCKWELL

	if (VerifyKeyString(mKeyString))

		MakeNormalVersion();

#endif



	mDeferedEventLoad = 0;

	if (!gForceDIBS)

		DDTest();

	mFirstModeSet = 1;

	mMode = (TrueCapMode_t)AfxGetApp()->GetProfileInt("DuckVision","Mode",(int)CTrueCapDoc::Capture);

	mPlaybackFile = AfxGetApp()->GetProfileString("DuckVision","PlaybackFile","c:\\capture.vp3");

	mCaptureFile = AfxGetApp()->GetProfileString("DuckVision","CaptureFile","c:\\capture.vp3");

	mPostCaptureFilename = mCaptureFile;

	mAudioCapture_SampleSize= AfxGetApp()->GetProfileInt("DuckVision","AudioCaptureSampleSize",16);

	mAudioCapture_Channels	= AfxGetApp()->GetProfileInt("DuckVision","AudioCaptureChannels",1);

	mAudioCapture_Frequency = AfxGetApp()->GetProfileInt("DuckVision","AudioCaptureFrequency",44100);

	mAudioCapture_Volume	= AfxGetApp()->GetProfileInt("DuckVision","AudioCaptureVolume",75);



	mVideoCapture_Width		= AfxGetApp()->GetProfileInt("DuckVision","VideoCaptureWidth",320);

	mVideoCapture_Height	= AfxGetApp()->GetProfileInt("DuckVision","VideoCaptureHeight",240);

	mVideoCapture_FPS		= AfxGetApp()->GetProfileInt("DuckVision","VideoCaptureFPS",15);

	mVideoCapture_Quality	= AfxGetApp()->GetProfileInt("DuckVision","VideoCaptureQuality",1);



	mSingleFieldInput		= AfxGetApp()->GetProfileInt("DuckVision","SingleFieldInput",0);

	//mCCOn					= AfxGetApp()->GetProfileInt("DuckVision","CCOn",0);

	//mCCChannel				= AfxGetApp()->GetProfileInt("DuckVision","CCChannel",1);

	mCCOn = 0;

	mCCChannel = 1;



	/////////////////////////////

	if (gExpiration)

		{

		COleDateTime today_o = COleDateTime::GetCurrentTime();

		COleDateTime install_date_o = COleDateTime::GetCurrentTime();

		char today[256];

		sprintf(today,"%d %d %d",today_o.GetYear(),today_o.GetMonth(),today_o.GetDay());

		CString install_date = AfxGetApp()->GetProfileString("DuckVision","RefreshRate",CString(today));

		if (CString(install_date) == CString(today))

			AfxGetApp()->WriteProfileString("DuckVision","RefreshRate",CString(today));



		int year_i,month_i,day_i;

		sscanf(((const char *)install_date),"%d %d %d",&year_i,&month_i,&day_i);

		install_date_o.SetDateTime(year_i,month_i,day_i,0,0,0);



		COleDateTimeSpan span = today_o - install_date_o;

		COleDateTime expiration_date(EXPIRATION_YEAR,EXPIRATION_MONTH,EXPIRATION_DAY,0,0,0);

		if ((span.GetTotalDays() > SOFT_EXPIRATION_DAY_COUNT) ||

			(today_o >= expiration_date))

			{

			AfxMessageBox("The application has expired.");

			exit(0);

			}

		}	

	//////////////////////////

	if (gNag)

		{

		CDialogNAG1 nag;

		nag.DoModal();

		}



	mCurrentDisplayFrame = 0;

	mGUI = 0;

	mView = 0;

	mMainFrame = 0;

	gTraceLog = new CLogger(10,0,0,0,"neilcap");

	gTraceLog->Start();

	ChangeVolume(mAudioCapture_Volume);

	mCanCapture = 1;

	CWin32VideoTunerFactory f;

	if (gsForceNoTuner)

		mVideoTuner = 0;

	else

		mVideoTuner = f.MakeTuner("DuckVision");


	if (mVideoTuner && (!gNoStartupMute))
		{
		try {mVideoTuner->SetAudioMute(0);} catch(...){}
		}

	mTryingToCaptureFrame = false;
}



CTrueCapDoc::~CTrueCapDoc()

{

	AfxGetApp()->WriteProfileInt("DuckVision","Mode",(int)mMode);

	AfxGetApp()->WriteProfileString("DuckVision","PlaybackFile",mPlaybackFile);

	AfxGetApp()->WriteProfileString("DuckVision","CaptureFile",mCaptureFile);

	AfxGetApp()->WriteProfileInt("DuckVision","AudioCaptureSampleSize",mAudioCapture_SampleSize);

	AfxGetApp()->WriteProfileInt("DuckVision","AudioCaptureChannels",mAudioCapture_Channels);

	AfxGetApp()->WriteProfileInt("DuckVision","AudioCaptureFrequency",mAudioCapture_Frequency);

	AfxGetApp()->WriteProfileInt("DuckVision","AudioCaptureVolume",mAudioCapture_Volume);

	AfxGetApp()->WriteProfileInt("DuckVision","VideoCaptureWidth",mVideoCapture_Width);

	AfxGetApp()->WriteProfileInt("DuckVision","VideoCaptureHeight",mVideoCapture_Height);

	AfxGetApp()->WriteProfileInt("DuckVision","VideoCaptureFPS",mVideoCapture_FPS);

	AfxGetApp()->WriteProfileInt("DuckVision","VideoCaptureQuality",mVideoCapture_Quality);

	AfxGetApp()->WriteProfileInt("DuckVision","SingleFieldInput",mSingleFieldInput);

	AfxGetApp()->WriteProfileInt("DuckVision","CCOn",mCCOn);

	AfxGetApp()->WriteProfileInt("DuckVision","CCChannel",mCCChannel);



	delete mVideoTuner;

	mVideoTuner = 0;



	delete mGUI;

	if (gTraceLog)

		gTraceLog->Terminate();

	if (gTraceLog)

		gTraceLog->Join();

	delete gTraceLog;

	gTraceLog = 0;



}





int			

CTrueCapDoc::SetKeyString(CString s)

{

	mKeyString = s;

	AfxGetApp()->WriteProfileString("DuckVision",KEYSTRING_KEY,mKeyString);

	return VerifyKeyString(s);

}



CString		

CTrueCapDoc::GetKeyString(void)

{

	return mKeyString;

}





BOOL CTrueCapDoc::OnNewDocument()

{

	if (!CDocument::OnNewDocument())

		return FALSE;



	// TODO: add reinitialization code here

	// (SDI documents will reuse this document)



	return TRUE;

}



/////////////////////////////////////////////////////////////////////////////

// CTrueCapDoc serialization



void CTrueCapDoc::Serialize(CArchive& ar)

{

	if (ar.IsStoring())

	{

		// TODO: add storing code here

	}

	else

	{

		// TODO: add loading code here

	}

}



/////////////////////////////////////////////////////////////////////////////

// CTrueCapDoc diagnostics



#ifdef _DEBUG

void CTrueCapDoc::AssertValid() const

{

	CDocument::AssertValid();

}



void CTrueCapDoc::Dump(CDumpContext& dc) const

{

	CDocument::Dump(dc);

}

#endif //_DEBUG



/////////////////////////////////////////////////////////////////////////////

// CTrueCapDoc commands



void

CTrueCapDoc::ReloadEvents(void)

{

	if (IsCapturing())

		mDeferedEventLoad = 1;

	else

		mView->LoadEvents();

}



CString

CTrueCapDoc::GetPlaybackFileName(void)

{

	return mPlaybackFile;

}



void	

CTrueCapDoc::SetAudioConfiguration(int sample_size,int channels,int frequency,int volume)

{

	assert(frequency == 11025 || frequency == 22050 || frequency == 44100);

	assert(channels == 1 || channels == 2);

	assert(sample_size == 8 || sample_size == 16);

	assert(volume >= 0 && volume <= 100);



	mAudioCapture_SampleSize= sample_size;

	mAudioCapture_Channels	= channels;

	mAudioCapture_Frequency = frequency;

	mAudioCapture_Volume	= volume;

	ChangeVolume(volume);

}



void	

CTrueCapDoc::GetAudioConfiguration(int &sample_size,int &channels,int &frequency,int &volume)

{

	sample_size	= mAudioCapture_SampleSize;

	channels	= mAudioCapture_Channels;

	frequency	= mAudioCapture_Frequency;

	volume		= mAudioCapture_Volume;

}



void

CTrueCapDoc::SetVideoConfiguration(int width,int height,int fps,int quality)

{

	assert(width == 320 || width == 160 || width==640);

	assert(height == 240 || height == 120 || height == 480);

	assert(fps == 30 || fps == 15 || fps == 10);

	assert(quality >= 0 && quality <= 4);



	mVideoCapture_Width		= width;

	mVideoCapture_Height	= height;

	mVideoCapture_FPS		= fps;

	mVideoCapture_Quality	= quality;

	mCap.SetVideoParams(mVideoCapture_Width,mVideoCapture_Height,mVideoCapture_FPS,

		mVideoCapture_Quality,mSingleFieldInput);

}



int		

CTrueCapDoc::GetTunerState(IVideoTuner::VideoSource_t &source,

		U8 &brightness,U8 &contrast,U8 &hue,U8 &saturation,

		IVideoTuner::Channel_t &channel)

{

	int result = FALSE;

	source = mVideoTuner ? IVideoTuner::Tuner_Antenna : IVideoTuner::BaseBand_Composite;

	brightness	= 128;

	contrast	= 128;

	hue			= 128;

	saturation	= 128;

	channel		= 2;

	if (mVideoTuner && mMode == Capture)

		{

		try{

			source		= mVideoTuner->GetVideoSource();

			brightness	= mVideoTuner->GetBrightness();

			hue			= mVideoTuner->GetHue();

			contrast	= mVideoTuner->GetContrast();

			saturation	= mVideoTuner->GetSaturation();

			channel		= mVideoTuner->GetChannel();

			result = TRUE;

			}

		catch(...){}

		}

	return result;

}





void	

CTrueCapDoc::SetTunerState(IVideoTuner::VideoSource_t source,

		U8 brightness,U8 contrast,U8 hue,U8 saturation,

		IVideoTuner::Channel_t channel)

{

	if (mVideoTuner && mMode == Capture)

	{

	try{

		mVideoTuner->SetVideoSource(source);

		mVideoTuner->SetBrightness(brightness);

		mVideoTuner->SetHue(hue);

		mVideoTuner->SetContrast(contrast);

		mVideoTuner->SetSaturation(saturation);

		mVideoTuner->SetChannel(channel);

		}

	catch(...){}

	}

}





int		

CTrueCapDoc::GetTunerState(IVideoTuner::VideoSource_t &source,

		U8 &brightness,U8 &contrast,U8 &hue,U8 &saturation)

{

	int result = FALSE;

	source = mVideoTuner ? IVideoTuner::Tuner_Antenna : IVideoTuner::BaseBand_Composite;

	brightness	= 128;

	contrast	= 128;

	hue			= 128;

	saturation	= 128;

	if (mVideoTuner && mMode == Capture)

		{

		try{

			source		= mVideoTuner->GetVideoSource();

			brightness	= mVideoTuner->GetBrightness();

			hue			= mVideoTuner->GetHue();

			contrast	= mVideoTuner->GetContrast();

			saturation	= mVideoTuner->GetSaturation();

			result = TRUE;

			}

		catch(...){}

		}

	return result;

}





void	

CTrueCapDoc::SetTunerState(IVideoTuner::VideoSource_t source,

		U8 brightness,U8 contrast,U8 hue,U8 saturation)

{

	if (mVideoTuner && mMode == Capture)

	{

	try{

		mVideoTuner->SetVideoSource(source);

		mVideoTuner->SetBrightness(brightness);

		mVideoTuner->SetHue(hue);

		mVideoTuner->SetContrast(contrast);

		mVideoTuner->SetSaturation(saturation);

		}

	catch(...){}

	}

}



void	

CTrueCapDoc::ConfigureCaptureDriverSource(IVideoTuner::VideoSource_t &source,

		U8 &brightness,U8 &contrast,U8 &hue,U8 &saturation)

{

	if (mVideoTuner)

		{

		CVideoSourceDialog dlog;

		if (mMode == Capture)

			dlog.SetVideoTuner(mVideoTuner);

		switch(source)

			{

			case IVideoTuner::BaseBand_Composite:

				dlog.mSource = 0;

				break;

			case IVideoTuner::BaseBand_SVideo:

				dlog.mSource = 1;

				break;

			case IVideoTuner::BaseBand_Camera:

				dlog.mSource = 2;

				break;

			case IVideoTuner::Tuner_Cable:

				dlog.mSource = 3;

				break;

			case IVideoTuner::Tuner_Antenna:

				dlog.mSource = 4;

				break;

			}

		dlog.mBrightness= brightness;

		dlog.mContrast	= contrast;

		dlog.mHue		= hue;

		dlog.mSaturation= saturation;



		if (dlog.DoModal() != IDOK)

			{

			if (mMode == Capture)

				{

				mVideoTuner->SetVideoSource(source);

				mVideoTuner->SetBrightness(brightness);

				mVideoTuner->SetHue(hue);

				mVideoTuner->SetContrast(contrast);

				mVideoTuner->SetSaturation(saturation);

				}

			}

		else

			{

			brightness	= dlog.mBrightness;

			contrast	= dlog.mContrast;

			hue			= dlog.mHue;

			saturation	= dlog.mSaturation;

			switch(dlog.mSource)

				{

				case 0:

					source = IVideoTuner::BaseBand_Composite;

					break;

				case 1:

					source = IVideoTuner::BaseBand_SVideo;

					break;

				case 2:

					source = IVideoTuner::BaseBand_Camera;

					break;

				case 3:

					source = IVideoTuner::Tuner_Cable;

					break;

				case 4:

					source = IVideoTuner::Tuner_Antenna;

					break;

				}

			}

		}

	else

		{

		mCap.ConfigureCaptureDriverSource();

		}

}



void

CTrueCapDoc::ShowVideo(BOOL s)

{

	if (mTryingToCaptureFrame) return;

	if (mMode == Capture)

		mCap.ShowVideo(s);

}





void

CTrueCapDoc::GetVideoConfiguration(int &width,int &height,int &fps,int &quality)

{

	width	= mVideoCapture_Width;

	height	= mVideoCapture_Height;

	fps		= mVideoCapture_FPS;

	quality	= mVideoCapture_Quality;

}



void

CTrueCapDoc::RefreshFilename(void)

{

	if (mMode == Capture)

		SetCaptureFileName(mCaptureFile);

	else

		SetPlaybackFileName(mPlaybackFile);

}



void

CTrueCapDoc::SetPlaybackFileName(const char *name)

{

	mPlaybackFile = name;

	nmr_string	n = "Playback file name: ";

	n += name;

	if (mMainFrame && !IsPageFlipping())

		mMainFrame->PostMessage(WM_USER,0,(long)new nmr_string(n));

}



CString

CTrueCapDoc::GetCaptureFileName(void)

{

	return mCaptureFile;

}



void

CTrueCapDoc::SetCaptureFileName(const char *name)

{

	mCaptureFile = name;

	nmr_string	n = "Capture file name: ";

	n += name;

	if (mMainFrame && !IsPageFlipping())

		mMainFrame->PostMessage(WM_USER,0,(long)new nmr_string(n));

}



int

CTrueCapDoc::GetCurrentDisplayFrame(void)

{

	return mCurrentDisplayFrame;

}



int

CTrueCapDoc::GetCurrentFrame(void)

{

	return mPlayer.GetCurrentFrame();

}



CTrueCapDoc::TrueCapMode_t

CTrueCapDoc::GetMode(void)

{

	return mMode;

}



int

CTrueCapDoc::GetCanCapture(void)

{

	return mCanCapture;

}



void

CTrueCapDoc::SetCaptureMode(void)

{

	if (!mView) return;

	if (mMode == Capture && !mFirstModeSet) return;

	try {

		if (!gNT)

			::SetSystemCursor(::LoadCursor(NULL,IDC_WAIT),_NORMAL);

		// give feedback first

		mMode = Capture;

		mView->HidePlaybackButtons();

		mView->ShowCaptureButtons();

		//

		if (mPlayer.IsPlaying())  mPlayer.Stop();

		mFirstModeSet = 0;

		if (CreateCaptureWindow())

			{

			mCanCapture = 1;

			SetCaptureFileName(mCaptureFile); // just so it updates

//			mView->Invalidate();

			}

		else

			{

			mCanCapture = 0;

			SetPlaybackMode();

			}

		}

	catch(...)

		{

		}

	if (!gNT)

		::SetSystemCursor(::LoadCursor(NULL,IDC_ARROW),_NORMAL);

}



void

CTrueCapDoc::SetPlaybackMode(int firsttime)

{

	if (!mView) return;

	if (mMode == Playback && !mFirstModeSet) return;

	// give feedback first

	mMode = Playback;

	mView->HideCaptureButtons();

	mView->ShowPlaybackButtons();

	//

	_HaltCapture();

	DestroyCaptureWindow();

	//if (firsttime)

	SetPlaybackFileName(mPlaybackFile);

	//else

	//	SetPlaybackFileName(mCaptureFile); // capture file is now playback file

//	mView->Invalidate();

	mFirstModeSet = 0;

	PrepareForSeek();

	mView->ReconfigureSlider();

	mView->PlaybackMode();

}



void

CTrueCapDoc::ChangeVolume(int v)

{

	assert(v >= 0 && v <= 100);

	mMixer.SetLineInVolume(v);

}



CCap &

CTrueCapDoc::GetCaptureWindow(void)

{

	return mCap;

}



void

CTrueCapDoc::SetView(CTrueCapView *v)

{

	mView = v;

	mMainFrame = dynamic_cast<CMainFrame*>(AfxGetMainWnd());

	assert(mMainFrame);

	assert(mView);

	assert(!mGUI);

	mMainFrame->SetDocument(this);

	mGUI = new CTrueCapGUIController(mView,mView,mMainFrame,"c:\\TrueCapTrace.txt");

}



void

CTrueCapDoc::ViewDestroying(void)

{

	if (mMainFrame)

		mMainFrame->ViewDestroying();

}



int

CTrueCapDoc::CreateCaptureWindow()

{

	int	result = 0;



	try

		{

		assert(mGUI);

		assert(mView);

		mCap.SetVideoParams(mVideoCapture_Width,mVideoCapture_Height,mVideoCapture_FPS,

			mVideoCapture_Quality,mSingleFieldInput);

		mCap.Instantiate(mView->m_hWnd,mGUI);

		// again in case the driver went nuts and reconfigured itself

		mCap.SetVideoParams(mVideoCapture_Width,mVideoCapture_Height,mVideoCapture_FPS,

			mVideoCapture_Quality,mSingleFieldInput);

		SetCaptureFileName(mCaptureFile); // so we see it

		ConfigureCC();

		try 

			{ 

			if (mVideoTuner) 

				{

				mVideoTuner->SetAudioMute(1);

				mVideoTuner->LoadSettings("DuckVision"); 

				}

			} 

		catch(...)

			{

			}

		result = 1;		

		}

	catch(CError &e)

		{

		AfxMessageBox(e.data());

		}

	return result;

}



void

CTrueCapDoc::DestroyCaptureWindow(void)

{

	try

		{

		try {if (mVideoTuner) mVideoTuner->SetAudioMute(0);} catch(...){}

		if (!mFirstModeSet)

			{

			try {if (mVideoTuner) mVideoTuner->SaveSettings("DuckVision");} catch(...){}

			}

		mCap.DestroyWindow();

		}

	catch(CError &e)

		{

		AfxMessageBox(e.data());

		}

}



int

CTrueCapDoc::BigImage(void)

{

	if (mMode == Playback)

		return mPlayer.BigImage();

	else

		return mCap.BigImage();

}



int

CTrueCapDoc::IsCapturing(void)

{

	return mCap.IsRunning();

}



int

CTrueCapDoc::IsPlaying(void)

{

	return mPlayer.IsPlaying();

}



int

CTrueCapDoc::IsPaused(void)

{

	return mPlayer.IsPause();

}



int

CTrueCapDoc::IsPageFlipping(void)

{

	if (mMode != Playback) return 0;

	return mPlayer.IsPageFlipping();

}



void

CTrueCapDoc::Play(void)

{

	assert(mMode == Playback);

	mPlayer.Play(mPlaybackFile,mView->m_hWnd,mGUI,mView->GetSlider(),mView->GetPlayButton());

}



void

CTrueCapDoc::Stop(void)

{

	assert(mMode == Playback);

	mPlayer.Stop();

	mView->DrawStaticFrame();

}



void

CTrueCapDoc::SkipCommercial(void)

{

	assert(mMode == Playback);

	mPlayer.SkipCommercial();

}



void

CTrueCapDoc::FastForward(void)

{

	assert(mMode == Playback);

	mPlayer.FastForward(mPlaybackFile,mView->m_hWnd,mGUI,mView->GetSlider(),mView->GetPlayButton());

}



void

CTrueCapDoc::Rewind(void)

{

	assert(mMode == Playback);

	mPlayer.Rewind();

}



void

CTrueCapDoc::Pause(void)

{

	assert(mMode == Playback);

	mPlayer.Pause();

}



int

CTrueCapDoc::PrepareForSeek(void)

{

	int	result = 0;

	if (!mPlayer.IsPause())

		{

		if (mPlayer.IsPlaying())

			{

			Pause();

			result = 1;

			}

		else

			{

			mPlayer.StartPaused(mPlaybackFile,mView->m_hWnd,mGUI,mView->GetSlider(),mView->GetPlayButton());

			}

		}

	return result;

}



int

CTrueCapDoc::GrabMPVE(void)

{

	return mPlayer.GrabMPVE();

}



void

CTrueCapDoc::ReleaseMPVE(void)

{

	mPlayer.ReleaseMPVE();

}



void

CTrueCapDoc::AdvanceFrame(void)

{

	mPlayer.AdvanceFrame();

}



void

CTrueCapDoc::RetreatFrame(void)

{

	mPlayer.RetreatFrame();

}



void

CTrueCapDoc::AdvanceTime(int milliseconds)

{

	mPlayer.AdvanceTime(milliseconds);

}



void

CTrueCapDoc::RetreatTime(int milliseconds)

{

	mPlayer.RetreatTime(milliseconds);

}



void

CTrueCapDoc::DisplayCurrentFrame(void)

{

	mPlayer.DisplayCurrentFrame();

}



void

CTrueCapDoc::SetAndDisplayFrame(int f)

{

	mPlayer.SetAndDisplayFrame(f);

}



void

CTrueCapDoc::GoFullScreen(int f)

{

	mPlayer.GoFullScreen(f);

}



void

CTrueCapDoc::SendCaptureOptions(void)

{

	mCap.SetCaptureFile(mCaptureFile);

	mCap.SetAudioParams(mAudioCapture_SampleSize,mAudioCapture_Channels,

		mAudioCapture_Frequency);

	mCap.SetVideoParams(mVideoCapture_Width,mVideoCapture_Height,mVideoCapture_FPS,

		mVideoCapture_Quality,mSingleFieldInput);

	

	char s[4];

	int len = 3;

	if (mCaptureFile.GetLength() < len)

		len = mCaptureFile.GetLength();

	memcpy(s,((LPCSTR)mCaptureFile),len);

	s[len] = '\0';

	mCap.SetFreeSpaceDrive(s);

}



void

CTrueCapDoc::_HaltCapture(void)

{

	int b = mCap.IsRunning();

	mCap.Halt();

	if (b)

		{

		mPlaybackFile = mCaptureFile;

		SetCaptureFileName(mPostCaptureFilename);

		}

	if (mDeferedEventLoad)

		{

		mDeferedEventLoad = 0;

		mView->LoadEvents();

		}

	mGUI->EnableDialogs(1);

	mView->CaptureStopped();

}



void

CTrueCapDoc::_StartCapture(void)

{

 dprintf("SendCaptureOptions");
	SendCaptureOptions();

 dprintf("calling mView->CaptureStart");
	mView->CaptureStart();
 dprintf("calling mCap.Run");
	mCap.Run();
 dprintf("just called mCap.Run");
}



void

CTrueCapDoc::DoTimedRecord(void)

{

	mGUI->EnableDialogs(0);

	DoCapture();

}



void

CTrueCapDoc::DoCapture(CString tempfilename)

{

	if (mMode != Capture) return;
 dprintf("DoCapture called"); ///


	if (mCap.IsRunning())

		_HaltCapture();

	else

		{

		if (tempfilename != "")

			mPostCaptureFilename = tempfilename;

		else

			mPostCaptureFilename = mCaptureFile;

 dprintf("about to call _StartCapture"); ///
		_StartCapture();

		}

}





void

CTrueCapDoc::StopCapture(void)

{

	_HaltCapture();

}



void

CTrueCapDoc::DDTest(void)

{

	LPDIRECTDRAW		mDDPointer;



	CoInitialize(NULL);

	if (CoCreateInstance(CLSID_DirectDraw,NULL,CLSCTX_ALL,

				IID_IDirectDraw,(void **)&mDDPointer) == DD_OK)

		{

		gDirectDrawAvailable = 1;

		mDDPointer -> Release();

		}

	CoUninitialize();

}



void

CTrueCapDoc::WindowPosChanged(void)

{

	if (mMode == Capture)

		mView->Invalidate();

}



int

CTrueCapDoc::GetNumVideoFrames(void)

{

	int		result = 0;



	AVIFileInit();

	PAVIFILE	f;

	PAVISTREAM	s;

	if (AVIFileOpen(&f,mPlaybackFile,OF_READ,NULL)) 

		{

		AVIFileExit();

		return 0;

		}

	if (AVIFileGetStream(f,&s,streamtypeVIDEO,0))

		{

		AVIFileRelease(f);

		AVIFileExit();

		return 0;

		}

	result = AVIStreamLength(s);

	AVIStreamRelease(s);

	AVIFileRelease(f);

	AVIFileExit();

	return result;

}



///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////







void CTrueCapDoc::OnEditCopy() 

{

	// TODO: Add your command handler code here

	if (mMode != Playback) return;



	AVIFileInit();

	PAVIFILE	f;

	if (!AVIFileOpen(&f,mPlaybackFile,OF_READ,NULL))

		{

		AVIPutFileOnClipboard(f);

		AVIFileRelease(f);

		}

	AVIFileExit();

}



void CTrueCapDoc::OnUpdateEditCopy(CCmdUI* pCmdUI) 

{

	// TODO: Add your command update UI handler code here

	pCmdUI->Enable(mMode == Playback);

}







void

CTrueCapDoc::ShowStatusBar(int s)

{

	if (s == SW_HIDE)

		{

		mMainFrame->GetWindowRect(&mWindowPosition);

		mMainFrame->ShowStatusBar(s);

		}

	else

		{

		mMainFrame->ShowStatusBar(s);

		mMainFrame->SetWindowPos(&CWnd::wndNoTopMost,

			mWindowPosition.left,mWindowPosition.top,

			mWindowPosition.right - mWindowPosition.left,

			mWindowPosition.bottom - mWindowPosition.top,

			0);

		//mMainFrame->MoveWindow(&mWindowPosition);

		}

}



IVideoTuner*

CTrueCapDoc::GetVideoTuner(void)

{

	return mVideoTuner;

}



int		

CTrueCapDoc::HasTuner(void)

{

	return (mVideoTuner ? 1 : 0);

}



int		

CTrueCapDoc::GetChannel(void)

{

	int	res = 0;

	try { res = mVideoTuner->GetChannel(); } catch(...){}

	return res;

}



int	

CTrueCapDoc::SetChannel(int channel)

{

	int res = 0;

	try {mVideoTuner->SetChannel(channel); res = 1;} catch(...){}

	return res;

}



void	

CTrueCapDoc::StopTimeShiftCapture(void)

{

	if (mMode == Capture)

		_HaltCapture();

}



void	

CTrueCapDoc::StartTimeShiftCapture(const CTimeShiftEvent &e)

{

	CString tmpfilename;



	mGUI->EnableDialogs(0);

	SetCaptureMode();

	if (mMode != Capture) return;

	mGUI->EnableDialogs(0);

	if (IsFullScreenCapture())

		ToggleFullScreen();



	nmr_string filename;

	filename = e.mFilename;

	if (filename.length() > 4)

		{

		if (strcmp(".vp3",((const char *)filename) + filename.length() - 4) == 0)

			{

			char *tmp = new char[filename.length() + 1];

			strcpy(tmp,filename);

			tmp[filename.length() - 4] = 0;

			filename = tmp;

			delete [] tmp;

			}

		}

	if (e.mAppendDateAndTime)

		//filename += (const char *)(COleDateTime::GetCurrentTime()).Format("_%m_%d_%y_%I_%M_%p");

		filename += (const char *)(e.mStartTime).Format("_%m_%d_%y_%I_%M_%p");

	filename += ".vp3";

	tmpfilename = mCaptureFile;

	SetCaptureFileName(filename);

	int sample_size,channels,frequency,volume;

	GetAudioConfiguration(sample_size,channels,frequency,volume);

	sample_size = e.mAudioBits;

	channels	= e.mAudioChannels;

	frequency	= e.mAudioFrequency;

	SetAudioConfiguration(sample_size,channels,frequency,volume);

	SetVideoConfiguration(e.mVideoWidth,e.mVideoHeight,e.mFPS,e.mVideoQuality);

	if (mVideoTuner)

		{

		try { 

			mVideoTuner->SetBrightness(e.mBrightness);

			mVideoTuner->SetContrast(e.mContrast);

			mVideoTuner->SetHue(e.mHue);

			mVideoTuner->SetSaturation(e.mSaturation);

			mVideoTuner->SetVideoSource(e.mVideoSource);

			mVideoTuner->SetChannel(e.mChannel); 

			} 

		catch(...)

			{

			}

		}	

	Sleep(2000);

	DoCapture(tmpfilename);

	if (!IsCapturing())

		{

		DoCapture(tmpfilename);

		}

}





IVideoTuner::ChannelList_t

CTrueCapDoc::BuildScanList(IScanProgressFeedback &feedback)

{

	if (mVideoTuner) 

		return mVideoTuner->GetChannelsWithSignal(feedback);

	IVideoTuner::ChannelList_t tmp;

	return tmp;

}



void

CTrueCapDoc::ConfigureCC(void)

{

	TRACE("CC: %d CCChannel: %d \n",(int)mCCOn,(int)mCCChannel);

	if (mVideoTuner)

		mVideoTuner->SetCC(mCCOn,mCCChannel);

}



void		

CTrueCapDoc::ToggleCC(void)

{

	if (mVideoTuner && mMode == Capture)

		{

		mCCOn = !mCCOn;

		ConfigureCC();

		}

}



void		

CTrueCapDoc::ToggleCCChannel(void)

{

	if (mVideoTuner && mMode == Capture)

		{

		mCCChannel = (mCCChannel == 1 ? 2 : 1);

		ConfigureCC();

		}

}





void

CTrueCapDoc::CaptureFrame(void)

{

	static char BASED_CODE szFilter[] = "BMP Files (*.bmp)|*.bmp|All Files (*.*)|*.*||";

	if (mMode != Capture) return;

	mTryingToCaptureFrame = true;

	if (!mCap.GrabFrame())

		{

		AfxMessageBox("Frame capture failed!");

		mCap.ShowVideo(TRUE);

		mTryingToCaptureFrame = false;

		return;

		}



	CFileDialog dlog(FALSE,"bmp",0,

		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,szFilter);

	if (dlog.DoModal() == IDOK)

		mCap.FileSaveDib(dlog.GetPathName());

	mCap.ShowVideo(TRUE);

	mTryingToCaptureFrame = false;

}



bool

CTrueCapDoc::IsFullScreenCapture(void)

{

	return mFullScreen;

}



void

CTrueCapDoc::ToggleFullScreen(void)

{

	if (mFullScreen)

		{

		DestroyCaptureWindow();

		mMainFrame->CaptureFullScreen(false);

		mCap.SetVideoParams(mVideoCapture_Width,mVideoCapture_Height,mVideoCapture_FPS,

			mVideoCapture_Quality,mSingleFieldInput);

		mFullScreen = !mFullScreen;

		mView->CaptureFullScreen(false);

		mMainFrame->SetFocus();

		CreateCaptureWindow();

		}

	else

		{

		mView->CaptureFullScreen(true);

		_HaltCapture();

		DestroyCaptureWindow();

		if (mMainFrame->CaptureFullScreen(true))

			{

			CreateCaptureWindow();

			mCap.SetVideoParams(640,480,mVideoCapture_FPS,

				mVideoCapture_Quality,mSingleFieldInput);

			mFullScreen = !mFullScreen;

			}

		else

			{

			mView->CaptureFullScreen(false);

			CreateCaptureWindow();

			}

 		}

}



void CTrueCapDoc::OnOptionsInvertaudio() 

{

	// TODO: Add your command handler code here

	if (!HasTuner()) return;

	mVideoTuner->SetAudioInversion(!mVideoTuner->GetAudioInversion());

}



void CTrueCapDoc::OnUpdateOptionsInvertaudio(CCmdUI* pCmdUI) 

{

	// TODO: Add your command update UI handler code here

	if (HasTuner())

		{

		pCmdUI->Enable(TRUE);

		pCmdUI->SetCheck(mVideoTuner->GetAudioInversion());

		}

	else

		{

		pCmdUI->Enable(FALSE);

		}

}



void CTrueCapDoc::OnOptionsHardwareSinglefieldinput() 

{

	// TODO: Add your command handler code here

	mSingleFieldInput = !mSingleFieldInput;

	mCap.SetVideoParams(mVideoCapture_Width,mVideoCapture_Height,mVideoCapture_FPS,

		mVideoCapture_Quality,mSingleFieldInput);

}



void CTrueCapDoc::OnUpdateOptionsHardwareSinglefieldinput(CCmdUI* pCmdUI) 

{

	// TODO: Add your command update UI handler code here

	pCmdUI->Enable(!IsCapturing());

	pCmdUI->SetCheck(mSingleFieldInput);

	

}



void CTrueCapDoc::OnOptionsClosedcaptionChannel1() 

{

	// TODO: Add your command handler code here

	if (mMode != Capture || !mVideoTuner || !mVideoTuner->HasCC()) return;

	mVideoTuner->SetCC(true,1);

	mCCOn = true;

	mCCChannel = 1;

}



void CTrueCapDoc::OnUpdateOptionsClosedcaptionChannel1(CCmdUI* pCmdUI) 

{

	// TODO: Add your command update UI handler code here

	if (mMode != Capture || !mVideoTuner || !mVideoTuner->HasCC())

		pCmdUI->Enable(FALSE);

	else

		{

		pCmdUI->Enable(TRUE);

		pCmdUI->SetCheck(mCCOn && (mCCChannel == 1));

		}

}



void CTrueCapDoc::OnOptionsClosedcaptionChannel2() 

{

	// TODO: Add your command handler code here

	if (mMode != Capture || !mVideoTuner || !mVideoTuner->HasCC()) return;

	mVideoTuner->SetCC(true,2);	

	mCCOn = true;

	mCCChannel = 2;

}



void CTrueCapDoc::OnUpdateOptionsClosedcaptionChannel2(CCmdUI* pCmdUI) 

{

	// TODO: Add your command update UI handler code here

	if (mMode != Capture || !mVideoTuner || !mVideoTuner->HasCC())

		pCmdUI->Enable(FALSE);

	else

		{

		pCmdUI->Enable(TRUE);

		pCmdUI->SetCheck(mCCOn && (mCCChannel == 2));

		}

}



void CTrueCapDoc::OnOptionsClosedcaptionOff() 

{

	// TODO: Add your command handler code here

	if (mMode != Capture || !mVideoTuner || !mVideoTuner->HasCC()) return;

	mVideoTuner->SetCC(false,1);

	mCCOn = false;

	mCCChannel = 1;

}



void CTrueCapDoc::OnUpdateOptionsClosedcaptionOff(CCmdUI* pCmdUI) 

{

	// TODO: Add your command update UI handler code here

	if (mMode != Capture || !mVideoTuner || !mVideoTuner->HasCC())

		pCmdUI->Enable(FALSE);

	else

		{

		pCmdUI->Enable(TRUE);

		pCmdUI->SetCheck(!mCCOn);

		}

}

