/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "TruecapGlobals.h"

#include <fstream>
using namespace std;

#ifndef NDEBUG

ofstream f("tglog.txt");

#endif


int gDuckVisionLite = 1;
int	gPlaybackLogo	= 0;
int	gEventTimeLimit = 0;
int	gEventLimit		= 0;
int	gExpiration		= 0;
int	gsForceNoTuner = 0;
int gForceDIBS = 0;

int gNoStartupMute = 0;
int gNag = 1;



UINT	gPrivateMessageLauncher = 0;

UINT	gPrivateMessageApp = 0;



static unsigned short AlphaNumericToFiveBit( char a) {



    if(( a < 79) && ( a >=58))

        return a - 65;

    if(( a >= 49) && ( a < 58))

        return a  - 35;

    if( a >= 80)

        return a - 57;





    return 0;

}



int	 VerifyKeyString(const char *s)

{

	unsigned short a,b,c,d,e;
	return 1;											///	dbm -- disable copy protection (it's OPEN SOURCE stupid!)
	if (!s) return 0;
	if (strlen(s) != 16) return 0;

	sscanf(s,"%04X%04X%04X%04X",&b,&c,&d,&e);
	a = (b + d + e + c)  % 0xFFFF;

    unsigned short bo[16];
    const char *x = s;
    for( int i = 0; i < 16; i++)
        bo[i] = AlphaNumericToFiveBit( x[i]);

	a  =  bo[0];     a  <<= 5;
    a  |= bo[1];     a  <<= 5;
    a  |= bo[2];     a  <<= 1;
    a  |= (( bo[3] >> 4) & 1);
    a &= 0xFFFF;


    b  =  bo[3];     b  <<= 5;            
    b  |= bo[4];     b  <<= 5;
    b  |= bo[5];     b  <<= 2;
    b  |= (( bo[6] >> 3) & 3);
    b &= 0xFFFF;

    c  =  bo[6];     c  <<= 5;            
    c  |= bo[7];     c  <<= 5;
    c  |= bo[8];     c  <<= 3;
    c  |= (( bo[9] >> 2) & 7);
    c &= 0xFFFF;

    d  =  bo[9];     d  <<= 5;            
    d  |= bo[10];     d  <<= 5;
    d  |= bo[11];     d  <<= 4;
    d  |= (( bo[12] >> 1) & 0xf);
    d &= 0xFFFF;

    e  =  bo[12];     e  <<= 5;            
    e  |= bo[13];     e  <<= 5;
    e  |= bo[14];     e  <<= 5;
    e  |=  bo[15]; 
    e &= 0xFFFF;

	if ((a != 0) && (b!=0) && (c != 0) && (d!=0) &&(e != 0)) 
		{
		if( c ==  (a + b + e +  d) % 0xFFFF) 
			{  
			return 0;
            //printf( "%04X%04X%04X%04X\n", a,b,d,e);
            //printf( "Hello Priority A.\n");
			} 
		else if( b ==  (a + d + e + c) % 0xFFFF) 
			{     
			return 0;
			//printf( "%04X%04X%04X%04X\n", a,c,d,e);
			//printf( "Hello Priority B.\n");
			} 
		else if( a == (b + d + e + c)  % 0xFFFF) 
			{
			return 1;
			//printf( "%04X%04X%04X%04X\n", b,c,d,e);
			//printf( "Hello Priority C.\n");
			}
		else return 0;
		return 0;
		}
	return 0;
}




void MakeRockwellVersion(void)

{

	gPlaybackLogo	= 0;

	gEventTimeLimit = 0;

	gEventLimit		= DUCKVISION_LITE_EVENTLIMIT;

	gExpiration		= 0;

	gDuckVisionLite	= 1;

	gNag = 0;

}



void MakeLiteVersion(void)
{
	gPlaybackLogo	= DUCKVISION_LITE_LOGOSTATE;
	gEventTimeLimit = DUCKVISION_LITE_EVENTTIMELIMIT;
	gEventLimit		= DUCKVISION_LITE_EVENTLIMIT;
	gExpiration		= DUCKVISION_LITE_EXPIRATION;
	gDuckVisionLite	= 1;

	gNag = 1;

}
void MakeNormalVersion(void)
{

	gDuckVisionLite = 0;
	gPlaybackLogo	= 0;
	gEventTimeLimit = 0;
	gEventLimit		= 0;
	gExpiration		= 0;
	gNag = 0;

}

void

CheckEventLimits(CTimeShiftManager &time_shift_manager)

{

	if (gEventLimit > 0)

		{

		CTimeShiftManager::EventList_t	el = time_shift_manager.GetEventList();

		while (el.size() > gEventLimit)

			el.pop_back();

		time_shift_manager.BeginListAdjustment();

		time_shift_manager.Clear();

		for (int x = 0; x < el.size(); ++x)

			time_shift_manager.AddEvent(el[x]);

		time_shift_manager.EndListAdjustment();

		}

}



void

CheckEventTimeLimits(CTimeShiftManager &time_shift_manager)

{

	if (gEventTimeLimit > 0)

		{

		CTimeShiftManager::EventList_t	el = time_shift_manager.GetEventList();

		CTimeShiftManager::EventList_t::iterator i;

		for (i = el.begin(); i != el.end(); ++i)

			{

			COleDateTimeSpan span = (*i).mEndTime - (*i).mStartTime;

			double seconds = span.GetTotalSeconds();

			if (seconds > (gEventTimeLimit * 60))

				(*i).mEndTime = (*i).mStartTime + COleDateTimeSpan(0,0,gEventTimeLimit,0);

			}

		time_shift_manager.BeginListAdjustment();

		time_shift_manager.Clear();

		for (int x = 0; x < el.size(); ++x)

			time_shift_manager.AddEvent(el[x]);

		time_shift_manager.EndListAdjustment();

		}

}





void

LoadEvents(const char *filename,CTimeShiftManager &time_shift_manager)

{

	// try it a few times in cause launcher has it open

	for (int xxx = 0; xxx < 5; ++xxx)

		{

		// because ifstream is buggy

		FILE *fff = fopen(filename,"r");

		if (fff)

			{

			ifstream f(filename);

			f >> time_shift_manager;

			fclose(fff);

			break;

			}

		else

			{

			Sleep(2000);

			}

		}



	// if event limits then prune list

	CheckEventLimits(time_shift_manager);

	CheckEventTimeLimits(time_shift_manager);

}



void

SaveEvents(const char *filename,CTimeShiftManager &time_shift_manager)

{

	for(int xxx = 0; xxx < 5; ++xxx)

		{

		ofstream f(filename);

		if (f)

			{

			f << time_shift_manager;

			break;

			}

		else

			Sleep(2000);

		}

}





void

LoadPrivateMessages(void)

{

	gPrivateMessageLauncher = RegisterWindowMessage(PRIVATE_MESSAGE_LAUNCHER);

	gPrivateMessageApp = RegisterWindowMessage(PRIVATE_MESSAGE_APP);



	assert(gPrivateMessageLauncher != WM_USER);

	assert(gPrivateMessageApp != WM_USER);

	assert(gPrivateMessageApp != gPrivateMessageLauncher);

	if (gPrivateMessageApp == 0 || gPrivateMessageLauncher == 0)

		{

		AfxMessageBox("Error registering IPC messages");

		exit(0);

		}

}







void	LoadLastKnownDuckvisionLocation(char *location,char *path)

{

	GetProfileString(APPNAME,DV_KEY,"",location,DV_LOCATION_SIZE);

	GetProfileString(APPNAME,DVPATH_KEY,"",path,DV_LOCATION_SIZE);

}



int		VerifyDuckvisionLocation(char *location)

{

	WIN32_FIND_DATA data;

	HANDLE h = ::FindFirstFile(location,&data);

	if (h == INVALID_HANDLE_VALUE) 

		{

#ifndef NDEBUG

		f << "Location check for " << location << " failed " << endl;

#endif

		location[0] = 0;

		return 0;

		}

	else

		{

#ifndef NDEBUG

		f << "Location check for " << location << " succeeded " << endl;

#endif

		::FindClose(h);

		return 1;

		}

}





int _FindDuckvision(const char *drive,char *duckvisionlocation,char *duckvisionpath)

{

	char path[1024];

	strcpy(path,drive);

	strcat(path,"\\*");

	WIN32_FIND_DATA data;

	HANDLE h = ::FindFirstFile(path,&data);

	if (h == INVALID_HANDLE_VALUE)

		return 0;



	while (1)

		{

		if (data.dwFileAttributes == FILE_ATTRIBUTE_DIRECTORY &&

			strcmp(data.cFileName,".") && strcmp(data.cFileName,".."))

			{

			char path2[4096];

			strcpy(path2,drive);

			strcat(path2,"\\");

			strcat(path2,data.cFileName);

			if (FindDuckvision(path2,duckvisionlocation,duckvisionpath))

				{

				::FindClose(h);

				return 1;

				}

			}



		if (!::FindNextFile(h,&data))

			{

			::FindClose(h);

			break;

			}

		}



	return 0;

}



int FindDuckvision(const char *drive,char *duckvisionlocation,char *duckvisionpath)

{

#ifndef NDEBUG

	f << "Checking directory " << drive << endl;

#endif



	int result = 0;

	char path[1024];

	strcpy(duckvisionpath,drive);

	strcpy(path,drive);

	strcat(path,"\\DuckVision.exe");

	WIN32_FIND_DATA data;

	HANDLE h = ::FindFirstFile(path,&data);

	if (h == INVALID_HANDLE_VALUE) 

		return _FindDuckvision(drive,duckvisionlocation,duckvisionpath); // check dirs



	while (1)

		{

		if (1 /*data.dwFileAttributes == FILE_ATTRIBUTE_NORMAL*/)

			{

#ifndef NDEBUG

			f << "Duckvision found at " << path << endl;

#endif

			strcpy(duckvisionlocation,path);

			result = 1;

			break;

			}

		else

			{

			if (!::FindNextFile(h,&data))

				{

				break;

				}

			}

		}

	

	::FindClose(h);

	return (result ? result : _FindDuckvision(drive,duckvisionlocation,duckvisionpath));

}



void CalculateNewDuckvisionLocation(char *duckvisionlocation,char *duckvisionpath)

{

	char drive[] = "C:";

	for (char x = 'C'; x <= 'Z'; ++x)

		{

		drive[0] = x;

		char d2[25];

		strcpy(d2,drive);

		strcat(d2,"\\");

		if (GetDriveType(d2) == DRIVE_FIXED)

			{

#ifndef NDEBUG

			f << "Checking drive " << drive << endl;

#endif

			if (FindDuckvision(drive,duckvisionlocation,duckvisionpath)) break;

			}

		}

}



void SaveDuckvisionLocation(char *location,char *path)

{

	WriteProfileString(APPNAME,DV_KEY,location);

	WriteProfileString(APPNAME,DVPATH_KEY,path);

}



