/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef TRUECAPGLOBALS_H_
#define TRUECAPGLOBALS_H_

#include <afxwin.h>

#include "CTimeShiftManager.h"


#define	EXPIRATION_YEAR		2002

#define EXPIRATION_MONTH	6

#define	EXPIRATION_DAY		30

#define	SOFT_EXPIRATION_DAY_COUNT	60



#define EVENTFILE	"\\Events.txt"

#define PRIVATE_MESSAGE_LAUNCHER	"duckvision_launcher"

#define PRIVATE_MESSAGE_APP			"duckvision_app"

#define KEYSTRING_KEY				"Platform"


#define DUCKVISION_LITE_LOGOSTATE	1
#define DUCKVISION_LITE_EVENTTIMELIMIT	15
#define DUCKVISION_LITE_EVENTLIMIT	1
#define DUCKVISION_LITE_EXPIRATION	1

extern int	gsForceNoTuner;
extern int	gPlaybackLogo;
extern int	gDuckVisionLite;
extern int	gEventTimeLimit;
extern int	gEventLimit;
extern int	gExpiration;

extern int	gForceDIBS;
extern UINT	gPrivateMessageLauncher;

extern UINT gPrivateMessageApp;

extern int	gNoStartupMute;
extern int	gNag;


void MakeRockwellVersion(void);

void MakeLiteVersion(void);
void MakeNormalVersion(void);
void CheckEventLimits(CTimeShiftManager &time_shift_manager);

void CheckEventTimeLimits(CTimeShiftManager &time_shift_manager);

void LoadEvents(const char *filename,CTimeShiftManager &time_shift_manager);

void SaveEvents(const char *filename,CTimeShiftManager &time_shift_manager);

void LoadPrivateMessages(void);

int	 VerifyKeyString(const char *s);


class MyCommands: public CCommandLineInfo
{
private:
	int mNextis_EventTimeLimit;
	int mNextis_EventCount;

	void	ClearNexts(void)
		{
		mNextis_EventTimeLimit = 0;
		mNextis_EventCount = 0;
		}

public:
	MyCommands(void) 
		{
		ClearNexts();
		}

protected:
	virtual void ParseParam( LPCTSTR lpszParam, BOOL bFlag, BOOL bLast )
		{
		if (CString("nostartupmute") == CString(lpszParam))

			{

			gNoStartupMute = 1;

			ClearNexts();

			}

		if (CString("forcedibs") == CString(lpszParam))

			{

			gForceDIBS = 1;

			ClearNexts();

			}

		if (CString("expire") == CString(lpszParam))
			{
			gExpiration = 1;
			ClearNexts();
			}
		else if (CString("notuner") == CString(lpszParam))
			{
			gsForceNoTuner = 1;
			ClearNexts();
			}
		else if (CString("lite") == CString(lpszParam))
			{
			gDuckVisionLite = 1;
			MakeLiteVersion();
			ClearNexts();
			}	
		else if (CString("logo") == CString(lpszParam))
			{
			gPlaybackLogo = 1;
			ClearNexts();
			}
		else if (CString("timelimit") == CString(lpszParam))
			{
			ClearNexts();
			mNextis_EventTimeLimit = 1;
			}
		else if (CString("eventlimit") == CString(lpszParam))
			{
			ClearNexts();
			mNextis_EventCount = 1;
			}
		else if (mNextis_EventCount || mNextis_EventTimeLimit)
			{
			int d;
			sscanf(lpszParam,"%d",&d);
			if (d > 0)
				{
				if (mNextis_EventCount && ((d < gEventLimit) || (gEventLimit == 0)))
					gEventLimit = d;
				else if (mNextis_EventTimeLimit && ((d < gEventTimeLimit) || (gEventTimeLimit == 0)))
					gEventTimeLimit = d;
				}
			ClearNexts();
			}
		else CCommandLineInfo::ParseParam(lpszParam,bFlag,bLast);
		}
};

#define APPNAME		"DVLaunch"

#define DV_KEY		"DuckVision"

#define DVPATH_KEY	"DuckVisionPath"	

#define DV_LOCATION_SIZE	4096

void	LoadLastKnownDuckvisionLocation(char *location,char *path);

int		VerifyDuckvisionLocation(char *location);

int FindDuckvision(const char *drive,char *duckvisionlocation,char *duckvisionpath);

void CalculateNewDuckvisionLocation(char *duckvisionlocation,char *duckvisionpath);

void SaveDuckvisionLocation(char *location,char *path);



#endif
