/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/* File: Api.h

 * Purpose: Function prototypes

 

 * $Log: api.h,v $
 * Revision 1.1  1999/08/27 02:52:27  nradisch
 * new
 *

 * Revision 2.7  1997/07/31 10:46:38  dtharp

 * Cleaned up multiple CC_CALLBACK definitions.

 * Revision 2.6  1997/05/28 16:57:28  trantq

 * Add Bt848ImageLoad & Bt848UnLoadImage.  Bug ID 431

 * Revision 2.5.1.2  1997/05/28 15:47:50  trantq

 * Add Bt848ImageLoad & Bt848UnLoadImage.  Bug ID 431

 * Revision 2.5.1.1  1997/05/05 17:40:58  trantq

 * Add feature LoadImage of DD Surface.  Bug ID 431

 * Revision 2.5  1997/05/05 17:40:58  dtharp

 * 848A Merge: from 2.4.1.4

 * Revision 2.4.1.4  1997/02/14 23:40:09  rudyl

 * Removed all #ifdef BT848A. Use same binary files for both Bt848 and Bt848A.

 * Revision 2.4.1.3  1997/02/11 23:52:24  rudyl

 * Added PCI check for Bt848A existence.

 * Revision 2.4.1.2  1997/02/03 23:39:11  rudyl

 * First Pisces+ check in.

 * Revision 2.4.1.1  1996/11/08 19:09:59  rudyl

 * Start Pisces+ work.

 * Revision 2.4  1996/10/02 04:26:23  sasha

 * Added CC_CALLBACK typedef and SetCCCallback() API.

 * Revision 2.3  1996/06/26 21:27:09  sasha

 * Added GetOverlayFlags() API

 * Revision 2.2  1996/06/26 19:07:28  sasha

 * Added Pause() and Continue() functions that freeze/unfreeze Pisces

 * Revision 2.1  1996/06/10 20:12:55  ssm

 * MarkBeta1AsRev2

 * Revision 1.10  1996/06/05 19:51:26  sasha

 * Added functions for getting the CC file name and alert token

 * Revision 1.9  1996/06/05 18:20:13  sasha

 * Added CC file name and alert functions

 * Revision 1.8  1996/06/05 00:26:52  ssm

 * added CUT HERE token for awk processing

 

 * Initial revision

 */



/* CUT_HERE */



/* File: Api.h */



#ifndef __API_H

#define __API_H



#ifndef __WINDOWS_H

#include <windows.h>

#endif



#ifndef __RETCODE_H

#include "retcode.h"

#endif



#include "dcdrvals.h"



#ifdef __cplusplus

extern "C" {

#endif



#define LimitRange( Val, Low, Hi ) ( max( Low,( min( Val,Hi ) ) ) )





#ifndef __VIDDEFS_H

#include "viddefs.h"

#endif



#ifndef __COLFRMAT_H

#include "colfrmat.h"

#endif



#include "common.h"



void WINAPI SetCCCallback( CC_CALLBACK );

  

// external video in channel

ErrorCode WINAPI SetConnector( Connector AConn, BOOL ApplyImm );

ErrorCode WINAPI SetSVideo( State aState );

ErrorCode WINAPI SetBrightness( int percentOfFullScale );

ErrorCode WINAPI SetContrast( int percentOfFullScale );

ErrorCode WINAPI SetHue( int degrees );

ErrorCode WINAPI SetSaturation( int percentOfFullScale );

ErrorCode WINAPI SetVideoFormat( VideoFormat aFormat );

ErrorCode WINAPI SetCCStatus( int );

void      WINAPI SetCCFileName( LPCSTR name );

void      WINAPI SetCCAlert( LPCSTR token );

void      WINAPI GetCCFileName( LPSTR name, int cnt );

void      WINAPI GetCCAlert( LPSTR token, int cnt );

DWORD     WINAPI GetStatus();

// video in channel

ErrorCode WINAPI SetImage( LPRECT lpRect, ColFmt aFormat );



// 'get' group

Connector   WINAPI GetConnector( void );

State       WINAPI GetSVideo( void );

VideoFormat WINAPI GetVideoFormat( void );

int         WINAPI GetBrightness( void );

int         WINAPI GetContrast( void );

int         WINAPI GetHue( void );

int         WINAPI GetSaturation( void );

int         WINAPI GetImageFormat( ColFmt *pColFrmt );

void        WINAPI GetImageSize( LPRECT lpR );

int         WINAPI GetCCStatus( void );



void WINAPI _export Pause();

void WINAPI _export Continue();



ErrorCode   WINAPI Initialize( void );

void        WINAPI Disconnect( void );

DWORD       WINAPI GetOverlayFlags( void );



// 'set' group

ErrorCode      WINAPI SetSignalFormat( SignalFormat sFormat );

ErrorCode      WINAPI SetSyncVideoRef( SyncVideoRef syncRef );

ErrorCode      WINAPI SetDecInputClock( DecInputClk iClk );

ErrorCode      WINAPI SetOutputClock( GPCLKOutputClk oClk );

ErrorCode      WINAPI SetEnableSyncOutput( State state );

ErrorCode      WINAPI SetTimGenByte( TimeGenByte tgb );

ErrorCode      WINAPI SetHReset( State state );

ErrorCode      WINAPI SetPLL( PLLFreq pll );

ErrorCode      WINAPI SetVideoInfo( VSIZEPARMS vSize );



// 'get' group

SignalFormat   WINAPI GetSignalFormat( void );

SyncVideoRef   WINAPI GetSyncVideoRef( void );

DecInputClk    WINAPI GetDecInputClock( void );

GPCLKOutputClk WINAPI GetOutputClock( void );

State          WINAPI GetEnableSyncOutput( void );

TimeGenByte    WINAPI GetTimGenByte( void );

State          WINAPI GetHReset( void );

PLLFreq        WINAPI GetPLL( void );

ErrorCode      WINAPI GetVideoInfo( VSIZEPARMS * vsize );



ErrorCode      WINAPI ResetFieldCounter( void );

int            WINAPI GetFieldCounter( void );



int            WINAPI GetHWRevisionID( void );

BOOL           WINAPI IsABt848A( void );



ErrorCode   WINAPI ImageLoad( HINSTANCE hInst, HWND hWnd, LPCSTR szBitmap );

ErrorCode   WINAPI UnLoadImage( void );



#ifdef __cplusplus

}

#endif



#endif

