/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/* File: Cap_api.cpp

 * Purpose: Links to the capture driver for entry points



 * $Log: cap_api.cpp,v $
 * Revision 1.1  1999/08/27 02:52:27  nradisch
 * new
 *

 * Revision 2.9  1997/07/10 17:00:56  trantq

 * - Last check-in got lost or something. 

 * Revision 2.8  1997/07/10 00:25:32  trantq

 * Insert carriage returns at end of file.

 * Revision 2.7  1997/07/09 20:55:42  trantq

 * Need to typedef return code because it was merge in from 

 * Revision 2.4.3.1

 * Revision 2.6  1997/07/09 20:55:42  trantq

 * Merge in Revision 2.4.2.2 to make dialog source compilable using 

 * MSVC compiler.

 * Revision 2.5  1997/05/05 19:45:36  dtharp

 * 848A Merge: from 2.4.1.4

 * Revision 2.4.1.4  1997/02/14 23:40:29  rudyl

 * Removed all #ifdef BT848A. Use same binary files for both Bt848 and Bt848A.

 * Revision 2.4.1.3  1997/02/11 23:52:37  rudyl

 * Added PCI check for Bt848A existence.

 * Revision 2.4.1.2  1997/02/03 23:40:47  rudyl

 * First Pisces+ check in.

 * Revision 2.4.1.1  1996/11/08 18:33:19  rudyl

 * Start Pisces+ work.

 * Revision 2.4.2.2  1996/11/28 00:55:26  trantq

 * Make revision compilable by Borland and Microsoft.

 * Revision 2.4  1996/10/02 04:25:12  sasha

 * Added SetCCCallback() function and all entourage to support it.

 * Revision 2.3  1996/06/26 21:27:24  sasha

 * Added GetOverlayFlags() API

 * Revision 2.2  1996/06/26 19:07:30  sasha

 * Added Pause() and Continue() functions that freeze/unfreeze Pisces

 * Revision 2.1  1996/06/10 20:13:14  ssm

 * MarkBeta1AsRev2

 * Revision 1.12  1996/06/05 19:51:02  sasha

 * Added functions for getting the CC file name and alert token

 * Revision 1.11  1996/06/05 04:07:29  sasha

 * Added APIs for setting CC file name and alert token

 * Revision 1.10  1996/06/05 00:49:11  ssm

 * added CUT HERE token for awk processing

 * Revision 1.8  1996/06/04 02:45:07  ssm

 * add Initial revision line to log section so stripLog.awk will work

 * Revision 1.7  1996/05/30 21:18:03  sasha

 * Added CC functions

 * Revision 1.6  1996/05/17 20:27:15  sasha

 * Killed WEP. Added Initialize() and modified Disconnect().

 * Revision 1.5  1996/05/17 02:17:25  sasha

 * Added export to the functions

 * Revision 1.4  1996/05/02 21:25:19  sasha

 * Added WEP() in which audio is muted. #include audio.h

 * Revision 1.3  1996/01/22 20:36:59  sasha

 * Added SetSVideo call

 * Revision 1.2  1996/01/10 21:28:25  sasha

 * Changed bunch of prototypes

 * Initial revision

 */



// CUT_HERE



#include <windows.h>

                                       

#include "msvccomp.h"                                       

#include "api.h"

#include "ddiflags.h"

#include "audio.h"



/* The following typedefs define a bunch of function pointers. These functions

 * exist in the Bt848 capture driver and are available to anyone.

 */

// external video in channel  'set' group

typedef ErrorCode ( WINAPI *SETCONNECTOR_t )( Connector AConn, BOOL ApplyImm );

typedef ErrorCode ( WINAPI *SETSVIDEO_t )( State aState );



typedef ErrorCode ( WINAPI *SETBRIGHTNESS_t )( int percentOfFullScale );

typedef ErrorCode ( WINAPI *SETCONTRAST_t )( int percentOfFullScale );

typedef ErrorCode ( WINAPI *SETHUE_t )( int degrees );

typedef ErrorCode ( WINAPI *SETSATURATION_t )( int percentOfFullScale );

typedef ErrorCode ( WINAPI *SETVIDEOFORMAT_t)( VideoFormat aFormat );

typedef ErrorCode ( WINAPI *SETCCSTATUS_t)( int );

typedef void      ( WINAPI *SETCCFILENAME_t )( LPCSTR );

typedef void      ( WINAPI *SETCCALERT_t )( LPCSTR );

typedef void      ( WINAPI *SETCCCALLBACK_t )( CC_CALLBACK );



/* Now define actual pointers */

SETCONNECTOR_t    pSETCONNECTOR    = NULL;

SETSVIDEO_t       pSETSVIDEO       = NULL;

SETBRIGHTNESS_t   pSETBRIGHTNESS   = NULL;

SETCONTRAST_t     pSETCONTRAST     = NULL;

SETHUE_t          pSETHUE          = NULL;

SETSATURATION_t   pSETSATURATION   = NULL;

SETVIDEOFORMAT_t  pSETVIDEOFORMAT  = NULL;

SETCCSTATUS_t     pSETCCSTATUS     = NULL;

SETCCFILENAME_t   pSETCCFILENAME   = NULL;

SETCCALERT_t      pSETCCALERT      = NULL;

SETCCCALLBACK_t   pSETCCCALLBACK   = NULL;



// video in channel

typedef ErrorCode ( WINAPI *SETIMAGE_t)( LPRECT lpRect, ColFmt aFormat );

SETIMAGE_t pSETIMAGE = NULL;



// 'get' group

typedef Connector   ( WINAPI *GETCONNECTOR_t )( void );

typedef State       ( WINAPI *GETSVIDEO_t )( void );

typedef VideoFormat ( WINAPI *GETVIDEOFORMAT_t )( void );

typedef int         ( WINAPI *GETBRIGHTNESS_t )( void );

typedef int         ( WINAPI *GETCONTRAST_t )( void );

typedef int         ( WINAPI *GETHUE_t )( void );

typedef int         ( WINAPI *GETSATURATION_t )( void );

typedef int         ( WINAPI *GETIMAGESIZE_t )( LPRECT lpR );

typedef int         ( WINAPI *GETCCSTATUS_t )( void );

typedef void        ( WINAPI *GETCCFILENAME_t )( LPSTR, int );

typedef void        ( WINAPI *GETCCALERT_t )( LPSTR, int );

typedef DWORD       ( WINAPI *GETSTATUS_t )();



typedef void        ( WINAPI *PAUSE_t )();

typedef void        ( WINAPI *CONTINUE_t )();

typedef DWORD       ( WINAPI *GETOVLYFLAGS_t ) ();



GETCONNECTOR_t   pGETCONNECTOR   = NULL;

GETSVIDEO_t      pGETSVIDEO      = NULL;

GETVIDEOFORMAT_t pGETVIDEOFORMAT = NULL;

GETBRIGHTNESS_t  pGETBRIGHTNESS  = NULL;

GETCONTRAST_t    pGETCONTRAST    = NULL;

GETHUE_t         pGETHUE         = NULL;

GETSATURATION_t  pGETSATURATION  = NULL;

GETIMAGESIZE_t   pGETIMAGESIZE   = NULL;

GETCCSTATUS_t    pGETCCSTATUS    = NULL;

GETCCFILENAME_t  pGETCCFILENAME  = NULL;

GETCCALERT_t     pGETCCALERT     = NULL;

GETSTATUS_t      pGETSTATUS      = NULL;



PAUSE_t          pPAUSE          = NULL;

CONTINUE_t       pCONTINUE       = NULL;

GETOVLYFLAGS_t   pGETOVLYFLAGS   = NULL;



typedef int (WINAPI *GETIMAGEFORMAT_t)( ColFmt *pColFrmt );

GETIMAGEFORMAT_t pGETIMAGEFORMAT = NULL;



typedef ErrorCode ( WINAPI *SETSIGNALFORMAT_t)( SignalFormat sFormat );

typedef ErrorCode ( WINAPI *SETSYNCVIDEOREF_t)( SyncVideoRef syncRef );

typedef ErrorCode ( WINAPI *SETDECINPUTCLOCK_t)( DecInputClk iClk );

typedef ErrorCode ( WINAPI *SETENABLESYNCOUTPUT_t)( State state );

typedef ErrorCode ( WINAPI *SETTIMGENBYTE_t)( TimeGenByte tgb );

typedef ErrorCode ( WINAPI *SETHRESET_t)( State state );

typedef ErrorCode ( WINAPI *SETPLL_t)( PLLFreq pll );

typedef ErrorCode ( WINAPI *SETVIDEOINFO_t)( VSIZEPARMS vsize );



typedef SignalFormat ( WINAPI *GETSIGNALFORMAT_t )( void );

typedef SyncVideoRef ( WINAPI *GETSYNCVIDEOREF_t)( void );

typedef DecInputClk  ( WINAPI *GETDECINPUTCLOCK_t)( void );

typedef State        ( WINAPI *GETENABLESYNCOUTPUT_t)( void );

typedef TimeGenByte  ( WINAPI *GETTIMGENBYTE_t)( void );

typedef State        ( WINAPI *GETHRESET_t)( void );

typedef PLLFreq      ( WINAPI *GETPLL_t)( void );

typedef ErrorCode    ( WINAPI *GETVIDEOINFO_t)( VSIZEPARMS * vsize );



typedef ErrorCode ( WINAPI *RESETFIELDCOUNTER_t)( void );

typedef int       ( WINAPI *GETFIELDCOUNTER_t)( void );

typedef int       ( WINAPI *GETHWREVISIONID_t)( void );

typedef BOOL      ( WINAPI *ISABT848A_t)( void );



SETSIGNALFORMAT_t     pSETSIGNALFORMAT     = NULL;

SETSYNCVIDEOREF_t     pSETSYNCVIDEOREF     = NULL;

SETDECINPUTCLOCK_t    pSETDECINPUTCLOCK    = NULL;

SETENABLESYNCOUTPUT_t pSETENABLESYNCOUTPUT = NULL;

SETTIMGENBYTE_t       pSETTIMGENBYTE       = NULL;

SETHRESET_t           pSETHRESET           = NULL;

SETPLL_t              pSETPLL              = NULL;

SETVIDEOINFO_t        pSETVIDEOINFO        = NULL;



GETSIGNALFORMAT_t     pGETSIGNALFORMAT     = NULL;

GETSYNCVIDEOREF_t     pGETSYNCVIDEOREF     = NULL;

GETDECINPUTCLOCK_t    pGETDECINPUTCLOCK    = NULL;

GETENABLESYNCOUTPUT_t pGETENABLESYNCOUTPUT = NULL;

GETTIMGENBYTE_t       pGETTIMGENBYTE       = NULL;

GETHRESET_t           pGETHRESET           = NULL;

GETPLL_t              pGETPLL              = NULL;

GETVIDEOINFO_t        pGETVIDEOINFO        = NULL;



RESETFIELDCOUNTER_t   pRESETFIELDCOUNTER   = NULL;

GETFIELDCOUNTER_t     pGETFIELDCOUNTER     = NULL;

GETHWREVISIONID_t     pGETHWREVISIONID     = NULL;

ISABT848A_t           pISABT848A           = NULL;



// this is needed to load dialog resources

static HINSTANCE ghModule;

HINSTANCE WINAPI GetOurInstance( void )

{ return ghModule; }



// these guys are used to select an appropriate audio input

#ifndef __BORLANDC__   // Make Microsoft compiler happy

extern ErrorCode SetAudioSource( DWORD );

#else				   // Make Borland compiler happy

extern SetAudioSource( DWORD );

#endif



extern SetAudioMute( DWORD );



#pragma argsused

#ifdef __cplusplus

extern "C"

{

#endif

int FAR PASCAL LibMain( HINSTANCE hInst, WORD w1, WORD w2, LPSTR str )

{

   ghModule = hInst;

   return 1;

}



/* API: Connect

 * Purpose: This function is called by the Bt848 video capture driver after it

 *   loads a DLL named Bt848dlg.dll to give a dialogs DLL a chance to initialize

 *   itself by obtaining all the exported entry points from the capture driver

 * Note: WINAPI calling convention is assumed by the bt848.drv

 *   Any DLL-specific activity can happen here ( except calling the exported functions

 *   as the capture driver is not fully initialized itself yet ).

 */

BOOL WINAPI _export Connect( HINSTANCE hDriver )

{

   // go and get all the exported functions

   pSETIMAGE       = (SETIMAGE_t)      GetProcAddress( hDriver, "SetImage" );

   pGETIMAGEFORMAT = (GETIMAGEFORMAT_t)GetProcAddress( hDriver, "GetImageFormat" );

   pSETCONNECTOR   = (SETCONNECTOR_t)  GetProcAddress( hDriver, "SetConnector" );

   pSETBRIGHTNESS  = (SETBRIGHTNESS_t) GetProcAddress( hDriver, "SetBrightness" );



   pSETSVIDEO      = (SETSVIDEO_t)     GetProcAddress( hDriver, "SetSVideo" );



   pSETCONTRAST    = (SETCONTRAST_t)   GetProcAddress( hDriver, "SetContrast" );

   pSETHUE         = (SETHUE_t)        GetProcAddress( hDriver, "SetHue" );

   pSETSATURATION  = (SETSATURATION_t) GetProcAddress( hDriver, "SetSaturation" );

   pSETVIDEOFORMAT = (SETVIDEOFORMAT_t)GetProcAddress( hDriver, "SetVideoFormat" );

   pSETCCSTATUS    = (SETCCSTATUS_t)   GetProcAddress( hDriver, "SetCCStatus" );

   pSETCCFILENAME  = (SETCCFILENAME_t) GetProcAddress( hDriver, "SetCCFileName" );

   pSETCCALERT     = (SETCCALERT_t)    GetProcAddress( hDriver, "SetCCAlert" );

   pSETCCCALLBACK  = (SETCCCALLBACK_t) GetProcAddress( hDriver, "SetCCCallback" );



   pGETCONNECTOR   = (GETCONNECTOR_t)  GetProcAddress( hDriver, "GetConnector" );

   pGETSVIDEO      = (GETSVIDEO_t)     GetProcAddress( hDriver, "GetSVideo" );

   pGETVIDEOFORMAT = (GETVIDEOFORMAT_t)GetProcAddress( hDriver, "GetVIdeoFormat" );

   pGETBRIGHTNESS  = (GETBRIGHTNESS_t) GetProcAddress( hDriver, "GetBrightness" );

   pGETCONTRAST    = (GETCONTRAST_t)   GetProcAddress( hDriver, "GetContrast" );

   pGETHUE         = (GETHUE_t)        GetProcAddress( hDriver, "GetHue" );

   pGETSATURATION  = (GETSATURATION_t) GetProcAddress( hDriver, "GetSaturation" );

   pGETIMAGESIZE   = (GETIMAGESIZE_t)  GetProcAddress( hDriver, "GetImageSize" );

   pGETCCSTATUS    = (GETCCSTATUS_t)   GetProcAddress( hDriver, "GetCCStatus" );

   pGETCCFILENAME  = (GETCCFILENAME_t) GetProcAddress( hDriver, "GetCCFileName" );

   pGETCCALERT     = (GETCCALERT_t)    GetProcAddress( hDriver, "GetCCAlert" );

   pGETSTATUS      = (GETSTATUS_t)     GetProcAddress( hDriver, "GetStatus" );

   pPAUSE          = (PAUSE_t)         GetProcAddress( hDriver, "Pause" );

   pCONTINUE       = (CONTINUE_t)      GetProcAddress( hDriver, "Continue" );



   pGETOVLYFLAGS   = (GETOVLYFLAGS_t)  GetProcAddress( hDriver, "GetOverlayFlags" );



   pSETSIGNALFORMAT     = (SETSIGNALFORMAT_t)     GetProcAddress( hDriver, "SetSignalFormat" );

   pSETSYNCVIDEOREF     = (SETSYNCVIDEOREF_t)     GetProcAddress( hDriver, "SetSyncVideoRef" );

   pSETDECINPUTCLOCK    = (SETDECINPUTCLOCK_t)    GetProcAddress( hDriver, "SetDecInputClock" );

   pSETENABLESYNCOUTPUT = (SETENABLESYNCOUTPUT_t) GetProcAddress( hDriver, "SetEnableSyncOutput" );

   pSETTIMGENBYTE       = (SETTIMGENBYTE_t)       GetProcAddress( hDriver, "SetTimGenByte" );

   pSETHRESET           = (SETHRESET_t)           GetProcAddress( hDriver, "SetHReset" );

   pSETPLL              = (SETPLL_t)              GetProcAddress( hDriver, "SetPLL" );

   pSETVIDEOINFO        = (SETVIDEOINFO_t)        GetProcAddress( hDriver, "SetVideoInfo" );



   pGETSIGNALFORMAT     = (GETSIGNALFORMAT_t)     GetProcAddress( hDriver, "GetSignalFormat" );

   pGETSYNCVIDEOREF     = (GETSYNCVIDEOREF_t)     GetProcAddress( hDriver, "GetSyncVideoRef" );

   pGETDECINPUTCLOCK    = (GETDECINPUTCLOCK_t)    GetProcAddress( hDriver, "GetDecInputClock" );

   pGETENABLESYNCOUTPUT = (GETENABLESYNCOUTPUT_t) GetProcAddress( hDriver, "GetEnableSyncOutput" );

   pGETTIMGENBYTE       = (GETTIMGENBYTE_t)       GetProcAddress( hDriver, "GetTimGenByte" );

   pGETHRESET           = (GETHRESET_t)           GetProcAddress( hDriver, "GetHReset" );

   pGETPLL              = (GETPLL_t)              GetProcAddress( hDriver, "GetPLL" );

   pGETVIDEOINFO        = (GETVIDEOINFO_t)        GetProcAddress( hDriver, "GetVideoInfo" );



   pRESETFIELDCOUNTER   = (RESETFIELDCOUNTER_t)   GetProcAddress( hDriver, "ResetFieldCounter" );

   pGETFIELDCOUNTER     = (GETFIELDCOUNTER_t)     GetProcAddress( hDriver, "GetFieldCounter" );

   pGETHWREVISIONID     = (GETHWREVISIONID_t)     GetProcAddress( hDriver, "GetHWRevisionID" );

   pISABT848A           = (ISABT848A_t)            GetProcAddress( hDriver, "IsABt848A" );

   return TRUE;

}



/* API: Disconnect

 * Purpose: This function is called by the Bt848 capture driver to let a dialogs

 *   DLL know that a session is over

 */

void WINAPI _export Disconnect()

{

   // mute audio when terminates

   SetAudioSource( AUDIO_SOURCE_MUTE );

}



/* API: Initialize

 * Purpose: This function is called by the Bt848 capture driver when it is fully

 *   initialized. It is a good place to turn audio on, etc.

 */

ErrorCode WINAPI _export Initialize()

{

   // ask th capture driver about current video connector...

   Connector CurCon = GetConnector();

   // ... and set audio mux appropriately

   switch ( CurCon ) {

   case ConTuner:

      SetAudioSource( AUDIO_SOURCE_TVTUNER );

      break;

   case ConComposite:

   default:

      SetAudioSource( AUDIO_SOURCE_EXTAUDIO );

      break;

   }

   GetStatus();

   return Success;

}



/* The following functions are exported by the dialogs DLL so an application

 * can make use of the functionality as well ( without popping dialogs )

 */



// sets image dimentions and color format

ErrorCode WINAPI _export SetImage( LPRECT lpRect, ColFmt aFormat )

{

   return pSETIMAGE ? pSETIMAGE( lpRect, aFormat ) : Fail;

}



// gets image dimentions and color format

int WINAPI _export GetImageFormat( ColFmt *pColFrmt )

{

   return pGETIMAGEFORMAT ? pGETIMAGEFORMAT( pColFrmt ) : 0;

}



/* API:

 * Purpose: selects a video connector.

 * Input: AConn: Connector, video connector to use

 *   ApplyImm: BOOL, indicates if needs to be applied immediately

 */

ErrorCode WINAPI _export SetConnector( Connector AConn, BOOL ApplyImm )

{

   return  pSETCONNECTOR ? pSETCONNECTOR( AConn, ApplyImm ) : Fail;

}



ErrorCode WINAPI _export SetSVideo( State aState )

{

   return pSETSVIDEO ? pSETSVIDEO( aState ) : Fail;

}



// sets contrast

ErrorCode WINAPI _export SetContrast( int value )

{

   return pSETCONTRAST ? pSETCONTRAST( value ) : (ErrorCode)1;

}



// sets brigtness

ErrorCode WINAPI _export SetBrightness( int value )

{

   return pSETBRIGHTNESS ? pSETBRIGHTNESS( value ) : Fail;

}



// sets hue

ErrorCode WINAPI _export SetHue( int value )

{

   return pSETHUE ? pSETHUE( value ) : (ErrorCode)1;

}



// sets saturation

ErrorCode WINAPI _export SetSaturation( int value )

{

   return pSETSATURATION ? pSETSATURATION( value ) : (ErrorCode)1;

}



// selects NTSC/PAL/SECAM

ErrorCode WINAPI _export SetVideoFormat( VideoFormat aFormat )

{

   return pSETVIDEOFORMAT ? pSETVIDEOFORMAT( aFormat ) : (ErrorCode)1;

}



// sets closed captioning parameters

ErrorCode WINAPI _export SetCCStatus( int st )

{

   return pSETCCSTATUS ? pSETCCSTATUS( st ) : Fail;

}



// sets the name of a file with decoded closed caption data

void WINAPI _export SetCCFileName( LPCSTR name )

{

   if ( pSETCCFILENAME ) pSETCCFILENAME( name );

}



// sets the alert token wich will trigger a message box

void WINAPI _export SetCCAlert( LPCSTR token )

{

   if ( pSETCCALERT ) pSETCCALERT( token );

}



// gets current video connector

Connector WINAPI _export GetConnector( void )

{

   return  pGETCONNECTOR ? pGETCONNECTOR() : (Connector)-1;

}



// gets state of SVideo bit

State WINAPI _export GetSVideo( void )

{

   return  pGETSVIDEO ? pGETSVIDEO() : Off;

}



// gets current video signal format ( NTSC/PAL/SECAM )

VideoFormat WINAPI _export GetVideoFormat( void )

{

   return  pGETVIDEOFORMAT ? pGETVIDEOFORMAT() : (VideoFormat)-1;

}



// obtains current brigtness settings

int WINAPI _export GetBrightness( void )

{

   return  pGETBRIGHTNESS ? pGETBRIGHTNESS() : -1;

}



// obtains current contrast

int WINAPI _export GetContrast( void )

{

   return  pGETCONTRAST ? pGETCONTRAST() : -1;

}



// obtains current hue value

int WINAPI _export GetHue( void )

{

   return  pGETHUE ? pGETHUE() : -1;

}



// obtains current saturation value

int WINAPI _export GetSaturation( void )

{

   return  pGETSATURATION ? pGETSATURATION() : -1;

}



// obtains current closed captioning status

int WINAPI _export GetCCStatus( void )

{

   return pGETCCSTATUS ? pGETCCSTATUS() : 0;

}



// obtains current image size

void WINAPI _export GetImageSize( LPRECT lpR )

{

   if ( pGETIMAGESIZE ) pGETIMAGESIZE( lpR );

}



// gets the name of a file with decoded closed caption data. cnt is the max # of bytes to get

void WINAPI _export GetCCFileName( LPSTR name, int cnt )

{

   if ( pGETCCFILENAME ) pGETCCFILENAME( name, cnt );

}



// gets the alert token wich will trigger a message box. cnt is the max # of bytes to get

void WINAPI _export GetCCAlert( LPSTR token, int cnt )

{

   if ( pGETCCALERT ) pGETCCALERT( token, cnt );

}



DWORD WINAPI _export GetStatus( void )

{

   return pGETSTATUS ? pGETSTATUS() : 0;

}



void WINAPI _export Pause( void )

{

   if ( pPAUSE )

      pPAUSE();

}



void WINAPI _export Continue( void )

{

   if ( pCONTINUE )

      pCONTINUE();

}



DWORD WINAPI _export GetOverlayFlags( void )

{

   return pGETOVLYFLAGS ? pGETOVLYFLAGS() : 0;

}



void WINAPI _export SetCCCallback( CC_CALLBACK cb )

{

   if ( pSETCCCALLBACK )

      pSETCCCALLBACK( cb );

}



/////////////////////////////////////////////////////////////////////////////

// 'set' group

/////////////////////////////////////////////////////////////////////////////



// selects Analog, CCIR656, ByteStream, External HSYNC,VSYNC & External HSYNC,FIELD

ErrorCode WINAPI _export SetSignalFormat( SignalFormat sFormat )

{

   return pSETSIGNALFORMAT ? pSETSIGNALFORMAT( sFormat ) : Fail;

}



// selects HS/VS aligned with Cb, Y0, Cr, or Y1

ErrorCode WINAPI _export SetSyncVideoRef( SyncVideoRef syncRef )

{

   return pSETSYNCVIDEOREF ? pSETSYNCVIDEOREF( syncRef ) : Fail;

}



// selects decoder input clock: DecClk_XTAL, DecClk_PLL, DecClk_GPCLK, DecClk_invGPCLK

ErrorCode WINAPI _export SetDecInputClock( DecInputClk iClk )

{

   return pSETDECINPUTCLOCK ? pSETDECINPUTCLOCK( iClk ) : Fail;

}



// Enable/Disable sync output for sync video input

ErrorCode WINAPI _export SetEnableSyncOutput( State state )

{

   return pSETENABLESYNCOUTPUT ? pSETENABLESYNCOUTPUT( state ) : Fail;

}



// set timing generator load byte

ErrorCode WINAPI _export SetTimGenByte( TimeGenByte tgb )

{

   return pSETTIMGENBYTE ? pSETTIMGENBYTE( tgb ) : Fail;

}



// enable/disable HRESET to be shortened from 64 to 32 pixels

ErrorCode WINAPI _export SetHReset( State state )

{

   return pSETHRESET ? pSETHRESET( state ) : Fail;

}



// set PLL to desired synthesized frequency

ErrorCode WINAPI _export SetPLL( PLLFreq pll )

{

   return pSETPLL ? pSETPLL( pll ) : Fail;

}



// set video parameters for scaling purpose

ErrorCode WINAPI _export SetVideoInfo( VSIZEPARMS vsize )

{

   return pSETVIDEOINFO ? pSETVIDEOINFO( vsize ) : Fail;

}



/////////////////////////////////////////////////////////////////////////////

// 'get' group

/////////////////////////////////////////////////////////////////////////////



// gets current video signal format ( Analog, CCIR656, ByteStream, External HSYNC,VSYNC & External HSYNC,FIELD )

SignalFormat WINAPI _export GetSignalFormat( void )

{

   return pGETSIGNALFORMAT ? pGETSIGNALFORMAT() : (SignalFormat)-1;

}



// gets HS/VS is aligned with either Cb, Y0, Cr, or Y1

SyncVideoRef WINAPI _export GetSyncVideoRef( void )

{

   return pGETSYNCVIDEOREF ? pGETSYNCVIDEOREF() : (SyncVideoRef)-1;

}



// gets decoder input clock: DecClk_XTAL, DecClk_PLL, DecClk_GPCLK, DecClk_invGPCLK

DecInputClk WINAPI _export GetDecInputClock( void )

{

   return pGETDECINPUTCLOCK ? pGETDECINPUTCLOCK() : (DecInputClk)-1;

}



// checks if sync output for sync video input is enabled or disabled

State WINAPI _export GetEnableSyncOutput( void )

{

   return pGETENABLESYNCOUTPUT ? pGETENABLESYNCOUTPUT() : (State)-1;

}



// gets timing generator load byte

TimeGenByte WINAPI _export GetTimGenByte( void )

{

   return ( pGETTIMGENBYTE ) ? pGETTIMGENBYTE() : (TimeGenByte)-1;

}



// checks if HRESET is shortened from 64 to 32 pixels

State WINAPI _export GetHReset( void )

{

   return pGETHRESET ? pGETHRESET() : (State)-1;

}



// obtains the settings of PLL registers

PLLFreq WINAPI _export GetPLL( void )

{

   return pGETPLL ? pGETPLL() : (PLLFreq)-1;

}



// obtains video parameters for scaling purpose

ErrorCode WINAPI _export GetVideoInfo( VSIZEPARMS * vsize )

{

   return pGETVIDEOINFO ? pGETVIDEOINFO( vsize ) : Fail;

}



/////////////////////////////////////////////////////////////////////////////

// Field Counter

/////////////////////////////////////////////////////////////////////////////



// reset field counter

ErrorCode WINAPI _export ResetFieldCounter( void )

{

   return pRESETFIELDCOUNTER ? pRESETFIELDCOUNTER() : Fail;

}



// obtain field counter

int WINAPI _export GetFieldCounter( void )

{

   return pGETFIELDCOUNTER ? pGETFIELDCOUNTER() : -1;

}



/////////////////////////////////////////////////////////////////////////////

// Hardware Revision ID

/////////////////////////////////////////////////////////////////////////////



int WINAPI _export GetHWRevisionID( void )

{

   return pGETHWREVISIONID ? pGETHWREVISIONID() : -1;

}



BOOL WINAPI _export IsABt848A( void )

{

   return pISABT848A ? pISABT848A() : -1;

}



#ifdef __cplusplus

}

#endif









