/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/* File: ColFrmat.h

 * Purpose: Defines all color formats Piesces supports

 * Author: sasha

 * $Log: colfrmat.h,v $
 * Revision 1.1  1999/08/27 02:52:28  nradisch
 * new
 *

 * Revision 2.1  1996/06/10 20:13:27  ssm

 * MarkBeta1AsRev2

 * Revision 1.10  1996/03/18 22:56:24  sasha

 * Added CF_UYVY color format

 * Revision 1.9  1996/02/19 01:20:38  sasha

 * Moved CF_VBI in front of CF_RAW

 * Revision 1.8  1996/02/16 20:07:54  sasha

 * Added CF_VBI

 * Revision 1.7  1996/02/08 23:43:39  sasha

 * Changed CF_RAW value

 * Revision 1.6  1996/01/29 02:35:36  sasha

 * Fixed ColFmt enum to start at -1

 * Revision 1.5  1996/01/06 02:06:34  sasha

 * Changed ColorFormat to ColFmt

 * Revision 1.4  1995/12/08 22:28:04  sasha

 * Added CF_RAW

 * Revision 1.3  1995/09/07 15:59:26  sasha

 * First major check-in for testing

 * Revision 1.2  1995/09/07 07:59:26  sasha

 * Just to make Mike happy

 * Revision 1.1  1995/09/07 00:59:26  sasha

 * Initial revision

 */



/* CUT_HERE */



/* File: ColFrmat.h */



#ifndef __COLFRMAT_H

#define __COLFRMAT_H





/* Type: ColorFormat

 * Purpose: Enumerates all possible color formats that BtPisces can produce

 */

typedef enum

{

   CF_BelowRange = -1, CF_RGB32, CF_RGB24, CF_RGB16, CF_RGB15, CF_YUY2,

   CF_BTYUV, CF_Y8, CF_RGB8, CF_PL_422, CF_PL_411, CF_YUV9, CF_YUV12, CF_VBI,

   CF_UYVY, CF_RAW = 0x0E, CF_I420, CF_AboveRange

} ColFmt;





#endif // __COLFRMAT_H

