/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/* $Header: /export/raid/cvs_videodev/TrueCap/VideoTuners/Bt848V2_2/Source/Dialogs/dcdrvals.h,v 1.1 1999/08/27 02:52:29 nradisch Exp $

 * File: Dcdrvals.h

 * Purpose: Defines values for the decoder

 * Author: sasha

 * $Log: dcdrvals.h,v $
 * Revision 1.1  1999/08/27 02:52:29  nradisch
 * new
 *

 * Revision 2.4  1997/04/28 22:59:05  dtharp

 * Grafted Bt8448A branch from 2.3.2.3

 * Revision 2.3.2.3  1997/02/14 23:49:38  rudyl

 * Removed all #ifdef BT848A. Use same binary files for both Bt848 and Bt848A.

 * Revision 2.3.2.2  1997/02/03 23:46:48  rudyl

 * First Pisces+ check in.

 * Revision 2.3  1996/08/16 17:13:14  rudyl

 * Updated corresponding C defines also.

 * Revision 2.2  1996/08/08 01:11:22  rudyl

 * changed max contrast to get 1ff and default SECAM value to 0x87

 * Revision 2.1  1996/06/10 20:13:37  ssm

 * MarkBeta1AsRev2

 * Revision 1.5  1996/04/16 22:05:18  rudyl

 * Added mapping function parameter's const.

 * Revision 1.4  1996/04/15 22:07:21  rudyl

 * Parameter range shouldn't be defined here. Removed them.

 * Revision 1.3  1996/04/15 19:57:03  rudyl

 * Added parameter range (0-255, def 128) for checking and calculation of Brightness, Contrast, Hue and Saturation.

 * Revision 1.2  1996/02/27 02:31:52  sasha

 * Revision 1.1  1996/01/10 21:19:38  sasha

 * Initial revision

*/



/* CUT_HERE */



/* File: Dcdrvals.h */



#ifndef __DCDRVALS_H

#define __DCDRVALS_H



#ifdef __cplusplus



const int HueMin = -90;

const int HueMax = 90;

const int HueDef = 0;



const int SatMinNTSC = 0;

const int SatMaxNTSC = 0x1FF;

const int SatDefNTSC = 0xFE;



const int SatMinSECAM = 0;

const int SatMaxSECAM = 0x1FF;

const int SatDefSECAM = 0x87;



const int ConMin = 0;

const int ConMax = 236;

const int ConDef = 100;



const int BrtMin = -50;

const int BrtMax = 50;

const int BrtDef = 0;



// More constants for digital camera video format

const int ConMinDig = 0;

const int ConMaxDig = 399;

const int ConDefDig = 100;



const int SatMinDig = 0;

const int SatMaxDig = 0x1FF;

const int SatDefDig = 0x80;



const int ParamMin = 0;

const int ParamMax = 255;

const int ParamDef = 128;



#else

#define HueMin -90

#define HueMax 90

#define HueDef 0



#define SatMinNTSC 0

#define SatMaxNTSC 0x1FF

#define SatDefNTSC 0xFE



#define SatMinSECAM 0

#define SatMaxSECAM 0x1FF

#define SatDefSECAM 0x87



#define ConMin 0

#define ConMax 236

#define ConDef 100



#define BrtMin -50

#define BrtMax 50

#define BrtDef 0



// More constants for digital camera video format

#define ConMinDig 0

#define ConMaxDig 399

#define ConDefDig 100



#define SatMinDig 0

#define SatMaxDig 0x1FF

#define SatDefDig 0x80



#define ParamMin 0

#define ParamMax 255

#define ParamDef 128



#endif



#endif

