/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/* File: Dialogs.cpp

 * Purpose: Configuration dialogs

 *

 * $Log: dialogs.cpp,v $
 * Revision 1.1  1999/08/27 02:52:29  nradisch
 * new
 *

 * Revision 2.8  1997/07/10 00:15:46  trantq

 * - Add typecast DLGPROC to last parameters to DialogBox().

 * Revision 2.7  1997/07/09 17:49:40  trantq

 * Merge in Revision 2.3.2.3, the branch was never checked into the

 * tip.

 * Revision 2.6  1997/05/06 00:20:52  dtharp

 * 848A Merge: from 2.3.1.10

 * Revision 2.5  1997/03/18 20:01:52  rudyl

 * Graft from 2.4.1.2. Changes sizes since PAL/SECAM use 288 lines per field.

 * Revision 2.4.1.2  1997/03/08 02:47:53  rudyl

 * Now PAL uses 288 lines per field.

 * Revision 2.4.1.1  1997/03/06 20:09:37  rudyl

 * Use 288 lines for PAL/SECAM

 * Revision 2.4  1996/11/08 18:47:16  rudyl

 * Graft from 2.3.1.2: Added NTSC-Japan, PAL-M & PAL-N formats.

 * Revision 2.3.1.2  1996/11/08 18:47:15  rudyl

 * Added NTSC-Japan, PAL-M & PAL-N formats.

 * Revision 2.3.1.1  1996/11/07 22:20:32  rudyl

 * Start work to add NTSC-Japan, PAL-M & PAL-N formats.

 * Revision 2.3.2.3  1996/11/28 01:47:19  trantq

 * Elimination #ifdef by type-casting (DLGPROC) for DialogBox call.

 * Revision 2.3.2.2  1996/11/28 00:59:13  trantq

 * -Make change in WinHelp Call to bring up help file's HELP_CONTENTS,0 instead of bringing up context sensitive help.

 * -Make revision compilable by Borland and Microsoft.

 * Revision 2.3.2.1  1996/11/26 21:22:07  trantq

 * Make dialogs compilable by Borland and Miscrosoft

 * Revision 2.3  1996/09/17 08:10:36  sasha

 * Added support for the raw mode. More bells and wistles could be added

 * for that ( dealing with size buttons ).

 * Revision 2.2  1996/09/06 21:38:22  rudyl

 * Allow all Image Format (in particular YUV9 & YUV12) to go full screen.

 * Revision 2.1  1996/06/10 20:13:16  ssm

 * MarkBeta1AsRev2

 * Revision 1.23  1996/06/05 04:09:36  sasha

 * A bogus check-in to fix that non-updated member crap

 * Revision 1.21.1.1  1996/06/05 04:08:03  sasha

 * Added 2 edit boxes to handle CC file name and alert token

 * Revision 1.21  1996/06/04 02:45:11  ssm

 * add Initial revision line to log section so stripLog.awk will work

 * Revision 1.20  1996/05/30 21:18:33  sasha

 * Put video display dialog here. It controls CC parameters right now.

 * Revision 1.19  1996/05/21 18:50:21  rudyl

 * Uses PAL_BDGHI for default PAL format.

 * Per Ben's suggestion, since we don't have that many lines available to display,

 * changed sizes for PAL/SECAM from 288 to 284 for 1/2, and similarly for 1/4 and full size.

 * Revision 1.18  1996/05/17 00:18:27  sasha

 * Added WINAPI to the dialog functions

 * Revision 1.17  1996/05/02 21:26:49  sasha

 * Added PAL/SECAM sizes and supporting code. Added audio functions

 * which are called when connector changes

 * Revision 1.16  1996/04/24 20:29:44  sasha

 * Fixed image size when 1/4 button pressed

 * Revision 1.15  1996/04/17 22:17:08  sasha

 * Changed scroll bars range.

 * Revision 1.14  1996/04/17 19:23:36  sasha

 * Removed commented code. Changed code to reflect new contents of the

 * video formats and sizes arrays.

 * Revision 1.13  1996/04/09 19:28:40  sasha

 * Added support for disabling hue for PAL and SECAM

 * Revision 1.12  1996/04/01 21:06:20  sasha

 * Use new connector names again

 * Revision 1.11  1996/03/30 01:24:20  sasha

 * Commented out extra color formats and sizes in the video format dialog

 * Revision 1.10  1996/03/29 18:18:06  sasha

 * Changed video format names ( as per viddefs.h )

 * Revision 1.9  1996/03/15 23:20:44  sasha

 * Updated connector values relation to radio button IDs

 * Revision 1.8  1996/03/15 21:02:04  sasha

 * Added handling of video connector radio buttons and changed associations

 * between connector values and radio battons

 * Revision 1.7  1996/02/18 06:15:31  sasha

 * Added validation for the 'full' button as well

 * Revision 1.6  1996/02/18 05:22:01  sasha

 * Added validation for the image size/color format to the video format dialog

 * Revision 1.5  1996/02/14 22:17:26  sasha

 * Added IDCANCEL and IDOK to the big config dialog

 * Revision 1.4  1996/01/22 20:36:29  sasha

 * Revision 1.3  1996/01/10 21:44:51  sasha

 * Revision 1.2  1996/01/10 21:28:51  sasha

 * Functional dialogs



 * Initial revision

 */

// CUT_HERE



//===========================================================================

// Search for <UPDATE REQUIRED> in order to add/modify support of additional

// cameras.

//===========================================================================



#include <stdlib.h>

#include "msvccomp.h"

#include "api.h"       

#include "config.h"

#include "exviddlg.h"

#include "dialogs.h"



#include "bt848api.h"

#include "audio.h"



#include "regutil.h"



extern HINSTANCE WINAPI GetOurInstance( void );



static int SizeOption;

static int VidSourceUp;



typedef struct tag_combobox_entry

{

   WORD wValue;

   char *szText;

} COMBOBOX_ENTRY;





//

// Loads entries into a combobox, and selects the current index

// Parmameters:

//      hWnd of the parent dialog box

//      ID of the combobox

//      array of text and values

//      Count of entries in the COMBOBOX_ENTRY array

//      Initial value which should match the wValue field of the

//              COMBOBOX_ENTRY.  If no values match, the selection

//              defaults to the first entry in the combobox.

// Returns:

//      Returns the index of the selected item in the combobox.

//



static int WINAPI ConfigLoadComboBox( HWND hDlg, int wID, COMBOBOX_ENTRY *pCBE,

   int nEntries, WORD wInitialValue )

{

   int	j;

   int	nIndex = 0;	// Zero entry should be blank, None, etc.

   HWND hWndCB = GetDlgItem( hDlg, wID );



   // make sure no old strings are present

   int items = (int)SendMessage( hWndCB, CB_GETCOUNT, 0, 0 );

   for ( ; items >= 0; )

      SendMessage( hWndCB, CB_DELETESTRING, --items, 0 );



  // add new strings

   for ( j = 0; j < nEntries; j++ ) {

      SendMessage( hWndCB, CB_ADDSTRING, 0, (LONG)(LPSTR)((pCBE+j)->szText ) );

      if ( pCBE [j].wValue == wInitialValue )

         nIndex = j;

      }

   SendMessage( hWndCB, CB_SETCURSEL, nIndex, 0L );

   return nIndex;

}



const int CameraSizeBase = 4;  // where do the camera sizes start?



static COMBOBOX_ENTRY gwSizeOptions[] [3] =

{

   {  // NTSC compatible

      { 0, "160 x 120" },

      { 1, "320 x 240" },

      { 2, "640 x 480" }

   },

   {  // PAL compatible

      { 0, "192 x 144" },

      { 1, "384 x 288" },

      { 2, "768 x 576" }

   },

   {  // Raw

      { 0, "1024 x 434" },

      { 1, "1024 x 868" },

      { 2, "1024 x 868" }

   },

   {  // PAL-NC

      { 0, "160 x 144" },

      { 1, "320 x 288" },

      { 2, "640 x 576" }

   },

// <UPDATE REQUIRED>

// Following is the available video sizes for each camera

   {  // digital camera: SVI

      { 0, "160 x 120" },

      { 1, "240 x 180" },

      { 2, "320 x 240" }

   },

   {  // digital camera: Logitech VideoMan 1.3

      { 0, "160 x 120" },

      { 1, "320 x 240" },

      { 2, "640 x 480" }

   },

};

#define N_SIZEOPTIONS (sizeof (gwSizeOptions [0] ) / sizeof (COMBOBOX_ENTRY))



static COMBOBOX_ENTRY gwFormatOptions[] =

{

   { CF_RGB32, "32 bit RGBA" },

   { CF_RGB24, "24 bit RGB"  },

   { CF_RGB15, "15 bit RGB"  },

   { CF_YUY2,  "YUY2"        },

   { CF_BTYUV, "BTYUV"       },

   { CF_YUV9,  "YUV9"        },

   { CF_I420,  "YUV12"       },

   { CF_RAW,   "Raw ADC data"}

};



#define N_FORMATOPTIONS (sizeof (gwFormatOptions) / sizeof (COMBOBOX_ENTRY))



RECT RectArr [] [3] =

{

   {  // NTSC compatible

      { 0, 0, 160, 120 },

      { 0, 0, 320, 240 },

      { 0, 0, 640, 480 }

   },

   {  // PAL compatible

      { 0, 0, 192, 144 },

      { 0, 0, 384, 288 },

      { 0, 0, 768, 576 }

   },

   {  // Raw

      { 0, 0, 1024, 434 },

      { 0, 0, 1024, 868 },

      { 0, 0, 1024, 868 }

   },

   {  // PAL-NC

      { 0, 0, 160, 144 },

      { 0, 0, 320, 288 },

      { 0, 0, 640, 576 }

   },

// <UPDATE REQUIRED>

// Following is the available video sizes for each camera

   {  // digital camera: SVI

      { 0, 0, 160, 120 },

      { 0, 0, 240, 180 },

      { 0, 0, 320, 240 }

   },

   {  // digital camera: Logitech VideoMan 1.3

      { 0, 0, 160, 120 },

      { 0, 0, 320, 240 },

      { 0, 0, 640, 480 }

   },

};



#define ARR_SIZE( arr ) sizeof( arr ) / sizeof( arr##[0] )





static COMBOBOX_ENTRY gwStandardOptions[] =

{

   { VFormat_NTSC,      "NTSC-M"        },

   { VFormat_NTSC_J,    "NTSC-Japan"    },

   { VFormat_PAL_BDGHI, "PAL-B,D,G,H,I" },

   { VFormat_PAL_M,     "PAL-M"         },

   { VFormat_PAL_N,     "PAL-N"         },

   { VFormat_SECAM,     "SECAM"         },

   { VFormat_PAL_NC,    "PAL-NC"        }

};

#define N_STANDARDOPTIONS (sizeof (gwStandardOptions) / sizeof (COMBOBOX_ENTRY))



//===========================================================================

// <UPDATE REQUIRED>

// List of supported camera. Update this list when camera models are added or

// deleted.

//===========================================================================

typedef enum { SVI, Logitech } CAMERA;



static COMBOBOX_ENTRY gwCameraOptions[] =

{

   { SVI,      "Silicon Vision 512N" },

   { Logitech, "Logitech VideoMan 1.3"   }

};

#define N_CAMERAOPTIONS (sizeof (gwCameraOptions) / sizeof (COMBOBOX_ENTRY))



//===========================================================================

// This is the structure of the camera specifications

//===========================================================================

typedef struct tag_cameraSpec

{

   SignalFormat signal;       // which digital signal format the camera has

   VideoFormat  vidFormat;    // video standard

   SyncVideoRef syncRef;      // which sync video reference is used

   State        syncOutput;   // enable sync output for sync video input?

   DecInputClk  iClk;         // which input clock is used

   TimeGenByte  tgb;          // which timing generator byte does the camera use

   State        HReset;       // uses 64 pixels(Off) or 32 pixels(On) for HReset

   PLLFreq      pllFreq;      // what synthesized frequency to set PLL to

   VSIZEPARMS   vSize;        // video size the camera produces

} CameraSpec;



//===========================================================================

// <UPDATE REQUIRED>

// Camera specifications database. Update this table whenever camera spec

// has been changed or added/deleted supported camera models

//===========================================================================

static CameraSpec dbCameraSpec[ N_CAMERAOPTIONS ] =

{  // Silicon Vision 512N

   { Signal_CCIR656, VFormat_NTSC, VRef_alignedCb, Off, DecClk_GPCLK, TGB_NTSC624, Off, KHz19636,

      // Clkx1_HACTIVE, Clkx1_HDELAY, VActive, VDelay, linesPerField;

   {         512,           0x64,       480,    0x13,      240 },

   },

   // Logitech VideoMan 1.3

   { Signal_CCIR656, VFormat_NTSC, VRef_alignedCb, Off, DecClk_GPCLK, TGB_NTSC780, Off, KHz24545,

      // Clkx1_HACTIVE, Clkx1_HDELAY, VActive, VDelay, linesPerField;

      {      640,           0x80,       480,    0x1A,      240 },

   }

};



//===========================================================================

// Call APIs to use digital camera as video source input

//===========================================================================

static bool SetDigitalCamera( CAMERA index )

{

   CameraSpec spec;

   if ( ( index < 0 ) || ( index >= N_CAMERAOPTIONS ) )

      return false;



   spec = dbCameraSpec[ index ];



   // call APIs to set up appropriately for the selected camera

   SetSignalFormat( spec.signal );

   SetVideoFormat( spec.vidFormat );

   SetSyncVideoRef( spec.syncRef );

   SetEnableSyncOutput( spec.syncOutput );

   SetTimGenByte( spec.tgb );

   SetHReset( spec.HReset );

   SetPLL( spec.pllFreq );

   SetDecInputClock( spec.iClk );

   SetVideoInfo( spec.vSize );

   return true;

}



//===========================================================================

// Return the size option for a video source

// 0:  NTSC-M, NTSC-Japan, PAL-M

// 1:  PAL-BDGHI, PAL-N, SECAM

// 3:  PAL-NC

// 4+: digital cameras

// NOTE: 2 is used by the raw mode and is NOT considered here.

//===========================================================================

static int GetSizeOption( SignalFormat sf, int camIndex, VideoFormat vf )

{

   // PAL-NC has horizontal size of NTSC and vertical size of PAL

   if ( sf != Signal_Analog )

      return CameraSizeBase + camIndex;

   else

      return ( vf == VFormat_PAL_NC ) ? 3 :

             IsNTSCCompatible( vf ) ? 0 : 1;

}



//===========================================================================

// Enable/Disable some controls when analog or digital signal is selected

//===========================================================================

static void AnalogSignalSelected( HWND hDlg, bool flag )

{

   EnableWindow( GetDlgItem( hDlg, ID_CBSTANDARD ),  flag );

   EnableWindow( GetDlgItem( hDlg, ID_CBCAMERA ),   !flag );

}



//===========================================================================

// Enable/Disable hue controls since they are only available for NTSC signals;

// not for digital source and PAL/SECAM analog signals

//===========================================================================

static void EnableHueControls( HWND hDlg, bool flag )

{

   EnableWindow( GetDlgItem( hDlg, ID_EBHUE ), flag );

   EnableWindow( GetDlgItem( hDlg, ID_SBHUE ), flag );

}



//===========================================================================

// Save camera model index to Windows registry

//===========================================================================

static void StoreCameraIndex( int index )

{

   RegUtil Storage( "Bt848" );

   Storage.SetValue( index, "CameraIndex" );

}



//===========================================================================

// Return camera model index from Windows registry

//===========================================================================

static int RestoreCameraIndex( void )

{

   RegUtil Storage( "Bt848" );

   DWORD dwTmp = 0;  // working variable



   if ( Storage.GetValue( &dwTmp, "CameraIndex" ) != Success )

      return 0;

   else

      return ( (int)dwTmp );

}



inline VOID UpdateSizeDisplay( HWND hDlg, WPARAM wIdx )

{

   SendDlgItemMessage( hDlg, ID_LBSIZE, CB_SETCURSEL, wIdx, 0L );

}



static WORD WINAPI ConfigGetComboBoxValue( HWND  hDlg, int wID,

   COMBOBOX_ENTRY *pCBE )

{

   int	nIndex;

   HWND	hWndCB = GetDlgItem( hDlg, wID );

   nIndex = (int) SendMessage( hWndCB, CB_GETCURSEL, 0, 0L );

   nIndex = max( 0, nIndex );//LB_ERR is negative

   return pCBE [nIndex].wValue;

}



///

#pragma argsused

int WINAPI _loadds VideoFormatDlgProc( HWND hDlg, UINT msg, WPARAM wParam,

   LPARAM lParam )

{

   WORD CurSelSize;

   ColFmt Col;

   RECT r;

   int i;



   switch ( msg ) {

   case WM_INITDIALOG:

      GetImageSize( & r );

      GetImageFormat( &Col );



      if ( !VidSourceUp )

         if ( IsABt848A() )

            SizeOption = GetSizeOption( GetSignalFormat(), RestoreCameraIndex(),

                                        GetVideoFormat() );

         else

            SizeOption = IsNTSCCompatible( GetVideoFormat() ) ? 0 : 1;



      // raw mode has very different sizes

      if ( Col == CF_RAW )

         SizeOption = 2;



      // find our index

      for ( i = 0; i < ARR_SIZE( RectArr [0] ); i++ )

         // have to do 'C' comparison as this should be 'C' compileable

         if ( memcmp( &r, RectArr [SizeOption] + i, sizeof( RECT ) ) == 0 )

            break;

      if ( i >= ARR_SIZE( RectArr [0] ) )

         i = 1;



      ConfigLoadComboBox( hDlg, ID_LBSIZE, gwSizeOptions [SizeOption],

         N_SIZEOPTIONS - ( SizeOption == 2 ), i );

      ConfigLoadComboBox( hDlg, ID_LBIMAGEFORMAT, gwFormatOptions,

         N_FORMATOPTIONS, Col );



      if ( VidSourceUp ) {

         HWND hCtl = GetDlgItem( hDlg, IDCANCEL );

         EnableWindow( hCtl, FALSE );

      }

      break;

      // User will unload this module at exit time, so make

      // sure that the dialog is gone if the user just quits

      // Windows with the dialog box up.

   case WM_ENDSESSION:

      if ( wParam )

         EndDialog( hDlg, IDCANCEL );

      break;



   case WM_COMMAND:

      switch ( wParam ) {

      case IDOK:

         if ( !VidSourceUp )

            if ( IsABt848A() )

               // determine size option for various video format

               SizeOption = GetSizeOption( GetSignalFormat(), RestoreCameraIndex(),

                                           GetVideoFormat() );

            else

               SizeOption = IsNTSCCompatible( GetVideoFormat() ) ? 0 : 1;



         Col = (ColFmt)ConfigGetComboBoxValue( hDlg, ID_LBIMAGEFORMAT, gwFormatOptions );

         if ( Col == CF_RAW )

            SizeOption = 2;



         SetImage( &RectArr [SizeOption] [ConfigGetComboBoxValue( hDlg, ID_LBSIZE, gwSizeOptions [SizeOption] )],

            Col );

         EndDialog( hDlg, IDOK );

         break;

      case IDCANCEL:

         EndDialog( hDlg, IDCANCEL );

         break;

      case ID_LBIMAGEFORMAT:

         if ( HIWORD( lParam ) != CBN_SELCHANGE )

            break;

         CurSelSize = ConfigGetComboBoxValue( hDlg, ID_LBSIZE, gwSizeOptions [SizeOption] );

         if ( CF_RAW == (ColFmt)ConfigGetComboBoxValue( hDlg, ID_LBIMAGEFORMAT, gwFormatOptions ) )

            ConfigLoadComboBox( hDlg, ID_LBSIZE, gwSizeOptions [2],

               N_SIZEOPTIONS - 1, 0 );

         else {

            if ( IsABt848A() )

               // determine size option for various video format

               SizeOption = GetSizeOption( GetSignalFormat(), RestoreCameraIndex(),

                                           GetVideoFormat() );

            else

               SizeOption = IsNTSCCompatible( GetVideoFormat() ) ? 0 : 1;

            ConfigLoadComboBox( hDlg, ID_LBSIZE, gwSizeOptions [SizeOption],

               N_SIZEOPTIONS, CurSelSize );

         }

         break;

      case ID_PBSIZEFULL:

         UpdateSizeDisplay( hDlg, 2 );

         break;

      case ID_PBSIZEHALF:

         UpdateSizeDisplay( hDlg, 1 );

         break;

      case ID_PBSIZEQUARTER:

         UpdateSizeDisplay( hDlg, 0 );

         break;

      case ID_PBSIZEEIGHTH:

         UpdateSizeDisplay( hDlg, ( ARR_SIZE( RectArr ) - 1 ) / 8 );

         break;

      default:

         break;

         }

      break;



   default:

      return FALSE;

   }

   return TRUE;

}



WORD WINAPI VidFormatDialog( HWND hParent )

{

   if ( DialogBox( GetOurInstance(), MAKEINTRESOURCE( DLG_VIDEOFORMAT ),

      hParent, (DLGPROC)VideoFormatDlgProc ) != -1 )

      return 0;

   return 1;

}





#define WM_UPDATEDIALOG  (WM_USER+200)



int ColorProcessScroll( HWND hDlg, HWND hCtl, WORD wParam, DWORD lParam,

   int iVal, WORD wIDEditBox )

{

   int iPageSize;

   int iMin, iMax;



   GetScrollRange( hCtl, SB_CTL, &iMin, &iMax );

   iPageSize = 1 + ( ( iMax - iMin ) / 10 );



   switch ( wParam ) {

   case SB_LINEDOWN:

      iVal++;

      break;

   case SB_LINEUP:

      iVal--;

      break;

   case SB_PAGEDOWN:

      iVal += iPageSize;

      break;

   case SB_PAGEUP:

      iVal -= iPageSize;

      break;

   case SB_THUMBTRACK:

      iVal = LOWORD ( lParam );

      break;

   default:

      break;

   }

   iVal = LimitRange( iVal, iMin, iMax );

   SetScrollPos( hCtl, SB_CTL, iVal, TRUE );

   SetDlgItemInt( hDlg, wIDEditBox, iVal, TRUE );

   return iVal;

}



DWORD FmtDlgHelpIDs [] = {

   ID_LBIMAGEFORMAT,   IDH_IMAGE_FORMAT,

   ID_PBSIZEFULL,      IDH_SIZE,

   ID_PBSIZEHALF,      IDH_SIZE,

   ID_PBSIZEQUARTER,   IDH_SIZE,

   ID_PBSIZEEIGHTH,    IDH_SIZE,

   ID_LBSIZE,          IDH_SIZE,

};



DWORD SrcDlgHelpIDs [] = {

   ID_RBSOURCE0,  IDH_VIDEO_CONNECT,

   ID_RBSOURCE1,  IDH_VIDEO_CONNECT,

   ID_RBSOURCE2,  IDH_VIDEO_CONNECT,

   ID_RBSOURCE3,  IDH_VIDEO_CONNECT,

   ID_RBNTSC,	   IDH_VIDEO_STANDARD,

   ID_RBNTSC_J,   IDH_VIDEO_STANDARD,

   ID_RBPAL,      IDH_VIDEO_STANDARD,

   ID_RBPAL_M,    IDH_VIDEO_STANDARD,

   ID_RBPAL_N,    IDH_VIDEO_STANDARD,

   ID_RBSECAM,    IDH_VIDEO_STANDARD

//   ID_CBSVHS,     IDH_VIDEO_STANDARD



};



/* Function:  GetAudioSource ( void )

 * Purpose: Get audio source

 * Input:   None

 * Output:  None

 * Return:  audio source - AUDIO_SOURCE_CDROM, AUDIO_SOURCE_EXTAUDIO,

                         AUDIO_SOURCE_TVTUNER, AUDIO_SOURCE_MUTE

*/

DWORD GetAudioSource( void )

{

   // read GPIE from pin (not register)

   SetGPIE( 0x00000000L );



   // ask GPIO what the setting is

   DWORD value;

   return ( GetGPDATABits( 0, 1, &value, 0 ) == Success ? value : -1 );

}





/* Method:  ULONG SetAudioSource ( ULONG audio )

 * Purpose: Set audio source

 * Input:   ULONG audio - AUDIO_SOURCE_CDROM, AUDIO_SOURCE_EXTAUDIO,

 *    AUDIO_SOURCE_TVTUNER, AUDIO_SOURCE_MUTE

 * Output:  None

 * Return:  TV control error value

*/

ErrorCode SetAudioSource( DWORD audio )

{

   if ( audio > AUDIO_SOURCE_MUTE )

      return Fail;



   // enables/disable GPOE drivers for [3:0]

   // analog uses GPIO[3:0] for audio; but they are used in digital so don't touch them

   if ( IsABt848A() )

      if ( GetConnector() == ConCamera )

      {  // digital signal; GPDATA[5:0] remapped

         SetGPOE( 0x00000000L );

      }

      else

      {  // analog signal; GPDATA[5:0] not remapped

         SetGPOE( 0x0000000FL );

         SetGPDATABits( 0, 1, audio, 0 );

      }

   else

   {

      SetGPOE( 0x0000000FL );

      SetGPDATABits( 0, 1, audio, 0 );

   }

   return Success;

/*

   // if already mute, don't change audio source, just remember it

   if ( GetAudioSource() == AUDIO_SOURCE_MUTE ) {

      return Success;

   } else {  // not in mute, change audio source

      if ( SetGPDATABits( 0, 1, audio, 0 ) == Success ) {

         return Success;

      } else

         return Fail;

   }

*/

}



/* Function: SetAudioMute

 * Purpose: Mute or UnMute audio

 * Input:   ULONG mute - 1 to mute; 0 to unmute

 * Output:  None

 * Return:  TV control error value

*/

ErrorCode SetAudioMute( DWORD mute )

{

   if ( mute > 1 )

      return Fail;



   // enables/disable GPOE drivers for [3:0]

   // analog uses GPIO[3:0] for audio; but they are used in digital so don't touch them

   if ( IsABt848A() )

      if ( GetConnector() == ConCamera )

         SetGPOE( 0x00000000L );

      else

         // analog signal; GPDATA[5:0] not remapped

         SetGPOE( 0x0000000FL );

   else

      SetGPOE( 0x0000000FL );



   if ( mute == 1 ) {

      if ( GetAudioSource() == AUDIO_SOURCE_MUTE )

         return Fail;

      else

         return SetGPDATABits( 0, 1, AUDIO_SOURCE_MUTE, 0 );

   }

   return Success;

}





//

// Dialog proc for the video source dialog box (VIDEO_EXTERNALIN channel)

//

#pragma argsused

int WINAPI _loadds VideoSourceDlgProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam )

{

   static int Brightness;

   static int Contrast;

   static int Saturation;

   static int Hue;

   int rbID;

   WORD wID;

   HWND hCtl;

   CAMERA cameraIndex;



   switch ( msg ) {

   case WM_INITDIALOG: {

         // start up audio not mute

         SetAudioMute( 0 );



         Brightness = GetBrightness();

         Contrast   = GetContrast();

         Saturation = GetSaturation();

         Hue        = GetHue();



         hCtl = GetDlgItem( hDlg, ID_SBBRIGHTNESS );

         SetScrollRange( hCtl, SB_CTL , 0, 255, FALSE );



         hCtl = GetDlgItem( hDlg, ID_SBCONTRAST );

         SetScrollRange( hCtl, SB_CTL, 0, 255, FALSE );



         hCtl = GetDlgItem( hDlg, ID_SBSATURATION );

         SetScrollRange( hCtl, SB_CTL, 0, 255, FALSE );



         hCtl = GetDlgItem( hDlg, ID_SBHUE );

         SetScrollRange( hCtl, SB_CTL, 0, 255, FALSE );



         ConfigLoadComboBox( hDlg, ID_CBSTANDARD, gwStandardOptions,

            N_STANDARDOPTIONS, 0 );

         ConfigLoadComboBox( hDlg, ID_CBCAMERA, gwCameraOptions,

            N_CAMERAOPTIONS, 0 );



         // intentional fall-through

   case WM_UPDATEDIALOG:

         Brightness = LimitRange( Brightness, 0, 255 );

         SetDlgItemInt( hDlg, ID_EBBRIGHTNESS, Brightness, TRUE );

         hCtl = GetDlgItem( hDlg, ID_SBBRIGHTNESS );

         SetScrollPos( hCtl, SB_CTL, Brightness, TRUE );



         Contrast = LimitRange( Contrast, 0, 255 );

         SetDlgItemInt( hDlg, ID_EBCONTRAST, Contrast, FALSE );

         hCtl = GetDlgItem( hDlg, ID_SBCONTRAST );

         SetScrollPos( hCtl, SB_CTL, Contrast, TRUE );



         Saturation = LimitRange( Saturation, 0, 255 );

         SetDlgItemInt( hDlg, ID_EBSATURATION, Saturation, FALSE );

         hCtl = GetDlgItem( hDlg, ID_SBSATURATION );

         SetScrollPos( hCtl, SB_CTL, Saturation, TRUE );



         Hue = LimitRange( Hue, 0, 255 );

         SetDlgItemInt( hDlg, ID_EBHUE, Hue, TRUE );

         hCtl = GetDlgItem( hDlg, ID_SBHUE );

         SetScrollPos( hCtl, SB_CTL, Hue, TRUE );



         switch ( GetConnector() )

         {

            case ConTuner:

               SetAudioSource( AUDIO_SOURCE_TVTUNER );

               AnalogSignalSelected( hDlg, TRUE );

               rbID = ID_RBSOURCE0;

               break;

            case ConComposite:

               AnalogSignalSelected( hDlg, TRUE );

               rbID = ID_RBSOURCE1;

               break;

            case ConSVideo:

               AnalogSignalSelected( hDlg, TRUE );

               rbID = ID_RBSOURCE2;

               break;

            case ConCamera:

               AnalogSignalSelected( hDlg, FALSE );

               rbID = ID_RBSOURCE3;

               break;

         }



         CheckRadioButton( hDlg, ID_RBSOURCE0, ID_RBSOURCE3, rbID );



         SendDlgItemMessage( hDlg, ID_CBSTANDARD, CB_SETCURSEL, GetVideoFormat()-1, 0L );

         SendDlgItemMessage( hDlg, ID_CBCAMERA, CB_SETCURSEL, RestoreCameraIndex(), 0L );



//         CheckDlgButton( hDlg, ID_CBSVHS, GetSVideo() );

         // after edit boxes were aupdated

         SetBrightness( Brightness );

         SetContrast( Contrast );

         SetSaturation( Saturation );

         SetHue( Hue );



         // re-enable the hue edit box which could be disabled. scroll bar gets

         // enabled by the SetScrollPos

         hCtl = GetDlgItem( hDlg, ID_EBHUE );

         EnableWindow( hCtl, TRUE );



         // disable Bt848A related control if doesn't find the exact hardware

         if ( !IsABt848A() )

         {

            EnableWindow( GetDlgItem( hDlg, ID_RBSOURCE3 ), FALSE );

            EnableWindow( GetDlgItem( hDlg, ID_CBCAMERA ), FALSE );

            SendDlgItemMessage( hDlg, ID_CBSTANDARD, CB_DELETESTRING, 6, 0 );  // No PAL-Nc

         }

         break;

      }

      // User will unload this module at exit time, so make

      // sure that the dialog is gone if the user just quits

      // Windows with the dialog box up.

   case WM_ENDSESSION:

      if ( wParam )

         EndDialog( hDlg, IDCANCEL );

      break;

   case WM_COMMAND:

      switch ( wParam ) {

      case IDOK:

         if ( IsABt848A() )

         {

            // need to "store" dialog selection since they may have changed

            cameraIndex = (CAMERA)ConfigGetComboBoxValue( hDlg, ID_CBCAMERA, gwCameraOptions );

            StoreCameraIndex( cameraIndex );



            // what is the selected video signal format? analog vs digital

            if ( IsDlgButtonChecked( hDlg, ID_RBSOURCE3 ) )

            {

               // digital camera source is selected

               SetDigitalCamera( cameraIndex );

            }

            else

            {

               // analog source is selected

               SetSignalFormat( Signal_Analog );

               SetVideoFormat( (VideoFormat)ConfigGetComboBoxValue( hDlg, ID_CBSTANDARD, gwStandardOptions ) );

            }

         }

         else

            SetVideoFormat( (VideoFormat)ConfigGetComboBoxValue( hDlg, ID_CBSTANDARD, gwStandardOptions ) );

         EndDialog( hDlg, IDOK );

         break;

      case IDCANCEL:

         EndDialog( hDlg, IDCANCEL );

         break;

      case ID_RBSOURCE0:

         if ( IsABt848A() )

         {

            // if change from digital source, ask for video size

            if ( GetConnector() == ConCamera )

            {

               VideoFormat vf = (VideoFormat)ConfigGetComboBoxValue( hDlg, ID_CBSTANDARD, gwStandardOptions );

               SizeOption = GetSizeOption( Signal_Analog, 0, vf );

               VidFormatDialog( hDlg );

               EnableHueControls( hDlg, ( vf == VFormat_NTSC || vf == VFormat_NTSC_J ) );

            }

         }

         AnalogSignalSelected( hDlg, TRUE );

         SetConnector( ConTuner, TRUE );

         SetAudioSource( AUDIO_SOURCE_TVTUNER );

         break;

      case ID_RBSOURCE1:

         if ( IsABt848A() )

         {

            // if change from digital source, ask for video size

            if ( GetConnector() == ConCamera )

            {

               VideoFormat vf = (VideoFormat)ConfigGetComboBoxValue( hDlg, ID_CBSTANDARD, gwStandardOptions );

               SizeOption = GetSizeOption( Signal_Analog, 0, vf );

               VidFormatDialog( hDlg );

               EnableHueControls( hDlg, ( vf == VFormat_NTSC || vf == VFormat_NTSC_J ) );

            }

         }

         AnalogSignalSelected( hDlg, TRUE );

         SetConnector( ConComposite, TRUE );

         SetAudioSource( AUDIO_SOURCE_EXTAUDIO );

         break;

      case ID_RBSOURCE2:

         if ( IsABt848A() )

         {

            // if change from digital source, ask for video size

            if ( GetConnector() == ConCamera )

            {

               VideoFormat vf = (VideoFormat)ConfigGetComboBoxValue( hDlg, ID_CBSTANDARD, gwStandardOptions );

               SizeOption = GetSizeOption( Signal_Analog, 0, vf );

               VidFormatDialog( hDlg );

               EnableHueControls( hDlg, ( vf == VFormat_NTSC || vf == VFormat_NTSC_J ) );

            }

         }

         AnalogSignalSelected( hDlg, TRUE );

         SetConnector( ConSVideo, TRUE );

         SetAudioSource( AUDIO_SOURCE_EXTAUDIO );

         break;

      case ID_RBSOURCE3:

         if ( IsABt848A() && ( GetConnector() != ConCamera ) )

         {

            CAMERA cam = (CAMERA)ConfigGetComboBoxValue( hDlg, ID_CBCAMERA, gwCameraOptions );

            SendDlgItemMessage( hDlg, ID_CBSTANDARD, CB_SETCURSEL, dbCameraSpec[ cam ].vidFormat-1, 0L );

            SizeOption = GetSizeOption( Signal_CCIR656, cam, (VideoFormat)0 );

            VidFormatDialog( hDlg );



            SetConnector( ConCamera, TRUE );

            SetAudioSource( AUDIO_SOURCE_EXTAUDIO );

            AnalogSignalSelected( hDlg, FALSE );



            // no hue control for digital camera

            EnableHueControls( hDlg, FALSE );

         }

         break;



      case ID_CBSTANDARD:

      {

         if ( HIWORD( lParam ) != CBN_SELCHANGE )

            break;

         VideoFormat vf = (VideoFormat)ConfigGetComboBoxValue( hDlg, ID_CBSTANDARD, gwStandardOptions );

         if ( vf == VFormat_PAL_NC )

         {

            // make sure sizes are OK

            SizeOption = 3;

            EnableHueControls( hDlg, FALSE );

         }

         else if ( IsNTSCCompatible( vf ) )

         {

            SizeOption = 0;

            EnableHueControls( hDlg, ( vf == VFormat_NTSC || vf == VFormat_NTSC_J ) );

         }

         else  // PAL compatible

         {

            SizeOption = 1;

            EnableHueControls( hDlg, FALSE );

         }

         VidFormatDialog( hDlg );

         break;

      }



      case ID_CBCAMERA:

      {

         if ( HIWORD( lParam ) != CBN_SELCHANGE )

            break;

         CAMERA cam = (CAMERA)ConfigGetComboBoxValue( hDlg, ID_CBCAMERA, gwCameraOptions );

         SendDlgItemMessage( hDlg, ID_CBSTANDARD, CB_SETCURSEL, dbCameraSpec[ cam ].vidFormat-1, 0L );

         SizeOption = CameraSizeBase + cam;

         VidFormatDialog( hDlg );

         break;

      }



      case ID_PBDEFAULT:

         Brightness = 128;

         Contrast   = 128;

         Saturation = 128;

         Hue        = 128;

         SendMessage( hDlg, WM_UPDATEDIALOG, 0, 0L );

         break;

         /*

      case ID_CBSVHS:

         if ( IsDlgButtonChecked( hDlg, ID_CBSVHS ) )

            SetSVideo( On );

         else

            SetSVideo( Off );

         break;

         */

/*

      case 0x0053: //WM_HELP

      case WM_CONTEXTMENU:

         WinHelp( ((LPHELPINFO) lParam)->hItemHandle, szHelpFileName,

            HELP_WM_HELP, (DWORD) (LPSTR) aConfigDlgHelpIDs );

         break;

*/

      case ID_HELP:

         {

            char HelpFile [100];

            if ( LoadString( GetOurInstance(), IDS_HELPFILE, HelpFile, sizeof( HelpFile ) ) )

//               WinHelp( hDlg, HelpFile, HELP_CONTEXT, (DWORD)SrcDlgHelpIDs );

               WinHelp( hDlg, HelpFile, HELP_CONTENTS,0 );

            break;

         }

      case ID_EBBRIGHTNESS:

      case ID_EBCONTRAST:

      case ID_EBSATURATION:

      case ID_EBHUE:

         if ( HIWORD( lParam ) != EN_KILLFOCUS )

         return FALSE;



         Brightness = GetDlgItemInt( hDlg, ID_EBBRIGHTNESS, NULL, TRUE );

         Contrast = GetDlgItemInt( hDlg, ID_EBCONTRAST, NULL, FALSE );

         Saturation = GetDlgItemInt( hDlg,ID_EBSATURATION, NULL, FALSE );

         Hue = GetDlgItemInt( hDlg, ID_EBHUE, NULL, TRUE );

         SendMessage( hDlg, WM_UPDATEDIALOG, 0, 0L );

         break;

      }

      break;

   case WM_HSCROLL:



      hCtl = (HWND)HIWORD( lParam );

      wID = GetWindowWord( hCtl, GWW_ID );

      switch ( wID ) {

      case ID_SBBRIGHTNESS:

         Brightness = ColorProcessScroll( hDlg, hCtl,

            wParam, lParam, Brightness, ID_EBBRIGHTNESS );

         SetBrightness( Brightness );

         break;

      case ID_SBCONTRAST:

         Contrast = ColorProcessScroll( hDlg, hCtl,

            wParam, lParam, Contrast, ID_EBCONTRAST );

         SetContrast( Contrast );

         break;

      case ID_SBSATURATION:

         Saturation = ColorProcessScroll( hDlg, hCtl, wParam,

            lParam, Saturation, ID_EBSATURATION );

         SetSaturation( Saturation );

         break;

      case ID_SBHUE:

         Hue = ColorProcessScroll( hDlg, hCtl, wParam,

            lParam, Hue, ID_EBHUE );

         SetHue( Hue );

         break;

      }

      break;

   default:

      return FALSE;

   }



   return TRUE;

}



WORD WINAPI VideoSourceDialog( HWND hParent )

{

   Connector CurCon;

   VideoFormat fmt;

   DWORD        audio;

   SignalFormat signal;

   SyncVideoRef syncRef;

   State        syncOutput;

   DecInputClk  iClk;

   TimeGenByte  tgb;

   State        HReset;

   PLLFreq      pllFreq;

   VSIZEPARMS   vSize;

   int Brightness;

   int Contrast;

   int Saturation;

   int Hue;



   CurCon = GetConnector();

   fmt = GetVideoFormat();

   if ( IsABt848A() )

   {

      audio = GetAudioSource();

      signal = GetSignalFormat();

      syncRef = GetSyncVideoRef();

      syncOutput = GetEnableSyncOutput();

      iClk = GetDecInputClock();

      tgb = GetTimGenByte();

      HReset = GetHReset();

      pllFreq = GetPLL();

      GetVideoInfo( &vSize );

   }



   Brightness = GetBrightness();

   Contrast   = GetContrast();

   Saturation = GetSaturation();

   Hue        = GetHue();



   VidSourceUp = TRUE;



   switch ( DialogBox( GetOurInstance(), MAKEINTRESOURCE( DLG_VIDEOSOURCE ),

      hParent, (DLGPROC) VideoSourceDlgProc ) ) {

   case IDOK:

      break;

   case IDCANCEL:

      // restore the values

      SetConnector( CurCon, TRUE );

      if ( IsABt848A() )

      {

         SetAudioSource( audio );

         if ( signal == Signal_Analog )

            SetVideoFormat( fmt );

         else

         {

            SetSignalFormat( signal );

            SetVideoFormat( fmt );

            SetSyncVideoRef( syncRef );

            SetEnableSyncOutput( syncOutput );

            SetTimGenByte( tgb );

            SetHReset( HReset );

            SetPLL( pllFreq );

            SetDecInputClock( iClk );

            SetVideoInfo( vSize );

         }

      }

      else

         SetVideoFormat( fmt );

      SetBrightness( Brightness );

      SetContrast( Contrast );

      SetSaturation( Saturation );

      SetHue( Hue );

      break;

   case -1:

      VidSourceUp = FALSE;

      return 1;

   }

   VidSourceUp = FALSE;

   return 0;

}



/* CALLBACK:

 * Purpose:

 */

int WINAPI _loadds VideoDisplayProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM )

{

   static int DoCC;

   switch ( msg ) {

   case WM_INITDIALOG: {

      int RB;

      char str [80];

      DoCC = GetCCStatus();

      if ( DoCC & 0x8000 ) {

         CheckDlgButton( hDlg, IDC_CBCC, 1 );

         RB = DoCC &  1 ? IDC_RBCC1 : IDC_RBCC2;

      } else {

         CheckDlgButton( hDlg, IDC_CBCC, 0 );

         RB = IDC_RBCC1;

         EnableWindow( GetDlgItem( hDlg, IDC_RBCC1 ), false );

         EnableWindow( GetDlgItem( hDlg, IDC_RBCC2 ), false );

         EnableWindow( GetDlgItem( hDlg, IDC_CCTOKEN ), false );

         EnableWindow( GetDlgItem( hDlg, IDC_FILENAME ), false );

      }

      CheckRadioButton( hDlg, IDC_RBCC1, IDC_RBCC2, RB );

      GetCCFileName( str, sizeof( str ) - 1 );

      SetDlgItemText( hDlg, IDC_FILENAME, str );

      GetCCAlert( str, sizeof( str ) - 1 );

      SetDlgItemText( hDlg, IDC_CCTOKEN, str );



      break;

      }

   case WM_COMMAND:

      switch ( wParam ) {

      case IDOK:

         if ( IsDlgButtonChecked( hDlg, IDC_CBCC ) ) {

            DoCC = 0x8000;

            if ( IsDlgButtonChecked( hDlg, IDC_RBCC1 ) )

               DoCC |= 0x0001;

            else

               DoCC |= 0x0002;

            char str [80];

            GetDlgItemText( hDlg, IDC_CCTOKEN, str, sizeof( str ) - 1 );

            SetCCAlert( str );

            GetDlgItemText( hDlg, IDC_FILENAME, str, sizeof( str ) - 1 );

            SetCCFileName( str );

         } else

            DoCC = 0;

         // no break

      case IDCANCEL:

         SetCCStatus( DoCC );

         EndDialog( hDlg, IDCANCEL );

         break;

      case IDC_CBCC:

         if ( !IsDlgButtonChecked( hDlg, IDC_CBCC ) ) {

            EnableWindow( GetDlgItem( hDlg, IDC_RBCC1 ), false );

            EnableWindow( GetDlgItem( hDlg, IDC_RBCC2 ), false );

            EnableWindow( GetDlgItem( hDlg, IDC_CCTOKEN ), false );

            EnableWindow( GetDlgItem( hDlg, IDC_FILENAME ), false );

         } else {

            EnableWindow( GetDlgItem( hDlg, IDC_RBCC1 ), true );

            EnableWindow( GetDlgItem( hDlg, IDC_RBCC2 ), true );

            EnableWindow( GetDlgItem( hDlg, IDC_CCTOKEN ), true );

            EnableWindow( GetDlgItem( hDlg, IDC_FILENAME ), true );

         }

         break;

      default:

         return FALSE;

      }

      break;

    default:

       return FALSE;

   }

   return TRUE;

}



/* Function: VideoDisplay

 * Purpose: Starts Video Display dialog

 */

WORD VideoDisplay( HWND hParent )

{

   return DialogBox( GetOurInstance(), MAKEINTRESOURCE( EXTVIDOUT_DLG ),

      hParent, (DLGPROC) VideoDisplayProc );

}



/* Function: VideoDialog

 * Purpose: Dialog dispatcher

 * Input: hParent: HWND, parent window

 *   dlg: int, dialog number

 */

#ifdef __cplusplus

extern "C"

#endif

WORD WINAPI _export VideoDialog( HWND hParent, int dlg )

{

   switch ( dlg ) {

   case VIDEO_SOURCE:

      return  VideoSourceDialog( hParent );

   case VIDEO_FORMAT:

      return VidFormatDialog( hParent );

   case VIDEO_DISPLAY:

      return VideoDisplay( hParent );

   default:

      return 0;

   }

}











