/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/***************************************************************************

* Module:   bt878api.h                                                     *

*                                                                          *

* Description:                                                             *

*     Documents the API for this DLL.                                      *

*                                                                          *

* [copyright, 97]                                                          *

*                                                                          *

***************************************************************************/



/***************************************************************************

* [start cut]

* $Log: Bt878api.h,v $
* Revision 1.1  1999/08/27 02:52:34  nradisch
* new
*

* Revision 1.7  1997/07/09 16:14:29  tomz

* Get ErrorCode definitions from the right place (retcode.h)

* Revision 1.6  1997/07/02 21:06:55  tomz

* Remove dead code, cleanup

* Revision 1.5  1997/07/02 14:50:37  tomz

* Fix calling convention, continue move to single entrypoint

* Revision 1.4  1997/07/01 23:48:24  tomz

* Moving to single entrypoint, multiple command.

* Also fixing declarations to match BT848.

* Revision 1.3  1997/06/20 20:59:44  tomz

* Revision 1.2  1997/06/20 20:40:18  tomz

* Revision 1.1  1997/06/19 23:01:50  tomz

* Initial revision

* [end cut]

***************************************************************************/



#ifndef  BT878API_H     // Make sure we don't include this file twice

#define  BT878API_H



#include <windows.h>

#include "def__.h"      // define __BT878CLASS and __BT878FUNC

#include "retcode.h"    // define ErrorCode, Sucess, and Failure



#ifdef __cplusplus

extern "C"

{

#endif



typedef enum {

   MUX_IN_INVALID,

   MUX_IN_TV,

   MUX_IN_RADIO,

   MUX_IN_LINE_IN

} AUDIO_INPUT;



typedef void ( WINAPI *FN_STEREO_CALLBACK )( BOOL bStereoDetected );



/***************************************************************************

*  Interfaces in DLL expected to be called from applications               *

***************************************************************************/



typedef enum {

   CMD_DEVICE_OPEN,

   CMD_DEVICE_CLOSE,



   CMD_SET_INPUT_SELECTION,

   CMD_SET_STEREO_STATE,

   CMD_SET_DBX_STATE,

   CMD_SET_SAMPLE_FREQ,

   CMD_SET_SAMPLE_RES,

   CMD_SET_CAPTURE_FILE,



   CMD_GET_INPUT_SELECTION,

   CMD_GET_STEREO_STATE,

   CMD_GET_DBX_STATE,

   CMD_GET_SAMPLE_FREQ,

   CMD_GET_SAMPLE_RES,

   CMD_GET_CAPTURE_FILE,



   CMD_START_PLAYING,

   CMD_START_CAPTURE,

   CMD_END_PLAYING,

   CMD_END_CAPTURE,



   CMD_SET_STEREO_CALLBACK,

   CMD_DUMP_STATUS,



   CMD_COUNT

} CMD_CODE;



typedef   DWORD ( WINAPI *ProcessCommand_t )( CMD_CODE cmd, DWORD dwHandle, DWORD dwExtra );

DWORD __BT878FUNC ProcessCommand ( CMD_CODE cmd, DWORD dwHandle, DWORD dwExtra );



/*********************************************************************

*  Radio      Stereo     Stereo    Dbx     Quality                   *

*   TV       Detected    State    State                              *

* LineIn                                                             *

**********************************************************************

* LineIn        x           x        x      Mono                     *

*    x          0           x        x      Mono                     *

*    x          x           0        x      Mono                     *

*   TV          1           1        0      Stereo, poor seperation  *

*   TV          1           1        1      Stereo                   *

*  Radio        1           1        x      Stereo                   *

*********************************************************************/



#ifdef __cplusplus

}

#endif



#endif   // BT878API_H



