/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// $Header: /export/raid/cvs_videodev/TrueCap/VideoTuners/Bt848V2_2/Source/Grappler/Tvctl.h,v 1.1 1999/08/27 02:52:36 nradisch Exp $

// $Log: Tvctl.h,v $
// Revision 1.1  1999/08/27 02:52:36  nradisch
// new
//

// Revision 2.3  1997/07/16 18:16:33  rudyl

// Use last 848 release as head rev. Incorporate Gemini changes later.

// Revision 2.1  1996/06/10 20:12:33  ssm

// MarkBeta1AsRev2

// Revision 1.4  1996/05/10 23:15:47  rudyl

// Implement TV_ERR_... return values from Intel. Also added exported function GetTVErrString() to retrieve our specific error msg.

// Revision 1.3  1996/04/28 01:20:13  rudyl

// ver 0.50 - does not instantiate I2C and GPIO objects here. Just make API

// calls to BT848_32.DLL. Also returns error types to caller instead of just TRUE/FALSE result.

// Revision 1.2  1996/04/12 21:01:09  rudyl

// Renamed DLL from 848Tuner.dll to Grappler.dll.

// Revision 1.1  1996/04/12 18:24:44  rudyl

// Initial revision





// CUT_HERE



/////////////////////////////////////////////////////////////////////////////

//

//  Copyright (c) 1996 Brooktree Corporation

//

//  Module:

//

//    TVCtl.h

//

//  Abstract:

//

//    Header file for TV Control

//

/////////////////////////////////////////////////////////////////////////////



/****************************************************************************



        INTEL CORPORATION PROPRIETARY INFORMATION

        Copyright (c) 1996 Intel Corporation

        All Rights Reserved



        This software is supplied under the terms of a license

        agreement or non-disclosure agreement with Intel Corporation

        and may not be copied or disclosed except in accordance

        with the terms of that agreement





****************************************************************************/

#ifndef __TVCTL_H

#define __TVCTL_H

     

//---------------------------------------- 

// Define BUILD_TVCTLDLL if you are building a TV Control DLL.

// Do NOT define BUILD_TVCTLDLL if you are building an Intercast application.

// assume WIN32 is used

//---------------------------------------- 

//#define BUILD_TVCTLDLL



#ifdef _BUILD_TVCTLDLL       // Building TV Control DLL

   #ifdef __BORLANDC__

      #define __TVCTLCLASS __export

      #define __TVCTLFUNC __export __cdecl

   #else // Microsoft

      #define __TVCTLCLASS __declspec(dllexport)

      #define __TVCTLFUNC __declspec(dllexport) __cdecl

   #endif



#else                        // Building Intercast Application

   #ifdef __BORLANDC__

      #define __TVCTLCLASS __import

      #define __TVCTLFUNC __import __cdecl

   #else // Microsoft

      #define __TVCTLCLASS

      #define __TVCTLFUNC __cdecl

   #endif

#endif



//---------------------------------------- 

// Registry Key and Value name definitions

//---------------------------------------- 

#define TV_CTL_REG_SUBKEY "SOFTWARE\\Intel\\Intercast\\TVControl"

#define TV_CTL_REG_VALNAME "TVControlDLL"



//---------------------------------------- 

// TV Parameter definitions

//---------------------------------------- 

#define TV_PARM_SOURCE                0x01       // Signal source (see below)

#define TV_PARM_CHANNEL               0x02       // Television Tuner Channel

#define TV_PARM_BRIGHTNESS            0x03       // Luminance Brightness

#define TV_PARM_CONTRAST              0x04       // Luminance Contrast

#define TV_PARM_HUE                   0x05       // Chrominance Hue Phase Angle

#define TV_PARM_SATURATION            0x06       // Chrominance Saturation



#define TV_PARM_MUTE                  0x10       // Audio Mute

     

     

//----------------------------------------

// TV Source Value definitions

//---------------------------------------- 

#define TV_SOURCE_BASEBAND_COMPOSITE  0x00       // Baseband Composite (typ RCA)

#define TV_SOURCE_BASEBAND_SVIDEO     0x01       // Baseband S/Video (typ DIN)

#define TV_SOURCE_BASEBAND_CAMERA     0x02       // Baseband Camera

#define TV_SOURCE_TUNER_CABLE         0x04       // TV Tuner, Cable Frequencies

#define TV_SOURCE_TUNER_ANTENNA       0x05       // TV Tuner, Antenna Freq's

     

     

//---------------------------------------- 

// TV Control Error Codes

//---------------------------------------- 

#define TV_ERR_SUCCESS                   0       // All is well

#define TV_ERR_GENERIC_ERR              -1       // Fill-all generic error

#define TV_ERR_UNSUPPORTED_PARAM        -2       // Bad or Unsupported Param

#define TV_ERR_BAD_VALUE                -3       // Out of Range Value

#define TV_ERR_NO_CARRIER               -4       // No TV Signal on this Chnl

#define TV_ERR_SOURCE_CANNOT_TUNE       -5       // Chnl Change, Baseband Source

     

#define TV_ERR_VENDOR_BASE            -256       // Begin Vendor Specific Codes

                                                 //   These codes extend down

                                                 //   (more negative) from here



//---------------------------------------- 

// TV Control Interface Function Prototypes 

//---------------------------------------- 

#ifdef __cplusplus

extern "C"

{

#endif

     

LONG  __TVCTLFUNC SetTVParam( ULONG Parameter, ULONG Value ); 

LONG  __TVCTLFUNC GetTVParam( ULONG Parameter );

char* __TVCTLFUNC GetTVErrString( LONG ErrCode );

     

#ifdef __cplusplus

}

#endif

     

#endif // __TVCTL_H

