/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// $Header: /export/raid/cvs_videodev/TrueCap/VideoTuners/Bt848V2_2/Source/Grappler/bt848fcn.h,v 1.1 1999/08/27 02:52:37 nradisch Exp $

// $Header: /export/raid/cvs_videodev/TrueCap/VideoTuners/Bt848V2_2/Source/Grappler/bt848fcn.h,v 1.1 1999/08/27 02:52:37 nradisch Exp $

// $Log: bt848fcn.h,v $
// Revision 1.1  1999/08/27 02:52:37  nradisch
// new
//

// Revision 2.6  1997/07/31 10:46:01  dtharp

// Cleaned up multiple CC_CALLBACK definitions.

// Revision 2.5  1997/05/28 16:37:34  trantq

// Add Bt848ImageLoad & Bt848UnLoadImage Bug ID 431

// Revision 2.4.1.2  1997/05/28 16:15:50  trantq

// Add Bt848ImageLoad & Bt848UnLoadImage Bug ID 431

// Revision 2.4.1.1  1997/04/16 15:57:40  trantq

// Add Bt848ImageLoad & Bt848UnLoadImage Bug ID 431

// Revision 2.4  1997/04/16 15:57:40  rudyl

// Graft from 2.3.1.5:

// Added functions to thunk down to capture driver.

// Revision 2.3.1.5  1997/04/16 15:56:30  rudyl

// No change. Just rearranged functions listing.

// Revision 2.3.1.4  1997/04/15 22:38:40  rudyl

// Removed Initialize() and Disconnect() functions.

// Revision 2.3.1.3  1997/03/26 18:17:43  rudyl

// Added all functions in capture driver available to Bt848_32.dll using thunking.

// Revision 2.3.1.2  1997/03/12 22:56:49  trantq

// - Add SetVideoFormat() and GetVideoFormat().

// Revision 2.3.1.1  1997/03/12 22:34:08  trantq

// - Add SetVideoFormat() and GetVideoFormat().

// Revision 2.3  1997/03/08 00:23:53  trantq

// - Add 32-bit version of SetSVideo() and GetSVideo().

// Revision 2.2  1996/06/11 23:04:00  rudyl

// only changed comment

// Revision 2.1  1996/06/10 20:11:58  ssm

// MarkBeta1AsRev2

// Revision 1.2  1996/06/05 00:27:00  ssm

// added CUT HERE token for awk processing

// Revision 1.1  1996/05/30 19:14:47  rudyl

// Initial revision



/* CUT_HERE */



/////////////////////////////////////////////////////////////////////////////

//

//  Copyright (c) 1996 Brooktree Corporation. All Rights Reserved.

//

//  Module:

//

//    Bt848Fcn.h

//

//  Abstract:

//

//    Header file for functions in BT848 DLL

//

/////////////////////////////////////////////////////////////////////////////



#ifndef __BT848FCN_H

#define __BT848FCN_H



#include "def__.h"      // define __BT848CLASS & __BT848FUNC



#ifndef __WINDOWS_H

#include <windows.h>

#endif



#include "gpiotype.h"

#include "viddefs.h"

#include "retcode.h"



#ifndef __COLFRMAT_H

#include "colfrmat.h"

#endif



#include "common.h"



#ifdef __cplusplus

extern "C"

{

#endif



//---------------------------------------------------------------------------

// Functions communicate with Bt848 VxD directly

//---------------------------------------------------------------------------

ErrorCode __BT848FUNC Bt848PreChannelChange( int channel );

ErrorCode __BT848FUNC Bt848ChannelChanged( int channel );



//---------------------------------------------------------------------------

// Functions thunk down to capture driver

//---------------------------------------------------------------------------

ErrorCode __BT848FUNC Bt848SetVideoSource( Connector conn );

ErrorCode __BT848FUNC Bt848GetVideoSource( Connector * conn );

ErrorCode __BT848FUNC Bt848SetBrightness( int brightness );

ErrorCode __BT848FUNC Bt848GetBrightness( int * brightness );

ErrorCode __BT848FUNC Bt848SetContrast( int contrast );

ErrorCode __BT848FUNC Bt848GetContrast( int * contrast );

ErrorCode __BT848FUNC Bt848SetHue( int hue );

ErrorCode __BT848FUNC Bt848GetHue( int * hue );

ErrorCode __BT848FUNC Bt848SetSaturation( int sat );

ErrorCode __BT848FUNC Bt848GetSaturation( int * sat );

DWORD     __BT848FUNC Bt848GetStatus();

ErrorCode __BT848FUNC Bt848SetSVideo( State s );

ErrorCode __BT848FUNC Bt848GetSVideo( State *s );

ErrorCode __BT848FUNC Bt848SetVideoFormat( VideoFormat vf );

ErrorCode __BT848FUNC Bt848GetVideoFormat( VideoFormat *vf );

void      __BT848FUNC Bt848SetCCCallback( CC_CALLBACK cb );

ErrorCode __BT848FUNC Bt848SetCCStatus( int status );

void      __BT848FUNC Bt848SetCCFileName( LPCSTR name );

void      __BT848FUNC Bt848SetCCAlert( LPCSTR token );

void      __BT848FUNC Bt848GetCCFileName( LPSTR name, int cnt );

void      __BT848FUNC Bt848GetCCAlert( LPSTR token, int cnt );

int       __BT848FUNC Bt848GetCCStatus( void );

ErrorCode __BT848FUNC Bt848SetImage( LPRECT lpRect, ColFmt aFormat );

int       __BT848FUNC Bt848GetImageFormat( ColFmt *pColFrmt );

void      __BT848FUNC Bt848GetImageSize( LPRECT lpR );

void      __BT848FUNC Bt848Pause( void );

void      __BT848FUNC Bt848Continue( void );

DWORD     __BT848FUNC Bt848GetOverlayFlags( void );

ErrorCode __BT848FUNC Bt848ImageLoad( HINSTANCE, HWND, LPCSTR );

ErrorCode __BT848FUNC Bt848UnLoadImage( void );



#ifdef __cplusplus

}

#endif



#endif // __BT848FCN_H

                         

