/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// $Header: /export/raid/cvs_videodev/TrueCap/VideoTuners/Bt848V2_2/Source/Grappler/radioctl.h,v 1.1 1999/08/27 02:52:40 nradisch Exp $

// $Log: radioctl.h,v $
// Revision 1.1  1999/08/27 02:52:40  nradisch
// new
//

// Revision 1.3  1997/07/16 01:22:47  rudyl

// Added member function to get radio signal strength.

// Revision 1.2  1997/07/10 17:32:08  rudyl

// Gemini: Added return error RADIO_ ERR_NO_DEV_HANDLE if audio device handle is null.

// Revision 1.1  1997/07/06 19:53:32  rudyl

// Initial revision



//*****************************************************************************

//*                                                                           *

//*     Header file for Radio control in DLL                                  *

//*                                                                           *

//*     Copyright (C) 1997 Rockwell Semiconductor Systems - San Diego         *

//*                                                                           *

//*     All Rights Reserved                                                   *

//*                                                                           *

//*****************************************************************************





#ifndef __RADIOCTL_H

#define __RADIOCTL_H



#include "tverr.h"



//----------------------------------------

// Define BUILD_RADIOCTLDLL if you are building a Radio Control DLL.

// Do NOT define BUILD_RADIOCTLDLL if you are building an application

// that is using the DLL.

// Assume WIN32 is used

//----------------------------------------



#ifdef _BUILD_RADIOCTLDLL       // Building Radio Control DLL

   #ifdef __BORLANDC__

      #define __RADIOCTLCLASS __export

      #define __RADIOCTLFUNC  __export __cdecl

   #else // Microsoft

      #define __RADIOCTLCLASS __declspec(dllexport)

      #define __RADIOCTLFUNC  __declspec(dllexport) __cdecl

   #endif



#else                        // Building Application

   #ifdef __BORLANDC__

      #define __RADIOCTLCLASS __import

      #define __RADIOCTLFUNC  __import __cdecl

   #else // Microsoft

      #define __RADIOCTLCLASS

      #define __RADIOCTLFUNC  __cdecl

   #endif

#endif



//----------------------------------------

// Radio Parameter definitions

//----------------------------------------

#define RADIO_PARM_AUDIO_HANDLE          0x01       // Set/Get audio dll handle (Bt878.dll)

#define RADIO_PARM_FREQ                  0x02       // Set/Get tuner frequency

#define RADIO_PARM_SIGNAL_STRENGTH       0x03       // Get signal strength



//----------------------------------------

// Radio Control Error Codes

//----------------------------------------

#define RADIO_ERR_SUCCESS                   0       // All is well

#define RADIO_ERR_GENERIC_ERR              -1       // Fill-all generic error

#define RADIO_ERR_UNSUPPORTED_PARAM        -2       // Bad or Unsupported Param

#define RADIO_ERR_BAD_VALUE                -3       // Out of Range Value

#define RADIO_ERR_NO_CARRIER               -4       // No Radio Signal on this freq



#define RADIO_ERR_VENDOR_BASE            -256       // Begin Vendor Specific Codes

#define RADIO_ERR_WRONG_HW               -257       //   These codes extend down

#define RADIO_ERR_I2C_ERROR              -258       //   (more negative) from here



#define RADIO_ERR_NO_DEV_HANDLE          TV_ERR_NO_DEV_HANDLE     // -260

                                                    

//----------------------------------------

// Radio Control Interface Function Prototypes

//----------------------------------------

#ifdef __cplusplus

extern "C"

{

#endif



LONG  __RADIOCTLFUNC SetRadioParam( ULONG Parameter, ULONG Value );

LONG  __RADIOCTLFUNC GetRadioParam( ULONG Parameter );



typedef LONG  (*SetRadioParam_t)( ULONG, ULONG );

typedef ULONG (*GetRadioParam_t)( ULONG );



#ifdef __cplusplus

}

#endif



#endif // __RADIOCTL_H

