/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CGRAPPLERVIDEOTUNER_H_
#define CGRAPPLERVIDEOTUNER_H_


#include "nmr_string.h"
#include "IVideoTuner.h"
#include "grappler/tvctl.h"

#include "grappler/tverr.h"

#include "grappler/tuner.h"

#include "grappler/audio.h"

#include "grappler/bt848api.h"

#include "grappler/bt848fcn.h"


	typedef BOOL __BT848FUNC (*GPIOIsInitOK_Ptr)( void );

	typedef void __BT848FUNC (*SetGPIOMODE_Ptr)( GPIOMode mode );

	typedef ErrorCode __BT848FUNC (*SetGPDATABits_Ptr)( int fromBit, int toBit,DWORD value, int offset = 0 );

	typedef ErrorCode __BT848FUNC (*GetGPDATABits_Ptr)( int fromBit, int toBit,DWORD * value, int offset = 0 );

	typedef void      __BT848FUNC (*SetGPIE_Ptr)( DWORD value );

	typedef void      __BT848FUNC (*SetGPOE_Ptr)( DWORD value );

	typedef ErrorCode __BT848FUNC (*SetCCStatus_Ptr) (int status);

	typedef int		  __BT848FUNC (*GetCCStatus_Ptr) (void);



class CGrapplerVideoTuner: public IVideoTuner
{
private:
	int			mInvertAudio;



	SetGPIE_Ptr			mSetGPIE;

	SetGPOE_Ptr			mSetGPOE;

	GPIOIsInitOK_Ptr	mGPIOIsInitOK;

	SetGPIOMODE_Ptr		mSetGPIOMODE;

	SetGPDATABits_Ptr	mSetGPDATABits;

	GetGPDATABits_Ptr	mGetGPDATABits;

	SetCCStatus_Ptr		mSetCCStatus;

	GetCCStatus_Ptr		mGetCCStatus;



	HINSTANCE			mBT848;



	HINSTANCE	mGrappler;
	bool		mHauppauge;

	nmr_string	mAppString;


	int			SetTVParam(unsigned parameter,unsigned value);
	int			GetTVParam(unsigned parameter);
	void		ErrorCheck(long res);

	int				GetSourceCode(VideoSource_t source);
	VideoSource_t	ConvertSourceCode(int code);
	void			SetupAudioInversion(void);



	LONG __GetAudioSource ( void );

	LONG __SetAudioSource ( ULONG audio );

	void	InvertAudio(void);

	ErrorCode _SetCCStatus(int status);

	int		  _GetCCStatus(void);


	Channel_t		mLastChannel;

	VideoSource_t	mLastSource;

	U8				mLastBrightness,mLastContrast,mLastHue,mLastSaturation;

public:
	CGrapplerVideoTuner(const char *appstring);
	virtual ~CGrapplerVideoTuner(void);

	virtual	void	SetVideoSource(VideoSource_t source);
	virtual	void	SetChannel(Channel_t channel);
	virtual	void	SetBrightness(U8 brightness);
	virtual	void	SetContrast(U8 contrast);
	virtual	void	SetHue(U8 hue);
	virtual	void	SetSaturation(U8 saturation);

	virtual	VideoSource_t	GetVideoSource(void);
	virtual	Channel_t		GetChannel(void);
	virtual	U8				GetBrightness(void);
	virtual	U8				GetContrast(void);
	virtual	U8				GetHue(void);
	virtual	U8				GetSaturation(void);

	virtual	void	SaveSettings(const char *appstring);
	virtual	void	LoadSettings(const char *appstring);

	virtual	void	SetAudioMute(bool mute);
	virtual	bool	GetAudioMute(void);

	virtual	ChannelList_t	GetChannelsWithSignal(VideoSource_t source,

								IScanProgressFeedback &feedback);
	virtual	ChannelList_t	GetChannelsWithSignal(IScanProgressFeedback &feedback);



	virtual	bool	GetAudioInversion(void);

	virtual	void	SetAudioInversion(bool i);

	virtual bool	HasCC(void);

	virtual	void	SetCC(int cc,int channel);

};


#endif
