/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CHAUPPAUGENTVIDEOTUNER_H_
#define CHAUPPAUGENTVIDEOTUNER_H_

#include "IVideoTuner.h"
#include "hcwav.h"




class CHauppaugeNTVideoTuner: public IVideoTuner
{

	typedef AVHdl (WINAPI *InitFunc_t)(WORD ,DWORD,WORD,DWORD);

	typedef DWORD (WINAPI *FreeFunc_t)(AVHdl hdl);

	typedef DWORD (WINAPI *GetFunc_t)(DWORD,AVFunction,PVOID);

	typedef DWORD (WINAPI *SetFunc_t)(DWORD,AVFunction,PVOID);



	HINSTANCE			mDll;

	AVHdl				mAV;

	InitFunc_t			mInitFunc;

	FreeFunc_t			mFreeFunc;

	GetFunc_t			mGetFunc;

	SetFunc_t			mSetFunc;



	Channel_t		mLastChannel;

	VideoSource_t	mLastSource;

	U8				mLastBrightness,mLastContrast,mLastHue,mLastSaturation;

	AVInputSource	mCompositeIndex,mTunerIndex,mSVideoIndex;



	void	_Cleanup(void);

	void	_InitCard(void);

	AVError	_SetChannel(Channel_t channel,VideoSource_t source);


public:

			CHauppaugeNTVideoTuner(const char *appstring);
	virtual ~CHauppaugeNTVideoTuner(void);

	virtual	void	SetVideoSource(VideoSource_t source);
	virtual	void	SetChannel(Channel_t channel);
	virtual	void	SetBrightness(U8 brightness);
	virtual	void	SetContrast(U8 contrast);
	virtual	void	SetHue(U8 hue);
	virtual	void	SetSaturation(U8 saturation);

	virtual	VideoSource_t	GetVideoSource(void);
	virtual	Channel_t		GetChannel(void);
	virtual	U8				GetBrightness(void);
	virtual	U8				GetContrast(void);
	virtual	U8				GetHue(void);
	virtual	U8				GetSaturation(void);

	virtual	void	SetAudioMute(bool mute);
	virtual	bool	GetAudioMute(void);

	virtual	void	SaveSettings(const char *appstring);
	virtual	void	LoadSettings(const char *appstring);

	virtual	ChannelList_t	GetChannelsWithSignal(VideoSource_t source,
								IScanProgressFeedback &feedback);
	virtual	ChannelList_t	GetChannelsWithSignal(
								IScanProgressFeedback &feedback);

	virtual	bool	GetAudioInversion(void);
	virtual	void	SetAudioInversion(bool i);
	virtual bool	HasCC(void);
	virtual	void	SetCC(int cc,int channel);

};


#endif
