/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*******************************************************************************

*                                                          

*       HH  HH     CCCC  WW           WW                     N U C C I O          

*       HH  HH   CCCCCC  WW           WW                                     

*       HH  HH  CCC      WW           WW                             A          

*       HHHHHH  CCC       WW   WWW   WW                          C            

*       HH  HH  CCC       WW  WW WW  WW                        W O R K S            

*       HH  HH   CCCCCC    WWWW   WWWW             R             M              

*       HH  HH     CCCC     WW     WW              O     H A U P P A U G E             

*                                                  D       U     U                      

*       Copyright (C) 1994-1995                    R       P L O T K I N   Y             

*       Hauppauge Computer Works, Inc      V T / N I W     P     E                      

*       91 Cabot Court                             G   N I E T S R E P A S              

*       Hauppauge, NY  11788                       U       R                              

*       516 / 434-1600                             E       L                                

*                                              O I Z I R B E F                 

*                                                                        

*******************************************************************************/

                                                                         

/*******************************************************************************

 

 hcwHWHdl.h



 HCW Hardware/Board Handle "hcwHW_" API



*******************************************************************************/





#ifndef HCW_HCWHWHDL_H

#define HCW_HCWHWHDL_H



#ifdef WDM

	#include "hcwWDM.h"

#else

	#include <Windows.h>

#endif



#ifdef __cplusplus

	extern "C" {

#endif





/*	BoardType */

#define	hcwHW_BT_UNDEFINED							0x0000

#define hcwHW_BT_CinemaPro							0x0006

#define hcwHW_BT_ComboCast							0x0009

#define hcwHW_BT_WinCast							0x000A

#define hcwHW_BT_WinTVPCI							0x000A

#define hcwHW_BT_VCB_EE								0x000B //detected as a WinCast

#define hcwHW_BT_TunerCard							0x000C

#define hcwHW_BT_Eurocast							0x000D //detected as a WinCast

#define hcwHW_BT_TunerCardIntel						0x000E

#define hcwHW_BT_TunerCardIntelVIRTUALViaWinCast	0x000F

#define hcwHW_BT_VCB_NoEE							0x0010

#define hcwHW_BT_MAXBT								16







/*  BoardType Classes */

#define hcwHW_BT_CLASS_UNDEFINED	0x8000

#define hcwHW_BT_CLASS_TVCard 		0x8001

#define hcwHW_BT_CLASS_TunerCard 	0x8002

#define hcwHW_BT_CLASS_Brooktree8xx	0x8003

#define hcwHW_BT_MAXBTCLASS			3



	

/*	GetType */

#define hcwHW_GET_UNDEFINED	0x0000

#define hcwHW_GET_FIRST		0x8100

#define hcwHW_GET_NEW		0x8200

#define hcwHW_GET_AVAILABLE	0x8300



/*	Flags */

#define hcwHW_FLAGS_NONE	0x0000



/* Feature Specification */

#define hcwHW_FEATURE_NONE				0x0000

#define hcwHW_FEATURE_UNSPECIFIED		hcwHW_FEATURE_NONE

#define hcwHW_FEATURE_RADIO				0x0001

	



/* Serial Number Specification */

#define hcwHW_SERIALNO_UNSPECIFIED	0x00

	



/*	hcwHW_PrepHdl parms */

#define hcwHW_PREP_BT		0x01

#define hcwHW_PREP_FEATURE	0x02

#define hcwHW_PREP_SERIALNO	0x03





/*	hcwHW_QueryHdl parms */

#define hcwHW_QUERY_VALIDHDL	0x00

#define hcwHW_QUERY_BT			0x01

#define hcwHW_QUERY_FEATURE		0x02

#define hcwHW_QUERY_PNP			0x03

#define hcwHW_QUERY_I2C			0x04

#define hcwHW_QUERY_SERIALNO	0x05

#define hcwHW_QUERY_AUDIO		0x06



typedef DWORD hcwHW_Hdl;

typedef DWORD hcwAudioHdl;

typedef DWORD hcwAVHdl;

typedef DWORD hcwTunerHdl;

typedef DWORD hcwGPIO_Hdl;



typedef enum {	hcwHW_SUCCESS,

				hcwHW_FAILURE,

				hcwHW_FAILURE_INVALID_HDL,

				hcwHW_FAILURE_INVALID_PREPTYPE,

				hcwHW_FAILURE_INVALID_BT,

				hcwHW_FAILURE_INVALID_GETTYPE,

				hcwHW_FAILURE_PNP_INIT,

				hcwHW_FAILURE_INVALID_QUERY,

				hcwHW_FAILURE_NO_FEATURE_RADIO,

				hcwHW_FAILURE_INVALID_OPERATION,

				hcwHW_FAILURE_EXIST_BUT_BUSY,

				hcwHW_FAILURE_EXCLUDED_FROM_SCAN } hcwHWResult;



typedef enum {	hcwHW_STATE_Virgin,

				hcwHW_STATE_InPrep,

				hcwHW_STATE_Valid } hcwHWState;



#ifndef WDM



/*

** Prototypes

*/

int WINAPI hcwHW_UpdateHWList( void );

hcwHW_Hdl WINAPI hcwHW_NewHdl( void );

hcwHWResult WINAPI hcwHW_FreeHdl( hcwHW_Hdl theHdl );

hcwHWResult WINAPI hcwHW_FreeHdlRemove( hcwHW_Hdl theHdl );

hcwHWResult WINAPI hcwHW_PrepHdl( hcwHW_Hdl theHdl, WORD wPrepType, DWORD dPrepParm );

hcwHWResult WINAPI hcwHW_GetHdl( hcwHW_Hdl FAR *theHdl, WORD wGetType );

DWORD WINAPI hcwHW_QueryHdl( hcwHW_Hdl theHdl, WORD wQuery );

hcwHWResult WINAPI hcwHW_InitByDetail( hcwHW_Hdl FAR *theHWHdl, WORD wBoardType, DWORD dFeatures, WORD wGetType, LPVOID pMisc );



typedef int			(WINAPI *TYPEhcwHW_UpdateHWList)	( void );

typedef hcwHW_Hdl	(WINAPI *TYPEhcwHW_NewHdl)			( void );

typedef hcwHWResult	(WINAPI *TYPEhcwHW_FreeHdl)			( hcwHW_Hdl theHdl );

typedef hcwHWResult	(WINAPI *TYPEhcwHW_FreeHdlRemove)	( hcwHW_Hdl theHdl );

typedef hcwHWResult	(WINAPI *TYPEhcwHW_PrepHdl)			( hcwHW_Hdl theHdl, WORD wPrepType, DWORD dPrepParm );

typedef hcwHWResult	(WINAPI *TYPEhcwHW_GetHdl)			( hcwHW_Hdl FAR *theHdl, WORD wGetType );

typedef DWORD		(WINAPI *TYPEhcwHW_QueryHdl)		( hcwHW_Hdl theHdl, WORD wQuery );

typedef hcwHWResult (WINAPI *TYPEhcwHW_InitByDetail)	( hcwHW_Hdl FAR *theHWHdl, WORD wBoardType, DWORD dFeatures, WORD wGetType, LPVOID pMisc );



#endif //ifndef WDM





#ifdef __cplusplus

	} //extern "C" {

#endif





#endif //HCW_HCWHWHDL_H

