/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/****************************************************************************

     

        INTEL CORPORATION PROPRIETARY INFORMATION 

     

        Copyright (c) 1996 Intel Corporation 

        All Rights Reserved



        You may copy or distribute this header file in source or binary form,

	royalty free, provided you agree to comply with the following terms

	and conditions.  YOU MAY NOT COPY OR DISTRIBUTE THIS HEADER FILE IF 

	YOU DO NOT AGREE TO COMPLY WITH ALL OF THESE TERMS AND CONDITIONS.



       (i)  this copyright notice and this copyright license appear in 

            all source code copies, and 



       (ii) this header file remains unmodifed.  



       No other rights or licenses are granted.  The Intel name or other 

       trademarks may not be used to endorse or promote products using this 

       header file without Intel's prior written permission. 



       THIS HEADER FILE IS PROVIDED "AS IS" WITH NO WARRANTIES WHATSOEVER, 

       INCLUDING ANY WARRANTY OF MERCHANTABILITY, NONINFRINGEMENT, OR FITNESS 

       FOR ANY PARTICULAR PURPOSE. Intel disclaims all liability, including

       liability for infringement of any proprietary rights, relating to use 

       of this header file. 



   

****************************************************************************/

     

#ifndef __TVCTL_H

#define __TVCTL_H

     

//---------------------------------------- 

// Define BUILD_TVCTLDLL if you are building a TV Control DLL.

// Do NOT define BUILD_TVCTLDLL if you are building an Intercast application.

// assume WIN32 is used

//---------------------------------------- 

#define BUILD_TVCTLDLL



#ifdef _BUILD_TVCTLDLL       // Building TV Control DLL

   #ifdef __BORLANDC__

      #define __TVCTLCLASS __export

      #define __TVCTLFUNC __export __cdecl

   #else // Microsoft

      #define __TVCTLCLASS __declspec(dllexport)

      #define __TVCTLFUNC __declspec(dllexport) __cdecl

   #endif



#else                        // Building Intercast Application

   #ifdef __BORLANDC__

      #define __TVCTLCLASS __import

      #define __TVCTLFUNC __import __cdecl

   #else // Microsoft

      #define __TVCTLCLASS

      #define __TVCTLFUNC __cdecl

   #endif

#endif

     

//---------------------------------------- 

// Registry Key and Value name definitions

//---------------------------------------- 

#define TV_CTL_REG_SUBKEY "SOFTWARE\\Intel\\Intercast\\TVControl"

#define TV_CTL_REG_VALNAME "TVControlDLL"



//---------------------------------------- 

// TV Parameter definitions

//---------------------------------------- 

#define TV_PARM_SOURCE                0x01       // Signal source (see below)

#define TV_PARM_CHANNEL               0x02       // Television Tuner Channel

#define TV_PARM_BRIGHTNESS            0x03       // Luminance Brightness

#define TV_PARM_CONTRAST              0x04       // Luminance Contrast

#define TV_PARM_HUE                   0x05       // Chrominance Hue Phase Angle

#define TV_PARM_SATURATION            0x06       // Chrominance Saturation



#define TV_PARM_MUTE                  0x10       // Audio Mute

     

     

//---------------------------------------- 

// TV Source Value definitions

//---------------------------------------- 

#define TV_SOURCE_BASEBAND_COMPOSITE  0x00       // Baseband Composite (typ RCA)

#define TV_SOURCE_BASEBAND_SVIDEO     0x01       // Baseband S/Video (typ DIN)

#define TV_SOURCE_BASEBAND_CAMERA     0x02       // Baseband Camera

#define TV_SOURCE_TUNER_CABLE         0x04       // TV Tuner, Cable Frequencies

#define TV_SOURCE_TUNER_ANTENNA       0x05       // TV Tuner, Antenna Freq's

     

     

//---------------------------------------- 

// TV Control Error Codes

//---------------------------------------- 

#define TV_ERR_SUCCESS                   0       // All is well

#define TV_ERR_GENERIC_ERR              -1       // Fill-all generic error

#define TV_ERR_UNSUPPORTED_PARAM        -2       // Bad or Unsupported Param

#define TV_ERR_BAD_VALUE                -3       // Out of Range Value

#define TV_ERR_NO_CARRIER               -4       // No TV Signal on this Chnl

#define TV_ERR_SOURCE_CANNOT_TUNE       -5       // Chnl Change, Baseband Source

     

#define TV_ERR_VENDOR_BASE            -256       // Begin Vendor Specific Codes

                                                 //   These codes extend down

                                                 //   (more negative) from here



//---------------------------------------- 

// TV Control Interface Function Prototypes 

//---------------------------------------- 

#ifdef __cplusplus

extern "C"

{

#endif

     

LONG  __TVCTLFUNC SetTVParam( ULONG Parameter, ULONG Value ); 

LONG  __TVCTLFUNC GetTVParam( ULONG Parameter );

char* __TVCTLFUNC GetTVErrString( LONG ErrCode );

     

#ifdef __cplusplus

}

#endif

     

#endif // __TVCTL_H

