/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include	"CDuckAudioDest.h"
#include	"CDuckAudioSrc.h"
#include	"CDuckAudioStream.h"
#include	"CDuckData.h"
#include	"CDuckBuffer.h"

#include	<CAudioInfo.h>
#include "danbug.h"

CDuckAudioDest::CDuckAudioDest(void)
{
}

CDuckAudioDest::~CDuckAudioDest(void)
{
}

int
CDuckAudioDest::DataPosToBytes(int data_pos,CDuckAudioStream &stream)
{
	CAudioInfo i;
 dprintf("==about to call ExtractFromStream\n");
	i.ExtractFromStream(stream.Native(),stream.Native(),1);
 dprintf("==ExtractFromStream done\n");
	return i.DataPosToBytes(data_pos);
}

int	
CDuckAudioDest::Resync(CDuckBuffer &buffer,CDuckAudioSrc &src,
							CDuckAudioStream &stream,
							CDuckData &data,int frame,float frame_rate)
{
	int	total_consumed = 0;
											dprintf("==CDuckAudioDest::Resync -- mDataLen=%d\n",data.GetRawDataLength());
											dprintf(">>>frame=%d, mSrcFreq=%d, frame_rate .000=%d",frame,mSrcFreq,(int)(frame_rate*1000) );

	double skipAudio_d =(double) (( ((double) frame) * ((double)mSrcFreq)) / frame_rate);
											///	skipAudio_d = # of samples to seek to
										    dprintf(">>>skipAudio_d = %d",(int)skipAudio_d);
	int data_pos = stream.GetDataPosition(-1);
											///	data_pos = sample count quantized to chunk length
										    dprintf(">>>data_pos = %d",data_pos);
	long skipAudio = (long)(skipAudio_d - data_pos);
											///	skipAudio = remainder -- samples into present chunk
										    dprintf(">>>skipAudio = %d",skipAudio);
	if (skipAudio < 0) skipAudio = 0;
	src.Clear();
										    dprintf("==      before           -- mDataLen=%d\n",data.GetRawDataLength());
	data.GetStreamingData(stream,DUK_FORWARD,1);
										    dprintf("==      after            -- mDataLen=%d\n",data.GetRawDataLength());
	if (data != CDuckData::Ok) return total_consumed;				///	tricky, Neil! overloaded == and != ops (see CDuckData.h)
	total_consumed += DataPosToBytes(data_pos,stream) + data.GetRawDataLength();
										    dprintf(">>>total_consumed = %d\n",total_consumed);
										    dprintf("==CDuckAudioDest::Resync A -- mDataLen=%d\n",data.GetRawDataLength());
											dprintf("==ok, could be,\n");
	src.Feed(data);
											dprintf("==ok, here\n");
	while (skipAudio)
		{
										    dprintf("==CDuckAudioDest::Resync; about to call src.CanProduce -- mDataLen=%d\n",data.GetRawDataLength());
		long amt = src.CanProduce();
										    dprintf("==CDuckAudioDest::Resync; skipAudio=%d; src.CanProduce returns %d\n",skipAudio,amt);
										    dprintf("==                       -- mDataLen=%d\n",data.GetRawDataLength());
		if (skipAudio < amt)
			amt = skipAudio;
										    dprintf("==CDuckAudioDest::Resync; about to call src.Skip\n");
		skipAudio -= src.Skip((unsigned long)amt);
		if (skipAudio && src.ReadyForMore())
			{
			data.ReleaseStreamingData(buffer);
			data.GetStreamingData(stream,DUK_FORWARD,1);
			if (data != CDuckData::Ok) return total_consumed;
										    dprintf("==CDuckAudioDest::Resync B5\n");
			total_consumed += data.GetRawDataLength();
			src.Feed(data);
			}
		}
	int	gotdata = 1;
	while (ReadyForMore())
		{
		if (src.ReadyForMore())
			{	
			if (gotdata)
				data.ReleaseStreamingData(buffer);
			data.GetStreamingData(stream,DUK_FORWARD,1);
			gotdata = 1;
			if (data == CDuckData::Ok)
				{
				total_consumed += data.GetRawDataLength();
				src.Feed(data);
				}
			else
				{
				break;
				}
			}
		Feed(src);
		}
	return total_consumed;
}


int	
CDuckAudioDest::Preload(CDuckBuffer &buffer,CDuckAudioSrc &src,
						CDuckAudioStream &stream,CDuckData &data)
{

	int	gotdata = 0;
	int	total_consumed = 0;

	while (ReadyForMore())
		{
		if (src.ReadyForMore())
			{	
			if (gotdata)
				data.ReleaseStreamingData(buffer);
			data.GetStreamingData(stream,DUK_FORWARD,1);
			gotdata = 1;
			if (data == CDuckData::Ok)
				{
				total_consumed += data.GetRawDataLength();
				src.Feed(data);
				}
			else
				{
				break;
				}
			}

		Feed(src);
		}

	return total_consumed;
}
