/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CDUCKAUDIODEST_H_
#define CDUCKAUDIODEST_H_


class CDuckAudioSrc;
class CDuckAudioStream;
class CDuckData;
class CDuckBuffer;

class CDuckAudioDest
{
protected:

	CDuckAudioDest(void);
	int	mSrcFreq;

public:

	virtual ~CDuckAudioDest(void);
	virtual int		GetFrequency(void) = 0;
	virtual	int		ReadyForMore(void) =0;
	virtual	void	Feed(CDuckAudioSrc &src) =0;
	virtual	void	FeedSilence(CDuckAudioSrc &src) =0;
	virtual	int		Preload(CDuckBuffer &buffer,CDuckAudioSrc &src,
							CDuckAudioStream &stream,CDuckData &data);
	virtual int		Resync(CDuckBuffer &buffer,CDuckAudioSrc &src,
							CDuckAudioStream &stream,
							CDuckData &data,int frame,float frame_rate);
	virtual	int		DataPosToBytes(int data_pos,CDuckAudioStream &stream);

	virtual	void	StartPlaying(void) = 0;
	virtual	void	StopPlaying(void) = 0;
	virtual	int		ElapsedAudioTime(void) = 0;
	virtual int		AudioSkipped(void) = 0;

	class InitException {};
	class AudioFormatException {};
};


#endif
