/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CDUCKAUDIODESTDIRECT_H_
#define CDUCKAUDIODESTDIRECT_H_

#ifdef	WIN32

#ifdef	_AFXDLL
#define VC_EXTRALEAN
#include <afxwin.h>
#else
#include <windows.h>
#endif

#include	 "CDuckAudioDest.h"
#include	"CDuckAudioSrcDirect.h"

#include	<mmsystem.h>
#include	<dsound.h>

class CDuckAudioDestDirect: public CDuckAudioDest
{
protected:

		LPDIRECTSOUND	mDirectSound;
		LPDIRECTSOUNDBUFFER	mAudioBuffer;
		LPDIRECTSOUNDBUFFER mAudioPrimary;
		int	mLastWriteIndex;
		int mBufferSize;
		_int64 mBytesConsumed;
		int mBlockAlign;
		int mSamplesPerSec;

public:

	CDuckAudioDestDirect(DKWAVEFORM *wave,int NumChannels,
					int SamplesPerSec,int BytesPerSec,int Format,
					HWND window);

	virtual ~CDuckAudioDestDirect(void);
	virtual int		GetFrequency(void);
	virtual	int		ReadyForMore(void);
	virtual	void	Feed(CDuckAudioSrc &src);
	virtual	void	FeedSilence(CDuckAudioSrc &src);

	virtual	void	StartPlaying(void);
	virtual	void	StopPlaying(void);
	virtual	int		ElapsedAudioTime(void);
	virtual int		AudioSkipped(void);

	
};

#endif
#endif
