/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CDUCKAUDIODESTSGI_H_
#define CDUCKAUDIODESTSGI_H_

#ifdef	IRIX

#include	"CDuckAudioDest.h"
#include	<duck_wav.h>
#include	<audio.h>

class CDuckAudioDestSGI : public CDuckAudioDest
{
protected:
	int mBytesPerSample;
	int mBytesConsumed;
	int mNumChannels;
	ALconfig	mAudioConfig;
	ALport		mAudioPort;	

public:
	CDuckAudioDestSGI(DKWAVEFORM *wave,int NumChannels,
					int SamplesPerSec,int BytesPerSec,int Format);
	virtual ~CDuckAudioDestSGI(void);

	virtual int		GetFrequency(void);
	virtual	int		ReadyForMore(void);
	virtual	void	Feed(CDuckAudioSrc &src);
	virtual	void	FeedSilence(CDuckAudioSrc &src);
	virtual	void	StartPlaying(void); 
	virtual	void	StopPlaying(void); 
	virtual	int		ElapsedAudioTime(void);
	virtual int		AudioSkipped(void); 

};



#endif

#endif
