/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CDUCKAUDIODESTSUN_H_
#define CDUCKAUDIODESTSUN_H_

#ifdef	SOLARIS

#include	"CDuckAudioDest.h"
#include	<duck_wav.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <sys/stat.h>
#include <sys/audioio.h>
#include <fcntl.h>

class CDuckAudioDestSUN : public CDuckAudioDest
{
protected:
	int mReadyForMore;
	int mBytesPerSample;
	int mBytesConsumed;
	int mNumChannels;
	int 			mAudioDevice;
	audio_info_t	mAudioInfo;
	int				mAudioTimeMultiplier;
	int				mAudioAccumulator;

public:
	CDuckAudioDestSUN(DKWAVEFORM *wave,int NumChannels,
					int SamplesPerSec,int BytesPerSec,int Format);
	virtual ~CDuckAudioDestSUN(void);

	virtual int		GetFrequency(void);
	virtual	int		ReadyForMore(void);
	virtual	void	Feed(CDuckAudioSrc &src);
	virtual	void	FeedSilence(CDuckAudioSrc &src);
	virtual	void	StartPlaying(void); 
	virtual	void	StopPlaying(void); 
	virtual	int		ElapsedAudioTime(void);
	virtual int		AudioSkipped(void); 

	class IOException {};
};



#endif

#endif
