/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CDUCKAUDIOSRCDIRECT_H_
#define CDUCKAUDIOSRCDIRECT_H_

#ifdef	WIN32

#ifdef	_AFXDLL
#define VC_EXTRALEAN
#include <afxwin.h>
#else
#include <windows.h>
#endif

#include	<duck_wav.h>

#include	"CDuckAudioSrc.h"
#include	"CDuckAudioDestDirect.h"

#ifndef	NDEBUG
// This wont work until HFB carries the extra WAVEFORMAT information
// Right not the extra (unless it's duck) gets chopped off
#endif

#define	USE_ACM

#ifdef	USE_ACM
#include	<mmreg.h>
#include	<msacm.h>
#endif


#ifdef	USE_VOXWARE
#define VOXWARE_WIN32
#define VOXWARE_KLUDGE	// until they fix the API
#include	<voxwareDLL.h>
#endif


#define USE_DUCK

#ifdef USE_DUCK
#include	<duck_dxl.h>
#endif


class CDuckAudioSrcDirect: public CDuckAudioSrc
{
protected:
		const char *mInputDataPtr;
		int	mInputDataLeft;
		char *mDecompressBuffer;
		int mBitsPerSample;
		int mBlockAlign;
		int mSamplesPerSec;
		int mFirstAudioChunk;
		HWND	mWindow;

		// duck compression
#ifdef	USE_DUCK
		DXL_AUDIODST_HANDLE		mDuckAudioDest;
		DXL_XAUDIOSRC_HANDLE	mDuckAudioSrc;
		DKWAVEFORM				mDuckWaveform;
		int						mUseDuckware;
		void	InitializeDuckware(const char *first_data_chunk,int len,
			DKWAVEFORM *wave,int num_channels,int samples_per_sec);
		void	CleanupDuckware(void);
		void	DuckwareDecompress(const char *data,int len);
#endif

#ifdef	USE_VOXWARE
		VOXWARE_DATA	mVoxwareData;
		int				mUseVoxware;

		int				mVoxwareUp;

		void InitializeVoxware(const char *first_data_chunk,int len);
		void CleanupVoxware(void);
		void VoxwareDecompress(const char *data,int len);
#endif

#ifdef	USE_ACM
		HACMSTREAM		mAcmStream;	
		ACMSTREAMHEADER	mAcmStreamHeader;
		int				mUseAcm;

		void	InitializeAcm(const char *first_data_chunk,int len,
						DKWAVEFORM *wave,int num_channels,int samples_per_sec,
						HWND window);
		void	CleanupAcm(void);
		void	AcmDecompress(const char *data,int len);
#endif

public:

	CDuckAudioSrcDirect(DKWAVEFORM *wave,int NumChannels,
					int SamplesPerSec,int BytesPerSec,int Format,
					CDuckAudioDest &dest,HWND window);
	~CDuckAudioSrcDirect(void);
	void	Feed(CDuckData &data);
	int		ReadyForMore(void);
	void	Clear(void) ;
	int		CanProduce(void);
	unsigned long Skip(unsigned long samples);

	const char *GetDataPtr(void);
	int			GetDataLeft(void);
	void		DecreaseDataPtr(int howmuch);


};


#endif
#endif
