/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CDUCKAUDIOSRCMAC_H_
#define	CDUCKAUDIOSRCMAC_H_

#ifdef	__POWERPC__

//////////////////////////
/////////////////////////


#ifdef	USE_VOXWARE
#define VOXWARE_MAC
#define VOXWARE_KLUDGE	// until they fix the API
#include	<toolvox.h>
#endif
/////////////////////////////
///////////////////////////

#include	"duck_hfb.h"
#include	"audio.h"
#include	"CDuckAudioSrc.h"

class CDuckAudioDest;
class CDuckAudioDestMAC;

class CDuckAudioSrcMAC: public CDuckAudioSrc
{
	audioBlockFactory *mAviFact;
	audio::Freq		mSrcFreq; // used by FillAudio to pad avi files.

#ifdef	USE_VOXWARE
		VOXWARE_DATA	mVoxwareData;
		int				mUseVoxware;
		int				mGotFirstDataChunk;
		char			*mDecompressBuffer;

		void InitializeVoxware(const char *first_data_chunk,int len);
		void CleanupVoxware(void);
		void VoxwareDecompress(const char *data,int len);

#ifdef	DEBUG_VOXWARE
		BOOL  mTraceFileInitialized;
		CFile mTraceFile;											// Voxware
																// Voxware
																// Voxware
		BOOL  TraceBuffer(const char* data, int len);				// Voxware
#endif
#endif

public:
	CDuckAudioSrcMAC(DKWAVEFORM *wave,int NumChannels,
		int SamplesPerSec,int BytesPerSec,int Format,
		CDuckAudioDest &dest);
	virtual ~CDuckAudioSrcMAC(void);

	virtual void	Feed(CDuckData &data);
	virtual int		ReadyForMore(void);
	virtual void	Clear(void); 
	virtual	unsigned long Skip(unsigned long samples);
	virtual int		CanProduce(void);

protected:
	audioBlockFactory	*Native(void);

	friend CDuckAudioDestMAC;

};

#endif
#endif
