/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CDUCKAUDIOSRCUNIX_H_
#define CDUCKAUDIOSRCUNIX_H_

#if ((defined IRIX) || (defined SOLARIS) || (defined LINUX))


#include	<duck_wav.h>

#include	"CDuckAudioSrc.h"
#include	"CDuckAudioDest.h"

#define USE_DUCK

#ifdef USE_DUCK
#include	<duck_dxl.h>
#endif
#ifdef USE_VOXWARE
#ifdef IRIX
#define VOXWARE_SGI
#endif
#ifdef SOLARIS
#define VOXWARE_SUN
#endif
#ifdef LINUX
#ifndef VOXWARE_LINUX
#define VOXWARE_LINUX
#endif
#endif
#define VOXWARE_UNIX
#define VOXWARE_KLUDGE
#define TRUE 1
#define FALSE 0
#include <toolvox.h>
#endif

class CDuckAudioSrcUnix: public CDuckAudioSrc
{
protected:
		const char *mInputDataPtr;
		int	mInputDataLeft;
		char *mDecompressBuffer;
		int mBitsPerSample;
		int mBlockAlign;
		int mSamplesPerSec;
		int mFirstAudioChunk;

		// duck compression
#ifdef	USE_DUCK
		DXL_AUDIODST_HANDLE		mDuckAudioDest;
		DXL_XAUDIOSRC_HANDLE	mDuckAudioSrc;
		DKWAVEFORM				mDuckWaveform;
		int						mUseDuckware;
		void	InitializeDuckware(const char *first_data_chunk,int len,
			DKWAVEFORM *wave,int num_channels,int samples_per_sec);
		void	CleanupDuckware(void);
		void	DuckwareDecompress(const char *data,int len);
#endif
#ifdef	USE_VOXWARE
		VOXWARE_DATA	mVoxwareData;
		int				mUseVoxware;

		void InitializeVoxware(const char *first_data_chunk,int len);
		void CleanupVoxware(void);
		void VoxwareDecompress(const char *data,int len);
#endif


public:

	CDuckAudioSrcUnix(DKWAVEFORM *wave,int NumChannels,
					int SamplesPerSec,int BytesPerSec,int Format,
					CDuckAudioDest &dest);
	~CDuckAudioSrcUnix(void);
	void	Feed(CDuckData &data);
	int		ReadyForMore(void);
	void	Clear(void) ;
	int		CanProduce(void);
	unsigned long Skip(unsigned long samples);

	const char *GetDataPtr(void);
	int			GetDataLeft(void);
	void		DecreaseDataPtr(int howmuch);


};


#endif
#endif
