/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CDUCKBASEPLAYER_H_
#define CDUCKBASEPLAYER_H_

#include	<MegaHeaders.h>
#include	<nmr_fraction.h>

class CDuckAudioDest;
class CDuckAudioSrc;
class CDuckAudioStream;
class CDuckData;
class CDuckFile;
class CDuckBuffer;
class CDuckVideoStream;
class CDuckImage;
class CDuckScreen;
class CAviCapture;


class CDuckBasePlayer
{
protected:

	unsigned char*		mStaticVideoBuffer;
	int				mRetainScreenObject;
#ifdef NETHFB
	CAviCapture		*mAVICapture;
#endif
	CDuckAudioSrc	 *mAudioSrc;
	CDuckAudioDest	 *mAudioDest;
	CDuckData		 *mAudioData;
	CDuckAudioStream *mAudioStream;
	CDuckFile			*mFile;
	CDuckBuffer			*mBuffer;
	CDuckVideoStream	*mVideoStream;
	CDuckData			*mVideoData;
	CDuckImage			*mImage;
	CDuckScreen			*mScreen;

	int				mCapturing;
	int				mFirstCaptureFrame;
	long			mAudioBytesProcessed;
	nmr_fraction<I32>	mFramesPerSecond;
	float				mFPSfloat;


	CDuckBasePlayer(void);
	virtual ~CDuckBasePlayer(void);

	void	RetainScreenObject(int retain);

	//////////////// AUDIO STUFF
	virtual void		LoadAudio(int ignore_data = 0);
	virtual void		CalculateFirstCaptureFrame(void);
	virtual	void		Cleanup(void);
	virtual	void		AudioChunkReleased(void);
public:
	virtual	int		IsCapturing(void);

};



#endif
