/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "CDuckBuffer.h"
#include "CDuckFile.h"


CDuckBuffer::CDuckBuffer(long size, long minindexframes)
{
	mBufferHandle = HFB_CreateBuffer(size,minindexframes);
	if (mBufferHandle == NULL)
		throw InitException();
}

CDuckBuffer::~CDuckBuffer(void)
{
	if (mBufferHandle != NULL)
		HFB_DestroyBuffer(mBufferHandle);
}

int
CDuckBuffer::GetPercentFull(void)
{
	return HFB_GetBufferPerCentFull(mBufferHandle);
}

HFB_BUFFER_HANDLE
CDuckBuffer::Native(void)
{
	return mBufferHandle;
}

void 
CDuckBuffer::InitBuffer(int frame,int preload,CDuckFile &file)
{
	HFB_InitBuffer(mBufferHandle,file.Native(),frame,preload);
}

int
CDuckBuffer::FillBuffer(long maxToRead,long elapsed)
{
	return HFB_FillBuffer(mBufferHandle,maxToRead,elapsed);

}

#ifdef NETHFB
void
CDuckBuffer::NET_SetNetBufferTime(int milliseconds)
{
	::NET_SetNetBufferTime(mBufferHandle,milliseconds);
}

void
CDuckBuffer::NET_SetNetPrebufferPercentWait(int percent)
{
	::NET_SetNetPrebufferPercentWait(mBufferHandle,percent);
}

int
CDuckBuffer::NET_NetworkMode(void)
{
	return ::NET_NetworkMode(mBufferHandle);
}

int				
CDuckBuffer::NET_NextMovieEventFrame(void)
{
	return ::NET_NextMovieEventFrame(mBufferHandle);
}

const char *	
CDuckBuffer::NET_NextMovieEventData1(void)
{
	return ::NET_NextMovieEventData1(mBufferHandle);
}

const char *	
CDuckBuffer::NET_NextMovieEventData2(void)
{
	return ::NET_NextMovieEventData2(mBufferHandle);
}

void			
CDuckBuffer::NET_AdvanceMovieEvent(void)
{
	::NET_AdvanceMovieEvent(mBufferHandle);
}

#endif
