/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CDUCKBUFFER_H_
#define CDUCKBUFFER_H_

#include	"duck_hfb.h"

class CDuckFile;

class CDuckBuffer
{
protected:
	HFB_BUFFER_HANDLE	mBufferHandle;


public:
	CDuckBuffer(long size,long minindexframes);
	virtual ~CDuckBuffer(void);
	HFB_BUFFER_HANDLE	Native(void);

	virtual void InitBuffer(int frame,int preload,CDuckFile &file);
	virtual	int	FillBuffer(long maxToRead,long elapsed);
	virtual	int	GetPercentFull(void);

#ifdef NETHFB
	virtual int				NET_NextMovieEventFrame(void);
	virtual const char *	NET_NextMovieEventData1(void);
	virtual const char *	NET_NextMovieEventData2(void);
	virtual void			NET_AdvanceMovieEvent(void);
	virtual	int				NET_NetworkMode(void);
	virtual	void			NET_SetNetBufferTime(int milliseconds);
	virtual	void			NET_SetNetPrebufferPercentWait(int percent);
#endif

	// Exceptions
	class InitException {};

};

#endif
