/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include	<stdlib.h>
#include	"CDuckCompositeBuffer.h"
#include	"CDuckImage.h"
#include	"danbug.h"

CDuckCompositeBuffer::CDuckCompositeBuffer(CDuckImage &image)
{
	int	x,y,width,height;
	
	mCBuffer		= NULL;
	mMallocScreen	= NULL;
	image.GetDimensions(x,y,width,height);

	if (image.GetType() == DXL_INTERFRAME)
		{
///	dbm -- obsolete DXV call - not clear why it's needed or if it's ever called
///		mCBuffer = DXL_DeriveVScreenFromXImage(image.Native());
 dprintf("obsolete call DXL_DeriveVScreenFromXImage");
		if (mCBuffer == NULL)
			throw InitException();
		}
	else
		{
		mMallocScreen = malloc(((long)width)*((long)height)*((long)2));	// use 16 bit always
		if (mMallocScreen == NULL)
			throw InitException();
		mCBuffer = DXL_CreateVScreen((unsigned char *)mMallocScreen,
			DXRGB16,width,height);
		if (mCBuffer == NULL)
			throw InitException();
		}
}

CDuckCompositeBuffer::~CDuckCompositeBuffer(void)
{
	if (mCBuffer)
		DXL_DestroyVScreen(mCBuffer);
	mCBuffer = NULL;
	if (mMallocScreen)
		free(mMallocScreen);
	mMallocScreen = NULL;
}


void
CDuckCompositeBuffer::Composite(CDuckImage &image)
{
	if (DXL_dxImageToVScreen(image.Native(),mCBuffer) < 0)
		throw CompositeException();
}

DXL_VSCREEN_HANDLE
CDuckCompositeBuffer::Native(void)
{
	return mCBuffer;
}
