/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include	"CDuckData.h"
#include	"CDuckStream.h"
#include	"CDuckBuffer.h"

CDuckData::CDuckData(void)
{
	mDataLen = 0;					///	dbm 4/29 -- this seems to be necessary
}

CDuckData::~CDuckData(void)
{
}

CDuckData::CDuckData(const CDuckData &d)
{
	mDataHandle = d.mDataHandle;
	mDataPtr = d.mDataPtr;
	mDataLen = d.mDataLen;
	mLastStreamAccessed = d.mLastStreamAccessed;
}

CDuckData&
CDuckData::operator=(const CDuckData &d)
{
	mDataHandle = d.mDataHandle;
	mDataPtr = d.mDataPtr;
	mDataLen = d.mDataLen;
	mLastStreamAccessed = d.mLastStreamAccessed;
	return *this;	
}



void
CDuckData::Reset(void)
{
	mDataHandle = -2;
}


void	
CDuckData::GetStreamingData(CDuckStream &stream,dukDirect direction,int count)
{
	mDataHandle = HFB_GetStreamingData(stream.Native(),&mDataPtr,&mDataLen,direction,count);
	mLastStreamAccessed = &stream;
}

void	
CDuckData::ReleaseStreamingData(CDuckBuffer &buffer)
{
	HFB_ReleaseStreamingData(buffer.Native(),mDataHandle);
}

const void	*
CDuckData::GetRawData(void)
{
	return mDataPtr;
}

long
CDuckData::GetRawDataLength(void)
{
	return mDataLen;
}

int 
CDuckData::operator ==(GetResult i)
{
	switch(mDataHandle)
		{
		case -1:
			if (i == Eof) return 1;
			break;
		case -2:
			if (i == NothingYet) return 1;
		default:
			if (mDataHandle < 0)
				{
				if (i == Error) return 1;
				}
			else if (i == Ok)
				{
				return 1;
				}
			break;

		}
	return 0;
}

CDuckData::operator !=(GetResult i)
{
	switch(mDataHandle)
		{
		case -1:
			if (i != Eof) return 1;
			break;
		case -2:
			if (i != NothingYet) return 1;
		default:
			if (mDataHandle < 0)
				{
				if (i != Error) return 1;
				}
			else if (i != Ok)
				{
				return 1;
				}
			break;

		}
	return 0;
}

CDuckData::operator CDuckData::GetResult()
{
	switch(mDataHandle)
		{
		case -1:
			return Eof;
		case -2:
			return NothingYet;
		default:
			if (mDataHandle < 0)
				return Error;
			return Ok;

		}
}

