/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CDUCKDATA_H_
#define CDUCKDATA_H_

#include	"duck_hfb.h"

class CDuckStream;
class CDuckBuffer;

class CDuckData
{
protected:
	HFB_DATA_HANDLE	mDataHandle;
	void			*mDataPtr;
	long			mDataLen;
	CDuckStream		*mLastStreamAccessed;

public:
	typedef enum { Ok,Eof,NothingYet,Error } GetResult;

	CDuckData(void);
	virtual ~CDuckData(void);
	CDuckData(const CDuckData &d);

	CDuckData& operator=(const CDuckData &d);

	virtual void	Reset(void);
	virtual void	GetStreamingData(CDuckStream &stream,dukDirect direction,int count);
	virtual void	ReleaseStreamingData(CDuckBuffer &buffer);
	virtual const void	*GetRawData(void);
	virtual	long		GetRawDataLength(void);

	int operator ==(GetResult i);
	int operator !=(GetResult i);
	operator GetResult();
			

};


#endif
