/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CDUCKDIRECTXSCREEN_H_
#define CDUCKDIRECTXSCREEN_H_

#ifdef	WIN32
#ifdef	_AFXDLL
#define VC_EXTRALEAN
#include <afxwin.h>
#else
#include <windows.h>
#endif

#include <ddraw.h>

#include "CDuckScreen.h"

class CDuckDirectXScreen: public CDuckScreen
{
protected:


	int					mBitsPerPixel;

	BITDEPTH			mBitDepth;

	int					mAutoCenter;
	LPDIRECTDRAW		mDDPointer;
	DDSURFACEDESC		mDDSurfaceDesc;
	LPDIRECTDRAWSURFACE	mDDSurface;
	int					mDDInitialized;
	int					mDirectDrawLocked;
	HWND				mWnd;

	void	UnlockDirectDraw(void);
	void	SetupDirectDraw(void);
	void	TeardownDirectDraw(void);
	HRESULT	LockDirectDraw(DDSURFACEDESC &desc);
	void	DestroyDDScreen(void);
	void	InitDDScreen(void);
	void	GetXY(HWND hwnd,int &x,int &y);
	void	Check565(void);

public:
	CDuckDirectXScreen(HWND wind,int autocenter=1);
	virtual ~CDuckDirectXScreen(void);
	virtual void	Instantiate(int x,int y,int width,int height,int stretch);
	virtual void	Blit(CDuckImage &image,int frame_number,
		int warpflag,int warpwidth,int warpheight);
	//virtual void	Blit(CDuckCompositeBuffer &cbuffer,int frame_number,
	//	int warpflag,int warpwidth,int warpheight);

	class DDException {};
	class UninitializedException {};
	class UnlockException {};
};

#endif
#endif
