/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "CDuckFile.h"
#include "CDuckBuffer.h"

CDuckFile::CDuckFile(void)
{
	mFileHandle = NULL;
}


CDuckFile::~CDuckFile(void)
{
	if (mFileHandle)
		CloseFile();

}

HFB_FILE_HANDLE
CDuckFile::Native(void)
{
	return mFileHandle;
}

void
CDuckFile::FindFile(const char *name)
{
	mFileHandle = HFB_FindFile(name);
	if (mFileHandle == NULL)
		throw FindException();
}

void
CDuckFile::ParseFile(CDuckBuffer &buffer)
{
	if (HFB_ParseFile(mFileHandle,buffer.Native()) < 0)
		throw ParseException();
}

#ifdef NETHFB
void	
CDuckFile::ParseFile2(CDuckBuffer &buffer,
						NetworkStatusCallback_t func,void *passback)

{
	if (HFB_ParseFile2(mFileHandle,buffer.Native(),func,passback) < 0)
		throw ParseException();
}

void	
CDuckFile::OpenFile2(const char *name,CDuckBuffer &buffer,
						NetworkStatusCallback_t func,void *passback)

{
	mFileHandle = HFB_OpenFile2(name,buffer.Native(),func,passback);
	if (mFileHandle == NULL)
		throw OpenException();
}
#endif


void
CDuckFile::LoadIndex(CDuckBuffer &buffer)
{
	HFB_LoadIndex(mFileHandle,buffer.Native());
}

void
CDuckFile::OpenFile(const char *name,CDuckBuffer &buffer)
{
	mFileHandle = HFB_OpenFile(name,buffer.Native());
	if (mFileHandle == NULL)
		throw OpenException();
}

void
CDuckFile::CloseFile(void)
{
	if (mFileHandle != NULL)
		HFB_CloseFile(mFileHandle);
	mFileHandle = NULL;
}
