/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CDUCKFILE_H_
#define CDUCKFILE_H_

#include	"duck_hfb.h"
#ifdef NETHFB
#include	<network.h>
#endif

class CDuckBuffer;
class CDuckStream;

class CDuckFile
{
protected:
	HFB_FILE_HANDLE	mFileHandle;
public:
	CDuckFile(void);
	virtual ~CDuckFile(void);
	HFB_FILE_HANDLE	Native(void);

	virtual	void	FindFile(const char *name);
	virtual	void	ParseFile(CDuckBuffer &buffer);
#ifdef NETHFB
	virtual	void	ParseFile2(CDuckBuffer &buffer,
						NetworkStatusCallback_t func,void *passback);
	virtual	void	OpenFile2(const char *name,CDuckBuffer &buffer,
						NetworkStatusCallback_t func,void *passback);
#endif

	virtual	void	LoadIndex(CDuckBuffer &buffer);
	virtual	void	OpenFile(const char *name,CDuckBuffer &buffer);
	virtual	void	CloseFile(void);
	class OpenException {};
	class ParseException {};
	class FindException {};

};


#endif
