/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CDUCKFLIPSCREEN_H_
#define CDUCKFLIPSCREEN_H_

#ifdef	WIN32

#ifdef _AFXDLL
#define VC_EXTRALEAN
#include <afxwin.h>
#else
#include <windows.h>
#endif

#include <ddraw.h>

#include "CDuckScreen.h"

class CDuckFlipScreen: public CDuckScreen
{
protected:



	int					mHRes,mVRes;

	int					mFrequency;

	int					mBitsPerPixel;

	BITDEPTH			mBitDepth;

	LPDIRECTDRAW2		mDDPointer;
	//LPDIRECTDRAW		mDDPointer;

	DDSURFACEDESC		*mDDSurfaceDesc;
	LPDIRECTDRAWSURFACE	*mDDSurface;
	int					mDDInitialized;
	int					mDirectDrawLocked;
	HWND				mWnd;
	int					mBackBuffers;

	int					mAllocatedBackbuffers;

	int					mBackBuffersVerificationCount;

	int					mBuffersAvailable;
	int					*mBufferFrames;

	int					mNextFlipPointer;

	int					mNextBlitPointer;


	void	UnlockDirectDraw(LPDIRECTDRAWSURFACE surface,DDSURFACEDESC &desc);
	void	SetupDirectDraw(void);
	void	TeardownDirectDraw(void);
	HRESULT	LockDirectDraw(LPDIRECTDRAWSURFACE surface,DDSURFACEDESC &desc);
	void	DestroyDDScreen(void);
	void	InitDDScreen(void);
	void	GetXY(HWND hwnd,int &x,int &y);
	void	Check565(void);

	void	_Blacken(void);

	void	_Reset(void);

public:
	CDuckFlipScreen(HWND wind,int backbuffers,int hres,int vres,int frequency,

					int bitsperpixel);
	virtual ~CDuckFlipScreen(void);
	virtual void	Instantiate(int x,int y,int width,int height,int stretch);
	virtual void	_Blit(CDuckImage &image,int frame_number,

		int warpflag,int warpwidth,int warpheight,int buffer);

	//virtual void	_Blit(CDuckCompositeBuffer &cbuffer,int frame_number,
	//	int warpflag,int warpwidth,int warpheight,int buffer);

	virtual void	Blit(CDuckImage &image,int frame_number,
		int warpflag,int warpwidth,int warpheight);
	//virtual void	Blit(CDuckCompositeBuffer &cbuffer,int frame_number,
	//	int warpflag,int warpwidth,int warpheight);

	virtual void	BlitNow(CDuckImage &image,int frame_number,

		int warpflag,int warpwidth,int warpheight);

//	virtual void	BlitNow(CDuckCompositeBuffer &cbuffer,int frame_number,
//		int warpflag,int warpwidth,int warpheight);



	virtual	void	Flip(void);

	virtual	int		BuffersAvailable(void);

	virtual int		ReadyFrame(void);

	virtual	void	Reset(void);
	virtual	void	VTRReset(void);

	class DDException {};
	class UninitializedException {};
	class UnlockException {};
	class BackbufferMismatch{};

friend	HRESULT WINAPI EnumSurfacesCallback(LPDIRECTDRAWSURFACE lpDDSurface,
    LPDDSURFACEDESC lpDDSurfaceDesc,LPVOID lpContext);

};


#endif

#endif
