/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include	"CDuckImage.h"
#include	"CDuckData.h"
#include	"danbug.h"

extern "C" {
int vp31_Init(void);
}

CDuckImage::CDuckImage(CDuckData &init_data)
{
	mImage = DXL_CreateXImage((unsigned char *)init_data.GetRawData());
	if (mImage == NULL)
		throw InitException();
 dprintf("created CDuckImage(CDuckData&) at %p",mImage);
}

CDuckImage::CDuckImage(const unsigned char *data)

{
 dprintf("trying to create CDuckImage(uchar*) at %p",mImage);
	vp31_Init();
	mImage = DXL_CreateXImage((unsigned char *)data);

	if (mImage == NULL)

		throw InitException();

 dprintf("created CDuckImage(uchar*) at %p",mImage);
}


CDuckImage::~CDuckImage(void)
{
	if (mImage)
 dprintf("destroying CDuckImage %p",mImage);
		DXL_DestroyXImage(mImage);
	mImage = NULL;
}

int
CDuckImage::GetColorDepth(void)
{
 dprintf("CDuckImage::GetColorDepth ALWAYS RETURNS 16 -- UNSUPPORTED! %p",mImage);
	return 16;	///	dbm -- unsupported call
///	return DXL_GetXImageColorDepth(mImage);
}

int
CDuckImage::Update(CDuckData &new_data)
{
 dprintf("CDuckImage::Update(CDuckData&) %p",mImage);
	return DXL_AlterXImageData(mImage,(unsigned char *)new_data.GetRawData());
}

void
CDuckImage::UpdateAndDecompress(unsigned char *new_data)
{
	if (Update(new_data) != -3)
 dprintf("CDuckImage::UpdateAndDecompress %p",mImage);
		DXL_dxImageToVScreen(mImage,NULL);
}

int
CDuckImage::Update(unsigned char *d)
{
 dprintf("CDuckImage::Update(uchar*) %p",mImage);
	return DXL_AlterXImageData(mImage,d);
}

void	
CDuckImage::GetDimensions(int &x,int &y,int &width,int &height)
{
 dprintf("CDuckImage::GetDimensions %p",mImage);
	DXL_GetXImageXYWH(mImage,&x,&y,&width,&height);
}

int 
CDuckImage::GetType(void)
{
 dprintf("CDuckImage::GetType -- UNSUPPORTED!!!%p",mImage);
///	return DXL_GetXImageType(mImage);
 return 0;
}


DXL_XIMAGE_HANDLE
CDuckImage::Native(void)
{
 dprintf("CDuckImage::Native %p",mImage);
	return mImage;
}



