/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CDUCKIMAGE_H_
#define CDUCKIMAGE_H_

#include "duck_dxl.h"

class CDuckData;
class CDuckCompositeBuffer;

class CDuckImage
{
protected:
	DXL_XIMAGE_HANDLE	mImage;

public:
	DXL_XIMAGE_HANDLE	Native(void);
	CDuckImage(CDuckData &init_data);

	CDuckImage(const unsigned char *);
	virtual ~CDuckImage(void);
	void	GetDimensions(int &x,int &y,int &width,int &height);
	int		GetType(void);
	int		GetColorDepth(void);
	int		Update(CDuckData &new_data);
	int		Update(unsigned char *);
	void	UpdateAndDecompress(unsigned char *d);

	class InitException {};

	friend CDuckCompositeBuffer;

};

#endif
