/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifdef	IRIX
#include	"CDuckSGIDigitalMediaScreen.h"
#include	"CDuckImage.h"
#include	"CDuckCompositeBuffer.h"
#include	<stdio.h>
#include	<unistd.h>
#include	<stdlib.h>
#include	<gl.h>
#include <GL/GLwDrawA.h> 

char *_progName;

CDuckSGIDigitalMediaScreen::CDuckSGIDigitalMediaScreen(HWND wnd)
{
	mWindow = wnd;
	mVideoServer= vlOpenVideo("");

	if (mVideoServer == NULL)
		{
		fprintf(stderr,"Could not connect to video server\n");
		vlPerror(_progName);
		throw InitException();
		}
	mSource		= vlGetNode(mVideoServer,VL_SRC,VL_MEM,VL_ANY);
	if (mSource == -1)
		{
		fprintf(stderr,"Could not create video source\n");
		vlPerror(_progName);
		throw InitException();
		}
	mDrain		= vlGetNode(mVideoServer,VL_DRN,VL_VIDEO,VL_ANY);
	if (mDrain == -1)
		{
		fprintf(stderr,"Could not create video drain\n");
		vlPerror(_progName);
		throw InitException();
		}

	mVideoPath	= vlCreatePath(mVideoServer,VL_ANY,mSource,mDrain);
	if (mVideoPath < 0)
		{
		fprintf(stderr,"Could not create video path\n");
		vlPerror(_progName);
		throw InitException();
		}	

	if (vlSetupPaths(mVideoServer,&mVideoPath,1,VL_LOCK,VL_LOCK) < 0)
		{
		fprintf(stderr,"Could not setup paths\n");
		vlPerror(_progName);
		throw InitException();
		}

	if (vlSelectEvents(mVideoServer,mVideoPath,VLTransferCompleteMask) < 0)
		{
		fprintf(stderr,"Could not select video events\n");
		vlPerror(_progName);
		throw InitException();
		}
}

CDuckSGIDigitalMediaScreen::~CDuckSGIDigitalMediaScreen(void)
{
}

static char *video_buffer[1000000];

void	
CDuckSGIDigitalMediaScreen::Instantiate(int xstart,int ystart,int width,int height,int stretch)
{
	mMovieWidth = width;
	mMovieHeight = height;
	mStretchFlag = stretch;
	mX = xstart;
	mY = ystart;
	int	x,y;

	VLControlValue v;
//	v.intVal  = XtWindow(mWindow);
	if (vlSetControl(mVideoServer,mVideoPath,mDrain,VL_WINDOW,&v) < 0)
		{
		fprintf(stderr,"Could not attach drain to window\n");
		vlPerror(_progName);
		throw InitException();
		}

	mScreen = DXL_CreateVScreen((unsigned char *)video_buffer,DXRGB16,
				width*2,height);
	if (mScreen == NULL)
		throw VScreenException();

//	GetXY(mWnd,x,y);
	x = y = 0;
	x += mX;
	y += mY;
//	if (mStretchFlag)
//		Blackout((unsigned char *)video_buffer,
//			x,y,mMovieWidth,mMovieHeight,16,2,width*2,height*2);
}

void	
CDuckSGIDigitalMediaScreen::Blit(CDuckCompositeBuffer &cbuffer,int frame_number,
						 int warp,int warpheight,int warpwidth)
{
	mLastBlitFrame = frame_number;
}


void	
CDuckSGIDigitalMediaScreen::Blit(CDuckImage &image,int frame_number,
						 int warp,int warpheight,int warpwidth)
{
	mLastBlitFrame = frame_number;
	int	 x,y;
	int	mult = (mStretchFlag ? 1 : 0);
	int	h = 0;// dxv deals with this now //mMovieHeight*mult;
	int w = 0;// mMovieWidth*mult;

	//GetXY(mWnd,x,y);
	x = y = 0;
	x += mX;
	y += mY;

//	DXL_AlterVScreen(mScreen,(unsigned char *)mDDSurfaceDesc.lpSurface,
//		(mDDSurfaceDesc.ddpfPixelFormat.dwRGBBitCount == 8) ? DXRGB8 : DXRGB16,
//		mDDSurfaceDesc.lPitch,mDDSurfaceDesc.dwHeight);

//	DXL_AlterVScreenView(mScreen,x,y,(mDDSurfaceDesc.dwWidth - x - w) & 0xfffffffe,
//			(mDDSurfaceDesc.dwHeight - y - h) & 0xfffffffe);

	DXL_dxImageToVScreen(image.Native(),mScreen);
}

#endif
