/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CDUCKSGISCREEN_H_
#define CDUCKSGISCREEN_H_

#ifdef	IRIX

#include 	"CDuckScreen.h"
#include 	"CDuckPlayer.h"
#include	<CCMutex.h>
#include	<CConditionVariable.h>

//#define TR20_KLUDGE 1

class CDuckSGIScreen: public CDuckScreen
{
protected:
#ifdef	TR20_KLUDGE
	unsigned char		*mKludgeBuffer;
	int					mTR20;
#endif

	unsigned char *	mVideoBuffer;
	HWND		mWindow;
	//GLXContext	mGLXContext;
	CCMutex				mVideoBufferMutex;
	CConditionVariable	mVideoBufferCondition;
	int					mBlitDone;
	int					mWidgetHeight,mWidgetWidth;

	int		mMovieHeightForPlacement;
	int		mMovieWidthForPlacement;
	float		mSGIHorZoom;
	float		mSGIVerZoom;

	int			mFirstBlit;
	int			mLastX,mLastY;

	void	SendBlitMessage(void);
	int			mVideoBufferSize;

public:
	CDuckSGIScreen(HWND wnd);
#ifdef TR20_KLUDGE
	void SetRT(int rt);
	virtual void SetBlitQuality(CDuckImage &image,int stretch_flag);
#endif
	virtual ~CDuckSGIScreen(void);
			void	SetWidgetDimensions(int h,int w);
	virtual void	Instantiate(int x,int y,int width,int height,int stretch);
	virtual void	Blit(CDuckImage &image,int frame_number,
		int warpflag,int warpwidth,int warpheight);
	virtual void	Blit(CDuckCompositeBuffer &cbuffer,int frame_number,
		int warpflag,int warpwidth,int warpheight);

	void	Blit(Widget w);
	virtual	void	Reset(void);
};

#endif
#endif
