/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CDUCKSCREEN_H_
#define CDUCKSCREEN_H_

#ifdef	WIN32
#ifdef	_AFXDLL
#define VC_EXTRALEAN
#include	<afxwin.h>
#else
#include <windows.h>
#endif

#endif

#include "duck_dxl.h"

class CDuckImage;
class CDuckCompositeBuffer;

class CDuckScreen
{
protected:
	DXL_VSCREEN_HANDLE mScreen;
	int					mMovieWidth;
	int					mMovieHeight;
	int					mStretchFlag;
	int					mX;
	int					mY;
	int					mLastBlitFrame;

#ifdef	WIN32
	void	BuildClut(HDC device,DXL_VSCREEN_HANDLE vs);
#endif

public:
	CDuckScreen(void);
	virtual ~CDuckScreen(void);
	virtual void	Instantiate(int x,int y,int width,int height,int stretch) = 0;
	void Blackout(unsigned char *p,int x,int y,int width,int height,
					 int depth,int pitch,int s_width,int s_height);
	virtual void SetBlitQuality(CDuckImage &image,int stretch_flag);
	virtual void	Blit(CDuckImage &image,int frame_number,
		int warpflag = 0,int warpwidth = 0,int warpheight = 0) = 0;
	//virtual void	Blit(CDuckCompositeBuffer &cbuffer,int frame_number,
	//	int warpflag = 0,int warpwidth = 0,int warpheight = 0) = 0;
	virtual void	BlitNow(CDuckImage &image,int frame_number,
		int warpflag = 0,int warpwidth = 0,int warpheight = 0);
	//virtual void	BlitNow(CDuckCompositeBuffer &cbuffer,int frame_number,
	//	int warpflag = 0,int warpwidth = 0,int warpheight = 0);

	virtual void NullBlit(CDuckImage &image,int frame_number);

	virtual	int		ReadyFrame(void);
	virtual	void	Flip(void);
	virtual	int		BuffersAvailable(void);
	virtual	void	Reset(void);
	virtual	void	VTRReset(void);
	virtual	void	AsyncCleanup(void);
	class InitException {};
	class VScreenException {};

};

#endif
