/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include	"CDuckStream.h"
#include	"CDuckFile.h"
#include	"CDuckData.h"
#include	"danbug.h"

CDuckStream::CDuckStream(CDuckFile &file,const char *name,int which,HFB_StreamType stype)
{
	dprintf("calling HFB_GetStream -- or should I say, lHFB_GetStream?");	///	dbm
	mStreamHandle = HFB_GetStream(file.Native(),name,which,stype);
	if (mStreamHandle == NULL) {
		dprintf("throwing exception from CDuckStream.cpp"); ///	dbm
		throw InitException();
	}
	dprintf("HFB_GetStream exited here");
}


CDuckStream::~CDuckStream(void)
{
	if (mStreamHandle)
		HFB_ReleaseStream(mStreamHandle);
}


HFB_STREAM_HANDLE
CDuckStream::Native(void)
{
	return mStreamHandle;
}

int
CDuckStream::GetDataPosition(int i)
{
	return HFB_GetDataPosition(mStreamHandle,i);
}

void
CDuckStream::Reset(void)
{
//	CDuckData	data;

//	data.GetStreamingData(*this,DUK_ABSOLUTE,0);
//	if (data == CDuckData::Ok)
//		data.ReleaseStreamingData();
}

unsigned long
CDuckStream::GetFCC(void)
{
	unsigned long t;
	unsigned long h;

	HFB_GetStreamFCCs(mStreamHandle,&t,&h);
	return h;
}

long
CDuckStream::GetStreamLength(void)
{
	return HFB_GetStreamLength(mStreamHandle);
}
