/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef CDUCKVIDEOSTREAM_H_
#define CDUCKVIDEOSTREAM_H_

#include "CDuckStream.h"
#include <MegaHeaders.h>
#include <nmr_fraction.h>

class CDuckAudioStream;
class CDuckImage;

#define MAX_STATIC_FRAME_SIZE		(750 * 1024) //65535	// use for ff and rewind

class CDuckVideoStream: public CDuckStream
{
protected:
	unsigned char	*mSeekBuffer;

public:
	CDuckVideoStream(CDuckFile &file,const char *name,int which);
	virtual ~CDuckVideoStream(void);
	void	GetFrameRates(CDuckAudioStream &audio_stream,
					nmr_fraction<I32>  &FramesPerSecond,
					int &AudioSamplesTillStart);
	void	GetFrameRates(nmr_fraction<I32> &FramesPerSecond,
												int &AudioSamplesTillStart);
	int	Seek(int frame,CDuckImage &image);
	int	ReadData(unsigned char *framedata,
						   long &frame_len,dukDirect direction,int count);
	int	FramesToNextKeyFrame(int cur_frame);
	int PreviousKeyFrame(int cur_frame);
	int IsFrameKeyFrame(int frame);
	int	FrameToChunk(int frame);

};


#endif
