/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CDUCKWINBLITSCREEN_H_
#define CDUCKWINBLITSCREEN_H_

#ifdef	WIN32

#ifdef	_AFXDLL
#define VC_EXTRALEAN
#include <afxwin.h>
#else
#include <windows.h>
#endif

#include	"CDuckScreen.h"

class CDuckWinblitScreen: public CDuckScreen
{
protected:

	int					mBitsPerPixel;

	BITDEPTH			mBitDepth;

	int					mAutoCenter;
	HWND				mWnd;
	int					mWinBlit;
	HGDIOBJ				mOldBitmap;
	void				*mWinblitMalloc;
	int					mWinblitWidth,mWinblitHeight;
	int					mWinDepthBytes;
	int					mWinPitch;
	HBITMAP				mDIB;
	BITMAPINFO			*mBmi;
	HPALETTE			mWinPalette;
	LOGPALETTE			*mWinLogPalette;
	int					mXOffset,mYOffset;

	void	InternalBlit(HDC device,int warpflag,int warpheight,int warpwidth);

public:
	CDuckWinblitScreen(HWND wind,int &rescode,int autocenter=1);
	virtual ~CDuckWinblitScreen(void);
	virtual void	Instantiate(int x,int y,int width,int height,int stretch);
	virtual void	Blit(CDuckImage &image,int frame_number,
		int warpflag,int warpheight,int warpwidth);
	//virtual void	Blit(CDuckCompositeBuffer &cbuffer,int frame_number,
	//	int warpflag,int warpheight,int warpwidth);


};

#endif
#endif
