/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CPLAYERCONTEXT_H_
#define CPLAYERCONTEXT_H_

class CPlayerUIContext;
class CDuckPlayer;

#include	<nmr_string.h>
#include	<CDuckPlayer.h>

class CPlayerContext
{
protected:
	CPlayerUIContext	*mUI;
	int					mOwnsUI;
	nmr_string			mFilename;
	nmr_string			mLastNetspec;
	nmr_string			mLastDirectoryAddress;
	nmr_string			mLastDirectoryPort;
	CDuckPlayer			*mPlayer;
	int					mNetBufferSize;
	int					mNetBufferPreload;
	int					mDiskBufferSize;
	int					mDiskBufferReadSize;
	int					mStretch;
	int					mBlitter;	
	nmr_string			mLastCaptureName;

	int					mShowMessages;
	int					mVideoSpeedTest;
	int					mLoopForever;

	virtual void	_LaunchPlayer(const char *filename,HWND wnd) = 0;


protected:
	CPlayerContext(CPlayerUIContext *ui,int owns_ui);
public:
	virtual ~CPlayerContext(void);

	virtual int		CanRewind(void);
	virtual int		CanFastforward(void);
	virtual int		CanPause(void);
	virtual	int		CanPlay(void);
	virtual int		IsPlaying(void);

	virtual void	Fastforward(void);
	virtual void	OpenNetwork(HWND wnd);
	virtual	void	OpenFile(const char *filename,HWND wnd);
	virtual	void	PlayLogo(const char *filename,HWND wnd);
	virtual	void	NetworkDirectory(HWND wnd);
	virtual void	Play(HWND wnd);
	virtual void	Rewind(void);
	virtual	void	Pause(void);
	virtual void	Stop(void);

	virtual	void	BuffersConfig(void);
	virtual	void	BlittingConfig(void);

	virtual	int		IsCapturing(void);
	virtual	void	StartCapture(void);
	virtual	void	StopCapture(void);

	virtual	void	SetVideoSpeedTest(int v);
	virtual	void	SetLoopForever(int v);
	virtual void	SetShowMessages(int v);

	virtual	int		GetVideoSpeedTest(void);
	virtual	int		GetLoopForever(void);
	virtual	int		GetShowMessages(void);
};


#endif
