/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CPLAYERUICONTEXT_H_
#define CPLAYERUICONTEXT_H_

#include	<nmr_string.h>

class CPlayerContext;

class CPlayerUIContext
{
protected:
	CPlayerUIContext(void){};
public:
	virtual ~CPlayerUIContext(void){};

	virtual nmr_string	PostOpenNetworkDialog(nmr_string name) = 0;
	virtual nmr_string	PostNetworkDirectoryDialog(
							nmr_string initial_address,
							nmr_string initial_port,
							nmr_string &new_address,
							nmr_string &new_port) = 0;
	virtual	int			PostBuffersConfigDialog(int &db_size,int &db_read,
											int &nb_size,int &nb_preload) = 0;
	virtual int			PostBlittingConfigDialog(
												int &stretch,int &blitter) = 0;
	virtual	nmr_string	PostStartCaptureDialog(nmr_string oldname) = 0;
	virtual	void		PostFPSDialog(float fps) = 0;
	virtual	void		AdjustMenus(CPlayerContext *pc) = 0;
};



#endif
