/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
typedef int	 (*NEIL_OPEN_PROC_TYPE)(const char *);
typedef void (*NEIL_CLOSE_PROC_TYPE)(int);
typedef int  (*NEIL_READ_PROC_TYPE)(int,void *,int);
typedef int  (*NEIL_SEEK_PROC_TYPE)(int,long,int);

#define	NEIL_OPEN_INDEX	0
#define	NEIL_CLOSE_INDEX 1
#define NEIL_READ_INDEX 2
#define NEIL_SEEK_INDEX 3
#define NEIL_NUM_ENTRIES 4

//typedef void **NEIL_FUNCTION_TABLE;
typedef void *NEIL_FUNCTION_TABLE[NEIL_NUM_ENTRIES];
extern	NEIL_FUNCTION_TABLE	gNeilFunctionTable;


#define	NEIL_OPEN_PROC	(*(NEIL_OPEN_PROC_TYPE)gNeilFunctionTable[NEIL_OPEN_INDEX])
#define	NEIL_CLOSE_PROC (*(NEIL_CLOSE_PROC_TYPE)gNeilFunctionTable[NEIL_CLOSE_INDEX])
#define	NEIL_READ_PROC	(*(NEIL_READ_PROC_TYPE)gNeilFunctionTable[NEIL_READ_INDEX])
#define	NEIL_SEEK_PROC	(*(NEIL_SEEK_PROC_TYPE)gNeilFunctionTable[NEIL_SEEK_INDEX])

void Neil_Init(void);
void Neil_InstallIOProcs(NEIL_OPEN_PROC_TYPE openproc,NEIL_CLOSE_PROC_TYPE closeproc,
						 NEIL_READ_PROC_TYPE readproc,NEIL_SEEK_PROC_TYPE seekproc);
void Neil_DefaultIOProcs(void);
void Neil_Exit(void);
