/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/***********************************************************************

    Filename:    HEADER.CPP

    Voxware Proprietary Material.
    Copyright 1996, Voxware, Inc., All Rights Reserved.
    DISTRIBUTION PROHIBITED without written authorization from Voxware.

************************************************************************/
#ifdef WIN32
#include <CDuckAudioSrcDirect.h>
#elif __POWERPC__
#define DLLcmpVoxInit cmpVoxInit
#define DLLcmpVoxFree cmpVoxFree
#include <CDuckAudioSrcMAC.h>
#define VOXWARE_MAC
#elif ((defined IRIX) || (defined SOLARIS) || (defined LINUX))
#include <CDuckAudioSrcUnix.h>
#include <string.h>
#define DLLcmpVoxInit cmpVoxInit
#define DLLcmpVoxFree cmpVoxFree
#endif

#ifdef	USE_VOXWARE

#if ((defined WIN32) || (defined LINUX))
#define VOX_NATIVE_ENDIAN       1
#define VOX_BIG_ENDIAN          0
#elif __POWERPC__
#define VOX_NATIVE_ENDIAN		1
#define VOX_BIG_ENDIAN			1
#ifdef VOXWARE_WIN32
gaseous anomoly captain!!!!
#endif
#elif IRIX
#define VOX_NATIVE_ENDIAN		1
#define VOX_BIG_ENDIAN			1
#elif SOLARIS
#define VOX_NATIVE_ENDIAN		1
#define VOX_BIG_ENDIAN			1
#endif

#define SwapShort(myUnsignedShort)  (unsigned short)(((myUnsignedShort)>>8)|((myUnsignedShort)<<8))

#if VOX_NATIVE_ENDIAN==VOX_BIG_ENDIAN
#define	LE2NE_Short(x)   SwapShort(x)
#else
#define	LE2NE_Short(x)   (x)
#endif



VOXWARE_RETCODE GetDecodeHeader(unsigned char * lpHeaderBuffer, short wHeaderBufferSize,
                                unsigned long dwCodecID,short *new_size)
{
    VOXWARE_RETCODE             voxRetCode;
    VOXWARE_DATA                vwdCompress;
    short                       wSizeOfVoxHeader;
    LPFIRST_BITSTREAM_BUFFER    lpFirstData;
    LPVOX_STREAM_HEADER         lpStreamHeader;

    memset(&vwdCompress, 0, sizeof(VOXWARE_DATA));

	// Initialize compression.
    vwdCompress.wSizeOfVoxwareData      = sizeof(VOXWARE_DATA);
    vwdCompress.dwInputType             = VOXTYPE_FORMAT_RAW | VOXTYPE_LOCATION_BUFFER | VOXTYPE_QUALIFIER_PCM;
    vwdCompress.lpOutputLocation        = lpHeaderBuffer;
    vwdCompress.dwOutputSize            = wHeaderBufferSize;
    vwdCompress.dwOutputType            = VOXTYPE_FORMAT_RAW | VOXTYPE_LOCATION_BITSTREAM | VOXTYPE_QUALIFIER_VOX;
    //vwdCompress.dwOutputType            = VOXTYPE_FORMAT_RAW | VOXTYPE_LOCATION_BUFFER | VOXTYPE_QUALIFIER_VOX;

	vwdCompress.dwInputSamplingRate     = VOXWARE_SAMPLING_RATE_8K;
	vwdCompress.wInputBytesPerSample    = VOXWARE_SAMPLE_SIZE_16BIT;

    // Use the requested codec.
    vwdCompress.dwCompressionSettings    = dwCodecID;

    // Initialize compression.
    if ((voxRetCode=DLLcmpVoxInit(&vwdCompress)) != VOX_NO_ERROR)
    {
        return voxRetCode;
    }

    // Move the portion that we should send to the decode init to the
    // beginning of this buffer.
    lpFirstData         = (LPFIRST_BITSTREAM_BUFFER)lpHeaderBuffer;

    // We now have access to the following:
    //      lpFirstData->wNumBitsPerFrame
    //      lpFirstData->wNumSamplesPerFrame

    lpStreamHeader      = (LPVOX_STREAM_HEADER) &(lpFirstData->voxStreamHeader);
    wSizeOfVoxHeader    = LE2NE_Short(lpStreamHeader->wSizeOfVoxStreamHeader);

    memmove(lpHeaderBuffer, lpStreamHeader, wSizeOfVoxHeader);


    // Clean up the encoder.
    voxRetCode = DLLcmpVoxFree(&vwdCompress);
    if (VOX_NO_ERROR != voxRetCode)
    {
        return voxRetCode;
    }

	*new_size = wSizeOfVoxHeader;
    return VOX_NO_ERROR;

}   // end of GetDecodeHeader()




#if 0
void main(void)
{

    char HeaderBuffer[512];

    GetDecodeHeader(HeaderBuffer, 512, VOXWARE_CODEC_AC_8K);

}
#endif


#endif
