/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef VOXWAREDLL_H_
#define VOXWAREDLL_H_

#if ((defined WIN32) && (defined USE_VOXWARE))
#include <toolvox.h>


int VoxwareDLLCtor(void);
void VoxwareDLLDtor(void);
typedef VOXWARE_RETCODE (VOXAPI *voxware_basic_func)(LPVOXWARE_DATA);

#define NUM_VOX_FUNCTIONS	18

extern voxware_basic_func vox_calls[NUM_VOX_FUNCTIONS];



#define INDEXcmpToolVoxRecord			0
#define INDEXcmpToolVoxCompress			1
#define INDEXcmpVoxInit					2
#define INDEXcmpVoxConvert				3
#define INDEXcmpVoxFree					4
#define INDEXcmpFileToVoxFile			5
#define INDEXcmpFileToVoxBuffer			6
#define INDEXcmpBufferToVoxFile			7
#define INDEXdcmpToolVoxPlay			8
#define INDEXdcmpToolVoxDecompress		9
#define INDEXdcmpVoxInit				10
#define INDEXdcmpVoxConvert				11
#define INDEXdcmpVoxFree				12
#define INDEXdcmpVoxFileToFile			13
#define INDEXdcmpVoxFileToBuffer		14
#define INDEXdcmpVoxBufferToFile		15
#define INDEXdcmpPlayVoxFile			16
#define INDEXdcmpPlayVoxBuffer			17

#define DLLcmpToolVoxRecord(x) 		(vox_calls[INDEXcmpToolVoxRecord](x))
#define DLLcmpToolVoxCompress(x) 	(vox_calls[INDEXcmpToolVoxCompress](x))
#define DLLcmpVoxInit(x) 			(vox_calls[INDEXcmpVoxInit](x))
#define DLLcmpVoxConvert(x) 		(vox_calls[INDEXcmpVoxConvert](x))
#define DLLcmpVoxFree(x) 			(vox_calls[INDEXcmpVoxFree](x))
#define DLLcmpFileToVoxFile(x) 		(vox_calls[INDEXcmpFileToVoxFile](x))
#define DLLcmpFileToVoxBuffer(x) 	(vox_calls[INDEXcmpFileToVoxBuffer](x))
#define DLLcmpBufferToVoxFile(x) 	(vox_calls[INDEXcmpBufferToVoxFile](x))
#define DLLdcmpToolVoxPlay(x) 		(vox_calls[INDEXdcmpToolVoxPlay](x))
#define DLLdcmpToolVoxDecompress(x) (vox_calls[INDEXdcmpToolVoxDecompress](x))
#define DLLdcmpVoxInit(x) 			(vox_calls[INDEXdcmpVoxInit](x))
#define DLLdcmpVoxConvert(x) 		(vox_calls[INDEXdcmpVoxConvert](x))
#define DLLdcmpVoxFree(x) 			(vox_calls[INDEXdcmpVoxFree](x))
#define DLLdcmpVoxFileToFile(x) 	(vox_calls[INDEXdcmpVoxFileToFile](x))
#define DLLdcmpVoxFileToBuffer(x) 	(vox_calls[INDEXdcmpVoxFileToBuffer](x))
#define DLLdcmpVoxBufferToFile(x) 	(vox_calls[INDEXdcmpVoxBufferToFile](x))
#define DLLdcmpPlayVoxFile(x) 		(vox_calls[INDEXdcmpPlayVoxFile](x))
#define DLLdcmpPlayVoxBuffer(x) 	(vox_calls[INDEXdcmpPlayVoxBuffer](x))


#endif
#endif
