/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CACTIVEMOVIESTAT_H_
#define CACTIVEMOVIESTAT_H_

#include	<MegaHeaders.h>
#include	<nmr_string.h>

class CTCPSocket;

class CActiveMovieStat {
private:
	U32			mInetAddr;
	nmr_string	mFilename;
	U32			mTimeActive; // seconds
	U32			mThreadID;
	U16			mMode;	// TCP transfer modes

public:	

		CActiveMovieStat(void);
		CActiveMovieStat(U32 inet_addr,nmr_string filename,
				U32 time_active,U32 thread_id,U16 mode);
		CActiveMovieStat(const CActiveMovieStat &am);
	CActiveMovieStat&	operator=(const CActiveMovieStat &am);

	void	Write(CTCPSocket &socket);
	void	Read(CTCPSocket &socket);
	size_t	CalculateSize(void);

	U32	GetInetAddr(void);
	nmr_string GetFilename(void);
	U32 GetTimeActive(void);
	U32	GetThreadID(void);
	U16	GetMode(void);


	// because it is used in stl lists directly, we have to
	// define these. They work off the threadid

	int	operator==(const CActiveMovieStat& ) const;
	int operator!=(const CActiveMovieStat& ) const;
	int operator<(const CActiveMovieStat& ) const;
	int operator>(const CActiveMovieStat& ) const;

	virtual	const char *Name(void);
	virtual	void	Dump(ostream &o,const char *indent);
};

ostream& operator<<(ostream &o,CActiveMovieStat &);
ostream& operator<<(ostream &o,CActiveMovieStat *);

CTCPSocket& operator<<(CTCPSocket &socket,CActiveMovieStat &am);
CTCPSocket& operator>>(CTCPSocket &socket,CActiveMovieStat &am);

#endif

