/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CAUDIOINFO_H_
#define CAUDIOINFO_H_

#include	<CStreamInfo.h>
#ifdef NETHFB
#include	<UDPPacketDefinition.h>
#endif

class CAudioInfo: public CStreamInfo
{
public:

	DKWAVEFORM	mWaveInfo;
	int			mNumChannels;
	int			mSamplesPerSec;
	int			mBytesPerSec;
	int			mFormat;
	long		mBytesPerBlock;
	unsigned long	mFCCHandler;

	CAudioInfo(void);
	~CAudioInfo(void);
	virtual	void	ExtractFromStream(HFB_STREAM_HANDLE primary_audio,
									HFB_STREAM_HANDLE strm,int s_num);
#ifdef NETHFB
	virtual	void	Read(CTCPSocket &socket);
	virtual	void	Write(CTCPSocket &socket);
	virtual	size_t	CalculateSize(void);
#endif
	virtual	double	ChunkTimeSize(long len);
	virtual	double	GetTimingFactor(void);
	virtual	nmr_fraction<I32> GetTimingFactorAsFraction(void);
	virtual	unsigned long GetFCCHandler(void);
#ifdef NETHFB
	virtual	void	FillInUDPData(UDPAudioInfoBlock_t *);
	static CAudioInfo *CreateFromUDPData(const UDPAudioInfoBlock_t *data,
																	int siz);
#endif

			int	DataPosToBytes(int data_pos);
	virtual	const char *Name(void);
	virtual	void	Dump(ostream &o,const char *indent);
};

ostream& operator<<(ostream&o,CAudioInfo *ai);
ostream& operator<<(ostream&o,CAudioInfo &ai);

#ifdef NETHFB
CTCPSocket& operator<<(CTCPSocket&,CAudioInfo &ai);
CTCPSocket& operator>>(CTCPSocket&,CAudioInfo &ai);
size_t CalculateTCPSize(CAudioInfo &ai);
#endif

#endif
