/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CCONFIGENTRY_H_
#define CCONFIGENTRY_H_

#include	<MegaHeaders.h>
#include	<CTCPSocket.h>
#include	<nmr_string.h>

#define	CCONFIGENTRY_NUMFIELDS	7
#define	CCONFIGENTRY_MAXSIZE	255

class CTCPSocket;

class CConfigEntry {
public:
	typedef	enum { eDisplayName = 0,ePathName = 1,
					eEventFile = 2,eMulticastAddress = 3,
					eTTL = 4,eServerAddress = 5,eServerPort = 6} ConfigField;

protected:
	nmr_string	mFields[CCONFIGENTRY_NUMFIELDS];
	unsigned long	mServerAddress;
	int				mServerPort;

public:
	CConfigEntry(void);
	CConfigEntry(unsigned long server_address,int server_port);
	CConfigEntry(const CConfigEntry &ce);

		virtual ~CConfigEntry(void);

	void		SetAddressAndPort(unsigned long addr,int port);
	nmr_string	GetField(ConfigField which) const;
	void		SetField(ConfigField which,nmr_string &);
	int			LastReadOk(void) const;

	void		Read(CTCPSocket &s);
	void		Write(CTCPSocket &s);
	size_t	CalculateSize(void) const;

	int		IntegrityCheck(nmr_string &rootpath) const;

	virtual const char *Name(void) const;
	virtual	void	Dump(ostream& o,const char *indent);

	friend ostream&	operator<<(ostream &,CConfigEntry &);
	friend ostream&	operator<<(ostream &,CConfigEntry *);
	friend istream&	operator>>(istream &,CConfigEntry &);
};

CTCPSocket&	operator<<(CTCPSocket &socket,CConfigEntry &ce);
CTCPSocket&	operator>>(CTCPSocket &socket,CConfigEntry &ce);

typedef CConfigEntry	*CConfigEntryPtr;

#endif
