/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CEVENTENTRY_H_
#define CEVENTENTRY_H_

#include	<MegaHeaders.h>
#include	<UDPPacketDefinition.h>
#include	<nmr_string.h>

class CTCPSocket;
class CUDPSocket;

class CEventEntry
{
protected:
	I32			mFrame;
	nmr_string	mAction;
	nmr_string	mTarget;
public:
	CEventEntry(void);
	CEventEntry(const CEventEntry &ce);
	CEventEntry(I32 frame,nmr_string action,nmr_string target);
	virtual ~CEventEntry(void);

	nmr_string	GetAction(void) const;
	void		SetAction(nmr_string);
	nmr_string	GetTarget(void) const;
	void		SetTarget(nmr_string);
	I32			GetFrame(void) const;
	void		SetFrame(I32);

	int		LastReadOk(void) const;

	void		Read(CTCPSocket &s);
	void		Write(CTCPSocket &s) const;
	size_t	CalculateSize(void) const;

	void	FillInUDPData(UDPEventEntryBlock_t *data);
	void	UDPTransmit(CUDPSocket *socket);
	static CEventEntry *CreateFromUDPData(const UDPEventEntryBlock_t *data,
																	int siz);

	int		IntegrityCheck(void) const;

	virtual	const char *Name(void);
	virtual	void	Dump(ostream &o,const char *indent);

	friend ostream&	operator<<(ostream &,CEventEntry &);
	friend ostream&	operator<<(ostream &,CEventEntry *);
	friend istream&	operator>>(istream &,CEventEntry &);
};

CTCPSocket& operator<<(CTCPSocket &s,CEventEntry &ee);
CTCPSocket& operator>>(CTCPSocket &s,CEventEntry &ee);
size_t CalculateTCPSize(CEventEntry &ee);

#endif
