/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include	<CIndexData.h>
#include	<CCThread.h>
#ifdef NETHFB
#include	<CTCPSocket.h>
#endif
#include	<stack_aids.h>

CIndexData::CIndexData(void)
	: CDataList<I32>(1)
{
	delete [] mData;
	mData = NULL;
	mSize = 0;
}

CIndexData::CIndexData(int siz)
	: CDataList<I32>(siz)
{
}

CIndexData::~CIndexData(void)
{
}

#ifdef NETHFB

size_t
CIndexData::CalculateSize(void)
{
	size_t	usize = sizeof(u_long);

	return usize + (GetSize() * usize);
}


void
CIndexData::Read(CTCPSocket &socket)
{
	U32	datasize;
	socket >> datasize;

	mSize = datasize;
	if (datasize)
		{
		delete [] mData;
		mData = new long[datasize];

		u_long *ua = new u_long[datasize];
		stack_ArrayDeleter<u_long> sad(ua);

		socket.Read((char *)ua,sizeof(u_long) * datasize);
		for (int x = 0; x < datasize; ++x)
			(mData)[x] = ntohl(ua[x]);
		}
}

void
CIndexData::Write(CTCPSocket &socket)
{
	U32	datasize = GetSize();
	socket << datasize;

	if (datasize != 0)
		{
		u_long	*ua = new u_long[datasize];
		stack_ArrayDeleter<u_long> sad(ua);

		for (int x = 0,y = 0; x < datasize; ++x,++y)
			{
			// don't burn up the network with the index
			if (y == 100)
				{
				CCThread::Yield();
				y = 0;
				}
			ua[x] = htonl((mData)[x]);
			}

		socket.Write((char *)ua,sizeof(u_long) * datasize);
		}
}
#endif

const char *
CIndexData::Name(void)
{
	return "CIndexData";
}


#ifdef NETHFB
CTCPSocket& operator<<(CTCPSocket &socket,CIndexData &d)
{
	d.Write(socket);
	return socket;
}

CTCPSocket& operator>>(CTCPSocket &socket,CIndexData &d)
{
	d.Read(socket);
	return socket;
}

size_t CalculateTCPSize(CIndexData &d)
{
	return d.CalculateSize();
}
#endif

ostream & operator<<(ostream &o,CIndexData &cd)
{
	cd.Dump(o,"");
	return o;
}

ostream & operator<<(ostream &o,CIndexData *cd)
{
	if (cd)
		cd->Dump(o,"");
	else
		o << " NULL " << endl;
	return o;
}

