/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CMONITORDATAPACKAGE_H_
#define CMONITORDATAPACKAGE_H_

#include	<MegaHeaders.h>
#include	<CActiveMovieStat.h>
#include	<list.h>

class	CTCPSocket;

#ifdef	NEEDS_STL_ALLOCATOR
typedef list<CActiveMovieStat, allocator<CActiveMovieStat> > 
														ActiveMovieStatList;
#else
typedef list<CActiveMovieStat> ActiveMovieStatList;
#endif

class CMonitorDataPackage
{
public:
	int	mAvailable;
	int	mActive;
	int	mDead;
	ActiveMovieStatList	*mQueueStats;
	int					mQueueSize;

	int					mDetachQueueData;

	CMonitorDataPackage(void);
	CMonitorDataPackage(int available,int active,int dead,
		ActiveMovieStatList *q,int qsize);
	~CMonitorDataPackage(void);
	void	DetachData(void);
	void	Read(CTCPSocket &socket);
	void	Write(CTCPSocket &socket);
	size_t	CalculateSize(void);

	virtual	const char *Name(void);
	virtual	void	Dump(ostream &o,const char *indent);

};

ostream& operator <<(ostream &o,CMonitorDataPackage &p);
ostream& operator <<(ostream &o,CMonitorDataPackage *p);

CTCPSocket&	operator<<(CTCPSocket &o,CMonitorDataPackage &p);
CTCPSocket& operator>>(CTCPSocket &o,CMonitorDataPackage &p);
size_t CalculateTCPSize(CMonitorDataPackage &p);

#endif
