/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CSTREAMDATA_H_
#define CSTREAMDATA_H_

#include	<MegaHeaders.h>
#include <iostream>
using namespace std;

#ifdef NETHFB
class CTCPSocket;
#endif

class CStreamData
{
	CLASS_NOCOPY(CStreamData)

protected:
	int		mStreamType;
	int		mStreamNumber;
	long	mIsKeyFrame;
	long	mIndex;
	long	mLen;
	long	mDataPosAccumulator;
	char	*mStreamData;
	int		mDataAttached;

public:
	CStreamData(void);
	CStreamData(int s_type,int s_num,long index,long len,long acc,
								long is_key_frame,char*);
	virtual ~CStreamData(void);
	void	DetachData(void);
	void	ReAttachData(void);
	int			GetStreamType(void);
	int			GetStreamNumber(void);
	long		GetIndex(void);
	long		GetLength(void);
	long		GetDataPosAccumulator(void);
	const char *GetStreamData(void);
	long		GetIsKeyFrame(void);

#ifdef NETHFB
	virtual void	Read(CTCPSocket &socket);
	virtual void	Write(CTCPSocket &socket);
	virtual	size_t	CalculateSize(void);
#endif

	virtual	const char *Name(void);
	virtual	void	Dump(ostream &o,const char *indent);
};

ostream& operator<<(ostream &o,CStreamData *sd);
ostream& operator<<(ostream &o,CStreamData &sd);

#ifdef NETHFB
CTCPSocket& operator<<(CTCPSocket &s,CStreamData &d);
CTCPSocket& operator>>(CTCPSocket &s,CStreamData &d);
size_t CalculateTCPSize(CStreamData &d);
#endif

#endif








