/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CSTREAMINFO_H_
#define	CSTREAMINFO_H_

#include	<MegaHeaders.h>
#include	<nmr_fraction.h>
#include	<duck_hfb.h>

#ifdef NETHFB
class CTCPSocket;
#endif

class CStreamInfo
{
public:
	CStreamInfo(void);
	~CStreamInfo(void);
	virtual	void	ExtractFromStream(HFB_STREAM_HANDLE primary_audio,
								HFB_STREAM_HANDLE strm,int s_num) = 0;
#ifdef NETHFB
	virtual	void	Read(CTCPSocket &socket) = 0;
	virtual	void	Write(CTCPSocket &socket) = 0;
	virtual	size_t	CalculateSize(void) = 0;
#endif
	virtual	double	ChunkTimeSize(long len) = 0;
	virtual double	GetTimingFactor(void) = 0;
	virtual	nmr_fraction<I32> GetTimingFactorAsFraction(void) = 0;
	virtual	unsigned long	GetFCCHandler(void) = 0;
};


#endif
