/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CSTREAMPARAMETERS_H_
#define CSTREAMPARAMETERS_H_

#include	<MegaHeaders.h>
#ifdef NETHFB
#include	<UDPPacketDefinition.h>
#endif

#include <iostream>
using namespace std;

class CAudioInfo;
class CVideoInfo;
#ifdef NETHFB
class CUDPSocket;
#endif

class CStreamParameters {
	CLASS_NOCOPY(CStreamParameters)

public:
	long	mDatarate;
	int		mHeight;
	int		mWidth;
	int		mNumAudioStreams;
	int		mNumVideoStreams;
	CAudioInfo	*mAudioInfo;
	CVideoInfo	*mVideoInfo;
	int			mOwnAudioInfo;
	int			mOwnVideoInfo;

public:
	CStreamParameters(long datarate,int height,int width,
		int num_aud_streams,int num_vid_streams,
		CAudioInfo *ainfo,int own_audio_info,
		CVideoInfo *vinfo,int own_video_info);
	~CStreamParameters(void);

	void	DetachStreamInfoObjects(void);
	
#ifdef NETHFB
	void	FillInUDPData(UDPStreamParameterBlock_t *data);
	void	UDPTransmit(CUDPSocket *socket);
	static CStreamParameters *CreateFromUDPData(
					const UDPStreamParameterBlock_t *data,int siz);
#endif

	virtual const char *Name(void);
	virtual	void	Dump(ostream &o,const char *indent);
};

ostream& operator<<(ostream& o,CStreamParameters *sp);
ostream& operator<<(ostream& o,CStreamParameters &sp);

#endif

