/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CVIDEOINFO_H_
#define CVIDEOINFO_H_

#include	<CStreamInfo.h>
#ifdef NETHFB
#include	<UDPPacketDefinition.h>
#endif
#include	<nmr_fraction.h>

class CVideoInfo: public CStreamInfo
{
public:

	DKBITMAP	mDKBitmap;
	int		mStreamNum;
	int		mSamplesPerFrame;
	int		mInitialFrames;
	nmr_fraction<I32> mFrameRate;
	unsigned long	mFCCHandler;

	CVideoInfo(void);
	~CVideoInfo(void);
	virtual	void	ExtractFromStream(HFB_STREAM_HANDLE primary_audio,
											HFB_STREAM_HANDLE strm,int s_num);

#ifdef NETHFB
	virtual	void	Read(CTCPSocket &socket);
	virtual	void	Write(CTCPSocket &socket);
	virtual	size_t	CalculateSize(void);
#endif
	virtual	double	ChunkTimeSize(long len);
	virtual	double	GetTimingFactor(void);
	virtual	nmr_fraction<I32> GetTimingFactorAsFraction(void);
	virtual	unsigned long GetFCCHandler(void);

#ifdef NETHFB
	virtual	void	FillInUDPData(UDPVideoInfoBlock_t *);
	static CVideoInfo *CreateFromUDPData(const UDPVideoInfoBlock_t *data,
																	int siz);
#endif

	virtual const char *Name(void);
	virtual void	Dump(ostream &o,const char *indent);
};

ostream& operator<<(ostream&o,CVideoInfo *vi);
ostream& operator<<(ostream&o,CVideoInfo &vi);

#ifdef NETHFB
CTCPSocket& operator<<(CTCPSocket &socket,CVideoInfo &vi);
CTCPSocket& operator>>(CTCPSocket &socket,CVideoInfo &vi);
size_t CalculateTCPSize(CVideoInfo &vi);
#endif

#endif
