/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include	<MegaHeaders.h>
#include	<CMosMessage.h>
#include	<CMosMessageType.h>
#include	<CPacket.h>
#include	<CPacketType.h>
#include	<CTCPSocket.h>
#include	<CAudioInfo.h>
#include	<CVideoInfo.h>
#include	<CConfiguration.h>
#include	<CStreamData.h>
#include	<CEventEntry.h>
#include	<CIndexData.h>
#include	<CMonitorDataPackage.h>

#ifdef	NEEDS_INSTANTIATIONS
#define	INSTANTIATING
#include	<CPacketType.cpp>
#include	<CMosMessageType.cpp>
#include	<CStreamParameters.h>

template class CPacketType< CVideoInfo >;
template class CPacketType< CAudioInfo >;
template class CPacketType< CConfiguration >;
template class CPacketType< CStreamData >;
template class CPacketType< CEventEntry >;
template class CPacketType< CIndexData >;
template class CPacketType< CMonitorDataPackage >;


template class CMosMessageType< CEventEntry >;
template class CMosMessageType< CStreamParameters >;


#endif

//// ANYTHING added here should have overloaded operators
// for TCPSocket<< TCPSocket>> and CalculateTCPSize()

const char *
CPacketType<CIndexData>::Name(void)
{
	return "CPacketType<CIndexData>";
}

const char *
CPacketType<CEventEntry>::Name(void)
{
	return "CPacketType<CEventEntry>";
}

const char *
CPacketType<CStreamData>::Name(void)
{
	return "CPacketType<CStreamData>";
}

const char *
CPacketType<CVideoInfo>::Name(void)
{
	return "CPacketType<CVideoInfo>";
}

const char *
CPacketType<CAudioInfo>::Name(void)
{
	return "CPacketType<CAudioInfo>";
}

const char *
CPacketType<CConfiguration>::Name(void)
{
	return "CPacketType<CConfiguration>";
}

const char *
CPacketType<CMonitorDataPackage>::Name(void)
{
	return "CPacketType<CMonitorDataPackage>";
}
