/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _nethfb_h
#define _nethfb_h

#ifndef NETHFB

#define lHFB_GetStreamingData HFB_GetStreamingData
#define lHFB_ReleaseStreamingData HFB_ReleaseStreamingData
#define lHFB_ReadData HFB_ReadData
#define lHFB_WhatsAhead HFB_WhatsAhead
#define lHFB_GetAudioInfo HFB_GetAudioInfo
#define lHFB_GetInitialFrames HFB_GetInitialFrames
#define lHFB_GetSamplesPerFrame HFB_GetSamplesPerFrame
#define lHFB_GetFrameRates HFB_GetFrameRates
#define lHFB_LoadIndex HFB_LoadIndex
#define lHFB_ParseFile HFB_ParseFile
#define lHFB_Init HFB_Init
#define lHFB_Exit HFB_Exit
#define lHFB_FindFile HFB_FindFile
#define lHFB_OpenFile HFB_OpenFile
#define lHFB_CloseFile HFB_CloseFile
#define lHFB_GetFileInfo HFB_GetFileInfo
#define lHFB_ResetStreams HFB_ResetStreams
#define lHFB_GetStream HFB_GetStream
#define lHFB_ReleaseStream HFB_ReleaseStream
#define lHFB_GetStreamInfo HFB_GetStreamInfo
#define lHFB_CreateBuffer HFB_CreateBuffer
#define lHFB_DestroyBuffer HFB_DestroyBuffer
#define lHFB_ResetBuffer HFB_ResetBuffer
#define lHFB_SetBufferMode HFB_SetBufferMode
#define lHFB_QueueOpenFile HFB_QueueOpenFile
#define lHFB_GetBufferPerCentFull HFB_GetBufferPerCentFull
#define lHFB_GetmovieSize HFB_GetmovieSize
#define lHFB_InitBuffer HFB_InitBuffer
#define lHFB_GetBufferSpace HFB_GetBufferSpace
#define lHFB_FillBuffer HFB_FillBuffer
#define lHFB_getBufferStatus HFB_getBufferStatus
#define lHFB_FramestoNextKeyFrame HFB_FramestoNextKeyFrame
#define lHFB_FrameToChunk HFB_FrameToChunk
#define lHFB_PreviousKeyFrame HFB_PreviousKeyFrame
#define lHFB_GetIndexFlags HFB_GetIndexFlags
#define lHFB_getDataPosition HFB_getDataPosition
#define lHFB_ConditionBuffer HFB_ConditionBuffer
#define lHFB_WalkFlags HFB_WalkFlags

#define lHFB_GetStreamParentBuffer HFB_GetStreamParentBuffer
#define lHFB_GetStreamParentFile HFB_GetStreamParentFile

#define lHFB_GetStreamRateAndScale HFB_GetStreamRateAndScale
#define lHFB_GetStreamFCCs HFB_GetStreamFCCs
#define lHFB_GetStreamSampleSize HFB_GetStreamSampleSize

#else
#if defined(__cplusplus)
extern "C" {
#endif

#include <duck_hfb.h>

HFB_DATA_HANDLE lHFB_GetStreamingData(HFB_STREAM_HANDLE ,void **,long *,enum dukDirect ,int );
void lHFB_ReleaseStreamingData(HFB_BUFFER_HANDLE ,HFB_DATA_HANDLE );
int lHFB_ReadData(HFB_STREAM_HANDLE ,void *,long *,enum dukDirect ,int );
int lHFB_WhatsAhead(MFP_STREAM_HANDLE ,int ,int *);
DKWAVEFORM *lHFB_GetAudioInfo(HFB_STREAM_HANDLE ,int *,int *,int *,int *);
int lHFB_GetInitialFrames(HFB_STREAM_HANDLE ,HFB_STREAM_HANDLE );
int lHFB_GetSamplesPerFrame(HFB_STREAM_HANDLE ,HFB_STREAM_HANDLE );
void lHFB_GetFrameRates(HFB_STREAM_HANDLE ,HFB_STREAM_HANDLE ,int *,int *);
void lHFB_LoadIndex(HFB_FILE_HANDLE ,HFB_BUFFER_HANDLE );
int lHFB_ParseFile(HFB_FILE_HANDLE ,HFB_BUFFER_HANDLE );
int lHFB_Init(int ,int ,int );
void lHFB_Exit(void);
HFB_FILE_HANDLE lHFB_FindFile(const char *);
HFB_FILE_HANDLE lHFB_OpenFile(const char *,HFB_BUFFER_HANDLE );
void lHFB_CloseFile(HFB_FILE_HANDLE );
HFB_FILE_INFO *lHFB_GetFileInfo(HFB_FILE_HANDLE );
void lHFB_ResetStreams(HFB_BUFFER_HANDLE );
HFB_STREAM_HANDLE lHFB_GetStream(HFB_FILE_HANDLE ,const char *,int ,unsigned long );
void lHFB_ReleaseStream(HFB_STREAM_HANDLE );
HFB_STREAM_INFO *lHFB_GetStreamInfo(HFB_STREAM_HANDLE );
HFB_BUFFER_HANDLE lHFB_CreateBuffer(long ,long );
void lHFB_DestroyBuffer(HFB_BUFFER_HANDLE );
int lHFB_ResetBuffer(HFB_BUFFER_HANDLE ,long ,long );
int lHFB_SetBufferMode(HFB_BUFFER_HANDLE ,enum HFB_Modes );
HFB_FILE_HANDLE lHFB_QueueOpenFile(const char *,HFB_BUFFER_HANDLE );
long lHFB_GetBufferPerCentFull(HFB_BUFFER_HANDLE );
long lHFB_GetmovieSize(HFB_BUFFER_HANDLE );
void lHFB_InitBuffer(HFB_BUFFER_HANDLE ,HFB_FILE_HANDLE ,int ,int );
long lHFB_GetBufferSpace(HFB_BUFFER_HANDLE );
int lHFB_FillBuffer(HFB_BUFFER_HANDLE ,long ,long );
int lHFB_getBufferStatus(HFB_BUFFER_HANDLE );
int lHFB_FramestoNextKeyFrame(HFB_STREAM_HANDLE ,int ,int *);
int lHFB_FrameToChunk(HFB_STREAM_HANDLE ,int );
int lHFB_PreviousKeyFrame(HFB_STREAM_HANDLE ,int );
int lHFB_GetIndexFlags(HFB_STREAM_HANDLE ,enum FTYPE ,int );
long lHFB_getDataPosition(HFB_STREAM_HANDLE ,HFB_DATA_HANDLE );
int lHFB_ConditionBuffer(HFB_BUFFER_HANDLE ,long ,long );

HFB_BUFFER_HANDLE lHFB_GetStreamParentBuffer(HFB_STREAM_HANDLE );
HFB_FILE_HANDLE lHFB_GetStreamParentFile(HFB_STREAM_HANDLE);

void lHFB_GetStreamRateAndScale(HFB_STREAM_HANDLE xStream,long *rate, long *scale);
unsigned long lHFB_GetStreamFCCs(HFB_STREAM_HANDLE,unsigned long *, unsigned long *);
int lHFB_GetStreamSampleSize(HFB_STREAM_HANDLE xStream);

#if defined(__cplusplus)
}
#endif

#endif

#endif
