/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _duck_mem_h
#define _duck_mem_h

#include <stddef.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef enum tmemtype {
	DMEM_GENERAL = 0,
	DMEM_TEMP,
	DMEM_CDBUFF,
	DMEM_FRAMEBUFF
} dmemType;

/* 
	size_t should be found in stddef.h on most compilers
	if necessary you can define this to be an unsigned int
*/

void *duck_malloc(size_t, dmemType);
void *duck_calloc(size_t, size_t, dmemType);
void duck_free(void *);

void *duck_memcpy(void *dest, const void *source, size_t length);
void *duck_memset(void *dest, int val , size_t length);
int duck_strcmp(const char *one, const char *two);

void Setduck_malloc(void *(*ptr_malloc)(size_t));
void Setduck_calloc(void *(*ptr)(size_t, size_t));
void Setduck_free(void (*ptr)(void *));

void DXV_Setduck_malloc(void *(*ptr_malloc)(size_t));
void DXV_Setduck_calloc(void *(*ptr)(size_t, size_t));
void DXV_Setduck_free(void (*ptr)(void *));
#ifdef __cplusplus
}
#endif

#endif