
PROJS = 
CLEANER = 

!if EXIST(sega)
PROJS = $(PROJS) SEGA1
CLEANER = $(CLEANER) csega
!endif

!if EXIST(sony)
PROJS = $(PROJS) SONY1
CLEANER = $(CLEANER) csony
!endif

!if EXIST(dos)
PROJS = $(PROJS) DOS1
CLEANER = $(CLEANER) cdos
!endif

!if EXIST(win95)
PROJS = $(PROJS) WIN951
CLEANER = $(CLEANER) cwin95
!endif

!if EXIST(irix)
PROJS = $(PROJS) irix1
CLEANER = $(CLEANER) cirix
!endif

!if EXIST(solaris)
PROJS = $(PROJS) solaris
CLEANER = $(CLEANER) csolaris
!endif

!if EXIST(linux)
PROJS = $(PROJS) linux1
CLEANER = $(CLEANER) clinux
!endif

ALL1: $(PROJS)

ROOT=$(ROOT:/=\)

TEMPLATES=$(ROOT)template.mk/ 

TEMPLATES=$(TEMPLATES:/=\)

##
## Master Makefile, creates makefiles for platforms and projects
##
## building for a target consists of building a makefile (if necessary)
## setting any environment variables needed and launching the make
##

linux:
	mkdir linux

LINUX1 : linux
	nmake /NOLOGO linux\makefile OS=linux
#	make -C linux

clinux:
	SET ROOT=$(ROOT:/=\)
	nmake /NOLOGO linux\makefile OS=linux
	SET ROOT=$(ROOT:\=/)
#	make -C linux clean
	del linux\makefile

irix:
	mkdir irix

IRIX1 : irix
	nmake /NOLOGO irix\makefile OS=irix
#	make -C irix

cirix:
	SET ROOT=$(ROOT:/=\)
	nmake /NOLOGO irix\makefile OS=irix
	SET ROOT=$(ROOT:\=/)
#	make -C irix clean
	del irix\makefile

##########################
#   BEGIN SUN SOLARIS
##########################

solaris:
	mkdir solaris

SOLARIS1 : solaris
	nmake /NOLOGO solaris\makefile OS=solaris
#	make -C solaris

csolaris:
	SET ROOT=$(ROOT:/=\)
	nmake /NOLOGO solaris\makefile OS=solaris
	SET ROOT=$(ROOT:\=/)
#	make -C solaris clean
	del solaris\makefile

##########################
#   END SUN SOLARIS
##########################

SEGA1 :
!if EXIST(sega)
	nmake /NOLOGO sega\makefile "OS=sega"
	SET ROOT=$(ROOT:\=/)
	SET PATH=%SHCDir%;%SHCDir%\BIN;%GCCDir%\BIN;%PATH%
	SET C_INCLUDE_PATH=%GCCDir%\include;%GCCDir%\include\machine
	SET CPLUS_INCLUDE_PATH=%GCCDir%\include\cxx;%GCCDir%\include
	SET LIBRARY_PATH=%GCCDir%\LIB
	SET GO32=EMU %GCCDir%\BIN\EMU387
	SET INFOPATH=%GCCDir%\INFO
	SET SHC_LIB=%SHCDir%\bin
	SET SHC_INC=%SHCDir%\include
	SET SHC_TMP=%temp%
	make -C sega
	cd sega
	nmake -f makefile.shc
	cd ..
!else
	cd
!endif

csega:
	SET ROOT=$(ROOT:/=\)
	nmake /NOLOGO sega\makefile "OS=sega"
	SET ROOT=$(ROOT:\=/)
	SET PATH=%SHCDir%;%SHCDir%\BIN;%GCCDir%\BIN;%PATH%
	SET C_INCLUDE_PATH=%GCCDir%\include;%GCCDir%\include\machine
	SET CPLUS_INCLUDE_PATH=%GCCDir%\include\cxx;%GCCDir%\include
	SET LIBRARY_PATH=%GCCDir%\LIB
	SET GO32=EMU %GCCDir%\BIN\EMU387
	SET INFOPATH=%GCCDir%\INFO
	SET SHC_LIB=%SHCDir%\bin
	SET SHC_INC=%SHCDir%\include
	SET SHC_TMP=%temp%
	make -C sega clean
	del sega\makefile

SONY1 :
!if EXIST(SONY)
	nmake /NOLOGO sony\makefile OS=sony
	SET PATH=%PSXDir%\BIN;%PATH%
	set COMPILER_PATH=%PSXDir%/psyq
	set PSYQ_PATH=%PSXDir%/psyq
	set C_INCLUDE_PATH=%PSXDir%/include
	set C_PLUS_INCLUDE_PATH=%PSXDir%/include
	set LIBRARY_PATH=%PSXDir%/lib
	set ROOT=$(ROOT:\=/)
	make -C SONY
!else
	cd
!endif

csony:
	SET ROOT=$(ROOT:/=\)
	nmake /NOLOGO sony\makefile OS=sony
	SET ROOT=$(ROOT:\=/)
	make -C sony clean
	del sony\makefile

DOS1 :
!if EXIST(DOS) 
	nmake /NOLOGO dos\makefile OS=dos
	cd dos
	set include=%WatcomDir%\h;%WatcomDir%\h\win
	set watcom=%WatcomDir%
	set wcl386=/lwin386
	nmake /NOLOGO everything
	cd ..
!else
	cd
!endif
	
cdos:
	SET ROOT=$(ROOT:/=\)
	nmake /NOLOGO dos\makefile OS=dos
	cd dos
	nmake /NOLOGO clean
	cd ..
	del dos\makefile
	
WIN951:
!if EXIST(win95) 
	nmake /NOLOGO win95\makefile OS=win95
	cd win95
	set INCLUDE=%MSDevDir%\INCLUDE;%MSDevDir%\MFC\INCLUDE;%INCLUDE%
	set LIB=%MSDevDir%\LIB;%MSDevDir%\MFC\LIB;%LIB%
	SET ROOT=$(ROOT:/=\)
	nmake /NOLOGO OS=win95
	cd ..
!else
	cd
!endif

cwin95:
	SET ROOT=$(ROOT:/=\)
	nmake /NOLOGO win95\makefile OS=win95
	cd win95
	nmake /NOLOGO clean
	cd ..
	del win95\makefile

##
## How to build a makefile
##
## Files to be included are:
##
## $(TEMPLATES)$(OS)\template.mk - system specific, project independent
## $(TEMPLATES)template.mk - system independent, project independent
## $(OS)\template.mk - system specific, project specific
## src\template.mk - system independent, project specific
##
##

$(OS)\makefile : \
!if EXIST($(TEMPLATES)$(OS)\template.mk)
	$(TEMPLATES)$(OS)\template.mk \
!endif
!if EXIST($(TEMPLATES)$(OS)\end.mk)
	$(TEMPLATES)$(OS)\end.mk \
!endif
!if EXIST($(TEMPLATES)$(OS)\header.mk)
	$(TEMPLATES)$(OS)\header.mk \
!endif
!if EXIST($(TEMPLATES)template.mk)
	$(TEMPLATES)template.mk \
!endif
!if EXIST(src\template.mk)
	src\template.mk \
!endif
!if EXIST($(OS)\template.mk)
	$(OS)\template.mk \
!endif
	$(ROOT)template.mk\makefile.mk
!if EXIST($(TEMPLATES)$(OS)\header.mk)
	copy /B $(TEMPLATES)$(OS)\header.mk $@
!else
	@echo ##### THIS FILE GENERATED AUTOMATICALLY >$@
	@echo OS=$(OS)>>$@
	@echo everything : all >>$@
	@echo ##### >>$@
!endif
!if EXIST($(TEMPLATES)$(OS)\template.mk)
	copy /B $@+$(TEMPLATES)$(OS)\template.mk $@
!endif
!if EXIST($(TEMPLATES)template.mk)
	copy /B $@+$(TEMPLATES)template.mk $@
!endif
!if EXIST(src\template.mk)
	copy /B $@+src\template.mk $@
!endif
!if EXIST($(OS)\template.mk)
	copy /B $@+$(OS)\template.mk $@
!elseif EXIST($(TEMPLATES)$(OS)\end.mk)
	copy /B $@+$(TEMPLATES)$(OS)\end.mk $@
!endif

clean : $(CLEANER)
	echo cleaned up...
