/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/**

	DXL24C.C


	this module contains the following callable routines:

**/

#include "dkpltfrm.h"
#include <stdlib.h>
#include "duktypes.h"
#include "cduck.h"
#include "dxparams.h"
#include "dxl_main.h"

#define IADD 0x0004
#define ISHIFT    4
#define IOFFSET 4096

#define VOFF swidth
#define COFF cwidth

extern int gswidth24;
extern dxVector8 *dx_vloc;
extern blockInfo *dx_bloc;
extern dxVector32 dx_index;

extern U32 *dxLast;                            /* for C */
extern U32 *dxcLast;                            /* for C */

/****************** C versions ***********************/

extern dxVector8 vectbl[1024*4*4];

/*********** MACROS: */

#define GETVECCNEW \
	temp=*(long *)(tbl+IOFFSET+index); \
     cvp+=(temp>>1); \
	 index+=IADD; \
     if(temp&1) \
		if(!(index=(*vloc++)<<ISHIFT)) { \
			index=(*vloc++)<<ISHIFT; \
			temp=*(long *)(tbl+index+(8192+IOFFSET));\
			index+=IADD; \
			if(temp&1) index=(*vloc++)<<ISHIFT; \
			cvp +=(temp>>1); \
		}\
	*(clast+COFF)=(*clast)+cvp; \
	++clast;

#define GVHVNEW1 \
	index+=IADD;                      \
	temp=*(long *)(tbl+index-IADD);        \
	vp+=(temp>>1);                    \
     if(temp&1){                       \
		if(!(index=(*vloc++)<<ISHIFT)){\
			index=(*vloc++)<<ISHIFT;   \
			temp=*(long *)(tbl+index+8192); \
			index+=IADD;               \
			if(temp&1) index=(*vloc++)<<ISHIFT;\
			temp >>= 1; \
			vp +=temp; \
		} \
	}\

#define GVHVNEW2 \
	temp=*(long *)(tbl+index);        \
	temp2 = vp<<16;\
	vp+=(temp>>1);                    \
	index+=IADD;                      \
	if(temp&1){                       \
		if(!(index=(*vloc++)<<ISHIFT)){\
			index=(*vloc++)<<ISHIFT;   \
			temp=*(long *)(tbl+index+8192); \
			index+=IADD;               \
			if(temp&1) index=(*vloc++)<<ISHIFT;\
			temp >>= 1; \
			vp +=temp; \
		} \
	}\
	temp = *last++; \
    *(last+VOFF-1)= (unsigned short)(temp+vp)+ ((temp+temp2)&0xffff0000);
					
#define DOIF \
		vp=*(short *)((short *)(last+VOFF)+1)-*(short *)((short *)last+1); \
		last++;
	
#define DOIFC \
		DOIF \
		cvp = *(clast+COFF)-*clast; \
		clast++;


#define GVHV1 GVHVNEW1
#define GVHV2 GVHVNEW2
#define GETVECC GETVECCNEW

void c_dxi(U32 width) {
    U8 *cbloc=(U8 *)dx_bloc;
    U32 xcnt;
    long temp,temp2,vp=0;
    long *last=(long*)dxLast;
    dxVector32 index=dx_index;
    dxVector8 *vloc=dx_vloc;
    dxVector8 *tbl=&vectbl[TBLOFFSET];
    U32 lbctl;
    int swidth = gswidth24;
    int cwidth = gswidth24;

    do{
	    lbctl =*cbloc++;
	
		xcnt = (width > (128/4)) ? (128/4) : width;
		width -= xcnt;	    
	
		xcnt>>=2; 
	    while(xcnt--){
			if(!(lbctl&1)){         /*/ TM*/
				lbctl>>=1;
				GVHV1         /*/ hit me agin:*/
				GVHV2
			}else {    /*/ if IF*/
				lbctl>>=1;
				last++;
				//if (!(lbctl & 1))
				{
					vp=*(short *)((short *)(last+VOFF)-1)-*(short *)((short *)last-1);
				}
			}
		}
    }while(width);

	dx_index=index;
	dx_vloc=vloc;
}

void c_dxic(U32 width) {
    U8 *cbloc=(U8 *)dx_bloc; /*/     ENDIAN issues -- get U8s*/
    U32 xcnt;
    long temp,temp2,vp=0,cvp = 0;
    long *last=(long*)dxLast;
    long *clast=(long*)dxcLast;
    dxVector32 index=dx_index;
    dxVector8 *vloc=dx_vloc;
    dxVector8 *tbl=&vectbl[TBLOFFSET];
    U32 lbctl;    
    int swidth = gswidth24;
    int cwidth = gswidth24;

    do{
	    lbctl =*cbloc++;

	    xcnt = (width > (128/4)) ? (128/4) : width;
	    width -= xcnt;

	    xcnt>>=2;
	    do{
			if(!(lbctl&1)){ /* TM */
				lbctl>>=1;
				GETVECC
				GVHV1     /*/ hit me agin:*/
				GVHV2
			}else {    /*/ if IF*/
				lbctl>>=1;
				clast++;
				last++;
				//if (!(lbctl & 1))
				{
					vp=*(short *)((short *)(last+VOFF)-1)-*(short *)((short *)last-1);
					cvp = *(clast+COFF-1)-*(clast-1);
				}
			}
	    }while(--xcnt);
	}while(width);

	dx_index=index;
	dx_vloc=vloc;
}

void c_dxic2(U32 width) {
    U8 *cbloc=(U8 *)dx_bloc; /*/     ENDIAN issues -- get U8s*/
    U32 xcnt;
    long temp,temp2, vp=0,cvp = 0;
    long *last=(long*)dxLast;
    long *clast=(long*)dxcLast;
    dxVector32 index=dx_index;
    dxVector8 *vloc=dx_vloc;
    dxVector8 *tbl=&vectbl[TBLOFFSET];
    U32 lbctl;    
    int swidth = gswidth24;
    int cwidth = gswidth24*2;
   
    do{
	    lbctl =*cbloc++;

	    xcnt = (width > (128/4)) ? (128/4) : width;
	    width -= xcnt;

	    xcnt>>=2;
	    do{
			if(!(lbctl&1)){ /* TM */
				lbctl>>=1;
				GETVECC
				GVHV1     /*/ hit me agin:*/
				GETVECC
				GVHV2
			}else {    /*/ if IF*/
				lbctl>>=1;
				clast += 2;
				last++;
				//if (!(lbctl & 1))
				{
					vp=*(short *)((short *)(last+VOFF)-1)-*(short *)((short *)last-1);
					cvp = *(clast+COFF-1)-*(clast-1);
				}
			}
	    }while(--xcnt);
	}while(width);

	dx_index=index;
	dx_vloc=vloc;
}

