;/***********************************************\
;??? bssm.ash
; contains 16bit to 16bit blit macros using MMX
;\***********************************************/ 

INCLUDE dxparam.ash 
INCLUDE prologue.ash

ifndef WIN95 
    ifdef DEBUG
        INCLUDE debugger.ash
    endif
endif           

;************************************************
UBLOC           EQU     0
BLKWIDTH        EQU     UBLOC+4
PIXELS_LEFT     EQU     BLKWIDTH+4

LOCAL_STACK_SZ  EQU     PIXELS_LEFT+4

;************************************************
_4_PIXEL_BLOCK MACRO            
if HSTRETCH
    movq        mm0,[ebp]       ;4 pixels
    movq        mm1,mm0
    movq        mm2,mm1         ;ready for high pixels

    punpcklwd   mm0,mm1         ;unpack low pixels
    punpckhwd   mm2,mm1         ;unpack high pixels
    movq        [edi],mm0       ;2 stretched pixels
    movq        [edi+8],mm2     ;2 stretched pixels
else
    movq        mm0,[ebp]
    movq        [edi],mm0
endif
ENDM

;************************************************
; (1) 16 bit pixel read from source
_1_16BIT_PIXEL MACRO            
if HSTRETCH
    mov     eax,[ebp] 
    mov     ebx,eax
    rol     ebx,16
    xchg    bx,ax
    mov     [edi],ebx
    add     ebp,2
    add     di,4
else
    mov     eax,[ebp]
    mov     [edi],ax
    add     ebp,2
    add     di,2
endif
ENDM

;************************************************
WR_REMAINING_PIXELS MACRO
LOCAL wr_one_pixel, no_remaining_pixels

    cmp     DWORD PTR[esp+PIXELS_LEFT],0h           ;check for remaining pixels
    jz      no_remaining_pixels
wr_one_pixel:                                       ;occurs when page does not align with
    _1_16BIT_PIXEL                                  ;4 pixel boundary
    dec     DWORD PTR[esp+PIXELS_LEFT]
    jnz     wr_one_pixel
no_remaining_pixels:        
ENDM

;************************************************
; blit to screen, source and dest the same
BSS_RA_MMX MACRO
        DUCK_PROLOGUE                         
        sub     esp,LOCAL_STACK_SZ

        mov     edi,[eax+vDest]                 ;points at screen
        mov     ebp,[eax+dxDest]                ;points at source buffer with 16-bit pixels        
        mov     ecx,[eax+Xwidth]

        mov     [esp+PIXELS_LEFT],ecx
        and     DWORD PTR[esp+PIXELS_LEFT],03h      
        shr     ecx,2                           ;4 pixel block
        jz      incompleteBlock   

bcopyloop:
        _4_PIXEL_BLOCK
        add     ebp,8

if HSTRETCH
        add     edi,16
else
        add     edi,8
endif                           
        dec     ecx
        jnz     bcopyloop

incompleteBlock:
        WR_REMAINING_PIXELS

        add     esp,LOCAL_STACK_SZ
        pop     es
        pop     ds
        popad
        ret
ENDM
