;   Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.
;
;   This file is part of VpVision.
;
;   VpVision is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License ver. 2,
;   as published by the Free Software Foundation (www.fsf.org).
;
;   Foobar is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with VpVision; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;/***********************************************\
;??? dxi16a.asm
; decompress and blit intraframe
;\***********************************************/ 
		.586
        .MODEL  flat, SYSCALL, os_dos
        .CODE
            
ifdef CHROMALINE
  ifdef BLOCK_2X
	NAME dxic162a
    PUBLIC dxic162a_
    PUBLIC _dxic162a
  else
	NAME dxic16a
    PUBLIC dxic16a_
    PUBLIC _dxic16a
  endif
 else
	NAME dxi16a            
    PUBLIC dxi16a_
    PUBLIC _dxi16a
endif


EXTRN _vectbl:DWORD     

;contains dxparam stucture offset equates
INCLUDE dxparam.ash
INCLUDE prologue.ash

ifndef WIN95 
	ifdef DEBUG
		INCLUDE debugger.ash
	endif
endif           

;************************************************
EOS MACRO fixupLabel, eosRet
	mov			bl,[ebp]     				;get next compressed data index
	inc			ebp                 		; point to next

	and			ebx,0ffh            		;  see if 0 (clear high order)
	jz			fixupLabel

    shl			ebx,4
	add			edx,eax

    jmp         eosRet
ENDM

;************************************************
GV MACRO vec_offset, eosLabel
	mov			eax,[ebx+_vectbl+vec_offset] ;lookup string value
	add			ebx,4                    	; bump pointer

	sar			eax,1                   	; check end-of-string flag
	jc			eosLabel                   	; jump if not

	add			edx,eax
ENDM

;************************************************
FIX_UP MACRO vec_offset, fixupRet
LOCAL moreok
; HEY! got a bad pixel -- needs *5 fixins; start a
; new vec, add 1st pair*5 to eax, then do your regular:
	mov			bl,[ebp]					;start new vec
	inc			ebp

	shl			ebx,4
	add			edx,eax						;add in the ole dVq

	mov			eax,[ebx+_vectbl+vec_offset]	;ax=big delta burke
	add			ebx,4

	sar			eax,1
	jnc			moreok

	xor         ebx,ebx
nop

	mov			bl,[ebp]     				;get
	inc			ebp

	shl			ebx,4
nop

moreok:
    lea         eax,[eax+eax*4]             ;mult eax by 5
nop

    add         edx,eax
	jmp			fixupRet
ENDM

;************************************************
FIX_UP2 MACRO vec_offset, fixupRet, addrOffset
LOCAL moreok
; HEY! got a bad pixel -- needs *5 fixins; start a
; new vec, add 1st pair*5 to eax, then do your regular:
	mov			bl,[ebp]					;start new vec
	inc			ebp

	shl			ebx,4
	add			edx,eax						;add in the ole dVq

	mov			eax,[ebx+_vectbl+vec_offset]	;ax=big delta burke
	add			ebx,4

	sar			eax,1
	jnc			moreok

	mov			bl,[ebp]     				;get
	inc			ebp

	shl			ebx,4
nop

moreok:
    lea         eax,[eax+eax*4]             ;mult eax by 5
    and         ebx,0fffh

    add         edx,eax
    mov         eax,[esi+addrOffset]

    add         eax,edx
nop

    mov         [esi+addrOffset],eax
    mov         [edi+addrOffset],eax

	jmp			fixupRet
ENDM

;************************************************
FIX_UP3 MACRO vec_offset, addrOffset
LOCAL moreok
; HEY! got a bad pixel -- needs *5 fixins; start a
; new vec, add 1st pair*5 to eax, then do your regular:
	mov			bl,[ebp]					;start new vec
	inc			ebp

	shl			ebx,4
	add			edx,eax						;add in the ole dVq

	mov			eax,[ebx+_vectbl+vec_offset]	;ax=big delta burke
	add			ebx,4

	sar			eax,1
	jnc			moreok

	mov			bl,[ebp]     				;get
	inc			ebp

	shl			ebx,4
nop

moreok:
    lea         eax,[eax+eax*4]             ;mult eax by 5
    and         ebx,0fffh

    add         edx,eax
    mov         eax,[esi+addrOffset]

    add         eax,edx
nop

    mov         [esi+addrOffset],eax
    mov         [edi+addrOffset],eax

    add     esi,8
    add     edi,8

	dec		ecx
	jnz		X_LOOP             
    
	pop     eax
	ret
ENDM

;************************************************
GV2		MACRO vec_offset, addrOffset, fixupLabel
LOCAL	more, more2, GV2_exit
	mov			eax,[ebx+_vectbl+vec_offset]    ;lookup string value

	sar			eax,1                   	    ;check end-of-string flag
	jnc			more                    	    ;jump if not

	mov			bl,[ebp]     				    ;get next compressed data index
	inc			ebp                 		    ;point to next

	and			ebx,0ffh            		    ;see if 0 (clear high order)
	jz			fixupLabel

    add			edx,eax
    mov         eax,[esi+addrOffset]

	shl			ebx,4
    add         eax,edx

    mov         [esi+addrOffset],eax
    mov         [edi+addrOffset],eax

    jmp GV2_exit

more:
	add			edx,eax
    mov         eax,[esi+addrOffset]

	add			ebx,4                    	    ;bump pointer
    add         eax,edx

    mov         [esi+addrOffset],eax
    mov         [edi+addrOffset],eax

GV2_exit:
ENDM

;************************************************
GV3		MACRO vec_offset, addrOffset, fixupLabel
LOCAL	more, more2
	mov			eax,[ebx+_vectbl+vec_offset]    ;lookup string value

	sar			eax,1                   	    ;check end-of-string flag
	jnc			more                    	    ;jump if not

	mov			bl,[ebp]     				    ;get next compressed data index
	inc			ebp                 		    ;point to next

	and			ebx,0ffh            		    ;see if 0 (clear high order)
	jz			fixupLabel

    add			edx,eax
    mov         eax,[esi+addrOffset]

	shl			ebx,4
    add         eax,edx

    mov         [esi+addrOffset],eax
    mov         [edi+addrOffset],eax

    add         esi,8
    add         edi,8

    dec		ecx
	jnz		X_LOOP             

    pop     eax
	ret

more:
	add			edx,eax
    mov         eax,[esi+addrOffset]

	add			ebx,4                    	    ;bump pointer
    add         eax,edx

    mov         [esi+addrOffset],eax
    mov         [edi+addrOffset],eax

    add     esi,8
    add     edi,8

    dec		ecx
	jnz		X_LOOP             

    pop     eax
	ret

ENDM

ifdef CHROMALINE
  ifdef BLOCK_2X
    dxic162a_:
    _dxic162a:
   else
    dxic16a_:
    _dxic16a:
   endif
 else
    dxi16a_:
    _dxi16a:
endif

;************************************************
        mov     ecx,[eax+xWidth]
		xor		edx,edx						;init vp
        
        push    eax
        jmp     X_LOOP

X_LOOP:
ifdef CHROMALINE
		GV 4096, eos1								;do chroma
endif

fixupRet1:
	    GV2  0, 0, fixup2

fixupRet2:

ifdef CHROMALINE
    ifdef BLOCK_2X
		GV 4096, eos3								;do chroma
    endif
endif

fixupRet3:
	    GV3  0, 4, fixup4


eos1:
    EOS     fixup1, fixupRet1

fixup1:
    FIX_UP   4096, fixupRet1

fixup2:
    FIX_UP2   0, fixupRet2, 0

eos3:
    EOS     fixup3, fixupRet3

fixup3:
    FIX_UP   4096, fixupRet3

fixup4:
    FIX_UP3   0, 4

;************************************************
		END
