;   Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.
;
;   This file is part of VpVision.
;
;   VpVision is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License ver. 2,
;   as published by the Free Software Foundation (www.fsf.org).
;
;   Foobar is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with VpVision; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;/***********************************************\
;??? dxi16blt.asm
; decompress and blit
;\***********************************************/ 
		.586
        .MODEL  flat, SYSCALL, os_dos
        .CODE
    
;11/7/96 - removing globals... (passing in structure containing parameters)
;1/2/97 - stripped out redundant code 

ifdef CHROMALINE
  ifdef BLOCK_2X
	NAME dxic162e
    PUBLIC dxic162e_
    PUBLIC _dxic162e
  else
	NAME dxic16e
    PUBLIC dxic16e_
    PUBLIC _dxic16e
  endif
 else
	NAME dxi16e            
    PUBLIC dxi16e_
    PUBLIC _dxi16e
endif


EXTRN _vectbl:DWORD     

;contains dxparam stucture offset equates
INCLUDE dxparam.ash
INCLUDE prologue.ash

ifndef WIN95 
	ifdef DEBUG
		INCLUDE debugger.ash
	endif
endif           

;************************************************
;; note that interframe decoder is hard-coded for a 320-wide refernce (lastdecomp) buffer
;;  we can't give that much speed away in low end machines.
HRES	equ		8

;************************************************
GV MACRO vec_offset, fixupLabel
LOCAL	more
	mov			eax,[_vectbl+(ebx)+vec_offset] ;lookup string value
;	add			ebx,4                    	; bump pointer
	sar			eax,1                   	; check end-of-string flag
    lea         ebx,[ebx+4]
	jnc			more                    	; jump if not

	mov			bl,[ebp]     				;get next compressed data index
	inc			ebp                 		; point to next
	and			ebx,0ffh            		;  see if 0 (clear high order)
	jz			fixupLabel

    shl			ebx,4

more:
;	add			edx,eax
    lea         edx,[edx+eax]
ENDM

;************************************************
FIX_UP MACRO vec_offset, fixupRet
LOCAL moreok
; HEY! got a bad pixel -- needs *5 fixins; start a
; new vec, add 1st pair*5 to eax, then do your regular:
	mov			bl,[ebp]					;start new vec
	shl			ebx,4
	inc			ebp
	add			edx,eax						;add in the ole dVq

	mov			eax,[_vectbl+(ebx)+vec_offset]	;ax=big delta burke
;	add			ebx,4
	sar			eax,1
    lea         ebx,[ebx+4]
	jnc			moreok

	xor         ebx,ebx
	mov			bl,[ebp]     				;get
	inc			ebp
	shl			ebx,4

moreok:
    lea         eax,[eax+eax*4]             ;mult eax by 5
    add         edx,eax

	jmp			fixupRet
ENDM

;************************************************
GET_NEW_BLOC_CONTROL MACRO
    mov		eax,[esp+UBLOC]	    		;get a new one block control word
    mov		ecx,[eax]
	add		eax,4
	mov		[esp+UBLOC],eax                                     

	movd	eax,mm5
    cmp		eax,0
    jle		save_vector
    jmp		DXLOOP
ENDM
    
;************************************************
;local var equates
STRUCT_PTR      EQU     0     
BLKWIDTH		EQU		STRUCT_PTR+4
BLKCWCOUNT		EQU		BLKWIDTH+4
UBLOC			EQU		BLKCWCOUNT+4
LINE_PITCH      EQU     UBLOC+4

LOCAL_STACK_SZ  EQU     LINE_PITCH+4

ifdef CHROMALINE
  ifdef BLOCK_2X
    dxic162e_:
    _dxic162e:
   else
    dxic16e_:
    _dxic16e:
   endif
 else
    dxi16e_:
    _dxi16e:
endif

;************************************************
ifdef WIN95	    
		mov		eax,[esp+4]
endif
        push    esi
        push    edi
        push    eax
        push    ebx
    ;    push    esp
        push    ebp
        push    ecx
        push    edx

        mov		esi,[eax+dxLast]            ;esi=dx_last; pixel array

		sub		esp,LOCAL_STACK_SZ

		mov		edx,[eax+dx_bloc] 
		mov		ebp,[eax+dx_vloc]			;offset, sel
		mov		ebx,[eax+dx_index]			;ebx=index into delta tbl from (1st compressed data pt * 4).


 		mov		edi,[eax+dxDest]       		;get dx destination

	    mov		ecx,[edx]
		add 	edx,4

        
	    movd    mm7,EIGHT
		mov		[esp+UBLOC],edx             ;work ubloc
                                                                      
        mov     [esp],eax                   ;save struct ptr        
 		mov		edx,[eax+xWidth]            ;get width
    	shr		edx,2

        movd    mm6,THIRTYTWO
        movd    mm5,edx                     

        movd    mm2,[eax+vDest]

		movd	eax,mm5
		xor		edx,edx						;init vp

DXLOOP:
		mov 	[esp+BLKCWCOUNT],eax
		cmp		eax,32
        jle		LessThan32
		mov	    DWORD PTR[esp+BLKCWCOUNT],32

LessThan32:        
        psubd   mm5,mm6

X_LOOP:
		rcr	ecx,1     
        jnc DX_PIX

        movd        eax,mm2                     ;vscreen addr
        movq        mm0,[edi] ;+HRES-4]			;vp=last pixpair in this line

		movq	    mm4,[esi] ;+HRES-4]			;- pair above

        movq        [eax],mm0
        psubd       mm0,mm4
        add		    edi,8						;dbm -- was 8
        punpckhdq   mm0,mm0
		add		    esi,8
        paddd   mm2,mm7
        movd        edx,mm0

		dec		DWORD PTR[esp+BLKCWCOUNT]
		jnz		X_LOOP             

        GET_NEW_BLOC_CONTROL

DX_PIX:

ifdef CHROMALINE
		GV 4096, fixup1								;do chroma
endif

fixupRet1:
	    GV  0, fixup2

fixupRet2:
        movq        mm0,[esi]
        movd        mm1,edx


ifdef CHROMALINE
    ifdef BLOCK_2X
		GV 4096, fixup3								;do chroma
    endif
endif

fixupRet3:
	    GV  0, fixup4

fixupRet4:
        add         esi,8
        add         edi,8
        movd        eax,mm2                 ;vscreen addr
        movd        mm4,edx

        punpckldq   mm1,mm4

        paddd       mm0,mm1
        paddd       mm2,mm7

		dec		DWORD PTR[esp+BLKCWCOUNT]
	    movq		[edi-8],mm0
        movq        [eax],mm0

		jnz		X_LOOP             

        GET_NEW_BLOC_CONTROL

save_vector:
		; save vector regs in vars:
        mov     eax,[esp]
		add		esp,LOCAL_STACK_SZ		                 

        pop    edx
        pop    ecx

		mov		[eax+dx_index],ebx			;save current dx_index value
		mov		[eax+dx_vloc],ebp			;save current dx_vloc value

emms
        pop    ebp
    ;   pop    esp
        pop    ebx
        pop    eax
        pop    edi
        pop    esi
		ret


fixup1:
    FIX_UP   4096, fixupRet1

fixup2:
    FIX_UP   0, fixupRet2

fixup3:
    FIX_UP   4096, fixupRet3

fixup4:
    FIX_UP   0, fixupRet4

;************************************************ 
        .DATA
ALIGN
EIGHT LABEL   DWORD   
        dd  00000008h

THIRTYTWO LABEL   DWORD   
        dd  00000032

;************************************************
		END
