/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "rename.h"

#include "dkpltfrm.h" 
#include "duktypes.h"
#include "cduck.h"       

#include "dxl_main.h"                                            
#include "tm1.h"

extern unsigned long work1K[320*2];

#define STRETCH2X(one,two)  \
	daddr[0] = (one<<8) + (one>>16); \
	daddr[1] = (one<<16) + (two>>8); \
	daddr[2] = two + (two<<24); \
	daddr += 3;

static void hiX(
	register unsigned char *luma,register long *chroma,
	register unsigned long *daddr,register int width,
	int dwidth,int height,int vres
)
{
	register long *lchroma;
	register unsigned long *lluma,tluma;
	unsigned long one,two;
	int i,k;
    long chrome;
	long *gtbl = (long *) work1K;
	unsigned long *daddr2 = daddr;
    
    lluma = (unsigned long *)luma;
	width /= 4;
	height /= 2;
	
    for(k = 0; k < height; k++){
    	lchroma = chroma;
		for(i = 0; i < width; i++){
			tluma = *lluma++;

			chrome = *lchroma++;
			one = (gtbl[(unsigned char)(tluma>>24)] + chrome);
			two = (gtbl[(unsigned char)(tluma>>16)] + chrome);
			STRETCH2X(one,two)

			chrome = *lchroma++;
			one = (gtbl[(unsigned char)(tluma>>8)] + chrome);
			two = (gtbl[(unsigned char)tluma] + chrome);
			STRETCH2X(one,two)

		}
		daddr = daddr2 += dwidth;

    	lchroma = chroma;
		for(i = 0; i < width; i++){
			tluma = *lluma++;

			chrome = *lchroma++;
			one = (gtbl[(unsigned char)(tluma>>24)] + chrome);
			two = (gtbl[(unsigned char)(tluma>>16)] + chrome);
			STRETCH2X(one,two)

			chrome = *lchroma++;
			one = (gtbl[(unsigned char)(tluma>>8)] + chrome);
			two = (gtbl[(unsigned char)tluma] + chrome);
			STRETCH2X(one,two)
		}
		daddr = daddr2 += dwidth;
		if (vres == 4){
			if (k & 1)
				chroma += width*2;
		}else
			chroma += width*2;
	}
}

static void loX(
	register unsigned char *luma,register long *chroma,
	register unsigned long *daddr,register int width,
	int dwidth,int height,int vres
)
{
	register long *lchroma;
	register unsigned long *lluma,tluma;
	unsigned long one,two;
	int i,k;
    long chrome;
	long *gtbl = (long *) work1K;
	unsigned long *daddr2 = daddr;
    
    lluma = (unsigned long *)luma;
	width /= 4;
	height /= 2;

    for(k = 0; k < height; k++){
    	lchroma = chroma;
		for(i = 0; i < width; i++){
			tluma = *lluma;
			chrome = *lchroma++;

			one = (gtbl[(unsigned char)(tluma>>24)] + chrome);
			two = (gtbl[(unsigned char)(tluma>>16)] + chrome);
			STRETCH2X(one,two)

			one = (gtbl[(unsigned char)(tluma>>8)] + chrome);
			two = (gtbl[(unsigned char)tluma] + chrome);
			STRETCH2X(one,two)

			daddr += dwidth-6;
			tluma = lluma[width];
			lluma++;

			one = (gtbl[(unsigned char)(tluma>>24)] + chrome);
			two = (gtbl[(unsigned char)(tluma>>16)] + chrome);
			STRETCH2X(one,two)

			one = (gtbl[(unsigned char)(tluma>>8)] + chrome);
			two = (gtbl[(unsigned char)tluma] + chrome);
			STRETCH2X(one,two)

			daddr -= dwidth;
		}
		lluma += width;
		daddr = daddr2 += dwidth*2;
		if (vres == 4){
			if (k & 1)
				chroma += width;
		}else
			chroma += width;
	}
}

void bff10(DXL_XIMAGE_1HANDLE src,DXL_VSCREEN_HANDLE dst)
{
    register unsigned char *luma = (unsigned char *)((U32)src->lineBuffer+src->dxInfo.imwidth);

	register long *chroma = (long *)((U32)src->chromaBuffer+src->dxInfo.imwidth);

	register unsigned long *daddr = (unsigned long *)(dst->addr);
	register int width = src->dxInfo.imwidth;
	int vres,height = src->dxInfo.imheight;

    int x,y;

	x = dst->viewX+ src->x;
	y = dst->viewY+ src->y;

    daddr += ((x*3)/4) + (y * (dst->pitch/4));

	if (src->dxInfo.lpbmione == 3)
		vres = 4;
	else
		vres = 2;

    if(src->dxInfo.block2x)
	   	chroma = (long *)((U32)chroma+src->dxInfo.imwidth);

	if (src->dxInfo.block2x){
		hiX(luma,chroma,daddr,width,dst->pitch/2,height,vres);
	}else{
		loX(luma,chroma,daddr,width,dst->pitch/2,height,vres);
	}
}


#define MASKER 0x000003FC

#define BYTEZERO(tbl,x) \
*((unsigned long *)  &(((unsigned char *) tbl)[x >> 22 & MASKER]))

#define BYTEONE(tbl,x) \
*((unsigned long *)  &(((unsigned char *) tbl)[x >> 14 & MASKER]))

#define BYTETWO(tbl,x) \
*((unsigned long *)  &(((unsigned char *) tbl)[x >> 6 & MASKER]))

#define BYTETHREE(tbl,x) \
*((unsigned long *)  &(((unsigned char *) tbl)[x << 2 & MASKER]))

#define HIXFOURPIX \
	temp32 = *lluma++; \
	chrome = *lchroma++; \
  	one = BYTEONE(gtbl,temp32) + chrome; \
	*daddr++ = ((BYTEZERO(gtbl,temp32) + chrome)<<8) + (one>>16); \
	chrome = *lchroma++; \
	two = BYTETWO(gtbl,temp32) + chrome; \
	*daddr++ = (one << 16) + (two >> 8); \
	*daddr++ = (BYTETHREE(gtbl,temp32) + chrome) + (two << 24);

static void hiX00(
	register unsigned char *luma,register long *chroma,
	register unsigned long *daddr,register int width,
	int dwidth,int height,int vres
)
{
	register long *lchroma;
	register unsigned long *lluma,tluma;
	unsigned long one,two,temp32;
	int i,k;
    long chrome;
	long *gtbl = (long *) work1K;
	unsigned long *daddr2 = daddr;
    
    lluma = (unsigned long *)luma;
	width /= 4;
	height /= 2;
	
    for(k = 0; k < height; k++){
    	lchroma = chroma;
		for(i = 0; i < width; i++){

			HIXFOURPIX
#if 0
			tluma = *lluma++;
			chrome = *lchroma++;
			*daddr++ = (gtbl[(unsigned char)(tluma>>24)] + chrome)<<8;
			*daddr++ = (gtbl[(unsigned char)(tluma>>16)] + chrome)<<8;
			chrome = *lchroma++;
			*daddr++ = (gtbl[(unsigned char)(tluma>>8)] + chrome)<<8;
			*daddr++ = (gtbl[(unsigned char)tluma] + chrome)<<8;
#endif
		}
		daddr = daddr2 += dwidth;

    	lchroma = chroma;
		for(i = 0; i < width; i++){

			HIXFOURPIX
#if 0
			tluma = *lluma++;
			chrome = *lchroma++;
			*daddr++ = (gtbl[(unsigned char)(tluma>>24)] + chrome)<<8;
			*daddr++ = (gtbl[(unsigned char)(tluma>>16)] + chrome)<<8;
			chrome = *lchroma++;
			*daddr++ = (gtbl[(unsigned char)(tluma>>8)] + chrome)<<8;
			*daddr++ = (gtbl[(unsigned char)tluma] + chrome)<<8;
#endif
		}
		daddr = daddr2 += dwidth;
		if (vres == 4){
			if (k & 1)
				chroma += width*2;
		}else
			chroma += width*2;
	}
}

#define LOXFOURPIX(x) \
	temp32 = x; \
  	one = BYTEONE(gtbl,temp32) + chrome; \
	*daddr++ = ((BYTEZERO(gtbl,temp32) + chrome)<<8) + (one>>16); \
	two = BYTETWO(gtbl,temp32) + chrome; \
	*daddr++ = (one << 16) + (two >> 8); \
	*daddr++ = (BYTETHREE(gtbl,temp32) + chrome) + (two << 24);


static void loX00(
	register unsigned char *luma,register long *chroma,
	register unsigned long *daddr,register int width,
	int dwidth,int height,int vres
)
{
	register long *lchroma;
	register unsigned long *lluma,tluma;
	unsigned long one,two,temp32;
	int i,k;
    long chrome;
	long *gtbl = (long *) work1K;
	unsigned long *daddr2 = daddr;
    
    lluma = (unsigned long *)luma;
	width /= 4;
	height /= 2;

    for(k = 0; k < height; k++){
    	lchroma = chroma;
		for(i = 0; i < width; i++){
			tluma = *lluma;
			chrome = *lchroma++;

			LOXFOURPIX(tluma)
#if 0
			*daddr++ = (gtbl[(unsigned char)(tluma>>24)] + chrome)<<8;
			*daddr++ = (gtbl[(unsigned char)(tluma>>16)] + chrome)<<8;
			*daddr++ = (gtbl[(unsigned char)(tluma>>8)] + chrome)<<8;
			*daddr++ = (gtbl[(unsigned char)tluma] + chrome)<<8;
#endif

			daddr += dwidth-3;
			tluma = lluma[width];
			lluma++;

			LOXFOURPIX(tluma)
#if 0
			*daddr++ = (gtbl[(unsigned char)(tluma>>24)] + chrome)<<8;
			*daddr++ = (gtbl[(unsigned char)(tluma>>16)] + chrome)<<8;
			*daddr++ = (gtbl[(unsigned char)(tluma>>8)] + chrome)<<8;
			*daddr++ = (gtbl[(unsigned char)tluma] + chrome)<<8;
#endif

			daddr -= dwidth;
		}
		lluma += width;
		daddr = daddr2 += dwidth*2;
		if (vres == 4){
			if (k & 1)
				chroma += width;
		}else
			chroma += width;
	}
}

void bff00(DXL_XIMAGE_1HANDLE src,DXL_VSCREEN_HANDLE dst)
{
    register unsigned char *luma = (unsigned char *)((U32)src->lineBuffer+src->dxInfo.imwidth);

	register long *chroma = (long *)((U32)src->chromaBuffer+src->dxInfo.imwidth);

	register unsigned long *daddr = (unsigned long *)(dst->addr);
	register int width = src->dxInfo.imwidth;
	int vres,height = src->dxInfo.imheight;

    int x,y;

	x = dst->viewX+ src->x;
	y = dst->viewY+ src->y;

    daddr += ((x*3)/4) + (y * (dst->pitch/4));

	if (src->dxInfo.lpbmione == 3)
		vres = 4;
	else
		vres = 2;

    if(src->dxInfo.block2x)
	   	chroma = (long *)((U32)chroma+src->dxInfo.imwidth);

	if (src->dxInfo.block2x){
		hiX00(luma,chroma,daddr,width,dst->pitch/4,height,vres);
	}else{
		loX00(luma,chroma,daddr,width,dst->pitch/4,height,vres);
	}
}
