/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "rename.h"

#include "dkpltfrm.h" 
#include "duktypes.h"
#include "cduck.h"       

#include "dxl_main.h"                                            

extern unsigned long work1K[256];

#define INTERP 1

void bfs20_hiX(
	register unsigned char *luma,register long *chroma,
	register unsigned long *daddr,register int width,
	int dwidth,int height,int vres
)
{
	register long *lchroma;
	register unsigned long *lluma,tluma;
	int i,k;
    long chrome,chrome2;
	long *gtbl = (long *) work1K;
	unsigned long *daddr2 = daddr;
    short bd;

	height /= 2;

    lluma = (unsigned long *)luma;
	width /= 4;
		    
    for(k = 0; k < height; k++){
    	lchroma = chroma;
		for(i = 0; i < width; i++){
			tluma = *lluma;
			bd = (short)(chrome = *lchroma++);
			chrome -= bd;

			if (chrome < 0) chrome += 0x00070000;
			if (bd < 0) bd += 7;

			chrome = (chrome >> 19)<<10;
			chrome += (long)(bd>>3);
			chrome += chrome << 16;

			daddr[0] = gtbl[((unsigned char)(tluma>>8))] + chrome;
			daddr[1] = gtbl[((unsigned char)tluma)] + chrome;
			
			bd = (short)(chrome2 = *lchroma++);
			chrome2 -= bd;

			if (chrome2 < 0) chrome2 += 0x00070000;
			if (bd < 0) bd += 7;
			
			chrome2 = (chrome2 >> 19)<<10;
			chrome2 += (long)(bd>>3);
			chrome2 += chrome2 << 16;

			daddr[2] = gtbl[((unsigned char)(tluma>>24))] + chrome2;
			daddr[3] = gtbl[((unsigned char)(tluma>>16))] + chrome2;

#if INTERP
			tluma &= 0xFEFEFEFE;
			tluma >>= 1;
			tluma += ((lluma[width]&0xFEFEFEFE) >> 1);

			daddr += dwidth/2;

			daddr[0] = gtbl[((unsigned char)(tluma>>8))] + chrome;
			daddr[1] = gtbl[((unsigned char)tluma)] + chrome;

			daddr[2] = gtbl[((unsigned char)(tluma>>24))] + chrome2;
			daddr[3] = gtbl[((unsigned char)(tluma>>16))] + chrome2;

			daddr += dwidth/2;
#else
			daddr += dwidth;
#endif
			tluma = lluma[width];

			daddr[0] = gtbl[((unsigned char)(tluma>>8))] + chrome;
			daddr[1] = gtbl[((unsigned char)tluma)] + chrome;

			daddr[2] = gtbl[((unsigned char)(tluma>>24))] + chrome2;
			daddr[3] = gtbl[((unsigned char)(tluma>>16))] + chrome2;

#if INTERP
			tluma &= 0xFEFEFEFE;
			tluma >>= 1;
#if 0			
			tluma += ((lluma[width*2]&0xFEFEFEFE) >> 1);
#else
			tluma <<= 1;
#endif
			daddr += dwidth/2;

			daddr[0] = gtbl[((unsigned char)(tluma>>8))] + chrome;
			daddr[1] = gtbl[((unsigned char)tluma)] + chrome;

			daddr[2] = gtbl[((unsigned char)(tluma>>24))] + chrome2;
			daddr[3] = gtbl[((unsigned char)(tluma>>16))] + chrome2;

			daddr -= dwidth/2;
#endif
			lluma++;
			daddr += 4-dwidth;
		}
		daddr = daddr2 += (dwidth*2);
		lluma += width;
		if (vres == 4){
			if (k & 1)
				chroma += width*2;
		}else
			chroma += width*2;
	}
}

void bfs20_loX(
	register unsigned char *luma,register long *chroma,
	register unsigned long *daddr,register int width,
	int dwidth,int height,int vres
)
{
	register long *lchroma;
	register unsigned long *lluma,tluma;
	int i,k;
    long chrome;
	long *gtbl = (long *) work1K;
	unsigned long *daddr2 = daddr;
    short bd;

	height /= 2;

    lluma = (unsigned long *)luma;
	width /= 4;
		    
    for(k = 0; k < height; k++){
    	lchroma = chroma;
		for(i = 0; i < width; i++){
			tluma = *lluma;
			bd = (short)(chrome = *lchroma++);
			chrome -= bd;

			if (chrome < 0) chrome += 0x00070000;
			if (bd < 0) bd += 7;

			chrome = (chrome>>19)<<10;
			chrome += (long)(bd>>3);
			chrome += chrome << 16;

			//chrome = 0;

			daddr[0] = gtbl[((unsigned char)(tluma>>8))] + chrome;
			daddr[1] = gtbl[((unsigned char)tluma)] + chrome;
			
			daddr[2] = gtbl[((unsigned char)(tluma>>24))] + chrome;
			daddr[3] = gtbl[((unsigned char)(tluma>>16))] + chrome;

#if INTERP
			tluma &= 0xFEFEFEFE;
			tluma >>= 1;
			tluma += ((lluma[width]&0xFEFEFEFE) >> 1);

			daddr += dwidth/2;

			daddr[0] = gtbl[((unsigned char)(tluma>>8))] + chrome;
			daddr[1] = gtbl[((unsigned char)tluma)] + chrome;
			daddr[2] = gtbl[((unsigned char)(tluma>>24))] + chrome;
			daddr[3] = gtbl[((unsigned char)(tluma>>16))] + chrome;

			daddr -= dwidth/2;
#endif
			tluma = lluma[width];

			daddr += dwidth;

			daddr[0] = gtbl[((unsigned char)(tluma>>8))] + chrome;
			daddr[1] = gtbl[((unsigned char)tluma)] + chrome;

			daddr[2] = gtbl[((unsigned char)(tluma>>24))] + chrome;
			daddr[3] = gtbl[((unsigned char)(tluma>>16))] + chrome;

#if INTERP
			tluma &= 0xFEFEFEFE;
			tluma >>= 1;
#if 0			
			tluma += ((lluma[width*2]&0xFEFEFEFE) >> 1);
#else
			tluma <<= 1;
#endif

			daddr += dwidth/2;

			daddr[0] = gtbl[((unsigned char)(tluma>>8))] + chrome;
			daddr[1] = gtbl[((unsigned char)tluma)] + chrome;
			daddr[2] = gtbl[((unsigned char)(tluma>>24))] + chrome;
			daddr[3] = gtbl[((unsigned char)(tluma>>16))] + chrome;

			daddr -= dwidth/2;
#endif
			lluma++;
			daddr += 4-dwidth;
		}
		daddr = daddr2 += (dwidth*2);
		lluma += width;
		if (vres == 4){
			if (k & 1)
				chroma += width;
		}else
			chroma += width;
	}
}

void bfs20_hiX565(
	register unsigned char *luma,register long *chroma,
	register unsigned long *daddr,register int width,
	int dwidth,int height,int vres
)
{
	register long *lchroma;
	register unsigned long *lluma,tluma;
	int i,k;
    long chrome,chrome2;
	long *gtbl = (long *) work1K;
	unsigned long *daddr2 = daddr;
    short bd;

	height /= 2;

    lluma = (unsigned long *)luma;
	width /= 4;
		    
    for(k = 0; k < height; k++){
    	lchroma = chroma;
		for(i = 0; i < width; i++){
			tluma = *lluma;
			bd = (short)(chrome = *lchroma++);
			chrome -= bd;

			if (chrome < 0) chrome += 0x00070000;
			if (bd < 0) bd += 7;

			chrome = ((long)(chrome & 0xfff80000))>>8;
//			chrome = (chrome >> 19)<<10;
			chrome += (long)(bd>>3);
			chrome += chrome << 16;

			daddr[0] = gtbl[((unsigned char)(tluma>>8))] + chrome;
			daddr[1] = gtbl[((unsigned char)tluma)] + chrome;
			
			bd = (short)(chrome2 = *lchroma++);
			chrome2 -= bd;

			if (chrome2 < 0) chrome2 += 0x00070000;
			if (bd < 0) bd += 7;
			
			chrome2 = ((long)(chrome2 & 0xfff80000))>>8;
//			chrome2 = (chrome2 >> 19)<<10;
			chrome2 += (long)(bd>>3);
			chrome2 += chrome2 << 16;

			daddr[2] = gtbl[((unsigned char)(tluma>>24))] + chrome2;
			daddr[3] = gtbl[((unsigned char)(tluma>>16))] + chrome2;

#if INTERP
			tluma &= 0xFEFEFEFE;
			tluma >>= 1;
			tluma += ((lluma[width]&0xFEFEFEFE) >> 1);

			daddr += dwidth/2;

			daddr[0] = gtbl[((unsigned char)(tluma>>8))] + chrome;
			daddr[1] = gtbl[((unsigned char)tluma)] + chrome;

			daddr[2] = gtbl[((unsigned char)(tluma>>24))] + chrome2;
			daddr[3] = gtbl[((unsigned char)(tluma>>16))] + chrome2;

			daddr += dwidth/2;
#else
			daddr += dwidth;
#endif
			tluma = lluma[width];

			daddr[0] = gtbl[((unsigned char)(tluma>>8))] + chrome;
			daddr[1] = gtbl[((unsigned char)tluma)] + chrome;

			daddr[2] = gtbl[((unsigned char)(tluma>>24))] + chrome2;
			daddr[3] = gtbl[((unsigned char)(tluma>>16))] + chrome2;

#if INTERP
			tluma &= 0xFEFEFEFE;
			tluma >>= 1;
#if 0			
			tluma += ((lluma[width*2]&0xFEFEFEFE) >> 1);
#else
			tluma <<= 1;
#endif
			daddr += dwidth/2;

			daddr[0] = gtbl[((unsigned char)(tluma>>8))] + chrome;
			daddr[1] = gtbl[((unsigned char)tluma)] + chrome;

			daddr[2] = gtbl[((unsigned char)(tluma>>24))] + chrome2;
			daddr[3] = gtbl[((unsigned char)(tluma>>16))] + chrome2;

			daddr -= dwidth/2;
#endif
			lluma++;
			daddr += 4-dwidth;
		}
		daddr = daddr2 += (dwidth*2);
		lluma += width;
		if (vres == 4){
			if (k & 1)
				chroma += width*2;
		}else
			chroma += width*2;
	}
}

void bfs20_loX565(
	register unsigned char *luma,register long *chroma,
	register unsigned long *daddr,register int width,
	int dwidth,int height,int vres
)
{
	register long *lchroma;
	register unsigned long *lluma,tluma;
	int i,k;
    long chrome;
	long *gtbl = (long *) work1K;
	unsigned long *daddr2 = daddr;
    short bd;

	height /= 2;

    lluma = (unsigned long *)luma;
	width /= 4;
		    
    for(k = 0; k < height; k++){
    	lchroma = chroma;
		for(i = 0; i < width; i++){
			tluma = *lluma;
			bd = (short)(chrome = *lchroma++);
			chrome -= bd;

			if (chrome < 0) chrome += 0x00070000;
			if (bd < 0) bd += 7;

			chrome = ((long)(chrome & 0xfff80000))>>8;
//			chrome = (chrome>>19)<<10;
			chrome += (long)(bd>>3);
			chrome += chrome << 16;

			//chrome = 0;

			daddr[0] = gtbl[((unsigned char)(tluma>>8))] + chrome;
			daddr[1] = gtbl[((unsigned char)tluma)] + chrome;
			
			daddr[2] = gtbl[((unsigned char)(tluma>>24))] + chrome;
			daddr[3] = gtbl[((unsigned char)(tluma>>16))] + chrome;

#if INTERP
			tluma &= 0xFEFEFEFE;
			tluma >>= 1;
			tluma += ((lluma[width]&0xFEFEFEFE) >> 1);

			daddr += dwidth/2;

			daddr[0] = gtbl[((unsigned char)(tluma>>8))] + chrome;
			daddr[1] = gtbl[((unsigned char)tluma)] + chrome;
			daddr[2] = gtbl[((unsigned char)(tluma>>24))] + chrome;
			daddr[3] = gtbl[((unsigned char)(tluma>>16))] + chrome;

			daddr -= dwidth/2;
#endif
			tluma = lluma[width];

			daddr += dwidth;

			daddr[0] = gtbl[((unsigned char)(tluma>>8))] + chrome;
			daddr[1] = gtbl[((unsigned char)tluma)] + chrome;

			daddr[2] = gtbl[((unsigned char)(tluma>>24))] + chrome;
			daddr[3] = gtbl[((unsigned char)(tluma>>16))] + chrome;

#if INTERP
			tluma &= 0xFEFEFEFE;
			tluma >>= 1;
#if 0			
			tluma += ((lluma[width*2]&0xFEFEFEFE) >> 1);
#else
			tluma <<= 1;
#endif

			daddr += dwidth/2;

			daddr[0] = gtbl[((unsigned char)(tluma>>8))] + chrome;
			daddr[1] = gtbl[((unsigned char)tluma)] + chrome;
			daddr[2] = gtbl[((unsigned char)(tluma>>24))] + chrome;
			daddr[3] = gtbl[((unsigned char)(tluma>>16))] + chrome;

			daddr -= dwidth/2;
#endif
			lluma++;
			daddr += 4-dwidth;
		}
		daddr = daddr2 += (dwidth*2);
		lluma += width;
		if (vres == 4){
			if (k & 1)
				chroma += width;
		}else
			chroma += width;
	}
}
