/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/* dx_share.c */

#include "dkpltfrm.h"
#include "duktypes.h"
#include "cduck.h"
#include "duck_hfb.h"
#include "dxl_main.h"
#include "dxparams.h"
#include "lblitter.h"
#include "blt_itrp.h"



/* Hinterp, Not bright but doubled via line skipping = stretch */
void DXL_bse12(DX_PARAMS_HANDLE params)
{
	register U16  *dxSrc;
	register U8  *dest8;
	int wd;
	int theMod;
	unsigned char *cluPtr1 = params->clutptr;
	unsigned char *cluPtr2 = params->clutptr2;
	
	dxSrc = (U16 *) (params->dxDest);
	
	wd = params->width/4;
	theMod = params->width % 4;
	
	if (!(params->dither)) {
		cluPtr1 = params->clutptr;
		cluPtr2 = params->clutptr2;
	}
	else {
		cluPtr2 = params->clutptr;
		cluPtr1 = params->clutptr2;
	}
	params->dither = !(params->dither);
	
	
    dest8 = (U8 *) (params->vDest);
	
	
	*dest8++ = cluPtr1[*dxSrc];
	*dest8++ = cluPtr2[*dxSrc];
	*dest8++ = cluPtr1[*dxSrc];
   
    *dest8++ = cluPtr2[INTERPOLATE16(dxSrc,(dxSrc + 1))]; 
	dxSrc++; 
    *dest8++ = cluPtr1[*dxSrc];
	*dest8++ = cluPtr2[*dxSrc];
			
    *dest8++ = cluPtr1[INTERPOLATE16(dxSrc,(dxSrc + 1))]; 
	dxSrc++; 
	*dest8++ = cluPtr2[*dxSrc];
	*dest8++ = cluPtr1[*dxSrc];
			
	*dest8++ = cluPtr2[INTERPOLATE16(dxSrc,(dxSrc + 1))]; 
	dxSrc++; 
	*dest8++ = cluPtr1[*dxSrc];
	*dest8++ = cluPtr2[*dxSrc];
	
	
    wd -= 1;
	
	if (wd) {				
		do{    
			*dest8++ = cluPtr1[INTERPOLATE16(dxSrc,(dxSrc + 1))]; 
	   		dxSrc++; 
			*dest8++ = cluPtr2[*dxSrc];
			*dest8++ = cluPtr1[*dxSrc];
			
			*dest8++ = cluPtr2[INTERPOLATE16(dxSrc,(dxSrc + 1))]; 
	   		dxSrc++; 
			*dest8++ = cluPtr1[*dxSrc];
			*dest8++ = cluPtr2[*dxSrc];
			
            *dest8++ = cluPtr1[INTERPOLATE16(dxSrc,(dxSrc + 1))]; 
	   		dxSrc++; 
			*dest8++ = cluPtr2[*dxSrc];
			*dest8++ = cluPtr1[*dxSrc];
			
			*dest8++ = cluPtr2[INTERPOLATE16(dxSrc,(dxSrc + 1))]; 
	   		dxSrc++; 
			*dest8++ = cluPtr1[*dxSrc];
			*dest8++ = cluPtr2[*dxSrc];
		} while(--wd);
	}
	
	
	if (theMod == 2) {
            *dest8++ = cluPtr1[INTERPOLATE16(dxSrc,(dxSrc + 1))]; 
	   		dxSrc++; 
			*dest8++ = cluPtr2[*dxSrc];
			*dest8++ = cluPtr1[*dxSrc];
			
			*dest8++ = cluPtr2[INTERPOLATE16(dxSrc,(dxSrc + 1))]; 
	   		dxSrc++; 
			*dest8++ = cluPtr1[*dxSrc];
			*dest8++ = cluPtr2[*dxSrc];
	}
	

} /* end of DXL_LineBlit_HInterp */



