/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "dkpltfrm.h"
#include "duktypes.h"
#include "cduck.h"
#include "duck_hfb.h"
#include "dxl_main.h"
#include "dxparams.h"
#include "lblitter.h"
#include "blt_itrp.h"



#if 1
/* stretch with intelligence and vertical interpolation */
void DXL_bse21(DX_PARAMS_HANDLE params)
{    
	register U16  *dxSrc;
	register U8	*dest8;
	register unsigned long temp;
	register U8 *bloc;
	register U8 *blocLast;
	register U16 *dxLast;
	register unsigned char *cluPtr1;
	register unsigned char *cluPtr2;
	
	register U16 bloc_contents;
	U16  bloc_contentsLast;
	
	
	bloc = (U8 *)params->dx_bloc;
	blocLast = (U8 *) params->dx_blocLast;

#if 0
    #define MORE_BITS \
	bloc_contents = ((U16)*bloc++) | 0x0100;
	bloc_contentsLast = ((U16)*blocLast++);
#else	
	#define MORE_BITS \
	temp = *bloc++;\
	temp &= 0x000001FF;\
	temp <<= 8;\
	temp |= ((*blocLast++) << 24);
#endif

	MORE_BITS
	
	
	dxSrc = (U16 *) (params->dxDest);
	dxLast = (U16 *) (params->dxLast);
	
	params->wd = params->width/4; 
	
	
	if (!(params->dither)) {
		cluPtr1 = params->clutptr;
		cluPtr2 = params->clutptr2;
	}
	else {
		cluPtr2 = params->clutptr;
		cluPtr1 = params->clutptr2;
	}
	params->dither = !(params->dither);
	
	
	
    dest8 = (U8 *) (params->vDest);
		
	if (params->wd) {			
	do{ 
	    /*if ((bloc_contents & 0x01) && (bloc_contentsLast & 0x01)) */ 
	    if ((temp & 0x00000100) && (temp & 0x01000000)) { 
			dxSrc += 4;
			dxLast += 4;
#if 0  
			dest8[0] = 0; dest8[1] = 0; dest8[2] = 0; dest8[3] = 0;
			(dest8 + bytePitch)[0] = 0; (dest8 + bytePitch)[1] = 0;
			(dest8 + bytePitch)[2] = 0; (dest8 + bytePitch)[3] = 0;
			
#endif
			dest8 += 8;
			}
			
			
		else { 
		    temp &= 0xFFFFFF00;
		    temp |=  cluPtr1[(	(*dxSrc & *dxLast & 0x0420) + 
		     	(	(*dxSrc  & 0x7BDF) +   
                   (*dxLast & 0x7BDF )	
				)/2) ]; 
			*dest8++ = *dest8++ = (unsigned char ) temp;
			dxSrc++;  dxLast++; 
			
			temp &= 0xFFFFFF00;
			temp  |= cluPtr2[(	(*dxSrc & *dxLast & 0x0420) + 
		     	(	(*dxSrc  & 0x7BDF) +   
                   (*dxLast & 0x7BDF )	
				)/2) ]; 
			*dest8++ = *dest8++ = (unsigned char ) temp;
			dxSrc++;  dxLast++; 
			
			temp &= 0xFFFFFF00;
			temp |=  cluPtr1[(	(*dxSrc & *dxLast & 0x0420) + 
		     	(	(*dxSrc  & 0x7BDF) +   
                   (*dxLast & 0x7BDF )	
				)/2) ]; 
			*dest8++ = *dest8++ = (unsigned char ) temp;
			dxSrc++;  dxLast++; 
			
			temp &= 0xFFFFFF00;
			temp  |= cluPtr2[(	(*dxSrc & *dxLast & 0x0420) + 
		     	(	(*dxSrc  & 0x7BDF) +   
                   (*dxLast & 0x7BDF )	
				)/2) ]; 
			*dest8++ = *dest8++ = (unsigned char ) temp;
			dxSrc++;  dxLast++; 
			
			dest8 -= 8;
           
			/* regular line below ... */
			dest8 += params->bPitch/2;
			dxSrc -= 4;
			
			#define JERKY8  temp &= 0xFFFFFF00;\
					temp |= cluPtr1[*dxSrc++]; \
					*dest8++ = *dest8++ = (unsigned char ) temp; \
                   	temp &= 0xFFFFFF00;\
					temp |= cluPtr2[*dxSrc++]; \
					*dest8++ = *dest8++ = (unsigned char )  temp; 
					
 			JERKY8
		  	JERKY8	  
			
			dest8 -= params->bPitch/2;
			
			}
				
		temp >>= 1;
		if ((temp & 0x00FFFF00) == 0x00000100)
		/*bloc_contentsLast >>= 1;
		if ((bloc_contents >>= 1) == 1)*/ {
			MORE_BITS
			}
			
	} while(--(params->wd));		
	} /* end if (wd) */
	
	
	if ((params->width % 4) == 2) {
	    /* if not both skip blocks */
		if ((temp & 0x00000100) && (temp & 0x01000000)) { 
		    *dest8++ = *dest8++ =  cluPtr1[INTERPOLATE16(dxSrc,dxLast)]; 
			dxSrc++;  dxLast++; 
			*dest8++ = *dest8++  = cluPtr2[INTERPOLATE16(dxSrc,dxLast)]; 
			dxSrc++;  dxLast++; 
			dest8 -= 4;
           
			/* regular line below ... */
			dest8 += params->bPitch/2;
			dxSrc -= 2;
			
		  	JERKY8	  
		}
	} /* end mod */
	
	

} /* end of DXL_LineBlit_Stretchiv */
#endif
