/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

 
#include "dkpltfrm.h"
#include "duktypes.h"
#include "cduck.h"
#include "duck_hfb.h"
#include "dxl_main.h"
#include "dxparams.h"
#include "lblitter.h"
#include "blt_itrp.h"


static unsigned short mLastBlit[1024];
/* provide space for last interpolated line, so don't have to interpolate 
   again with vertically interped line. */
int DXL_bse22_init(DX_PARAMS_HANDLE params)
{
    int t;
	int width = params->width*3;
	
	unsigned short *temp;
    params->dxLastBlit = (unsigned char *) &mLastBlit[0];
    
    // clear out temp buffer 
    for(t=0,temp=(unsigned short *) params->dxLastBlit; t<width; t++)
        *temp++ = 0;
}



#if 1
/* Hinterp, Bright */
void DXL_bse22(DX_PARAMS_HANDLE params)
{
	register U16  *dxSrc;
	register U16  *dxLast;
    register U16  *dxNewLast;
	register U16  temp;
    register U8  *dest8;
	int wd;
    int bytePitch;
	int theMod;
	unsigned char *cluPtr1 = params->clutptr;
	unsigned char *cluPtr2 = params->clutptr2;
	
	dxSrc = (U16 *) (params->dxDest);
	dxLast = (U16 *) (params->dxLast);
    dxNewLast = (U16 *) (params->dxLastBlit);
     
	  
	wd = params->width / 4;
	 
    bytePitch = params->bPitch/2;
	 
    dest8 = (U8 *) (params->vDest);
	
    theMod = params->width  % 4;
	
	
	if (!(params->dither)) {
		cluPtr1 = params->clutptr;
		cluPtr2 = params->clutptr2;
	}
	else {
		cluPtr2 = params->clutptr;
		cluPtr1 = params->clutptr2;
	}
	params->dither = !(params->dither);
     
	
	if (wd) {				
	do{     
#define JERKY \
			*dest8++ = cluPtr1[INTERPOLATE16(dxSrc,dxNewLast)];\
			*dest8++ = cluPtr2[INTERPOLATE16(dxSrc,dxNewLast)];\
			dxNewLast += 2;\
			temp = INTERPOLATE16(dxSrc,(dxSrc+1));\
			*dest8++ = cluPtr1[INTERPOLATE16(&temp,dxNewLast)];\
			*dxSrc++;\
			*dxNewLast++;\
			*dest8++ = cluPtr2[INTERPOLATE16(dxSrc,dxNewLast)];\
			*dest8++ = cluPtr1[INTERPOLATE16(dxSrc,dxNewLast)];\
			dxNewLast += 2;\
			temp = INTERPOLATE16(dxSrc,(dxSrc+1));\
			*dest8++ = cluPtr2[INTERPOLATE16(&temp,dxNewLast)];\
			*dxSrc++;\
			*dxNewLast++;
			
			JERKY
			JERKY
	  
            dest8 -= 12;
			dxSrc -= 4;
			dest8 += bytePitch;
            dxNewLast -=12;
			 
#define JERKY2  \
			*dest8++ = cluPtr1[*dxSrc];\
			*dxNewLast++ = *dxNewLast++ = *dxSrc;\
			*dest8++ = cluPtr2[*dxSrc];\
			*dest8++ = cluPtr1[*dxNewLast++ = INTERPOLATE16(dxSrc,(dxSrc + 1))];\
			dxSrc++;\
			*dest8++ = cluPtr2[*dxSrc];\
			*dxNewLast++ = *dxNewLast++ = *dxSrc;\
			*dest8++ = cluPtr1[*dxSrc];\
			*dest8++ = cluPtr2[*dxNewLast++ = INTERPOLATE16(dxSrc,(dxSrc + 1))];\
			dxSrc++;
			
			JERKY2
			JERKY2
			
            dest8 -= bytePitch;
			
	} while(--wd);
	} /* end if (wd) */
	
	if (theMod == 2) {
            JERKY
		
            dest8 -= 6;
			dxSrc -= 2;
			dest8 += bytePitch;
            dxNewLast -=6;
            
			JERKY2
			
	}
	
	dest8--;
	dest8[1] = dest8[0];
	dest8 += bytePitch;
	dest8[1] = dest8[0];
	

} 
#endif
 


