/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

 
#include "dkpltfrm.h"
#include "duktypes.h"
#include "cduck.h"
#include "duck_hfb.h"
#include "dxl_main.h"
#include "dxparams.h"
#include "tm1blit.h"
#include "blt_itrp.h"


unsigned short mLastBlit[1024];
/* provide space for last interpolated line, so don't have to interpolate 
   again with vertically interped line. */
void DXL_bss22_init(DX_PARAMS_HANDLE params)
{
    int t;
	int width = params->width*3;
	
	unsigned short *temp;
    params->dxLastBlit = (unsigned char *) &mLastBlit[0];
    
    // clear out temp buffer 
    for(t=0,temp=(unsigned short *) params->dxLastBlit; t<width; t++)
        *temp++ = 0;
}



#if 1
/* Hinterp, Bright */
void DXL_bss22(DX_PARAMS_HANDLE params)
{
	register U16  *dxSrc;
	register U32  *dxLast;
    register U32  *dxNewLast;
    register U32  *dest32;
    U32  temp32;
	int wd;
    int wordPitch;
	int theMod;
	
	dxSrc = (U16 *) (params->dxDest);
	dxLast = (U32 *) (params->dxLast);
    dxNewLast = (U32 *) (params->dxLastBlit);
     
	  
	wd = params->width / 4;
	 
    wordPitch = params->bPitch/8;
	 
    dest32 = (U32 *) (params->vDest);
	
    theMod = params->width  % 4;
     
	
	if (wd) {				
	do{     
            
    		BLIT_BSS22_TWOPIXEL_VINTERP(dest32,dxSrc,dxNewLast,temp32);
            BLIT_BSS22_TWOPIXEL_VINTERP(dest32,dxSrc,dxNewLast,temp32);
	  
            dest32 -= 6;
			 dxSrc -= 4;
			
            dest32 += wordPitch;
             
			 dxNewLast -=6;
            BLIT_BSS22_TWOPIXEL(dest32,dxSrc,dxNewLast);
            BLIT_BSS22_TWOPIXEL(dest32,dxSrc,dxNewLast);
			
            dest32 -= wordPitch;
			
	} while(--wd);
	} /* end if (wd) */
	
	if (theMod == 2) {
            BLIT_BSS22_TWOPIXEL_VINTERP(dest32,dxSrc,dxLast,temp32);
            dest32 -= 3;
			 dxSrc -= 2;
            dest32 += wordPitch;
            BLIT_BSS22_TWOPIXEL(dest32,dxSrc,dxLast);
			dest32 -= wordPitch;
	}
	
	dest32--;
	((unsigned short *) dest32)[1] = ((unsigned short *) dest32)[0];
	dest32 += wordPitch;
	((unsigned short *) dest32)[1] = ((unsigned short *) dest32)[0];
	

} /* end of HInterpBright */
#endif
 


/* Hinterp with no VInterp, but bright */
#if 0
void DXL_bss22(DX_PARAMS_HANDLE params)
{
	register U16  *dxSrc;
	register U16  *dest16;
	int wd;
	int shortPitch;
	int theMod;
	
	dxSrc = (U16 *) (params->dxDest);
	
	wd = params->width / 4;
	
	shortPitch = params->bPitch/4;
	
    dest16 = (U16 *) (params->vDest);
	
	theMod = params->width  % 4;

   
   BLIT_SOME_DESTPIX(dest16,dxSrc);
   
   dest16 -= 12;
   dxSrc -= 3;
   dest16 += shortPitch;
   
   BLIT_SOME_DESTPIX(dest16,dxSrc);
   dest16 -= shortPitch;
   
   wd -= 1;
     
	
	if (wd) {				
	do{     

            BLIT_REST_DESTPIX(dest16,dxSrc);
            BLIT_REST_DESTPIX(dest16,dxSrc);
            BLIT_REST_DESTPIX(dest16,dxSrc);
            BLIT_REST_DESTPIX(dest16,dxSrc);

			dest16 -= 12;
			dxSrc -= 4;
			
			dest16 += shortPitch;
			BLIT_REST_DESTPIX(dest16,dxSrc);
			BLIT_REST_DESTPIX(dest16,dxSrc);
			BLIT_REST_DESTPIX(dest16,dxSrc);
			BLIT_REST_DESTPIX(dest16,dxSrc);
			dest16 -= shortPitch;
			
	} while(--wd);
	} /* end if (wd) */
	
	if (theMod == 2) {
			BLIT_REST_DESTPIX(dest16,dxSrc);
			BLIT_REST_DESTPIX(dest16,dxSrc);
            dest16 -= 6;
			dxSrc -= 2;
			
			dest16 += shortPitch;
			BLIT_REST_DESTPIX(dest16,dxSrc);
			BLIT_REST_DESTPIX(dest16,dxSrc);
	}

} /* end of DXL_LineBlit_HInterpBright */
#endif


