/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/***********************************************\
??? dxduck.c
\***********************************************/
#include <stdio.h>
#include <stdlib.h>                     

#include "protect.h"
#include "duktypes.h"                      
#include "dkpltfrm.h"
#include "cduck.h"
#include "dxl_main.h"
#include "duck_mem.h"
#include "dxparams.h"

#ifdef HIRES
void DecompressWithBuiltInBlitLoopRA(DX_PARAMS_HANDLE dxParams, DX_FUNC *dxfuncs, int height);
#endif

typedef void ((*BLIT_FUNC)(DX_PARAMS_HANDLE));

#include "dxl_16.h"             

int foundMMX = 0;


int DXL_GetXImageSizeOfPixel(DXL_XIMAGE_HANDLE src)
{
    switch (DXL_GetXImageColorDepth(src)){
        case DXRGB16:
            return 2;
        default:
            return 3;
    }
}
#ifdef HIRES
#if 0
/***********************************************/
void DecompressWithBuiltInBlitLoopRA(DX_PARAMS_HANDLE dxParams, DX_FUNC *dxfuncs, int height)
{   
    int lineCount;

    for(lineCount=1; lineCount <= height; lineCount++) {
                    
        (*dxfuncs[lineCount & 3])(dxParams);
                    
//        if (!(lineCount & 3))   
//            dxParams->dx_bloc += ifbitsBytesPerLine;    /* next bloc 4 pixel boundaries */
                    
        dxParams->vDest += dxParams->bPitch;
        dxParams->dxDest += dxParams->src_bPitch;                  
        dxParams->dxLast += dxParams->src_bPitch;
    } /* for */
}
#endif

/***********************************************/
void DecompressWithBuiltInBlitLoopER(DX_PARAMS_HANDLE dxParams, DX_FUNC *dxfuncs, int height, int ifbitsBytesPerLine)
{   
    int lineCount;

    for(lineCount=1; lineCount <= height; lineCount++) {
                    
        (*dxfuncs[lineCount & 3])(dxParams);
                    
        if (!(lineCount & 3))   
            dxParams->dx_bloc += ifbitsBytesPerLine;    /* next bloc 4 pixel boundaries */
                    
        dxParams->vDest += dxParams->bPitch;
        dxParams->dxDest += dxParams->src_bPitch;                  
        dxParams->dxLast += dxParams->src_bPitch;
    } /* for */
}

#endif

/***********************************************/

void DecompressLoop(DX_PARAMS_HANDLE dxParams, DX_FUNC *dxfuncs, int height, int ifbitsBytesPerLine)
{   
    int lineCount;

    for(lineCount=1; lineCount <= height; lineCount++) {
                    
        (*dxfuncs[lineCount & 3])(dxParams);
                    
        if (!(lineCount & 3))   
            dxParams->dx_bloc += ifbitsBytesPerLine;    /* next bloc 4 pixel boundaries */
                    
        dxParams->dxDest += dxParams->src_bPitch;                  
        dxParams->dxLast += dxParams->src_bPitch;
    } /* for */
}

/***********************************************/

void DecompressAndBlitLoop(DX_PARAMS_HANDLE dxParams, DX_FUNC *dxfuncs, BLIT_FUNC blitfunc,
                           int height, int ifbitsBytesPerLine)
{                                              
    int lineCount;
 
    for(lineCount=1; lineCount <= height; lineCount++) {
        (*dxfuncs[lineCount & 3])(dxParams);
        blitfunc(dxParams);
                    
        if (!(lineCount & 3))   
            dxParams->dx_bloc += ifbitsBytesPerLine;    /* next bloc 4 pixel boundaries */
        
        if (!((lineCount < 3 ? 1 : lineCount - 2) & 3))   
            dxParams->dx_blocLast += ifbitsBytesPerLine;    /* next bloc 4 pixel boundaries */
                
        dxParams->vDest += dxParams->bPitch;
        dxParams->dxDest += dxParams->src_bPitch;
        dxParams->dxLast += dxParams->src_bPitch;
    } /* for */
}

/***********************************************/
void DecompressIntraFrameAndBlitLoop(DX_PARAMS_HANDLE dxParams, DX_FUNC *dxfuncs, BLIT_FUNC blitfunc,
                           int height, int ifbitsBytesPerLine)
{   unsigned char *temp;

    int lineCount;
//     int t;
     
    dxParams->dxDest = dxParams->dxLast + (dxParams->width*2);//dxParams->src_bPitch;

	/* this should be in setup function */
	/*
    dxParams->dxLastBlit = dxParams->dxDest + 640;//dxParams->src_bPitch; 
    
    // clear out temp buffer 
    for(t=0,temp=dxParams->dxLastBlit; t<640*2; t++)
        *temp++ = 0;
	*/

    for(lineCount=1; lineCount <= height; lineCount++) {
        (*dxfuncs[lineCount & 3])(dxParams);
                  
        blitfunc(dxParams);
                    
        if (!(lineCount & 3))   
             dxParams->dx_bloc += ifbitsBytesPerLine;    /* next bloc 4 pixel boundaries */
        
        if (!((lineCount < 3 ? 1 : lineCount - 2) & 3))   
            dxParams->dx_blocLast += ifbitsBytesPerLine;    /* next bloc 4 pixel boundaries */
                
        dxParams->vDest += dxParams->bPitch;

#if 1
         temp = dxParams->dxDest;
         dxParams->dxDest = dxParams->dxLast;
         dxParams->dxLast = temp;
#endif

    } /* for */
}

#ifdef HIRES
DX_FUNC funky[3][3] = {
    { dxic16, dxic162, dxi16 },
    { dxic16e, dxic162e, dxi16e },
    { dxic16a, dxic162a, dxi16a },
    };
#else
DX_FUNC funky[1][3] = {
    { dxic16, dxic162, dxi16 }
    };
#endif

/***********************************************/

void resetDecompressor(DXL_XIMAGE_1HANDLE src, DXL_VSCREEN_HANDLE dst, DX_PARAMS_HANDLE dxParams, DX_FUNC *dxfuncs)
{   /* setup dx functions table */
    short dx_mask;
    int i;

    dx_mask = (src->dxInfo.blockpower == 1) ? 1 : 3;
    
    for(i=0; i < 4; i++) {  /* i==0 has colors */
        if(src->dxInfo.sprite) {
            if(i==1)
                (dxfuncs[i]) = dxcSprite;
            else
                (dxfuncs[i]) = dxSprite;
        } else {
            if(!((i+3)&dx_mask))
                (dxfuncs[i]) =  funky[0][src->dxInfo.block2x ? 1 : 0];
            else
                (dxfuncs[i]) = funky[0][2];
        }
    }
}

void SetupDecompressor(DXL_XIMAGE_1HANDLE src, DXL_VSCREEN_HANDLE dst, DX_PARAMS_HANDLE dxParams, DX_FUNC *dxfuncs)
{   /* setup dx functions table */
    int i;      

    /* 16 bytes of luma, 16 of chroma */
    dxParams->dx_index=((dxVector32)(*(dxParams->dx_vloc)))*16; 
    dxParams->dx_vloc++;
        
    if (src->lineBuffer){   /* clear out the linebuffer/first line of framebuffer */
        register unsigned char *temp; 

        i = src->dxInfo.imwidth*DXL_GetXImageSizeOfPixel((DXL_XIMAGE_HANDLE)src); 
        temp = src->lineBuffer;

        while(i--) *temp++ = 0;
    }

    {   /* set up the decompressor's function table */
        short dx_mask;
        int tblNum = 0;
    
        
#ifdef HIRES
        if(dst) {
            if((dst->bq == DXBLIT_SAME && dst->bd == DXRGB16)) {
                if(src->dxInfo.interframe && foundMMX) 
                    tblNum = 1;

                if(!(src->dxInfo.interframe || src->dxInfo.hinterp)) 
                    tblNum = 2;
            }
        }
#endif

        dx_mask = (src->dxInfo.blockpower == 1) ? 1 : 3;
        
        for(i=0; i < 4; i++) {  /* i==0 has colors */
            if(src->dxInfo.sprite) {
                if(i==1)
                    (dxfuncs[i]) = dxcSprite;
                else
                    (dxfuncs[i]) = dxSprite;
            } else {
                if(!((i+3)&dx_mask))
                    (dxfuncs[i]) =  funky[tblNum][src->dxInfo.block2x ? 1 : 0];
                else
                    (dxfuncs[i]) = funky[tblNum][2];
            }
        }
    }
}

/***********************************************/

void SetupBlockAndVectorInfo(DXL_XIMAGE_1HANDLE src, DX_PARAMS_HANDLE dxParams, int *ifbitsBytesPerLine, blockInfo *dx_keybloc)
{
    blockInfo *dxSrc;
    
    dxSrc = (blockInfo *)((unsigned char *)(src->addr) + src->dxInfo.hdrSize);
    
    if(!src->dxInfo.iskeyframe) {   
        dxParams->dx_bloc = dxSrc;
        dxParams->dx_blocLast = dxSrc;
        *ifbitsBytesPerLine = ((src->dxInfo.imwidth>>2)+7)>>3;
        /* note, below, use size of data in object, not what we're going to draw on screen */
        dxParams->dx_vloc = (dxVector8 *)(dxParams->dx_bloc + *ifbitsBytesPerLine * (src->dxInfo.imheight>>2));
    } else if(src->dxInfo.sprite) {
        dxParams->dx_bloc = dxSrc;
        *ifbitsBytesPerLine = ((src->dxInfo.imwidth>>2)+3)>>2;
        dxParams->dx_vloc = (dxVector8 *)(dxParams->dx_bloc + *ifbitsBytesPerLine * (src->dxInfo.imheight>>2));
    } else {
        dxParams->dx_vloc = (dxVector8 *)dxSrc;
        dxParams->dx_bloc = dx_keybloc;
        *ifbitsBytesPerLine = 0; 
    }
}

/***********************************************/

int DXL_GetXImageOffset(DXL_XIMAGE_HANDLE src, int *x, int *y)
{
    validate(src);

    *x = src->x;
    *y = src->y;

	{
		DXL_XIMAGE_1HANDLE srcx = (DXL_XIMAGE_1HANDLE)src;

		if (srcx->dxInfo.sprite) {
			*y  += srcx->dxInfo.f.yoff;
			*x  += srcx->dxInfo.f.xoff;
		}
	}
	return 0;
}

/***********************************************/

int SetupXImageDxDestAndOrBlitSrc(DXL_XIMAGE_1HANDLE src, DX_PARAMS_HANDLE dxParams)
{
    /* for intermediate blitters */ 
    int sop = dxParams->sizeofpixel = DXL_GetXImageSizeOfPixel((DXL_XIMAGE_HANDLE) src);
    dxParams->width = src->dxInfo.imwidth;

    /* check to see if the linebuffer is 2 dimensional, 
       and that the image would fit */
    if (src->lineBufferSize >= ((src->dxInfo.imheight+1)*src->dxInfo.imwidth*sop))
        dxParams->src_bPitch = (dxParams->width * sop);
    else{
        if (src->dxInfo.interframe) /* interframe without adequate buffer */
            return -1;

        dxParams->src_bPitch = 0;
    }
    dxParams->hinterp = src->dxInfo.hinterp;
    
    dxParams->dxLast = src->lineBuffer;
    dxParams->dxDest = dxParams->dxLast + dxParams->src_bPitch;
    return 0;
}

/***********************************************/

void SetupVScreenBlitSrc(DXL_VSCREEN_HANDLE src, DX_PARAMS_HANDLE dxParams)
{
    dxParams->sizeofpixel = DXL_GetVScreenSizeOfPixel(src);
    dxParams->width = abs(src->pitch)/dxParams->sizeofpixel; 
    
    dxParams->hinterp = 0;
    
    dxParams->src_bPitch = src->pitch;
    dxParams->dxDest = src->addr;                  
}

/***********************************************/

void SetupBlitterDestination(DX_PARAMS_HANDLE dxParams, DXL_VSCREEN_HANDLE dst, int x, int y)
{     
    extern int is565;            
    
    dxParams->ScreenIs565 = is565;
    dxParams->vDest = dxParams->addr = dst->addr;

    if (dst->bq == DXBLIT_STRETCH || dst->bq == DXBLIT_STRETCH_BRIGHT)
        dxParams->bPitch = dst->pitch<<1;
    else
        dxParams->bPitch = dst->pitch;          

    y += dst->viewY;           
    x += dst->viewX;
    x &= ~1;        /* even block start for blends */
                                           
    dxParams->clutptr = dst->clut1;
    dxParams->clutptr2 = dst->clut2;

    if (dxParams->vDest) 
        dxParams->vDest += (x * DXL_GetVScreenSizeOfPixel(dst)) + (y * dst->pitch);
}

typedef struct { int x,y,w,h; } ClipRect;
     
#define BETWEEN(a,b,c)    (b >= a) ? 1 : ((b <= c) ? 1 : 0)  

#define MAX(x,y) ((x > y) ? x : y)
      
#define MIN(x,y) ((x < y) ? x : y)

#define PT_IN_RECT(x,y,aRect)  BETWEEN(aRect.x,x,aRect.x+w-1) && BETWEEN(aRect.y,y,aRect.y+h-1)

/* computes sectRect = srcRect intersection with dstRect, or empty rectangle */
int Intersect_Rectangles(ClipRect *s,ClipRect *d, ClipRect *sectRect)
{
int emptyRect = 0;

/* if no dst corners are in source rectange  */
if (
    (d->x > (s->x+s->w - 1)) || 
    (d->y > (s->y+s->h - 1)) ||  
    ((d->x + d->w + 1) < s->x) ||
    ((d->y + d->h + 1) < s->y)      
   ) 
    emptyRect = 1;        
                                  
                  
if (!emptyRect)  {
    sectRect->x = MAX(s->x,d->x);
    sectRect->y = MAX(s->y,d->y);
    if (s->x+s->w< d->x+d->w) 
        sectRect->w = s->x+s->w - sectRect->x;
    else 
        sectRect->w = d->x+d->w - sectRect->x;
        
    if (s->y+s->h < d->y+d->h) 
        sectRect->h = s->y+s->h - sectRect->y;
    else 
        sectRect->h = d->y+d->h - sectRect->y;

} 
else 
    sectRect->x = sectRect->y = sectRect->w = sectRect->h = 0;


return !emptyRect;
}

/***********************************************/
int SetupXimageClipping(DX_PARAMS_HANDLE dxParams, DX_PARAMS_HANDLE clippedParams, 
    DXL_XIMAGE_1HANDLE src, DXL_VSCREEN_HANDLE dst)
{     
    int Clipped = 0;
    int scale;
    int sizeofpixel;    
    int dxDestX = 0;
            
    ClipRect s,d,sect; /* s = screen rect, d = ximage rect, sect = intersect rect */
    
    if(src && dst) {            
        sizeofpixel = DXL_GetVScreenSizeOfPixel(dst);

        s.x = dst->clipX + dst->viewX;
        s.y = dst->clipY + dst->viewY;
        s.w = (dst->clipW) ? dst->clipW : (dst->viewW ? dst->viewW : dst->pitch/sizeofpixel);
        s.h = (dst->clipH) ? dst->clipH : (dst->viewH ? dst->viewH : dst->height);
        duck_memcpy(clippedParams, dxParams, sizeof(DX_PARAMS));   
        scale = (dst->bq == DXBLIT_SAME) ? 1 : 2;
       
        /* ximage box */
        DXL_GetXImageOffset((DXL_XIMAGE_HANDLE)src, &d.x, &d.y);

/* force ximage to follow viewport */
d.x += dst->viewX;
d.y += dst->viewY;
        
        d.h = src->h*scale;
        d.w = src->w*scale;  
        
        
        if(!Intersect_Rectangles(&s, &d, &sect)) {
            /* force sprite to decompress only */
            if(src->dxInfo.sprite)
                clippedParams->lineStart = src->dxInfo.imheight + 1;
            return 2;                             
        }            
            
        /* check to see if clipping occurred */
        if((d.x != sect.x) || (d.y != sect.y) || (d.h != sect.h) || (d.w != sect.w)) {
            Clipped = 1;
            src->dkFlags.doCompleteBlit = 1;
        }
            
        clippedParams->width = sect.w;
   
        dxParams->LeftSkipPixels = dxDestX = (d.x < sect.x) ? (sect.x-d.x) : 0;

        /* top edge ximage outside view */
        if(d.y < sect.y ) { //&& !dst->viewY) {   
            clippedParams->lineStart = sect.y - d.y + 1; 
        } else {
            clippedParams->lineStart = 1;
        }                       

        clippedParams->lineEnd = sect.h + clippedParams->lineStart - 1;

        clippedParams->vDest = dxParams->addr + (sect.x*sizeofpixel) + (sect.y*dst->pitch); 

        clippedParams->lineEnd = clippedParams->lineEnd/scale;
        clippedParams->lineStart = clippedParams->lineStart/scale;
        clippedParams->width = (dxParams->hinterp) ? clippedParams->width/scale*2/3 : clippedParams->width/scale;

        if(((d.x + d.w) > (sect.x + sect.w)) && src->dxInfo.sprite)
            dxParams->RightSkipPixels = clippedParams->width + dxParams->LeftSkipPixels; 

        dxDestX = (dxParams->hinterp) ? (dxDestX*2/3) /scale : dxDestX /scale;

        clippedParams->dxDest = dxParams->dxDest + (dxDestX*sizeofpixel);

        if (src->dxInfo.sprite && Clipped) 
            return 3;

    } else
        Clipped = -1;
    return Clipped;     
}               

/***********************************************/
void DecompressAndClipSpriteBlitLoop(DX_PARAMS_HANDLE dxParams, DX_PARAMS_HANDLE clippedParams, DX_FUNC *dxfuncs, 
                                int height, int ifbitsBytesPerLine)
{                                              
    int lineCount;

    for(lineCount=1; lineCount <= height; lineCount++) {
                    
        if((lineCount >= clippedParams->lineStart) && (lineCount <= clippedParams->lineEnd))
            dxParams->linedisplay = 1;
        else
            dxParams->linedisplay = 0;
                        
        (*dxfuncs[lineCount & 3])(dxParams);
          
        if (!(lineCount & 3)) { 
            dxParams->dx_bloc += ifbitsBytesPerLine;    /* next bloc 4 pixel boundaries */
        }
                    
//        dxParams->vDest += dxParams->bPitch;
        dxParams->dxDest += dxParams->src_bPitch;
        dxParams->dxLast += dxParams->src_bPitch;
    } /* for */
}

/***********************************************/
void DecompressAndClipBlitLoop(DX_PARAMS_HANDLE dxParams, DX_PARAMS_HANDLE clippedParams, DX_FUNC *dxfuncs, 
                                BLIT_FUNC blitfunc, int height, int ifbitsBytesPerLine)
{                                              
    int lineCount;
        
    for(lineCount=1; lineCount <= height; lineCount++) {
                    
        (*dxfuncs[lineCount & 3])(dxParams);
          
        if((lineCount >= clippedParams->lineStart) && (lineCount <= clippedParams->lineEnd)) {
            blitfunc(clippedParams);
            clippedParams->vDest += clippedParams->bPitch;
            }

                    
        if (!(lineCount & 3)) { 
            dxParams->dx_bloc += ifbitsBytesPerLine;    /* next bloc 4 pixel boundaries */
            clippedParams->dx_bloc += ifbitsBytesPerLine;   /* next bloc 4 pixel boundaries */
        }
                    
        dxParams->dxDest += dxParams->src_bPitch;
        dxParams->dxLast += dxParams->src_bPitch;
        
        clippedParams->dxDest += clippedParams->src_bPitch;
        clippedParams->dxLast += clippedParams->src_bPitch; 
        
    } /* for */
}

/***********************************************/

void ClipBlitLoop(DX_PARAMS_HANDLE clippedParams, BLIT_FUNC blitfunc,
                           int height, int ifbitsBytesPerLine)
{                                              
    int lineCount;

    for(lineCount=1; lineCount <= height; lineCount++) {
        if((lineCount >= clippedParams->lineStart) && (lineCount <= clippedParams->lineEnd))
            blitfunc(clippedParams);

        if (!(lineCount & 3))   
            clippedParams->dx_bloc += ifbitsBytesPerLine;   /* next bloc 4 pixel boundaries */
                    
        clippedParams->vDest += clippedParams->bPitch;
        clippedParams->dxDest += clippedParams->src_bPitch;
    } /* for */
}

/***********************************************/

void BlitLoop(DX_PARAMS_HANDLE dxParams, BLIT_FUNC blitfunc,
                           int height, int ifbitsBytesPerLine)
{                                              
    int lineCount;

/*                               
    changed 4/23/97 by sjl
    seemed to fix bug (extra garbaged line) when blitting to a stretch bright screen
    
    for(lineCount=1; lineCount <= height; lineCount++) {
*/
    for(lineCount=1; lineCount < height; lineCount++) {
        blitfunc(dxParams);
        if (!(lineCount & 3))   
            dxParams->dx_bloc += ifbitsBytesPerLine;    /* next bloc 4 pixel boundaries */
                    
        dxParams->vDest += dxParams->bPitch;
        dxParams->dxDest += dxParams->src_bPitch;

/* for stretch bright*/
/* 4/23/97 */
dxParams->dxLast += dxParams->src_bPitch;

    } /* for */
}

/***********************************************/
int DecompressorBlitter(DXL_XIMAGE_1HANDLE src, DXL_VSCREEN_HANDLE dst,int BlitOnly)
{
    int ifbitsBytesPerLine;
    unsigned long longkeybloc[10]={0,0,0,0,0,0,0,0,0,0};    
        /* up to 10*32 blocks (1280 pix) */
    DX_FUNC dxfuncs[4];          
    DX_PARAMS dxParams;
    DX_PARAMS clippedParams;
    int xImageClipped = 0;
        
    validate(src);

    if (BlitOnly) /* there must be an interframe buffer to blit */
        BlitOnly = (src->lh > 0);

    /* place-holder frame, type 0 means no header -- don't decode */    
    if (!src->addr | !src->dxInfo.f.Type){
        if (!BlitOnly) 
            return DXL_HOLD_FRAME;

        src->dkFlags.doCompleteBlit = 1;
    }    
    
    if (dst){ 
        if((dst->bd == DXRGB16VESA) && src->dxInfo.sprite) 
            return DXL_INVALID_BLIT;

        if (dst->lXImage != (DXL_XIMAGE_HANDLE ) src){
            src->dkFlags.doCompleteBlit = 1;
            dst->lXImage = (DXL_XIMAGE_HANDLE ) src;
        }

        /* if derived VScreen, don't copy twice */
        if (src->lineBuffer == (dst->addr-dst->pitch))
            dst = (DXL_VSCREEN_HANDLE)0L;
    }else {
        if (BlitOnly) return DXL_INVALID_BLIT;

        if (src->dxInfo.sprite) return DXL_INVALID_BLIT;
    }
    
    dxParams.linedisplay = 1;       /* everything draws */

    dxParams.LeftSkipPixels = dxParams.RightSkipPixels = 0;

    dxParams.sizeofpixel = DXL_GetXImageSizeOfPixel((DXL_XIMAGE_HANDLE) src);

    SetupBlockAndVectorInfo(src, &dxParams, 
        &ifbitsBytesPerLine, (blockInfo *)longkeybloc);

    if (SetupXImageDxDestAndOrBlitSrc(src,&dxParams) < 0)
        return DXL_INVALID_BLIT;
    

    if (!BlitOnly) {
        SetupDecompressor(src, dst, &dxParams, dxfuncs);
    }
    
    if (dst) { /* decompress and blit */
        BLIT_FUNC blitsetup,blitfunc;
        int framexoff=0;
        int frameyoff=0;
                                          
        DXL_GetXImageOffset((DXL_XIMAGE_HANDLE)src,&framexoff,&frameyoff);
        SetupBlitterDestination(&dxParams,dst,framexoff,frameyoff);

#if defined(DX_TIGB)
#if DX_TIGB
        if (src->dxInfo.f.Type == COMP_TYPES){ /* dbm */
            dx(dxParams.vDest, dst->bq == DXBLIT_STRETCH, 
                ((unsigned char *)(src->addr) + src->dxInfo.hdrSize), 
                src->dxInfo.imwidth | (src->dxInfo.imheight << 16),
                dxParams.bPitch,        /* pitch in bytes */
                src->dxInfo.f.metaType);    /* TIGB uses metatype!*/
            return DXL_OK;
        }
#endif
#endif
        
        if (dxParams.vDest != dst->laddr){
            src->dkFlags.doCompleteBlit = 1;
            dst->laddr = dxParams.vDest;
        }

#if 1  /* do not clip when making fast lib for John... */
        /* check for clipping */
        xImageClipped = SetupXimageClipping(&dxParams, &clippedParams, src, dst);
		if (xImageClipped)
	        resetDecompressor(src, dst, &dxParams, dxfuncs);
#endif

        /* get your hamdy damdy registered blitter setup */
        blitsetup = (BLIT_FUNC) DXL_GetBlitSetupFunc((DXL_XIMAGE_HANDLE) src,dst);

        if (blitsetup != (BLIT_FUNC)-1) blitsetup(xImageClipped ? &clippedParams : &dxParams);

        /* get your hamdy damdy registered blitter */   
        blitfunc = (BLIT_FUNC) DXL_GetBlitFunc((DXL_XIMAGE_HANDLE) src,dst);
        
/*        if (blitfunc != (BLIT_FUNC)-1){ */
                                            /* and the kludge pot grows */       
        if ((blitfunc != (BLIT_FUNC)-1) && (!src->dxInfo.sprite)){
            switch(xImageClipped) {
                case 0:
                    if (BlitOnly)
                        BlitLoop(&dxParams,blitfunc,
                            src->dxInfo.imheight, ifbitsBytesPerLine);
                    else {
#ifdef HIRES
//this only works with win95!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//need more logic to prevent other platforms from crashing
//break out code from dxduck
                        if((dst->bq == DXBLIT_SAME && dst->bd == DXRGB16) && (!src->dxInfo.sprite)) {
                            if(!src->dxInfo.hinterp && !src->dxInfo.interframe) {
                                DecompressWithBuiltInBlitLoopRA(&dxParams, dxfuncs,
                                    src->dxInfo.imheight);
                            } else if(src->dxInfo.interframe && foundMMX) {
                                DecompressWithBuiltInBlitLoopER(&dxParams, dxfuncs,
                                    src->dxInfo.imheight, ifbitsBytesPerLine);
                            } else {
                                DecompressAndBlitLoop(&dxParams, dxfuncs, blitfunc,
                                src->dxInfo.imheight, ifbitsBytesPerLine);
                            }
                        } else 
#endif                        
                        if (src->imType == DXL_INTRAFRAME)
                            DecompressIntraFrameAndBlitLoop(&dxParams, dxfuncs, blitfunc,
                              src->dxInfo.imheight, ifbitsBytesPerLine); 
                        else 
                            DecompressAndBlitLoop(&dxParams, dxfuncs, blitfunc,
                            src->dxInfo.imheight, ifbitsBytesPerLine);
                    }
                    break;
                case 1:
                    if (BlitOnly){
                        ClipBlitLoop(&clippedParams,blitfunc,
                            src->dxInfo.imheight, ifbitsBytesPerLine);
                    }else{
                        DecompressAndClipBlitLoop(&dxParams, &clippedParams, dxfuncs, blitfunc, 
                            src->dxInfo.imheight, ifbitsBytesPerLine);
                    }
                    break;   
                case 2:
                    /* decompress only */
                    DecompressLoop(&dxParams, dxfuncs, src->dxInfo.imheight, 
                        ifbitsBytesPerLine);
                    break;
            }   
            
            src->dkFlags.doCompleteBlit = 0;
            return DXL_OK;
        }else if (!src->dxInfo.sprite)
            return DXL_INVALID_BLIT;
    }
    
    /* if no interframe buffer, don't bother dx'ing*/
    if (src->lh < 1 && !src->dxInfo.sprite) return DXL_OK; 

    src->dkFlags.doCompleteBlit = 1;

    if(xImageClipped) {
        int i;
        /* setup dxfuncs for sprite clipping */
        for(i=0; i < 4; i++) {  /* i==0 has colors */
            if(i==1)
                (dxfuncs[i]) = clp_dxcSprite;
            else
                (dxfuncs[i]) = clp_dxSprite;
        }
        DecompressAndClipSpriteBlitLoop(&dxParams, &clippedParams, dxfuncs,  
                     src->dxInfo.imheight, ifbitsBytesPerLine);
    } else {                 
         /* decompress only */
        DecompressLoop(&dxParams, dxfuncs, src->dxInfo.imheight, 
            ifbitsBytesPerLine);
    }
    return DXL_OK;          
}

/***********************************************/

int tm1_xImageDx(DXL_XIMAGE_1HANDLE src, DXL_VSCREEN_HANDLE dst)
{        
    if (((src->dxInfo.f.Type >= CTYP_V24_4x4) && (src->dxInfo.f.Type <= CTYP_H24_2x2))){
		int dPitch=0,forceHeight=1024;
		char *daddr=NULL;

		if (!(src->dxInfo.f.Type && src->addr)) return 1;

		if (dst){
    		dPitch = dst->pitch;
    		daddr = (char *)dst->addr;
	    	forceHeight = dst->height;
		}
	    dxl_24c(src->dxInfo.hdrSize + src->addr, (void *)daddr,
			dPitch,src->dxInfo.iskeyframe,
			src->dxInfo.hinterp,
			0,
			src->dxInfo.imwidth,
			src->dxInfo.imheight,
			src->dxInfo.blockpower, 
			src->dxInfo.block2x,
			forceHeight, 
			(char *)src->lineBuffer,
			(char *)src->chromaBuffer);

		if (dst) {
			int DXL_Blit24(register DXL_XIMAGE_1HANDLE src,register DXL_VSCREEN_HANDLE dst);
			DXL_Blit24(src,dst);
			}

		return 0;
	}
	return DecompressorBlitter(src,dst,0); /* not BlitOnly */
}

int tm1_xImageBlit(DXL_XIMAGE_1HANDLE src, DXL_VSCREEN_HANDLE dst)
{
	return DecompressorBlitter(src,dst,1); /* BlitOnly */
}

/***********************************************/

unsigned char *DXL_GetXImageBlockInfo(DXL_XIMAGE_HANDLE xImage)
{
    dxInfoStruct *pdxInfo = &(((DXL_XIMAGE_1HANDLE)xImage)->dxInfo);

    if(pdxInfo->iskeyframe) return 0L;
    return (xImage->addr + pdxInfo->hdrSize );
} 

/***********************************************/

int DXL_BlitVScreenToVScreen(DXL_VSCREEN_HANDLE src, DXL_VSCREEN_HANDLE dst)
{
    DX_PARAMS dxParams;
    
    if (!src || !dst) return DXL_INVALID_BLIT;

    if(src->addr == dst->addr) return DXL_OK;
        
    dxParams.linedisplay = 1;       /* everything draws */
    dxParams.LeftSkipPixels = dxParams.RightSkipPixels = 0;

    SetupVScreenBlitSrc(src,&dxParams);
    SetupBlitterDestination(&dxParams,dst,0,0);


/* 4/23/97 */
if (dst->bq == DXBLIT_STRETCH_BRIGHT) {
    dxParams.dxLast = dxParams.dxDest;
    dxParams.dxDest = dxParams.dxLast + dxParams.src_bPitch;
}


    {
        BLIT_FUNC blitsetup,blitfunc;

        /* get your hamdy damdy registered blitter setup */
        blitsetup = (BLIT_FUNC) DXL_GetVBlitSetupFunc(src,dst);

        if (blitsetup != (BLIT_FUNC)-1) blitsetup(&dxParams);

        /* get your hamdy damdy registered blitter */   
        blitfunc = (BLIT_FUNC) DXL_GetVBlitFunc(src,dst); 

        if (blitfunc != (BLIT_FUNC)-1){
            BlitLoop(&dxParams,blitfunc,src->height, 0);
        }else
            return DXL_INVALID_BLIT;    
    }   
    return DXL_OK;          
}

/***********************************************/
