/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/**

	DXL16C.C


	this module contains the following callable routines:

I32 init_dxI();
void end_dxI();
void dxI(U32 fp16Src,I32 hdrSize,U32 fp16Dest,
	WORD dstX,WORD dstY,WORD dstW,WORD dstH,
	long dstHeight,long dstPitch,I32 iskeyframe,
	I32 hinterp,I32 doublesize,I32 directtoscreen);
**/

#include "dkpltfrm.h"

#include <stdlib.h>
#include "duktypes.h"
#include "cduck.h"

#define OLDCODE 0
#define BLOCK2X 0
#define HSTRETCH 0
#define COLOR_256 0
#define BUILDMAC 0

#define IADD 0x0004
#define ISHIFT    4
#define IOFFSET 4096

#define tbl2 tbl+IOFFSET

#if defined(DEBUG)
#define DIAGNOSTIC(x) x
#else
#define DIAGNOSTIC(x)
#endif
/*
/// these arrays are in dxc2:

//extern  I16 dxDelta1[];
//extern  I16 dxCdelta1[];

/// this ptr is in ccomp2.c:

//extern U8 (*pc_tbl2)[16];
//extern I32 forceheight;   
*/
/************************************** INTERFRAME STUFF/C DECOMPRESSION */

#define ISINTERBLOCK(a,b)   ((*(a+((b)>>3))) & (1<<((b)%8)))

void c_dxicNC2(unsigned long);
void c_dxic2(unsigned long);
void c_dxicNC(unsigned long);
void c_dxic(unsigned long);
void c_dxiNC(unsigned long);
void c_dxi(unsigned long);
void c_dxiSpriteC(unsigned long);
void c_dxiSprite(unsigned long);

/*
// used by ASM code, so get it right:
//#define MAX_WIDTH   640
//#define VOFF        (MAX_WIDTH/2)
*/
#define VOFF swidth
int gswidth;
/* vars that need to be seen by asm code*/

void *scrn;
signed char *dx_vloc;
long dx_index;

/* vars that don't                    */

static  I16 dx_hres,dx_vres;
static  U8 *dx_bloc;
/*static  U32 *dx_ubloc;*/
static  I16 dx_iblocks,dx_tmblocks,dx_ablocks;
static U32  dx_doublesize;
/*static U16 dxIdeltas[8],dxIfdeltas[8];*/
/*static U16 dxIcolor[8],dxIfcolor[8];*/
static  U32 far dx_keybloc[5]={0,0,0,0,0};      /* up to 5*32 blocks (640 pix)*/

static  U32 *dxLast;                            /* for C */
static  U16 far *dxDest;                        /* for C */

/****************** C versions ***********************/

extern signed char vectbl[1024*4*4];

/*extern unsigned short *clutbuf;*/

/*********** MACROS: */

#define WRITEPIX1                               \
	*ldest++=(ltemp>>16) | (ltemp&0xffff0000);

#define WRITEPIX2                               \
	*ldest++=(ltemp&0xffff) | (ltemp<<16);

#if 0
#define WRITE2PIX(last,vp,pitch) \
	({asm("lw $3,0(%1);  \
		add $3,$3,%2; \
		add $2,%0,%3; \
		sw $3,0($2); \
		addi %0,%1,4" \
		: "=g" (last) \
		: "0" (last), "g" (vp), "g" (pitch) \
		: "$2", "$3" );})

#define WRITEDBLPIX WRITE2PIX(last,vp,swidth);
#else


#define WRITEDBLPIX                                      \
	*ldest++=*(last+VOFF)=(*last)+vp; \
	++last;

#define WRITEDBLPIXNC                     \
	*(last+VOFF)=(*last)+vp; \
	++last;

#endif

#define GETVECCNEW                                      \
	temp=*(long *)(tbl2+index);       \
     vp+=(temp>>1);                                             \
	 index+=IADD;                                     \
     if(temp&1)                                            \
		if(!(index=(*vloc++)<<ISHIFT)) {\
			index=(*vloc++)<<ISHIFT;          \
			temp=*(long *)(tbl2+index);\
			index+=IADD;                                    \
			if(temp&1) index=(*vloc++)<<ISHIFT;          \
			vp +=((temp>>1)*5);                        \
		}                                                                               

#define GVHVNEW \
	index+=IADD; \
	temp=*(long *)(tbl+index-IADD); \
	vp+=(temp>>1); \
     if(temp&1) \
		if(!(index=(*vloc++)<<ISHIFT)){ \
			index=(*vloc++)<<ISHIFT; \
			temp=*(long *)(tbl+index); \
			index+=IADD; \
			if(temp&1) index=(*vloc++)<<ISHIFT; \
			vp +=((temp>>1)*5); \
		} \
	WRITEDBLPIX

#define GVHVNEWNC\
	index+=IADD; \
	temp=*(long *)(tbl+index-IADD); \
	vp+=(temp>>1); \
     if(temp&1) \
		if(!(index=(*vloc++)<<ISHIFT)){ \
			index=(*vloc++)<<ISHIFT; \
			temp=*(long *)(tbl+index); \
			index+=IADD; \
			if(temp&1) index=(*vloc++)<<ISHIFT; \
			vp +=((temp>>1)*5); \
		} \
	WRITEDBLPIXNC

#define GVHVSPRITE \
	index+=IADD; \
	temp=*(long *)(tbl+index-IADD); \
	vp+=(temp>>1); \
     if(temp&1) \
		if(!(index=(*vloc++)<<ISHIFT)){ \
			index=(*vloc++)<<ISHIFT; \
			temp=*(long *)(tbl+index); \
			index+=IADD; \
			if(temp&1) index=(*vloc++)<<ISHIFT; \
			vp +=((temp>>1)*5); \
		} \
	*ldest++= *last++ += vp;

#define GVHVA                                  \
	index+=IADD;                                    \
	temp=*(long *)(tbl+index-IADD);        \
	vp+=(temp>>1);                                  \
     if(temp&1)                                     \
		if(!(index=(*vloc++)<<ISHIFT)){\
			index=(*vloc++)<<ISHIFT;   \
			temp=*(long *)(tbl+index);      \
			index+=IADD;                            \
		 if(temp&1)                                       \
				index=(*vloc++)<<ISHIFT;   \
			vp +=((temp>>1)*5);                         \
		}

#ifdef SEGA
#define DOALPHA \
	temp=*(long *)(tbl+index+(IOFFSET*2));        \
	index+=IADD;                                    \
     if(temp&1) index=(*vloc++)<<ISHIFT;        \
	(*last) += vp; \
	*ldest++ = 0x80008000 | antiAlias(temp>>1,*last++,*ldest);
#else
#define DOALPHA \
	temp=*(long *)(tbl+index+(IOFFSET*2));        \
	index+=IADD;                                    \
     if(temp&1) index=(*vloc++)<<ISHIFT;        \
	(*last) += vp; \
	*ldest++ = antiAlias(temp>>1,*last++,*ldest);
#endif
	
#define DOIF                                       \
		vp=*(last+VOFF+1)-*(last+1); \
		*ldest++=*(last++ +VOFF);        \
		*ldest++=*(last++ +VOFF);

#define DOIFNC \
		vp=*(last+VOFF+1)-*(last+1); \
		last += 2; \
		ldest += 2; 

#define DOBG \
		vp = 0; \
		ldest += 2; \
		last += 2;
 
#define DOBGC \
		vp = 0; \
		*last++ = 0; \
		ldest += 2;  \
		*last++ = 0;
		
#define GVHVS	GVHVSPRITE
#define GVHV	GVHVNEW
#define GVHVNC	GVHVNEWNC
#define GETVECC	GETVECCNEW


#if 1
#ifdef __GNUC__
static inline unsigned long 
#else
static unsigned long 
#endif
antiAlias(unsigned int alpha,unsigned long fore, unsigned long back)
{                                     
	fore &= 0x7fff7fff;
	back &= 0x7fff7fff;
	
	if (alpha == 6) return fore;
	if (alpha == 0) return back;
    {
		unsigned long low=0,high=0;
		unsigned int alpha1 = (alpha%5); 

		alpha = (alpha/5);      
	
		back += 0x04210421;	
		fore += 0x04210421;	
		
		back &= 0xf39cf39c;
		fore &= 0xf39cf39c;

#ifdef SONY
#define AL1 alpha1
#define AL alpha
#else
#define AL1 alpha
#define AL alpha1
#endif
		
		if (AL1 == 1)
			high = fore;
		else if (AL1 == 0)
			high = back;
		else{
			AL1 -= 1;
			low = fore & 0xffff0000;
			high = back & 0xffff0000;
			high = ((low>>2)*AL1) + ((back>>2)*(4-AL1));
			/*high = low + ((back>>2)*(4-AL1));*/
		}
		
		if (AL == 1)
			low = fore;
		else if (AL == 0)
			low = back;
		else{
			AL -= 1;
			low = ((fore>>2)*AL) + ((back>>2)*(4-AL));
			/*low = fore + ((back>>2)*(4-AL));*/
		}
		return ((low & 0x00007fff) | (high & 0x7fff0000));
	}
}

void c_dxiSprite(U32 width) {
    U8 *cbloc=(U8 *)dx_bloc;
    U32 xcnt;
    long temp;
    long vp=0;
    long *last=(long*)dxLast;
    long *ldest=(long*)dxDest;
    long index=dx_index;
    signed char *vloc=dx_vloc;
    signed char *tbl=&vectbl[TBLOFFSET];
    U32 lbctl;
             
    while(width){
		lbctl =(U32)*cbloc++;
	
		xcnt = (width > 16) ? 16 : width;
		width -= xcnt;      

		if (!lbctl){
			vp = 0;
			ldest += xcnt>>1;
			last += xcnt>>1;
			continue;
		}
		xcnt>>=2;
		while(xcnt--){
			if(lbctl&1) {    /*/ if TM*/
				GVHVS         /*/ hit me agin:*/
				GVHVS
			} else {         /*/ SP*/
				if (lbctl&2){
					GVHVA     /*/ hit me agin:*/
					DOALPHA
					GVHVA
					DOALPHA
				}else{
					DOBG
				}
			}
			lbctl>>=2;
		}
    }
    
	dx_index=index;
	dx_vloc=vloc;
}

void c_dxiSpriteC(U32 width) {
    U8 *cbloc=(U8 *)dx_bloc;        /*/     ENDIAN issues -- get bytes*/
    U32 xcnt;
    long temp;
    long vp=0;
    long *last=(long*)dxLast;
    long *ldest=(long*)dxDest;
    long index=dx_index;
    signed char *vloc=dx_vloc;
    signed char *tbl=&vectbl[TBLOFFSET];
    U32 lbctl;    
    
    while(width){
	    lbctl =(U32)*cbloc++;

	    xcnt = (width > 16) ? 16 : width;
	    width -= xcnt;
	    
	    xcnt>>=2;
	    while(xcnt--){
			if(lbctl&1) {    /*/ if TM*/
				GETVECC
				GVHVS     /*/ hit me agin:*/
				GVHVS
			} else {         /*/ SP*/
				if (lbctl&2){
					GETVECC
					GVHVA     /*/ hit me agin:*/
					DOALPHA
					GVHVA
					DOALPHA
				}else{
					DOBGC
				}
			}
			lbctl>>=2;
	    }
	}
	
	dx_index=index;
	dx_vloc=vloc;
}
#endif

void c_dxic(U32 width) {
    U8 *cbloc=(U8 *)dx_bloc;        /*/     ENDIAN issues -- get bytes*/
    U32 xcnt;
    long temp;
    long vp=0;
    long *last=(long*)dxLast;
    long *ldest=(long*)dxDest;
    long index=dx_index;
    signed char *vloc=dx_vloc;
    signed char *tbl=&vectbl[TBLOFFSET];
    U32 lbctl;    
    int swidth = gswidth;

    while(width){
	    lbctl =(U32)*cbloc++;

	    xcnt = (width > 32) ? 32 : width;
	    width -= xcnt;
	    
	    xcnt>>=2;
	    while(xcnt--){
			if(lbctl&1) {    /*/ if IF*/
					DOIF
			} else {         /*/ TM*/
					GETVECC
					GVHV     /*/ hit me agin:*/
					GVHV
			}
			lbctl>>=1;
	    }
	}
	
	dx_index=index;
	dx_vloc=vloc;
}

void c_dxi(U32 width) {
    U8 *cbloc=(U8 *)dx_bloc;
    U32 xcnt;
    long temp;
    long vp=0;
    long *last=(long*)dxLast;
    long *ldest=(long*)dxDest;
    long index=dx_index;
    signed char *vloc=dx_vloc;
    signed char *tbl=&vectbl[TBLOFFSET];
    U32 lbctl;
    int swidth = gswidth;
    
    while(width){
		lbctl =(U32)*cbloc++;
	
		xcnt = (width > 32) ? 32 : width;
		width -= xcnt;      
	
		xcnt>>=2;
		while(xcnt--){
			if(lbctl&1) {    /*/ if IF*/
				DOIF
			} else {         /*/ TM*/
				GVHV         /*/ hit me agin:*/
				GVHV
			}
			lbctl>>=1;
		}
    }
	dx_index=index;
	dx_vloc=vloc;
}

void c_dxic2(U32 width) {
    U8 *cbloc=(U8 *)dx_bloc;        /*/     ENDIAN issues -- get bytes*/
    U32 xcnt;
    long temp;
    long vp=0;
    long *last=(long*)dxLast;
    long *ldest=(long*)dxDest;
    long index=dx_index;
    signed char *vloc=dx_vloc;
    signed char *tbl=&vectbl[TBLOFFSET];
    U32 lbctl;    
    int swidth = gswidth;

    while(width){
	    lbctl =(U32)*cbloc++;

	    xcnt = (width > 32) ? 32 : width;
	    width -= xcnt;
	    
	    xcnt>>=2;
	    while(xcnt--){
			if(lbctl&1) {    /*/ if IF*/
					DOIF
			} else {         /*/ TM*/
					GETVECC
					GVHV     /*/ hit me agin:*/
					GETVECC
					GVHV
			}
			lbctl>>=1;
	    }
	}
	
	dx_index=index;
	dx_vloc=vloc;
}


#define c_dxi2x c_dxi
#define c_dxic2x c_dxic

/******************* ASM stuff ************************/

void dxIline_init() {
    dx_index=((long)(*dx_vloc))<<ISHIFT;
    dx_vloc++;
}

#define IF_BLOCKSIZE 4


void dxl_16c(void *compaddr, void far *scrnaddr,
	int dstPitch,short iskeyframe,
	short hinterp,int doublesize,
	long scrnwidth,long scrnheight,
	long blockpower, long block2x,
	int forceheight, char *lastdecomp,
	short sprite,short NoCopy)
{
    U16 i;
    I16 ifbitsBytesPerLine = 0;
    U8 far *dxSrc;
	U32     tempheight,scanline;
	int		lgswidth;
	void (*funcs[4])(unsigned long);
    
    if (sprite) iskeyframe = 0;

    gswidth = scrnwidth/2;
    
	{
    dxSrc = (U8 far *)compaddr;
    dxDest = (U16 far *)scrnaddr;
    
    /*dxDest += (dstPitch*4);*/
	hinterp=doublesize=HSTRETCH;

#ifdef SONY    
    if (sprite)
    	dxLast = (U32 *)0x1f800000;
    else
#endif
		dxLast = (U32 *)lastdecomp;
    	
    if(!iskeyframe) {
		dx_bloc = dxSrc;
		if (sprite){
			ifbitsBytesPerLine = ( ( scrnwidth>>2 )+3) >>2;
			dx_vloc = (signed char *)((U32)dx_bloc + ifbitsBytesPerLine * (scrnheight>>2));
		}else{
			ifbitsBytesPerLine = ( ( scrnwidth>>2 )+7) >>3;
			dx_vloc = (signed char *)((U32)dx_bloc + ifbitsBytesPerLine * (scrnheight>>2));
		}
    } else {
		dx_vloc = (signed char *)dxSrc;
		dx_bloc = (U8 far *)dx_keybloc;
    }

    dxIline_init();
    
    if(blockpower == 1)  dx_vres = 2;
    else dx_vres = 4;

    if(block2x == 1) dx_hres = 2;
    else dx_hres = 4;

    for(i=0; i<scrnwidth/2; i++) 
		dxLast[i] = BLACK16X2;
		
    scrn = (void *)(dxLast + (scrnwidth/2));
	
    dx_ablocks = dx_iblocks = dx_tmblocks = 0;

	tempheight = (scrnheight>forceheight) ? forceheight:scrnheight;
	
	/**** LINE LOOP: ****/

    if(doublesize) dstPitch *= 2;
	dx_doublesize=doublesize;
    
	/* generate a function calling table */

	for(i = 0; i < 4; i++){
		if (!sprite){
			if(!(i%dx_vres)){
				if (dx_hres == 2)
					funcs[i] = (NoCopy) ? c_dxicNC2 : c_dxic2; /* color */
				else
					funcs[i] = (NoCopy) ? c_dxicNC : c_dxic; /* color */
			}else
				funcs[i] = (NoCopy) ? c_dxiNC : c_dxi;  /* no color */
		}else{
			if(!(i%dx_vres))
				funcs[i] = c_dxiSpriteC; /* color */
			else
				funcs[i] = c_dxiSprite;  /* no color */
		}
	}

	/* now call use the function call table in the frame loop */

	lgswidth = sprite ? 0 : gswidth;
	
	for(scanline=0; scanline < tempheight;) {

		(*funcs[scanline&3])(scrnwidth);
		dxLast += lgswidth;						/* update pixpair ptr */
		
		dxDest += dstPitch;

		if(!(++scanline%IF_BLOCKSIZE)) {         /* if interframe row top */
			if(!iskeyframe) {                          /* if not keyframe,*/
				dx_bloc += ifbitsBytesPerLine; /* next bloc */
		    }
		}
    } /*/-for all lines*/
  }
}

void c_dxicNC(U32 width) {
    U8 *cbloc=(U8 *)dx_bloc;        /*/     ENDIAN issues -- get bytes*/
    U32 xcnt;
    long temp;
    long vp=0;
    long *last=(long*)dxLast;
    long *ldest=(long*)dxDest;
    long index=dx_index;
    signed char *vloc=dx_vloc;
    signed char *tbl=&vectbl[TBLOFFSET];
    U32 lbctl;    
    int swidth = gswidth;

    while(width){
	    lbctl =(U32)*cbloc++;

	    xcnt = (width > 32) ? 32 : width;
	    width -= xcnt;
	    
	    xcnt>>=2;
	    while(xcnt--){
			if(lbctl&1) {    /*/ if IF*/
					DOIFNC
			} else {         /*/ TM*/
					GETVECC
					GVHVNC     /*/ hit me agin:*/
					GVHVNC
			}
			lbctl>>=1;
	    }
	}
	
	dx_index=index;
	dx_vloc=vloc;
}

void c_dxiNC(U32 width) {
    U8 *cbloc=(U8 *)dx_bloc;
    U32 xcnt;
    long temp;
    long vp=0;
    long *last=(long*)dxLast;
    long *ldest=(long*)dxDest;
    long index=dx_index;
    signed char *vloc=dx_vloc;
    signed char *tbl=&vectbl[TBLOFFSET];
    U32 lbctl;
    int swidth = gswidth;
    
    while(width){
		lbctl =(U32)*cbloc++;
	
		xcnt = (width > 32) ? 32 : width;
		width -= xcnt;      
	
		xcnt>>=2;
		while(xcnt--){
			if(lbctl&1) {    /*/ if IF*/
				DOIFNC
			} else {         /*/ TM*/
				GVHVNC         /*/ hit me agin:*/
				GVHVNC
			}
			lbctl>>=1;
		}
    }
	dx_index=index;
	dx_vloc=vloc;
}

void c_dxicNC2(U32 width) {
    U8 *cbloc=(U8 *)dx_bloc;        /*/     ENDIAN issues -- get bytes*/
    U32 xcnt;
    long temp;
    long vp=0;
    long *last=(long*)dxLast;
    long *ldest=(long*)dxDest;
    long index=dx_index;
    signed char *vloc=dx_vloc;
    signed char *tbl=&vectbl[TBLOFFSET];
    U32 lbctl;    
    int swidth = gswidth;

    while(width){
	    lbctl =(U32)*cbloc++;

	    xcnt = (width > 32) ? 32 : width;
	    width -= xcnt;
	    
	    xcnt>>=2;
	    while(xcnt--){
			if(lbctl&1) {    /*/ if IF*/
					DOIFNC
			} else {         /*/ TM*/
					GETVECC
					GVHVNC     /*/ hit me agin:*/
					GETVECC
					GVHVNC
			}
			lbctl>>=1;
	    }
	}
	
	dx_index=index;
	dx_vloc=vloc;
}
