/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/**

	DXL24C.C


	this module contains the following callable routines:

**/

#include "dkpltfrm.h"
#include <stdlib.h>
#include "duktypes.h"
#include "cduck.h"
#include "dxparams.h"
#include "dxl_main.h"

#define IADD 0x0004
#define ISHIFT    4
#define IOFFSET 4096

#define VOFF swidth
#define COFF cwidth

int gswidth24;
dxVector8 *dx_vloc;
blockInfo *dx_bloc;
dxVector32 dx_index;

U32 *dxLast;                            /* for C */
U32 *dxcLast;                            /* for C */

void c_dxi(U32);
void c_dxic(U32);
void c_dxic2(U32);

static U32 dx_keybloc[5]={0,0,0,0,0};      /* up to 5*32 blocks (640 pix)*/

/****************** C versions ***********************/

#define c_dxi2x c_dxi
#define c_dxic2x c_dxic

/******************* ASM stuff ************************/

#define IF_BLOCKSIZE 4

void dxSetdts24(long pseudo)
{
}

void dxl_24c(void *compaddr, void *scrnaddr,
	int dstPitch,int iskeyframe,
	int hinterp,int doublesize,
	int scrnwidth,int scrnheight,
	int blockpower, int block2x,
	int forceheight, char *lastdecomp,
	char *lastcdecomp)
{
    I16 ifbitsBytesPerLine;
	int scanline;
    I16 dx_hres,dx_vres;

    gswidth24 = scrnwidth/4;
    
    dxLast = (U32 *)lastdecomp;
    dxcLast = (U32 *)lastcdecomp;

    if(!iskeyframe) {
		dx_bloc = (blockInfo *)compaddr;
		ifbitsBytesPerLine = ( ( scrnwidth>>2 )+7) >>3;
		dx_vloc = (dxVector8 *) dx_bloc + ifbitsBytesPerLine * (scrnheight>>2);
    } else {
		dx_bloc = (blockInfo *)dx_keybloc;
		ifbitsBytesPerLine = 0;
		dx_vloc = (dxVector8 *)compaddr;
    }

    dx_index=((dxVector32)(*dx_vloc))<<ISHIFT;
    dx_vloc++;
    
    if(blockpower == 1)  dx_vres = 2;
    else dx_vres = 4;

    if(block2x == 1) dx_hres = 2;
    else dx_hres = 4;
    
	/**** LINE LOOP: ****/

	for(scanline=0; scanline < scrnheight; scanline++) {

	    if(!(scanline%IF_BLOCKSIZE)) { /* if interframe row top */
			if(scanline) dx_bloc += ifbitsBytesPerLine; /* next bloc */
		}
	
		if(!(scanline%dx_vres)){
		    if (dx_hres == 4){
				c_dxic(scrnwidth); /* color */
				dxcLast += gswidth24;          /* update color ptr */
			}else{
				c_dxic2(scrnwidth); /* color */
				dxcLast += gswidth24*2;          /* update color ptr */
			}
		}else
		    c_dxi(scrnwidth);  /* no color */

		dxLast += gswidth24;                   /* update pixpair ptr */
    } /*/-for all lines*/
}
