/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "dkpltfrm.h"

#include "duktypes.h"
#include "cduck.h"

#include "dxl_main.h"                                            
#include "stdlib.h"

DXL_XIMAGE_HANDLE populateXImage(DXL_XIMAGE_HANDLE xImage);

DXL_XIMAGE_HANDLE tm1_AlterXImage(DXL_XIMAGE_HANDLE nImage,
	void *vData,int type,
	enum BITDEPTH bitDepth,int width,int height)
{
    

	unsigned char *data = (unsigned char *) vData;
	
	if (nImage != NULL)
		DXL_DestroyXImage(nImage);

	if ((nImage = DXL_CreateXImage(data)) == NULL)
		return NULL;
    
    nImage->dkFlags.DXed = 0;
    
    if (data != NULL){
		return nImage;
	}
	
	((DXL_XIMAGE_1HANDLE)nImage)->dxInfo.imheight = height;
	((DXL_XIMAGE_1HANDLE)nImage)->dxInfo.imwidth = width;

	((DXL_XIMAGE_1HANDLE)nImage)->dxInfo.f.Type = (bitDepth == DXRGB24CHAR) ? 
		CTYP_V24_4x4: CTYP_H16_4x4;

	((DXL_XIMAGE_1HANDLE)nImage)->dxInfo.interframe = (type == DXL_INTERFRAME);
	((DXL_XIMAGE_1HANDLE)nImage)->dxInfo.sprite = (type == DXL_SPRITE);

	return populateXImage(nImage);
}

