/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "dkpltfrm.h"
#include <string.h>
#include <stdlib.h>
#include "duktypes.h"
#include "cduck.h"

#include "duck_hfb.h"
#include "dxl_main.h"  


void dxl_24c(void *compaddr, void far *scrnaddr,
	int dstPitch,short iskeyframe,
	short hinterp,int doublesize,
	long scrnwidth,long scrnheight,
	long blockpower, long block2x,
	int forceheight, char *lastdecomp,
	char *lastcdecomp);
	
void dxl_16c(void *compaddr, void far *scrnaddr,
	int dstPitch,short iskeyframe,
	short hinterp,int doublesize,
	long scrnwidth,long scrnheight,
	long blockpower, long block2x,
	int forceheight, char *lastdecomp,short sprite,short noCopy);

									      
int DXL_dxImageToVScreen(register DXL_XIMAGE_HANDLE src, register DXL_VSCREEN_HANDLE dst)
{
    int w,h,dPitch,forceHeight,noCopy;
    char *daddr;
    
    if (!src)
    	return -1;
    else if (!src->dkFlags.inUse) 
    	return -2;

    if (dst){
    	dPitch = dst->pitch;
    	daddr = (char *)dst->addr;
    	if (!dst->dkFlags.inUse) return -2;
    	forceHeight = dst->height;
	}else{
		daddr = (char *)NULL;
		dPitch = 0;
		forceHeight = 1024;
	}
	
    if (!(src->dxInfo.f.Type && src->addr)) return 1;
    
    if (((src->dxInfo.f.Type >= CTYP_V24_4x4) && (src->dxInfo.f.Type <= CTYP_H24_2x2))){
	    dxl_24c(src->dxInfo.hdrSize + src->addr, (void *)daddr,
		dst->pitch,src->dxInfo.iskeyframe,
		src->dxInfo.hinterp,0,
		src->dxInfo.imwidth,src->dxInfo.imheight,
		src->dxInfo.blockpower, src->dxInfo.block2x,
		forceHeight, (char *)src->lineBuffer,(char *)src->chromaBuffer);

		if (dst) DXL_BlitXImageToVScreen(src,dst);
	}else{
		short *newDest = (short *)daddr;
		
		if (newDest) newDest += (src->y*dPitch) + (src->x);
		
		if (src->dxInfo.sprite && daddr){
			newDest += (src->dxInfo.f.yoff*dPitch) + (src->dxInfo.f.xoff);
		}
		if (daddr && !src->dxInfo.sprite) noCopy = 0;
		else noCopy = 1;

	    dxl_16c(src->dxInfo.hdrSize + src->addr, (void *)newDest,
			dPitch,src->dxInfo.iskeyframe,
			src->dxInfo.hinterp,0,
			src->dxInfo.imwidth,src->dxInfo.imheight,
			src->dxInfo.blockpower, src->dxInfo.block2x,
			forceHeight, (char *)src->lineBuffer,
			src->dxInfo.sprite,noCopy);
	}    
    return 0;
}
