/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _dxparams_h /* include guards */
#define _dxparams_h

#if defined(CENTER_TABLE)
#if CENTER_TABLE
typedef signed char dxVector8;
typedef signed long dxVector32;
#else
typedef unsigned char dxVector8;
typedef unsigned long dxVector32;
#endif
#else
typedef unsigned char dxVector8;
typedef unsigned long dxVector32;
#endif

typedef unsigned char blockInfo;

/***********************************************\
??? dxparams.h
\***********************************************/

/* DO NOT change the order of this structure */
/* it will BREAK the assembly code if you do!! */
/* SEE dxparam.ash */
typedef struct tdx_params {
    unsigned char *vDest;
    unsigned char *dxDest;                                                                      
    unsigned char *dxLast;                          
    blockInfo *dx_bloc;
    unsigned long width;

    dxVector8 *dx_vloc;
    dxVector32 dx_index;  

    /* used for clipping */
    long linedisplay;   
    unsigned long RightSkipPixels;
    unsigned long LeftSkipPixels;

    unsigned long ScreenIs565;                  
    signed long src_bPitch;
    unsigned long vesapage;
    signed long bPitch;               
    unsigned char *vesaDest; 
    unsigned long dither;  
    unsigned char *clutptr;
    unsigned char *clutptr2;
    unsigned char *dxLastBlit;
	blockInfo *dx_blocLast;
/*------------------------------------------*/
/* Ok, below this line you can */  
    int lineEnd; 
    int lineStart;
    unsigned char *addr;
    int hinterp;    
    int sizeofpixel;
    unsigned char *dxSrcRed;
    unsigned char *dxSrcGreen;
    unsigned char *dxSrcBlue;

} DX_PARAMS, *DX_PARAMS_HANDLE; 
    
typedef void ((*DX_FUNC)(DX_PARAMS_HANDLE));


#endif /* include guards */
