/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _dxSprite_h
#define _dxSprite_h

/**

    sprite.C

    this module contains the following callable routines:


**/

#include <stdlib.h>

#include "dkpltfrm.h"
#include "duktypes.h"
#include "cduck.h"
#include "dxparams.h"
#include "dxl_16.h"

#define OLDCODE 0
#define BLOCK2X 0
#define HSTRETCH 0
#define COLOR_256 0
#define BUILDMAC 0

#define IADD 0x0004
#define ISHIFT    4
#define IOFFSET 4096

#define tbl2 tbl+IOFFSET

#if defined(DEBUG)
#define DIAGNOSTIC(x) x
#else
#define DIAGNOSTIC(x)
#endif


/************************************** INTERFRAME STUFF/C DECOMPRESSION */

#define VOFF swidth

/* vars that need to be seen by asm code*/
extern dxVector8 vectbl[];

/*********** MACROS: */
#define WRITEDBLPIX                                      \
    *ldest++=*(last+VOFF)=(*last)+vp; \
    ++last;

#define WRITEDBLPIXNC                     \
    *(last+VOFF)=(*last)+vp; \
    ++last;

#define GVHVA                                  \
    index+=IADD;                                    \
    temp=*(long *)(tbl+index-IADD);        \
    vp+=(temp>>1);                                  \
     if(temp&1)                                     \
        if(!(index=(*vloc++)<<ISHIFT)){\
            index=(*vloc++)<<ISHIFT;   \
            temp=*(long *)(tbl+index);      \
            index+=IADD;                            \
         if(temp&1)                                       \
                index=(*vloc++)<<ISHIFT;   \
            vp +=((temp>>1)*5);                         \
        }

#define GETVECCNEW                                      \
    temp=*(long *)(tbl2+index);       \
     vp+=(temp>>1);                                             \
     index+=IADD;                                     \
     if(temp&1)                                            \
        if(!(index=(*vloc++)<<ISHIFT)) {\
            index=(*vloc++)<<ISHIFT;          \
            temp=*(long *)(tbl2+index);\
            index+=IADD;                                    \
            if(temp&1) index=(*vloc++)<<ISHIFT;          \
            vp +=((temp>>1)*5);                        \
        }                                                                               

#define GVHVNEW \
    GVHVA \
    WRITEDBLPIX 


#define GVHVSPRITE \
    GVHVA \
    *ldest++= *last++ += vp;

#define DOALPHA \
    temp=*(long *)(tbl+index+(IOFFSET*2));        \
    index+=IADD;                                    \
     if(temp&1) index=(*vloc++)<<ISHIFT;        \
    (*last) += vp; \
    *ldest++ = antiAlias(temp>>1,*last++,*ldest); 

#define DOBG \
        vp = 0; \
        ldest += 2; \
        last += 2; 
 
#define DOBGC \
        vp = 0; \
        *last++ = 0; \
        ldest += 2;  \
        *last++ = 0; 
        
#define GVHVS   GVHVSPRITE
#define GVHV    GVHVNEW
#define GETVECC GETVECCNEW

#ifdef __GNUC__
#define ANTIALIASTYPE inline unsigned long 
#else
#define ANTIALIASTYPE unsigned long 
#endif

ANTIALIASTYPE antiAlias(unsigned int alpha,
            unsigned long fore, unsigned long back);


#endif /* include guard */
