/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#define NEW24 1

#include "rename.h"
#include "dkpltfrm.h"

#include <stdlib.h> 

#include "duktypes.h"
#include "cduck.h"

#include "duck_hfb.h"
#include "dxl_main.h"

typedef unsigned int uint;

#define dxdt1 yyyy4
#define dxdt2 yyyy5
#define dxdt3 yyyy6
#define dxdt4 yyyy7
#define dxCdt1 yyyy8
#define dxCdt2 yyyy9
/*#define pdxdts yyy10*/
/*#define pdxCdts yyy11*/
#define olddts yyy12
#define oldCdts yyy13
#define lastdtSet yyy14
#define lastTable yyy15
#define lastdraw yyy16

static I16 dxdt1[8] = { 0, -2, 2, -6, 6, -12, 12, -12 };
static I16 dxdt2[8] = { 0, -2, 4, -6, 8, -12, 12, -12 };

static I16 dxdt3[8] = { 4, -6, 20, -20, 46, -46, 94, -94 };
static I16 dxdt3f[8] = { 0, -15, 50, -50, 115, -115, 235, -235 };

/*static I16 dxdt4[8] = { 0, -4, 4, -16, 28, -36, 80, -80 };
static I16 dxdt4f[8] = { 0, -10, 10, -40, 70, -90, 200, -200 };*/

static I16 dxdt4[8] = { 0, -4, 4, -16, 16, -36, 36, -80 };
static I16 dxdt4f[8] = { 0, 40, 80, -76, 160, -154, 236, -236 };

static I16 dxCdt1[8] = { 0, -1, 1, -2, 3 ,-4, 5, -4 };
static I16 dxCdt2[8] = { 0, -4, 3, -16, 20 ,-32, 36, -32 };
static I16 dxCdt2f[8] = { 0, -20, 15, -80, 100 ,-160, 180, -160 };

static I16 dxCdt3[8] = { 0, -2, 2, -8, 8, -18, 18, -40 };
static I16 dxCdt3f[8] = { 0, 40, 80, -76, 160, -154, 236, -236 };

/*static I16 dxCdt1[8] = { 0, -1, 1, -2, 2 ,-3, 3, -4 };*/

I16 *pdxdts[] = {	dxdt1,	dxdt2,	dxdt3,	dxdt4,	NULL };
static I16 *pdxfdts[] = { 	dxdt3f,	dxdt3f,	dxdt3f,	dxdt4f,	NULL };

I16 *pdxCdts[] = {	dxCdt1,	dxCdt1,	dxCdt2,	dxCdt3,	NULL };
static I16 *pdxfCdts[] = { dxCdt2f,dxCdt2f,dxCdt2f,dxCdt3f,NULL };
 
static I16 olddts[8],oldCdts[8];

signed short dt[8];
signed short cdt[8];
signed short fdt[8];
signed short fcdt[8];

#define block2x_array yyyy3
static I16 block2x_array[] =		{0,		0, 0, 0, 0, 1, 1, 1, 1,
									0, 0, 0, 0, 1, 1, 1, 1};
#define blockpower_array yyyy2
static I16 blockpower_array[] =	{0,		2, 2, 1, 1, 2, 2, 1, 1,
									2, 2, 1, 1, 2, 2, 1, 1};

/***********************************************************/
#define compTypes yyyy1
static COMPSTRUCT compTypes[COMP_TYPES] = {
/*DXEnabled[METATYPE+1], Algorithm, Numdts, HRes, VRes*/
	{ {0,0,0,0} ,     0,0,0,0 }, /*0 entry unused*/
	{ {0,1,1,1} ,RGB16V,8,4,4 }, /*C decompression*/
	{ {0,1,1,1} ,RGB16H,8,4,4 },
	{ {0,1,1,1} ,RGB16V,8,4,2 }, /*C decompression*/
	{ {0,1,1,1} ,RGB16H,8,4,2 },
	{ {0,0,0,0} ,RGB16V,8,2,4 }, 
	{ {0,1,1,1} ,RGB16H,8,2,4 },
	{ {0,0,0,0} ,RGB16V,8,2,2 },
	{ {0,1,1,1} ,RGB16H,8,2,2 },

	{ {0,0,0,0} ,     0,8,4,4 }, /*C decompression*/
	{ {0,0,1,1} ,RGB24H,8,4,4 },
	{ {0,0,0,0} ,     0,8,4,2 }, /*C decompression*/
	{ {0,0,1,1} ,RGB24H,8,4,2 },
	{ {0,0,0,0} ,     0,8,2,4 }, 
	{ {0,0,1,1} ,RGB24H,8,2,4 },
	{ {0,0,0,0} ,     0,8,2,2 },
	{ {0,0,1,1} ,RGB24H,8,2,2 }
};
#define VECLEN          15

typedef uchar (*tbltype)[VECLEN+1];

extern U8 pc_tbl2[];

extern U8 pc_tbl3[];

#ifdef NEW24
	extern U8 pc_tbl4[];
#endif

#ifdef NEW24
U8 *tables[] = {NULL,pc_tbl2,pc_tbl3,pc_tbl4};
#else
U8 *tables[] = {NULL,pc_tbl2,pc_tbl3};
#endif

void maketbl (signed short *dts,signed short *cdts, unsigned char *v);

void maketbl24_2 (signed short *dts,signed short *cdts,
	signed short *fdts,signed short *fcdts,
	unsigned char *v);

void setup_dxdts2(I16 *dd, I16 *cd,I16 *fd,I16 *fcd);
int setup_dxdts(I16 *dd, I16 *cd,I16 *fd,I16 *fcd);

static U8 lastdtSet = 0xFF, lastTable = 0xFF;
static I16 lastdraw = -1;

void resetHdr()
{
	lastdtSet = 0xFF;
	lastTable = 0xFF;
	lastdraw = -1;
}
int decodeHeader(void *data,register dxInfoStruct *dxInfo)
{
  	FRAMEHEADER far *nfrmh;
  	int i;
	extern int is565;

	dxInfo->drawing = is565;

#if 0
	dxInfo->bitcnt = 16;
	switch(dxInfo->fmt) {
		case 15:	dxInfo->fmt=0; break;
		case 16:	dxInfo->fmt=1; break;
		case 24:	dxInfo->fmt=0; dxInfo->bitcnt=24; break;
		case 8:		return -2;
	}
#endif

	/* getting information from the fameheader */
	nfrmh = (FRAMEHEADER far *)data;

	if (nfrmh->hdrSize < 0x10){
		return DXL_INVALID_DATA;
	} else {
		U8 far *hdata;
      	char *buffer = (char *)&(dxInfo->f);
		
		hdata = (U8 far *)nfrmh;
		
		/* decode the size of the header */
		dxInfo->hdrSize = (short)(((nfrmh->hdrSize >> 5) | (nfrmh->hdrSize << 3)) & 0x7F);
        
		/*decode the rest of the header */

		for (i = 1; i < sizeof(FRAMEHEADER); i++)
	        buffer[i] = hdata[i] ^ hdata[i+1];

        if (dxInfo->f.Type == COMP_TYPES && dxInfo->f.Table == 5)
			return DXL_INVALID_DATA;

		dxInfo->f.CheckSum = invert2(dxInfo->f.CheckSum);

#if defined(DX_TIGB)
#if DX_TIGB
		/*
		GCRTMRT Cludge -- this is real bad because
		 this should really be different algorithm, not different Type
        
		 dbm -- you think that's bad?  I just made it worse with TIGB
		*/
        if (dxInfo->f.Type == COMP_TYPES) {
			dxInfo->hinterp = 0;
			dxInfo->interframe = 0;
			dxInfo->sprite = 0;
			dxInfo->iskeyframe = 1;
	   		dxInfo->imwidth = invert2(dxInfo->f.Xsize);
			dxInfo->imheight = invert2(dxInfo->f.Ysize);
			dxInfo->f.xoff = 0;
			dxInfo->f.yoff = 0;
			dxInfo->blockpower = 0;  /* V 2X2*/
			dxInfo->lpbmione = 0;
			dxInfo->block2x = 0;	/* H 2X2*/
            if(dxInfo->f.Type == COMP_TYPES) {
                dxinit(is565,dxInfo->f.metaType);
                                        /* TIGB uses metatype for internals*/
            }
            return dxInfo->hdrSize;     /* Claim success*/
		}
#endif
#endif

		if(dxInfo->hdrSize > 10 && dxInfo->f.CVersion >= 2) {
			if(dxInfo->f.metaType > 3) {
				return DXL_VERSION_CONFLICT;
			} else if(dxInfo->f.metaType == 2 || dxInfo->f.metaType == 3) {
				dxInfo->hinterp = (short)((dxInfo->f.Frameinfo&IS_INTERPOLATED)>>2);
				dxInfo->interframe = (short)(dxInfo->f.Frameinfo&IS_INTERFRAME);
				if(dxInfo->interframe) 
					dxInfo->iskeyframe = (short) (dxInfo->f.Frameinfo&IS_KEYFRAME);
				else
					dxInfo->iskeyframe = 1;
				/*
				dxInfo->iskeyframe = (dxInfo->interframe) ? dxInfo->f.Frameinfo&IS_KEYFRAME : 1;
				*/
				dxInfo->sprite = (short) (dxInfo->f.Frameinfo&IS_SPRITE);
			} else {
				dxInfo->hinterp = 0;
				dxInfo->interframe = 0;
				dxInfo->sprite = 0;
				dxInfo->iskeyframe = 1;
			}
		} else {		/* really old file */
			dxInfo->f.CVersion = PUBLIC_VERSION;
			dxInfo->f.metaType = 0;
			dxInfo->hinterp = 0;
			dxInfo->interframe = 0;
			dxInfo->sprite = 0;
			dxInfo->iskeyframe = 1;
		}
		if(dxInfo->sprite) {
	   		dxInfo->imwidth = invert2(dxInfo->f.width);
			dxInfo->imheight = invert2(dxInfo->f.height);
			dxInfo->f.xoff = invert2(dxInfo->f.xoff);
			dxInfo->f.yoff = invert2(dxInfo->f.yoff);
		} else {
	   		dxInfo->imwidth=invert2(dxInfo->f.Xsize);
			dxInfo->imheight=invert2(dxInfo->f.Ysize);
			if (dxInfo->f.metaType < 2 )
				if ((dxInfo->imwidth < 213) && (dxInfo->imwidth >= 176)) 
					dxInfo->hinterp = 2;
		}                                      
		dxInfo->f.Xsize = invert2(dxInfo->f.Xsize);
		dxInfo->f.Ysize = invert2(dxInfo->f.Ysize);

#if RESTRICT_VERSION && 0
		{
			extern DUCKINI far *dini;
	
			if ((dini->CVersion != PUBLIC_VERSION) && 
				(dxInfo->f.CVersion != PUBLIC_VERSION) && 
				(dxInfo->f.CVersion != dini->CVersion)){
	
				return DXL_VERSION_CONFLICT;
			}
		}
#endif
		
		if (!dxInfo->f.Type) return DXL_OK;

		if ((dxInfo->f.Type >= COMP_TYPES) || !compTypes[dxInfo->f.Type].DXEnabled[dxInfo->f.metaType])	
			return DXL_INVALID_DATA;

		dxInfo->algorithm = compTypes[dxInfo->f.Type].Algorithm;
        
		if (dxInfo->f.DeltaSet != lastdtSet || dxInfo->f.Table != lastTable || dxInfo->drawing != lastdraw) {
			setup_dxdts2(pdxdts[dxInfo->f.DeltaSet],
				pdxCdts[dxInfo->f.DeltaSet],
				pdxfdts[dxInfo->f.DeltaSet],
				pdxfCdts[dxInfo->f.DeltaSet]);
			    
			/* making the tables */                                                    
			if((dxInfo->f.Type&1) && dxInfo->f.metaType) dxInfo->vectbl = pc_tbl2;
			else {
				if(dxInfo->f.Table < TBL_MAX)
					dxInfo->vectbl = tables[dxInfo->f.Table];
				else return DXL_INVALID_DATA;
			}

			if (compTypes[dxInfo->f.Type].Algorithm == RGB24H)
				maketbl24_2(dt,cdt,fdt,fcdt,(unsigned char *)(dxInfo->vectbl));
			else
				maketbl(dt,cdt,(unsigned char *) (dxInfo->vectbl));

#if 0
			if(dxInfo->interframe || dxInfo->sprite || (dxInfo->f.Type&1)) {
				if(dxInfo->f.DeltaSet != lastdtSet)
					init_dxI(dxInfo->f.DeltaSet,dxInfo->fmt);
			}
#endif
			/* in case tables must be rebuilt next time */
			lastdtSet = dxInfo->f.DeltaSet;
			lastTable = dxInfo->f.Table;
			lastdraw = dxInfo->drawing;
		}
        /* to tell asm code about block size */
		dxInfo->blockpower = blockpower_array[dxInfo->f.Type];
		dxInfo->lpbmione=(1<<dxInfo->blockpower)-1;
		dxInfo->block2x = block2x_array[dxInfo->f.Type];
	}	
	return dxInfo->hdrSize;    
}
