/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/**

    spr_clip.C

**/

#include <stdlib.h>

#include "dkpltfrm.h"
#include "duktypes.h"
#include "cduck.h"
#include "dxparams.h"
#include "dxl_16.h"

#define OLDCODE 0
#define BLOCK2X 0
#define HSTRETCH 0
#define COLOR_256 0
#define BUILDMAC 0

#define IADD 0x0004
#define ISHIFT    4
#define IOFFSET 4096

#define tbl2 tbl+IOFFSET

#if defined(DEBUG)
#define DIAGNOSTIC(x) x
#else
#define DIAGNOSTIC(x)
#endif


/************************************** INTERFRAME STUFF/C DECOMPRESSION */

#define VOFF swidth

/* vars that need to be seen by asm code*/
extern dxVector8 vectbl[];

/*********** MACROS: */
#define WRITEDBLPIX                                      \
    *ldest++=*(last+VOFF)=(*last)+vp; \
    ++last;

#define WRITEDBLPIXNC                     \
    *(last+VOFF)=(*last)+vp; \
    ++last;

#define GVHVA                                  \
    index+=IADD;                                    \
    temp=*(long *)(tbl+index-IADD);        \
    vp+=(temp>>1);                                  \
     if(temp&1)                                     \
        if(!(index=(*vloc++)<<ISHIFT)){\
            index=(*vloc++)<<ISHIFT;   \
            temp=*(long *)(tbl+index);      \
            index+=IADD;                            \
         if(temp&1)                                       \
                index=(*vloc++)<<ISHIFT;   \
            vp +=((temp>>1)*5);                         \
        }

#define GETVECCNEW                                      \
    temp=*(long *)(tbl2+index);       \
     vp+=(temp>>1);                                             \
     index+=IADD;                                     \
     if(temp&1)                                            \
        if(!(index=(*vloc++)<<ISHIFT)) {\
            index=(*vloc++)<<ISHIFT;          \
            temp=*(long *)(tbl2+index);\
            index+=IADD;                                    \
            if(temp&1) index=(*vloc++)<<ISHIFT;          \
            vp +=((temp>>1)*5);                        \
        }                                                                               

#define GVHVNEW \
    GVHVA \
    WRITEDBLPIX \
    currentPixel += 2;


#define GVHVSPRITE \
    GVHVA \
    *ldest++= *last++ += vp;\
    currentPixel += 2;

/* get vectors, don't write */
#define GVNW                                  \
    GVHVA \
    ldest++;  \
    *last++ += vp;\


/* get vectors and check left skip pixel before writing */           
#define GVCHKL                                  \
    GVHVA \
    if(leftSkip>0 || (currentPixel >= rightSkip && rightSkip > 0)) { \
        last++; \
        ldest++;        \
    } else \
        *ldest++= *last++ += vp;\
    leftSkip-=2;\
    currentPixel += 2;

/* get vectors and check right skip pixel before writing */           
#define GVCHKR                                  \
    GVHVA \
    if(currentPixel < rightSkip) { \
        *ldest++= *last++ += vp; \
    }\
    currentPixel += 2;

#define DOALPHA \
    temp=*(long *)(tbl+index+(IOFFSET*2));        \
    index+=IADD;                                    \
     if(temp&1) index=(*vloc++)<<ISHIFT;        \
    (*last) += vp; \
    *ldest++ = antiAlias(temp>>1,*last++,*ldest); \
    currentPixel += 2;

#define DOALPHANW \
    temp=*(long *)(tbl+index+(IOFFSET*2));        \
    index+=IADD;                                    \
     if(temp&1) index=(*vloc++)<<ISHIFT;        \
    ldest++;  \
    *last++ += vp;\

/* do alpha and check left skip pixels */
#define DOALPHACHKL \
    temp=*(long *)(tbl+index+(IOFFSET*2));        \
    index+=IADD;                                    \
     if(temp&1) index=(*vloc++)<<ISHIFT;        \
    if(leftSkip>0 || (currentPixel >= rightSkip && rightSkip > 0)) { \
        last++; \
        ldest++; \
    } else { \
        (*last) += vp; \
        *ldest++ = antiAlias(temp>>1,*last++,*ldest); \
    }\
    leftSkip-=2;\
    currentPixel += 2;
    
/* do alpha and check right skip pixels */
#define DOALPHACHKR \
    temp=*(long *)(tbl+index+(IOFFSET*2));        \
    index+=IADD;                                    \
    if(temp&1) index=(*vloc++)<<ISHIFT;        \
    if(currentPixel < rightSkip) { \
        (*last) += vp; \
        *ldest++ = antiAlias(temp>>1,*last++,*ldest); \
    }\
    currentPixel += 2;

#define DOBG \
        vp = 0; \
        ldest += 2; \
        last += 2; \
        currentPixel += 4;
 
#define DOBGC \
        vp = 0; \
        *last++ = 0; \
        ldest += 2;  \
        *last++ = 0; \
        currentPixel += 4;
        
#define GVHVS   GVHVSPRITE
#define GVHV    GVHVNEW
#define GETVECC GETVECCNEW


#if 1
#ifdef __GNUC__
static inline unsigned long 
#else
static unsigned long 
#endif
antiAlias(unsigned int alpha,unsigned long fore, unsigned long back)
{                                     
    fore &= 0x7fff7fff;
    back &= 0x7fff7fff;
    
    if (alpha == 6) return fore;
    if (alpha == 0) return back;
    {
        unsigned long low=0,high=0;
        unsigned int alpha1 = (alpha%5); 

        alpha = (alpha/5);      
    
        back += 0x04210421; 
        fore += 0x04210421; 
        
        back &= 0xf39cf39c;
        fore &= 0xf39cf39c;

#ifdef SONY
#define AL1 alpha1
#define AL alpha
#else
#define AL1 alpha
#define AL alpha1
#endif
        
        if (AL1 == 1)
            high = fore;
        else if (AL1 == 0)
            high = back;
        else{
            AL1 -= 1;
            low = fore & 0xffff0000;
            high = back & 0xffff0000;
            high = ((low>>2)*AL1) + ((back>>2)*(4-AL1));
            /*high = low + ((back>>2)*(4-AL1));*/
        }
        
        if (AL == 1)
            low = fore;
        else if (AL == 0)
            low = back;
        else{
            AL -= 1;
            low = ((fore>>2)*AL) + ((back>>2)*(4-AL));
            /*low = fore + ((back>>2)*(4-AL));*/
        }
        return ((low & 0x00007fff) | (high & 0x7fff0000));
    }
}

void clp_dxSprite(DX_PARAMS_HANDLE params) {
    U8 *cbloc=(U8 *) params->dx_bloc;
    long xcnt = 0L;
    long temp;
    long vp=0;
    long *last=(long*) params->dxLast;
    long leftSkip = params->LeftSkipPixels;
    long rightSkip = params->RightSkipPixels;
	long currentPixel = 0;    
    long *ldest=(long*) params->vDest;
    dxVector32 index= params->dx_index;
    dxVector8 *vloc= params->dx_vloc;
    dxVector8 *tbl=&vectbl[TBLOFFSET];
    U32 lbctl=0;
    unsigned long width;
    int nearRightSkip=0;
    
    width = params->width;
    
    if(params->linedisplay) {
        if(leftSkip>0) {
            while(width){
                /* break on block boundary */
                if(leftSkip<0)
                    break;

                lbctl =(U32)*cbloc++;
                xcnt = (width > 16) ? 16 : width;

                width -= xcnt;      
        
                if (!lbctl){
                    vp = 0; 
                    leftSkip-=xcnt;
                    currentPixel+=xcnt;
                    ldest += xcnt>>1;
                    last += xcnt>>1;
                    continue;
                }      
                
                xcnt>>=2;  
                while(xcnt--){
                    if(lbctl&1) {    /* if TM*/
                        GVCHKL
                        GVCHKL
                    } else {         /* SP*/
                        if (lbctl&2){
                            GVHVA
                            DOALPHACHKL
                            GVHVA
                            DOALPHACHKL
                        }else{
                            DOBG
                            leftSkip-=4;
                        }
                    }
//                    leftSkip -=4;
                    lbctl>>=2;
                }
            }
        } /* if leftSkip > 0 */ 
        
            while(width){  
                lbctl =(U32)*cbloc++;
                xcnt = (width > 16) ? 16 : width;
                /* getting close to right clipped */   
                if(rightSkip) {
                    if((currentPixel+(xcnt))>=rightSkip) {
                        nearRightSkip=1;
                        break;                            
                    }          
                }
        
                width -= xcnt;      
                if (!lbctl){
                    vp = 0;
                    currentPixel+=xcnt;
                    ldest += xcnt>>1;
                    last += xcnt>>1;
                    continue;
                }   
                                    
                xcnt>>=2;
                while(xcnt--){
                    if(lbctl&1) {    /* if TM*/
                        GVHVS         /* hit me agin:*/
                        GVHVS
                    } else {         /* SP*/
                        if (lbctl&2){
                            GVHVA     /* hit me agin:*/
                            DOALPHA
                            GVHVA
                            DOALPHA
                        }else{
                            DOBG
                        }
                    }
                    lbctl>>=2;
                }  
            } /* while width */

       if(rightSkip>0) {    
            while(width){
                if(!nearRightSkip) {
                    lbctl =(U32)*cbloc++;
                    xcnt = (width > 16) ? 16 : width;
                } else 
                    nearRightSkip = 0;
    
                width -= xcnt;      
    #if 1
                if (!lbctl){
                    vp = 0;
                    currentPixel+=xcnt;
                    ldest += xcnt>>1;
                    last += xcnt>>1;
                    continue;
                }   
    #endif

                xcnt>>=2;
                while(xcnt--){
                    if(lbctl&1) {    
                        GVCHKR        
                        GVCHKR
                    } else {        
                        if (lbctl&2){
                            GVHVA    
                            DOALPHACHKR
                            GVHVA
                            DOALPHACHKR
                        }else{
                            DOBG
                        }
                    }
                    lbctl>>=2;
                }  
            } /* while width -- right clipped */
        }
    } /* if linedisplay */
    else {     
        /* decompress only loop */
        while(width){
            lbctl =(U32)*cbloc++;
            xcnt = (width > 16) ? 16 : width;
            
            width -= xcnt;      
            if (!lbctl){
                vp = 0;
                ldest += xcnt>>1;
                last += xcnt>>1;
                continue;
            }   
                                
            xcnt>>=2;
            while(xcnt--){
                if(lbctl&1) {    /* if TM*/
                    GVNW
                    GVNW
                } else {         /* SP*/
                    if (lbctl&2){
                        GVHVA     /* hit me agin:*/
                        DOALPHANW
                        GVHVA
                        DOALPHANW
                    }else{
                        DOBG
                    }
                }
                lbctl>>=2;
            }  
        } /* while width */
    }
    
    params->vDest += params->bPitch;
    params->dx_index=index;
    params->dx_vloc= vloc;
}

void clp_dxcSprite(DX_PARAMS_HANDLE params) {
    U8 *cbloc=(U8 *)params->dx_bloc;        /*/     ENDIAN issues -- get bytes*/
    long xcnt=0L;
    long temp;
    long vp=0;
    long *last=(long*)params->dxLast;
    long leftSkip = params->LeftSkipPixels;
    long rightSkip = params->RightSkipPixels;
long currentPixel=0;      
    long *ldest=(long*)params->vDest;
    dxVector32 index=params->dx_index;
    dxVector8 *vloc= params->dx_vloc;
    dxVector8 *tbl=&vectbl[TBLOFFSET];
    U32 lbctl=0;  
    unsigned long width;           
    int nearRightSkip=0;
    
    width = params->width;  
    
    if(params->linedisplay) {
        if(leftSkip>0) {        
            while(width){
                lbctl =(U32)*cbloc++;
                xcnt = (width > 16) ? 16 : width;

                width -= xcnt;
                xcnt>>=2;
                while((xcnt--)){
                    if(lbctl&1) {    /* if TM*/
                        GETVECC
                        GVCHKL
                        GVCHKL
                    } else {         /* SP*/
                        if (lbctl&2){
                            GETVECC
                            GVHVA
                            DOALPHACHKL
                            GVHVA
                            DOALPHACHKL
                        }else{
                            DOBGC
                            leftSkip-=4;
                      }
                    }
//                    leftSkip-=4;
                    lbctl>>=2;
                } 
                
                if(leftSkip<0)
                    break;
            }
        } 
        
            while(width){
                lbctl =(U32)*cbloc++;
                xcnt = (width > 16) ? 16 : width;
        
                /* getting close to right clipped */   
                if(rightSkip) {
                    if((currentPixel+(xcnt))>=rightSkip) {
                        nearRightSkip=1;
                        break;                            
                    } 
                }
        
                width -= xcnt;
                xcnt>>=2;     
                while(xcnt--){
                    if(lbctl&1) {    /* if TM*/
                        GETVECC
                        GVHVS         /* hit me agin:*/
                        GVHVS
                    } else {         /* SP*/
                        if (lbctl&2){
                            GETVECC
                            GVHVA     /* hit me agin:*/
                            DOALPHA
                            GVHVA
                            DOALPHA
                        }else{   
                            DOBGC
                        }
                    }
                    lbctl>>=2;
                } 
            }
            
        if(rightSkip>0) {    
            while(width){
                if(!nearRightSkip) {
                    lbctl =(U32)*cbloc++;
                    xcnt = (width > 16) ? 16 : width;
                } else 
                    nearRightSkip = 0;

                width -= xcnt;      
                xcnt>>=2;

                while(xcnt--){
                    if(lbctl&1) {    
                        GETVECC
                        GVCHKR        
                        GVCHKR
                    } else {        
                        if (lbctl&2){
                            GETVECC
                            GVHVA    
                            DOALPHACHKR
                            GVHVA
                            DOALPHACHKR
                        }else{
                            DOBGC
                        }
                    }
                    lbctl>>=2;
                }     
            } /* while width -- right clipped */
        }
    } /* if linedisplay */
    else {
        /* decompress only loop */
        while(width){
            lbctl =(U32)*cbloc++;
            xcnt = (width > 16) ? 16 : width;
            width -= xcnt;      
            xcnt>>=2;
            while(xcnt--){
                if(lbctl&1) { 
                    GETVECC
                    GVNW
                    GVNW
                } else {      
                    if (lbctl&2){
                        GETVECC
                        GVHVA 
                        DOALPHANW
                        GVHVA
                        DOALPHANW
                    }else{
                        DOBGC
                    }
                }
                lbctl>>=2;
            }  
        } /* while width */
    }
    
    params->vDest += params->bPitch;
    params->dx_index=index;
    params->dx_vloc=vloc;
}
#endif




