/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <stdlib.h>

#include "dxl_main.h"                                            
#include "proc.h"
#include "tm1blit.h"

static int TM1dummy(void);
static int TM1dummy(void){ return 0; }

enum PROCTYPE getCPUID(void);

void tm1SetBlit(void)
{
	DXL_BLIT_FORMAT temp;
    extern int foundMMX;

    foundMMX = getCPUID();

    if(foundMMX == PMMX || foundMMX == PII)
        foundMMX = 1;
    else
        foundMMX = 0;

    /* 16 bit 555 blitters */
    temp = DXL_OverrideBlitter(DXBLIT_SAME,DXRGB16_565);
        DXL_RegisterBlitter(temp, DXL_LINE16, DXL_bss00, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16i, DXL_bss01, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16hi, DXL_bss02, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, TM1_24, TM1dummy, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16spr, TM1dummy, TM1dummy, TM1dummy);

    temp = DXL_OverrideBlitter(DXBLIT_STRETCH,DXRGB16_565);
        DXL_RegisterBlitter(temp, DXL_LINE16, DXL_bss10, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16i, DXL_bss11, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16hi, DXL_bss12, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, TM1_24, TM1dummy, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16spr, TM1dummy, TM1dummy, TM1dummy);

    temp = DXL_OverrideBlitter(DXBLIT_STRETCH_BRIGHT,DXRGB16_565);
        DXL_RegisterBlitter(temp, DXL_LINE16, DXL_bss20, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16i, DXL_bss21, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16hi, DXL_bss22, ff_BrightSetup, TM1dummy); 
        DXL_RegisterBlitter(temp, TM1_24, TM1dummy, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16spr, TM1dummy, TM1dummy, TM1dummy);

    /* 16 bit 555 blitters */
    temp = DXL_OverrideBlitter(DXBLIT_SAME,DXRGB16);
        DXL_RegisterBlitter(temp, DXL_LINE16, DXL_bss00, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16i, DXL_bss01, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16hi, DXL_bss02, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, TM1_24, TM1dummy, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16spr, TM1dummy, TM1dummy, TM1dummy);

    temp = DXL_OverrideBlitter(DXBLIT_STRETCH,DXRGB16);
        DXL_RegisterBlitter(temp, DXL_LINE16, DXL_bss10, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16i, DXL_bss11, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16hi, DXL_bss12, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, TM1_24, TM1dummy, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16spr, TM1dummy, TM1dummy, TM1dummy);

    temp = DXL_OverrideBlitter(DXBLIT_STRETCH_BRIGHT,DXRGB16);
        DXL_RegisterBlitter(temp, DXL_LINE16, DXL_bss20, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16i, DXL_bss21, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16hi, DXL_bss22, ff_BrightSetup, TM1dummy); 
        DXL_RegisterBlitter(temp, TM1_24, TM1dummy, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16spr, TM1dummy, TM1dummy, TM1dummy);

    /* 8 bit blitters */
    temp = DXL_OverrideBlitter(DXBLIT_STRETCH_BRIGHT,DXRGB8);
        DXL_RegisterBlitter(temp, DXL_LINE16, DXL_bse20, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16i, DXL_bse21, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16hi, DXL_bse22, ff_BrightSetup, TM1dummy);

    temp = DXL_OverrideBlitter(DXBLIT_STRETCH,DXRGB8);
        DXL_RegisterBlitter(temp, DXL_LINE16, DXL_bse10, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16i, DXL_bse11, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16hi, DXL_bse12, TM1dummy, TM1dummy);

    temp = DXL_OverrideBlitter(DXBLIT_SAME,DXRGB8);
        DXL_RegisterBlitter(temp, DXL_LINE16, DXL_bse00, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16i, DXL_bse01, TM1dummy, TM1dummy);
        DXL_RegisterBlitter(temp, DXL_LINE16hi, DXL_bse02, TM1dummy, TM1dummy);

    /* blitters are hard coded in copy24c */
    temp = DXL_OverrideBlitter(DXBLIT_SAME,DXRGB24);
        DXL_RegisterBlitter(temp, TM1_24, TM1dummy, TM1dummy, TM1dummy);

    temp = DXL_OverrideBlitter(DXBLIT_STRETCH,DXRGB24);
        DXL_RegisterBlitter(temp, TM1_24, TM1dummy, TM1dummy, TM1dummy);

    temp = DXL_OverrideBlitter(DXBLIT_SAME,DXRGB32);
        DXL_RegisterBlitter(temp, TM1_24, TM1dummy, TM1dummy, TM1dummy);

    temp = DXL_OverrideBlitter(DXBLIT_STRETCH,DXRGB32);
        DXL_RegisterBlitter(temp, TM1_24, TM1dummy, TM1dummy, TM1dummy);
}
