/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <windows.h>
#include <stdio.h>
#include "duktypes.h"
#include "deltas.h"

//#ifdef TMRT32
#define _clear_linebuf	clear_linebuf_
#define	_dxy			dxy_
#define	_dxu			dxu_
#define	_dxv			dxv_
#define	_dxy2x2			dxy2x2_
//#endif

#define WIDTH		320
#define	HEIGHT		270
#define MAXWIDTH	1920	//640 (to handle expanded RGB input: DSS
#define	BUF_LEN		(WIDTH*HEIGHT+64)
#define	VUBYTES		(80*60*2)

#ifdef __cplusplus  
 extern "C" {               
#endif   //__cplusplus__  

U8	vubuf[VUBYTES];
I32 deltas[NUMDELTAS]=DELTAS_4BIT
U16	linebuf[MAXWIDTH];
//U32	xxtbl[1024];
U32	dxtbl[16];
U16	yvuclut[0x40000];

//external asm routines from dx.asm
extern void _dxy(U8 *dst_addr, U8 *compbuf, U32 wh);
extern void _dxy2x2(U8 *dst_addr, U8 * compbuf, U32 wh);
extern void _dxu(U8 *dst_addr, U8 * compbuf, U32 wh);
extern void _dxv(U8 *dst_addr, U8 * compbuf, U32 wh);
extern void _clear_linebuf(I32 width, I32 setval);
extern long pitch;

//extern void dx( U8 far *dst_addr, U32 fullscreen, U8 far *compbuf, U32 wh, U32 dstpitch, U32 metaType);
extern U32 vesapage;
extern void _clear_linebuf(I32 width, I32 setval);
//extern
unsigned char tempbuffer[(WIDTH*HEIGHT*9)/16+16];   /// 4-bit buffer for compress

#ifdef __cplusplus  
 }               
#endif   //__cplusplus__  


//beware of operator precedence!

/// v and u seem to be switched~!

/// see notes in xxinit about gamma - dbm

#define GAMMA_UNFIX(x) x=(((x-32)*4)/3)
//#define GAMMA_UNFIX(x) x=(((x-42)*3)/2)
///#define GAMMA_UNFIX(x) { }


#ifdef DEBUG
void dbgout(char *str)
{
	FILE *fh;

    fh = fopen("C:\\TIGB.OUT","a+");
	if(fh != NULL) {
		fputs(str,fh);
		fclose(fh);
    } /// else while(1);
}

void cdecl dprintf(LPSTR szFormat, ...)
{
    char ach[256];

//   static BOOL fDebug = -1;

//    if (fDebug == -1)
//        fDebug = GetProfileInt("Debug", MODNAME, FALSE);

//    if (!fDebug)
//        return;

//    lstrcpy(ach, MODNAME ": ");
    wvsprintf(ach,szFormat,(LPSTR)(&szFormat+1));
    lstrcat(ach, "\r\n");

    dbgout(ach);
}
# define DPF                 dprintf
#else
# define DPF                 / ## /
#endif


static int yvu_to_r(int y,int v,int u)
{
	int r;

/// inverse scaling (later make it gamma):
    GAMMA_UNFIX(y);

    r = (int)((float)y + 1.370705 * (float)v - 191.45029);
/// r=((y-25)*4)/3 - ((u-128)*2);         /// bullshit placeholder function
 
	if(r < 0) return(0);
	else if(r > 255) return(255);
	else return(r);
}

static int yvu_to_g(int y,int v,int u)
{
	int r;
/// inverse scaling (later make it gamma):
    GAMMA_UNFIX(y);
    r = (int)((float)y - 0.698001 * (float)v - 0.337633 * (float)u + 116.56116);
/// r=((y-25)*4)/3;

	if(r < 0) return(0);
	else if(r > 255) return(255);
	else return(r);
}

static int yvu_to_b(int y,int v,int u)
{
	int r;
/// inverse scaling (later make it gamma):
    GAMMA_UNFIX(y);
    r = (int)((float)y + 1.732446 * (float)u - 237.7534);
/// r=((y-25)*4)/3 - ((v-128)*2);
	if(r < 0) return(0);
	else if(r > 255) return(255);
	else return(r);
}

static void build_yvuclut(int mode565) {
	I32	y,v,u,r,g,b,rgb,i;

	for(y=0;y<64;y++) {
		for(v=0;v<64;v++) {
			for(u=0;u<64;u++) {
				i=y+(v<<12)+(u<<6);
					r=yvu_to_r(y<<2,v<<2,u<<2);
					g=yvu_to_g(y<<2,v<<2,u<<2);
					b=yvu_to_b(y<<2,v<<2,u<<2);
					if(mode565) {
						r=(r+0)>>3;
						b=(b+0)>>3;
						g=(g+0)>>2;
						rgb=(r<<11) + (g<<5) + b;
					} else {
						r>>=3; g>>=3; b>>=3;
						rgb=(r<<10) + (g<<5) + b;
					}
					yvuclut[i]=(U16)rgb;
				}
		}
	}
}

void setline(I32 width, I32 setval) {
	_clear_linebuf(width,setval);
}

void dxinit(int mode565,int metaType) {
	I32 s,dvq;
	static int savemode = -1;

    if(metaType == 4) {
        INIT_DELTAS_4BIT
    } else if(metaType == 2) {
        INIT_DELTAS_2BIT
    } else if(metaType == 3) {
        INIT_DELTAS_3BIT
    }

	for(s=0;s<16;s++) {
		dvq=deltas[s];
		dxtbl[s]=dvq;
	}

 DPF("  dxinit: metaType = %d\n",metaType);

	if(mode565 == savemode) return;
    build_yvuclut(mode565);
	savemode = mode565;
}

/*
    dbm 10/96 -- pack-un your troubles (2bit, 3bit, 4bit?) and return
    size of unpack'd
*/


long dx_unpack(unsigned char* src, unsigned char* dest, long size, int format) {
    int i,t1;
    long insize,t2;
    unsigned char* tsrc;

    insize = *(long *)src;

 DPF("dx_unpack insize: %d size: %d src: %x dest: %x\n",insize,size,src,dest);

    if(format == 4) {
        for(i=0;i<size;i++) {
            dest[i]=src[i+4];   // ignore size now
        }
    } else if (format ==2) {
        tsrc = src+4;

        for(i=0;i<insize;i++) {
            t1=*tsrc++;
            dest[i*2]   = (t1 & 0x03) + ((t1 &0x0c) << 2);
            dest[i*2+1] = ((t1 & 0x30) >> 4) + ((t1 &0xc0) >> 2);
        }

    } else if (format ==3) {
        tsrc = src+4;

        for(i=0;i<insize/3;i++) {
            t2=*(long *)tsrc;
            tsrc+=3;

#define PULLOUT1(x) ( (t2 & (7 << (x*3)) ) >> (x*3) )
#define PULLOUT2(x) ( (t2 & (7 << (x*3)) ) >> (x*3-4) )

            dest[i*4]     = PULLOUT1(0) | (PULLOUT1(1) << 4);
            dest[i*4+1]   = PULLOUT1(2) | PULLOUT2(3);
            dest[i*4+2]   = PULLOUT1(4) | PULLOUT2(5);
            dest[i*4+3]   = PULLOUT1(6) | PULLOUT2(7);
        }

    } else {
        DPF("dx_unpack unsupportable format\n");
    }
DPF("dx_unpack returning %d\n",size);

    return(size);
}



void dx(U8 far *dst_addr, U32 nada, U8 far *compbuf, U32 wh, U32 dstpitch, U32 metaType) {
	U32 width=wh & 0xffff;
	U32 height=wh>>16,voff,uoff;

	pitch = dstpitch;
//	voff=(height*width*16)/18;
//	uoff=(height*width*17)/18;
	voff = (height*width)>>1;
	uoff = voff + (((height>>2) * (width>>2)) >>1);
//	height=(height*16)/18;

//  Give me the bloody unpack, you spanky monkey! (unpack into tempbuffer)

 DPF("  metatype = %d\n",metaType);
    dx_unpack(compbuf,tempbuffer,voff+ ((height>>2) * (width>>2)), metaType);

// V & U planes:

DPF("   V & U planes\n");
	wh=((height>>2)<<16)+(width>>2);
	setline(width,128);
    _dxv(vubuf, tempbuffer+voff, wh);
	setline(width,128);
    _dxu(vubuf+1, tempbuffer+uoff, wh);

// Y plane:

DPF("   Y plane\n");
	setline(width,0);
	wh=(height<<16)+width;
	vesapage=0;
//	if(nada!=oldnada) {
//		_clear_vesa_screen();
//		oldnada=nada;
//	}
//KLUDGE ALERT, THIS CODE CRASHES PREMIERE UNLESS WE ALTER THE DIMENSIONS
//wh=((height)<<16)+(width-16);
	if(nada) {
DPF("WOULD CALL DXY2X2 %x %x %x\n",dst_addr,tempbuffer,wh);
        _dxy2x2(dst_addr, tempbuffer, wh);
	} else {
DPF("WOULD CALL DXY %x %x %x\n",dst_addr,tempbuffer,wh);
        _dxy(dst_addr, tempbuffer, wh);
	}
DPF("dx DONE\n");
}
