# Microsoft (n)makefile for Win95 DXV.DLL . Eric Ameres 10/9/96
# Uses Microsoft visual c++ compiler, borland tasm assembler.

THISFILE = makefile

!if "$(OBJDIR)"=="$(DEBDIR)"

DXVNAME = tm1g
#DXVNAME = tm1
!else
DXVNAME = tm1
!endif

DXV = $(DXVNAME).dll
DXVLNK = $(OBJDIR)$(DXVNAME).lnk
SDXVLIB = $(OBJDIR)s_$(DXVNAME).lib
DXV_FILE = $(SRCDIR)\DXV.DEF

all: tm1.rel tm1.deb

$(OBJDIR:\= ) :
    mkdir $(OBJDIR:\= )

$(LIBDIR):
    mkdir $(LIBDIR)

tm1.rel:
    set CL=-nologo -Ob2 -Ot -MD -W3 -DWIN32 -D_MBCS -D_AFXDLL -DNDEBUG \
-D_WINDOWS -DHIRES
    set LINK=-INCREMENTAL:no
    nmake /NOLOGO -f $(THISFILE) $(RELDIR)s_tm1.lib OBJDIR=$(RELDIR)

tm1.deb:
    set CL=-nologo -MD -W3 -GX -Od -Z7 -DWIN32 -D_MBCS -D_AFXDLL -D_DEBUG \
-D_WINDOWS -DHIRES
    set LINK=-INCREMENTAL:no -DEBUG -DEBUGTYPE:BOTH
    nmake /NOLOGO -f $(THISFILE) $(DEBDIR)s_tm1g.lib OBJDIR=$(DEBDIR)

CC = cl

cppflags = $(cppflags) /DDXASMX86

OBJS = $(OBJS) \
    $(OBJDIR)dxi16a.obj $(OBJDIR)dxic16a.obj $(OBJDIR)dxic162a.obj \
    $(OBJDIR)dxi16e.obj $(OBJDIR)dxic16e.obj $(OBJDIR)dxic162e.obj \
	$(OBJDIR)dxblit.$(OBJ) \
	$(OBJDIR)dxl_w95.$(OBJ) \
	$(OBJDIR)tigb.$(OBJ) \
	$(OBJDIR)tigbdx.$(OBJ) \
#
	$(OBJDIR)bfs00lx.$(OBJ) \
	$(OBJDIR)bfs00hx.$(OBJ) \
	$(OBJDIR)bff00lx.$(OBJ) \
	$(OBJDIR)bff00hx.$(OBJ) \
#	$(OBJDIR)bft00lx.$(OBJ) \
#	$(OBJDIR)bft00hx.$(OBJ) \
#	$(OBJDIR)bft10hx.$(OBJ) \
#	$(OBJDIR)bft10lx.$(OBJ) \
#
	$(OBJDIR)bse00.$(OBJ) \
	$(OBJDIR)bse01.$(OBJ) \
	$(OBJDIR)bse10.$(OBJ) \
	$(OBJDIR)bse11.$(OBJ) \
    $(OBJDIR)bse02.$(OBJ) \
	$(OBJDIR)bse12.$(OBJ) \
	$(OBJDIR)bse20.$(OBJ) \
	$(OBJDIR)bse21.$(OBJ) \
	$(OBJDIR)bse22.$(OBJ)

ASMDIR = ..\X86\ 
MMXDIR = ..\mmx\ 

ASM = tasm /ml /m8 /dWINP /zd /d_MSC_VER /I$(ASMDIR) /dWIN95

{..\X86}.asm{$(OBJDIR)}.obj:
    $(ASM) $< $@ 

WASMDIR = ..\wX86\ 
WASM = wasm /dWINP /dWIN95 /I=$(ASMDIR) /I=$(MMXDIR)  

{..\wx86}.asm{$(OBJDIR)}.obj:
    $(WASM) $< -fo=$@ 
    editbin /NOLOGO /RELEASE $@

{..\X86}.asm{$(OBJDIR)}.obj:
    $(ASM) $< $@ 
    editbin /NOLOGO /RELEASE $@

{src}.asm{$(OBJDIR)}.obj:
    $(ASM) $< $@ 
    editbin /NOLOGO /RELEASE $@
    
$(OBJDIR)dxic162.obj : $(ASMDIR)dxi16.asm 
    $(ASM) /dCHROMALINE /dBLOCK_2X $(ASMDIR)dxi16.asm $@ /dmname=$(@B)
    editbin /NOLOGO /RELEASE $@

$(OBJDIR)dxic16.obj : $(ASMDIR)dxi16.asm 
    $(ASM) /dCHROMALINE $(ASMDIR)dxi16.asm $@ /dmname=$(@B)
    editbin /NOLOGO /RELEASE $@

$(OBJDIR)dxi16.obj : $(ASMDIR)dxi16.asm
    $(ASM) $(ASMDIR)dxi16.asm $@ /dmname=$(@B)
    editbin /NOLOGO /RELEASE $@

$(OBJDIR)dxspr.obj : $(ASMDIR)dxSprite.asm
   $(ASM) $(ASMDIR)dxSprite.asm $@ /dmname=$(@B)
    editbin /NOLOGO /RELEASE $@

$(OBJDIR)dxcspr.obj : $(ASMDIR)dxSprite.asm
   $(ASM) /dCOLOR $(ASMDIR)dxSprite.asm $@ /dmname=$(@B)
    editbin /NOLOGO /RELEASE $@

$(OBJDIR)dxic162e.obj : $(MMXDIR)dxi16e.asm
    $(WASM) /dCHROMALINE /dBLOCK_2X $(MMXDIR)dxi16e.asm -fo=$@ /nm=$(@B)
    editbin /NOLOGO /RELEASE $@

$(OBJDIR)dxic16e.obj : $(MMXDIR)dxi16e.asm 
    $(WASM) /dCHROMALINE $(MMXDIR)dxi16e.asm -fo=$@ /nm=$(@B)
    editbin /NOLOGO /RELEASE $@

$(OBJDIR)dxi16e.obj : $(MMXDIR)dxi16e.asm
    $(WASM) $(MMXDIR)dxi16e.asm -fo=$@ /nm=$(@B)
    editbin /NOLOGO /RELEASE $@

$(OBJDIR)dxic162a.obj : $(MMXDIR)dxi16a.asm 
    $(WASM) /dCHROMALINE /dBLOCK_2X $(MMXDIR)dxi16a.asm -fo=$@ /nm=$(@B)
    editbin /NOLOGO /RELEASE $@

$(OBJDIR)dxic16a.obj : $(MMXDIR)dxi16a.asm 
    $(WASM) /dCHROMALINE $(MMXDIR)dxi16a.asm -fo=$@ /nm=$(@B)
    editbin /NOLOGO /RELEASE $@

$(OBJDIR)dxi16a.obj : $(MMXDIR)dxi16a.asm
    $(WASM) $(MMXDIR)dxi16a.asm -fo=$@ /nm=$(@B)
    editbin /NOLOGO /RELEASE $@

$(SDXVLIB): $(LIBDIR) $(OBJDIR:\= ) $(OBJS) $(ROOT)tmrt\win95\lib\s_tmrtg.lib
    LIB $(OBJS) /OUT:$(SDXVLIB)
    copy $(OBJDIR)*.dll $(LIBDIR)
    copy $(OBJDIR)*.lib $(LIBDIR)

clean:
    deltree /Y obj.rel
    deltree /Y obj.deb
    deltree /Y obj
