;   Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.
;
;   This file is part of VpVision.
;
;   VpVision is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License ver. 2,
;   as published by the Free Software Foundation (www.fsf.org).
;
;   Foobar is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with VpVision; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;/***********************************************\
;??? bff00lx.asm   
; 24 to 24 same loX
;\***********************************************/ 
        .486
        .MODEL  flat, SYSCALL, os_dos
        .CODE

NAME bff00lx

PUBLIC bff00_loX_   
PUBLIC _bff00_loX

INCLUDE bff.ash
  
EXTRN _work1K:DWORD

;------------------------------------------------
BLIT_LINE MACRO 
LOCAL blitFourMore
blitFourMore:
    mov     dl,BYTE PTR[ebp+0]          ;get g0
    mov     eax,[esi]                   ;get chrome

    mov     ebx,_work1K[edx*4]
    add     esi,4

    mov     dl,BYTE PTR[ebp+1]          ;get g1
    add     ebx,eax                     ;pixel 1

    mov     ecx,_work1K[edx*4]
    mov     one[esp],ebx                ;need again later

    mov     dl,BYTE PTR[ebp+3]          ;get g3
    add     ecx,eax                     ;pixel 0
    
    shl     ebx,24
    and     ecx,00ffffffh               ;make sure upper byte is zero

    or      ecx,ebx
    mov     ebx,_work1K[edx*4]

    mov     [edi+(0*4)],ecx             ;write first packed dword
    add     ebx,eax                     ;pixel 2

    mov     dl,BYTE PTR[ebp+2]          ;get g2
    mov     two[esp],ebx                ;need again later

    shl     ebx,16
    mov     ecx,one[esp]
    
    shr     ecx,8   
nop
    
    or      ecx,ebx
    mov     ebx,_work1K[edx*4]

    add     ebx,eax                     ;pixel 3
    mov     [edi+(1*4)],ecx             ;write second packed dword

    shl     ebx,8
    mov     ecx,two[esp]

    shr     ecx,16
    add     ebp,4

    or      ecx,ebx
    mov     eax,i[esp]

    mov     [edi+(2*4)],ecx             ;write third packed dword
nop    

    add     edi,12
    dec     eax

    mov     i[esp],eax
    jnz     blitFourMore
ENDM

;------------------------------------------------
BLIT_LINE2 MACRO 
LOCAL blitFourMore
blitFourMore:
    mov     dl,BYTE PTR[ebp+0]          ;get g0
    mov     eax,[esi]                   ;get chrome

    mov     ebx,_work1K[edx*4]
    add     esi,4

    mov     dl,BYTE PTR[ebp+1]          ;get g1
    add     ebx,eax                     ;pixel 1

    mov     ecx,_work1K[edx*4]
    mov     one[esp],ebx                ;need again later

    mov     dl,BYTE PTR[ebp+3]          ;get g3
    add     ecx,eax                     ;pixel 0
    
    shl     ebx,24
    and     ecx,00ffffffh               ;make sure upper byte is zero

    or      ecx,ebx
    mov     ebx,_work1K[edx*4]

    add     ebx,eax                     ;pixel 2
    mov     [edi+(0*4)],ecx             ;write first packed dword

    mov     dl,BYTE PTR[ebp+2]          ;get g2
    mov     two[esp],ebx                ;need again later

    shl     ebx,16
    mov     ecx,one[esp]
    
    shr     ecx,8   
nop
    
    or      ecx,ebx
    mov     ebx,_work1K[edx*4]

    mov     [edi+(1*4)],ecx             ;write second packed dword
    add     ebx,eax                     ;pixel 3

    shl     ebx,8
    mov     ecx,two[esp]

    shr     ecx,16
    add     ebp,4

    or      ecx,ebx
    mov     eax,i[esp]

nop    
    mov     [edi+(2*4)],ecx             ;write third packed dword

    add     edi,12
    dec     eax

    mov     i[esp],eax
    jnz     blitFourMore
ENDM
;------------------------------------------------
; local vars

k           EQU     0
blkWidth    EQU     k+4
dstWidth    EQU     blkWidth+4
chromaPtr   EQU     dstWidth+4
lchroma     EQU     chromaPtr+4
lvres       EQU     lchroma+4
i           EQU     lvres+4
daddr2		EQU		i+4

one         EQU     daddr2+4
two         EQU     one+4
L_stack     EQU     two+4

Vars        EQU     (L_stack+4+31) AND 0ffffffe0h
;------------------------------------------------

bff00_loX_:
_bff00_loX:
    BFF_INIT
         
blkLoop:
    BLIT_LINE

    mov     esi,chromaPtr[esp]
    mov     ebx,blkWidth[esp]

    mov     eax,dstWidth[esp]
    mov     edi,daddr2[esp]

    mov     i[esp],ebx
    add     edi,eax                     ;dst += dwidth

    BLIT_LINE2

    mov     eax,dstWidth[esp]
    mov     ebx,blkWidth[esp]

    mov     edi,daddr2[esp]
    mov     i[esp],ebx

    shl     ebx,2
    add     eax,eax

    add     edi,eax                     ;dst += dwidth
    mov     eax,k[esp]

	mov		daddr2[esp],edi				;save line start addr
    mov     esi,chromaPtr[esp]

    cmp     DWORD PTR lvres[esp],4
    jne     addWtoC

    test    eax,1
    jnz     addWtoC    

    dec     eax
nop

    mov     k[esp],eax
    jnz     blkLoop

    jmp     theExit

addWtoC:
    add     esi,ebx                     ;chroma += width*4
    dec     eax

    mov     chromaPtr[esp],esi
    mov     k[esp],eax

    jnz     blkLoop

theExit:
    add     esp,Vars
;    mov     esp,L_stack[esp]                   ;restore stack

    pop     edx
    pop     ecx
    pop     ebx
    pop     ebp
    pop     edi
    pop     esi
    ret

;************************************************
         END

