;   Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.
;
;   This file is part of VpVision.
;
;   VpVision is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License ver. 2,
;   as published by the Free Software Foundation (www.fsf.org).
;
;   Foobar is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with VpVision; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;/***********************************************\
;??? bfs00lx.asm   
; 24 to 16 same loX
;\***********************************************/ 
        .486
        .MODEL  flat, SYSCALL, os_dos
        .CODE

NAME bfs00lx

PUBLIC bfs00_loX_   
PUBLIC _bfs00_loX

PUBLIC bfs00_loX565_   
PUBLIC _bfs00_loX565

EXTRN _work1K:DWORD

INCLUDE bfs.ash

;------------------------------------------------
; local vars

k           EQU     0
blkWidth    EQU     k+4
dstWidth    EQU     blkWidth+4
chromaPtr   EQU     dstWidth+4
lchroma     EQU     chromaPtr+4
lvres       EQU     lchroma+4
i           EQU     lvres+4
daddr2		EQU		i+4
L_stack     EQU     daddr2+4

Vars        EQU     (L_stack+4+31) AND 0ffffffe0h
;------------------------------------------------
FRAME_BLIT MACRO SAR
LOCAL blkLoop, checkBD, bdOk, addWtoC, theExit
    BFS_INIT
    
blkLoop:
    mov     eax,[esi]                       ;get chrome
    add     esi,4

    movsx   ebx,ax                          ;get blue diff

    mov     lchroma[esp],esi
    sub     eax,ebx            

    jns     checkBD

    add     eax,00070000h

checkBD:
    test    ebx,ebx
    jge     bdOk

    add     ebx,7h

bdOk:
    sar     ebx,3
    and     eax,0fff80000h

    sar     eax,SAR
    xor     edx,edx

    mov     dl,BYTE PTR[ebp+ecx*4+0]      ;get second line g0
    add     eax,ebx

    mov     esi,dstWidth[esp]
    mov     ebx,eax

    shl     ebx,16
nop

    add     eax,ebx                     ;double chroma
    mov     ebx,_work1K[edx*4]

    mov     dl,BYTE PTR[ebp+ecx*4+1]      ;get second line g1
    add     ebx,eax

    shl     ebx,16
    mov     ecx,_work1K[edx*4]

    mov     dl,BYTE PTR[ebp+0]          ;get first line g0
    add     ecx,eax
    
    mov     bx,cx
nop

    mov     [edi+esi+(0*4)],ebx         ;write out second line pixel pair
    mov     ebx,_work1K[edx*4]

    mov     dl,BYTE PTR[ebp+1]          ;get g1
    add     ebx,eax

    shl     ebx,16
    mov     ecx,_work1K[edx*4]

    add     ecx,eax
nop

    mov     bx,cx
    mov     ecx,blkWidth[esp]

    mov     dl,BYTE PTR[ebp+ecx*4+2]      ;get second line g2
    mov     [edi+(0*4)],ebx             ;write out pixel pair
;>>>>>>>>>>>>>
    mov     ebx,_work1K[edx*4]
nop

    mov     dl,BYTE PTR[ebp+ecx*4+3]      ;get second line g3
    add     ebx,eax

    shl     ebx,16
    mov     ecx,_work1K[edx*4]

    mov     dl,BYTE PTR[ebp+2]          ;get first line g2
    add     ecx,eax
    
    mov     bx,cx
nop

    mov     [edi+esi+(1*4)],ebx         ;write out second line pixel pair
    mov     ebx,_work1K[edx*4]

    mov     dl,BYTE PTR[ebp+3]          ;get g3
    add     ebx,eax

    shl     ebx,16
    mov     ecx,_work1K[edx*4]

    add     ecx,eax
    mov     esi,lchroma[esp]

    mov     bx,cx
    mov     eax,i[esp]

    mov     [edi+(1*4)],ebx             ;write out pixel pair
    add     ebp,4

    add     edi,8
    dec     eax

    mov     ecx,blkWidth[esp]
nop

    mov     i[esp],eax
    jnz     blkLoop

    mov     eax,dstWidth[esp]
    mov     ebx,blkWidth[esp]

    add     eax,eax
nop

    mov     edi,daddr2[esp]
    mov     i[esp],ebx

    shl     ebx,2
    add     edi,eax                     ;dst += dwidth

    mov     eax,k[esp]
    add     ebp,ebx                     ;lluma += width*4

	mov		daddr2[esp],edi				;save line start addr
    mov     esi,chromaPtr[esp]

    cmp     DWORD PTR lvres[esp],4
    jne     addWtoC

    test    eax,1
    jnz     addWtoC    

    dec     eax
nop

    mov     k[esp],eax
    jnz     blkLoop

    jmp     theExit

addWtoC:
    add     esi,ebx                     ;chroma += width*4
    dec     eax

    mov     chromaPtr[esp],esi
    mov     k[esp],eax

    jnz     blkLoop

theExit:
    add     esp,Vars
;    mov     esp,L_stack[esp]                   ;restore stack

    pop     edx
    pop     ecx
    pop     ebx
    pop     ebp
    pop     edi
    pop     esi
    ret
ENDM


bfs00_loX_:
_bfs00_loX:
    FRAME_BLIT 09h

bfs00_loX565_:
_bfs00_loX565:
    FRAME_BLIT 08h
;************************************************
         END

