;   Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.
;
;   This file is part of VpVision.
;
;   VpVision is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License ver. 2,
;   as published by the Free Software Foundation (www.fsf.org).
;
;   Foobar is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with VpVision; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;/***********************************************\
;??? bfs10.asm   
; 24 to 16 stretched
;\***********************************************/ 
        .486
        .MODEL  flat, SYSCALL, os_dos
        .CODE

NAME bfs10

HIX     EQU     1

if HIX
PUBLIC bfs_hiX_   
PUBLIC _bfs_hiX

PUBLIC bfs_hiX565_   
PUBLIC _bfs_hiX565
endif

EXTRN _work1K:DWORD

INCLUDE bfs.ash

;------------------------------------------------
; local vars

k           EQU     0
blkWidth    EQU     k+4
dstWidth    EQU     blkWidth+4
chromaPtr   EQU     dstWidth+4
lchroma     EQU     chromaPtr+4
lvres       EQU     lchroma+4
i           EQU     lvres+4
daddr2		EQU		i+4

Vars        EQU     (daddr2+4+31) AND 0ffffffe0h
;------------------------------------------------
FRAME_BLIT MACRO SAR
LOCAL blkLoop, checkBD, bdOk, checkBD1, bdOk1, addWtoC, theExit
    BFS10_INIT

blkLoop:
    mov     eax,[esi]                       ;get chrome
    add     esi,4

    movsx   ebx,ax                          ;get blue diff

    mov     lchroma[esp],esi
    sub     eax,ebx            

    jns     checkBD

    add     eax,00070000h

checkBD:
    cmp     ebx,0
    jge     bdOk

    add     ebx,7h

bdOk:
    sar     ebx,3
    and     eax,0fff80000h

    sar     eax,SAR
    xor     edx,edx

    mov     dl,BYTE PTR[ebp+ecx+1]      ;get second line g1
    add     eax,ebx

    mov     esi,dstWidth[esp]
    mov     ebx,eax

    shl     ebx,16

    add     eax,ebx                     ;double chroma
    mov     ebx,_work1K[edx*4]

    mov     dl,BYTE PTR[ebp+ecx]        ;get second line g0
    add     ebx,eax

    mov     [edi+esi+(0*4)],ebx         ;write out second line stretched pixel
    mov     ebx,_work1K[edx*4]

    mov     dl,BYTE PTR[ebp+1]          ;get g1 or g3
    add     ebx,eax

    mov     [edi+esi+(1*4)],ebx         ;write out second line stretched pixel
    mov     esi,lchroma[esp]

    mov     ebx,_work1K[edx*4]
    mov     dl,BYTE PTR[ebp]            ;get g0 or g2

    add     ebx,eax
    mov     [edi+(0*4)],ebx             ;write out stretched pixel

    mov     ebx,_work1K[edx*4]
    add     esi,4

    add     ebx,eax
    mov     lchroma[esp],esi

    mov     [edi+(1*4)],ebx             ;write out stretched pixel
;>>>>>>>>>>>>>>>>>>>>>>
    mov     eax,-4[esi]                       ;get chrome

    movsx   ebx,ax                          ;get blue diff

    sub     eax,ebx            
    jns     checkBD1

    add     eax,00070000h

checkBD1:
    cmp     ebx,0
    jge     bdOk1

    add     ebx,7h

bdOk1:
    sar     ebx,3
    and     eax,0fff80000h

    sar     eax,SAR
    xor     edx,edx

    mov     dl,BYTE PTR[ebp+ecx+3]      ;get second line g1
    add     eax,ebx

    mov     esi,dstWidth[esp]
    mov     ebx,eax

    shl     ebx,16

    add     eax,ebx                     ;double chroma
    mov     ebx,_work1K[edx*4]

    mov     dl,BYTE PTR[ebp+ecx+2]      ;get second line g0
    add     ebx,eax

    mov     [edi+esi+(2*4)],ebx         ;write out second line stretched pixel
    mov     ebx,_work1K[edx*4]

    mov     dl,BYTE PTR[ebp+3]          ;get g1 or g3
    add     ebx,eax

    mov     [edi+esi+(3*4)],ebx         ;write out second line stretched pixel
    mov     esi,lchroma[esp]

    mov     ebx,_work1K[edx*4]
    mov     dl,BYTE PTR[ebp+2]          ;get g0 or g2

    add     ebx,eax
    mov     [edi+(2*4)],ebx             ;write out stretched pixel

    mov     ebx,_work1K[edx*4]

    add     ebx,eax
    add     ebp,4

    mov     eax,i[esp]
    mov     [edi+(3*4)],ebx             ;write out stretched pixel

    dec     eax
    lea     edi,[edi+16]

    mov     i[esp],eax
    jnz     blkLoop

    mov     eax,dstWidth[esp]
    mov     ebx,blkWidth[esp]
	add		eax,eax						;dstWidth*2
    mov     edi,daddr2[esp]
    mov     i[esp],ebx
    shl     ebx,2

    add     edi,eax                     ;dst += dwidth*2
    mov     eax,k[esp]
    add     ebp,ebx                     ;lluma += width*4
	mov		daddr2[esp],edi				;save line start addr
    add     ebx,ebx
    mov     esi,chromaPtr[esp]
    cmp     DWORD PTR lvres[esp],4
    jne     addWtoC

    test    eax,1
    jnz     addWtoC    

    dec     eax
    mov     chromaPtr[esp],esi
    mov     k[esp],eax 
    jnz     blkLoop
    jmp     theExit

addWtoC:
    add     esi,ebx                     ;chroma += width*2*4
    dec     eax
    mov     chromaPtr[esp],esi
    mov     k[esp],eax
    jnz     blkLoop

theExit:
    add     esp,Vars
;    mov     esp,[esp]                   ;restore stack

    pop     edx
    pop     ecx
    pop     ebx
    pop     ebp
    pop     edi
    pop     esi
    ret
ENDM

if HIX
bfs_hiX_:
_bfs_hiX:
    FRAME_BLIT 09h

bfs_hiX565_:
_bfs_hiX565:
    FRAME_BLIT 08h

endif

;************************************************
         END

