;   Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.
;
;   This file is part of VpVision.
;
;   VpVision is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License ver. 2,
;   as published by the Free Software Foundation (www.fsf.org).
;
;   Foobar is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with VpVision; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;/***********************************************\
;??? bft00.asm   
; 24 to 32 same loX/hiX
;\***********************************************/ 
        .486
        .MODEL  flat, SYSCALL, os_dos
        .CODE

NAME x86bft00

PUBLIC bft00_loX_   
PUBLIC _bft00_loX

PUBLIC bft00_hiX_   
PUBLIC _bft00_hiX

EXTRN _work1K:DWORD

;------------------------------------------------
BLIT_LINE_LOX MACRO 
LOCAL blitFourMore
blitFourMore:
    mov     dl,BYTE PTR[ebp+0]          ;get g0
    mov     eax,[esi]                   ;get chrome

    mov     ebx,_work1K[edx*4]
    add     esi,4

    mov     dl,BYTE PTR[ebp+1]          ;get g1
    add     ebx,eax                     ;pixel 1

    mov     ecx,_work1K[edx*4]
nop

    mov     dl,BYTE PTR[ebp+3]          ;get g3
    add     ecx,eax                     ;pixel 0
    
    and     ebx,00ffffffh               ;make sure upper byte is zero
    and     ecx,00ffffffh               ;make sure upper byte is zero

    mov     [edi+(0*4)],ecx             ;write first 0RGB pixel
    mov     [edi+(1*4)],ebx             ;write second 0RGB pixel

    mov     ebx,_work1K[edx*4]
nop

    mov     dl,BYTE PTR[ebp+2]          ;get g2
    add     ebx,eax                     ;pixel 2

    mov     ecx,_work1K[edx*4]
    add     ebp,4

    add     ecx,eax                     ;pixel 3
    mov     eax,i[esp]

    and     ebx,00ffffffh               ;make sure upper byte is zero
    and     ecx,00ffffffh               ;make sure upper byte is zero

    mov     [edi+(2*4)],ebx             ;write third 0RGB pixel
    mov     [edi+(3*4)],ecx             ;write fourth 0RGB pixel

    add     edi,16
    dec     eax

    mov     i[esp],eax
    jnz     blitFourMore
ENDM
;------------------------------------------------
BLIT_LINE_HIX MACRO 
LOCAL blitFourMore
blitFourMore:
    mov     dl,BYTE PTR[ebp+0]          ;get g0
    mov     eax,[esi]                   ;get chrome

    mov     ebx,_work1K[edx*4]
    add     esi,4

    mov     dl,BYTE PTR[ebp+1]          ;get g1
    add     ebx,eax                     ;pixel 1

    mov     ecx,_work1K[edx*4]

    mov     dl,BYTE PTR[ebp+3]          ;get g3
    add     ecx,eax                     ;pixel 0
    
    and     ebx,00ffffffh               ;make sure upper byte is zero
    and     ecx,00ffffffh               ;make sure upper byte is zero

    mov     eax,[esi]                   ;get chrome
    add     esi,4

    mov     [edi+(0*4)],ecx             ;write first 0RGB pixel
    mov     [edi+(1*4)],ebx             ;write second 0RGB pixel

    mov     ebx,_work1K[edx*4]
nop

    mov     dl,BYTE PTR[ebp+2]          ;get g2
    add     ebx,eax                     ;pixel 2

    mov     ecx,_work1K[edx*4]
    add     ebp,4

    add     ecx,eax                     ;pixel 3
    mov     eax,i[esp]

    and     ebx,00ffffffh               ;make sure upper byte is zero
    and     ecx,00ffffffh               ;make sure upper byte is zero

    mov     [edi+(2*4)],ebx             ;write third 0RGB pixel
    mov     [edi+(3*4)],ecx             ;write fourth 0RGB pixel

    add     edi,16
    dec     eax

    mov     i[esp],eax
    jnz     blitFourMore
ENDM
;------------------------------------------------
bft00Params    STRUC
                dd  6 dup (?)   ;6 pushed regs
                dd  ?           ;return address
    luma        dd  ?           ;pointer to luma
    chroma      dd  ?           ;pointer to chroma
    dst         dd  ?           ;pointer to dest 
    xwidth      dd  ?           ;ximage width
    dwidth      dd  ?           ;dest width
    height      dd  ?           ;image height
    vres        dd  ?           ;vertical color res
bft00Params    ENDS
;------------------------------------------------

;------------------------------------------------
; local vars

k           EQU     0
blkWidth    EQU     k+4
dstWidth    EQU     blkWidth+4
chromaPtr   EQU     dstWidth+4
lchroma     EQU     chromaPtr+4
lvres       EQU     lchroma+4
i           EQU     lvres+4
daddr2		EQU		i+4

L_stack     EQU     daddr2+4

Vars        EQU     (L_stack+4+31) AND 0ffffffe0h
;------------------------------------------------

bft00_loX_:
_bft00_loX:
    push    esi
    push    edi
    push    ebp
    push    ebx 
    push    ecx
    push    edx

    mov     eax,[esp].dwidth
    mov     ebp,[esp].luma

	shl		eax,1							;dwidth * 4 / 2
    mov     ecx,[esp].xwidth

    mov     esi,[esp].chroma
    mov     edi,[esp].dst

    mov     ebx,[esp].height
    mov     edx,[esp].vres

;    mov     ebp,esp                         ;save current stack ptr
;    and     esp,0ffffffe0h                  ;align

    shr     ebx,1                           ;height /= 2
    sub     esp,Vars                        ;make room for local var 32 byte block(s)

    shr     ecx,2
;    mov     L_stack[esp],ebp                ;save stack ptr

    mov     lvres[esp],edx
    mov     dstWidth[esp],eax

    mov     blkWidth[esp],ecx
    mov     i[esp],ecx

    mov     k[esp],ebx                      ;k = height
    mov     chromaPtr[esp],esi

	mov		daddr2[esp],edi					;save dst addr
    
blkLoop_loX:
    BLIT_LINE_LOX

    mov     esi,chromaPtr[esp]
    mov     ebx,blkWidth[esp]

    mov     eax,dstWidth[esp]
    mov     edi,daddr2[esp]

    mov     i[esp],ebx
    add     edi,eax                     ;dst += dwidth

    BLIT_LINE_LOX

    mov     eax,dstWidth[esp]
    mov     ebx,blkWidth[esp]

    mov     edi,daddr2[esp]
    mov     i[esp],ebx

    shl     ebx,2
    add     eax,eax

    add     edi,eax                     ;dst += dwidth
    mov     eax,k[esp]

	mov		daddr2[esp],edi				;save line start addr
    mov     esi,chromaPtr[esp]

    cmp     DWORD PTR lvres[esp],4
    jne     addWtoC_loX

    test    eax,1
    jnz     addWtoC_loX    

    dec     eax
nop

    mov     k[esp],eax
    jnz     blkLoop_loX

    jmp     theExit_loX

addWtoC_loX:
    add     esi,ebx                     ;chroma += width*4
    dec     eax

    mov     chromaPtr[esp],esi
    mov     k[esp],eax

    jnz     blkLoop_loX

theExit_loX:
    add     esp,Vars
;    mov     esp,L_stack[esp]                   ;restore stack

    pop     edx
    pop     ecx
    pop     ebx
    pop     ebp
    pop     edi
    pop     esi
    ret
;------------------------------------------------
bft00_hiX_:
_bft00_hiX:
    push    esi
    push    edi
    push    ebp
    push    ebx 
    push    ecx
    push    edx

    mov     eax,[esp].dwidth
    mov     ebp,[esp].luma

	shl		eax,1							;dwidth * 4 / 2
    mov     ecx,[esp].xwidth

    mov     esi,[esp].chroma
    mov     edi,[esp].dst

    mov     ebx,[esp].height
    mov     edx,[esp].vres

;    mov     ebp,esp                         ;save current stack ptr
;    and     esp,0ffffffe0h                  ;align

    shr     ebx,1                           ;height /= 2
    sub     esp,Vars                        ;make room for local var 32 byte block(s)

    shr     ecx,2
;    mov     L_stack[esp],ebp                ;save stack ptr

    mov     lvres[esp],edx
    mov     dstWidth[esp],eax

    mov     blkWidth[esp],ecx
    mov     i[esp],ecx

;    shl     ecx,2
    mov     k[esp],ebx                      ;k = height
    mov     chromaPtr[esp],esi

;    mov     lchroma[esp],esi
	mov		daddr2[esp],edi					;save dst addr
    
blkLoop_hiX:
    BLIT_LINE_HIX

    mov     esi,chromaPtr[esp]
    mov     ebx,blkWidth[esp]

    mov     eax,dstWidth[esp]
    mov     edi,daddr2[esp]

    mov     i[esp],ebx
    add     edi,eax                     ;dst += dwidth

    BLIT_LINE_HIX

    mov     eax,dstWidth[esp]
    mov     ebx,blkWidth[esp]

    mov     edi,daddr2[esp]
    mov     i[esp],ebx

    add     eax,eax
nop

    shl     ebx,2
    add     edi,eax                     ;dst += dwidth

    mov     eax,k[esp]
;    add     ebp,ebx                     ;lluma += width*4

	mov		daddr2[esp],edi				;save line start addr
    mov     esi,chromaPtr[esp]

    cmp     DWORD PTR lvres[esp],4
    jne     addWtoC_hiX

    test    eax,1
    jnz     addWtoC_hiX

    dec     eax
nop

    mov     k[esp],eax
    jnz     blkLoop_hiX

    jmp     theExit_hiX

addWtoC_hiX:
;    add     esi,ebx                     ;chroma += width*4
    lea     esi,[esi+ebx*2]                     ;chroma += width*4*2
    dec     eax

    mov     chromaPtr[esp],esi
    mov     k[esp],eax

    jnz     blkLoop_hiX

theExit_hiX:
    add     esp,Vars
;    mov     esp,L_stack[esp]                   ;restore stack

    pop     edx
    pop     ecx
    pop     ebx
    pop     ebp
    pop     edi
    pop     esi
    ret

;************************************************
         END

