;   Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.
;
;   This file is part of VpVision.
;
;   VpVision is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License ver. 2,
;   as published by the Free Software Foundation (www.fsf.org).
;
;   Foobar is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with VpVision; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;/***********************************************\
;??? dxi24.asm   
;\***********************************************/ 
        .486
        .MODEL  flat, SYSCALL, os_dos
        .CODE

;IDEAL
NAME dxi24
;MASM

CDXI    EQU     1
CDXIC   EQU     1
CDXIC2  EQU     1

if CDXI
PUBLIC c_dxi_   
PUBLIC _c_dxi
endif

if CDXIC2
PUBLIC c_dxic2_   
PUBLIC _c_dxic2
endif

if CDXIC
PUBLIC c_dxic_   
PUBLIC _c_dxic
endif

EXTRN _gswidth24:DWORD
EXTRN _dx_bloc:DWORD
EXTRN _dxLast:DWORD
EXTRN _dxcLast:DWORD
EXTRN _dx_index:DWORD
EXTRN _dx_vloc:DWORD
EXTRN _vectbl:DWORD

TBLOFFSET   EQU     0
IADD        EQU     4
ISHIFT      EQU     4
IOFFSET     EQU     4096

BLKSIZE     EQU     128

;************************************************
GVHV1   MACRO
LOCAL L1
    mov     eax,TBLOFFSET[_vectbl+ebx]
    add     ebx,IADD

    sar     eax,1
    jnc     L1
    
    xor     ebx,ebx

    mov     bl,BYTE PTR[ebp]
    inc     ebp

    shl     ebx,ISHIFT
    jnz     L1
    
    xor     ebx,ebx

    mov     bl,BYTE PTR[ebp]
    add     edx,eax

    shl     ebx,ISHIFT
    inc     ebp

    mov     eax,8192[_vectbl+ebx]
    add     ebx,4

    sar     eax,1
    jnc      L1

    xor     ebx,ebx

    mov     bl,BYTE PTR[ebp]
    inc     ebp

    shl     ebx,ISHIFT

L1:
    add     edx,eax
ENDM

;************************************************
GVHV2   MACRO
LOCAL L1
    mov     esi,edx                             ;save vp
    mov     eax,TBLOFFSET[_vectbl+ebx]

    add     ebx,IADD

    sar     eax,1
    jnc     L1
    
    xor     ebx,ebx

    mov     bl,BYTE PTR[ebp]
    inc     ebp

    shl     ebx,ISHIFT
    jnz     L1
    
    xor     ebx,ebx

    mov     bl,BYTE PTR[ebp]
    add     edx,eax

    shl     ebx,ISHIFT
    inc     ebp

    mov     eax,8192[_vectbl+ebx]
    add     ebx,4

    sar     eax,1
    jnc      L1

    xor     ebx,ebx

    mov     bl,BYTE PTR[ebp]
    inc     ebp

    shl     ebx,ISHIFT

L1:
    add     edx,eax
    mov     L_vloc[esp],ebp                 ;save vloc ptr

    mov     eax,[edi]
    add     edi,4

    add     esi,eax
    mov     ebp,VOFF[esp]

    sar     eax,16
    and     esi,0ffffh

    add     eax,edx
    mov     L_temp[esp],ecx             
 
    shl     eax,16
    mov     ecx,-4[edi+(ebp*4)]             ;fetching the cache

    add     eax,esi
    mov     ecx,L_temp[esp]                 ;restore cbloc info
    
    mov     -4[edi+(ebp*4)],eax             ;write dx pixel
    mov     ebp,L_vloc[esp]                 ;restore vloc ptr
ENDM

;************************************************
GETVECC   MACRO
LOCAL L1
    mov     vp[esp],edx                     ;save vp
    mov     edx,clast[esp]

    mov     esi,cvp[esp]                    ;get color vp
    add     edx,4                           ;pre-increment

    mov     eax,TBLOFFSET+IOFFSET[_vectbl+ebx]
    add     ebx,IADD

    sar     eax,1
    jnc     L1
    
    xor     ebx,ebx

    mov     bl,BYTE PTR[ebp]
    inc     ebp

    shl     ebx,ISHIFT
    jnz     L1
    
    xor     ebx,ebx
    mov     bl,BYTE PTR[ebp]
    add     esi,eax

    shl     ebx,ISHIFT
    inc     ebp

    mov     eax,8192+IOFFSET[_vectbl+ebx]
    add     ebx,4

    sar     eax,1
    jnc      L1

    xor     ebx,ebx

    mov     bl,BYTE PTR[ebp]
    inc     ebp

    shl     ebx,ISHIFT

L1:
    add     esi,eax
    mov     L_vloc[esp],ebp                 ;save vloc ptr

    mov     eax,-4[edx]
    mov     ebp,COFF[esp]

    mov     cvp[esp],esi  
    add     eax,esi

    mov     clast[esp],edx
nop

    mov     -4[edx+ebp*4],eax
    mov     eax,[edx+ebp*4]                 ;prefetch cache

    mov     ebp,L_vloc[esp]                 ;save vloc ptr
    mov     edx,vp[esp]                     ;restore vp
ENDM

;------------------------------------------------
;static void c_dxi(U32 width) 
;
c_dxiParams    STRUC
                dd  6 dup (?)   ;6 pushed regs
                dd  ?           ;return address
    xWidth      dd  ?       
c_dxiParams    ENDS
;------------------------------------------------

;------------------------------------------------
; local vars
;
lWidth      EQU     0
cbloc       EQU     lWidth+4
xcnt        EQU     cbloc+4
VOFF        EQU     xcnt+4
COFF        EQU     VOFF+4
cvp         EQU     COFF+4
clast       EQU     cvp+4
vp          EQU     clast+4

L_vloc      EQU     vp+4
L_temp      EQU     L_vloc+4

Vars        EQU     (L_temp+4+31) AND 0ffffffe0h
;------------------------------------------------
; regs in main loop
; eax = work
; ebx = index/cbloc/work
; ecx = lbctl
; edx = vp
; ebp = vloc
; esi = work
; edi = last
;------------------------------------------------

if CDXI
c_dxi_:
_c_dxi:
    push    esi
    push    edi
    push    ebp
    push    ebx 
    push    ecx
    push    edx

ifdef WIN95
    mov     edx,[esp].xWidth
else
    mov     edx,eax
endif

    mov     ebp,esp                         ;save current stack ptr
    and     esp,0ffffffe0h                  ;align
    sub     esp,4                           ;room for saved ptr
    mov     [esp],ebp
    sub     esp,Vars                        ;make room for local var 32 byte block(s)

    mov     ebx,_dx_bloc
    mov     eax,_gswidth24
    mov     edi,_dxLast
    mov     ebp,_dx_vloc

    mov     esi,lWidth[esp]                 ;fill cache with local vars
    mov     lWidth[esp],edx
    mov     cbloc[esp],ebx
    mov     COFF[esp],eax
    mov     VOFF[esp],eax
    mov     ebx,_dx_index

    xor     edx,edx                         ;vp = 0

doWidth:
    mov     eax,lWidth[esp]
    mov     esi,cbloc[esp]

    cmp     eax,0                           ;check for width > 0
    jle     doneDX

    mov     ecx,[esi]
    add     esi,4
    
    cmp     eax,BLKSIZE
    mov     cbloc[esp],esi

    mov     esi,eax
    jle     lte128

    mov     esi,BLKSIZE

lte128:    	
    sub     eax,esi
    mov     xcnt[esp],esi

    mov     lWidth[esp],eax

doXCNT:
    rcr     ecx,1
    jc      ER

    GVHV1    
    GVHV2

    sub     DWORD PTR xcnt[esp],4
    jnz     doXCNT

    jmp     doWidth

ER:
    test    ecx,1

    lea     edi,[edi+4]
    jnz     chkXcnt

    mov     esi,VOFF[esp] 
    xor     eax,eax

    mov     ax,WORD PTR -2[edi]
    xor     edx,edx

    mov     dx,WORD PTR -2[edi+esi*4]

    sub     edx,eax

chkXcnt:
    sub     DWORD PTR xcnt[esp],4
    jnz     doXCNT

    jmp     doWidth

doneDX:
    add     esp,Vars
    mov     esp,[esp]                   ;restore stack

    mov     _dx_index,ebx
    mov     _dx_vloc,ebp
    pop     edx
    pop     ecx
    pop     ebx
    pop     ebp
    pop     edi
    pop     esi
    ret
endif

;------------------------------------------------
;static void c_dxic(U32 width) 

if CDXIC
c_dxic_:
_c_dxic:
    push    esi
    push    edi
    push    ebp
    push    ebx 
    push    ecx
    push    edx

ifdef WIN95
    mov     edx,[esp].xWidth
else
    mov     edx,eax
endif

    mov     ebp,esp                         ;save current stack ptr
    and     esp,0ffffffe0h                  ;align
    sub     esp,4                           ;room for saved ptr
    mov     [esp],ebp
    sub     esp,Vars                        ;make room for local var 32 byte block(s)

    mov     ebx,_dx_bloc
    mov     eax,_gswidth24
    mov     edi,_dxLast

    mov     esi,lWidth[esp]                 ;fill cache with local vars
    mov     lWidth[esp],edx
    mov     cbloc[esp],ebx
    mov     VOFF[esp],eax
    mov     ebp,_dx_vloc
    mov     COFF[esp],eax
    mov     eax,_dxcLast
    mov     clast[esp],eax

    xor     edx,edx                         ;vp = 0
    mov     ebx,_dx_index
    mov     cvp[esp],edx                    ;cvp = 0

doWidthc:
    mov     eax,lWidth[esp]
    mov     esi,cbloc[esp]

    cmp     eax,0                           ;check for width > 0
    jle     doneDXc

    mov     ecx,[esi]
    add     esi,4
    
    cmp     eax,BLKSIZE
    mov     cbloc[esp],esi

    mov     esi,eax
    jle     lte128c

    mov     esi,BLKSIZE

lte128c:    	
    sub     eax,esi
    mov     xcnt[esp],esi

    mov     lWidth[esp],eax

doXCNTc:
    rcr     ecx,1
    jc      ERc

    GETVECC
    GVHV1    
    GVHV2

    sub     DWORD PTR xcnt[esp],4
    jnz     doXCNTc

    jmp     doWidthc

ERc:
    test    ecx,1

    lea     edi,[edi+4]
    jnz     chkXcntc

    mov     esi,COFF[esp] 
    mov     edx,clast[esp]

    mov     eax,[edx+esi*4]
    mov     edx,[edx]

    mov     esi,VOFF[esp] 
    sub     eax,edx

    xor     edx,edx
    mov     cvp[esp],eax

    mov     dx,WORD PTR -2[edi+esi*4]
    xor     eax,eax

    mov     ax,WORD PTR -2[edi]

    sub     edx,eax

chkXcntc:
    add     DWORD PTR clast[esp],4
    sub     DWORD PTR xcnt[esp],4

    jnz     doXCNTc

    jmp     doWidthc

doneDXc:
    mov     _dx_index,ebx
    mov     _dx_vloc,ebp

    add     esp,Vars
    mov     esp,[esp]                   ;restore stack

    pop     edx
    pop     ecx
    pop     ebx
    pop     ebp
    pop     edi
    pop     esi
    ret
endif ;c_dxic

;------------------------------------------------
;static void c_dxic2(U32 width) 

if CDXIC2
c_dxic2_:
_c_dxic2:
    push    esi
    push    edi
    push    ebp
    push    ebx 
    push    ecx
    push    edx

ifdef WIN95
    mov     edx,[esp].xWidth
else
    mov     edx,eax
endif

    mov     ebp,esp                         ;save current stack ptr
    and     esp,0ffffffe0h                  ;align
    sub     esp,4                           ;room for saved ptr
    mov     [esp],ebp
    sub     esp,Vars                        ;make room for local var 32 byte block(s)

    mov     ebx,_dx_bloc
    mov     eax,_gswidth24
    mov     edi,_dxLast

    mov     esi,lWidth[esp]                 ;fill cache with local vars

    mov     lWidth[esp],edx
    mov     cbloc[esp],ebx
    mov     VOFF[esp],eax
    add     eax,eax
    mov     ebp,_dx_vloc
    mov     COFF[esp],eax
    mov     eax,_dxcLast
    mov     clast[esp],eax

    xor     edx,edx                         ;vp = 0
    mov     ebx,_dx_index
    mov     cvp[esp],edx                    ;cvp = 0

doWidthc2:
    mov     eax,lWidth[esp]
    mov     esi,cbloc[esp]

    cmp     eax,0                           ;check for width > 0
    jle     doneDXc2

    mov     ecx,[esi]
    add     esi,4
    
    cmp     eax,BLKSIZE
    mov     cbloc[esp],esi

    mov     esi,eax
    jle     lte128c2

    mov     esi,BLKSIZE

lte128c2:    	
    sub     eax,esi
    mov     xcnt[esp],esi

    mov     lWidth[esp],eax

doXCNTc2:
    rcr     ecx,1
    jc      ERc2

    GETVECC
    GVHV1    
    GETVECC 
    GVHV2

    sub     DWORD PTR xcnt[esp],4
    jnz     doXCNTc2
    jmp     doWidthc2

ERc2:
    test    ecx,1

    lea     edi,[edi+4]
    jnz     chkXcntc2

    mov     esi,COFF[esp] 
    mov     edx,clast[esp]

    mov     eax,4[edx+esi*4]
    mov     edx,4[edx]

    mov     esi,VOFF[esp] 
    sub     eax,edx

    xor     edx,edx
    mov     cvp[esp],eax

    xor     eax,eax

    mov     dx,WORD PTR -2[edi+esi*4]

    mov     ax,WORD PTR -2[edi]

    sub     edx,eax

chkXcntc2:
    add     DWORD PTR clast[esp],8
    sub     DWORD PTR xcnt[esp],4

    jnz     doXCNTc2

    jmp     doWidthc2

doneDXc2:
    mov     _dx_index,ebx
    mov     _dx_vloc,ebp

    add     esp,Vars
    mov     esp,[esp]                   ;restore stack

    pop     edx
    pop     ecx
    pop     ebx
    pop     ebp
    pop     edi
    pop     esi
    ret
endif ;c_dxic2

;************************************************
         END
