;/***********************************************\
;??? 16_8.ash
; contains various 16bit to 8bit related macros
;\***********************************************/ 

;************************************************
DITHER_8BIT MACRO
    mov     ax,[ebp+6]
    mov     dh, BYTE PTR [ebx+eax]
    mov     ax,[ebp+4]
    mov     dl, BYTE PTR [esi+eax]
    shl     edx,16
    mov     ax,[ebp+2]
    mov     dh, BYTE PTR [ebx+eax]
    mov     ax,[ebp]
    mov     dl, BYTE PTR [esi+eax]
    mov     [edi],edx                           ;; write 4 8-bit pixels
ENDM

;************************************************
DITHER_STRETCH_8BIT MACRO
    mov     ax,[ebp+6]
    mov     dh, BYTE PTR [ebx+eax]
    mov     dl,dh
    shl     edx,16
    mov     ax,[ebp+4]
    mov     dh, BYTE PTR [esi+eax]
    mov     dl,dh
    mov     [edi+4],edx                         ;; write 4 8-bit pixels

    mov     ax,[ebp+2]
    mov     dh, BYTE PTR [ebx+eax]
    mov     dl,dh
    shl     edx,16
    mov     ax,[ebp]
    mov     dh, BYTE PTR [esi+eax]
    mov     dl,dh
    mov     [edi],edx                           ;; write 4 8-bit pixels
ENDM

;************************************************
VINTERP_8BIT MACRO _5x5_savebits, _5x5_mask, addrOffset
    mov     ebx,[ebp+addrOffset]                ;get last line pixel pair 
    mov     eax,ebx                             ;save last line pixel pair
    mov     ebx,[ecx+addrOffset]                ;get current line pixel pair

    mov     edx,ebx                             ;save current line pixel pair
    and     ebx,eax
    and     ebx,_5x5_savebits                   ;save fudge factor

    and     edx,_5x5_mask
    and     eax,_5x5_mask
    add     eax,edx
    rcr     eax,1                               ;last+current/2
    add     eax,ebx                             ;add in fudge factor
    rol     eax,16                         
    mov     [esp+PIXEL_PAIR1],eax      ;write out stretched vinterped pixel
ENDM

;************************************************
BLIT16TO8   MACRO addrOffset
    mov     ebx,[esp+CLUT_PTR2]
    and     eax,0ffffh
    mov     dh, BYTE PTR[ebx+eax]
    mov     dl,dh
    shl     edx,16    
    mov     eax, [esp+PIXEL_PAIR1]
    shr     eax,16
    mov     dh, BYTE PTR[esi+eax]
    mov     dl,dh
    mov     [edi+addrOffset],edx             ;; write 4 8-bit pixels
ENDM

;************************************************
; (1) 8 bit pixel read from source
_1_8BIT_PIXEL MACRO destAddr_reg           
    mov     ax,[ebp]
    mov     dh, BYTE PTR [ebx+eax]
    mov     dl,dh
    mov     [edi],dx                            ;; write 2 8-bit pixels
    add     ebp,2
    add     destAddr_reg,2
ENDM
 
;************************************************
_1_8BIT_VPIXEL MACRO destAddr_reg, _5x5_savebits, _5x5_mask           
    push    ebx
    mov     ebx,[ebp]                           ;get last line pixel pair 
    mov     eax,ebx                             ;save last line pixel pair
    mov     ebx,[ecx]                           ;get current line pixel pair
    mov     edx,ebx                             ;save current line pixel pair
    and     ebx,eax
    and     ebx,_5x5_savebits                   ;save fudge factor

    and     edx,_5x5_mask
    and     eax,_5x5_mask
    add     eax,edx
    rcr     eax,1                               ;last+current/2
    add     eax,ebx                             ;add in fudge factor
    and     eax,0ffffh   
    pop     ebx  
    
    mov     dh, BYTE PTR [ebx+eax]
    mov     dl,dh
    mov     [edi],dx                            ;; write 2 8-bit pixels
    add     ebp,2          
    add     ecx,2
    add     destAddr_reg,2
ENDM

;************************************************
_1_8BIT_PIXEL_PAIR MACRO destAddr_reg, _5x5_savebits, _5x5_mask           
    push    ebx
    mov     ebx,[ebp]                           ;get last line pixel pair 
    mov     [edi],bx
    mov     eax,ebx                             ;save last line pixel pair
    mov     ebx,[ecx]                          ;get current line pixel pair
    mov     edx,ebx                             ;save current line pixel pair
    and     ebx,eax
    and     ebx,_5x5_savebits                   ;save fudge factor

    and     edx,_5x5_mask
    and     eax,_5x5_mask
    add     eax,edx
    rcr     eax,1                               ;last+current/2
    add     eax,ebx                             ;add in fudge factor
    and     eax,0ffffh   
    pop     ebx  
    
    mov     dh, BYTE PTR [ebx+eax]
    mov     dl,dh

;;;;;;;;;;;;;;;;;;;;;;;;;;
    mov     [edi+ecx],dx                         ;write 2 8-bit pixels
    add     ebp,2
    add     ecx,2
    add     destAddr_reg,2
ENDM

;************************************************
WR_8BIT_PIXEL_PAIRS MACRO destAddr_reg, _5x5_savebits, _5x5_mask
LOCAL wr_one_pixel, no_remaining_pixels

    cmp     DWORD PTR[esp+PIXELS_LEFT],0h         ;check for remaining pixels
    jz      no_remaining_pixels
wr_one_pixel:                                       ;occurs when page does not align with
    _1_8BIT_PIXEL_PAIR destAddr_reg, _5x5_savebits, _5x5_mask        ;4 pixel boundary
    dec     DWORD PTR[esp+PIXELS_LEFT]
    jnz     wr_one_pixel
no_remaining_pixels:        
ENDM



