;/***********************************************\
;??? bse.ash
; 16 bit source to 8 bit destination
;\***********************************************/ 
INCLUDE dxparam.ash
INCLUDE prologue.ash
INCLUDE interp.ash
INCLUDE 16_8.ash

ifndef WIN95 
    ifdef DEBUG
        INCLUDE debugger.ash
    endif
endif           
                                                             
;************************************************
WR_REMAINING_PIXELS MACRO 
LOCAL wr_one_pixel, no_remaining_pixels

    cmp     DWORD PTR[esp+PIXELS_LEFT],0h           ;check for remaining pixels
    jz      no_remaining_pixels
wr_one_pixel:                                       ;occurs when page does not align with
    _1_8BIT_PIXEL edi                               ;1 pixel boundary
    dec     DWORD PTR[esp+PIXELS_LEFT]
    jnz     wr_one_pixel
no_remaining_pixels:        
ENDM

;************************************************
;local var equates
BLKCWCOUNT      EQU     4
UBLOC           EQU     8
A_DITHER        EQU     12
BLKWIDTH        EQU     16
TEMPCOUNT       EQU     20
PIXELS_LEFT     EQU     24

;************************************************
BSE_ER MACRO
        DUCK_PROLOGUE
        sub     esp,32
        push    eax                                 ;save pointer to structure
        
        mov     ebx,[eax+dx_bloc]                   ;; block control (The word with block types) 
        mov     [esp+UBLOC],ebx             
        mov     ebx,[eax+dither]
        mov     [esp+A_DITHER],ebx
        mov     edi,DWORD PTR[eax+vDest]            ;; points at screen
        mov     ebp,DWORD PTR[eax+dxDest]           ;; points at source buffer with 16-bit pixels

        mov     ebx,[eax+clutptr]
        mov     esi,[eax+clutptr2]
        cmp     DWORD PTR[eax+dither],1
        je      clut_ptrs_ok               ;clut ptrs setup ok
        xchg    esi,ebx                     ;swap ptrs if doing other dither
clut_ptrs_ok:

        mov     ecx,[eax+xWidth]                     ; set up count of blocks done, this line
        mov     [esp+PIXELS_LEFT],ecx
        and     DWORD PTR[esp+PIXELS_LEFT],03h      
        shr     ecx,2                               ;4 pixel block
        cmp     ecx,0                               ;is the block incomplete?
        jz      block_exit                          ;yes, so just do remaining pixels
        mov     [esp+BLKWIDTH],ecx               

do_block:
        mov     DWORD PTR[esp+BLKCWCOUNT],ecx
        mov     eax,ecx
        cmp     ecx,32
        jle     LessThanEqual32
        mov     eax,32
LessThanEqual32:
        sub     [esp+BLKWIDTH],eax
        mov     DWORD PTR[esp+TEMPCOUNT],eax

        mov     eax,[esp+UBLOC] 
        mov     ecx,[eax]
        add     eax,4
        mov     [esp+UBLOC],eax             
        
blcopyloop:                                     ; this copies a block, if we want to
        xor     eax,eax                             ;; zero high order
dither_b:
        rcr     ecx,1
        jc      skipcopy_b
if HSTRETCH
        DITHER_STRETCH_8BIT
else        
        DITHER_8BIT
endif  

skipcopy_b:
        add     ebp,8
if HSTRETCH
        add     edi,8
else
        add     edi,4
endif
        dec     DWORD PTR[esp+TEMPCOUNT]
        jnz     dither_b

        cmp     DWORD PTR[esp+BLKWIDTH],0
        jle     block_exit

        mov     ecx,[esp+BLKWIDTH]              ;ready to do some more
        jmp     do_block

block_exit:
        WR_REMAINING_PIXELS
                    
        pop     eax  
        add     esp,32
        not     DWORD PTR[eax+dither]               ;toggle dither
        pop     es
        pop     ds
        popad
        ret
ENDM

;************************************************
BSE_RA MACRO
        DUCK_PROLOGUE
        sub     esp,32
        push    eax                             ;save structure pointer
        
        mov     edi,DWORD PTR[eax+vDest]            ;; points at screen
        mov     ebp,DWORD PTR[eax+dxDest]           ;; points at source buffer with 16-bit pixels

        mov     ebx,[eax+dither]
        mov     [esp+A_DITHER],ebx

        mov     ebx,[eax+clutptr]
        mov     esi,[eax+clutptr2]
        cmp     DWORD PTR[eax+dither],1
        je      clut_ptrs_ok_RA               ;clut ptrs setup ok
        xchg    esi,ebx                     ;swap ptrs if doing other dither

clut_ptrs_ok_RA:
        mov     ecx,[eax+xWidth]                     ; set up count of blocks done, this line
        mov     [esp+PIXELS_LEFT],ecx
        and     DWORD PTR[esp+PIXELS_LEFT],03h      
        shr     ecx,2                               ;4 pixel block
        cmp     ecx,0                               ;is the block incomplete?
        jz      aswapcopy                           ;yes, so just do remaining pixels
        mov     [esp+BLKWIDTH],ecx               

        xor     eax,eax                             ;; zero high order
acopyloop:

if HSTRETCH
        DITHER_STRETCH_8BIT
else        
        DITHER_8BIT
endif  
        add     ebp,8
if HSTRETCH
        add     edi,8
else
        add     edi,4
endif

        dec     ecx
        jnz     acopyloop

aswapcopy:      
        WR_REMAINING_PIXELS

        pop     eax
        add     esp,32
        not     DWORD PTR[eax+dither]               ;toggle dither
        pop     es
        pop     ds
        popad
        ret
ENDM

