;/***********************************************\
;??? bse22.ash
; SJL 4/97
; 16 to 8 stretch bright fat freddy bright 
;\***********************************************/ 
_555_MASK32      EQU     7bde7bdeh
_555_SAVEBITS32  EQU     04210421h

;contains dxparam stucture offset equates
INCLUDE dxparam.ash

ifndef WIN95
    INCLUDE v_macros.ash
endif

INCLUDE interp.ash

ifndef WIN95
    ifdef DEBUG
       INCLUDE debugger.ash
    endif
endif
                                                             
VESAPAGE                EQU     4
NEXT_LENGTH             EQU     VESAPAGE+4
ALREADY_PAGED           EQU     NEXT_LENGTH+4
SCREEN565               EQU     ALREADY_PAGED+4
PIXPAIR_BEFORE_BREAK    EQU     SCREEN565+4
PIXELS_LEFT             EQU     PIXPAIR_BEFORE_BREAK+4
BLKCNT                  EQU     PIXELS_LEFT+4
LINE_PITCH              EQU     BLKCNT+4
CLUT_PTR1               EQU     LINE_PITCH+4
CLUT_PTR2               EQU     CLUT_PTR1+4
PIX_PAIR_L1             EQU     CLUT_PTR2+4
PIX_PAIR_L2             EQU     PIX_PAIR_L1+4
PIX_PAIR_I1             EQU     PIX_PAIR_L2+4
PIX_PAIR_I2             EQU     PIX_PAIR_I1+4

STACKFRAME_SIZE         EQU     PIX_PAIR_I2+4

;************************************************
INTERP16_8_5X5 MACRO _5x5_savebits, _5x5_mask
;ax has pixel 0
;bx,dx has pixel 1
;bx returned with interped value
    and     dx,ax
    and     dx,_5x5_savebits            ;fudge factor
    and     bx,_5x5_mask                ;work on pixel pair
    and     ax,_5x5_mask
    add     bx,ax                       ;dx already has pixel #0
    rcr     bx,1                        ;0+1/2 pixel
    add     bx,dx                       ;add in fudge factor
ENDM

;************************************************
INTERP32_16_8_LINE MACRO _5x5_savebits, _5x5_mask
    ;ebx has last line pixel pair
    ;eax has current line pixel pair
    mov     edx,eax                             ;save current line pixel pair
    and     eax,ebx
    and     eax,_5x5_savebits                   ;save fudge factor
    and     edx,_5x5_mask
    and     ebx,_5x5_mask
    add     ebx,edx
    rcr     ebx,1                               ;last+current/2
    add     ebx,eax                             ;add in fudge factor
ENDM

;************************************************
; ebx contains clut_ptr1
; ecx contains clut_ptr2
_4_16TO8_LPIXS MACRO pair1, pair2, vDestOff
    mov     eax,pair2                           ;get first pixel
    and     eax,0ffffh
    mov     dl, BYTE PTR[ebx+eax]
    mov     eax,pair2
    shr     eax,16                              ;get second pixel
    mov     dh, BYTE PTR[ecx+eax]
    shl     edx,16

    mov     eax,pair1
    and     eax,0ffffh
    mov     dl, BYTE PTR[ebx+eax]
    mov     eax,pair1
    shr     eax,16
    mov     dh, BYTE PTR[ecx+eax]
    mov     [edi+vDestOff],edx                 ;; write 4 8-bit pixels
ENDM

;************************************************
; ebx contains clut_ptr1
; ecx contains clut_ptr2
_4_16TO8_IPIXS MACRO pair1, pair2, vDestOff
    mov     eax,pair2                           ;get first pixel
    and     eax,0ffffh
    mov     dl, BYTE PTR[ecx+eax]
    mov     eax,pair2
    shr     eax,16                              ;get second pixel
    mov     dh, BYTE PTR[ebx+eax]
    shl     edx,16

    mov     eax,pair1
    and     eax,0ffffh
    mov     dl, BYTE PTR[ecx+eax]
    mov     eax,pair1
    shr     eax,16
    mov     dh, BYTE PTR[ebx+eax] 
    mov     eax,[esp+LINE_PITCH]
    mov     [edi+eax+vDestOff],edx                 ;; write 4 8-bit pixels
ENDM

;************************************************
; ebx contains clut_ptr1
; ecx contains clut_ptr2
_2_16TO8_LPIXS MACRO pair1, vDestOff
    mov     eax,pair1
    and     eax,0ffffh
    mov     dl, BYTE PTR[ebx+eax]
    mov     eax,pair1
    shr     eax,16
    mov     dh, BYTE PTR[ecx+eax]
    mov     WORD PTR[edi+vDestOff],dx                 ;; write 4 8-bit pixels
ENDM

;************************************************
; ebx contains clut_ptr1
; ecx contains clut_ptr2
_2_16TO8_IPIXS MACRO pair1, vDestOff
    mov     eax,pair1
    and     eax,0ffffh
    mov     dl, BYTE PTR[ecx+eax]
    mov     eax,pair1
    shr     eax,16
    mov     dh, BYTE PTR[ebx+eax] 
    mov     eax,[esp+LINE_PITCH]
    mov     WORD PTR[edi+eax+vDestOff],dx                 ;; write 4 8-bit pixels
ENDM                 

;************************************************
BSE22 MACRO _5X5_savebits32, _5X5_mask32, _5X5_savebits, _5X5_mask
LOCAL bse22_pixloop, bse22_exit

        shr     ecx,1                                       ;single line pitch
        mov     [esp+LINE_PITCH],ecx
        mov     ebx,[esi]                                   ;previous interped line -- first time all zeros
        mov     [esp+PIX_PAIR_L1],ebx                        
        
        mov     eax,[ebp]                                   ;get first source pixel pair        
        mov     edx,eax                                     ;save
        rol     eax,16
        mov     ax,dx                                       ;first pixel doubled
        mov     [esi],eax                                   ;save for next scanline blit
        
        INTERP32_16_8_LINE _5X5_savebits32, _5X5_mask32
        mov     [esp+PIX_PAIR_I1],ebx                        

        mov     eax,[ebp]                                   ;get first source pixel pair        
        mov     ebx,eax                                     ;another temp work reg 
        rol     ebx,16        
        mov     edx,ebx                                     ;another temp work reg 
        
        INTERP16_8_5X5 _5X5_savebits, _5X5_mask

        mov     eax,[ebp]                                   ;get first source pixel pair        
        rol     eax,16
        mov     ax,bx

        mov     ebx,[esi+4]                                 ;previous interped line -- first time all zeros
        mov     [esi+4],eax                                 ;save for next scanline blit
        mov     [esp+PIX_PAIR_L2],ebx                        

        INTERP32_16_8_LINE _5X5_savebits32, _5X5_mask32
        mov     [esp+PIX_PAIR_I2],ebx                        

;convert to 8 bit and write
        mov     ebx,[esp+CLUT_PTR1]
        mov     ecx,[esp+CLUT_PTR2]
        _4_16TO8_LPIXS [esp+PIX_PAIR_L1],[esp+PIX_PAIR_L2],0
        _4_16TO8_IPIXS [esp+PIX_PAIR_I1],[esp+PIX_PAIR_I2],0

ifndef WIN95
        add     di,4
else
        add     edi,4
endif
        add     ebp,4
        add     esi,8
            
        mov     ebx,[esp]
        mov     edx,[ebx+xWidth]         
        dec     edx
        dec     edx                                         ;already read two pixels

        mov     [esp+PIXELS_LEFT],edx
        and     DWORD PTR[esp+PIXELS_LEFT],03h
        shr     edx,2

        mov     [esp+BLKCNT],edx
        jz      bse22_exit

        xor     eax,eax
        mov     ax, WORD PTR[ebp-2]
        
ALIGN 10h  ;for 486
bse22_pixloop:
        mov     ebx,[ebp]                                   ;get first source pixel pair        
        mov     edx,ebx                                     ;another temp work reg 
                
        INTERP16_8_5X5 _5X5_savebits, _5X5_mask
        mov     ax,bx
        rol     eax,16
        mov     ax,WORD PTR[ebp-2]                          ;get first source pixel pair        

        
        mov     ebx,[esi]                                   ;previous interped line -- first time all zeros
        mov     [esi],eax                                   ;save for next scanline blit
        mov     [esp+PIX_PAIR_L1],ebx                        
                
        INTERP32_16_8_LINE _5X5_savebits32, _5X5_mask32
        mov     [esp+PIX_PAIR_I1],ebx                        
        
        mov     ebx,[esi+4]       
        mov     eax,[ebp]
        mov     edx,eax
        rol     eax,16
        mov     ax,dx
        mov     [esi+4],eax                                 ;save doubled pixels for next scanline blit

        mov     [esp+PIX_PAIR_L2],ebx                        
        
        INTERP32_16_8_LINE _5X5_savebits32, _5X5_mask32
        mov     [esp+PIX_PAIR_I2],ebx                        

;convert to 8 bit and write
        mov     ebx,[esp+CLUT_PTR1]
        mov     ecx,[esp+CLUT_PTR2]
        _4_16TO8_LPIXS [esp+PIX_PAIR_L1],[esp+PIX_PAIR_L2],0
        _4_16TO8_IPIXS [esp+PIX_PAIR_I1],[esp+PIX_PAIR_I2],0
        
        mov     ebx,[ebp]
        mov     eax,ebx
        rol     eax,16
        mov     edx,ebx
        
        INTERP16_8_5X5 _5X5_savebits, _5X5_mask
        
        mov     ax,WORD PTR[ebp+2]                          ;get source pixel pair        
        rol     eax,16
        mov     ax,bx
                
        mov     ebx,[esi+8]
        mov     [esi+8],eax
        mov     [esp+PIX_PAIR_L1],ebx                        
        
        INTERP32_16_8_LINE _5X5_savebits32, _5X5_mask32
        mov     [esp+PIX_PAIR_I1],ebx                        
                
        xor     eax,eax
        mov     ax,WORD PTR[ebp+2]
;--------------------------------------------------------------
        mov     ebx,[ebp+4]                                   ;get first source pixel pair        
        mov     edx,ebx                                     ;another temp work reg 
                
        INTERP16_8_5X5 _5X5_savebits, _5X5_mask
        mov     ax,bx
        rol     eax,16
        mov     ax,WORD PTR[ebp-2+4]                          ;get first source pixel pair        

        
        mov     ebx,[esi+12]                                   ;previous interped line -- first time all zeros
        mov     [esi+12],eax                                   ;save for next scanline blit
        mov     [esp+PIX_PAIR_L2],ebx                        
                
        INTERP32_16_8_LINE _5X5_savebits32, _5X5_mask32
        mov     [esp+PIX_PAIR_I2],ebx                        
        
;convert to 8 bit and write
        mov     ebx,[esp+CLUT_PTR1]
        mov     ecx,[esp+CLUT_PTR2]
        _4_16TO8_LPIXS [esp+PIX_PAIR_L1],[esp+PIX_PAIR_L2],4
        _4_16TO8_IPIXS [esp+PIX_PAIR_I1],[esp+PIX_PAIR_I2],4

        mov     ebx,[esi+4+12]       
        mov     eax,[ebp+4]
        mov     edx,eax
        rol     eax,16
        mov     ax,dx
        mov     [esi+4+12],eax                                 ;save doubled pixels for next scanline blit

        mov     [esp+PIX_PAIR_L1],ebx                        
        
        INTERP32_16_8_LINE _5X5_savebits32, _5X5_mask32
        mov     [esp+PIX_PAIR_I1],ebx                        
        
        mov     ebx,[ebp+4]
        mov     eax,ebx
        rol     eax,16
        mov     edx,ebx
        
        INTERP16_8_5X5 _5X5_savebits, _5X5_mask
        
        mov     ax,WORD PTR[ebp+2+4]                          ;get source pixel pair        
        rol     eax,16
        mov     ax,bx
                
        mov     ebx,[esi+8+12]
        mov     [esi+8+12],eax
        mov     [esp+PIX_PAIR_L2],ebx                        
        
        INTERP32_16_8_LINE _5X5_savebits32, _5X5_mask32
        mov     [esp+PIX_PAIR_I2],ebx                        
                
;convert to 8 bit and write
        mov     ebx,[esp+CLUT_PTR1]
        mov     ecx,[esp+CLUT_PTR2]
        _4_16TO8_LPIXS [esp+PIX_PAIR_L1],[esp+PIX_PAIR_L2],8
        _4_16TO8_IPIXS [esp+PIX_PAIR_I1],[esp+PIX_PAIR_I2],8

        xor     eax,eax
        mov     ax,WORD PTR[ebp+2+4]
 
;---------------
        
        add     ebp,4+4
ifndef WIN95
        add     di,12       
else
        add     edi,12
endif
        add     esi,12+12
                    
        dec     DWORD PTR[esp+BLKCNT]
        jnz     bse22_pixloop                    ;until counts down

;-----------------------
        cmp     DWORD PTR[esp+PIXELS_LEFT],0
        je      doLast_pixel

        mov     ebx,[ebp]                                   ;get first source pixel pair        
        mov     edx,ebx                                     ;another temp work reg 
                
        INTERP16_8_5X5 _5X5_savebits, _5X5_mask
        mov     ax,bx
        rol     eax,16
        mov     ax,WORD PTR[ebp-2]                          ;get first source pixel pair        

        
        mov     ebx,[esi]                                   ;previous interped line -- first time all zeros
        mov     [esi],eax                                   ;save for next scanline blit
        mov     [esp+PIX_PAIR_L1],ebx                        
                
        INTERP32_16_8_LINE _5X5_savebits32, _5X5_mask32
        mov     [esp+PIX_PAIR_I1],ebx                        
        
        mov     ebx,[esi+4]       
        mov     eax,[ebp]
        mov     edx,eax
        rol     eax,16
        mov     ax,dx
        mov     [esi+4],eax                                 ;save doubled pixels for next scanline blit

        mov     [esp+PIX_PAIR_L2],ebx                        
        
        INTERP32_16_8_LINE _5X5_savebits32, _5X5_mask32
        mov     [esp+PIX_PAIR_I2],ebx                        

;convert to 8 bit and write
        mov     ebx,[esp+CLUT_PTR1]
        mov     ecx,[esp+CLUT_PTR2]
        _4_16TO8_LPIXS [esp+PIX_PAIR_L1],[esp+PIX_PAIR_L2],0
        _4_16TO8_IPIXS [esp+PIX_PAIR_I1],[esp+PIX_PAIR_I2],0
        
        mov     ebx,[ebp]
        mov     eax,ebx
        rol     eax,16
        mov     edx,ebx
        
        INTERP16_8_5X5 _5X5_savebits, _5X5_mask
        
        mov     ax,WORD PTR[ebp+2]                          ;get source pixel pair        
        rol     eax,16
        mov     ax,bx
                
        mov     ebx,[esi+8]
        mov     [esi+8],eax
        mov     [esp+PIX_PAIR_L1],ebx                        
        
        INTERP32_16_8_LINE _5X5_savebits32, _5X5_mask32
        mov     [esp+PIX_PAIR_I1],ebx                        
                
;convert to 8 bit and write
        mov     ebx,[esp+CLUT_PTR1]
        mov     ecx,[esp+CLUT_PTR2]
        _2_16TO8_LPIXS [esp+PIX_PAIR_L1],4
        _2_16TO8_IPIXS [esp+PIX_PAIR_I1],4

        xor     eax,eax
        mov     ax,WORD PTR[ebp+2]

ifndef WIN95
        add     di,6       
else
        add     edi,6
endif
        add     esi,12

doLast_pixel:
        mov     ebx,[esi]
        mov     dx,ax
        rol     eax,16
        mov     ax,dx
        mov     [esi],eax  

    mov     [esp+PIX_PAIR_L1],ebx
        
        INTERP32_16_8_LINE _5X5_savebits32, _5X5_mask32
    mov     [esp+PIX_PAIR_I1],ebx
;convert to 8 bit and write
        mov     ebx,[esp+CLUT_PTR1]
        mov     ecx,[esp+CLUT_PTR2]
        _2_16TO8_LPIXS [esp+PIX_PAIR_L1],0
        _2_16TO8_IPIXS [esp+PIX_PAIR_I1],0


bse22_exit:
ENDM
