;/***********************************************\
;??? bseb.ash
;
; contains code for vertically interped 
; 16 bit source to 8 bit destination
;\***********************************************/ 
INCLUDE dxparam.ash
INCLUDE prologue.ash
INCLUDE 16_8.ash

ifndef WIN95 
    ifdef DEBUG
        INCLUDE debugger.ash
    endif
endif           
                                                             
EXTRN c vectbl
                                                 
;************************************************
_555_MASK        EQU     7bde7bdeh
_555_SAVEBITS    EQU     04210421h

_565_MASK        EQU     0f7def7dfh
_565_SAVEBITS    EQU     08210820h                 

;************************************************
;local var equates           
LOW_COUNT       EQU     4
HIGH_COUNT      EQU     8

PIXELS_LEFT     EQU     12
STRUCT_PTR      EQU     PIXELS_LEFT+4
PIXEL_PAIR1     EQU     STRUCT_PTR+4
BLKWIDTH        EQU     PIXEL_PAIR1+4

BLKLOOPCNT      EQU     BLKWIDTH+4
UBLOC           EQU     BLKLOOPCNT+4
UBLOC_LAST      EQU     UBLOC+4
UB_DATA         EQU     UBLOC_LAST+4
UB_DATA_LAST    EQU     UB_DATA+4  
CLUT_PTR2       EQU     UB_DATA_LAST+4
LINE_PITCH      EQU     CLUT_PTR2+4
DX_DEST         EQU     LINE_PITCH+4

V16TO8_STACK_SIZE       EQU     DX_DEST+4

;************************************************
WR_REMAINING_8BIT_PIXELS MACRO 
LOCAL wr_one_pixel, no_remaining_pixels
    cmp     DWORD PTR[esp+PIXELS_LEFT],0h           ;check for remaining pixels
    jz      no_remaining_pixels

wr_one_pixel:                                       ;occurs when page does not align with
    _1_8BIT_PIXEL edi                               ;1 pixel boundary
xchg esi,ebx
    dec     DWORD PTR[esp+PIXELS_LEFT]
    jnz     wr_one_pixel

no_remaining_pixels:        
ENDM

;************************************************
WR_REMAINING_8BIT_VPIXELS MACRO _5x5_savebits, _5x5_mask
LOCAL wr_one_pixel, no_remaining_pixels
    cmp     DWORD PTR[esp+PIXELS_LEFT],0h           ;check for remaining pixels
    jz      no_remaining_pixels

wr_one_pixel:                                       ;occurs when page does not align with
    _1_8BIT_VPIXEL edi, _5x5_savebits, _5x5_mask     ;1 pixel boundary

xchg esi,ebx
    dec     DWORD PTR[esp+PIXELS_LEFT]
    jnz     wr_one_pixel                            

no_remaining_pixels:        
ENDM

;************************************************
BSE_BRIGHT_ER MACRO
        DUCK_PROLOGUE
        sub     esp,V16TO8_STACK_SIZE             
        push    eax                                 ;save structure pointer

        mov     [esp+STRUCT_PTR],eax  
        mov     DWORD PTR[esp+PIXELS_LEFT],0

        mov     ebx,[eax+dx_bloc] 
        mov     [esp+UBLOC],ebx  
        mov     ebx,[eax+dx_blocLast] 
        mov     [esp+UBLOC_LAST],ebx            

        mov     edi,[eax+vDest]         
        mov     ebp,[eax+dxLast]           

        mov     ecx,[eax+xWidth]
        mov     [esp+PIXELS_LEFT],ecx
        and     DWORD PTR[esp+PIXELS_LEFT],03h      
        shr     ecx,2                       ;4 pixel block
        mov     [esp+BLKLOOPCNT],ecx
        mov     [esp+BLKWIDTH],ecx
        jz      block_exit

        mov     ecx,[eax+pitch]
        shr     ecx,1
        mov     [esp+LINE_PITCH],ecx

        mov     ecx,[eax+dxDest]
        mov     [esp+DX_DEST],ecx
        
do_block:
        cmp     DWORD PTR[esp+BLKLOOPCNT],32
        jle     LessThanEqual32
        mov     DWORD PTR[esp+BLKLOOPCNT],32

LessThanEqual32:
        mov     ebx,[esp+BLKLOOPCNT]
        sub     [esp+BLKWIDTH],ebx
    
        mov     ebx,[esp+UBLOC] 
        mov     eax,[ebx]
        mov     [esp+UB_DATA],eax
        add     ebx,4
        mov     [esp+UBLOC],ebx             
        
        mov     ebx,[esp+UBLOC_LAST] 
        mov     eax,[ebx]
        mov     [esp+UB_DATA_LAST],eax
        add     ebx,4
        mov     [esp+UBLOC_LAST],ebx             

        mov     eax,[esp]                       ;contains structure pointer
        mov     ebx,[eax+clutptr]
        mov     [esp+CLUT_PTR2],ebx
        mov     esi,[eax+clutptr2] 

blcopyloop:                                     ; this copies a block, if we want to
        rcr     DWORD PTR[esp+UB_DATA],1
        setb    al
        rcr     DWORD PTR[esp+UB_DATA_LAST],1
        setb    ah
        and     al,ah
        jnz      black_out
    
        xor     eax,eax
        DITHER_STRETCH_8BIT     
        xchg    [esp+CLUT_PTR2],esi

        mov     ecx,[esp+DX_DEST]
        VINTERP_8BIT _555_SAVEBITS, _555_MASK, 0

        mov     ecx,[esp+LINE_PITCH]
        BLIT16TO8 ecx+0

        mov     ecx,[esp+DX_DEST]
        VINTERP_8BIT _555_SAVEBITS, _555_MASK, 4

        mov     ecx,[esp+LINE_PITCH]
        BLIT16TO8 ecx+4
        xchg    [esp+CLUT_PTR2],esi
    
;jmp blskipcopy
    
black_out:
;       mov     ecx,[esp+LINE_PITCH]
;       mov DWORD PTR[edi],0
;       mov DWORD PTR[edi+4],0
;       mov DWORD PTR[edi+ecx],0
;       mov DWORD PTR[edi+ecx+4],0

blskipcopy:                            
        add     ebp,8
        add     edi,8 
        add     DWORD PTR[esp+DX_DEST],8

        dec     DWORD PTR[esp+BLKLOOPCNT]
        jnz     blcopyloop
    
        cmp     DWORD PTR[esp+BLKWIDTH],0
        jle     block_exit
    
        mov     ebx,[esp+BLKWIDTH]              ;ready to do some more
        mov     [esp+BLKLOOPCNT],ebx
        jmp     do_block
                                               
block_exit:
        WR_8BIT_PIXEL_PAIRS edi, _555_SAVEBITS, _555_MASK
        add     esp,V16TO8_STACK_SIZE+4
        pop     es
        pop     ds
        popad
        ret
ENDM

;************************************************
BSE_BRIGHT_RA MACRO
        DUCK_PROLOGUE
        sub     esp,V16TO8_STACK_SIZE             
        
;START_CLKSTAMP LOW_COUNT-4, HIGH_COUNT-4

        push    eax                                 ;save structure pointer

        mov     [esp+STRUCT_PTR],eax  
        mov     DWORD PTR[esp+PIXELS_LEFT],0
    
        mov     edi,[eax+vDest]
        mov     ebp,[eax+dxLast]      
            
        mov     ecx,[eax+xWidth] 
        mov     ebx,[eax+clutptr]
        mov     [esp+CLUT_PTR2],ebx
        mov     esi,[eax+clutptr2] 

do_line:
        mov     [esp+PIXELS_LEFT],ecx
        and     DWORD PTR[esp+PIXELS_LEFT],03h      
        shr     ecx,2 
        jz      blkskip_1       

        mov     [esp+BLKWIDTH],ecx

        mov     ecx,[eax+pitch]
        shr     ecx,1
        mov     [esp+LINE_PITCH],ecx

        mov     ecx,[eax+dxDest]
        mov     [esp+DX_DEST],ecx

do_bright_line:        
        xor     eax,eax
        DITHER_STRETCH_8BIT     
        
        xchg    [esp+CLUT_PTR2],esi
        
        mov     ecx,[esp+DX_DEST]
        VINTERP_8BIT _555_SAVEBITS, _555_MASK, 0
 
        mov     ecx,[esp+LINE_PITCH]
        BLIT16TO8 ecx+0

        mov     ecx,[esp+DX_DEST]
        VINTERP_8BIT _555_SAVEBITS, _555_MASK, 4
 
        mov     ecx,DWORD PTR[esp+LINE_PITCH]
        BLIT16TO8 ecx+4
        
        xchg    [esp+CLUT_PTR2],esi

        add     edi,8
        add     ebp,8
        add     DWORD PTR[esp+DX_DEST],8

        dec     DWORD PTR[esp+BLKWIDTH]
        jnz     do_bright_line

blkskip_1:      
        WR_8BIT_PIXEL_PAIRS edi, _555_SAVEBITS, _555_MASK
        add     esp,V16TO8_STACK_SIZE+4
        pop     es
        pop     ds
        popad
        ret
ENDM
