;/***********************************************\
;??? bseh.ash
; 16 to 8 fat freddy
;\***********************************************/ 
INCLUDE dxparam.ash
INCLUDE prologue.ash
INCLUDE interp.ash
INCLUDE 16_8.ash

ifndef WIN95 
    ifdef DEBUG
        INCLUDE debugger.ash
    endif
endif           
                                                             
;************************************************
WR_REMAINING_PIXELS MACRO 
LOCAL wr_one_pixel, no_remaining_pixels

    cmp     DWORD PTR[esp+PIXELS_LEFT],0h           ;check for remaining pixels
    jz      no_remaining_pixels
wr_one_pixel:                                       ;occurs when page does not align with
    _1_8BIT_PIXEL edi                               ;1 pixel boundary
    dec     DWORD PTR[esp+PIXELS_LEFT]
    jnz     wr_one_pixel
no_remaining_pixels:        
ENDM

;************************************************
BLIT_TO_8BIT    MACRO
LOCAL h_copyloop, h_otherdither, h_swapcopy, @@clut_ptrs_ok
    sub     esp,32
    push    eax                             ;save structure pointer
        
    mov     edi,[eax+vDest]            ;; points at screen
    mov     ebx,[eax+dither]
    mov     [esp+A_DITHER],ebx

    mov     ebx,[eax+clutptr]
    mov     esi,[eax+clutptr2]

    cmp     DWORD PTR[eax+dither],1
    je     @@clut_ptrs_ok               ;clut ptrs setup ok
    xchg    esi,ebx                     ;swap ptrs if doing other dither
@@clut_ptrs_ok:

    mov     ecx,[eax+xWidth]                     ; set up count of blocks done, this line
    shl     ecx,1
    add     ecx,[eax+xWidth]
    mov     [esp+BLKCWCOUNT],ecx       ;save width

if HSTRETCH
    shr     ecx,2                               ; = ((3/2)*2)/4
else
    shr     ecx,3                               ; = (3/2)/4
endif

if HSTRETCH
    dec ecx
endif

    xor     eax,eax                             ;; zero high order

h_copyloop:
if HSTRETCH
    DITHER_STRETCH_8BIT
else        
    DITHER_8BIT
endif  
    add     ebp,8

;if HSTRETCH
;    add     edi,8
;else
    add     edi,4
;endif

    dec     ecx
    jnz     h_copyloop
    jmp     h_swapcopy
h_swapcopy:      
ENDM

;************************************************
;local var equates
BLKCWCOUNT      EQU     4
UBLOC           EQU     8
A_DITHER        EQU     12
BLKWIDTH        EQU     16
TEMPCOUNT       EQU     20
PIXELS_LEFT     EQU     24

SCREEN565       EQU     8

;************************************************
;converts hi compressed data and blits to 8bit dest
;pass 1 interpolates
;pass 2 converts/blits to 8bit
;************************************************
BSE_H MACRO    
        DUCK_PROLOGUE
        sub     esp,320*2                   ;temp destination
        mov     edi,esp                     ;pointer to temp destination
        sub     esp,4
        push    eax
        push    edi                         ;save pointer to temp destination
        mov     ebx,[eax+is565]
        mov     [esp+SCREEN565],ebx
        ;========================================
        ;PASS 1     
        ;========================================
        mov     ebp,[eax+dxDest]                
        mov     ecx,[eax+xWidth]                 ;get width
        shr     ecx,2

h_loop:
        mov     ebx,[ebp]       ;read #1    ; get #1,#2 pixel pair
        mov     edx,ebx                     ;save #1,#2 pixels
        mov     eax,edx                     ;temp work reg for #1,#2
        mov     esi,edx                     ;another temp work reg
        rol     eax,16                      ;put #2 pixel in low word
        
        INTERPOLATE     
        
        rol     eax,16                      ;put interp in high word, pixel #1 already in high word
        mov     [edi],eax       ;write #1   ;write 1+2/2,#1 pixels
                
        mov     edx,[ebp+4]     ;read #2    ;get #3,#4 pixel pair
        mov     bx,dx                       ;pair up #2,#3
        rol     ebx,16                      ;put #2 in low, #3 in high
        mov     [edi+4],ebx     ;write #2   ;write #2,#3 pixel pair

        mov     eax,edx                     ;save #3,#4 pixel pair
        mov     esi,edx                     ;another temp work reg
        rol     edx,16                      ;put #4 pixel in low word
        
        INTERPOLATE
        
        mov     [edi+8],eax     ;write #3   ;write 3+4/2,#4 pixels
                
        add     edi,12
        add     ebp,8
        dec     ecx
        jnz     h_loop                      ;until counts down

        pop     ebp                         ;points to temp dest
        pop     eax                         ;restore pointer
        ;========================================
        ;PASS 2 
        ;========================================
        BLIT_TO_8BIT

        pop     eax
        not     DWORD PTR[eax+dither]               ;toggle dither
        add     esp,(320*2)+32+4                            
        pop     es
        pop     ds
        popad
        ret
ENDM

;************************************************
;converts hi compressed data, stretches, and then 
;blits to a 8bit dest
;pass 1 interpolates
;pass 2 converts/blits to 8bit
;************************************************
BSE_HS MACRO    
        DUCK_PROLOGUE
        sub     esp,320*4                   ;temp destination
        mov     edi,esp                     ;pointer to temp destination
        sub     esp,4
        push    eax
        push    edi                         ;save pointer to temp destination
        mov     ebx,[eax+is565]
        mov     [esp+SCREEN565],ebx
        ;========================================
        ;PASS 1     
        ;========================================
        mov     ebp,[eax+dxDest]                
        mov     ecx,[eax+xWidth]                 ;get width

        shr     ecx,1
        mov     bx,[ebp]        ;read #1        ;get #0 pixel  
        add     ebp,2

hs_loop:
        mov     dx,bx
        rol     edx,16
        mov     dx,bx
        mov     [edi],edx       ;write #1   ;write #0,#0 pixel pair
        mov     ebx,[ebp]       ;read #2    ;get #1,#2 pixel pair
        mov     esi,ebx                     ;another temp work reg
        mov     eax,ebx                     ;another temp work reg 
        
        INTERPOLATE
        
        mov     edx,ebx                     ;get #1,#2
        rol     edx,16                      ;put #1 in high word
        mov     dx,ax                       ;interped
        mov     [edi+4],edx     ;write #2   ;write 0+1/2,#1 pixels

        mov     edx,ebx
        mov     eax,ebx                     ;get #1,#2
        rol     edx,16                      ;#2 in low word
        mov     esi,ebx                     ;another temp work reg
        
        INTERPOLATE

        mov     dx,ax                       ;interped pixel
        rol     edx,16                      ;interped in high word
        mov     dx,bx                       ;get #1
        mov     [edi+8],edx     ;write #3   ;write 1+2/2,#2 pixels
        rol     ebx,16                      ;put #2 pixel in low word for next iter
        
        add     ebp,4
        add     edi,12      

        dec     ecx
        jnz     hs_loop             ;until counts down
        
    rol     ebx,16
    sub     edi,2
    mov     [edi],bx                    ;write last pixel

        pop     ebp                         ;points to temp dest
        pop     eax                         ;restore pointer
        ;========================================
        ;PASS 2 
        ;========================================
        BLIT_TO_8BIT

        pop     eax
        not     DWORD PTR[eax+dither]               ;toggle dither
        add     esp,(320*4)+32+4                            
        pop     es
        pop     ds
        popad
        ret
ENDM