;/***********************************************\
;??? bss.ash
;\***********************************************/ 

;contains dxparam stucture offset equates
INCLUDE dxparam.ash 
INCLUDE prologue.ash

ifndef WIN95 
    ifdef DEBUG
        INCLUDE debugger.ash
    endif
endif           

;************************************************
; (2) 16 bit pixels read from source
_2_16BIT_PIXEL MACRO            
if HSTRETCH
    mov     eax,[ebp] 
    mov     ebx,eax
    rol     ebx,16
    xchg    bx,ax
    mov     [edi],ebx
    mov     [edi+4],eax
    add     ebp,4
    add     di,8
else
    mov     eax,[ebp]
    mov     [edi],eax
    add     ebp,4
    add     di,4
endif
ENDM

;************************************************
_4_PIXEL_BLOCK MACRO            
if HSTRETCH
    mov     eax,[ebp]
    mov     ebx,eax
    rol     ebx,16
    xchg    bx,ax
    mov     [edi],ebx
    mov     [edi+4],eax

    mov     eax,[ebp+4]
    mov     ebx,eax
    rol     ebx,16
    xchg    bx,ax
    mov     [edi+8],ebx
    mov     [edi+12],eax
else
    mov     ebx,[ebp]
    mov     eax,[ebp+4]
    mov     [edi],ebx                       
    mov     [edi+4],eax                     ; write 4 16-bit pixels
endif
ENDM


;************************************************
; (1) 16 bit pixel read from source
_1_16BIT_PIXEL MACRO            
if HSTRETCH
    mov     eax,[ebp] 
    mov     ebx,eax
    rol     ebx,16
    xchg    bx,ax
    mov     [edi],ebx
    add     ebp,2
    add     di,4
else
    mov     eax,[ebp]
    mov     [edi],ax
    add     ebp,2
    add     di,2
endif
ENDM

;************************************************
WR_REMAINING_PIXELS MACRO
LOCAL wr_one_pixel, no_remaining_pixels

    cmp     DWORD PTR[esp+PIXELS_LEFT],0h           ;check for remaining pixels
    jz      no_remaining_pixels
wr_one_pixel:                                       ;occurs when page does not align with
    _1_16BIT_PIXEL                                  ;4 pixel boundary
    dec     DWORD PTR[esp+PIXELS_LEFT]
    jnz     wr_one_pixel
no_remaining_pixels:        
ENDM

;************************************************
UBLOC           EQU     0
BLKWIDTH        EQU     4
PIXELS_LEFT     EQU     8

;************************************************
BSS_ER MACRO
        DUCK_PROLOGUE
        sub     esp,12                          ;make room for local vars
        mov     edi,[eax+vDest]     ; points to linear addr space
        mov     ebp,[eax+dxDest]        ; points at source buffer with 16-bit pixels

        mov     ebx,[eax+dx_bloc] 
        mov     [esp+UBLOC],ebx             

        mov     esi,[eax+xWidth]                 ; set up count of blocks done, this line
        mov     [esp+PIXELS_LEFT],esi
        and     DWORD PTR[esp+PIXELS_LEFT],03h      
        shr     esi,2                           ;4 pixel block
;        cmp     esi,0                           ;is the block incomplete?
        jz      block_exit                      ;yes, so just do remaining pixels
        mov     [esp+BLKWIDTH],esi               

do_block:
        cmp     esi,32
        jle     LessThanEqual32
        mov     esi,32
LessThanEqual32:
        sub     [esp+BLKWIDTH],esi

        mov     ebx,[esp+UBLOC] 
        mov     ecx,[ebx]
        add     ebx,4
        mov     [esp+UBLOC],ebx             
        
blcopyloop:                                     ; this copies a block, if we want to
        rcr     ecx,1
        jc      blskipcopy
        _4_PIXEL_BLOCK
blskipcopy:
        add     ebp,8
if HSTRETCH                                  
        add     edi,16
else
        add     edi,8
endif
        dec     esi
        jnz     blcopyloop

        cmp     DWORD PTR[esp+BLKWIDTH],0
        jle     block_exit

        mov     esi,[esp+BLKWIDTH]              ;ready to do some more
        jmp     do_block

block_exit:
        WR_REMAINING_PIXELS

        add     esp,12
        pop     es
        pop     ds
        popad
        ret
ENDM

;************************************************
; blit to screen, source and dest the same
BSS_RA MACRO
        DUCK_PROLOGUE                         
        sub     esp,12                          ;make room for local vars

        mov     edi,[eax+vDest]                 ; points at screen
        mov     ebp,[eax+dxDest]                ; points at source buffer with 16-bit pixels        
        mov     ecx,[eax+xWidth]                 ; set up count of blocks done, this line

        mov     [esp+PIXELS_LEFT],ecx
        and     DWORD PTR[esp+PIXELS_LEFT],03h      
        shr     ecx,2                           ;4 pixel block
;        cmp     ecx,0                           ;is the block incomplete?
        jz      incompleteBlock                 ;yes, so just do remaining pixels

;        test    ecx,03h                        ; should be 2 or 0, never 3 or 1
;        jz      no_remaining_pixels
;        _2_16BIT_PIXEL
;
;no_remaining_pixels:
;       shr     ecx,2

bcopyloop:
        _4_PIXEL_BLOCK
        add     ebp,8
if HSTRETCH
        add     edi,16
else
        add     edi,8
endif                           
        dec     ecx
        jnz     bcopyloop

incompleteBlock:
        WR_REMAINING_PIXELS

        add     esp,12
        pop     es
        pop     ds
        popad
        ret
ENDM
