;/***********************************************\
;??? bss22.ash
; SJL 4/97
; 16 to 16 stretch bright fat freddy bright 
;\***********************************************/ 
_555_MASK32      EQU     7bde7bdfh
_555_SAVEBITS32  EQU     04210420h

_565_MASK32      EQU     0f7def7dfh
_565_SAVEBITS32  EQU     08210820h

;contains dxparam stucture offset equates
INCLUDE dxparam.ash

ifndef WIN95
    INCLUDE v_macros.ash
endif

INCLUDE interp.ash

ifndef WIN95
    ifdef DEBUG
       INCLUDE debugger.ash
    endif
endif
                                                             
VESAPAGE                EQU     4
NEXT_LENGTH             EQU     VESAPAGE+4
ALREADY_PAGED           EQU     NEXT_LENGTH+4
SCREEN565               EQU     ALREADY_PAGED+4
PIXPAIR_BEFORE_BREAK    EQU     SCREEN565+4
PIXELS_LEFT             EQU     PIXPAIR_BEFORE_BREAK+4
BLKCNT                  EQU     PIXELS_LEFT+4
STACKFRAME_SIZE         EQU     BLKCNT+4

;************************************************
INTERP16_5X5 MACRO _5x5_savebits, _5x5_mask
;ax has pixel 0
;bx,dx has pixel 1
;bx returned with interped value
    and     dx,ax
    and     dx,_5x5_savebits            ;fudge factor
    and     bx,_5x5_mask                ;work on pixel pair
    and     ax,_5x5_mask
    add     bx,ax                       ;dx already has pixel #0
    rcr     bx,1                        ;0+1/2 pixel
    add     bx,dx                       ;add in fudge factor
ENDM

;************************************************
INTERP32_LINE MACRO _5x5_savebits, _5x5_mask, vDest_index           
    ;ebx has last line pixel pair
    ;eax has current line pixel pair
    mov     edx,eax                         ;save current line pixel pair
    and     eax,ebx
    and     eax,_5x5_savebits               ;save fudge factor
    and     edx,_5x5_mask
    and     ebx,_5x5_mask
    add     ebx,edx
    rcr     ebx,1                           ;last+current/2
    add     ebx,eax                         ;add in fudge factor
    mov     [edi+ecx+vDest_index],ebx       ;write out vinterped pixel pair
ENDM

;************************************************
BSS22 MACRO _5X5_savebits32, _5X5_mask32, _5X5_savebits, _5X5_mask
LOCAL bss22v_pixloop, bss22v_exit

        shr     ecx,1                                       ;single line pitch
        mov     ebx,[esi]                          ;previous interped line -- first time all zeros
        mov     [edi],ebx                                  
        
        mov     eax,[ebp]                          ;get first source pixel pair        
        mov     edx,eax                                     ;save
        rol     eax,16
        mov     ax,dx                                       ;first pixel doubled
        mov     [esi],eax                          ;save for next scanline blit
        
        INTERP32_LINE _5X5_savebits32, _5X5_mask32, 0

        mov     eax,[ebp]                          ;get first source pixel pair        
        mov     ebx,eax                                     ;another temp work reg 
        rol     ebx,16        
        mov     edx,ebx                                     ;another temp work reg 
        
        INTERP16_5X5 _5X5_savebits, _5X5_mask

        mov     eax,[ebp]                          ;get first source pixel pair        
        rol     eax,16
        mov     ax,bx

        mov     ebx,[esi+4]                        ;previous interped line -- first time all zeros
        mov     [edi+4],ebx                                  
        mov     [esi+4],eax                        ;save for next scanline blit

        INTERP32_LINE _5X5_savebits32, _5X5_mask32, 4

ifndef WIN95
        add     di,8
else
        add     edi,8
endif
        add     ebp,4
        add     esi,8
            
        mov     ebx,[esp]
        mov     edx,[ebx+xWidth]         
        dec     edx
        dec     edx                                         ;already read two pixels

        shr     edx,1

        mov     [esp+BLKCNT],edx
        jz      bss22v_exit

        xor     eax,eax
        mov     ax, WORD PTR[ebp-2]
        
ALIGN 10h  ;for 486
bss22v_pixloop:
        mov     ebx,[ebp]                          ;get first source pixel pair        
        mov     edx,ebx                                     ;another temp work reg 
                
        INTERP16_5X5 _5X5_savebits, _5X5_mask
        mov     ax,bx
        rol     eax,16
        mov     ax,WORD PTR[ebp-2]                          ;get first source pixel pair        

        
        mov     ebx,[esi]                          ;previous interped line -- first time all zeros
        mov     [edi],ebx                                  
        mov     [esi],eax                          ;save for next scanline blit
                
        INTERP32_LINE _5X5_savebits32, _5X5_mask32, 0
        
        mov     ebx,[esi+4]       
        mov     [edi+4],ebx                        ;write last line doubled pixel pair
        mov     eax,[ebp]
        mov     edx,eax
        rol     eax,16
        mov     ax,dx
        mov     [esi+4],eax                        ;save doubled pixels for next scanline blit
        
        INTERP32_LINE _5X5_savebits32, _5X5_mask32, 4
        
        mov     ebx,[ebp]
        mov     eax,ebx
        rol     eax,16
        mov     edx,ebx
        
        INTERP16_5X5 _5X5_savebits, _5X5_mask
        
        mov     ax,WORD PTR[ebp+2]                          ;get source pixel pair        
        rol     eax,16
        mov     ax,bx
                
        mov     ebx,[esi+8]
        mov     [edi+8],ebx                        ;write last line pixel pair                             
        mov     [esi+8],eax
        
        INTERP32_LINE _5X5_savebits32, _5X5_mask32, 8
                
        xor     eax,eax
        mov     ax,WORD PTR[ebp+2]
        
        add     ebp,4
ifndef WIN95
        add     di,12       
else
        add     edi,12
endif
        add     esi,12
                    
        dec     DWORD PTR[esp+BLKCNT]
        jnz     bss22v_pixloop                    ;until counts down
            
        mov     ebx,[esi]
        mov     [edi],ebx
        mov     dx,ax
        rol     eax,16
        mov     ax,dx
        mov     [esi],eax  

        INTERP32_LINE _5X5_savebits32, _5X5_mask32, 0

bss22v_exit:
ENDM
