;/***********************************************\
;??? bssb.ash
; contains code for vertical interp stretched blitters 
;\***********************************************/ 
;contains dxparam stucture offset equates
INCLUDE dxparam.ash 
INCLUDE prologue.ash
INCLUDE v_interp.ash

ifndef WIN95 
    ifdef DEBUG
        INCLUDE debugger.ash
    endif
endif           

;************************************************
UBLOC           EQU     0
BLKWIDTH        EQU     4
PIXELS_LEFT     EQU     8
BLKLOOPCNT      EQU     12
UBLOC_LAST      EQU     16
UB_DATA         EQU     20
UB_DATA_LAST    EQU     24

;************************************************
BSS_BRIGHT_ER MACRO
        DUCK_PROLOGUE
        sub     esp,28                          ;make room for local vars

        mov     edi,[eax+vDest]                 ;points at screen
        mov     ebp,[eax+dxDest] 
        mov     esi,[eax+dxLast]                ;previous dxed line

        mov     ecx,[eax+pitch]                 ;save dest pitch
        shr ecx,1

        mov     ebx,[eax+dx_bloc] 
        mov     [esp+UBLOC],ebx             
        mov     ebx,[eax+dx_blocLast] 
        mov     [esp+UBLOC_LAST],ebx            

        mov     ebx,[eax+xWidth]                 ; set up count of blocks done, this line
        mov     [esp+BLKLOOPCNT],ebx

        mov     [esp+PIXELS_LEFT],ebx
        and     DWORD PTR[esp+PIXELS_LEFT],03h      
        shr     ebx,2                           ;4 pixel block

        cmp     DWORD PTR[eax+is565],1
        je      do_line565_ER

do_line555_ER:
        cmp     ebx,0                           ;is the block incomplete?
        jz      block_exit555                   ;yes, so just do remaining pixels
        mov     [esp+BLKWIDTH],ebx               

do_block555:
        DO_SMART_LINE _555_SAVEBITS, _555_MASK, edi

block_exit555:
        WR_REMAINING_PIXEL_PAIRS _555_SAVEBITS, _555_MASK
        add     esp,28
        pop     es
        pop     ds
        popad
        ret

do_line565_ER:
        cmp     ebx,0                           ;is the block incomplete?
        jz      block_exit565                   ;yes, so just do remaining pixels
        mov     [esp+BLKWIDTH],ebx               

do_block565:
        DO_SMART_LINE _565_SAVEBITS, _565_MASK, edi
        
block_exit565:
        WR_REMAINING_PIXEL_PAIRS _565_SAVEBITS, _555_MASK
        add     esp,28
        pop     es
        pop     ds
        popad
        ret
ENDM

;************************************************
BSS_BRIGHT_RA MACRO
        DUCK_PROLOGUE                         
        sub     esp,12                          ;make room for local vars

        mov     edi,[eax+vDest]                 ;points at screen
        mov     ebp,[eax+dxDest] 

        mov     esi,[eax+dxLast]                ;previous dxed line
        mov     ebx,[eax+xWidth]                 ;set up count of blocks done, this line
        mov     ecx,[eax+pitch]                 ;save dest pitch
        shr ecx,1
        
        mov     [esp+PIXELS_LEFT],ebx
        and     DWORD PTR[esp+PIXELS_LEFT],03h      
        shr     ebx,2                           ;4 pixel block
        cmp     DWORD PTR[eax+is565],1
        je      do_line565

do_line555:
        cmp     ebx,0                           ;is the block incomplete?
        jz      incompleteBlock555              ;yes, so just do remaining pixels
        mov     DWORD PTR[esp+BLKWIDTH],ebx

_555_blkLoop:
        PIXEL_PAIR_1 _555_SAVEBITS, _555_MASK
        PIXEL_PAIR_2 _555_SAVEBITS, _555_MASK
        add     esi,8
        add     ebp,8
        add     edi,16

        dec     DWORD PTR[esp+BLKWIDTH]
        jnz     _555_blkLoop

incompleteBlock555:
        WR_REMAINING_PIXEL_PAIRS _555_SAVEBITS, _555_MASK


        add     esp,12
        pop     es
        pop     ds
        popad
        ret

do_line565:
        cmp     ebx,0                           ;is the block incomplete?
        jz      incompleteBlock565              ;yes, so just do remaining pixels
        mov     DWORD PTR[esp+BLKWIDTH],ebx

_565_blkLoop:
        PIXEL_PAIR_1 _565_SAVEBITS, _565_MASK
        PIXEL_PAIR_2 _565_SAVEBITS, _565_MASK
        add     esi,8
        add     ebp,8
        add     edi,16

        dec     DWORD PTR[esp+BLKWIDTH]
        jnz     _565_blkLoop

incompleteBlock565:
        WR_REMAINING_PIXEL_PAIRS _565_SAVEBITS, _565_MASK


        add     esp,12
        pop     es
        pop     ds
        popad
        ret
ENDM
