;   Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.
;
;   This file is part of VpVision.
;
;   VpVision is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License ver. 2,
;   as published by the Free Software Foundation (www.fsf.org).
;
;   Foobar is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with VpVision; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;/***********************************************\
;??? dxsprite.asm
;\***********************************************/ 
;;
;;  assembly code for 80x86 sprites where x >= 4
;;  begun 2/26/95    Gerry Rossi
;;
;;  Copyright (c) 1995 The Duck Corporation, all rights reserved
;;           
;; 12/96 - removed globals    
;; 2/97 - fixing clipping, making more use of macros
;; 3/97 - removed all clipping

        .386
        .MODEL  flat, SYSCALL, os_dos
        .CODE

SHAPED      equ     1

;contains dxparam stucture offset equates
INCLUDE dxparam.ash 
INCLUDE prologue.ash

EXTRN c vectbl      ;; table of vectors accessed by compressed data vector numbers

;************************************************
;local var equates
A_JINDEX        EQU     4
A_COUNT         EQU     8
A_SKIP          EQU     12
A_RUN           EQU     16
A_PBLOC         EQU     20
SCREENIS565     EQU     24

;************************************************
CALL_MYBLEND    MACRO
    push    edi     
    mov     edi,[esp+SCREENIS565+24]
    call    myblend
    pop     edi 
ENDM        

;************************************************
GET_DELTAS MACRO vec_offset
LOCAL fixupcc, okcc, morecc
        mov         eax,[ebx+vectbl+vec_offset] ;;lookup string (vector) value
        add         bx,4
        sar         eax,1                       ;;look for end-of-string flag
        jnc         morecc
        mov         bl,[ebp]                    ;;get
        inc         ebp
        and         ebx,0ffh
        jnz         okcc
    
    ; HEY! got a bad pixel -- needs *5 fixins
        add         edx,eax                     ;;add in the ole dVq
        mov         bl,[ebp]                    ;;start new vec (high part of bx 0 becasue of and, above)
        shl         ebx,4                       ;; * 32 to pick up 32 bits at a time
        inc         ebp                         ;; point at next compressed vector #

        mov         eax,[ebx+vectbl+vec_offset] ;;ax=big delta burke
        add         bx,4                        ;; point at next (4 away)
        sar         eax,1
        jnc         fixupcc                     ;; got delta
        sub         ebx,ebx                     ;;yet another end-of-vec
        mov         bl,[ebp]                    ;;get index and fancy it up
        shl         ebx,4
        inc         ebp
fixupcc:                                        ;; here we multiply fixupdelta by 5
        add         edx,eax                     ;;one time add
        shl         eax,2                       ;;and 4 more (note add where we jump
        jmp         morecc
okcc:
        shl         ebx,4                       ;;compressed vector# * 32
morecc:
        add         edx,eax
ENDM                                            

;************************************************
INIT_VARS MACRO
        sub     esp,36
        push    eax                             ; save pointer to params structure

        mov     edx,[eax+dx_bloc]               ; set pointer to block ID words
        mov     [esp+A_PBLOC],edx
        mov     edx,[eax+is565]    
        mov     [esp+SCREENIS565],edx

        mov     esi,[eax+dxDest]                ; esi=dx_last; pixel array
        mov     edi,[eax+vDest]                 ; get dx destination
        mov     ebp,[eax+dx_vloc]               ; offset, sel
        mov     ebx,[eax+dx_index]              ; ebx=index into delta tbl from (1st compressed data pt * 4).

        mov     edx,[eax+xWidth]                 ; get width
        shr     edx,2                           ; width already in eax
        mov     [esp+A_JINDEX],edx
        xor     edx,edx                         ; init vp to 0

        mov     DWORD PTR[esp+A_COUNT],0
        mov     DWORD PTR[esp+A_RUN],0                      ; init run counter
ENDM

;************************************************
CHK_LINE MACRO
        jmp     doline
;; this is where we come to see if we're at end of display line
moreline:                                       ;; see if done with line
        shr     ecx,2                           ;; position next block ID bit field
        dec     DWORD PTR[esp+A_JINDEX]
        mov     eax,[esp+A_JINDEX]              ;; for debugger
        jz      endline                         ;; go on if no more to do
doline:                                         ;; start of line loop
        dec     DWORD PTR[esp+A_COUNT]
        jg      useval                          ;; count GT 0 -- val has meaning
        mov     ecx,[esp+A_PBLOC]
        mov     eax,[ecx]                       ;; get block ID word
        add     ecx,4                           ;; it's a dword (point to next)
        or      eax,eax                         ;; see if all transparent
        mov     [esp+A_PBLOC],ecx
        jnz     analval                         ;; something worth looking at
                                                ;; it's transparent for 16 blocks!!
        add     DWORD PTR[esp+A_RUN],16         ;; bump run a bunch
        sub     DWORD PTR[esp+A_JINDEX],16      ;; get pixel count
        jg      doline                          ;; jump if more left to do
        
        mov     eax,[esp+A_JINDEX]
        add     [esp+A_RUN],eax                 ;; done -- fix run 
        jmp     endline                         ;; done with line -- do run at end and leave
;;
;; enter below with val in the eax reg
;;
analval:    
        mov     ecx,eax
        mov     DWORD PTR[esp+A_COUNT],16
useval:                                         ;; here, we have to pick val up         
        inc     DWORD PTR[esp+A_RUN]            ;; in case xparent
        test    cl,03h                          ;; low 2 bits for this one
        jz      moreline                        ;; see if more to do this line if xparent
        dec     DWORD PTR[esp+A_RUN]            ;; guessed wrong
        jz      decode                          ;; jump if no xparent run to output

        xor     edx,edx            
        mov     eax,[esp+A_RUN]
        shl     eax,3                           ;; blocks to pixels
        add     edi,eax
workloop:
        mov     [esi],edx                       ;; zero next array for this block
        mov     [esi + 4],edx
        add     esi,8
        dec     DWORD PTR[esp+A_RUN]
        jnz     workloop 

;; note edx  (vp) is now 0
decode:
ENDM

;************************************************
IDEAL
ifdef COLOR
    NAME dxcSprite
else
    NAME dxSprite
endif
MASM
ifdef COLOR
    PUBLIC dxcSprite_
    PUBLIC _dxcSprite
else                
    PUBLIC dxSprite_
    PUBLIC _dxSprite
endif


ifdef COLOR
    dxcSprite_:
    _dxcSprite:
        DUCK_PROLOGUE 
        INIT_VARS 
        CHK_LINE
        GET_DELTAS 4096
else
    dxSprite_:
    _dxSprite:
        DUCK_PROLOGUE   
        INIT_VARS
        CHK_LINE
endif

nocolor:           
        ;get pair of luma deltas for 1st pixpair
        GET_DELTAS 0
        
        add         [esi],edx                   ;; update with vp
draw1:
        test        cl,2
        mov         eax,[esi]                   ;; get entry from last-frame buffer
        jz          writepix1                   ;; jump if not alpha block (2 which became 3.  Note 0 got picked off!, so odd parity must be the 1)
        call        alpha                       ;; do the ugly blend thing
writepix1:
        mov         [edi],eax                   ;; save our results don't bump until bottom of loop
bump1:
        add         esi,4
        add         edi,4

        ;get pair of luma deltas for 2nd pixpair
        GET_DELTAS 0

        add         [esi],edx                   ; update with vp
draw2:
        test        cl,2
        mov         eax,[esi]                   ;; get entry from last-frame buffer
        jz          writepix2                   ;; jump if not alpha block (2)
        call        alpha                       ;; do the ugly blend thing
writepix2:
        mov         [edi],eax
bump2:
        add     esi,4
        add     edi,4
        jmp     moreline                        ;inside CHK_LINE macro
        
endline:                    
        ;; end of line -- cleanup time
        ; save vector regs in vars for next call

        pop     edx                             ; get start of parameters
        mov     [edx+dx_vloc],ebp               ; save current dx_vloc value
;;
;;      write out last run
;;
        cmp     DWORD PTR[esp+A_RUN-4],0
        jz      noendrun                        ;; bag it if no run to finish off
        mov     eax,[esp+A_RUN-4]
        shl     eax,3                           ;; skip screen area
        add     edi,eax    
        xor     eax,eax
endloop:
        mov     [esi],eax
        mov     [esi+4],eax
        add     esi,8
        dec     DWORD PTR[esp+A_RUN-4]
        jnz     endloop 
noendrun:
        mov     [edx+dx_index],ebx              ; save current dx_index value
        mov     edi,[edx+vDest]
        mov     eax,[edx+pitch]
        add     edi,eax
        mov     [edx+vDest],edi
                
exit:                   ;; leave entire routine
        add     esp,36
        pop     es
        pop     ds
        popad
        ret     

;************************************************
;; blend foreground with background  note:  foreground in eax on entry
;; just get the needed 2 deltas, now 
alpha:
        mov     eax,[ebx+vectbl + 8192]         ;lookup
        add     bx,4
        sar     eax,1
        jnc     morea1
        mov     bl,[ebp]                        ;get
        and     ebx,0ffh
        inc     ebp
        shl     ebx,4
morea1:            
        shl     eax,2
        mov     eax,[eax+a_jumps]
        push    eax
noalpha:                                        ;; return without doing blend (and reading memory outside viewport
        ret                                     ;; cgoto

;************************************************
;; these are all real fast...
BackBack:
        mov     eax,es:[edi]
        ret
ForeFore:
        mov     eax,[esi]
        ret                  
ForeBack:
        mov     eax,[esi]
        mov     ax,es:[edi]
        ret
BackFore:
        mov     eax,es:[edi]
        mov     ax,[esi]
        ret
;; for these, we have to work a bit harder
BackBl1:
        mov     eax,es:[edi]                    ;; back in high order
        mov     ax,1
        jmp     BlendRight
BackBl2:
        mov     eax,es:[edi]                    ;; back in high order
        mov     ax,2
        jmp     BlendRight
BackBl3:
        mov     eax,es:[edi]                    ;; back in high order
        mov     ax,3
        jmp     BlendRight
        
ForeBl1:
        mov     eax,[esi]                       ;; fore in high order
        mov     ax,1
        jmp     BlendRight
ForeBl2:
        mov     eax,[esi]                       ;; fore in high order
        mov     ax,2
        jmp     BlendRight
ForeBl3:
        mov     eax,[esi]                       ;; fore in high order
        mov     ax,3
        jmp     BlendRight

Bl1Fore:
        mov     ax,1
        call    BlendLeft
        mov     ax,[esi] 
        ret
Bl2Fore:
        mov     ax,2
        call    BlendLeft
        mov     ax,[esi]
        ret
Bl3Fore:
        mov     ax,3
        call    BlendLeft
        mov     ax,[esi]
        ret

Bl1Back:
        mov     ax,1
        call    BlendLeft
        mov     ax,es:[edi] 
        ret
Bl2Back:
        mov     ax,2
        call    BlendLeft
        mov     ax,es:[edi] 
        ret
Bl3Back:
        mov     ax,3
        call    BlendLeft
        mov     ax,es:[edi] 
        ret                 
;; these we have to really put out for
Bl1Bl1:
        mov     ax,1
        call    BlendLeft
        mov     ax,1
        jmp     BlendRight
Bl1Bl2:
        mov     ax,1
        call    BlendLeft
        mov     ax,2
        jmp     BlendRight
Bl1Bl3:
        mov     ax,1
        call    BlendLeft
        mov     ax,3
        jmp     BlendRight

Bl2Bl1:
        mov     ax,2
        call    BlendLeft
        mov     ax,1
        jmp     BlendRight
Bl2Bl2:
        mov     ax,2
        call    BlendLeft
        mov     ax,2
        jmp     BlendRight
Bl2Bl3:
        mov     ax,2
        call    BlendLeft
        mov     ax,3
        jmp     BlendRight

Bl3Bl1:
        mov     ax,3
        call    BlendLeft
        mov     ax,1
        jmp     BlendRight
Bl3Bl2:
        mov     ax,3
        call    BlendLeft
        mov     ax,2
        jmp     BlendRight
Bl3Bl3:
        mov     ax,3
        call    BlendLeft
        mov     ax,3

; enter with left hand pixel computed in high order of eax
; weight in low order of eax
; esi points to foreground pixpair  (note: we only need low order)
; edi points to background pixpair
BlendRight:
        push    ebx
        push    eax
        push    ecx
        push    edx

        mov     ecx,[esi]           ;; foreground
        mov     edx,es:[edi]        ; background

        CALL_MYBLEND

        mov     bx,ax
        
        pop     edx
        pop     ecx
        pop     eax                 ;; recover left side value
        
        mov     ax,bx               ;; add in our right
        pop     ebx
        ret

; weight in low order of eax
; esi points to foreground pixpair  (note: we only need low order)
; edi points to background pixpair
BlendLeft:
        push    ebx
        push    ecx
        push    edx

        mov     cx,[esi + 2]        ;; foreground
        mov     dx,es:[edi + 2]     ; background
        
        CALL_MYBLEND

        shl     eax,16
        pop     edx
        pop     ecx
        pop     ebx
        ret

;************************************************
;; blend back (edx) and foreground (ecx) via weight (in al)
;;      foreground in esi [0-15], background in edi[0-16], a has weight

;   rhi = _dx_blend(RED(back),RED(fore),w);
;   ghi = _dx_blend(GRN(back),GRN(fore),w);
;   bhi = _dx_blend(BLU(back),BLU(fore),w);
;   back = MKRGB(rhi,ghi,bhi);
; dx_blend
;   U16 iw = 4-w;
;   return((back*iw + fore*w)/4);  /// for 1 mpy could use: a + ((b-a) * w) / 4

;************************************************
myblend:
        push    ax
        mov     bx,ax
;edi has screen565
        or      edi,edi
        jnz     myblend565
    ;; hopefully, alternating helps the pipeline         
        shl     edx,11              ;; r,g high order
        shl     ecx,11              ;; r,g high order
        shr     dx,2                ;; blue down
        shr     cx,2                ;; blue down
        mov     eax,01f3e7ch
        shr     edx,5
        shr     ecx,5
        shr     dx,2                ;; separate 5 bit fields for up to 4X add
        shr     cx,2                ;; separate 5 bit fields for up to 4X add
        and     edx,eax
        and     eax,ecx
        mov     ecx,eax
if SHAPED
        add     eax,ecx
        add     eax,ecx
else                                ; UNSHAPED VIDEO BLEND
        dec     bx                  ;; for cl < 4, this is fast
        jz      rw8ed
        add     eax,ecx
        dec     bx                  ;; for cl < 4, this is fast
        jz      rw8ed
        add     eax,ecx
endif

rw8ed:
        pop     bx
        sub     bx,4                ;; count - 4
        neg     bx                  ;; now 4 - count
        add     eax,edx

        dec     bx
        jz      rw8ed1
        add     eax,edx
        dec     bx
        jz      rw8ed1
        add     eax,edx
rw8ed1:
        and     eax,07cf9f0h        ;; strip out low order parts
        shr     eax,2               ;; red to boundary
        shl     ax,2                ;; green up to red
        shl     eax,5               ;; green to boundary
        shl     ax,2
        shr     eax,11
        ret                         ;; result in ax

    ;; hopefully, alternating helps the pipeline         
myblend565:
        shl     edx,11              ;; r,g high order
        shl     ecx,11              ;; r,g high order
        shr     dx,2                ;; blue down
        shr     cx,2                ; blue down
        mov     eax,01f3f3eh
        shr     edx,6
        shr     ecx,6
        shr     dx,2                ;; separate 5 bit fields for up to 4X add
        shr     cx,2                ;; separate 5 bit fields for up to 4X add
        and     edx,eax
        and     eax,ecx
        mov     ecx,eax

if SHAPED
        add     eax,ecx
        add     eax,ecx
else                                ;; UNSHAPED VIDEO BLEND
        dec     bx                  ;; for cl < 4, this is fast
        jz      rw8ed
        add     eax,ecx
        dec     bx                  ;; for cl < 4, this is fast
        jz      rw8ed
        add     eax,ecx
endif
rw8ed565:
        pop     bx
        sub     bx,4                ;; count - 4
        neg     bx                  ;; now 4 - count
        add     eax,edx

        dec     bx
        jz      rw8ed1565
        add     eax,edx
        dec     bx
        jz      rw8ed1565
        add     eax,edx
rw8ed1565:
        and     eax,07cfcf8h        ;; strip out low order parts
        shr     eax,2               ; red to boundary
        shl     ax,2                ; green up to red
        shl     eax,6               ;; green to boundary
        shl     ax,2
        shr     eax,11
        ret                         ;; result in ax  
        
;************************************************
        .DATA
ALIGN
a_jumps     LABEL   DWORD   ; table of jumps indexed by alpha pair
        dd  BackBack
        dd  BackFore
        dd  BackBl1
        dd  BackBl2
        dd  BackBl3
        
        dd  ForeBack
        dd  ForeFore
        dd  ForeBl1
        dd  ForeBl2
        dd  ForeBl3
        
        dd  Bl1Back
        dd  Bl1Fore
        dd  Bl1Bl1
        dd  Bl1Bl2
        dd  Bl1Bl3
        
        dd  Bl2Back
        dd  Bl2Fore
        dd  Bl2Bl1
        dd  Bl2Bl2
        dd  Bl2Bl3
        
        dd  Bl3Back
        dd  Bl3Fore
        dd  Bl3Bl1
        dd  Bl3Bl2
        dd  Bl3Bl3                          
;************************************************
            END
