;/***********************************************\
;??? interp.ash
;contains interpolating macros
;\***********************************************/ 


;************************************************
_555_MASK        EQU     7bdfh
_555_SAVEBITS    EQU     0420h

_565_MASK        EQU     0f7dfh
_565_SAVEBITS    EQU     0820h                 

;************************************************
INTERPOLATE_555 MACRO
    and     si,ax
    and     si,0420h                    ;fudge factor
    and     ax,7bdfh                    ;work on pixel pair
    and     dx,7bdfh
    add     ax,dx                       ;dx already has pixel #0
    shr     ax,1                        ;0+1/2 pixel
    add     ax,si                       ;add in fudge factor
ENDM

;************************************************
INTERPOLATE_565 MACRO
    and     esi,eax
    and     esi,0820h                   ;fudge factor
    and     eax,0f7dfh                    ;work on pixel pair
    and     edx,0f7dfh
    add     eax,edx                       ;dx already has pixel #0
    shr     eax,1                       ;0+1/2 pixel
    add     eax,esi                     ;add in fudge factor
ENDM

;************************************************
INTERPOLATE MACRO
LOCAL scrn565, macro_exit
    cmp     DWORD PTR[esp+SCREEN565],1
    je      scrn565      
    INTERPOLATE_555
    jmp     macro_exit
scrn565:   
    INTERPOLATE_565
macro_exit: 
ENDM

;************************************************
INTERP5X5 MACRO _5x5_savebits, _5x5_mask
    and     esi,eax
    and     esi,_5x5_savebits            ;fudge factor
    and     eax,_5x5_mask                ;work on pixel pair
    and     edx,_5x5_mask
    add     eax,edx                       ;dx already has pixel #0
    shr     eax,1                        ;0+1/2 pixel
    add     eax,esi                       ;add in fudge factor
ENDM


;************************************************
FATFREDDY_PIXLOOP MACRO _5x5_savebits, _5x5_mask, destAddr_reg
LOCAL pixel_loop
pixel_loop:
    mov     ebx,[ebp]       ;read #1    ; get #1,#2 pixel pair
    mov     edx,ebx                     ;save #1,#2 pixels
    mov     eax,edx                     ;temp work reg for #1,#2
    mov     esi,edx                     ;another temp work reg
    rol     eax,16                      ;put #2 pixel in low word
        
    INTERP5X5 _5x5_savebits, _5x5_mask
        
    rol     eax,16                      ;put interp in high word, pixel #1 already in high word
mov ax,bx
    mov     [edi],eax       ;write #1   ;write 1+2/2,#1 pixels

    mov     edx,[ebp+4]     ;read #2    ;get #3,#4 pixel pair
    mov     bx,dx                       ;pair up #2,#3
    rol     ebx,16                      ;put #2 in low, #3 in high
    mov     [edi+4],ebx     ;write #2   ;write #2,#3 pixel pair

    mov     eax,edx                     ;save #3,#4 pixel pair
mov ebx,edx
    mov     esi,edx                     ;another temp work reg
    rol     edx,16                      ;put #4 pixel in low word
        
    INTERP5X5 _5x5_savebits, _5x5_mask
mov bx,ax        
    mov     [edi+8],ebx     ;write #3   ;write 3+4/2,#4 pixels

    add     ebp,8
    add     destAddr_reg,12

    dec     ecx
    jnz     pixel_loop                  ;until counts down
ENDM

;************************************************
FATFREDDY_STRETCH_PIXLOOP MACRO _5x5_savebits, _5x5_mask, destAddr_reg
LOCAL pixel_loop1
pixel_loop1:
    mov     dx,bx
    rol     edx,16
    mov     dx,bx
    mov     [edi],edx       ;write #1   ;write #0,#0 pixel pair
    mov     ebx,[ebp]       ;read #2    ;get #1,#2 pixel pair
    mov     esi,ebx                     ;another temp work reg
    mov     eax,ebx                     ;another temp work reg 
        
    INTERP5X5 _5x5_savebits, _5x5_mask
        
    mov     edx,ebx                     ;get #1,#2
    rol     edx,16                      ;put #1 in high word
    mov     dx,ax                       ;interped
    mov     [edi+4],edx     ;write #2   ;write 0+1/2,#1 pixels

    mov     edx,ebx
    mov     eax,ebx                     ;get #1,#2
    rol     edx,16                      ;#2 in low word
    mov     esi,ebx                     ;another temp work reg
        
    INTERP5X5 _5x5_savebits, _5x5_mask

    mov     dx,ax                       ;interped pixel
    rol     edx,16                      ;interped in high word
    mov     dx,bx                       ;get #1
    mov     [edi+8],edx     ;write #3   ;write 1+2/2,#2 pixels
    rol     ebx,16                      ;put #2 pixel in low word for next iter
        
    add     ebp,4
    add     destAddr_reg,12       

    dec     ecx
    jnz     pixel_loop1                 ;until counts down
ENDM