;   Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.
;
;   This file is part of VpVision.
;
;   VpVision is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License ver. 2,
;   as published by the Free Software Foundation (www.fsf.org).
;
;   Foobar is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with VpVision; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
		.386
        .MODEL  flat, c, os_dos
        .CODE

EXTRN c dxtbl
EXTRN c yvuclut
EXTRN c linebuf
EXTRN c vubuf
PUBLIC c timer_
PUBLIC c dxy_
PUBLIC c dxy2x2_
PUBLIC c dxv_
PUBLIC c dxu_
PUBLIC c clear_linebuf_
;PUBLIC c clear_vesa_screen_
PUBLIC c lineaddr
PUBLIC c vuaddr
PUBLIC c vesapage
PUBLIC c pitch

timer_:
		push	ebx						; sFr
		push	edi
		push	ecx
		push	edx

		mov		al,0
		out		043h,al
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		in		al,040h
		mov		ah,al
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		in		al,040h
		xchg	al,ah	
		pop		edx
		pop		ecx						; rFr
		pop		edi
		pop		ebx
		ret

DXV	MACRO
LOCAL	xloop,yloop
dxv_:

		push	ebx						; sFr
		push	edi
		push	ecx
		push	edx
		push	esi
		push	ebp

; on entry:

; eax	=	imaddr
; edx	=	compaddr
; ebx 	=	width/height (bx=width, bx>>16=height)

		mov		eax,[esp+28]
		mov		edx,[esp+32]
		mov		ebx,[esp+36]
		mov		[imaddr],eax
		mov		[compaddr],edx
		mov		ecx,ebx
		shr		ebx,16
		mov		[height],ebx
		and		ecx,0ffffh
		mov		[width],ecx
		lea		eax,linebuf
		mov		[lineaddr],eax
;		call	clear_linebuf

; set up ptr regs:

; esi=compressed data
; edi=output data (bytes)
; ebp=lastline

		mov		ebp,[lineaddr]
		mov		esi,[compaddr]
		mov		edi,[imaddr]

; set up y loop:

		mov		eax,[height]
		mov		[ycount],eax
yloop:

; set up x loop:

		sub		edx,edx						; vp=0
		mov		ebp,[lineaddr]				; reset lineaddr
		mov		ecx,[width]
		shr		ecx,1						; 2 pix ata time
xloop:
		mov		al,[esi]
		and		eax,0fh
		add		edx,[dxtbl+eax*4]
		add		[ebp],dl

		mov		al,[esi]
		shr		al,4
		inc		esi
		add		edx,[dxtbl+eax*4]
		add		[ebp+1],dl

		mov		ax,[ebp]
		and		eax,0fcfch					; dxy needs this done
		add		ebp,2
		mov		[edi],al
		mov		[edi+2],ah
		add		edi,4
		dec		ecx
		jnz		xloop

		dec		[ycount]
		jnz		yloop

		pop		ebp
		pop		esi
		pop		edx
		pop		ecx						; rFr
		pop		edi
		pop		ebx
		ret

ENDM
		DXV

DXU		MACRO
LOCAL	xloop,yloop
dxu_:

		push	ebx						; sFr
		push	edi
		push	ecx
		push	edx
		push	esi
		push	ebp

; on entry:

; eax	=	imaddr
; edx	=	compaddr
; ebx 	=	width/height (bx=width, bx>>16=height)

		mov		eax,[esp+28]
		mov		edx,[esp+32]
		mov		ebx,[esp+36]
		mov		[imaddr],eax
		mov		[compaddr],edx
		mov		ecx,ebx
		shr		ebx,16
		mov		[height],ebx
		and		ecx,0ffffh
		mov		[width],ecx
		lea		eax,linebuf
		mov		[lineaddr],eax
;		call	clear_linebuf

; set up ptr regs:

; esi=output
; edi=input data (bytes)
; ebp=lastline

		mov		ebp,[lineaddr]
		mov		esi,[compaddr]
		mov		edi,[imaddr]

; set up y loop:

		mov		eax,[height]
		mov		[ycount],eax
yloop:

; set up x loop:

		sub		edx,edx						; vp=0
		mov		ebp,[lineaddr]				; reset lineaddr
		mov		ecx,[width]
		shr		ecx,1						; 2 pix ata time
xloop:
		mov		al,[esi]
		and		eax,0fh
		add		edx,[dxtbl+eax*4]
		add		[ebp],dl

		mov		al,[esi]
		shr		al,4
		inc		esi
		add		edx,[dxtbl+eax*4]
		add		[ebp+1],dl

		mov		ax,[ebp]
		shr		al,2						; dxy needs this too
		shr		ah,2
		add		ebp,2
		mov		[edi],al
		mov		[edi+2],ah
		add		edi,4
		dec		ecx
		jnz		xloop

		dec		[ycount]
		jnz		yloop

		pop		ebp
		pop		esi
		pop		edx
		pop		ecx						; rFr
		pop		edi
		pop		ebx
		ret

ENDM
		DXU

DXLOOP1	MACRO	off1,off2,off3
		mov		al,[esi+off1]
		and		eax,0fh
		add		edx,[dxtbl+eax*4]
		add		[ebp+off2],dl
		mov		al,[ebp+off2]
		shr		eax,2
		or		eax,ecx
		mov		ax,WORD PTR[yvuclut+eax*2]
		mov		[edi+off3],ax
		mov		[edi+off3+2],ax
ENDM

DXLOOP2	MACRO	off1,off2,off3
		sub		eax,eax
		mov		al,[esi+off1]
		shr		eax,4
		add		edx,[dxtbl+eax*4]
		add		[ebp+off2],dl
		mov		al,[ebp+off2]
		shr		eax,2
		or		eax,ecx
		mov		ax,WORD PTR[yvuclut+eax*2]
		mov		[edi+off3],ax
		mov		[edi+off3+2],ax
ENDM


;============================================================================


DXMAIN	MACRO
LOCAL	xloop,yloop,vesa_ok,new_chroma,no_page,nextvesapage
dxy_:

VUOFF	equ		1						; why can't I do (ubuf-vbuf) ???

		push	ebx						; sFr
		push	edi
		push	ecx
		push	edx
		push	esi
		push	ebp

; on entry:

; eax	=	imaddr
; edx	=	compaddr
; ebx 	=	width/height (bx=width, bx>>16=height)

		mov		eax,[esp+28]
		mov		edx,[esp+32]
		mov		ebx,[esp+36]
		mov		[imaddr],eax
		mov		[compaddr],edx
		mov		ecx,ebx
		shr		ebx,16
		mov		[height],ebx
		and		ecx,0ffffh
		mov		[width],ecx
		shr		ecx,2
		mov		[vuwidth],ecx
		lea		eax,linebuf
		mov		[lineaddr],eax
;		call	clear_linebuf

; set up ptr regs:

; eax=temp
; ebx=compressed VU
; ecx=VU bits
; edx=vp
; esi=compressed Y
; edi=output data
; ebp=lastline

		mov		ebp,[lineaddr]
		mov		esi,[compaddr]
		mov		edi,[imaddr]
		mov		ebx,[vuaddr]

; set up y loop:

		mov		eax,[height]
		mov		[ycount],eax
yloop:

; set up x loop:

		sub		edx,edx						; vp=0
		mov		ebp,[lineaddr]				; reset lineaddr
		mov		ecx,[width]
		shr		ecx,4						; 16 pix ata time

		push	ecx
xloop:

; get V & U:

		sub		ecx,ecx
		mov		cx,[ebx]					; V
		shl		ecx,4

; do the Y thing:

		DXLOOP1	0,0,0
		DXLOOP2	0,1,2
		DXLOOP1	1,2,4
		DXLOOP2	1,3,6

; ---------------------------------

		sub		ecx,ecx
		mov		cx,[ebx+2]					; V & U
		shl		ecx,4

; ---------------------------------

		DXLOOP1	2,4,8
		DXLOOP2	2,5,10
		DXLOOP1	3,6,12
		DXLOOP2	3,7,14

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

; get V & U:

		sub		ecx,ecx
		mov		cx,[ebx+4]					; V	 & U
		shl		ecx,4

; do the Y thing:


		DXLOOP1	4,8,16
		DXLOOP2	4,9,18
		DXLOOP1	5,10,20
		DXLOOP2	5,11,22

; ---------------------------------

		sub		ecx,ecx
		mov		cx,[ebx+6]					; V & U
		shl		ecx,4

; ---------------------------------

		DXLOOP1	6,12,24
		DXLOOP2	6,13,26
		DXLOOP1	7,14,28
		DXLOOP2	7,15,30

		add		esi,8					; 16 nybbles
		add		ebx,8					; 8 bytes VU
		add		ebp,16					; 16 bytes
		add		edi,32					; 16 longwords +++

		jc		nextvesapage
vesa_ok:
		dec		DWORD PTR [esp]

		jnz		xloop
		pop		ecx

		dec		[ycount]
		test	[ycount],3
		jz		new_chroma
		sub		ebx,[vuwidth]					; over and over
		sub		ebx,[vuwidth]					; over and over
new_chroma:
		mov		eax,[pitch]						; in pixels
		sub		eax,[width]						; in pixels
		shl		eax,1							; in bytes
		add		edi,eax							; +++
		jnc		no_page
;		call	incvesapage						; +++
no_page:
		test	[ycount],0ffffh
		jnz		yloop

		pop		ebp
		pop		esi
		pop		edx
		pop		ecx						; rFr
		pop		edi
		pop		ebx
		ret

nextvesapage:
;		call	incvesapage						; +++
		jmp		vesa_ok

ENDM


;============================================================================


DX2x2	MACRO
LOCAL	xloop,yloop,vesa_ok,new_chroma,no_page,nextvesapage
dxy2x2_:

VUOFF	equ		1						; why can't I do (ubuf-vbuf) ???

		push	ebx						; sFr
		push	edi
		push	ecx
		push	edx
		push	esi
		push	ebp

; on entry:

; eax	=	imaddr
; edx	=	compaddr
; ebx 	=	width/height (bx=width, bx>>16=height)

		mov		eax,[esp+28]
		mov		edx,[esp+32]
		mov		ebx,[esp+36]
		mov		[imaddr],eax
		mov		[compaddr],edx
		mov		ecx,ebx
		shr		ebx,16
		mov		[height],ebx
		and		ecx,0ffffh
		mov		[width],ecx
		shr		ecx,2
		mov		[vuwidth],ecx
		lea		eax,linebuf
		mov		[lineaddr],eax
;		call	clear_linebuf

; set up ptr regs:

; eax=temp
; ebx=compressed VU
; ecx=VU bits
; edx=vp
; esi=compressed Y
; edi=output data
; ebp=lastline

		mov		ebp,[lineaddr]
		mov		esi,[compaddr]
		mov		edi,[imaddr]
		mov		ebx,[vuaddr]

; set up y loop:

		mov		eax,[height]
		mov		[ycount],eax
yloop:

; set up x loop:

		sub		edx,edx						; vp=0
		mov		ebp,[lineaddr]				; reset lineaddr
		mov		ecx,[width]
		shr		ecx,4						; 16 pix ata time

		push	ecx
xloop:

; get V & U:

		sub		ecx,ecx
		mov		cx,[ebx]					; V
		shl		ecx,4

; do the Y thing:

		DXLOOP1	0,0,0
		DXLOOP2	0,1,4
		DXLOOP1	1,2,8
		DXLOOP2	1,3,12

; ---------------------------------

		sub		ecx,ecx
		mov		cx,[ebx+2]					; V & U
		shl		ecx,4

; ---------------------------------

		DXLOOP1	2,4,16
		DXLOOP2	2,5,20
		DXLOOP1	3,6,24
		DXLOOP2	3,7,28

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

; get V & U:

		sub		ecx,ecx
		mov		cx,[ebx+4]					; V	 & U
		shl		ecx,4

; do the Y thing:


		DXLOOP1	4,8,32
		DXLOOP2	4,9,36
		DXLOOP1	5,10,40
		DXLOOP2	5,11,44

; ---------------------------------

		sub		ecx,ecx
		mov		cx,[ebx+6]					; V & U
		shl		ecx,4

; ---------------------------------

		DXLOOP1	6,12,48
		DXLOOP2	6,13,52
		DXLOOP1	7,14,56
		DXLOOP2	7,15,60

		add		esi,8					; 16 nybbles
		add		ebx,8					; 8 bytes VU
		add		ebp,16					; 16 bytes
		add		edi,64					; 16 longwords	+++

		jc		nextvesapage
vesa_ok:
		dec		DWORD PTR [esp]

		jnz		xloop
		pop		ecx

		dec		[ycount]
		test	[ycount],3
		jz		new_chroma
		sub		ebx,[vuwidth]					; over and over
		sub		ebx,[vuwidth]					; over and over
new_chroma:
		mov		eax,[pitch]						; in pixels
		sub		eax,[width]						; in pixels
		shl		eax,2							; in bytes
		add		edi,eax							; +++
		jnc		no_page
;		call	incvesapage						; +++
no_page:
		test	[ycount],0ffffh
		jnz		yloop

		pop		ebp
		pop		esi
		pop		edx
		pop		ecx						; rFr
		pop		edi
		pop		ebx
		ret

nextvesapage:
;		call	incvesapage						; +++
		jmp		vesa_ok

ENDM

		DXMAIN

		DX2x2

incvesapage:
		inc		[vesapage]
;		add		[vesapage],16				; FOR CIRRUS
setvesapage:
		push	eax
		push	ebx
		push	ecx
		push	edx
		mov		edx,[vesapage]

		mov     eax,4f05h       			; set vesa vidpage
		sub		ebx,ebx
		sub		ecx,ecx
		int     10h

		pop		edx
		pop		ecx
		pop		ebx
		pop		eax
		ret

clear_linebuf_:
		push	eax
		push	ecx
		push	esi

		mov		eax,[esp+16]
		mov		edx,[esp+20]
		mov		ecx,eax
		mov		al,dl
		shl		eax,8
		mov		al,dl
		shl		eax,8
		mov		al,dl
		shl		eax,8
		mov		al,dl
		lea		esi,[linebuf]
		shr		ecx,2
cloop:
		mov		[esi],eax
		add		esi,4
		dec		ecx
		jnz		cloop

		pop		esi
		pop		ecx
		pop		eax
		ret

;clear_vesa_screen_:
;		push            edx
;		push            ecx
;		push            ebx
;		push            eax
;		push			edi
;
;		push	[vesapage]
;		mov		eax,0
;		mov		[vesapage],eax
;		call	setvesapage
;
;		mov		ebx,10					; 10 64k pages (we don't need no
;pageloop:								; stinking pages!)
;		mov		ecx,04000h				; 64K video memory X 4
;		mov		edi,0a0000h
;		sub		eax,eax
;clearloop:
;		mov		[edi],eax
;		add		edi,4
;		dec		ecx
;		jnz		clearloop				; i hate that repz stuff!
;										; I'm just not PC
;		call	incvesapage
;		dec		ebx
;		jnz		pageloop
;
;		pop		[vesapage]
;		call	setvesapage
;		pop				edi
;		pop             eax
;		pop             ebx
;		pop             ecx
;		pop             edx
;		ret

.DATA
ALIGN

width		LABEL	DWORD
			dd		0
vuwidth		LABEL	DWORD
			dd		0
pitch		LABEL	DWORD
			dd		640
height		LABEL	DWORD
			dd		0
imaddr		LABEL	DWORD
			dd		0
compaddr	LABEL	DWORD
			dd		0
lineaddr	LABEL	DWORD
			dd		0
vuaddr		LABEL	DWORD
			dd		vubuf
ycount		LABEL	DWORD
			dd		0
vesapage	LABEL	DWORD
			dd		0
END
