;/***********************************************\
;??? v_interp.ash
; contains various vertical interp related macros
;\***********************************************/ 

;************************************************
_555_MASK        EQU     07bde7bdfh
_555_SAVEBITS    EQU     04210420h

_565_MASK        EQU     0f7def7dfh
_565_SAVEBITS    EQU     08210820h


;************************************************
PIXEL_PAIR_1 MACRO _5x5_savebits, _5x5_mask           
    mov     ebx,[esi]                   ;get last line pixel pair 
    mov     eax,ebx                     ;save last line pixel pair
    mov     edx,ebx                     ;copy
    rol     eax,16
    xchg    bx,ax
    mov     [edi],eax                   ;write out stretched pixels
    mov     [edi+4],ebx

    mov     ebx,[ebp]               ;get current line pixel pair
    mov     eax,ebx                     ;save current line pixel pair
    and     ebx,edx
    and     ebx,_5x5_savebits            ;save fudge factor

    and     edx,_5x5_mask
    and     eax,_5x5_mask
    add     eax,edx
;    shr     eax,1                       ;last+current/2
    ;for 565
    rcr     eax,1                       ;last+current/2
    add     eax,ebx                     ;add in fudge factor

    mov     edx,eax                     ;eax has vinterped pixel pair
    rol     eax,16
    xchg    dx,ax
    mov     [edi+ecx],eax               ;write out vinterped stretched pixels
    mov     [edi+ecx+4],edx                 
ENDM

;************************************************
PIXEL_PAIR_2 MACRO _5x5_savebits, _5x5_mask           
    mov     ebx,[esi+4]                 ;get last line pixel pair 
    mov     eax,ebx                     ;save last line pixel pair
    mov     edx,ebx                     ;copy
    rol     eax,16
    xchg    bx,ax
    mov     [edi+8],eax                 ;write out stretched pixels
    mov     [edi+12],ebx

    mov     ebx,[ebp+4]             ;get current line pixel pair
    mov     eax,ebx                     ;save current line pixel pair
    and     ebx,edx
    and     ebx,_5x5_savebits            ;save fudge factor

    and     edx,_5x5_mask
    and     eax,_5x5_mask
    add     eax,edx
;    shr     eax,1                       ;last+current/2
    ;for 565
    rcr     eax,1                       ;last+current/2
    add     eax,ebx                     ;add in fudge factor

    mov     edx,eax                     ;eax has vinterped pixel pair
    rol     eax,16
    xchg    dx,ax
    mov     [edi+ecx+8],eax             ;write out vinterped stretched pixels
    mov     [edi+ecx+12],edx                 
ENDM

;************************************************
; (1) 16 bit pixel read from source
_1_16BIT_PIXEL_PAIR MACRO _5x5_savebits, _5x5_mask           
    mov     ebx,[esi]                   ;get last line pixel pair 
    mov     eax,ebx                     ;save last line pixel pair
    shl     ebx,16
    mov     bx,ax
    mov     [edi],ebx
    mov     ebx,[ebp]               ;get current line pixel pair
    mov     edx,ebx                     ;save current line pixel pair
    and     ebx,eax
    and     ebx,_5x5_savebits           ;save fudge factor

    and     edx,_5x5_mask
    and     eax,_5x5_mask
    add     eax,edx
;    shr     eax,1                       ;last+current/2
    ;for 565
    rcr     eax,1                       ;last+current/2
    add     eax,ebx                     ;add in fudge factor
    mov     ebx,eax
    shl     eax,16
    mov     ax,bx
    mov     [edi+ecx],eax               ;write out stretched vinterped pixel
    add     esi,2  
    add     ebp,2
    add     di,4
ENDM

;************************************************
WR_REMAINING_PIXEL_PAIRS MACRO _5x5_savebits, _5x5_mask
LOCAL wr_one_pixel, no_remaining_pixels

    cmp     DWORD PTR[esp+PIXELS_LEFT],0h         ;check for remaining pixels
    jz      no_remaining_pixels
wr_one_pixel:                                       ;occurs when page does not align with
    _1_16BIT_PIXEL_PAIR _5x5_savebits, _5x5_mask        ;4 pixel boundary
    dec     DWORD PTR[esp+PIXELS_LEFT]
    jnz     wr_one_pixel
no_remaining_pixels:        
ENDM

;************************************************
DO_SMART_LINE MACRO _5x5_savebits, _5x5_mask, destAddr_reg
LOCAL do_block, LessThanEqual32, blcopyloop, blskipcopy, black_out, block_exit
do_block:
    cmp     DWORD PTR[esp+BLKLOOPCNT],32
    jle     LessThanEqual32
    mov     DWORD PTR[esp+BLKLOOPCNT],32
LessThanEqual32:
    mov     ebx,[esp+BLKLOOPCNT]
    sub     [esp+BLKWIDTH],ebx

    mov     ebx,[esp+UBLOC] 
    mov     eax,[ebx]
    mov     [esp+UB_DATA],eax
    add     ebx,4
    mov     [esp+UBLOC],ebx             

    mov     ebx,[esp+UBLOC_LAST] 
    mov     eax,[ebx]
    mov     [esp+UB_DATA_LAST],eax
    add     ebx,4
    mov     [esp+UBLOC_LAST],ebx            
    
blcopyloop:                                     ; this copies a block, if we want to
    rcr     DWORD PTR[esp+UB_DATA],1
    setb    al
    rcr     DWORD PTR[esp+UB_DATA_LAST],1
    setb    ah
    and     al,ah
    jnz     black_out

    PIXEL_PAIR_1 _5x5_savebits, _5x5_mask
    PIXEL_PAIR_2 _5x5_savebits, _5x5_mask
;jmp blskipcopy

black_out:
;    mov DWORD PTR[edi],0
;    mov DWORD PTR[edi+4],0
;    mov DWORD PTR[edi+ecx],0
;    mov DWORD PTR[edi+ecx+4],0
;    mov DWORD PTR[edi+8],0
;    mov DWORD PTR[edi+12],0
;    mov DWORD PTR[edi+ecx+8],0
;    mov DWORD PTR[edi+ecx+12],0

blskipcopy:
    add     esi,8  
    add     ebp,8
    add     destAddr_reg,16 
    dec     DWORD PTR[esp+BLKLOOPCNT]
    jnz     blcopyloop

    cmp     DWORD PTR[esp+BLKWIDTH],0
    jle     block_exit

    mov     ebx,[esp+BLKWIDTH]              ;ready to do some more
    mov     [esp+BLKLOOPCNT],ebx

    jmp     do_block
block_exit:
ENDM

