;   Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.
;
;   This file is part of VpVision.
;
;   VpVision is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License ver. 2,
;   as published by the Free Software Foundation (www.fsf.org).
;
;   Foobar is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with VpVision; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;/***********************************************\
;??? dxi16.asm
;\***********************************************/ 
		.386
        .MODEL  flat, SYSCALL, os_dos
        .CODE
    
;11/7/96 - removing globals... (passing in structure containing parameters)
;1/2/97 - stripped out redundant code 

ifdef SILICONG

 ifdef CHROMALINE
  ifdef B2X
    PUBLIC c dxic162
  else
    PUBLIC c dxic16
  endif
 else
  ifdef B2X
    PUBLIC c dxi162
  else
    PUBLIC c dxi16
  endif
 endif

else

 ifdef CHROMALINE
  ifdef B2X
    IDEAL
	NAME dxic162
	MASM
    PUBLIC dxic162_
    PUBLIC _dxic162
  else
    IDEAL
	NAME dxic16
	MASM
    PUBLIC dxic16_
    PUBLIC _dxic16
  endif
 else
  ifdef B2X
    IDEAL
	NAME dxi162
	MASM
    PUBLIC dxi162_
    PUBLIC _dxi162
  else
    IDEAL
	NAME dxi16            
	MASM
    PUBLIC dxi16_
    PUBLIC _dxi16
 endif
 endif

endif

EXTRN c	vectbl     

;contains dxparam stucture offset equates
INCLUDE dxparam.ash
INCLUDE prologue.ash

ifndef WIN95 
	ifdef DEBUG
		INCLUDE debugger.ash
	endif
endif           

;************************************************
;; note that interframe decoder is hard-coded for a 320-wide refernce (lastdecomp) buffer
;;  we can't give that much speed away in low end machines.
HRES	equ		8

;************************************************
; MACRO DEFS (Macros people play):
;************************************************
;************************************************
GV		MACRO vec_offset		
LOCAL	more,ok,moreok,bump1,draw1,hard1
	mov			eax,[ebx+vectbl+vec_offset] ;lookup string value
	add			bx,4                    	; bump pointer
	sar			eax,1                   	; check end-of-string flag
	jnc			more                    	; jump if not
	mov			bl,[ebp]     				;get next compressed data index
	inc			ebp                 		; point to next
	and			ebx,0ffh            		;  see if 0 (clear high order)
	jnz			ok                  		; jump if not out-of-bounds
; HEY! got a bad pixel -- needs *5 fixins; start a
; new vec, add 1st pair*5 to eax, then do your regular:
	add			edx,eax						;add in the ole dVq
	mov			bl,[ebp]					;start new vec
	shl			ebx,4
	inc			ebp
	mov			eax,[ebx+vectbl+vec_offset]	;ax=big delta burke
	add			bx,4
	sar			eax,1
	jnc			moreok
	sub			ebx,ebx						;yet another end-of-vec
	mov			bl,[ebp]     				;get
	inc			ebp
	shl			ebx,4
moreok:
	add			edx,eax						;one time add
	shl			eax,2						;and 4 more
	jmp			more
ok:
	shl			ebx,4
more:
	add			edx,eax
ENDM

;************************************************
GVHV	MACRO		
	GV  0
; NOW...
    mov         eax,[esi]           	;get top pix
    add         eax,edx                 ;add vp
	mov			[edi],eax
	add			esi,4					;update pinhead
	add			edi,4					;;;	dbm -- was 4
ENDM

;************************************************

GETVECC	MACRO
	GV	4096
ENDM

;************************************************
;local var equates
BLKWIDTH		EQU		4
BLKCWCOUNT		EQU		8
UBLOC			EQU		12

ifdef SILICONG

 ifdef CHROMALINE
  ifdef B2X
    dxic162:  
  else
    dxic16:  
  endif
 else
  ifdef B2X
    dxi162:
  else
    dxi16:
  endif
 endif
 
else

 ifdef CHROMALINE
  ifdef B2X
    dxic162_:
    _dxic162:
   else
    dxic16_:
    _dxic16:
   endif
 else
  ifdef B2X
    dxi162_:
    _dxi162:
  else
    dxi16_:
    _dxi16:
  endif
 endif
 
endif

;************************************************
		DUCK_PROLOGUE

		sub		esp,12						;make room for local vars
 		push	eax							; save pointer to params structure

        mov		esi,[eax+dxLast]            ; esi=dx_last; pixel array
 		mov		edi,[eax+dxDest]       		; get dx destination

		mov		edx,[eax+dx_bloc] 
		mov		ecx,[edx]
		add 	edx,4
		mov		[esp+UBLOC],edx             ; work ubloc
                                                
   		mov		ebp,[eax+dx_vloc]			; offset, sel
		mov		ebx,[eax+dx_index]			; ebx=index into delta tbl from (1st compressed data pt * 4).

 		mov		edx,[eax+xWidth]             ; get width
		shr		edx,2
		mov		DWORD PTR[esp+BLKWIDTH],edx	; countdown in block control word

		mov		eax,edx
		xor		edx,edx						; init vp
		mov		DWORD PTR[esp+BLKCWCOUNT],eax
DXLOOP:
		cmp		eax,32
        jle		LessThan32
        mov		eax,32
		mov		DWORD PTR[esp+BLKCWCOUNT],eax
LessThan32:        
 		sub		DWORD PTR[esp+BLKWIDTH],32
X_LOOP:
		rcr	ecx,1     
		jc	IF_BLOCK

GETVEC_LOOP:
ifdef CHROMALINE
		GETVECC								; do chroma
endif
		GVHV						; do 2 pixpairs
ifdef (B2X AND CHROMALINE)
		GETVECC								; do chroma
endif
		GVHV						; do 2 pixpairs

IF_XLOOP:
		dec		DWORD PTR[esp+BLKCWCOUNT]
		jnz		X_LOOP             

		mov		eax,[esp+UBLOC]				;; get a new one block control word
		mov		ecx,[eax]
		add		eax,4
		mov		[esp+UBLOC],eax                                     
		
		mov		eax,DWORD PTR[esp+BLKWIDTH]
		mov		DWORD PTR[esp+BLKCWCOUNT],eax
        cmp		eax,0
        jle		save_vector
        jmp		DXLOOP

IF_BLOCK:
		mov		edx,[edi+HRES-4]			; vp=last pixpair in this line
		sub		edx,[esi+HRES-4]			; - pair above
		add		esi,8
		add		edi,8						;;;	dbm -- was 8
		jmp		IF_XLOOP
        
save_vector:
		; save vector regs in vars:
		pop		edx							; get start of parameters
		mov		[edx+dx_index],ebx			; save current dx_index value
		mov		[edx+dx_vloc],ebp			; save current dx_vloc value
		add		esp,12		                 
exit:
		pop		es
		pop		ds
		popad
		ret

;************************************************
		END
