/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _ducklogo_h
#define _ducklogo_h

/* Put up duck logo in lower R corner of video image.  David Silver 5/24/97 */

//#include "PixelFmt.h"

#include "dxl_main.h"

#ifdef __cplusplus
extern "C" {
#endif

/* dci == 1  indicates usual image specification, i.e.,
	dst = upper L corner;  _not_ the lowest address when pitchInBytes < 0
   dci == 0  means we are passing an upside-down DIB with
    dst = lowest address, pitchInBytes > 0  though it's actually negative. */

void duck_logo( unsigned char *dst,
					   int widthInPixels, int heightInPixels,
					   int pitchInBytes, enum BITDEPTH format,
					   int dci, enum BLITQUALITY);

enum { duckLogoHeight =29, duckLogoWidth =40};

extern unsigned char tmlogo24[1160];
extern unsigned char tmlogo555[2320];
extern unsigned char tmlogo565[2320];

#ifdef __cplusplus
}
#endif

#endif	// _ducklogo_h
