/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "tm2blit.h"

void tm2bff10(
	unsigned long *lcDest,
	unsigned long **hDest,
	PitchType scrnPitch
)
{ 	unsigned long color1;
  	unsigned long color2;
  	unsigned long temp32;
	unsigned long *dst = *hDest;
	unsigned long tempa,tempb;
	extern unsigned long gTable[256];

#define STRETCH2X(x,y,z)  \
	dst[x] = (tempa<<8) + (tempa>>16); \
	dst[y] = (tempa<<16) + (tempb>>8); \
	dst[z] = tempb + (tempb<<24);

	*hDest += 6;

  	color1 = lcDest[0];
	color2 = lcDest[1];

  	temp32 = lcDest[4];

	tempa = BYTEZERO(gTable,temp32) + color1;
	tempb = BYTEONE(gTable,temp32) + color1;

	STRETCH2X(0,1,2)

	tempa = BYTETWO(gTable,temp32) + color2;
	tempb = BYTETHREE(gTable,temp32) + color2;

	STRETCH2X(3,4,5)

	dst = (unsigned long *)((unsigned long)dst + scrnPitch);
	temp32 = lcDest[5];

	tempa = BYTEZERO(gTable,temp32) + color1;
	tempb = BYTEONE(gTable,temp32) + color1;

	STRETCH2X(0,1,2)

	tempa = BYTETWO(gTable,temp32) + color2;
	tempb = BYTETHREE(gTable,temp32) + color2;

	STRETCH2X(3,4,5)

  	color1 = lcDest[2];
	color2 = lcDest[3];

	dst = (unsigned long *)((unsigned long)dst + scrnPitch);
	temp32 = lcDest[6];
	tempa = BYTEZERO(gTable,temp32) + color1;
	tempb = BYTEONE(gTable,temp32) + color1;

	STRETCH2X(0,1,2)

	tempa = BYTETWO(gTable,temp32) + color2;
	tempb = BYTETHREE(gTable,temp32) + color2;

	STRETCH2X(3,4,5)
	
	dst = (unsigned long *)((unsigned long)dst + scrnPitch);
	temp32 = lcDest[7];
	tempa = BYTEZERO(gTable,temp32) + color1;
	tempb = BYTEONE(gTable,temp32) + color1;

	STRETCH2X(0,1,2)

	tempa = BYTETWO(gTable,temp32) + color2;
	tempb = BYTETHREE(gTable,temp32) + color2;

	STRETCH2X(3,4,5)
}

void tm2bff00(
	unsigned long *lcDest,
	unsigned long **hDest,
	PitchType scrnPitch
	)
{ 	unsigned long color1;
  	unsigned long color2;
  	unsigned long temp32;
 	unsigned long *dst = *hDest;
	unsigned long tempa,tempb;
	extern unsigned long gTable[256];

#define FOURPIX(x) \
	temp32 = x; \
  	tempa = BYTEONE(gTable,temp32) + color1; \
	dst[0] = ((BYTEZERO(gTable,temp32) + color1)<<8) + (tempa>>16); \
	tempb = BYTETWO(gTable,temp32) + color2; \
	dst[1] = (tempa << 16) + (tempb >> 8); \
	dst[2] = (BYTETHREE(gTable,temp32) + color2) + (tempb << 24);

	*hDest += 3;

  	color1 = lcDest[0];
	color2 = lcDest[1];

	FOURPIX(lcDest[4])

	dst = (unsigned long *)((unsigned long)dst + scrnPitch);
	FOURPIX(lcDest[5])

  	color1 = lcDest[2];
	color2 = lcDest[3];

	dst = (unsigned long *)((unsigned long)dst + scrnPitch);
	FOURPIX(lcDest[6])

	dst = (unsigned long *)((unsigned long)dst + scrnPitch);
	FOURPIX(lcDest[7])

}
