/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "dkpltfrm.h"
#include "dxl_main.h"
#include "ducklogo.h"
#include "tinker.h"
#include "tm2.h"
#include <stdlib.h>

typedef void ((*W95BLIT_FUNC)(void));

void x86_dxTM2Blocks(int , int, DXL_TM2X_HANDLE, char *,
        int, void *, unsigned char *, unsigned char *);

void dxTM2Blocks(DXL_TM2X_HANDLE src, DXL_VSCREEN_HANDLE vScreen)
{
    int scrnPitch = 0;
	char *scrnDest = (char *)0L;
    unsigned char *clut_1, *clut_2;
	
    if(vScreen) {
		int x,y;

		if (vScreen->bq == DXBLIT_STRETCH || vScreen->bq == DXBLIT_STRETCH_BRIGHT) 
            scrnPitch = vScreen->pitch<<1;
        else
            scrnPitch = vScreen->pitch;

		y = vScreen->viewY + src->y;           
		x = vScreen->viewX + src->x;

		scrnDest = (char *) vScreen->addr;
		scrnDest += (x * DXL_GetVScreenSizeOfPixel(vScreen)) + (y * vScreen->pitch);

        clut_1 = vScreen->clut1;
        clut_2 = vScreen->clut2;

        if (vScreen->blitSetup != (void *)-1) 
            ((W95BLIT_FUNC)vScreen->blitSetup)();

        if (vScreen->blitter == (W95BLIT_FUNC)-1)
            return; // DXL_INVALID_BLIT;
    }

    x86_dxTM2Blocks(src->imHeight/4, src->imWidth/4, src, scrnDest,
        scrnPitch, vScreen ? vScreen->blitter : 0, clut_1, clut_2);

    if(vScreen) {
        if (vScreen->blitExit != (W95BLIT_FUNC)-1) ((W95BLIT_FUNC)vScreen->blitExit)();

    if(src->compressFlags & 1)
        duck_logo(scrnDest, src->imWidth, src->imHeight, scrnPitch,
					   vScreen->bd, 1, vScreen->bq);
    }
}

