/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "dxl_main.h"
#include "proc.h"
#include "tm2blits.h"

#include <stdlib.h>
#include <string.h>

enum PROCTYPE cpuID = X86; 
enum PROCTYPE getCPUID(void);

void tm2SetBlit(void)
{
	DXL_BLIT_FORMAT temp;

    cpuID = getCPUID();

    YUVBlitInit(); 

    /* tm2 MMX block blitters are slower on pmmx -- go figuire */
    if(cpuID == PII) {
        temp = DXL_OverrideBlitter(DXBLIT_SAME,DXRGB32);
            DXL_RegisterBlitter(temp, TM2_BLOCK24, tm2bft00x, MMXsetup, MMXexit); 

        temp = DXL_OverrideBlitter(DXBLIT_SAME,DXRGB24);
            DXL_RegisterBlitter(temp, TM2_BLOCK24, tm2bff00z, MMXsetup, MMXexit); 

    } else {
        temp = DXL_OverrideBlitter(DXBLIT_SAME,DXRGB32);
            DXL_RegisterBlitter(temp, TM2_BLOCK24, tm2bft00, (blitFunc)(blitFunc)-1L, (blitFunc)(blitFunc)-1L); 

        temp = DXL_OverrideBlitter(DXBLIT_SAME,DXRGB24);
            DXL_RegisterBlitter(temp, TM2_BLOCK24, tm2bff00, (blitFunc)-1L, (blitFunc)-1L); 
    }

    temp = DXL_OverrideBlitter(DXBLIT_STRETCH,DXRGB32);
        DXL_RegisterBlitter(temp, TM2_BLOCK24, tm2bft10, (blitFunc)(blitFunc)-1L, (blitFunc)(blitFunc)-1L); 

    temp = DXL_OverrideBlitter(DXBLIT_STRETCH,DXRGB24);
        DXL_RegisterBlitter(temp, TM2_BLOCK24, tm2bff10, (blitFunc)-1L, (blitFunc)-1L); 

    temp = DXL_OverrideBlitter(DXBLIT_STRETCH_BRIGHT,DXRGB24);
        DXL_RegisterBlitter(temp, TM2_BLOCK24, tm2bff10, (blitFunc)-1L, (blitFunc)-1L); 

    /* 24 to 16 blitters */
    temp = DXL_OverrideBlitter(DXBLIT_SAME,DXRGB16);
        DXL_RegisterBlitter(temp, TM2_BLOCK24, tm2bfs00, (blitFunc)-1L, (blitFunc)-1L); 

    temp = DXL_OverrideBlitter(DXBLIT_SAME,DXRGB16_565);
        DXL_RegisterBlitter(temp, TM2_BLOCK24, tm2bfs00_565, (blitFunc)-1L, (blitFunc)-1L); 

    temp = DXL_OverrideBlitter(DXBLIT_STRETCH,DXRGB16);
        DXL_RegisterBlitter(temp, TM2_BLOCK24, tm2bfs10, (blitFunc)-1L, (blitFunc)-1L); 

    temp = DXL_OverrideBlitter(DXBLIT_STRETCH_BRIGHT,DXRGB16);
        DXL_RegisterBlitter(temp, TM2_BLOCK24, tm2bfs10, (blitFunc)-1L, (blitFunc)-1L); 

    temp = DXL_OverrideBlitter(DXBLIT_STRETCH,DXRGB16_565);
        DXL_RegisterBlitter(temp, TM2_BLOCK24, tm2bfs10_565, (blitFunc)-1L, (blitFunc)-1L); 

    temp = DXL_OverrideBlitter(DXBLIT_STRETCH_BRIGHT,DXRGB16_565);
        DXL_RegisterBlitter(temp, TM2_BLOCK24, tm2bfs10_565, (blitFunc)-1L, (blitFunc)-1L); 

		/* 24 to 8 blitters */
    temp = DXL_OverrideBlitter(DXBLIT_SAME,DXRGB8);
        DXL_RegisterBlitter(temp, TM2_BLOCK24, tm2bfe00, (blitFunc)-1L, (blitFunc)-1L); 

    temp = DXL_OverrideBlitter(DXBLIT_STRETCH,DXRGB8);
        DXL_RegisterBlitter(temp, TM2_BLOCK24, tm2bfe10, (blitFunc)-1L, (blitFunc)-1L); 

    temp = DXL_OverrideBlitter(DXBLIT_STRETCH_BRIGHT,DXRGB8);
        DXL_RegisterBlitter(temp, TM2_BLOCK24, tm2bfe10, (blitFunc)-1L, (blitFunc)-1L); 

    /* YUV blitters */
    temp = DXL_OverrideBlitter(DXBLIT_SAME,DXRGBYUY2);
        DXL_RegisterBlitter(temp, TM2_BLOCK24, blitYUY2, (blitFunc)-1L, (blitFunc)-1L); 

    temp = DXL_OverrideBlitter(DXBLIT_SAME,DXRGBYVYU);
        DXL_RegisterBlitter(temp, TM2_BLOCK24, blitYVYU, (blitFunc)-1L, (blitFunc)-1L);
}
