;   Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.
;
;   This file is part of VpVision.
;
;   VpVision is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License ver. 2,
;   as published by the Free Software Foundation (www.fsf.org).
;
;   Foobar is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with VpVision; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;/***********************************************\
;??? dxplanar.asm   
;\***********************************************/ 
 
; 6/97 - converting eric's dxplanar c routines

        .586
        .MODEL  flat, SYSCALL, os_dos
 
        .DATA 
        ALIGN 4  
  
        ZERO  dq 0      

        transformBlk LABEL DWORD  
            dd _dxHiRes
            dd _dxMedRes 
            dd _dxLowRes
            dd _dxNullRes 
            dd _dxUpdateBlock
            dd _dxStillBlock
            dd _dxMotionBlock 

        switchTable  LABEL DWORD 
            dd CASE_0
            dd CASE_1      
            dd CASE_2
            dd CASE_3 

        jmp_doBlkRows LABEL DWORD
            dd doBlkRows1

        jmp_dxBlock LABEL DWORD
            dd _dxBlock


        firstLineTemp LABEL DWORD
            dd 0
            dd 0

        secondLineTemp LABEL DWORD
            dd 0
            dd 0

        TMPPITCH    EQU 0*4    
        OFFSETSIZE  EQU 4

        _tinkPitch dd 0

        _offsetTable  LABEL DWORD 
            dd 0
            dd OFFSETSIZE         
            dd OFFSETSIZE           
            dd OFFSETSIZE

            dd 0
            dd OFFSETSIZE          
            dd OFFSETSIZE           
            dd TMPPITCH+OFFSETSIZE

            dd 0 
            dd OFFSETSIZE          
            dd TMPPITCH+OFFSETSIZE  
            dd OFFSETSIZE 

            dd 0 
            dd TMPPITCH+OFFSETSIZE 
            dd OFFSETSIZE           
            dd OFFSETSIZE

 
        mmxDebug0   dq 0
        mmxDebug1   dq 0
        mmxDebug2   dq 0

        .CODE

NAME x86dxplanar

;enums from proc.h
X86     EQU 0
PMMX    EQU 1
PPRO    EQU 2
PII     EQU 3

PUBLIC jmp_dxBlock

PUBLIC x86_dxTM2Blocks_
PUBLIC _x86_dxTM2Blocks

PUBLIC _setupOffsetTable 
PUBLIC setupOffsetTable_

; labels to block blitters
PUBLIC _dxBlock                    ;dx only
PUBLIC dxBlock_

PUBLIC _tm2bft00                    ;24 to 32 same
PUBLIC tm2bft00_

PUBLIC _tm2bft10                    ;24 to 32 stretched
PUBLIC tm2bft10_

PUBLIC _tm2bff10                    ;24 to 24 stretched
PUBLIC tm2bff10_

PUBLIC _tm2bff00                    ;24 to 24 same
PUBLIC tm2bff00_

PUBLIC _tm2bfs10                    ;24 to 16 stretched
PUBLIC tm2bfs10_

PUBLIC _tm2bfs10_565                ;24 to 16 (565) stretched
PUBLIC tm2bfs10_565_

PUBLIC _tm2bfs00                    ;24 to 16 (555) same
PUBLIC tm2bfs00_

PUBLIC _tm2bfs00_565                ;24 to 16 (565) same
PUBLIC tm2bfs00_565_

PUBLIC _tm2bft00x                   ;24 to 32 same using MMX
PUBLIC tm2bft00x_

PUBLIC _tm2bff00x                   ;24 to 24 same using MMX
PUBLIC tm2bff00x_

PUBLIC _tm2bff00z                   ;24 to 24 same for pii/ppro
PUBLIC tm2bff00z_

PUBLIC _tinkPitch
PUBLIC _offsetTable 

PUBLIC _tm2bfe00                    ;24 to 8 same
PUBLIC tm2bfe00_
 
PUBLIC _tm2bfe10                    ;24 to 8 stretch
PUBLIC tm2bfe10_
 
EXTRN doBlkRowsz:DWORD                    ;starting point for pii/ppro optimized code
EXTRN dxBlockz:DWORD                      ;pii/ppro dx only
 
INCLUDE tinker.ash 
INCLUDE tm2blit.ash
INCLUDE tm2blitx.ash
INCLUDE locvars.ash
 
EXTRN _tm2Table:DWORD
EXTRN _g16Table:DWORD 
EXTRN _cpuID:DWORD

;------------------------------------------------
; void setupOffsetTable(int blockwidth)
;
ifdef WIN95
setupOffsetTableParams    STRUC
                    dd  ?           ;return address
    blockwidth      dd  ?       
setupOffsetTableParams    ENDS
endif

_setupOffsetTable:
setupOffsetTable_:
ifdef WIN95
    mov     eax,[esp].blockwidth
    nop
endif

    shl     eax,3                       ;blockwidth*8
    nop
    
    mov     _tinkPitch,eax
    lea     eax,-12[eax*OFFSETSIZE]     ;(tinkPitch - 3)*OFFSETSIZE

	mov     _offsetTable[3*16+1*4],eax
    mov     _offsetTable[2*16+2*4],eax

    mov     _offsetTable[1*16+3*4],eax
    nop

    ret
;------------------------------------------------
_4X4LUMA_BLK_LINE MACRO ordOff, holdOff, destOff
    mov     edx,VPHOLD[_tm2Table+(holdOff*4)]             ;init vp
    mov     eax,lumaHiOffset[_tm2Table+(ebx*4)]

    mov     bl,BYTE PTR ordOff+1[esi]
    add     edx,eax                             ;add to vp

    mov     cl,BYTE PTR ordOff+2[esi]
    mov     ebp,edx                             ;init vpx

    shl     ebp,8   
    mov     eax,lumaHiOffset[_tm2Table+(ebx*4)]

    add     edx,eax                             ;add to vp
    mov     eax,lumaHiOffset[_tm2Table+(ecx*4)]

    mov     bl,BYTE PTR ordOff+3[esi]
    add     ebp,edx                             ;update vpx

    shl     ebp,8
    add     edx,eax                                 ;add to vp

    add     ebp,edx                                 ;update vpx
    mov     eax,lumaHiOffset[_tm2Table+(ebx*4)]

    shl     ebp,8
    add     edx,eax                                 ;add to vp

    add     edi,ebp                                  ;add current vpx
    mov     ebp,L_lcDest[esp]

    mov     bl,BYTE PTR ordOff+4[esi]
    add     edi,edx                                 ;add in vp

    mov     VPHOLD[_tm2Table+(holdOff*4)],edx
    mov     [ebp+(destOff*4)],edi                   ;write lumaDest 0
ENDM
;------------------------------------------------
_4X4LUMA_BLK_LINE2 MACRO ordOff, holdOff, destOff
    mov     edx,VPHOLD[_tm2Table+(holdOff*4)]             ;init vp
    mov     eax,lumaHiOffset[_tm2Table+(ebx*4)]

    mov     bl,BYTE PTR ordOff+1[esi]
    add     edx,eax                             ;add to vp

    mov     cl,BYTE PTR ordOff+2[esi]
    mov     ebp,edx                             ;init vpx

    shl     ebp,8
    mov     eax,lumaHiOffset[_tm2Table+(ebx*4)]

    add     edx,eax                             ;add to vp
    mov     eax,lumaHiOffset[_tm2Table+(ecx*4)]

    mov     bl,BYTE PTR ordOff+3[esi]
    add     ebp,edx                             ;update vpx

    shl     ebp,8
    add     edx,eax                                 ;add to vp

    add     ebp,edx                                 ;update vpx
    mov     eax,lumaHiOffset[_tm2Table+(ebx*4)]

    shl     ebp,8
    add     edx,eax                                 ;add to vp
  
    add     edi,ebp                                  ;add current vpx
    mov     ebp,L_lcDest[esp]

nop
    add     edi,edx                                 ;add in vp

    mov     VPHOLD[_tm2Table+(holdOff*4)],edx
    mov     [ebp+(destOff*4)],edi                   ;write lumaDest 0
ENDM
;------------------------------------------------
; before using HIGH_LUMA_BLOCK, the following registers must be init with:
; edi -> last4ptr[2]
; esi -> L_lumaHiTptr[esp]
; ebx -> BYTE PTR 0[esi] -- make sure upper bits are cleared
; ecx -> 0
;------------------------------------------------
HIGH_LUMA_BLOCK MACRO
    _4X4LUMA_BLK_LINE 0, 0, 4                   ;ordOff, holdOff, destOff
    _4X4LUMA_BLK_LINE 4, 1, 5                   ;ordOff, holdOff, destOff
    _4X4LUMA_BLK_LINE 8, 2, 6                   ;ordOff, holdOff, destOff
    _4X4LUMA_BLK_LINE2 12, 3, 7                  ;ordOff, holdOff, destOff

    add     ebp,8*4
    mov     ecx,L_last4ptr[esp]

    mov     L_lcDest[esp],ebp
    add     esi,16

    mov     [ecx+(2*4)],edi
    add     ecx,3*4

    mov     L_lumaHiTptr[esp],esi
    mov     esi,L_lcSource[esp]

    mov     L_last4ptr[esp],ecx
    add     esi,8*4

    mov     edx,L_blitType[esp]
    xor     ebx,ebx

    mov     L_lcSource[esp],esi
    mov     eax,L_blockInfoPtr[esp]         ;get block type function ptr

    jmp     edx
ENDM
;------------------------------------------------
LOW_CHROMA_BLOCK MACRO
LOCAL lowChroma1, lowChroma2
    mov     eax,CVPHOLD[_tm2Table+(0*4)]           
    mov     edx,CVPHOLD[_tm2Table+(1*4)]           

    add     edx,eax                                 ;init vp
    mov     ebp,L_last4ptr[esp]

    mov     eax,[edi]                               ;prime the cache
    mov     ecx,[edi+9*4]

    mov     edi,[ebp+(-2*4)]                        ;get last4ptr[-2] (last2a)
    mov     ecx,[ebp+(1*4)]                         ;(last2b)   

    sub     edi,edx
    mov     esi,L_chromaLoTptr[esp]

    add     edi,ecx                                 ;last2a += last2b
    mov     ebp,edx                                 ;save vp

    add     edi,08000h                              ;if lower word is neg, adds 1 to upper
    add     edx,08000h

    sar     edi,1                                   ;divide by 2
    mov     eax,0800h                               ;in order to pair tests

    sar     edx,1
    and     edi,0ffff3fffh                          ;mask out div 2 remainder and added bit

    test    edi,eax                                 ;if low word neg, fix sign and upper word
    jz      lowChroma1

    add     edi,0ffffc000h
    nop

lowChroma1:
    xor     ebx,ebx                                 ;ready ordinal index
    and     edx,0ffff3fffh
    
    mov     bl,BYTE PTR 0[esi]
    test    edx,eax

    jz      lowChroma2

    add     edx,0ffffc000h
    nop

lowChroma2:
    mov     eax,chromaLoOffset[_tm2Table+(ebx*4)]
nop

    mov     bl,BYTE PTR 1[esi]
    sub     ebp,edx

    shl     eax,16
    mov     CVPHOLD[_tm2Table+(1*4)],ebp

    add     edx,eax
    mov     eax,chromaLoOffset[_tm2Table+(ebx*4)]

    mov     ebp,L_lcDest[esp]
    add     edx,eax

    mov     CVPHOLD[_tm2Table+(0*4)],edx
    add     edi,edx                                 ;update last2a

    mov     [ebp+(0*4)],edi                         ;write chroma dest
    add     ecx,edx                                 ;update last2b

    add     esi,2                                   ;update chromalowptr
    mov     eax,CVPHOLD[_tm2Table+(1*4)]

    mov     [ebp+(1*4)],ecx                         ;write chroma dest
    add     edi,eax

    mov     L_chromaLoTptr[esp],esi
    mov     esi,L_lumaHiTptr[esp]
ENDM
;------------------------------------------------
MEDR_CHROMA_BLOCK MACRO
    LOW_CHROMA_BLOCK

    mov     edx,L_last4ptr[esp]
    mov     [ebp+(2*4)],edi                         ;write chroma dest

    mov     bl,BYTE PTR 0[esi]
    add     ecx,eax

    mov     [edx+(1*4)],ecx                         ;write last4ptr[1]
    mov     [edx+(0*4)],edi                         ;write last4ptr[0]

    mov     edi,[edx+(2*4)]                         ;get last4ptr[2]
    mov     [ebp+(3*4)],ecx                         ;write chroma dest

    xor     ecx,ecx
nop
ENDM

ifdef WIN95
;------------------------------------------------
x86_dxTM2BlocksParams    STRUC
                    dd  6 dup (?)   ;6 pushed regs
                    dd  ?           ;return address
    numBlkRows      dd  ?       
    numBlkCols      dd  ?       
    TM2Xptrs        dd  ?       
    vScreenAddr     dd  ?
    vScreenPitch    dd  ?
    blitType        dd  ?
    clut1           dd  ?
    clut2           dd  ?
x86_dxTM2BlocksParams    ENDS
else
;------------------------------------------------
x86_dxTM2BlocksParams    STRUC
                    dd  6 dup (?)   ;6 pushed regs
                    dd  ?           ;return address
;    numBlkRows      dd  ?       -- eax
;    numBlkCols      dd  ?       -- edx
;    TM2Xptrs        dd  ?       -- ebx
;    vScreenAddr     dd  ?       -- ecx
    vScreenPitch    dd  ?
    blitType        dd  ?
    clut1           dd  ?
    clut2           dd  ?
x86_dxTM2BlocksParams    ENDS
endif

;------------------------------------------------
x86_dxTM2Blocks_:
_x86_dxTM2Blocks:
    push    esi
    push    edi
    push    ebp
    push    ebx 
    push    ecx
    push    edx

ifdef WIN95
    mov     ebx,[esp].vScreenAddr
    mov     ecx,[esp].vScreenPitch

    mov     ebp,[esp].blitType
    nop

    mov     eax,[esp].TM2Xptrs
    mov     edx,[esp].numBlkRows

    mov     edi,[esp].numBlkCols
    mov     esi,esp                         ;save current stack ptr
else
    mov     edi,edx                         ;get numBlkCols
    mov     ebp,[esp].blitType

    mov     edx,eax                         ;get numBlkRows
    mov     eax,ebx                         ;get TM2Xptrs

    mov     ebx,ecx                         ;get vScreenAddr
    mov     ecx,[esp].vScreenPitch

    mov     esi,esp                         ;save current stack ptr
nop
endif

    and     esp,0ffffffe0h                  ;align
    inc     edx                             ;adjust blkrow count

    sub     esp,L_Vars                      ;make room for vars
    nop
  
    mov     L_vScreenAddr1[esp],ebx
    mov     L_blitType[esp],ebp

    mov     L_vScreenAddr[esp],ebx
    mov     ebp,[eax].lineBuff

    mov     L_vScreenPitch[esp],ecx
    add     ebp,3*4

    shl     ecx,2                           ;pitch * 4
    mov     ebx,[eax].chromaHi.tokenCPtr

    mov     L_vScreenPitch4[esp],ecx
    mov     ecx,[eax].chromaLo.tokenCPtr

    mov     L_blkRow[esp],edx
    mov     L_blkCol[esp],edi 

    mov     L_chromaHiTptr[esp],ebx
    mov     L_chromaLoTptr[esp],ecx

    mov     ebx,[esi].clut1                 ;get clut ptrs
    mov     ecx,[esi].clut2

    mov     L_clut1[esp],ebx                ;save in case converting 24 to 8
    mov     L_clut2[esp],ecx

    mov     L_stackptr[esp],esi
    mov     esi,L_lastLine[esp]             ;prefetch cache line

    mov     ebx,[eax].lumaHi.tokenCPtr
    mov     ecx,[eax].lumaLo.tokenCPtr

    mov     L_lumaHiTptr[esp],ebx
    mov     L_lumaLoTptr[esp],ecx

    mov     ebx,[eax].update.tokenCPtr
    mov     ecx,[eax].motion.tokenCPtr

    mov     L_updateTptr[esp],ebx
    mov     L_motionTptr[esp],ecx

    mov     edx,[eax].frontBuffer
    mov     ebx,[eax].tm2xdeltas

    add     ebx,MAXDELTAS*8*4
    nop

    mov     edi,[eax].backBuffer
    mov     L_lastLine[esp],ebp

    mov     ecx,L_vScreenPitch[esp]
    mov     L_vph[esp],ebx

    mov     L_lcSource[esp],edi
    mov     ebx,[eax].blockType.tokenPtr

    mov     L_lcDest[esp],edx
    mov     L_blockInfoPtr[esp],ebx

    lea     ecx,[ecx+ecx*2]                     ;pitch * 3
    xor     ebx,ebx

    mov     L_vScreenPitch3[esp],ecx  
    mov     eax,[_cpuID] 

    cmp     eax,PMMX                            ;check uproc type
    jle     startDX     

    lea     edx,doBlkRowsz
    lea     eax,dxBlockz   

    mov     [jmp_doBlkRows],edx                 ;override dx starting point
    mov     [jmp_dxBlock],eax                   ;to use the pii/ppro optimized version

    cmp     DWORD PTR L_blitType[esp],0
    jne     piiDX

    mov     L_blitType[esp],eax                 ;pii/ppro optimized version of dx only

piiDX:
    jmp     [jmp_doBlkRows]

startDX:
    cmp     DWORD PTR L_blitType[esp],0
    jne     startDX2

    lea     ecx,_dxBlock

    mov     L_blitType[esp],ecx                 ;blit type is dx only

startDX2:
    jmp     [jmp_doBlkRows]

doBlkRows:
    mov     edx,L_vScreenAddr1[esp]
    mov     ebp,L_vScreenPitch4[esp]

    add     edx,ebp
    nop

    mov     L_vScreenAddr1[esp],edx
    mov     L_vScreenAddr[esp],edx

doBlkRows1:
    mov     eax,L_vph[esp]                  ;reset the VP's
    mov     edx,L_blkCol[esp]

    mov     ecx,L_lastLine[esp]             ;restart the last line
    mov     L_i[esp],edx

    mov     edx,0[eax]                      ;prefetch to prevent write stalls
    xor     ebx,ebx

    mov     L_last4ptr[esp],ecx
    mov     ecx,L_blkRow[esp]

    mov     0h[eax],ebx
    mov     4h[eax],ebx

    mov     8h[eax],ebx 
    mov     0ch[eax],ebx

    mov     10h[eax],ebx
    mov     14h[eax],ebx

    mov     eax,L_blockInfoPtr[esp]         ;get block type function ptr
    dec     ecx

    mov     L_blkRow[esp],ecx
    jnz     doNextBlk
      
    jmp     theExit

_dxBlock:   
dxBlock_:    
    mov     ecx,L_i[esp]   
nop

    dec     ecx     
    jz      doBlkRows

    mov     L_i[esp],ecx
    xor     ebx,ebx  

doNextBlk:
    mov     bl,BYTE PTR[eax]
    inc     eax

    mov     L_blockInfoPtr[esp],eax
    mov     edi,L_lcDest[esp]

    jmp     transformBlk[ebx*4]

theExit:
    mov     eax,L_stackptr[esp]
    mov     esp,eax

    pop     edx
    pop     ecx
    pop     ebx
    pop     ebp
    pop     edi
    pop     esi
    ret
;------------------------------------------------
dxHiRes_:
_dxHiRes:
    mov     esi,L_chromaHiTptr[esp]
    xor     ecx,ecx                                 ;clear upper -- cl = ordinal index

    mov     ebp,L_last4ptr[esp]
    xor     ebx,ebx                                 ;clear upper -- bl = ordinal index

    mov     cl,BYTE PTR 0[esi]                      
    nop  

    mov     eax,[edi]                               ;prime the cache
    mov     edx,[edi+9*4]

    mov     bl,BYTE PTR 1[esi]
    mov     eax,chromaHiOffset[_tm2Table+(ecx*4)]

    shl     eax,16
    mov     edx,CVPHOLD[_tm2Table+(0*4)]            ;init vp

    add     edx,eax
    mov     eax,chromaHiOffset[_tm2Table+(ebx*4)]

    add     edx,eax                                 ;update vp
    mov     eax,[ebp+(0*4)]

    mov     bl,BYTE PTR 2[esi]
    add     eax,edx

    mov     [ebp+(0*4)],eax                         ;last2a
    mov     [edi+(0*4)],eax                         ;write to chroma dest

    mov     cl,BYTE PTR 3[esi]
    mov     eax,chromaHiOffset[_tm2Table+(ebx*4)]

    shl     eax,16 
    mov     ebx,[ebp+(1*4)]
       
    add     edx,eax
    mov     eax,chromaHiOffset[_tm2Table+(ecx*4)]
   
    mov     cl,BYTE PTR 4[esi]
    add     edx,eax
   
    mov     CVPHOLD[_tm2Table+(0*4)],edx
    add     ebx,edx

    nop
    mov     [ebp+(1*4)],ebx                         ;last2b

    mov     [edi+(1*4)],ebx                         ;write to chroma dest
    xor     ebx,ebx
;------------------------------------------------
    mov     bl,BYTE PTR 5[esi]
    mov     eax,chromaHiOffset[_tm2Table+(ecx*4)]

    shl     eax,16
    mov     edx,CVPHOLD[_tm2Table+(1*4)]            ;init vp

    add     edx,eax
    mov     eax,chromaHiOffset[_tm2Table+(ebx*4)]

    add     edx,eax                                 ;update vp
    mov     eax,[ebp+(0*4)]

    mov     bl,BYTE PTR 6[esi] 
    add     eax,edx

    mov     [ebp+(0*4)],eax                         ;last2a
    mov     [edi+(2*4)],eax                         ;write to chroma dest

    mov     cl,BYTE PTR 7[esi]
    mov     eax,chromaHiOffset[_tm2Table+(ebx*4)]

    shl     eax,16
    add     esi,8

    mov     L_chromaHiTptr[esp],esi
    mov     esi,L_lumaHiTptr[esp]                   ;ready for luma
       
    add     edx,eax
    mov     eax,chromaHiOffset[_tm2Table+(ecx*4)]
   
    add     edx,eax
    mov     eax,[ebp+(1*4)]
   
    mov     CVPHOLD[_tm2Table+(1*4)],edx
    add     eax,edx

    mov     bl,BYTE PTR 0[esi]                      
    mov     [edi+(3*4)],eax                     ;write to chroma dest

    mov     [ebp+(1*4)],eax                         ;last2b
    mov     edi,[ebp+(2*4)]

    HIGH_LUMA_BLOCK
;------------------------------------------------
; end of _dxHiRes
;------------------------------------------------
dxMedRes_:
_dxMedRes:
    MEDR_CHROMA_BLOCK 
    HIGH_LUMA_BLOCK
;------------------------------------------------
; end of _dxMedRes
;------------------------------------------------
; edi = vp, edx = last4, ebp = vpx
dxLowRes_:
_dxLowRes:
    LOW_CHROMA_BLOCK 

    mov     esi,L_last4ptr[esp]
    mov     [ebp+(2*4)],edi                         ;write chroma dest

    add     ecx,eax
    mov     edx,[esi+(2*4)]                         ;get last4ptr[2] -- aka last4

    mov     [esi+(0*4)],edi                         ;write last4ptr[0]
    mov     [esi+(1*4)],ecx                         ;write last4ptr[1]

    mov     eax,VPHOLD[_tm2Table+(1*4)]
    mov     edi,VPHOLD[_tm2Table+(0*4)]

    mov     [ebp+(3*4)],ecx                         ;write chroma dest
    add     edi,eax                                 ;init vp

    mov     eax,VPHOLD[_tm2Table+(2*4)]
    mov     ecx,VPHOLD[_tm2Table+(3*4)]

    mov     bl,BYTE PTR [esi+(-1*4)]              
    add     eax,ecx                                 ;vphold 2+3

    add     eax,edi                                 ;add in vp
    mov     ecx,edx                                 ;start calculating vpx

    sar     ecx,16
    sub     ebx,eax                                 ;lastPix

    and     ecx,0ffh
    and     ebx,0ffh

    mov     ebp,ecx                                 ;save byte 2 of last4
    add     ecx,ebx

    sar     ecx,1
    and     edx,00ff00ffh                           ;clear out interp bytes

    shl     ecx,24
    mov     esi,L_lumaLoTptr[esp]

    or      edx,ecx                                 ;interped luma in upper byte
    xor     ecx,ecx

    mov     cl,dl
    mov     eax,edi

    sar     eax,1                                   ;vpHalf
    add     ecx,ebp

    sar     ecx,1
    xor     ebx,ebx

    mov     bl,BYTE PTR 0[esi]
    or      dh,cl
    
    sub     edi,eax                                 ;vp-(vp>>1)
nop

    mov     ecx,edi
    mov     VPHOLD[_tm2Table+(1*4)],edi             ;vp1 = vpTotal - vpHalf

    mov     edi,eax                                 ;vp = vpHalf
    mov     eax,lumaLoOffset[_tm2Table+(ebx*4)]

    mov     bl,BYTE PTR 1[esi]
    add     edi,eax                                 ;add to vp

    mov     ebp,edi                                 ;init vpx
    mov     esi,ecx                                 

    shl     ebp,8
    mov     eax,lumaLoOffset[_tm2Table+(ebx*4)]

    shl     ecx,8
    add     ebp,edi

    shl     ebp,8
    add     edi,eax

    add     ecx,esi
    add     ebp,edi

    shl     ebp,8
    mov     eax,L_lcDest[esp]

    shl     ecx,8
    add     ebp,edi

    add     ecx,esi
    add     edx,ebp                                 ;update last4

    shl     ecx,8
    mov     VPHOLD[_tm2Table+(0*4)],edi
    
    add     ecx,esi                                 ;vphold[0] * 01010101h
    mov     esi,L_lumaLoTptr[esp]

    mov     [eax+(4*4)],edx
    add     edx,ecx

    mov     bl,BYTE PTR 2[esi]
    mov     [eax+(5*4)],edx

    mov     eax,VPHOLD[_tm2Table+(2*4)]
    mov     ecx,VPHOLD[_tm2Table+(3*4)]

    add     ecx,eax
    mov     ebp,lumaLoOffset[_tm2Table+(ebx*4)]

    mov     bl,BYTE PTR 3[esi]
    mov     edi,ecx

    sar     edi,1                                   ;init vp
nop    

    sub     ecx,edi
    add     edi,ebp

    mov     VPHOLD[_tm2Table+(3*4)],ecx
    mov     ebp,edi                                 ;init vpx

    shl     ebp,8
    mov     eax,lumaLoOffset[_tm2Table+(ebx*4)]

    add     ebp,edi
    add     edi,eax                                 ;update vp

    shl     ebp,8
    mov     esi,ecx

    shl     ecx,8
    add     ebp,edi

    shl     ebp,8
    add     ecx,esi

    shl     ecx,8
    add     ebp,edi

    add     ecx,esi
    add     edx,ebp

    shl     ecx,8
    mov     eax,L_lcDest[esp]

    add     ecx,esi                             ;vphold[3] * 01010101h
    mov     VPHOLD[_tm2Table+(2*4)],edi

    mov     [eax+(6*4)],edx
    add     edx,ecx

    mov     [eax+(7*4)],edx
    add     eax,8*4

    mov     ebp,L_last4ptr[esp]
    mov     L_lcDest[esp],eax

    mov     esi,L_lumaLoTptr[esp]
    mov     [ebp+(2*4)],edx

    add     esi,4
    add     ebp,3*4

    mov     L_lumaLoTptr[esp],esi
    mov     esi,L_lcSource[esp]

    add     esi,8*4
    mov     L_last4ptr[esp],ebp

    xor     ebx,ebx
    mov     edx,L_blitType[esp]

    mov     ecx,L_i[esp]
    mov     L_lcSource[esp],esi

    mov     eax,L_blockInfoPtr[esp]         ;get block type function ptr

;    jmp     blitJmpTable[edx*4]

jmp edx

;------------------------------------------------
; end of _dxLowRes
;------------------------------------------------
dxNullRes_:
_dxNullRes:
    mov     eax,CVPHOLD[_tm2Table+(0*4)]           
    mov     edx,CVPHOLD[_tm2Table+(1*4)]           

    add     edx,eax                                 ;init vp
    mov     ebp,L_last4ptr[esp]

    mov     eax,[edi]                               ;prime the cache
    mov     ecx,[edi+9*4]

    mov     edi,[ebp+(-2*4)]                        ;get last4ptr[-2] (last2a)
    mov     ecx,[ebp+(1*4)]                         ;(last2b)   

    sub     edi,edx
    xor     ebx,ebx

    add     edi,ecx                                 ;last2a += last2b
    mov     ebp,edx                                 ;save vp

    add     edi,08000h                              ;if lower word is neg, adds 1 to upper
    add     edx,08000h

    sar     edi,1                                   ;divide by 2
    mov     eax,0800h                               ;in order to pair tests

    sar     edx,1
    and     edi,0ffff3fffh                          ;mask out div 2 remainder and added bit

    test    edi,eax                                 ;if low word neg, fix sign and upper word
    jz      nullChroma1

    add     edi,0ffffc000h
    nop

nullChroma1:
    and     edx,0ffff3fffh
nop
    
    test    edx,eax
    jz      nullChroma2

    add     edx,0ffffc000h
    nop

nullChroma2:
    sub     ebp,edx
    mov     esi,L_lcDest[esp]

    mov     CVPHOLD[_tm2Table+(0*4)],edx
    mov     CVPHOLD[_tm2Table+(1*4)],ebp

    add     edi,edx                                 ;update last2a
    mov     eax,ebp

    mov     [esi+(0*4)],edi                         ;write chroma dest
    add     ecx,edx                                 ;update last2b

    add     edi,eax
    mov     ebp,L_last4ptr[esp]

    mov     [esi+(1*4)],ecx                         ;write chroma dest
    mov     [esi+(2*4)],edi                         ;write chroma dest

    add     ecx,eax
    mov     edx,VPHOLD[_tm2Table+(1*4)]

    mov     [ebp+(0*4)],edi                         ;write last4ptr[0]
    mov     [ebp+(1*4)],ecx                         ;write last4ptr[1]

    mov     bl,BYTE PTR [ebp+(2*4)]                 ;get last4ptr[2] -- aka rightPix
    mov     edi,VPHOLD[_tm2Table+(0*4)]
;-----
    mov     [esi+(3*4)],ecx                         ;write chroma dest
    add     edi,edx

    mov     eax,VPHOLD[_tm2Table+(2*4)]
    mov     ecx,[ebp+(-1*4)]                        ;get last4ptr[-1] -- aka leftPix

    add     edi,eax
    mov     eax,VPHOLD[_tm2Table+(3*4)]

    add     edi,eax                                 ;init vpt
    mov     eax,ebx                                 ;ready to find diff

    sub     ecx,edi                                 ;init leftPix
    mov     edx,L_lcSource[esp]

    and     ecx,0ffh
    add     edx,8*4

    sub     eax,ecx                                 ;init diff
    mov     L_lcSource[esp],edx

    sar     eax,1                                   ;diff>>1
    mov     edx,edi                                 ;work vpt

    sar     edx,2                                   ;qvpt = vpt>>2
nop 

    mov     esi,edx                                 ;starting to calc qvpt * 01010101h
    mov     ebp,ebx                                 ;save right pix

    shl     esi,8
    mov     ebx,ecx                                 ;work leftPix

    add     ebx,eax
    add     esi,edx

    sar     eax,1                                   ;diff>>2
    mov     VPHOLD[_tm2Table+(3*4)],edx

    shl     esi,8
    add     ecx,eax

    mov     bh,cl
    add     esi,edx

    shl     esi,8
    mov     ecx,ebp                                 ;get rightPix

    shl     ebx,16
    add     esi,edx                                 ;qvpt * 01010101h

    or      ebx,ecx
    sub     ecx,eax

    mov     eax,edi                                 ;temp vpt
    mov     bh,cl                                   ;init last4

    sar     eax,1
    mov     VPHOLD[_tm2Table+(0*4)],edx

    mov     ecx,eax                                 ;save hvpt
    sub     eax,edx                                 ;hvpt-qvpt

    mov     VPHOLD[_tm2Table+(1*4)],eax
    sub     edi,edx                                 ;vpt-qvpt

    sub     edi,ecx                                 ;vpt-qvpt-hvpt
    mov     ecx,eax                                 ;start vphold[1] * 01010101h

    shl     eax,8
    mov     ebp,edi                                 ;start vphold[2] * 01010101h

    shl     ebp,8
    add     eax,ecx

    shl     eax,8
    add     ebp,edi

    shl     ebp,8
    add     eax,ecx

    shl     eax,8
    add     ebp,edi

    shl     ebp,8
    add     eax,ecx                                 ;vphold[1] * 01010101h

    mov     ecx,L_lcDest[esp]
    add     ebp,edi                                 ;vphold[2] * 01010101h

    mov     VPHOLD[_tm2Table+(2*4)],edi
    add     ebx,esi

    mov     [ecx+(4*4)],ebx    
    add     ebx,eax

    mov     [ecx+(5*4)],ebx    
    add     ebx,ebp

    mov     [ecx+(6*4)],ebx    
    add     ebx,esi

    mov     [ecx+(7*4)],ebx    
    mov     ebp,L_last4ptr[esp]

    add     ecx,8*4
    add     ebp,3*4

    mov     L_lcDest[esp],ecx
    mov     ecx,L_i[esp]

    mov     [ebp+(-1*4)],ebx                ;last4ptr[2]
    xor     ebx,ebx

    mov     edx,L_blitType[esp]
nop

    mov     L_last4ptr[esp],ebp
    mov     eax,L_blockInfoPtr[esp]         ;get block type function ptr

;    jmp     blitJmpTable[edx*4]
jmp edx

;------------------------------------------------
; end of _dxNullRes
;------------------------------------------------
UPDATE_LUMA MACRO ordOff, destOff, srcOff, holdOff
    shl     edx,8
    mov     eax,updateOffset[_tm2Table+(ebx*4)]

    mov     cl,BYTE PTR ordOff[esi]
    add     edx,eax

    mov     bl,BYTE PTR ordOff+1[esi]
nop

    shl     edx,8
    mov     eax,updateOffset[_tm2Table+(ecx*4)]

    add     edx,eax
    mov     eax,updateOffset[_tm2Table+(ebx*4)]

    shl     edx,8
nop

    add     edx,eax    
    mov     eax,[ebp+(srcOff*4)]

    mov     bl,BYTE PTR L_last4[esp]
    add     edx,eax

    mov     cl,BYTE PTR ordOff+2[esi]
    mov     eax,edx

    and     eax,0ffh
nop

    sub     eax,ebx
    mov     L_last4[esp],edx                            ;save vp

    mov     bl,BYTE PTR ordOff+3[esi]
    mov     [edi+(destOff*4)],edx

    mov     VPHOLD[_tm2Table+(holdOff*4)],eax
    mov     edx,updateOffset[_tm2Table+(ecx*4)]
ENDM
;------------------------------------------------
UPDATE_LUMA2 MACRO ordOff, destOff, srcOff, holdOff
    shl     edx,8
    mov     eax,updateOffset[_tm2Table+(ebx*4)]

    mov     cl,BYTE PTR ordOff[esi]
    add     edx,eax

    mov     bl,BYTE PTR ordOff+1[esi]
nop

    shl     edx,8
    mov     eax,updateOffset[_tm2Table+(ecx*4)]

    add     edx,eax
    mov     eax,updateOffset[_tm2Table+(ebx*4)]

    shl     edx,8
nop

    add     edx,eax    
    mov     eax,[ebp+(srcOff*4)]

    mov     bl,BYTE PTR L_last4[esp]
    add     edx,eax

    mov     eax,edx
    add     ebp,8*4

    mov     L_lcSource[esp],ebp
    mov     ebp,L_last4ptr[esp]

    and     eax,0ffh
nop

    sub     eax,ebx
    mov     [edi+(destOff*4)],edx

    add     esi,24
    mov     [ebp+(2*4)],edx
 
    mov     VPHOLD[_tm2Table+(holdOff*4)],eax
    add     edi,8*4

    add     ebp,3*4
    mov     L_lcDest[esp],edi

    mov     edx,L_blitType[esp]
    xor     ebx,ebx

    mov     ecx,L_i[esp]
    mov     L_last4ptr[esp],ebp

    mov     L_updateTptr[esp],esi
    mov     eax,L_blockInfoPtr[esp]         ;get block type function ptr

;    jmp     blitJmpTable[edx*4]
jmp edx

ENDM
;------------------------------------------------
dxUpdateBlock_:
_dxUpdateBlock:
    mov     esi,L_updateTptr[esp]
    xor     ebx,ebx                                 ;clear upper -- bl = ordinal index

    mov     ebp,L_lcSource[esp]
    xor     ecx,ecx

    mov     cl,BYTE PTR 0[esi]                      
    mov     eax,[edi]                               ;prime the cache

    mov     bl,BYTE PTR 1[esi]
    mov     edx,[edi+9*4]                           ;prime the cache

    mov     edx,updateOffset[_tm2Table+(ecx*4)]
nop

    shl     edx,16
    mov     eax,updateOffset[_tm2Table+(ebx*4)]

    mov     cl,BYTE PTR 2[esi]                      
    add     edx,eax

    mov     bl,BYTE PTR 3[esi]                      
    mov     eax,[ebp+(0*4)]                             ;get source

    add     eax,edx
    mov     edx,updateOffset[_tm2Table+(ecx*4)]

    shl     edx,16
    mov     [edi+(0*4)],eax

    mov     cl,BYTE PTR 4[esi]                      
    mov     eax,updateOffset[_tm2Table+(ebx*4)]

    add     edx,eax
    mov     eax,[ebp+(1*4)]

    mov     bl,BYTE PTR 5[esi]                      
    mov     ebp,L_last4ptr[esp]

    add     edx,eax
    mov     eax,[ebp+(1*4)]                             ;last4ptr[1]

    mov     [edi+(1*4)],edx                             ;write dest
    mov     L_last4[esp],edx

    sub     edx,eax
    mov     ebp,L_lcSource[esp]

    mov     CVPHOLD[_tm2Table+(0*4)],edx
    mov     edx,updateOffset[_tm2Table+(ecx*4)]

    shl     edx,16
    mov     eax,updateOffset[_tm2Table+(ebx*4)]

    mov     cl,BYTE PTR 6[esi]                      
    add     edx,eax

    mov     bl,BYTE PTR 7[esi]                      
    mov     eax,[ebp+(2*4)]

    add     eax,edx
    mov     ebp,L_last4ptr[esp]

    mov     edx,updateOffset[_tm2Table+(ecx*4)]
    mov     ecx,updateOffset[_tm2Table+(ebx*4)]
    
    shl     edx,16
    mov     ebx,L_lcSource[esp]

    add     edx,ecx
    mov     [ebp+(0*4)],eax

    mov     [edi+(2*4)],eax
    mov     eax,[ebx+(3*4)]

    add     edx,eax
    mov     eax,L_last4[esp]

    mov     [edi+(3*4)],edx
    mov     [ebp+(1*4)],edx

    sub     edx,eax
    mov     eax,[ebp+(2*4)]

    mov     cl,BYTE PTR 8[esi]                      
    mov     CVPHOLD[_tm2Table+(1*4)],edx

    xor     ebx,ebx
    and     ecx,0ffh                                ;clear out upper bits

    mov     bl,BYTE PTR 9[esi]                      
    mov     L_last4[esp],eax
;------------------------------------------------
; end of chroma, start of luma
;------------------------------------------------
    mov     edx,updateOffset[_tm2Table+(ecx*4)]
    mov     ebp,L_lcSource[esp]

    UPDATE_LUMA 10, 4, 4, 0
    UPDATE_LUMA 14, 5, 5, 1
    UPDATE_LUMA 18, 6, 6, 2
    UPDATE_LUMA2 22, 7, 7, 3
;------------------------------------------------
; end of _dxUpdateBlock
;------------------------------------------------
dxStillBlock_:
_dxStillBlock:
    mov     bl,BYTE PTR[eax]
    mov     eax,[edi]                               ;prime the cache

    mov     esi,L_lcSource[esp]
    mov     ebp,L_last4ptr[esp]

    cmp     ebx,4
    jl      sb_calcVPs
if 1

nop
    mov     ebx,[ebp+(0*4)]

    mov     eax,[esi+(0*4)] 
    mov     ebx,[esi+(1*4)]

    mov     ecx,[esi+(2*4)] 
    mov     edx,[esi+(3*4)]

    mov     [edi+(0*4)],eax                         ;dst[0]=src[0]
    mov     [edi+(1*4)],ebx                         ;dst[1]=src[1]

    mov     [edi+(2*4)],ecx                         ;dst[2]=src[2]
    mov     [edi+(3*4)],edx                         ;dst[3]=src[3]

    mov     [ebp+(0*4)],ecx                         ;last4ptr[0]=src[2]
    mov     [ebp+(1*4)],edx                         ;last4ptr[1]=src[3]

    mov     eax,[esi+(4*4)] 
    mov     ebx,[esi+(5*4)]

    mov     ecx,[esi+(6*4)] 
    mov     edx,[esi+(7*4)]

    mov     [edi+(4*4)],eax                         ;dst[4]=src[4]
    mov     [edi+(5*4)],ebx                         ;dst[5]=src[5]

    mov     [edi+(6*4)],ecx                         ;dst[6]=src[6]
    mov     [edi+(7*4)],edx                         ;dst[7]=src[7]

    mov     [ebp+(2*4)],edx                         ;last4ptr[2]=src[7]
nop

    mov     ecx,L_i[esp]
    jmp     stillBlockDone

else
    mov     ebx,[ebp+(0*4)]                         ;prime cache
nop

    movq    mm0,[esi+(0*4)] 

    movq    mm1,[esi+(2*4)] 

    movq    mm2,[esi+(4*4)] 

    movq    mm3,[esi+(6*4)] 

    movq    [edi+(0*4)],mm0                         ;dst 0,1 = src 0,1

    movq    [edi+(2*4)],mm1                         ;dst 2,3 = src 2,3

    movq    [edi+(4*4)],mm2                         ;dst 4,5 = src 4,5

    movq    [edi+(6*4)],mm3                         ;dst 6,7 = src 6,7

    movq    [ebp+(0*4)],mm1                         ;last4ptr 0,1 = src 2,3
    psrlq   mm3,32                                  ;ready src[7] for move

    movd    [ebp+(2*4)],mm3                         ;last4ptr[2]=src[7]
    
    mov     ecx,L_i[esp]
    jmp     stillBlockDone
endif

sb_calcVPs:
    mov     eax,CVPHOLD[_tm2Table+(0*4)]            ;prime
    xor     edx,edx

    mov     dl,BYTE PTR[ebp+(2*4)]
    mov     ecx,[ebp+(1*4)]                         ;get last4ptrs

    mov     eax,[esi+(1*4)]                         ;get src
    mov     ebx,[esi+(3*4)]

    mov     [ebp+(1*4)],ebx                         ;last4ptr[1]=src[3]
    mov     [edi+(3*4)],ebx                         ;dst[3]=src[3]

    sub     ebx,eax                                 ;src[3]-src[1]
    mov     [edi+(1*4)],eax                         ;dst[1]=src[1]

    sub     eax,ecx                                 ;src[1]-last4ptr[1]
    mov     CVPHOLD[_tm2Table+(1*4)],ebx
    
    mov     ecx,[esi+(0*4)]                         ;get src
    mov     ebx,[esi+(2*4)]

    mov     [edi+(0*4)],ecx                         ;dst[0]=src[0]
    mov     [edi+(2*4)],ebx                         ;dst[2]=src[2]

    mov     CVPHOLD[_tm2Table+(0*4)],eax
    mov     [ebp+(0*4)],ebx                         ;last4ptr[0]=src[2]

    mov     ecx,[esi+(7*4)]                         ;get src
    mov     ebx,[esi+(6*4)]

    mov     [edi+(6*4)],ebx                         ;dst[6]=src[6]
    mov     [edi+(7*4)],ecx                         ;dst[7]=src[7]

    mov     [ebp+(2*4)],ecx                         ;last4ptr[2]=src[7]
    and     ebx,0ffh                                ;byte 6

    mov     eax,[esi+(5*4)]                         ;get src
    and     ecx,0ffh                                ;byte 7

    sub     ecx,ebx                                 ;7-6
    mov     [edi+(5*4)],eax                         ;dst[5]=src[5]

    mov     VPHOLD[_tm2Table+(3*4)],ecx
    and     eax,0ffh                                ;byte 5

    sub     ebx,eax                                 ;6-5
    mov     ecx,[esi+(4*4)]                         ;get src

    mov     [edi+(4*4)],ecx                         ;dst[4]=src[4]
    and     ecx,0ffh                                ;byte 4

    sub     eax,ecx                                 ;5-4
    mov     VPHOLD[_tm2Table+(2*4)],ebx

    mov     VPHOLD[_tm2Table+(1*4)],eax
    sub     ecx,edx                                 ;4-last4ptr

    mov     VPHOLD[_tm2Table+(0*4)],ecx
    mov     ecx,L_i[esp]

stillBlockDone:
    add     esi,8*4
    add     edi,8*4

    mov     L_lcSource[esp],esi
    mov     L_lcDest[esp],edi

    add     ebp,3*4
    mov     edx,L_blitType[esp]

    xor     ebx,ebx
    mov     L_last4ptr[esp],ebp

    mov     eax,L_blockInfoPtr[esp]         ;get block type function ptr

;    jmp     blitJmpTable[edx*4]
jmp edx
;------------------------------------------------
; end of _dxStillBlock
;------------------------------------------------
MBLOCK_DONE MACRO
    add     edi,8*4
    mov     edx,L_blitType[esp]

    add     ebp,3*4
    mov     L_lcDest[esp],edi

    xor     ebx,ebx
    mov     L_last4ptr[esp],ebp

    mov     eax,L_blockInfoPtr[esp]         ;get block type function ptr

;    jmp     blitJmpTable[edx*4]
jmp edx

ENDM
;------------------------------------------------
MOTION_DEST MACRO shLeft, shRight
    mov     eax,[ebp+(0*4)]
    mov     edx,[ebp+(1*4)]

    add     esi,eax
    mov     ecx,L_lcSource[esp]
;nop

    add     ecx,8*4
    mov     eax,[esi+(8*4)]

    and     ebx,0ffh                                ;only interested in low byte
    mov     L_lcSource[esp],ecx

    shr     eax,shRight
    mov     ecx,[esi]

    shl     ecx,shLeft
    add     esi,edx

    mov     edx,[ebp+(2*4)]
    or      eax,ecx

    mov     [edi+(4*4)],eax
    and     eax,0ffh

    sub     eax,ebx                                     ;4-last4ptr
    mov     ebx,[esi+(8*4)]

    shr     ebx,shRight
    mov     ecx,[esi]

    mov     VPHOLD[_tm2Table+(0*4)],eax
    add     esi,edx

    shl     ecx,shLeft
    mov     edx,[ebp+(3*4)]

    or      ebx,ecx
    mov     eax,[edi+(4*4)]

    mov     [edi+(5*4)],ebx
    and     ebx,0ffh

    and     eax,0ffh
    mov     ecx,[esi+(8*4)]

    shr     ecx,shRight
    sub     ebx,eax                                     ;5-4
    
    mov     eax,[esi]
    add     esi,edx

    shl     eax,shLeft
    mov     VPHOLD[_tm2Table+(1*4)],ebx

    or      ecx,eax
    mov     eax,[edi+(5*4)]

    mov     [edi+(6*4)],ecx
    and     ecx,0ffh

    and     eax,0ffh
    mov     ebx,[esi+(8*4)]

    sub     ecx,eax                                     ;6-5
    mov     eax,[esi]

    shr     ebx,shRight
    mov     VPHOLD[_tm2Table+(2*4)],ecx

    shl     eax,shLeft
    mov     ebp,L_last4ptr[esp] 

    mov     edx,[edi+(6*4)]
    or      ebx,eax

    and     edx,0ffh
    mov     [edi+(7*4)],ebx

    mov     [ebp+(2*4)],ebx
    and     ebx,0ffh

    sub     ebx,edx
nop

    mov     VPHOLD[_tm2Table+(3*4)],ebx
    jmp      motionBlockDone
ENDM
;------------------------------------------------
dxMotionBlock_:
_dxMotionBlock:
    mov     ebp,L_motionTptr[esp]
    mov     esi,L_lcSource[esp]

    xor     ecx,ecx
    mov     eax,CVPHOLD[_tm2Table+(0*4)]            ;prime the cache

    mov     bl,BYTE PTR 1[ebp]
    mov     eax,_tinkPitch

    mov     cl,BYTE PTR 0[ebp]
    add     ebp,2

    mov     edx,motionOffset[_tm2Table+(ebx*4)]
    mov     ecx,motionOffset[_tm2Table+(ecx*4)]

    mov     L_yoff[esp],edx
    and     edx,0fffffffch

;    test    edx,edx
    jz      dontMult

    imul    edx                                     ;tinkPitch * (yoff>>2) -- 10 cycles 

    add     esi,eax
nop

dontMult:
    mov     L_xoff[esp],ecx
    mov     edx,L_yoff[esp]

    mov     L_motionTptr[esp],ebp
;nop
    mov     eax,[edi]                               ;prime the cache

    and     ecx,0fffffffch
    and     edx,03h

    shl     ecx,3 
    mov     eax,2                                   ;used to make tests pairable

    mov     L_yoff[esp],edx
    add     esi,ecx                                 ;src += (xoff>>2) * 8

    test    edx,eax
    mov     ecx,L_xoff[esp]

    mov     ebp,_tinkPitch
    jz      wrDest2

wrDest1:
    test    ecx,eax
    jz      wrDest1a

    mov     eax,[esi+(3*4)]
    mov     ebx,[esi+(10*4)]

    mov     [edi+(0*4)],eax
    mov     [edi+(1*4)],ebx

    mov     eax,4[esi+ebp*4]
    mov     ebx,32[esi+ebp*4]

    mov     [edi+(2*4)],eax
    mov     [edi+(3*4)],ebx

    mov     ebp,L_last4ptr[esp]
    jmp     L1

wrDest1a:
    mov     eax,[esi+(2*4)]
    mov     ebx,[esi+(3*4)]

    mov     [edi+(0*4)],eax
    mov     [edi+(1*4)],ebx

    mov     eax,[esi+ebp*4]
    mov     ebx,4[esi+ebp*4]

    mov     [edi+(2*4)],eax
    mov     [edi+(3*4)],ebx

    mov     ebp,L_last4ptr[esp]
    jmp     L1

wrDest2:
    test    ecx,eax
    jz      wrDest2a

    mov     eax,[esi+(1*4)]
    mov     ebx,[esi+(8*4)]

    mov     [edi+(0*4)],eax
    mov     [edi+(1*4)],ebx

    mov     eax,[esi+(3*4)]
    mov     ebx,[esi+(10*4)]

    mov     [edi+(2*4)],eax
    mov     [edi+(3*4)],ebx

    mov     ebp,L_last4ptr[esp]
    jmp     L1

wrDest2a:
    mov     eax,[esi+(0*4)]
    mov     ebx,[esi+(1*4)]

    mov     [edi+(0*4)],eax
    mov     [edi+(1*4)],ebx

    mov     eax,[esi+(2*4)]
    mov     ebx,[esi+(3*4)]

    mov     [edi+(2*4)],eax
    mov     [edi+(3*4)],ebx

    mov     ebp,L_last4ptr[esp]
    nop

L1:
    lea     esi,16[esi+(edx*4)]                 ;src += (4+yoff)
    and     ecx,03h                             ;xoff&3

    mov     [ebp+(0*4)],eax                     ;dst[2]
    mov     eax,[edi+(1*4)]

    sub     ebx,eax
    mov     edx,[ebp+(1*4)]

    sub     eax,edx
    mov     CVPHOLD[_tm2Table+(1*4)],ebx

    mov     CVPHOLD[_tm2Table+(0*4)],eax
    mov     eax,[edi+(3*4)]

    mov     [ebp+(1*4)],eax                         ;dst[3]
    mov     ebx,[ebp+(2*4)]

    mov     ebp,L_yoff[esp]
nop

    shl     ebp,4                                   ;index*16 bytes 
    mov     L_last4[esp],ebx

    add     ebp,offset _offsetTable                 ;&offsetTable[yoff&3][0]
    mov     eax,VPHOLD[_tm2Table+(0*4)]             ;prefetch cache

    jmp     switchTable[ecx*4]
;------------------------------------------------
CASE_0:
    mov     eax,[ebp+(0*4)]
    mov     edx,[ebp+(1*4)]

    mov     ecx,[ebp+(2*4)]
    add     esi,eax

;stall
    mov     eax,[esi]        
    add     esi,edx

    mov     [edi+(4*4)],eax                             
    and     ebx,0ffh                                ;only interested in low byte

    mov     edx,[esi]
    and     eax,0ffh

    sub     eax,ebx           
    mov     [edi+(5*4)],edx

    mov     VPHOLD[_tm2Table+(0*4)],eax
    add     esi,ecx

    and     edx,0ffh
    mov     eax,[edi+(4*4)]                             ;get 4

    and     eax,0ffh
    mov     ebx,[esi]

    mov     ecx,[ebp+(3*4)]
    sub     edx,eax                                     ;5-4

    mov     ebp,L_last4ptr[esp]
    add     esi,ecx

    mov     [edi+(6*4)],ebx
    mov     VPHOLD[_tm2Table+(1*4)],edx

    mov     ecx,[esi]
    mov     eax,[edi+(5*4)]                             ;get 5

    mov     [edi+(7*4)],ecx
    and     eax,0ffh
 
    and     ebx,0ffh
    mov     [ebp+(2*4)],ecx

    sub     ebx,eax                                     ;6-5
    and     ecx,0ffh

    mov     VPHOLD[_tm2Table+(2*4)],ebx
    mov     ebx,[edi+(6*4)]                             ;get 6

    and     ebx,0ffh
    sub     ecx,ebx                                     ;7-6

    mov     VPHOLD[_tm2Table+(3*4)],ecx
nop

    mov     esi,L_lcSource[esp]
    add     edi,8*4

    add     esi,8*4
    mov     L_lcDest[esp],edi

    mov     L_lcSource[esp],esi
    add     ebp,3*4

    mov     edx,L_blitType[esp]
    xor     ebx,ebx

    mov     L_last4ptr[esp],ebp
    mov     eax,L_blockInfoPtr[esp]         ;get block type function ptr

    jmp     edx
;------------------------------------------------
CASE_1:
    MOTION_DEST 8, 24    
;------------------------------------------------
CASE_2:
    MOTION_DEST 16, 16    
;------------------------------------------------
CASE_3:
    MOTION_DEST 24, 8    

motionBlockDone:
    MBLOCK_DONE 
;------------------------------------------------
; end of _dxMotionBlock
;------------------------------------------------
;------------------------------------------------
; various blitters 
;------------------------------------------------
_tm2bff00z:
tm2bff00z_:               
    TM2_BFF00Z_BLK              ;24 to 24 same dumb blitter for pii/ppro

_tm2bft00x:
tm2bft00x_:
    TM2_BFT00X_BLK              ;24 to 32 same dumb blitter using MMX

_tm2bff00x:
tm2bff00x_:               
    TM2_BFF00X_BLK              ;24 to 24 same dumb blitter using MMX

_tm2bft00:
tm2bft00_:
    TM2_BFT00_BLK 

_tm2bft10:
tm2bft10_:
    TM2_BFT10_BLK 

_tm2bff00:
tm2bff00_:               
    TM2_BFF00_BLK 

_tm2bff10:
tm2bff10_:
    TM2_BFF10_BLK
 
_tm2bfs00:
tm2bfs00_:
    TM2_BFS00_BLK

_tm2bfs00_565:
tm2bfs00_565_:
    TM2_BFS00565_BLK  

_tm2bfs10:
tm2bfs10_:
    TM2_BFS10_BLK

_tm2bfs10_565:
tm2bfs10_565_:
    TM2_BFS10565_BLK

_tm2bfe00:
tm2bfe00_:
    TM2_BFE00_BLK

_tm2bfe10:
tm2bfe10_:
    TM2_BFE10_BLK

;************************************************
        END
