;/***********************************************\
;??? tm2blit.ash
; various tm2 block blits
;\***********************************************/ 

BYTEOFF2 EQU 32

;------------------------------------------------
; reads 4 pixels (0RGB) and writes 8 pixels (0RGB)
;------------------------------------------------
bft10Pix MACRO scrnLoc, chroma, luma
    mov     bl,BYTE PTR 2+luma[esi]               ;g2
    mov     edx,[esi+(chroma)]                     ;chroma 0

    mov     cl,BYTE PTR 3+luma[esi]               ;g3
    mov     bh,bl

    shl     ebx,8
    mov     ch,cl

    shl     ecx,8
    mov     bl,bh

    add     ebx,edx                             ;0 R1 G1 B1    
    mov     cl,ch

    add     ecx,edx                             ;0 R0 G0 B0
    xor     eax,eax
    
    mov     0[scrnLoc],ecx                          ;write 0
    mov     4[scrnLoc],ecx                          ;write 0

    mov     8[scrnLoc],ebx                          ;write 0
    mov     12[scrnLoc],ebx                          ;write 0

    mov     al,BYTE PTR 1+luma[esi]
nop

    mov     ah,al
    xor     ecx,ecx

    shl     eax,8
    mov     edx,[esi+(chroma+4)]                     ;chroma 1

    mov     cl,BYTE PTR 0+luma[esi]
    mov     al,ah

    add     eax,edx                             ;0 R2 G2 B2
    mov     ch,cl

    shl     ecx,8
    xor     ebx,ebx

    mov     cl,ch
nop

    add     edx,ecx                             ;0 R3 G3 B3
    xor     ecx,ecx

    mov     16[scrnLoc],eax                          ;write 1
    mov     20[scrnLoc],eax                          ;write 1

    mov     24[scrnLoc],edx                         ;write 2
    mov     28[scrnLoc],edx                         ;write 2
ENDM
;------------------------------------------------
TM2_BFT10_BLK MACRO
    mov     esi,L_lcDest[esp]
    xor     ecx,ecx 

    mov     edi,L_vScreenAddr[esp]
    mov     ebp,L_vScreenPitch[esp]

    bft10Pix edi, %0-BYTEOFF2, %16+0-BYTEOFF2
    bft10Pix edi+ebp, %0-BYTEOFF2, %16+4-BYTEOFF2
    bft10Pix edi+ebp*2, %8-BYTEOFF2, %16+8-BYTEOFF2
    mov     ebp,L_vScreenPitch3[esp]
    nop
    bft10Pix edi+ebp, %8-BYTEOFF2, %16+12-BYTEOFF2

    add     edi,16*2
    mov     eax,L_blockInfoPtr[esp]

    mov     L_vScreenAddr[esp],edi
    jmp     [jmp_dxBlock]
ENDM
;------------------------------------------------
; reads 4 pixels (0RGB) and writes 4 pixels (0RGB)
;------------------------------------------------
bft00Pix MACRO scrnLoc, chroma, luma
    mov     bl,BYTE PTR 2+luma[esi]               ;g2
    mov     edx,[esi+(chroma)]                     ;chroma 0

    mov     cl,BYTE PTR 3+luma[esi]               ;g3
    mov     bh,bl

    shl     ebx,8
    mov     ch,cl

    shl     ecx,8
    mov     bl,bh

    add     ebx,edx                             ;0 R1 G1 B1    
    mov     cl,ch

    add     ecx,edx                             ;0 R0 G0 B0
    xor     eax,eax
    
    mov     0[scrnLoc],ecx                          ;write 0
    mov     4[scrnLoc],ebx                          ;write 0

    mov     al,BYTE PTR 1+luma[esi]
nop

    mov     ah,al
    xor     ecx,ecx

    shl     eax,8
    mov     edx,[esi+(chroma+4)]                     ;chroma 1

    mov     cl,BYTE PTR 0+luma[esi]
    mov     al,ah

    add     eax,edx                             ;0 R2 G2 B2
    mov     ch,cl

    shl     ecx,8
    xor     ebx,ebx

    mov     cl,ch
nop

    add     edx,ecx                             ;0 R3 G3 B3
    xor     ecx,ecx

    mov     8[scrnLoc],eax                          ;write 1
    mov     12[scrnLoc],edx                         ;write 2
ENDM
;------------------------------------------------
TM2_BFT00_BLK MACRO
    mov     esi,L_lcDest[esp]
    xor     ecx,ecx 

    mov     edi,L_vScreenAddr[esp]
    mov     ebp,L_vScreenPitch[esp]

    bft00Pix edi, %0-BYTEOFF2, %16+0-BYTEOFF2
    bft00Pix edi+ebp, %0-BYTEOFF2, %16+4-BYTEOFF2
    bft00Pix edi+ebp*2, %8-BYTEOFF2, %16+8-BYTEOFF2
    mov     ebp,L_vScreenPitch3[esp]
    nop
    bft00Pix edi+ebp, %8-BYTEOFF2, %16+12-BYTEOFF2

    add     edi,16
    mov     eax,L_blockInfoPtr[esp]

    mov     L_vScreenAddr[esp],edi
    jmp     [jmp_dxBlock]
ENDM
;------------------------------------------------
; reads 4 pixels (0RGB) and writes 3 pixels (packed RGB)
;------------------------------------------------
bff00Pix MACRO scrnLoc, chroma, luma
    mov     bl,BYTE PTR 2+luma[esi]               ;g2
    mov     edx,[esi+(chroma)]                     ;chroma 0

    mov     cl,BYTE PTR 3+luma[esi]               ;g3
    mov     bh,bl

    shl     ebx,8
    mov     ch,cl

    shl     ecx,8
    mov     bl,bh

    add     ebx,edx                             ;0 R1 G1 B1    
    mov     cl,ch

    add     ecx,edx                             ;0 R0 G0 B0
    mov     edx,ebx

    shl     edx,24                              ;B1 0 0 0
    xor     eax,eax
    
    mov     al,BYTE PTR 1+luma[esi]
    or      edx,ecx                             ;B1 R0 G0 B0

    shr     ebx,8                               ;0 0 R1 G1
    mov     ah,al

    mov     0[scrnLoc],edx                          ;write 0
    xor     ecx,ecx

    shl     eax,8
    mov     edx,[esi+(chroma+4)]                     ;chroma 1

    mov     cl,BYTE PTR 0+luma[esi]
    mov     al,ah

    add     eax,edx                             ;0 R2 G2 B2
    mov     ch,cl

    shl     ecx,8
    mov     edx,eax

    shl     edx,16                              ;G2 B2 0 0
    mov     cl,ch

    or      edx,ebx                             ;G2 B2 R1 G1
    mov     ebx,[esi+(chroma+4)]                     ;chroma 1

    shr     eax,16                              ;0 0 0 R2
    add     ecx,ebx                             ;0 R3 G3 B3

    shl     ecx,8                               ;R3 G3 B3 0
    xor     ebx,ebx

    mov     cl,al
    mov     4[scrnLoc],edx                          ;write 1

    mov     8[scrnLoc],ecx                          ;write 2
    xor     ecx,ecx
ENDM
;------------------------------------------------
TM2_BFF00_BLK MACRO
    mov     esi,L_lcDest[esp]
    xor     ecx,ecx 

    mov     edi,L_vScreenAddr[esp]
    mov     ebp,L_vScreenPitch[esp]

    bff00Pix edi, %0-BYTEOFF2, %16+0-BYTEOFF2
    bff00Pix edi+ebp, %0-BYTEOFF2, %16+4-BYTEOFF2
    bff00Pix edi+ebp*2, %8-BYTEOFF2, %16+8-BYTEOFF2
    mov     ebp,L_vScreenPitch3[esp]
    nop
    bff00Pix edi+ebp, %8-BYTEOFF2, %16+12-BYTEOFF2

    add     edi,12
    mov     eax,L_blockInfoPtr[esp]

    mov     L_vScreenAddr[esp],edi
    jmp     [jmp_dxBlock]
ENDM
;------------------------------------------------
; reads 4 pixels (0RGB) and writes 6 (stretched) pixels (packed RGB)
;------------------------------------------------
bff10Pix MACRO scrnLoc, chroma, luma
    mov     bl,BYTE PTR 3+luma[esi]                 ;g3
    mov     edx,[esi+(chroma)]                      ;chroma 0

    mov     cl,BYTE PTR 2+luma[esi]                 ;g2
    mov     bh,bl

    shl     ebx,8
    mov     ch,cl

    shl     ecx,8
    mov     bl,bh

    add     ebx,edx                                 ;0 R0 G0 B0    
    mov     cl,ch

    add     ecx,edx                                 ;0 R1 G1 B1
    mov     edx,ebx

    shl     edx,24                                  ;B0 0 0 0
    mov     eax,ecx                     

    shl     eax,16                                  ;G1 B1 0 0
    or      edx,ebx                                 ;B0 R0 G0 B0

    mov     0[scrnLoc],edx                          ;(u) write 0
nop

    shr     ebx,8                                   ;0 0 R0 G0
nop

    shl     ecx,8                                   ;R1 G1 B1 0
    or      ebx,eax                                 ;G1 B1 R0 G0

    mov     eax,ecx
    mov     4[scrnLoc],ebx                          ;(v) write 1

    shr     eax,24                                  ;O O O R1
    xor     ebx,ebx

    or      eax,ecx                                 ;R1 G1 B1 R1
    xor     ecx,ecx

    mov     8[scrnLoc],eax                          ;(u) write 2
nop
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
    mov     bl,BYTE PTR 1+luma[esi]                 ;g1
    mov     edx,[esi+(chroma+4)]                    ;chroma 1

    mov     cl,BYTE PTR 0+luma[esi]                 ;g0
    mov     bh,bl

    shl     ebx,8
    mov     ch,cl

    shl     ecx,8
    mov     bl,bh

    add     ebx,edx                                 ;0 R2 G2 B2    
    mov     cl,ch

    add     ecx,edx                                 ;0 R3 G3 B3
    mov     edx,ebx

    shl     edx,24                                  ;B2 0 0 0
    mov     eax,ecx                     

    shl     eax,16                                  ;G3 B3 0 0
    or      edx,ebx                                 ;B2 R2 G2 B2

    shr     ebx,8                                   ;0 0 R2 G2
    mov     12[scrnLoc],edx                         ;(v) write 3

    shl     ecx,8                                   ;R3 G3 B3 0
    or      ebx,eax                                 ;G3 B3 R2 G2

    mov     16[scrnLoc],ebx                         ;(u) write 4
    mov     eax,ecx

    shr     eax,24                                  ;O O O R3
    xor     ebx,ebx

    or      eax,ecx                                 ;R3 G3 B3 R3
    xor     ecx,ecx

nop
    mov     20[scrnLoc],eax                         ;(v) write 5
ENDM
;------------------------------------------------
TM2_BFF10_BLK MACRO
    mov     esi,L_lcDest[esp]
    xor     ecx,ecx

    mov     edi,L_vScreenAddr[esp]
    mov     ebp,L_vScreenPitch[esp]

    bff10Pix edi, %0-BYTEOFF2, %16+0-BYTEOFF2
    bff10Pix edi+ebp, %0-BYTEOFF2, %16+4-BYTEOFF2
    bff10Pix edi+ebp*2, %8-BYTEOFF2, %16+8-BYTEOFF2
    mov     ebp,L_vScreenPitch3[esp]
    nop
    bff10Pix edi+ebp, %8-BYTEOFF2, %16+12-BYTEOFF2

    add     edi,24
    mov     eax,L_blockInfoPtr[esp]

    mov     L_vScreenAddr[esp],edi
    jmp     [jmp_dxBlock]
ENDM
;------------------------------------------------
; 24 to 16 stretched
;------------------------------------------------
; dx is an 8 bit dither pattern
bfs10Pix MACRO chroma, luma, d0, d1, d2, d3, d4, d5, d6, d7, SAR
LOCAL checkBD, checkBD1, bdOk, bdOk1
    mov     eax,[esi+(chroma)]                      ;chroma 0
    xor     ecx,ecx

    movsx   ebx,ax                                  ;get blue diff

    sub     eax,ebx            
    jns     checkBD

    add     eax,00070000h
    nop

checkBD:
    test    ebx,ebx
    jns     bdOk

    add     ebx,7h
    nop

bdOk:
    sar     ebx,3
    and     eax,0fff80000h

    sar     eax,SAR
    xor     edx,edx

    mov     dl,BYTE PTR 3+luma[esi+4]              ;second line g3
    add     eax,ebx

    mov     cl,BYTE PTR 2+luma[esi+4]              ;second line g2
    mov     ebx,eax

    add     dl,d7
    add     cl,d6

    shl     ebx,16
nop

    add     eax,ebx                                 ;double chroma
    mov     ebx,_g16Table[edx*4]

    mov     dl,BYTE PTR 3+luma[esi]                 ;g3
    add     ebx,eax

    mov     0[edi+ebp],ebx                          ;write out second line stretched pixel
    add     dl,d3

    mov     ebx,_g16Table[ecx*4]
nop

    mov     cl,BYTE PTR 2+luma[esi]                 ;g2
nop

    add     cl,d2
    add     ebx,eax
    
    mov     edx,_g16Table[edx*4]
    mov     4[edi+ebp],ebx                          ;write out second line stretched pixel
    
    add     edx,eax
nop

    mov     0[edi],edx                              ;write out stretched pixel
    mov     ebx,_g16Table[ecx*4]

    add     ebx,eax
nop

    mov     eax,[esi+(chroma+4)]                    ;chroma 1
    mov     4[edi],ebx                              ;write out stretched pixel

    movsx   ebx,ax                                  ;get blue diff

    sub     eax,ebx            
    jns     checkBD1

    add     eax,00070000h
    nop

checkBD1:
    test    ebx,ebx
    jns     bdOk1
    
    add     ebx,7h
    nop

bdOk1:
    sar     ebx,3
    and     eax,0fff80000h
    
    sar     eax,SAR
    xor     edx,edx
    
    mov     dl,BYTE PTR 1+luma[esi+4]               ;second line g1
    add     eax,ebx

    mov     cl,BYTE PTR 0+luma[esi+4]               ;second line g0
    mov     ebx,eax

    add     dl,d5
    add     cl,d4

    shl     ebx,16
nop

    add     eax,ebx                                 ;double chroma
    mov     ebx,_g16Table[edx*4]

    mov     dl,BYTE PTR 1+luma[esi]                 ;g1
    add     ebx,eax

    mov     8[edi+ebp],ebx                          ;write out second line stretched pixel
    add     dl,d1

    mov     ebx,_g16Table[ecx*4]
nop

    mov     cl,BYTE PTR 0+luma[esi]                 ;g0
nop

    add     cl,d0
    add     ebx,eax

    mov     edx,_g16Table[edx*4]
    mov     12[edi+ebp],ebx                         ;write out second line stretched pixel

    add     edx,eax
    mov     ebx,_g16Table[ecx*4]

    mov     8[edi],edx                              ;write out stretched pixel
    mov     ecx,edi
ENDM
;------------------------------------------------
; John's 4x4 dither pattern taken from Tim's blitter code.
; ditherTable  LABEL DWORD
;     dd 7010600h
;     dd 3050204h
;     dd 6000701h
;     dd 2040305h
;------------------------------------------------
; block blit (24 to 16 stretched)
;------------------------------------------------
TM2_BFS10_BLK MACRO
    mov     esi,L_lcDest[esp]
    nop

    mov     edi,L_vScreenAddr[esp]
    mov     ebp,L_vScreenPitch[esp]

    bfs10Pix %0-BYTEOFF2, %16+0-BYTEOFF2, 00h,06h,01h,07h,04h,02h,05h,03h, 09h

    add     ebx,eax
    lea     edi,[edi+ebp*2] 

    nop
    mov     12[ecx],ebx                             ;write out stretched pixel

    bfs10Pix %8-BYTEOFF2, %16+8-BYTEOFF2, 01h,07h,00h,06h,05h,03h,04h,02h, 09h

    add     ebx,eax
    mov     edi,L_vScreenAddr[esp] 

    nop
    mov     12[ecx],ebx                             ;write out stretched pixel

    add     edi,16
    mov     eax,L_blockInfoPtr[esp]

    mov     L_vScreenAddr[esp],edi
    jmp     [jmp_dxBlock]
ENDM 
;------------------------------------------------
; block blit (24 to 16 (565)stretched)
;------------------------------------------------
TM2_BFS10565_BLK MACRO
    mov     esi,L_lcDest[esp]
    nop

    mov     edi,L_vScreenAddr[esp]
    mov     ebp,L_vScreenPitch[esp]

    bfs10Pix %0-BYTEOFF2, %16+0-BYTEOFF2, 00h,06h,01h,07h,04h,02h,05h,03h, 08h

    add     ebx,eax
    lea     edi,[edi+ebp*2] 

    nop
    mov     12[ecx],ebx                             ;write out stretched pixel

    bfs10Pix %8-BYTEOFF2, %16+8-BYTEOFF2, 01h,07h,00h,06h,05h,03h,04h,02h, 08h

    add     ebx,eax
    mov     edi,L_vScreenAddr[esp] 

    nop
    mov     12[ecx],ebx                             ;write out stretched pixel

    add     edi,16
    mov     eax,L_blockInfoPtr[esp]

    mov     L_vScreenAddr[esp],edi
    jmp     [jmp_dxBlock]
ENDM 
;------------------------------------------------
; 24 to 16 same
;------------------------------------------------
; dx is an 8 bit dither pattern
bfs00Pix MACRO chroma, luma, d0, d1, d2, d3, d4, d5, d6, d7, SAR
LOCAL checkBD, checkBD1, bdOk, bdOk1
    mov     eax,[esi+(chroma)]                      ;chroma 0
    xor     ecx,ecx

    movsx   ebx,ax                                  ;get blue diff

    sub     eax,ebx                                 ;only red now            
    jns     checkBD

    add     eax,00070000h
    nop

checkBD:
    test    ebx,ebx
    jns     bdOk

    add     ebx,7h
    nop

bdOk:
    sar     ebx,3
    and     eax,0fff80000h

    sar     eax,SAR
    xor     edx,edx

    mov     dl,BYTE PTR 2+luma[esi+4]              ;second line g2
    add     eax,ebx

    mov     cl,BYTE PTR 3+luma[esi+4]              ;second line g3
    and     eax,0ffffh                  

    add     dl,d7
    add     cl,d6

    mov     ebx,_g16Table[edx*4]                    ;only interested in lower 16
    mov     ecx,_g16Table[ecx*4]

    mov     dl,BYTE PTR 2+luma[esi]                 ;g2
    add     ebx,eax

    shl     ebx,16
    add     dl,d3

    lea     bx,[ecx+eax]                              ;add chroma to second pixel and move to bx
    xor     ecx,ecx
    
    mov     0[edi+ebp],ebx                          ;write out second line pixels
    mov     ebx,_g16Table[edx*4]
    
    mov     cl,BYTE PTR 3+luma[esi]                 ;g3
    add     ebx,eax

    shl     ebx,16
    add     cl,d2

    mov     ecx,_g16Table[ecx*4]
nop

    lea     bx,[ecx+eax]                              ;add chroma to second pixel and move to bx
    xor     ecx,ecx
;>>>>
    mov     eax,[esi+(chroma+4)]                    ;chroma 1
    mov     0[edi],ebx                              ;write out pixels

    movsx   ebx,ax                                  ;get blue diff

    sub     eax,ebx            
    jns     checkBD1

    add     eax,00070000h
    nop

checkBD1:
    test    ebx,ebx
    jns     bdOk1
    
    add     ebx,7h
    nop

bdOk1:
    sar     ebx,3
    and     eax,0fff80000h
    
    sar     eax,SAR
    xor     edx,edx
    
    mov     dl,BYTE PTR 0+luma[esi+4]               ;second line g0
    add     eax,ebx

    mov     cl,BYTE PTR 1+luma[esi+4]               ;second line g1
nop

    add     dl,d5
    add     cl,d4

    mov     ebx,_g16Table[edx*4]
    mov     ecx,_g16Table[ecx*4]

    mov     dl,BYTE PTR 0+luma[esi]                 ;g0
    add     ebx,eax

    shl     ebx,16
    add     dl,d1

    lea     bx,[ecx+eax]
    xor     ecx,ecx

    mov     4[edi+ebp],ebx                         ;write out second line pixels
    mov     ebx,_g16Table[edx*4]

    mov     cl,BYTE PTR 1+luma[esi]                 ;g1
    add     ebx,eax

    shl     ebx,16
    add     cl,d0

    mov     ecx,_g16Table[ecx*4]
    mov     edx,edi

    lea     bx,[ecx+eax]
    xor     ecx,ecx
ENDM
;------------------------------------------------
; block blit (24 to 16 (555) same)
;------------------------------------------------
TM2_BFS00_BLK MACRO
    mov     esi,L_lcDest[esp]
    xor     ecx,ecx

    mov     edi,L_vScreenAddr[esp]
    mov     ebp,L_vScreenPitch[esp]

    bfs00Pix %0-BYTEOFF2, %16+0-BYTEOFF2, 00h,06h,01h,07h,04h,02h,05h,03h, 09h

    lea     edi,[edi+ebp*2]
    mov     4[edx],ebx                             ;write out stretched pixel

    bfs00Pix %8-BYTEOFF2, %16+8-BYTEOFF2, 01h,07h,00h,06h,05h,03h,04h,02h, 09h

    mov     edi,L_vScreenAddr[esp]
    mov     4[edx],ebx                             ;write out stretched pixel

    add     edi,8
    mov     eax,L_blockInfoPtr[esp]

    mov     L_vScreenAddr[esp],edi
    jmp     [jmp_dxBlock]
ENDM 

;------------------------------------------------
; block blit (24 to 16 (565) same)
;------------------------------------------------
TM2_BFS00565_BLK MACRO
    mov     esi,L_lcDest[esp]
    xor     ecx,ecx

    mov     edi,L_vScreenAddr[esp]
    mov     ebp,L_vScreenPitch[esp]

    bfs00Pix %0-BYTEOFF2, %16+0-BYTEOFF2, 00h,06h,01h,07h,04h,02h,05h,03h, 08h

    lea     edi,[edi+ebp*2]
    mov     4[edx],ebx                             ;write out stretched pixel

    bfs00Pix %8-BYTEOFF2, %16+8-BYTEOFF2, 01h,07h,00h,06h,05h,03h,04h,02h, 08h

    mov     edi,L_vScreenAddr[esp]
    mov     4[edx],ebx                             ;write out stretched pixel

    add     edi,8
    mov     eax,L_blockInfoPtr[esp]

    mov     L_vScreenAddr[esp],edi
    jmp     [jmp_dxBlock]
ENDM 
;------------------------------------------------
; used for 24 to 8 same
;------------------------------------------------
; dx is an 8 bit dither pattern
bfe00Pix MACRO chroma, luma, d0, d1, d2, d3, d4, d5, d6, d7
LOCAL checkBD, checkBD1, bdOk, bdOk1
    mov     eax,[esi+(chroma)]                      ;chroma 0
    xor     ecx,ecx

    movsx   ebx,ax                                  ;get blue diff

    sub     eax,ebx                                 ;only red now            
    jns     checkBD

    add     eax,00070000h
    nop

checkBD:
    test    ebx,ebx
    jns     bdOk

    add     ebx,7h
    nop

bdOk:
    sar     ebx,3
    and     eax,0fff80000h

    sar     eax,9h
    xor     edx,edx

    mov     dl,BYTE PTR 2+luma[esi+4]              ;second line g2
    add     eax,ebx

    mov     cl,BYTE PTR 3+luma[esi+4]              ;second line g3
    and     eax,0ffffh                  

    add     dl,d7
    add     cl,d6

    mov     ebx,_g16Table[edx*4]                    ;only interested in lower 16
    mov     ecx,_g16Table[ecx*4]

    mov     dl,BYTE PTR 2+luma[esi]                 ;g2
    add     ebx,eax

    shl     ebx,16
    add     dl,d3

    lea     bx,[ecx+eax]                              ;add chroma to second pixel and move to bx
    xor     ecx,ecx
    
    mov     [secondLineTemp+0],ebx                    ;write out second line pixels
    mov     ebx,_g16Table[edx*4]
    
    mov     cl,BYTE PTR 3+luma[esi]                 ;g3
    add     ebx,eax

    shl     ebx,16
    add     cl,d2

    mov     ecx,_g16Table[ecx*4]
nop

    lea     bx,[ecx+eax]                              ;add chroma to second pixel and move to bx
    xor     ecx,ecx
;>>>>
    mov     eax,[esi+(chroma+4)]                    ;chroma 1
    mov     0[firstLineTemp],ebx                              ;write out pixels

    movsx   ebx,ax                                  ;get blue diff

    sub     eax,ebx            
    jns     checkBD1

    add     eax,00070000h
    nop

checkBD1:
    test    ebx,ebx
    jns     bdOk1
    
    add     ebx,7h
    nop

bdOk1:
    sar     ebx,3
    and     eax,0fff80000h
    
    sar     eax,9h
    xor     edx,edx
    
    mov     dl,BYTE PTR 0+luma[esi+4]               ;second line g0
    add     eax,ebx

    mov     cl,BYTE PTR 1+luma[esi+4]               ;second line g1
nop

    add     dl,d5
    add     cl,d4

    mov     ebx,_g16Table[edx*4]
    mov     ecx,_g16Table[ecx*4]

    mov     dl,BYTE PTR 0+luma[esi]                 ;g0
    add     ebx,eax

    shl     ebx,16
    add     dl,d1

    lea     bx,[ecx+eax]
    xor     ecx,ecx

    mov     [secondLineTemp+4],ebx                         ;write out second line pixels
    mov     ebx,_g16Table[edx*4]

    mov     cl,BYTE PTR 1+luma[esi]                 ;g1
    add     ebx,eax

    shl     ebx,16
    add     cl,d0

    mov     ecx,_g16Table[ecx*4]
    mov     edx,edi

    lea     bx,[ecx+eax]
    xor     ecx,ecx

    mov     [firstLineTemp+4],ebx                             ;write out stretched pixel
nop
ENDM
;------------------------------------------------
_4_8BIT_PIX MACRO TEMP, CPTR1, CPTR2, DEST
    mov     cx,WORD PTR[TEMP+6]

    mov     ah, BYTE PTR [CPTR1+ecx]
    mov     cx,WORD PTR[TEMP+4]

    mov     al, BYTE PTR [CPTR2+ecx]

    shl     eax,16
    mov     cx,WORD PTR[TEMP+2]

    mov     ah, BYTE PTR [CPTR1+ecx]
    mov     cx,WORD PTR[TEMP+0]

    mov     al, BYTE PTR [CPTR2+ecx]
    mov     -4[DEST],eax                           ;; write 4 8-bit pixels
ENDM
;------------------------------------------------
; block blit (24 to 8 same)
;------------------------------------------------
TM2_BFE00_BLK MACRO
    mov     edi,L_vScreenAddr[esp]
    xor     ecx,ecx

    add     edi,4
    mov     ebp,L_vScreenPitch[esp]

    mov     esi,L_lcDest[esp]
    mov     L_vScreenAddr[esp],edi

    bfe00Pix %0-BYTEOFF2, %16+0-BYTEOFF2, 00h,06h,01h,07h,04h,02h,05h,03h

    mov     ebx,L_clut1[esp]
    mov     esi,L_clut2[esp]

    ;convert here
    _4_8BIT_PIX firstLineTemp, ebx, esi, edi
    _4_8BIT_PIX secondLineTemp, esi, ebx, edi+ebp

    lea     edi,[edi+ebp*2]

    mov     esi,L_lcDest[esp]
    xor     ecx,ecx

    bfe00Pix %8-BYTEOFF2, %16+8-BYTEOFF2, 01h,07h,00h,06h,05h,03h,04h,02h

    mov     ebx,L_clut1[esp]
    mov     esi,L_clut2[esp]

    ;convert here
    _4_8BIT_PIX firstLineTemp, ebx, esi, edi
    _4_8BIT_PIX secondLineTemp, esi, ebx, edi+ebp

    mov     eax,L_blockInfoPtr[esp]

    jmp     [jmp_dxBlock]
ENDM 
;------------------------------------------------
_4_8BIT_STRETCHEDPIX MACRO TEMP, CPTR1, CPTR2, DEST
    mov     cx,WORD PTR[TEMP+6]

    mov     ah, BYTE PTR [CPTR1+ecx]
    mov     cx,WORD PTR[TEMP+2]

    mov     dh, BYTE PTR [CPTR1+ecx]
    mov     al,ah                                   ;double pixel

    shl     eax,16
    mov     dl,dh                                   

    shl     edx,16
    mov     cx,WORD PTR[TEMP+4]

    mov     ah, BYTE PTR [CPTR2+ecx]
    mov     cx,WORD PTR[TEMP+0]

    mov     dh, BYTE PTR [CPTR2+ecx]
    mov     al,ah

    mov     dl,dh

    mov     -8[DEST],edx                           ;; write 4 8-bit pixels
    mov     -4[DEST],eax
ENDM
;------------------------------------------------
; block blit (24 to 8 stretch)
;------------------------------------------------
TM2_BFE10_BLK MACRO
    mov     edi,L_vScreenAddr[esp]
    xor     ecx,ecx

    add     edi,8
    mov     ebp,L_vScreenPitch[esp]
 
    mov     esi,L_lcDest[esp]
    mov     L_vScreenAddr[esp],edi

    bfe00Pix %0-BYTEOFF2, %16+0-BYTEOFF2, 00h,06h,01h,07h,04h,02h,05h,03h

    mov     ebx,L_clut1[esp]
    mov     esi,L_clut2[esp]

    ;convert here
    _4_8BIT_STRETCHEDPIX firstLineTemp, ebx, esi, edi
    _4_8BIT_STRETCHEDPIX secondLineTemp, esi, ebx, edi+ebp

    lea     edi,[edi+ebp*2]

    mov     esi,L_lcDest[esp]
    xor     ecx,ecx

    bfe00Pix %8-BYTEOFF2, %16+8-BYTEOFF2, 01h,07h,00h,06h,05h,03h,04h,02h

    mov     ebx,L_clut1[esp]
    mov     esi,L_clut2[esp]

    ;convert here
    _4_8BIT_STRETCHEDPIX firstLineTemp, ebx, esi, edi
    _4_8BIT_STRETCHEDPIX secondLineTemp, esi, ebx, edi+ebp

    mov     eax,L_blockInfoPtr[esp]

    jmp     [jmp_dxBlock]
ENDM 
