;/***********************************************\
;??? tm2blitx.ash
; various tm2 block blits using MMX
;\***********************************************/ 

PUBLIC _MMXsetup
PUBLIC MMXsetup_

PUBLIC _MMXexit
PUBLIC MMXexit_

_MMXsetup:
MMXsetup_:
    movq    mm7,ZERO 
    ret

_MMXexit:
MMXexit_:
    emms
    ret
;------------------------------------------------
; reads 4 pixels (0RGB) and writes 4 pixels (0RGB)
;------------------------------------------------
bft00xPix MACRO scrnLoc, chroma, luma
    mov         eax,luma[esi]                       ;g3 - g0
nop

    bswap       eax

    movd        mm1,eax                             ;g0 - g3
nop

    movq        mm0,[esi+(chroma)]                  ;chroma 0, 1
    punpcklbw   mm1,mm7                             ;0 g0 0 g1 0 g2 0 g3

    movq        mm3,mm1
    psllq       mm1,8

    por         mm3,mm1                             ;g0 g0 g1 g1 g2 g2 g3 g3
nop

    movq        mm4,mm3                             ;save
    punpcklwd   mm3,mm7                             ;0 0 g2 g2 0 0 g3 g3

    movq        mm5,mm0
    punpckhwd   mm4,mm7                             ;0 0 g0 g0 0 0 g1 g1

    movq        mm2,mm3                             ;save
    psllq       mm3,8                               ;0 g2 g2 0 0 g3 g3 0

    movq        mm1,mm4                             ;save
    por         mm3,mm2                             ;0 g2 g2 g2 0 g3 g3 g3

    movq        mm6,mm7
    psllq       mm4,8                               ;0 g0 g0 0 0 g1 g1 0

    punpckldq   mm5,mm5                             ;dup chroma 0
    por         mm4,mm1                             ;0 g0 g0 g0 0 g1 g1 g1

    punpckhdq   mm0,mm0                             ;dup chroma 1
    paddd       mm3,mm5                             ;0 R1 G1 B1 0 R0 G0 B0
 
    paddd       mm4,mm0                             ;0 R3 G3 B3 0 R2 G2 B2
   
    movq        0[scrnLoc],mm3                      ;write 0, 1

    movq        8[scrnLoc],mm4                      ;write 2, 3
ENDM
;------------------------------------------------
TM2_BFT00X_BLK MACRO
    mov     esi,L_lcDest[esp]
    xor     ecx,ecx 

    mov     edi,L_vScreenAddr[esp]
    mov     ebp,L_vScreenPitch[esp]

    bft00xPix edi, %0-BYTEOFF2, %16+0-BYTEOFF2
    bft00xPix edi+ebp, %0-BYTEOFF2, %16+4-BYTEOFF2
    bft00xPix edi+ebp*2, %8-BYTEOFF2, %16+8-BYTEOFF2
    mov     ebp,L_vScreenPitch3[esp]
    nop
    bft00xPix edi+ebp, %8-BYTEOFF2, %16+12-BYTEOFF2

    add     edi,16
    mov     eax,L_blockInfoPtr[esp]

    mov     L_vScreenAddr[esp],edi
    jmp     [jmp_dxBlock]
ENDM
;------------------------------------------------
; reads 4 pixels (0RGB) and writes 3 pixels (packed RGB)
;------------------------------------------------
bff00xPix MACRO scrnLoc, chroma, luma
    mov         eax,luma[esi]                       ;g3 - g0

    bswap       eax

    movd        mm1,eax                             ;g0 - g3
nop

    movq        mm0,[esi+(chroma)]                  ;chroma 0, 1
    punpcklbw   mm1,mm7                             ;0 g0 0 g1 0 g2 0 g3

    movq        mm3,mm1
    psllq       mm1,8

    por         mm3,mm1                             ;g0 g0 g1 g1 g2 g2 g3 g3
nop

    movq        mm4,mm3                             ;save
    punpcklwd   mm3,mm7                             ;0 0 g2 g2 0 0 g3 g3

    movq        mm5,mm0
    punpckhwd   mm4,mm7                             ;0 0 g0 g0 0 0 g1 g1

    movq        mm2,mm3                             ;save
    psllq       mm3,8                               ;0 g2 g2 0 0 g3 g3 0

    movq        mm1,mm4                             ;save
    por         mm3,mm2                             ;0 g2 g2 g2 0 g3 g3 g3

    movq        mm6,mm7
    psllq       mm4,8                               ;0 g0 g0 0 0 g1 g1 0
 
    punpckldq   mm5,mm5                             ;dup chroma 0
    por         mm4,mm1                             ;0 g0 g0 g0 0 g1 g1 g1

    punpckhdq   mm0,mm0                             ;dup chroma 1
    paddd       mm3,mm5                             ;0 R1 G1 B1 0 R0 G0 B0
 
    paddd       mm4,mm0                             ;0 R3 G3 B3 0 R2 G2 B2
    punpckhdq   mm6,mm3                             ;0 R1 G1 B1 0 0 0 0

    movq        mm5,mm4                             ;work reg
    punpckldq   mm3,mm7                             ;0 0 0 0 0 R0 G0 B0

    movd        eax,mm4                             ;0 R2 G2 B2
    psrlq       mm6,8                               ;0 0 R1 G1 B1 0 0 0

    shr         eax,16                              ;0 0 0 R2
nop

    psllq       mm5,48                              ;G2 B2 0 0 0 0 0 0
    por         mm3,mm6                             ;0 0 R1 G1 B1 R0 G0 B0

    psrlq       mm4,24                              ;0 0 0 0 R3 G3 B3 0 
    and         eax,0ffh

    movd        ebx,mm4
    por         mm5,mm3                             ;G2 B2 R1 G1 B1 R0 G0 B0

    movq        0[scrnLoc],mm5                      ;write 0, 1

    or          eax,ebx

    mov        8[scrnLoc],eax                      ;write 2
ENDM
;------------------------------------------------
TM2_BFF00X_BLK MACRO
    mov     esi,L_lcDest[esp]
    xor     ecx,ecx 

    mov     edi,L_vScreenAddr[esp]
    mov     ebp,L_vScreenPitch[esp]

    bff00xPix edi, %0-BYTEOFF2, %16+0-BYTEOFF2
    bff00xPix edi+ebp, %0-BYTEOFF2, %16+4-BYTEOFF2
    bff00xPix edi+ebp*2, %8-BYTEOFF2, %16+8-BYTEOFF2
    mov     ebp,L_vScreenPitch3[esp]
    nop
    bff00xPix edi+ebp, %8-BYTEOFF2, %16+12-BYTEOFF2

    add     edi,12
    mov     eax,L_blockInfoPtr[esp]

    mov     L_vScreenAddr[esp],edi
    jmp     [jmp_dxBlock]
ENDM
;------------------------------------------------
; reads 4 pixels (0RGB) and writes 3 pixels (packed RGB)
; optimized for pentium ii and pentium pro
; believe it or not -- this is faster than the mmx version
;------------------------------------------------
bff00zPix MACRO scrnLoc, chroma, luma
    mov         bl,BYTE PTR luma[esi+2]					;g2
    mov			edx,[esi+(chroma)]						;chroma 0

	imul		ebx,010101h								;1 cycle on pii

    mov         cl,BYTE PTR luma[esi+3]					;g3
	add			ebx,edx									;0 R1 G1 B1

	imul		ecx,010101h

	mov			eax,ebx
	add			ecx,edx									;0 R0 G0 B0
	
	shl			eax,24									;B1 0 0 0
    mov			edx,[esi+(chroma+4)]					;chroma 1

	shr			ebx,8									;0 0 R1 G1
	or			eax,ecx									;B1 R0 G0 B0

	mov			0[scrnLoc],eax
	xor			ecx,ecx

    mov         cl,BYTE PTR luma[esi+1]					;g1
;nop	

	imul		ecx,010101h

    add         ecx,edx                                 ;0 R2 G2 B2
    xor         edx,edx

    mov         dl,BYTE PTR luma[esi+0]					;g0
    mov         eax,ecx

    shl         eax,16                                  ;G2 B2 0 0

    shr         ecx,16                                  ;0 0 0 R2
    or          eax,ebx                                 ;G2 B2 R1 G1

    mov			ebx,[esi+(chroma+4)]					;chroma 1
	mov			4[scrnLoc],eax

	imul		edx,010101h

    add         ebx,edx                                 ;0 R3 G3 B3

    shl         ebx,8                                   ;R3 G3 B3 0

    or          ebx,ecx                                 ;R3 G3 B3 R2
    xor         ecx,ecx

	mov			8[scrnLoc],ebx
    xor         ebx,ebx
ENDM
;------------------------------------------------
TM2_BFF00Z_BLK MACRO
    mov     esi,L_lcDest[esp]
    xor     ecx,ecx 

    mov     edi,L_vScreenAddr[esp]
    mov     ebp,L_vScreenPitch[esp]

    xor     ebx,ebx

    bff00zPix edi, %0-BYTEOFF2, %16+0-BYTEOFF2
    bff00zPix edi+ebp, %0-BYTEOFF2, %16+4-BYTEOFF2
    bff00zPix edi+ebp*2, %8-BYTEOFF2, %16+8-BYTEOFF2

    mov     ebp,L_vScreenPitch3[esp]

    bff00zPix edi+ebp, %8-BYTEOFF2, %16+12-BYTEOFF2

    add     edi,12
    mov     eax,L_blockInfoPtr[esp]

    mov     L_vScreenAddr[esp],edi
    jmp     [jmp_dxBlock]
ENDM
