;   Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.
;
;   This file is part of VpVision.
;
;   VpVision is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License ver. 2,
;   as published by the Free Software Foundation (www.fsf.org).
;
;   Foobar is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with VpVision; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;/***********************************************\
;??? buildt.asm   
;\***********************************************/ 

; 6/97 - converting eric's build table c routines

        .586
        .MODEL  flat, SYSCALL, os_dos
        .CODE

IDEAL
NAME buildt 
MASM

BUILD_TABLE         EQU 1


if BUILD_TABLE
PUBLIC buildTableFromTree_
PUBLIC  _buildTableFromTree

INCLUDE tinker.ash

;------------------------------------------------
; unsigned char buildTableFromTree(DXL_STREAM_HANDLE strmPtr)
;
ifdef WIN95
buildTableParams    STRUC
                dd  6 dup (?)   ;6 pushed regs
                dd  ?           ;return address
    strmPtr     dd  ?       
buildTableParams    ENDS
endif

;------------------------------------------------
; local vars
;
bT_nodes        EQU     0
    ;nodes in first dword
    ;valid in second dword

bT_tree         EQU     bT_nodes+((MAX_BITS+1)*8)
bT_numbits      EQU     bT_tree+4
bT_index        EQU     bT_numbits+4
bT_table        EQU     bT_index+4
bT_nodeptr      EQU     bT_table+4
L_stackptr      EQU     bT_nodeptr+4
bT_value        EQU     L_stackptr+4

bT_Vars         EQU     (bT_value+((MAX_BITS+1))+4+31) and 0ffffffe0h
;bT_Vars         EQU     bT_value+((MAX_BITS+1))+4
;------------------------------------------------

;------------------------------------------------
; eax = work reg
; ebx = nodeptr
; ecx = numbits/xfer
; edx = v
;
; esi = nodes/valid
; edi = value
; ebp = tree/table
;------------------------------------------------
buildTableFromTree_:
_buildTableFromTree:
    push    esi
    push    edi
    push    ebp
    push    ebx 
    push    ecx
    push    edx

ifdef WIN95
    mov     eax,[esp].strmPtr   
    mov     ebx,esp                         ;save current stack ptr

    and     esp,0ffffffe0h                  ;align
    nop
else
    mov     ebx,esp                         ;save current stack ptr
    and     esp,0ffffffe0h                  ;align
endif

    sub     esp,bT_Vars
    xor     edx,edx                         ;v = 0

    mov     edi,(1 shl MAX_BITS)
    mov     ebp,[eax].htree  

    mov     L_stackptr[esp],ebx
    mov     ebx,[eax].htable

    xor     eax,eax                         
    lea     esi,bT_nodes[esp]

    mov     bT_tree[esp],ebp
    mov     bT_table[esp],ebx

    mov     bT_index[esp],edi
    mov     DWORD PTR [esi],eax                     ;zero out

    mov     ecx,1
    mov     ebx,MAX_BITS

    cmp     edi,(1 shl MAX_BITS) * 2
    jge     theExit

indexLoop:
    lea     edi,bT_value[esp]
nop

    cmp     edx,7
    jge     doneTraveling

travelNodes:
    mov     al,BYTE PTR [ebp+eax]           ;get nodeptr from tree
nop

    test    eax,01h
    jz      updateNodes

    shr     eax,1
    mov     [esi+(edx*8)+4],ecx             ;mark the new number of valid bits

    mov     BYTE PTR [edi+edx],al
    xor     eax,eax                         ;start at top of tree

    inc     edx
nop
        
updateNodes:
    mov     [esi+(ecx*8)],eax
    inc     ecx

    dec     ebx 
    jnz     travelNodes
    
doneTraveling: 
;    cmp     edx,0
;    je     valuesNotFound
    test    edx,edx
    jz      valuesNotFound

    cmp     edx,TOK_SLEN-2
    mov     ebp,bT_table[esp]

nop
    jle     bT_1

    mov     edx,TOK_SLEN-2
nop

bT_1:
    mov     ecx,[edi+4]
    mov     ebx,[edi+0]

    shl     ecx,16
nop

    mov     ch,BYTE PTR[esi+((edx-1)*8)+4]
nop

    mov     [ebp+4],ebx
    mov     cl,dl
 
    mov     [ebp],ecx
    nop

backTracking:
    add     ebp,8
    mov     ebx,bT_index[esp]
    
    mov     ecx,MAX_BITS
    inc     ebx
    
    mov     bT_table[esp],ebp
    mov     bT_index[esp],ebx

    cmp     ebx,(1 shl (MAX_BITS+1))
    jge     theExit

bT_5:
    shr     ebx,1
    jc      bT_6

    dec     ecx
    jmp     bT_5

bT_6:
    mov     ebx,[esi+((edx-1)*8)+4]
    nop

bT_6a:
    cmp     ebx,ecx
    jl      bT_7

    mov     ebx,[esi+((edx-2)*8)+4]
    nop

    dec     edx
    jg      bT_6a

    xor     edx,edx 
    nop

bT_7:
    mov     ebx,MAX_BITS+1
    mov     eax,[esi+((ecx-1)*8)]

    sub     ebx,ecx
    mov     ebp,bT_tree[esp]

    inc     eax
    jmp     indexLoop

valuesNotFound:
    mov     ebp,bT_table[esp]
    xor     ah,ah

    mov     BYTE PTR [ebp+1],al
    nop

    mov     BYTE PTR [ebp+0],ah
    jmp     backTracking

theExit:
    mov     eax,L_stackptr[esp]
    add     esp,bT_Vars

    mov     esp,eax                   ;restore stack
    xor     eax,eax                         ;return 0

    pop     edx
    pop     ecx
    pop     ebx
    pop     ebp
    pop     edi
    pop     esi
    ret

endif

;************************************************
         END
