;   Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.
;
;   This file is part of VpVision.
;
;   VpVision is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License ver. 2,
;   as published by the Free Software Foundation (www.fsf.org).
;
;   Foobar is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with VpVision; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;/***********************************************\
;??? dtoken.asm   
;\***********************************************/ 

; 6/97 - converting eric's huffman c routines

        .486
        .MODEL  flat, SYSCALL, os_dos
        .CODE

IDEAL
NAME x86dtoken
MASM

DECODETOKENS        EQU 1

if DECODETOKENS
PUBLIC decodeTokens_
PUBLIC _decodeTokens

INCLUDE tinker.ash

SEARCH_TREE MACRO jumpBack
LOCAL while_numBits, reInitBits, readyRV
    xor     eax,eax
    mov     edx,edi

    mov     al,ch
    mov     L_tCount[esp],ebx

    mov     ebx,ecx                         ;numBits in bl
    mov     ecx,32

    sub     cl,bl
    and     ebx,0ffh

    jz      reInitBits

    shl     edx,cl

while_numBits:
    add     edx,edx                             ;shift upper bit out
    nop
    
    adc     eax,0
    nop

    mov     al,BYTE PTR TBL_BYTE_SIZE[eax+esi]               ;tree[nodeptr]
    nop
    
    test    eax,1
    jnz     readyRV

    and     eax,0ffh
    dec     ebx

    jg     while_numBits
    
reInitBits:
    mov     ecx,32
    mov     ebx,32

    mov     edx,[ebp]
    add     ebp,4

    ror     edx,16

    jmp     while_numBits

readyRV:
    mov     edi,-4[ebp]
    dec     ebx

    ror     edi,16

    shr     al,1
    mov     edx,edi

    lea     ecx,[ebx-MAX_BITS]
    mov     ebx,L_tCount[esp]

    mov     BYTE PTR -8[esi+ebx],al  
    inc     ebx

    jl     jumpBack
ENDM

;------------------------------------------------
; int decodeTokens(DXL_STREAM_HANDLE strmPtr)
;
ifdef WIN95
decodeTokensParams    STRUC
                dd  6 dup (?)   ;6 pushed regs
                dd  ?           ;return address
    strmPtr     dd  ?       
decodeTokensParams    ENDS
else
endif
;------------------------------------------------
L_tCount        EQU     0
L_bs            EQU     L_tCount+4
L_bsSB          EQU     L_bs+4
L_stackptr      EQU     L_bsSB+4
DEBUG0          EQU     L_stackptr+4
DEBUG1          EQU     DEBUG0+4

dTokensVars     EQU     (DEBUG1+4+31) AND 0ffffffe0h
;------------------------------------------------
; regs in main loop
;
; eax =
; ebx = tCount 
; ecx = numBits
; edx = 

; esi = tBuffer
; edi = bitBuffer
; ebp = table
;------------------------------------------------
decodeTokens_:
_decodeTokens:
    push    esi
    push    edi
    push    ebp  
    push    ebx
    push    ecx
    push    edx

ifdef WIN95
    mov     edx,[esp].strmPtr   
else
    mov     edx,eax
endif
    mov     eax,esp                         ;save current stack ptr

    and     esp,0ffffffe0h                  ;align
    nop

    sub     esp,dTokensVars
    mov     ecx,32-MAX_BITS

    mov     esi,[edx].htable
    lea     ebx,[edx].bitSource

    mov     L_stackptr[esp],eax
    mov     ebp,[ebx]

    mov     eax,L_tCount[esp]                       ;fill cache
    mov     L_bs[esp],ebx

    mov     ebx,[edx].tokenCount
    mov     edi,[ebp]

    neg     ebx

    ror     edi,16

;    jmp      dToken

    mov     eax,[edx].minCodeLength
    nop

    cmp     eax, 2
    jl      dToken

    mov     eax,[edx].maxCodeLength
    nop

    cmp     eax, 9
    jle     dToken2

    jmp     dToken1

dToken:
    add     ebp,4
    mov     edx,edi
 
getTableEntry:
    cmp     cl,17-MAX_BITS 
    jge     gT1

update_bitBuffer:
    shl     edx,16
    add     cl,16

    mov     dx,WORD PTR [ebp]                       ;prefix penalty

    add     ebp,2 
    mov     edi,edx

gT1:
    shr     edx,cl

    and     edx,MAX_BITS_MASK
nop

gT:
    mov     eax,4[esi+edx*8]     
    mov     edx,[esi+edx*8]               

    cmp     dl,4
    jg      dl4

    mov     -8[esi+ebx],eax                  ;write b0 b1 b2 b3
    mov     ch,dh

    and     edx,0ffh                    ;check num bytes produced
    jz      searchTree     

    add     ebx,edx
    jge     decodeTokensExit

    mov     edx,edi
    sub     cl,ch

    jle     update_bitBuffer

    shr     edx,cl

    and     edx,MAX_BITS_MASK
    jmp     gT

dl4:
    mov     -6[esi+ebx],edx
    mov     ch,dh

    and     edx,0ffh    
    mov     -8[esi+ebx],eax                  ;write b0 b1 b2 b3

    add     ebx,edx
    jge    decodeTokensExit

    mov     edx,edi
    sub     cl,ch

    jle     update_bitBuffer 

    shr     edx,cl

    and     edx,MAX_BITS_MASK
    jmp     gT

searchTree:
    SEARCH_TREE getTableEntry

decodeTokensExit:
    mov     eax,L_bs[esp]
    mov     edx,L_stackptr[esp]

;    add     esp,dTokensVars
    mov     [eax].shortBuffer,ebp

    mov     esp,edx                   ;restore stack
    xor     eax,eax

    pop     edx
    pop     ecx
    pop     ebx
    pop     ebp
    pop     edi
    pop     esi
    ret
;------------------------------------------------
dToken1:
    add     ebp,4
    mov     edx,edi

a_getTableEntry:
    cmp     cl,17-MAX_BITS 
    jge     a_gT1

a_update_bitBuffer:
    shl     edx,16
    add     cl,16

    mov     dx,WORD PTR [ebp]           ;prefix penalty

    add     ebp,2
    mov     edi,edx

a_gT1:
    shr     edx,cl

    and     edx,MAX_BITS_MASK
nop    

a_gT:
    mov     eax,4[esi+edx*8]     
    mov     edx,[esi+edx*8]               

    mov     -8[esi+ebx],eax                  ;write b0 b1 b2 b3
    mov     ch,dh

    and     edx,0ffh                    ;check num bytes produced
    jz      a_searchTree     

    add     ebx,edx
    jge     a_decodeTokensExit

    mov     edx,edi
    sub     cl,ch

    jle     a_update_bitBuffer

    shr     edx,cl

    and     edx,MAX_BITS_MASK
    jmp     a_gT

a_searchTree:
    SEARCH_TREE a_getTableEntry

a_decodeTokensExit:
    mov     eax,L_bs[esp]
    mov     edx,L_stackptr[esp]

;    add     esp,dTokensVars
    mov     esp,edx                   ;restore stack

    mov     [eax].shortBuffer,ebp
    xor     eax,eax

    pop     edx
    pop     ecx
    pop     ebx
    pop     ebp
    pop     edi
    pop     esi
    ret
;------------------------------------------------
dToken2:
    add     ebp,4
    mov     edx,edi

b_getTableEntry:
    cmp     cl,17-MAX_BITS 
    jge     b_gT1

b_update_bitBuffer:
    shl     edx,16
    add     cl,16

    mov     dx,WORD PTR [ebp]           ;prefix penalty

    add     ebp,2
    mov     edi,edx

b_gT1:
    shr     edx,cl

    and     edx,MAX_BITS_MASK
nop

b_gT:

    mov     eax,4[esi+edx*8]     
    mov     edx,[esi+edx*8]               

    mov     ch,dh
    and     edx,0ffh                    ;check num bytes produced

    mov     -8[esi+ebx],eax                   ;write b0 b1 b2 b3
    add     ebx,edx

    mov     edx,edi
    jge     b_decodeTokensExit

    sub     cl,ch
    jle     b_update_bitBuffer

    shr     edx,cl

    and     edx,MAX_BITS_MASK
    jmp     b_gT

b_decodeTokensExit:
    mov     eax,L_bs[esp]
    mov     edx,L_stackptr[esp]

;    add     esp,dTokensVars
    mov     esp,edx                   ;restore stack

    mov     [eax].shortBuffer,ebp
    xor     eax,eax

    pop     edx
    pop     ecx
    pop     ebx
    pop     ebp
    pop     edi
    pop     esi
    ret
endif
;************************************************
        END

 