;/***********************************************\
;??? tinker.ash
; contains stuctures and equates for TM2
; assembly routines   
;\***********************************************/ 

MAX_BITS            EQU 9
MAX_BITS_MASK       EQU 01ffh
TBL_BITS            EQU MAX_BITS
TBL_SIZE            EQU (1 SHL TBL_BITS)
TOK_SLEN            EQU 8
TBL_BYTE_SIZE       EQU TBL_SIZE * TOK_SLEN
MAXDELTAS           EQU 32

chromaHiOffset	    EQU 0
chromaLoOffset	    EQU MAXDELTAS*4
lumaHiOffset	    EQU MAXDELTAS*4*2
lumaLoOffset	    EQU MAXDELTAS*4*3
updateOffset	    EQU MAXDELTAS*4*4
motionOffset	    EQU MAXDELTAS*4*5
blockTypeOffset	    EQU MAXDELTAS*4*6

vpOffset            EQU MAXDELTAS*4*8

VPHOLD              EQU vpOffset
CVPHOLD             EQU vpOffset+16

;------------------------------------------------
x86_bitSrc  STRUC
	shortBuffer     dd ?
	bitBuffer       dd ?
 	numBits         dd ?
x86_bitSrc  ENDS
;------------------------------------------------
x86_stream  STRUC
 	numDeltas       dd ?
 	deltas          dd ?        		;/* upto 32 deltas (64bytes) */
 	htree           dd ?                ;/* huffman tree (64bytes) */
 	htable	        dd ?                ;/* huffman decoder table (1536bytes) */
 							            ;/* total "decoder" size 2176 bytes */
 	tokenCount      dd ?
 	tokenPtr        dd ?
    tokenCPtr       dd ?

  	bitSource       x86_bitSrc  <>

	valueLength     dd ?
	maxCodeLength   dd ?
	minCodeLength   dd ?
	nodeCount       dd ?
x86_stream  ENDS 	
;------------------------------------------------
x86_TM2X STRUC
	xImageBaseStruct db 64 DUP (?)      ;size of xImageBaseStruct

	chromaHi        x86_stream <>
	chromaLo        x86_stream <>
	lumaHi          x86_stream <>
	lumaLo          x86_stream <>
	update          x86_stream <>
	motion          x86_stream <>
	blockType       x86_stream <>

    type            dd ?
    depth           dd ?
    dataSize        dd ?
    compressFlags   dd ?

    formatSize      dd ?
    cData           dd ?

    hBuffer         dd ?
    hBufferTop      dd ?
    hBufferSize     dd ?

    lineBuff        dd ?
    pBuffer1        dd ?
    pBuffer2        dd ?

    tm2xdeltas      dd ?

    frontBuffer     dd ?
    backBuffer      dd ?
x86_TM2X ENDS
;------------------------------------------------
if 1
x86_TM2Xptrs  STRUC
	chromaHiTptr    dd ?
	chromaLoTptr    dd ?
	lumaHiTptr      dd ?
	lumaLoTptr      dd ?
	updateTptr      dd ?
	motionTptr      dd ?
	blockTypeTptr   dd ?
    deltaPtr        dd ?

    blockInfoPtr    dd ?
    lastLine        dd ?
    lcDest          dd ?
    lcSource        dd ?
    vph             dd ?
x86_TM2Xptrs  ENDS
endif
