;   Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.
;
;   This file is part of VpVision.
;
;   VpVision is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License ver. 2,
;   as published by the Free Software Foundation (www.fsf.org).
;
;   Foobar is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with VpVision; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;/***********************************************\
;??? bff00.asm   
; 24 to 24 blitter
;\***********************************************/ 


        .586 
        .MODEL  flat, SYSCALL, os_dos
        .CODE

IDEAL
NAME x86bff00
MASM

PUBLIC tm2_bff00_
PUBLIC  _tm2_bff00

;EXTRN _gTable:DWORD

;------------------------------------------------
; according to intel pci chipset documentation, back to back
; sequential memory writes to pci are converted to burst
; writes on pci
;
_3_PIXELS MACRO scrnLoc, chroma, luma
    mov     bl,BYTE PTR 2+luma[esi]               ;g2
    mov     edx,[esi+(chroma)]                     ;chroma 0

    mov     cl,BYTE PTR 3+luma[esi]               ;g3
    mov     bh,bl

    shl     ebx,8
    mov     ch,cl

    shl     ecx,8
    mov     bl,bh

    add     ebx,edx                             ;0 R1 G1 B1    
    mov     cl,ch

    add     ecx,edx                             ;0 R0 G0 B0
    mov     edx,ebx

    shl     edx,24                              ;B1 0 0 0
    xor     eax,eax
    
    mov     al,BYTE PTR 1+luma[esi]
    or      edx,ecx                             ;B1 R0 G0 B0

    shr     ebx,8                               ;0 0 R1 G1
    mov     ah,al

    mov     0[scrnLoc],edx                          ;write 0
    xor     ecx,ecx

    shl     eax,8
    mov     edx,[esi+(chroma+4)]                     ;chroma 1

    mov     cl,BYTE PTR 0+luma[esi]
    mov     al,ah

    add     eax,edx                             ;0 R2 G2 B2
    mov     ch,cl

    shl     ecx,8
    mov     edx,eax

    shl     edx,16                              ;G2 B2 0 0
    mov     cl,ch

    or      edx,ebx                             ;G2 B2 R1 G1
    mov     ebx,[esi+(chroma+4)]                     ;chroma 1

    shr     eax,16                              ;0 0 0 R2
    add     ecx,ebx                             ;0 R3 G3 B3

    shl     ecx,8                               ;R3 G3 B3 0
    xor     ebx,ebx

    mov     cl,al
    mov     4[scrnLoc],edx                          ;write 1

    mov     8[scrnLoc],ecx                          ;write 2
    xor     ecx,ecx
ENDM

_3_PIXELS2 MACRO scrnLoc, chroma, luma
    mov     bl,BYTE PTR 2+luma[esi]               ;g2
    mov     edx,[esi+(chroma)]                     ;chroma 0

    mov     cl,BYTE PTR 3+luma[esi]               ;g3
    mov     bh,bl

    shl     ebx,8
    mov     ch,cl

    shl     ecx,8
    mov     bl,bh

    add     ebx,edx                             ;0 R1 G1 B1    
    mov     cl,ch

    add     ecx,edx                             ;0 R0 G0 B0
    mov     edx,ebx

    shl     edx,24                              ;B1 0 0 0
    xor     eax,eax
    
    mov     al,BYTE PTR 1+luma[esi]
    or      edx,ecx                             ;B1 R0 G0 B0

    shr     ebx,8                               ;0 0 R1 G1
    mov     ah,al

    xor     ecx,ecx
    mov     0[scrnLoc],edx                          ;write 0

    shl     eax,8
    mov     edx,[esi+(chroma+4)]                     ;chroma 1

    mov     cl,BYTE PTR 0+luma[esi]
    mov     al,ah

    add     eax,edx                             ;0 R2 G2 B2
    mov     ch,cl

    shl     ecx,8
    mov     edx,eax

    shl     edx,16                              ;G2 B2 0 0
    mov     cl,ch

    or      edx,ebx                             ;G2 B2 R1 G1
    mov     ebx,[esi+(chroma+4)]                     ;chroma 1

    shr     eax,16                              ;0 0 0 R2
    add     ecx,ebx                             ;0 R3 G3 B3

    shl     ecx,8                               ;R3 G3 B3 0
    xor     ebx,ebx

    mov     4[scrnLoc],edx                          ;write 1
    mov     cl,al

nop
    mov     8[scrnLoc],ecx                          ;write 2

nop
    xor     ecx,ecx
ENDM

;------------------------------------------------
; local vars
;
L_stackptr      EQU     0
L_blkPitch      EQU     L_stackptr+4
L_dest          EQU     L_blkPitch+4
L_i             EQU     L_dest+4
L_blkRow        EQU     L_i+4
L_blkCol        EQU     L_blkRow+4
L_src           EQU     L_blkCol+4

L_Vars          EQU     (L_src+4+31) AND 0ffffffe0h
;------------------------------------------------
; void blitMe(unsigned short *shortPtr, long length)
;
blitMeParams    STRUC
                dd  6 dup (?)   ;6 pushed regs
                dd  ?           ;return address
    dst         dd  ?
    src         dd  ?       
    numBlkRows  dd  ?
    numBlkCols  dd  ?
    pitch       dd  ?
    scrnPitch   dd  ?
blitMeParams    ENDS
;------------------------------------------------
tm2_bff00_:
_tm2_bff00:
    push    esi
    push    edi
    push    ebp
    push    ebx
    push    ecx
    push    edx

    mov     edi,[esp].dst
    mov     esi,[esp].src

    mov     ecx,[esp].numBlkRows
    mov     edx,[esp].numBlkCols

    nop
    mov     ebp,[esp].scrnPitch

    mov     ebx,esp                         ;save current stack ptr
    and     esp,0ffffffe0h                  ;align

    sub     esp,L_Vars                      ;make room for vars
nop

    mov     L_stackptr[esp],ebx
    mov     ebx,L_stackptr[esp]

    mov     L_blkCol[esp],edx  
    mov     L_blkRow[esp],ecx    

    mov     L_dest[esp],edi
    mov     L_blkPitch[esp],ebp

    xor     ebx,ebx
    mov     ebp,L_blkCol[esp]

    mov     L_src[esp],esi
    xor     ecx,ecx

doCols:
L1:
    _3_PIXELS <edi>, 0, %16+0

    add     esi,32;+32
    add     edi,12;+12

    dec     ebp
    jnz     L1

    mov     edi,L_dest[esp]
    mov     edx,L_blkPitch[esp]

    mov     ebp,L_blkCol[esp]
    add     edi,edx

    mov     esi,L_src[esp]
    mov     L_dest[esp],edi

L2:
    _3_PIXELS2 <edi>, 0, %16+4

    add     esi,32;+32
    add     edi,12;+12

    dec     ebp
    jnz     L2

    mov     edi,L_dest[esp]
    mov     edx,L_blkPitch[esp]

    mov     ebp,L_blkCol[esp]
    add     edi,edx

    mov     esi,L_src[esp]
    mov     L_dest[esp],edi

L3:
    _3_PIXELS <edi>, 8, %16+8
    add     esi,32;+32
    add     edi,12;+12

    dec     ebp
    jnz     L3

    mov     edi,L_dest[esp]
    mov     edx,L_blkPitch[esp]

    mov     ebp,L_blkCol[esp]
    add     edi,edx

    mov     esi,L_src[esp]
    mov     L_dest[esp],edi

L4:
    _3_PIXELS2 <edi>, 8, %16+12

    add     esi,32;+32
    add     edi,12;+12

    dec     ebp
    jnz     L4
;----------------------------------------------------------
    mov     L_src[esp],esi
    mov     edi,L_dest[esp]

    mov     edx,L_blkPitch[esp]
    mov     eax,L_blkRow[esp]

    add     edi,edx
    mov     ebp,L_blkCol[esp]

    mov     L_dest[esp],edi 
    dec     eax

    mov     L_blkRow[esp],eax
    jnz     L1

theExit:
    mov     eax,L_stackptr[esp]
    mov     esp,eax

    pop     edx
    pop     ecx 
    pop     ebx
    pop     ebp
    pop     edi
    pop     esi
    ret

;************************************************
         END

