/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*==========================================================================;
//
//  Most sections now (c) 1994 The Duck Corporation. All Rights Reserved.
//
//  re-worked for Duck: Dan Miller 12/94
//  decode re-worked for Duck's DOS Player: Eric Ameres 12/94
//
//-------------------------------------------------------------------------;
//
//  dk3bit.c
//
//==========================================================================;
*/
#include <stdlib.h>
#include "duktypes.h"

#include "dkpltfrm.h"
//#include "cduck.h"
#include <duck_hfb.h> 
#include <duck_mem.h>
#include "dxl_main.h"
#include "dxl_audi.h"

/* found in dkglobal.h */

extern short step[];
extern short MulTbl[16];
extern short FixTbl[16];
extern short next_step[16];

typedef
struct adpcm3hdr_tag {
	unsigned char typeID, version;
	unsigned long srate;
	unsigned long scount;
	short isum, idif;
	unsigned char isumx, idifx;
} adpcm3hdr;

typedef
struct adpcm3hdr_tag2 {
	unsigned long scount;
	short isum, idif;
	unsigned char isumx, idifx;
} adpcm3hdr2;

#define DK3B_HEADER_BYTES 16
#define DK3B_TYPEID 0
#define DK3B_VERSION 0
#define DK3B_EXTRA_KLUGE 1

#define CLAMP(x, min, max) { if(x<min) x=min; else if (x > max) x=max; }
#define CLAMP2(x, y, z)

static void decodeSamp(short iInput,short *aiSamp,short *aiStepIndex)
{
	long lSamp = *aiSamp;

	/* compute new sample: */
	lSamp += (  (long)step[*aiStepIndex]*
				(long)MulTbl[iInput]+
				(long)FixTbl[iInput]   ) >> 3;
	
	/* compute new index: */
    *aiStepIndex += next_step[iInput];
	CLAMP( *aiStepIndex, 0, 88 );

	*aiSamp = (short)lSamp;
}


#define SUM		(xsrc->aiSamp[0])
#define NUDIFF	(xsrc->aiSamp[1])

extern int dx3BitStereo(int numToGet,unsigned char *src, short *dst, short *dest2,
			short *aiSamp,short *aiStepIndex, short *iNextInput, int firstNib,int n,
			unsigned char **addr,short *diff);

int dxDK3S(register DXL_XAUDIOSRC_HANDLE xsrc,short *left, short *right,int nSamples)
{   
	short	numToGet;
	int		numGotten = nSamples,n=0;
	long	lSamp;
	unsigned char *laddr;
	adpcm3hdr2 ahdr;

	do{
		if (xsrc->finiBlock){
			xsrc->totalPos += DK3B_HEADER_BYTES;
					
			if (xsrc->totalPos > xsrc->length)
				return numGotten - nSamples;
				
			duck_memcpy(&ahdr,xsrc->addr+6,sizeof(adpcm3hdr2));
			xsrc->aiSamp[0] = xsrc->sum = invert2(ahdr.isum);
			xsrc->aiSamp[1] = xsrc->diff = xsrc->nudiff = invert2(ahdr.idif);
			xsrc->aiStepIndex[0] = ahdr.isumx;
			xsrc->aiStepIndex[1] = ahdr.idifx;
			xsrc->samplesPerBlock = invert4(ahdr.scount);
	
			xsrc->addr += DK3B_HEADER_BYTES;

			lSamp =(long)xsrc->sum+xsrc->diff;
			lSamp =(long)xsrc->sum-xsrc->diff;
	
			xsrc->iFirstNibble = 1;
			xsrc->finiBlock = 0;
			xsrc->samplesRead = 0;
		}
	    n = xsrc->samplesRead;
		numToGet = xsrc->samplesPerBlock - xsrc->samplesRead;
			
		if (nSamples < numToGet)
			numToGet = nSamples;          
		else
			xsrc->finiBlock = 1;			
			
		nSamples -= numToGet;           
		xsrc->samplesRead += numToGet;
        
        laddr = xsrc->addr;

		{	/* c version */
            unsigned char *addr;
			short diff,nudiff,iNextInput,iFirstNibble;
			
			diff = xsrc->diff;
			nudiff = xsrc->aiSamp[1];
			iNextInput = xsrc->iNextInput;
			addr = xsrc->addr;
			iFirstNibble = xsrc->iFirstNibble;
			
			do{ 
				if (iFirstNibble){
					iNextInput = (short) *(addr++);
					decodeSamp(
						(short)(iNextInput & 0x0F),
						(short *)(&SUM),
						(short *)(&xsrc->aiStepIndex[0]));
					if(!(n&1)) {
						decodeSamp(
							(short)((iNextInput >> 4) & 0x000F),
							(short *)(&NUDIFF),
							(short *)(&xsrc->aiStepIndex[1]));
						
						diff =(short)(((long)diff)+((long)NUDIFF))>>1;
					}else
						iFirstNibble = 0;
				}else{
					decodeSamp(
						(short)((iNextInput >> 4) & 0x0F),
						(short *)(&SUM),
						(short *)(&xsrc->aiStepIndex[0]));
                    if(!(n&1)) {
						iNextInput = (short) *(addr++);
						decodeSamp(
							(short)(iNextInput & 0x0F),
							(short *)(&NUDIFF),
							(short *)(&xsrc->aiStepIndex[1]) );
						
						diff =(short)(((long)diff)+((long)NUDIFF))>>1;
					}else
						iFirstNibble = 1;
				}
				*left++ =(short)SUM+diff;
#if AUDIOINTERLEAVED || 1
				*left++ =(short)SUM-diff;
#else
				*right++ =(short)SUM-diff;
#endif
				diff = NUDIFF;

				n++;
			}while(--numToGet);

			xsrc->diff = diff;
			xsrc->iNextInput = iNextInput;
			xsrc->addr = addr;
			xsrc->iFirstNibble = iFirstNibble;
		}
		
		xsrc->totalPos += (unsigned long)xsrc->addr - (unsigned long)laddr;
		if (xsrc->finiBlock){
			xsrc->totalPos += DK3B_EXTRA_KLUGE;
			xsrc->addr += DK3B_EXTRA_KLUGE;
		}
	}while(nSamples > 0);
	return numGotten;
}
