/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*==========================================================================;
//
//  (c) 1994-6 The Duck Corporation. All Rights Reserved.
//
//  re-worked for Duck: Dan Miller 12/94
//  decode re-worked for Duck's DOS Player: Eric Ameres 12/94
//  reworked for everything else: Eric Ameres 94-96
//
//-------------------------------------------------------------------------;
//
//  dk4s.c
//
//
//==========================================================================;
*/

#include "duktypes.h" 

#include "dkpltfrm.h"
//#include "cduck.h"
#include <duck_hfb.h>
#include "dxl_main.h"
#include "dxl_audi.h"

#define DEBUG 0

#if DEBUG
#define DIAGNOSTIC(x) x
#else 
#define DIAGNOSTIC(x)
#endif

/* found in dkglobal.h */

extern short step[];
extern short MulTbl[16];
extern short FixTbl[16];
extern short next_step[16];

int dx4BitMono(int numToGet,unsigned char *src, short *dst, short firstNib,
			short *aiSamp,short *aiStepIndex, short *iNextInput);


int dxDK4(DXL_XAUDIOSRC_HANDLE xsrc,short *left, short *right,int nSamples)
{   
	int numGotten = nSamples;
	register int numToGet =0;
    short *nextDst;
	unsigned char *nextSrc;

    do{
		if (xsrc->finiBlock){
			xsrc->totalPos += xsrc->numChannels << 2;
				
			if (xsrc->totalPos > xsrc->length)
				return numGotten - nSamples;
				
			xsrc->aiSamp[0] = (short)*(xsrc->addr++) & 0x00FF;
			xsrc->aiSamp[0] |=  *(xsrc->addr++) << 8;
				
			xsrc->aiStepIndex[0] = (short)*(xsrc->addr++);
			xsrc->addr++;
			
			*(left++) = xsrc->aiSamp[0];
			
			if (right){
				xsrc->aiSamp[1] = (short)*(xsrc->addr++) & 0x00FF;
				xsrc->aiSamp[1] |=  *(xsrc->addr++) << 8;
				
				xsrc->aiStepIndex[1] = (short)*(xsrc->addr++);
				xsrc->addr++;		
#if AUDIOINTERLEAVED
				*(left++) = xsrc->aiSamp[1];
#else
				*(right++) = xsrc->aiSamp[1];
#endif
			}else
				xsrc->iFirstNibble = 1;

			xsrc->finiBlock = DKFALSE;
			xsrc->samplesRead = 1;
			if (--nSamples <= 0) return numGotten;
		}
		numToGet = xsrc->samplesPerBlock - xsrc->samplesRead;
		
		if (nSamples < numToGet){
			numToGet = nSamples;
			xsrc->samplesRead += nSamples;
		}else
			xsrc->finiBlock = DKTRUE;			
		
		nSamples -= numToGet;

		if (right){
			xsrc->totalPos += numToGet;
			{
			int iInput,lSamp;
			
			do{
				xsrc->iNextInput  = (short)*(xsrc->addr++);
				iInput      = (xsrc->iNextInput >> 4) & 0x0F;
				xsrc->iNextInput  &= 0x0F;
		
				lSamp = xsrc->aiSamp[0];
	        	lSamp += (	(long)step[xsrc->aiStepIndex[0]]*
					(long)MulTbl[iInput]+
					(long)FixTbl[iInput]) >> 3;
		
				if (lSamp > 32767) lSamp = 32767;
				else if (lSamp < -32768) lSamp = -32768;
	
				*(left++) = (short)lSamp;
		
				xsrc->aiStepIndex[0] += next_step[iInput];
	
				if (xsrc->aiStepIndex[0] < 0) xsrc->aiStepIndex[0] = 0;
				else if (xsrc->aiStepIndex[0] > 88) xsrc->aiStepIndex[0] = 88;
	
				xsrc->aiSamp[0] = (short)lSamp;
	/********end first *******************/
		
				lSamp = xsrc->aiSamp[1];
	        	lSamp += (	(long)step[xsrc->aiStepIndex[1]]*
					(long)MulTbl[xsrc->iNextInput]+
					(long)FixTbl[xsrc->iNextInput]) >> 3;
		
				if (lSamp > 32767) lSamp = 32767;
				else if (lSamp < -32768) lSamp = -32768;
	
#if AUDIOINTERLEAVED
				*(left++) = (short)lSamp;
#else
				*(right++) = (short)lSamp;		
#endif
				xsrc->aiStepIndex[1] += next_step[xsrc->iNextInput];
	
				if (xsrc->aiStepIndex[1] < 0) xsrc->aiStepIndex[1] = 0;
				else if (xsrc->aiStepIndex[1] > 88) xsrc->aiStepIndex[1] = 88;
	
				xsrc->aiSamp[1] = (short)lSamp;
	/*************end second *************/
			}while (--numToGet > 0);
			}
		}else{
			nextDst = left + numToGet;            
		
			xsrc->totalPos += (numToGet + xsrc->iFirstNibble)/2;
			nextSrc = xsrc->addr + ((numToGet + xsrc->iFirstNibble)/2);
			
		{
			int iInput,lSamp;
		
			lSamp = xsrc->aiSamp[0];
	        do{ 
				if (xsrc->iFirstNibble){
					xsrc->iNextInput  = (short)*xsrc->addr++;
					iInput      = (xsrc->iNextInput >> 4) & 0x0F;
					xsrc->iNextInput  &= 0x0F;
			
					xsrc->iFirstNibble = 0;
				}else{
					iInput = xsrc->iNextInput;
					xsrc->iFirstNibble = 1;
				}
				lSamp += ((long)step[xsrc->aiStepIndex[0]]*
						(long)MulTbl[iInput]+
						(long)FixTbl[iInput]) >> 3;
						
		        if (lSamp > 32767) lSamp = 32767;
				else if (lSamp < -32768) lSamp = -32768;
				
		        *(left++) = (short)lSamp;
				
				xsrc->aiStepIndex[0] += next_step[iInput];
				if (xsrc->aiStepIndex[0] < 0) xsrc->aiStepIndex[0] = 0;
				else if (xsrc->aiStepIndex[0] > 88) xsrc->aiStepIndex[0] = 88;			                          
	            
			}while (--numToGet > 0);
			 
			xsrc->aiSamp[0] = (short)lSamp;
		}
			if (numToGet & 1) xsrc->iFirstNibble ^= 1;
				
			xsrc->addr = nextSrc;
			left += numToGet;
		}
		
	}while(nSamples > 0);   
	
	return numGotten;
}
