/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
    Windows 95 Memory allocation abstraction functions
 */

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include "dkpltfrm.h"
#include "duck_mem.h"

static void *(*ptr_malloc)(size_t size) = malloc;
static void *(*ptr_calloc)(size_t, size_t size) = calloc;
static void (*ptr_free)(void *) = free;


void *duck_memset( void *dest, int c, size_t count )
{ 
    return((void *) memset(dest, c, count));
}                           
 
void *duck_malloc(size_t size, enum tmemtype fred)
{   
    void *temp;
    
    temp = (*ptr_malloc)(size);
    
    return temp;
}

void *duck_calloc(size_t n,size_t size, enum tmemtype  fred)
{   
    void *temp = (*ptr_calloc) (n, size);

    return temp;
}

void duck_free(void *old_blk) 
{  
    (*ptr_free) (old_blk);
}

void *duck_memcpy( void *dest, const void *src, size_t count )
{          
    return((void *) memcpy(dest, src, count));
}

void DXA_Setmalloc(void *(*ptr)(size_t))
{
    ptr_malloc = ptr;
}
 
void DXA_Setcalloc(void *(*ptr)(size_t, size_t))
{
    ptr_calloc = ptr;
}

void DXA_Setfree(void (*ptr)(void *))
{
    ptr_free = ptr;
}
