;   Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.
;
;   This file is part of VpVision.
;
;   VpVision is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License ver. 2,
;   as published by the Free Software Foundation (www.fsf.org).
;
;   Foobar is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with VpVision; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;/***********************************************\
;??? dk3s.asm   
;\***********************************************/ 

; 11/97 - converting dxa c routines -- see dk3s.c

        .486
        .MODEL  flat, SYSCALL, os_dos
        .CODE

IDEAL
NAME x86dk3
MASM

PUBLIC dxDK3S_
PUBLIC  _dxDK3S

INCLUDE dxl_audi.ash

AUDIOINTERLEAVED EQU 1

EXTRN _step
EXTRN _MulTbl
EXTRN _FixTbl
EXTRN _next_step

DK3B_HEADER_BYTES   EQU 16
DK3B_TYPEID         EQU 0
DK3B_VERSION        EQU 0
DK3B_EXTRA_KLUGE    EQU 1
;------------------------------------------------
CLAMP MACRO reg16, reg32, min, max
LOCAL LM1, LM2
    cmp     reg16,min                                  
    jge     LM1

    xor     reg32,reg32
    jmp     LM2

LM1:
    cmp     reg16,max
    jle     LM2

    mov     reg32,max

LM2:
ENDM
;------------------------------------------------
; int dxDK3S(DXL_XAUDIOSRC_HANDLE xsrc,short *left, short *right,int nSamples)
;
dxDK3SParams    STRUC
                dd  6 dup (?)   ;6 pushed regs
                dd  ?           ;return address
    xsrc        dd  ?       
    left        dd  ?       
    right       dd  ?       
    nSamples    dd  ?       
dxDK3SParams    ENDS
;------------------------------------------------
; local vars
;
L_left          EQU 0
L_nextSrc       EQU L_left+4
L_numToGet      EQU L_nextSrc+4
L_iFirstNibble  EQU L_numToGet+4
L_iNextInput    EQU L_iFirstNibble+4
L_numGotten     EQU L_iNextInput+4
L_n             EQU L_numGotten+4
L_diff          EQU L_n+4

L_nSamples      EQU L_diff+4
L_xsrc          EQU L_nSamples+4
L_laddr         EQU L_xsrc+4
L_stackPtr      EQU L_laddr+4
Vars            EQU (L_stackPtr+4+31) AND 0ffffffe0h
;------------------------------------------------

dxDK3S_:
_dxDK3S:
    push    esi
    push    edi
    push    ebp
    push    ebx 
    push    ecx
    push    edx

    mov     esi,[esp].xsrc   
    mov     ebp,esp                         ;save current stack ptr

    mov     ebx,[esp].left
    mov     ecx,[esp].right

    and     esp,0ffffffe0h                  ;align
    mov     edx,[ebp].nSamples

    sub     esp,Vars
    xor     edi,edi                         ;init lSamp

    xor     eax,eax
nop

    mov     L_numToGet[esp],eax
    mov     L_n[esp],eax

    mov     L_diff[esp],eax
    mov     L_iNextInput[esp],eax

    mov     ax,WORD PTR [esi].iFirstNibble
    mov     L_stackPtr[esp],ebp           
    
    mov     L_iFirstNibble[esp],eax  
    mov     L_left[esp],ebx

    mov     L_nSamples[esp],edx
    mov     L_numGotten[esp],edx

    mov     ebp,[esi].addr                          ;get source addr
nop

doSamples:
    mov     edx,[esi].finiBlock
;    mov     ebp,[esi].addr                          ;get source addr
nop
    
    test    edx,edx
    jz      numberToGet

    mov     edx,[esi].totalPos
    mov     edi,L_nSamples[esp]

    add     edx,DK3B_HEADER_BYTES
    mov     eax,L_numGotten[esp]

    mov     [esi].totalPos,edx
    mov     ecx,[esi].length
 
    cmp     edx,ecx
    jle     L1

    sub     eax,edi                                 ;return numGotten - nSamples
    jmp     theExit

L1:
    mov     ebx,6+4[ebp]                            ;get ahdr.isum (lower) and ahdr.idif (upper)
    xor     ecx,ecx

    mov     WORD PTR [esi].aiSamp0,bx
    mov     [esi].finiBlock,0                      

    mov     WORD PTR [esi].sum,bx
    mov     [esi].samplesRead,0

;    movsx   edi,bx

    sar     ebx,16                                  ;free long sign extension of idif
    xor     edx,edx

    mov     WORD PTR [esi].aiSamp1,bx
;    sub     edi,ebx                                 ;xsrc->sum - xsrc->diff
nop
    
    mov     WORD PTR [esi].diff,bx
    mov     eax,6[ebp]                              ;get ahdr.scount

    mov     WORD PTR [esi].nudiff,bx
    mov     [esi].samplesPerBlock,eax

    mov     dl,BYTE PTR 6[ebp].isumx
    xor     ebx,ebx

    mov     bl,BYTE PTR 6[ebp].idifx
    mov     DWORD PTR L_iFirstNibble[esp],1

    mov     WORD PTR [esi].aiStepIndex0,dx
    add     ebp,DK3B_HEADER_BYTES

    mov     WORD PTR [esi].aiStepIndex1,bx

numberToGet:
    mov     eax,[esi].samplesPerBlock
    mov     ebx,[esi].samplesRead

    mov     L_n[esp],ebx
    mov     L_laddr[esp],ebp

    sub     eax,ebx                                     ;calc num samples to get
    mov     edx,L_nSamples[esp]
    
    cmp     edx,eax
    jge     L4

    mov     eax,edx                                     ;numToGet = nSamples
    jmp     L5

L4:
    mov     [esi].finiBlock,1
nop

L5:
    sub     edx,eax                                 ;nSamples -= numToGet
    add     ebx,eax                                 ;xsrc->samplesRead += numToGet
    
    mov     [esi].samplesRead,ebx
    mov     L_numToGet[esp],eax

    mov     L_nSamples[esp],edx
    xor     ecx,ecx

    mov     cx, WORD PTR [esi].diff
    xor     edx,edx

    mov     dx, WORD PTR [esi].iNextInput
    mov     L_diff[esp],ecx

    mov     L_iNextInput[esp],edx
    mov     ecx,L_iFirstNibble[esp]

dxSamp:
    movsx   edi,WORD PTR [esi].aiSamp0

    xor     eax,eax
    test    ecx,ecx                                     ;xsrc->iFirstNibble ?

    mov     ax,WORD PTR [esi].aiStepIndex0
    je      not_iFirstNibble

    mov     cl,BYTE PTR [ebp]
    add     ebp,1
    
    and     ecx,0fh
    mov     eax,_step[eax*4]

    mov     edx,_MulTbl[ecx*4]
    mov     ebx,_FixTbl[ecx*4]

    imul    edx

    mov     dx,WORD PTR [esi].aiStepIndex0
    add     eax,ebx

    sar     eax,3
    mov     ebx,_next_step[ecx*4]

    add     edi,eax
    add     edx,ebx

    CLAMP   dx, edx, 0, 88
    
    mov     cl,BYTE PTR -1[ebp]
    mov     eax,L_n[esp]

    mov     WORD PTR [esi].aiStepIndex0,dx
    and     ecx,0f0h

    mov     WORD PTR [esi].aiSamp0,di
;    xor     ebx,ebx
        
    test    eax,1
    jz      L7

    mov     ebx,L_left[esp]
    xor     eax,eax

    add     ebx,4
    mov     L_iFirstNibble[esp],eax

    mov     L_left[esp],ebx
    jmp     updateLeft

L7:
    shr     ecx,4
    xor     eax,eax

    movsx   edi,WORD PTR [esi].aiSamp1

    mov     ax,WORD PTR [esi].aiStepIndex1
    mov     edx,_MulTbl[ecx*4]

    mov     eax,_step[eax*4]
    mov     ebx,_FixTbl[ecx*4]

    imul    edx

    mov     dx,WORD PTR [esi].aiStepIndex1
    add     eax,ebx

    sar     eax,3
    mov     ebx,_next_step[ecx*4]

    add     edi,eax
    add     edx,ebx

    CLAMP   dx, edx, 0, 88

    mov     WORD PTR [esi].aiStepIndex1,dx
    mov     eax,L_diff[esp]

    mov     WORD PTR [esi].aiSamp1,di
    and     edi,0ffffh

    add     eax,edi
    mov     ebx,L_left[esp]

;    sar     eax,1
    sar     ax,1
    add     ebx,4

    mov     WORD PTR L_diff[esp],ax
    mov     L_left[esp],ebx

    jmp     updateLeft

not_iFirstNibble:
    mov     cl,BYTE PTR -1[ebp]
    mov     eax,_step[eax*4]
        
    shr     ecx,4
nop

    mov     edx,_MulTbl[ecx*4]
    mov     ebx,_FixTbl[ecx*4]

    imul    edx

    mov     dx,WORD PTR [esi].aiStepIndex0
    add     eax,ebx

    sar     eax,3
    mov     ebx,_next_step[ecx*4]

    add     edi,eax
    add     edx,ebx

    CLAMP   dx, edx, 0, 88

    mov     WORD PTR [esi].aiStepIndex0,dx
    mov     eax,L_n[esp]

    mov     WORD PTR [esi].aiSamp0,di
    test    eax,1

    mov     eax,0
    jz      L8

    mov     ebx,L_left[esp]
;    mov     eax,1
    inc     eax

    add     ebx,4
    mov     L_iFirstNibble[esp],eax

    mov     L_left[esp],ebx
    jmp     updateLeft

L8:
    mov     ax,WORD PTR [esi].aiStepIndex1
nop

    mov     cl,BYTE PTR [ebp]
    add     ebp,1
    
    and     ecx,0fh
    mov     eax,_step[eax*4]

    movsx   edi,WORD PTR [esi].aiSamp1

    mov     edx,_MulTbl[ecx*4]
    mov     ebx,_FixTbl[ecx*4]

    imul    edx

    mov     dx,WORD PTR [esi].aiStepIndex1
    add     eax,ebx

    sar     eax,3
    mov     ebx,_next_step[ecx*4]

    add     edi,eax
    add     edx,ebx

    CLAMP   dx, edx, 0, 88

    mov     WORD PTR [esi].aiStepIndex1,dx
    mov     eax,L_diff[esp]

    mov     WORD PTR [esi].aiSamp1,di
    and     edi,0ffffh

    add     eax,edi
    mov     ebx,L_left[esp]

;    sar     eax,1
    sar     ax,1
    add     ebx,4

    mov     WORD PTR L_diff[esp],ax
    mov     L_left[esp],ebx

updateLeft:
    mov     ax,WORD PTR [esi].aiSamp0
    mov     edx,L_diff[esp]

    mov     cx,WORD PTR [esi].aiSamp0
    sub     ax,dx                               ;(short)SUM-diff

    shl     eax,16
    add     cx,dx                               ;(short)SUM+diff

    mov     dx,WORD PTR [esi].aiSamp1
    mov     ax,cx

    mov     -4[ebx],eax                         ;combined writes
    mov     ebx,L_n[esp]
    
    mov     WORD PTR L_diff[esp],dx
    inc     ebx

    mov     L_n[esp],ebx
    mov     eax,L_numToGet[esp]

    dec     eax
    mov     ecx,L_iFirstNibble[esp]

    mov     L_numToGet[esp],eax
    jg      dxSamp

    mov     WORD PTR [esi].diff,dx
    xor     ebx,ebx

    mov     bl,BYTE PTR -1[ebp]
    mov     eax,[esi].totalPos

    mov     WORD PTR [esi].iNextInput,bx
    mov     edx,L_laddr[esp]

    mov     WORD PTR [esi].iFirstNibble,cx
    add     eax,ebp                                 ;add in xsrc->addr

    sub     eax,edx
    mov     edx,[esi].finiBlock

    test    edx,edx
    jz      moreSamples

    add     eax,DK3B_EXTRA_KLUGE
    add     ebp,DK3B_EXTRA_KLUGE

moreSamples:
    mov     [esi].totalPos,eax
    mov     edx,L_nSamples[esp]
    
    cmp     edx,0
    jg      doSamples

    mov     eax,L_numGotten[esp]

theExit:
    mov     ebx,L_left[esp]
    mov     esp,L_stackPtr[esp]

    mov     [esi].addr,ebp

    mov     [esp].left,ebx
    mov     [esp].right,ecx

    pop     edx
    pop     ecx
    pop     ebx
    pop     ebp
    pop     edi
    pop     esi
    ret

;************************************************
         END
