;   Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.
;
;   This file is part of VpVision.
;
;   VpVision is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License ver. 2,
;   as published by the Free Software Foundation (www.fsf.org).
;
;   Foobar is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with VpVision; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;/***********************************************\
;??? dk4.asm   
;\***********************************************/ 

; 11/97 - converting dxa c routines -- see dk4.c

        .486
        .MODEL  flat, SYSCALL, os_dos
        .CODE

IDEAL
NAME x86dk4
MASM

PUBLIC dxDK4_
PUBLIC  _dxDK4

INCLUDE dxl_audi.ash

AUDIOINTERLEAVED EQU 1

EXTRN _step
EXTRN _MulTbl
EXTRN _FixTbl
EXTRN _next_step

;------------------------------------------------
; int dxDK4(DXL_XAUDIOSRC_HANDLE xsrc,short *left, short *right,int nSamples)
;
dxDK4Params    STRUC
                dd  6 dup (?)   ;6 pushed regs
                dd  ?           ;return address
    xsrc        dd  ?       
    left        dd  ?       
    right       dd  ?       
    nSamples    dd  ?       
dxDK4Params    ENDS

;------------------------------------------------
; local vars
;
L_left          EQU 0
L_right         EQU L_left+4
L_nextSrc       EQU L_right+4
L_numToGet      EQU L_nextSrc+4
L_iFirstNibble  EQU L_numToGet+4
L_numGotten     EQU L_iFirstNibble+4
L_nSamples      EQU L_numGotten+4
L_xsrc          EQU L_nSamples+4

L_stackPtr      EQU L_xsrc+4
Vars            EQU (L_stackPtr+4+31) AND 0ffffffe0h
;------------------------------------------------

dxDK4_:
_dxDK4:
    push    esi
    push    edi
    push    ebp
    push    ebx 
    push    ecx
    push    edx

    mov     esi,[esp].xsrc   
    mov     ebp,esp                         ;save current stack ptr

    mov     ebx,[esp].left
    mov     ecx,[esp].right

    and     esp,0ffffffe0h                  ;align
    mov     edx,[ebp].nSamples

    sub     esp,Vars
nop

    mov     L_stackPtr[esp],ebp             
    mov     L_xsrc[esp],esi

    mov     L_left[esp],ebx
    mov     L_right[esp],ecx

    mov     L_nSamples[esp],edx
    mov     DWORD PTR L_numToGet[esp],0

    mov     L_numGotten[esp],edx
nop

doSamples:
    mov     edx,[esi].finiBlock
    mov     edi,L_nSamples[esp]
    
    test    edx,edx
    jz      numberToGet

    mov     edx,[esi].totalPos
    mov     ebx,[esi].numChannels

    shl     ebx,2
    mov     ebp,[esi].addr                          ;get source addr

    add     edx,ebx
    mov     eax,L_numGotten[esp]

    mov     [esi].totalPos,edx
    mov     ecx,[esi].length
 
    cmp     edx,ecx
    jle     L1

    sub     eax,edi                                 ;return numGotten - nSamples
    jmp     theExit

L1:
    mov     eax,[ebp]
    mov     ebx,L_left[esp]                         ;get left ptr

    mov     WORD PTR [esi].aiSamp0,ax
    mov     ecx,eax

    shr     eax,16
    add     ebp,4                                   ;update addr

    and     eax,0ffh
nop

    mov     WORD PTR [ebx],cx
    add     ebx,2                                   ;update left ptr

    mov     WORD PTR [esi].aiStepIndex0,ax
    mov     [esi].addr,ebp

    mov     L_left[esp],ebx
    mov     eax,L_right[esp]

    test    eax,eax
    jz      L2

    mov     eax,[ebp]                               ;get source data
if AUDIOINTERLEAVED
    mov     ebx,L_left[esp]                         ;get left ptr
else
    mov     ebx,L_right[esp]                        ;get right ptr
endif

    mov     WORD PTR [esi].aiSamp1,ax
    mov     ecx,eax

    shr     eax,16
    add     ebp,4                                   ;update addr

    and     eax,0ffh
nop

    mov     WORD PTR [ebx],cx
    add     ebx,2                                   ;update left ptr

    mov     WORD PTR [esi].aiStepIndex1,ax
    mov     [esi].addr,ebp

if AUDIOINTERLEAVED
    mov     L_left[esp],ebx
else
    mov     L_right[esp],ebx
endif
    jmp     L3

L2:
    mov     WORD PTR [esi].iFirstNibble,1
nop
 
L3:
    mov     [esi].finiBlock,0                      
    mov     [esi].samplesRead,1

    dec     edi                                     ;dec nSamples
    jg      numberToGet

    mov     eax,L_numGotten[esp]                    ;ready for return value
    jmp     theExit

numberToGet:
    mov     eax,[esi].samplesPerBlock
    mov     ebx,[esi].samplesRead

    sub     eax,ebx                                     ;calc num samples to get
    mov     ebp,[esi].addr                              
    
    cmp     edi,eax
    jge     L4

    mov     eax,edi                                 ;numToGet = nSamples
    mov     ebx,[esi].samplesRead

    add     ebx,eax
    
    mov     [esi].samplesRead,ebx
    jmp     L5

L4:
    mov     [esi].finiBlock,1
nop

L5:
    sub     edi,eax                                 ;nSamples -= numToGet
    mov     L_numToGet[esp],eax

    cmp     DWORD PTR L_right[esp],0                ;is there a right?
    je      doLeft
;------------------------------------------------
doRight:
    mov     ebx,[esi].totalPos
    xor     ecx,ecx

    mov     L_nSamples[esp],edi
    add     ebx,eax                                 ;add in numToGet

    mov     [esi].totalPos,ebx
    xor     ebx,ebx

dxSamp1:
    mov     bl,BYTE PTR [ebp]
    xor     eax,eax

    mov     cl,BYTE PTR [ebp]                       ;get *(xsrc->addr) again
    add     ebp,1

    mov     ax,WORD PTR [esi].aiStepIndex0
    and     ebx,0fh

    shr     ecx,4                                   ;iInput
    mov     eax,_step[eax*4]

    movsx   edi,WORD PTR [esi].aiSamp0                       ;lSamp

    mov     WORD PTR [esi].iNextInput,bx
    mov     edx,_MulTbl[ecx*4]

    imul    edx

    mov     ebx,_FixTbl[ecx*4]
    xor     edx,edx

    mov     dx,WORD PTR [esi].aiStepIndex0
    add     eax,ebx

    sar     eax,3
nop

    mov     ebx,_next_step[ecx*4]
    add     edi,eax

    cmp     edi,32767
    jle     L6
    
    mov     edi,32767
    jmp     L7

L6:
    cmp     edi,-32768
    jge     L7

    mov     edi,-32768
nop

L7:
    mov     WORD PTR [esi].aiSamp0,di
    and     ebx,0ffffh                              ;clear out upper

    add     edx,ebx
    mov     ebx,L_left[esp]

    mov     WORD PTR [ebx],di
    add     ebx,2
        
    cmp     dx,0                                  ;check aiStepIndex[0]
    jge     L8

    xor     edx,edx
    jmp     L9

L8:
    cmp     dx,88
    jle     L9

    mov     edx,88

L9:
    mov     cx,WORD PTR [esi].iNextInput
    xor     eax,eax

    mov     ax,WORD PTR [esi].aiStepIndex1   
    mov     L_left[esp],ebx    

    mov     WORD PTR [esi].aiStepIndex0,dx
    mov     eax,_step[eax*4]

    movsx   edi,[esi].aiSamp1

    mov     edx,_MulTbl[ecx*4]
    mov     ebx,_FixTbl[ecx*4]

    imul    edx

    mov     dx,WORD PTR [esi].aiStepIndex1
    add     eax,ebx

    sar     eax,3
    and     edx,0ffffh                              ;just to make sure upper is cleared

    mov     ebx,_next_step[ecx*4]
    add     edi,eax

    cmp     edi,32767
    jle     L10
    
    mov     edi,32767
    jmp     L11

L10:
    cmp     edi,-32768
    jge     L11

    mov     edi,-32768
nop

L11:
    mov     WORD PTR [esi].aiSamp1,di
    and     ebx,0ffffh                              ;clear out upper

    add     edx,ebx                                 ;update aiStepIndex[1]
if AUDIOINTERLEAVED
    mov     ebx,L_left[esp]                         ;get left ptr
else
    mov     ebx,L_right[esp]                        ;get right ptr
endif

    mov     WORD PTR [ebx],di                       ;write right or left
    add     ebx,2
        
    cmp     dx,0                                  ;check aiStepIndex[1]
    jge     L12

    xor     edx,edx
    jmp     L13

L12:
    cmp     dx,88
    jle     L13

    mov     edx,88

L13:
    mov     WORD PTR [esi].aiStepIndex1,dx
    xor     ecx,ecx

if AUDIOINTERLEAVED
    mov     L_left[esp],ebx
else
    mov     L_right[esp],ebx
endif
    mov     eax,L_numToGet[esp]

    xor     ebx,ebx
    dec     eax

    mov     L_numToGet[esp],eax
    jg      dxSamp1

    mov     [esi].addr,ebp
nop

    mov     eax,L_nSamples[esp]
    jmp     moreSamples
;------------------------------------------------
doLeft:
    mov     L_nSamples[esp],edi
    xor     ecx,ecx

    mov     cx, WORD PTR [esi].iFirstNibble
;    xor     edi,edi

    movsx     edi,WORD PTR [esi].aiSamp0                       ;init lSamp

    add     eax,ecx                                         ;numToGet + xsrc->iFirstNibble
;nop

    sar     eax,1
    mov     edx,[esi].totalPos

    add     edx,eax                                         ;update total Pos
    add     eax,ebp                                         ;add in xsrc->addr

    mov     L_nextSrc[esp],eax
    xor     ebx,ebx

    mov     [esi].totalPos,edx
    xor     edx,edx

dxSamp2:
    xor     eax,eax
    test    ecx,ecx                                     ;xsrc->iFirstNibble ?

    mov     ax,WORD PTR [esi].aiStepIndex0
    je      L14

    mov     bl,BYTE PTR [ebp]
    xor     ecx,ecx                                     ;xsrc->iFirstNibble = 0

    mov     dl,BYTE PTR [ebp]
    and     ebx,0f0h

    shr     ebx,4
    and     edx,0fh

    mov     WORD PTR [esi].iNextInput,dx
    add     ebp,1

    mov     L_iFirstNibble[esp],ecx
    jmp     L15

L14:
    mov     bx,WORD PTR [esi].iNextInput                ;get new iInput
    mov     ecx,1                                       ;xsrc->iFirstNibble = 1

    mov     L_iFirstNibble[esp],ecx
    and     ebx,0ffffh                                  ;make sure upper is cleared

L15:
    mov     ecx,_next_step[ebx*4]              
    mov     edx,_step[eax*4]

    add     ecx,eax
    mov     eax,_MulTbl[ebx*4]
    
    mov     ebx,_FixTbl[ebx*4]
    and     ecx,0ffffh                                  ;only interested in lower 16

    imul    edx

    add     eax,ebx
    mov     ebx,L_left[esp]

    sar     eax,3
    add     ebx,2

    add     edi,eax
    mov     L_left[esp],ebx

    cmp     edi,32767
    jle     L16
    
    mov     edi,32767 
    jmp     L17

L16:
    cmp     edi,-32768
    jge     L17

    mov     edi,-32768
nop

L17:
    mov     WORD PTR -2[ebx],di                         ;write lSamp to left
    mov     eax,L_numToGet[esp]

;    cmp     cx,0                                   ;check aiStepIndex[0]
;    jge     L18

    test    ecx,8000h                               ;check sign of aiStepIndex[0]
    jz      L18

    xor     ecx,ecx
    jmp     L19

L18:
    cmp     ecx,88 
;    cmp     cx,88
    jle     L19

    mov     ecx,88

L19:
    mov     WORD PTR [esi].aiStepIndex0,cx
    dec     eax

    mov     L_numToGet[esp],eax
nop

    mov     ecx,L_iFirstNibble[esp]
    jg      dxSamp2

    mov     WORD PTR [esi].iFirstNibble,cx
nop

    test    eax,1
    jz      L20

    xor     WORD PTR [esi].iFirstNibble,1
         
L20:
    mov     ecx,L_nextSrc[esp]
    mov     ebx,L_numToGet[esp]

    mov     eax,L_nSamples[esp]
    mov     edx,L_left[esp]

    mov     WORD PTR [esi].aiSamp0,di
    add     edx,ebx

    mov     L_left[esp],edx
    mov     [esi].addr,ecx

moreSamples:
    cmp     eax,0
    jg      doSamples

    mov     eax,L_numGotten[esp]

theExit:
    mov     ebx,L_left[esp]
    mov     ecx,L_right[esp]

    mov     esp,L_stackPtr[esp]

    mov     [esp].left,ebx
    mov     [esp].right,ecx

    pop     edx
    pop     ecx
    pop     ebx
    pop     ebp
    pop     edi
    pop     esi
    ret

;************************************************
         END
