/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CAPPSERVICES_H_
#define CAPPSERVICES_H_

#include	<MegaHeaders.h>
#include	<nmr_string.h>
#include	<map.h>
#include	<CCMutex.h>
#include	<CError.h>

#ifdef	NEEDS_STL_ALLOCATOR
typedef map<nmr_string,nmr_string,less<nmr_string>,allocator<nmr_string> > ArgMap_t;
#else
typedef map<nmr_string,nmr_string,less<nmr_string> > ArgMap_t;
#endif

class CAppServices
{
	CLASS_NOCOPY(CAppServices)

protected:
	ArgMap_t mArgTable;
	CCMutex	mArgTableMutex;
	nmr_string	mAppName;

public:
	CAppServices(void);
	~CAppServices(void);

	void	Daemonize(void);
	void	ExtractArgs(int argc,char *argv[]);
	void	ExtractArgs(char *arg);
	int		HasArg(const char *arg);
	nmr_string	GetArgAsString(const char *arg);
	int		GetArgAsInt(const char *arg);
	unsigned long GetArgAsUnsignedLong(const char *arg);
	nmr_string	GetAppName(void);

	CERROR_SUBCLASS(DaemonizeException);
};

#endif
