/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CCMUTEX_H_
#define CCMUTEX_H_

#include	<MegaHeaders.h>
#include	<CError.h>

class CConditionVariable;

class CCMutex  
{
	CLASS_NOCOPY(CCMutex)

protected:
#ifdef	 WIN32
	HANDLE				mMutex;
#elif __POWERPC__
	int					mMutex;
#else
	pthread_mutex_t 	mMutex;
#endif

public:
					CCMutex(void);
	virtual 		~CCMutex(void);
	void			Lock(void);
	void			Unlock(void);
	int				TryLock(void);
	int				TryLock(int milli_timeout);
	virtual	void	Dump(ostream &o,const char *indent) const;

	CERROR_SUBCLASS(CtorException);
	CERROR_SUBCLASS(DtorException);
	CERROR_SUBCLASS(LockException);
	CERROR_SUBCLASS(UnlockException);
	CERROR_SUBCLASS(TryLockException);

	friend CConditionVariable;
};

ostream& operator<<(ostream &o,CCMutex &m);
ostream& operator<<(ostream &o,CCMutex *m);


#endif
