/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CCONDITIONVARIABLE_H_
#define CCONDITIONVARIABLE_H_

#include	<CCMutex.h>

class CConditionVariable 
{
	CLASS_NOCOPY(CConditionVariable)

protected:

#ifdef	WIN32
	HANDLE			mCondition;
#elif __POWERPC__
	int				mCondition;
#else
	pthread_cond_t	mCondition;
#endif

public:
					CConditionVariable(void);
	virtual 		~CConditionVariable(void);
	void			Wait(CCMutex &mutex);
	void			WaitInterval(CCMutex &mutex,int sec);
	void			Signal(void);
	void			Broadcast(void);
	virtual	void	Dump(ostream &o,const char *indent) const;

	CERROR_SUBCLASS(CtorException);
	CERROR_SUBCLASS(DtorException);
	CERROR_SUBCLASS(WaitException);
	CERROR_SUBCLASS(TimeoutException);
	CERROR_SUBCLASS(SignalException);
	CERROR_SUBCLASS(BroadcastException);
};

ostream& operator << (ostream &o,CConditionVariable &c);
ostream& operator << (ostream &o,CConditionVariable *c);

#endif
