/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CECHOSERVICE_H_
#define	CECHOSERVICE_H_

#include	<CMosMessage.h>
#include	<CMosMessageType.h>
#include	<CFsmTcpService.h>
#include	<CTCPSocket.h>


class CEchoService: public CFsmTcpService
{
	CLASS_NOCOPY(CEchoService)

private:
	SOCKET		mFileDescriptor;
	CTCPSocket	*mSocket;
	int			mDone;

	static state_table_entry_t	sStateTable[];

	void	CB_Init(CMosMessage *message);
	void	CB_Echo(CMosMessage *message);
	void	CB_Close(CMosMessage *message);

#ifdef	WIN32
	void	CB_Open(CMosMessage *message);
#else
	void	CB_Open(CMosMessageType<SOCKET> *message);
#endif

public:
	CEchoService(int queue_size,CTcpServer *server);
	virtual	~CEchoService(void);
	virtual	void	Terminate(void);

	MEP(Init);
	MEP(INT_Error);
	MEP(IO_Error);
	MEP(Echo);
	MEP(Done);
	MEP1(Open,SOCKET);

	virtual const char *Name(void);
	virtual	void	Dump(ostream &o,const char *indent);
};

#endif
