/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CERROR_H_
#define CERROR_H_

#include <iostream>
using namespace std;

#define	MAX_CERROR_MESSAGE_SIZE 255

class CError
{
protected:
	char 	mData[MAX_CERROR_MESSAGE_SIZE + 1];
	int		mCode;
public:
						CError(void);
						CError(const char *s,int code);
						CError(const CError &err,int code);
	virtual 			~CError(void);

	virtual CError& 	operator=(const CError &err);
	virtual CError&		operator=(const char *s);
	virtual	CError&		operator=(int code);

	virtual int			length(void) 	const;
	virtual const char*	data(void) 		const;
	virtual	int			code(void)		const;

	virtual	void		Dump(ostream& o,const char *indent) const;
};

ostream& operator<<(ostream &o,const CError &err);
ostream& operator<<(ostream &o,const CError *err);

#define	CERROR_SUBCLASS(c) \
	class c : public CError \
		{ \
		public:\
			c(const char *s,int code): CError(s,code){};\
			c(void): CError(){};\
			c(const c &cc,int code): CError(cc,code){};\
		}

#endif
