/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CFSM_H_
#define CFSM_H_

#include	<CMos.h>
#include	<CMosMessage.h>
#include	<CMosMessageType.h>

class CFsm: public CMos
{
	CLASS_NOCOPY(CFsm)

public:

	typedef void (CFsm::*fsm_callback_t)(CMosMessage *);

	typedef struct {
		int				mNextState;
		fsm_callback_t	mAction;
	} state_stub_t,*state_stub_ptr_t;

	typedef struct {
		int				mCurrentState;
		int				mTransition;
		int				mNextState;
		fsm_callback_t	mAction;
	} state_table_entry_t,*state_table_entry_ptr_t;

protected:
	int			mCurrentState;
	int			mMaxEvent;
	int			mMaxState;
	state_stub_t **mStateTable;
	virtual	void		Null_Callback(CMosMessage *message);
	virtual	void		EventOutOfBounds(CMosMessage *message);
	virtual void		MessageHandler(CMosMessage *mess);
	virtual	void		TraceCallback(const char *name);

public:
	CFsm(int max_queue_size);
	~CFsm(void);
	void	ClearStateTable(void);
	void	AttachStateTable(state_table_entry_t *table,int num_entries);

	virtual	const char *Name(void);
	virtual	void	Dump(ostream &o,const char *indent);
};

#define	FCT(x)	((fsm_callback_t)&x)

#define MESSAGE_ENTRY_POINT(mess) \
private:	static const int MESS_ ## mess; \
public:		void SEND_MESS_ ## mess(void) \
				{SendMessage(new CMosMessage(MESS_ ## mess));}

#define	MESSAGE_DECLARE(obj,mess,val) \
	const int obj ## :: ## MESS_ ## mess = val;

#define MESSAGE_ENTRY_POINT1(mess,t1) \
private:	static const int MESS_ ## mess; \
public:		void SEND_MESS_ ## mess(t1* p1) \
				{SendMessage(new CMosMessageType< t1 >(MESS_ ## mess,p1));}

#define MEP		MESSAGE_ENTRY_POINT
#define MEP1	MESSAGE_ENTRY_POINT1
#define MD		MESSAGE_DECLARE

#endif
