/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CIOUDATA_H_
#define CIOUDATA_H_

#include	<MegaHeaders.h>
#include	<CCMutex.h>
#include	<CConditionVariable.h>

template <class T>
class CIOUData
{
private:
	// NOT ALLOWED
	// using the CLASS_NOCOPY macro doesnt work on mac

	CIOUData(const CIOUData<T> &data);
	CIOUData<T>& operator=(const CIOUData<T> &data);

protected:
	T					*mData;
	int					mDataAttached;
	CCMutex				mMutex;
	CConditionVariable	mWait;
	int					mDataReady;

public:
			CIOUData(void);
			CIOUData(T *data);
	virtual	~CIOUData(void);
	virtual	T*	Redeem(void);
	virtual	T* 	Redeem(int interval);
	virtual	void		Fulfill(T *data);
};


#endif


