/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CLOGGER_H_
#define CLOGGER_H_

#include	<MegaHeaders.h>
#include	<CMos.h>
#include	<CCMutex.h>
#include	<nmr_string.h>

class CLogger: public CMos
{
	CLASS_NOCOPY(CLogger)

protected:
	int				mLog;
	int 			mFileDes;
	int				mSyslogPriority;
	nmr_string		mIdent;
	static CCMutex	sLogMutex;
#ifdef	__POWERPC__
	CCMutex			mTimeLock; // POWERPC. Non-reentrant
#endif

public:
						CLogger(int maxmessages,int log,int filedes,
									int syslog_priority,const char *ident);
	virtual 			~CLogger(void);
			void		SendMessage(const char *message);
	virtual	void		MessageHandler(CMosMessage *message);

	virtual	const char* Name(void);
	virtual	void		Dump(ostream &o,const char *indent);
};

extern CLogger	*gErrorLog;
extern CLogger	*gTraceLog;
extern CLogger	*gLogLog;
#endif
