/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CMOS_H_
#define CMOS_H_

#include	<CCThread.h>
#include	<CFifo.h>
#include	<CCMutex.h>

class CMosMessage;

#define	TERMINATE_JOIN_DELETE_CLEAR(x)\
	if (x)\
		{\
		x->Terminate();\
		JOIN_DELETE_CLEAR(x);\
		}


class CMos : public CCThread 
{
	CLASS_NOCOPY(CMos)


protected:
	static void SignalCatch(int sig);

protected:
	int		mTerminate;
	int		mNoMoreMessages;
	CCMutex	mNoMoreMutex;

	CFifo<CMosMessage*>	mMessageQueue;
	virtual	void		Run(void);
			void		_MessageHandler(CMosMessage *message);
			void		RemoveMosFromTable(void);
			void		AddMosToTable(void);
	virtual	void		InstallSignalHandlers(void);
			int			InMosList(void);
public:

	static int			sSigKill;
	static int			sSignal;

	static	void		TerminateAll(void);

						CMos(int maxMessages);
	virtual				~CMos(void);
	virtual	void		Start(void);
	void				SendMessage(CMosMessage *message);
			int			SendMessageIfSpaceElseBlock(CMosMessage *message,
																int percent);
			int			SendMessageIfSpaceElseFail(CMosMessage *message,
																int percent);
	virtual	void		MessageHandler(CMosMessage *message) = 0;
	virtual	void		Terminate(void);
			int			MessageQueuePercentFull(void) const;
			int			NumObjectsInQueue(void) const;

	virtual const char *Name(void);
	virtual	void		Dump(ostream &o,const char *indent);
};

#endif

