/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CMOSMESSAGE_H_
#define CMOSMESSAGE_H_

#include	<MegaHeaders.h>
using namespace std;

#define CMOS_SYS_INVALID_EVENT 	0
#define CMOS_SYS_INIT_OK		1
#define CMOS_SYS_OPEN			2
#define CMOS_SYS_CLOSE			3
#define CMOS_SYS_IO_ERROR		4
#define CMOS_SYS_INTERNAL_ERROR	5
#define CMOS_SYS_TERMINATE		6

#define CMOS_SYS_FIRST_USER_EVENT 11


class CMosMessage
{
	CLASS_NOCOPY(CMosMessage)

protected:
	int	mCode;

public:
					CMosMessage(int code);
	virtual			~CMosMessage(void);
			int		GetCode(void);
	virtual	void	DetachData(void);

	static	void *	operator new(size_t s);
	static	void 	operator delete(void *d);

	virtual void	Dump(ostream &o,const char *indent) const;
};

ostream& operator << (ostream &o,CMosMessage &m);
ostream& operator << (ostream &o,CMosMessage *m);

#endif
