/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include	<CPacketSimple.h>
#include	<nmr_string.h>

/******************************************************************************
CPacketSimple
	Useable packet type that has no data
******************************************************************************/

///////////////////////////////////////////////////////////////////////////////
// CPacketSimple
//
// Constructor
//
// INPUT:
//	code 			- the message code
//	packet_type 	- the packet type
//	protocol_code 	- the protocol sending this packet
///////////////////////////////////////////////////////////////////////////////
CPacketSimple::CPacketSimple(int code,int packet_type,int protocol_code)
	: CPacket(code,packet_type,protocol_code)
{
}

///////////////////////////////////////////////////////////////////////////////
// ~CPacketSimple
//
// Destructor
///////////////////////////////////////////////////////////////////////////////
CPacketSimple::~CPacketSimple(void)
{
}

///////////////////////////////////////////////////////////////////////////////
// _Creator
//
// static function that creates a packet of type CPacketSimple. Used when
// registering the packet with the packet subsystem
//
// INPUT:
//	code 			- the message code
//	packet_type 	- the packet type
//	protocol_code 	- the protocol sending this packet
///////////////////////////////////////////////////////////////////////////////
CPacket*
CPacketSimple::_Creator(int code,int packet_type,int protocol_code)
{
	return new CPacketSimple(code,packet_type,protocol_code);
}

void
CPacketSimple::_Read(CTCPSocket &socket)
{
}

void
CPacketSimple::_Write(CTCPSocket &socket)
{
}

size_t
CPacketSimple::CalculateSize(void)
{
	return CPacket::CalculateSize();
}

const char *
CPacketSimple::Name(void)
{
	return "CPacketSimple";
}

void
CPacketSimple::Dump(ostream &o,const char *indent)
{
	nmr_string	nmr(indent);
	nmr += "   ";

	o << indent << "CPacketSimple: " << endl;
	CPacket::Dump(o,nmr);
}

