/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CPACKETTYPE_H_
#define CPACKETTYPE_H_

#include	<CPacket.h>

template <class T> class CPacketType: public CPacket
{
private:
	// not allowed
	// CLASS_NOCOPY macro doesn't work on mac
	CPacketType(const CPacketType<T> &p);
	CPacketType<T>& operator=(const CPacketType<T> &p);

protected:
	T	*mData;
	int	mDetached;

	virtual	void	_Read(CTCPSocket &socket);
										
	virtual	void	_Write(CTCPSocket &socket);

public:
	static CPacket* _Creator(int code,int packet_type,int protocol_code);

	CPacketType(int code,int packet_type,int protocol_code);
	CPacketType(int code,int packet_type,int protocol_code,T* data);
	virtual ~CPacketType(void);

			T*		GetData(void);
			void	SetData(T* t);
	virtual	void	DetachData(void);
	virtual	size_t	CalculateSize(void);

	virtual	const char *Name(void);	// not automatic you must define this
	virtual	void	Dump(ostream &o,const char *indent);
};


#endif
