/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CPORTMONITOR_H_
#define	CPORTMONITOR_H_

#include	<CMos.h>
#include	<CCMutex.h>

class CTCPSocket;
class CProtocol;
class CMosMessage;


class CPortMonitor : public CMos
{
	CLASS_NOCOPY(CPortMonitor)

protected:
	typedef	CProtocol* protocol_map_entry;
	typedef	protocol_map_entry	*Dispatch_Table_t;

	CCMutex				mDispatchTableMutex;
	CTCPSocket			*mSocket;
	Dispatch_Table_t	mDispatchTable;
	int					mDispatchTableMax;
	int					mErrorInducedIgnore;
	int					mIgnoreErrors;
	
	void	SendToAllInDispatch(int code);

public:
					CPortMonitor(int queue_size,CTCPSocket *socket);
	virtual			~CPortMonitor(void);
	virtual	int		RegisterProtocol(CProtocol *protocol);
	virtual	void	MessageHandler(CMosMessage *mess);
	virtual	void	Fetch(void);
	virtual	void	Terminate(void);
	virtual	void	SetIgnoreErrors(int i);

	virtual const char *Name(void);
	virtual	void	Dump(ostream &o,const char *indent);
};

#endif
