/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CPORTTRANSMITTER_H_
#define	CPORTTRANSMITTER_H_

#include	<CMos.h>

class CTCPSocket;
class CProtocol;
class CPacket;

class CPortTransmitter: public CMos 
{
	CLASS_NOCOPY(CPortTransmitter)

protected:
	CTCPSocket	*mSocket;
	int		mErrorInducedIgnore;
	int		mIgnoreErrors;

	virtual void		RawSendPacket(CPacket *p);
public:
			CPortTransmitter(int queue_size,CTCPSocket *socket);
	virtual	~CPortTransmitter(void);

	void	MessageHandler(CMosMessage *message);
	void	SendPacket(CProtocol *who,CPacket *p);
	void	SendPacketImmediately(CProtocol *who,CPacket *p);
	int		SendPacketIfSpaceElseBlock(CProtocol *who,CPacket *p,int percent);
	virtual	void	SetIgnoreErrors(int i);
	virtual	void	Terminate(void);
	virtual const char *Name(void);
	virtual	void	Dump(ostream &o,const char *indent);
};


class CPTData {
protected:
	CProtocol	*mWho;
	CPacket		*mPacket;
	CPTData(CProtocol *who,CPacket *p);
public:
	~CPTData(void);

	virtual	void	Dump(ostream &o,const char *indent);
friend CPortTransmitter;
};

ostream& operator<<(ostream &o,CPTData &c);
ostream& operator<<(ostream &o,CPTData *c);

#endif
