/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CTCPSOCKET_H_
#define CTCPSOCKET_H_

#include	<MegaHeaders.h>
#include	<nmr_string.h>
#include	<CSocket.h>

class CTCPSocket: public CSocket
{
	CLASS_NOCOPY(CTCPSocket)

public:
							CTCPSocket(void);
							CTCPSocket(SOCKET socket_descriptor);
	virtual					~CTCPSocket(void);

	virtual	void			Listen(int backlog);
	virtual	SOCKET			Accept(void);
	virtual	void			Connect(unsigned long addr,int port);
	virtual	void			Connect(const char *host_addr,int port);
	virtual	unsigned long	GetPeerAddress(void);
	virtual	void			Read(char *data,int len);
	virtual	void			Write(const char *data,int len);
			void			SetOption_Linger(bool onoff,int duration);
			void			SetOption_NoDelay(bool b);

	virtual	const char *	Name(void);
	virtual	void			Dump(ostream &o,const char *indent);

	CERROR_SUBCLASS(CtorException);
	CERROR_SUBCLASS(ConnectException);
	CERROR_SUBCLASS(ListenException);
	CERROR_SUBCLASS(AcceptException);
	CERROR_SUBCLASS(WriteException);
	CERROR_SUBCLASS(ReadException);
	CERROR_SUBCLASS(GetPeerException);

};

CTCPSocket &operator <<(CTCPSocket &s,I16 i);
CTCPSocket &operator <<(CTCPSocket &s,U16 i);
CTCPSocket &operator <<(CTCPSocket &s,I32 l);
CTCPSocket &operator <<(CTCPSocket &s,U32 l);
CTCPSocket &operator <<(CTCPSocket &s,I8 c);
CTCPSocket &operator <<(CTCPSocket &s,U8 c);
CTCPSocket &operator <<(CTCPSocket &s,nmr_string c);

CTCPSocket &operator >>(CTCPSocket &s,I16 &i);
CTCPSocket &operator >>(CTCPSocket &s,U16 &i);
CTCPSocket &operator >>(CTCPSocket &s,I32 &l);
CTCPSocket &operator >>(CTCPSocket &s,U32 &l);
CTCPSocket &operator >>(CTCPSocket &s,I8 &c);
CTCPSocket &operator >>(CTCPSocket &s,U8 &c);
CTCPSocket &operator >>(CTCPSocket &s,nmr_string &c);

size_t	CalculateTCPSize(I8 &i);
size_t	CalculateTCPSize(U8 &i);
size_t	CalculateTCPSize(I16 &i);
size_t	CalculateTCPSize(U16 &i);
size_t	CalculateTCPSize(I32 &i);
size_t	CalculateTCPSize(U32 &i);
size_t	CalculateTCPSize(nmr_string &i);

#endif
