/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include	<CTcpService.h>
#include	<CTcpServer.h>

/******************************************************************************
	A TCPService is an abstract object that handles connections
    from the TcpServer object
******************************************************************************/

///////////////////////////////////////////////////////////////////////////////
// CTcpService
//
// Constructor
//
// INPUT:
//	server - the CTcpServer that gives connections to this object
///////////////////////////////////////////////////////////////////////////////
CTcpService::CTcpService(CTcpServer *server)
{
	mServer = server;
}

///////////////////////////////////////////////////////////////////////////////
// ~CTcpService
//
// Destructor
///////////////////////////////////////////////////////////////////////////////
CTcpService::~CTcpService(void)
{
}

///////////////////////////////////////////////////////////////////////////////
// MakeAvailable
//
// Makes this Service Available to the CTcpServer. Don't forget to 
// call this after you are done as well.
///////////////////////////////////////////////////////////////////////////////
void
CTcpService::MakeAvailable(void)
{
	mServer->AddTcpService(this);
}


///////////////////////////////////////////////////////////////////////////////
// 	SEND_MESS_Open(int *file_descriptor)
//
// Abstract. This is called by the CTcpServer when it wants you to handle
// a connection.
//
// INPUT:
//	file_descriptor - pointer to the file descriptor for the connection
//		(do not delete, the CTcpServer takes care of that)
///////////////////////////////////////////////////////////////////////////////

const char *
CTcpService::Name(void)
{
	return "CTcpService";
}

void
CTcpService::Dump(ostream &o,const char *indent)
{
	// do not dump server or we go into infinite loop
}
