/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	CUDPSOCKET_H_
#define CUDPSOCKET_H_

#include	<CSocket.h>

class CUDPSocket: public CSocket
{
	CLASS_NOCOPY(CUDPSocket)

protected:
	struct	sockaddr_in		mSendPeer;
	struct	sockaddr_in		mReceivePeer;

		void	_SetPeer(struct sockaddr_in &s,unsigned long addr,int port);
		void	_ClearPeers(void);

public:
							CUDPSocket(void);
							CUDPSocket(SOCKET socket_descriptor);
	virtual					~CUDPSocket(void);
	virtual	void			SetSendPeer(unsigned long addr,int port);
	virtual	void			SetReceivePeer(unsigned long addr,int port);
	virtual	void			GetSendPeer(unsigned long &addr,int &port);
	virtual	void			GetReceivePeer(unsigned long &addr,int &port);
			int				RecvFrom(char *data,int len);
			void			SendTo(const char *data,int len);
	virtual	const char *	Name(void);
	virtual	void			Dump(ostream &o,const char *indent);

	CERROR_SUBCLASS(CtorException);
	CERROR_SUBCLASS(SendException);
	CERROR_SUBCLASS(RecvException);
};

#endif
