/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	MAC_SOCKETS_H_
#define MAC_SOCKETS_H_
#ifdef	__POWERPC__
#include	<OpenTransport.h>
#include	<OpenTptInternet.h>

// bogus unix style berkely definitions
typedef long	SOCKET;

#define	INADDR_ANY	0

#define	htonl(x)	(x)
#define	htons(x)	(x)
#define	ntohl(x)	(x)
#define	ntohs(x)	(x)

typedef	 unsigned long	u_long;
typedef	unsigned short	u_short;

typedef struct hostent
{
	unsigned long addr;
	unsigned long *h_addr;
};

typedef struct addr_block
{
	unsigned long s_addr;
};


typedef struct sockaddr
{
	int 				sin_family;
	struct addr_block 	sin_addr;
	int					sin_port;
};

typedef struct linger
{
	int l_onoff;
	int l_linger;
};

typedef struct imr_sub
{
	unsigned long s_addr;
};

typedef struct ip_mreq
{
	struct imr_sub	imr_multiaddr;
	struct imr_sub	imr_interface;
};


#define	sockaddr_in	sockaddr

//#define	AF_INET			0

#define	SOCK_STREAM		0
#define	SOCK_DGRAM		1

#define	SOL_SOCKET 		0
#define	IPPROTO_TCP		1
#define IPPROTO_IP		2

#define SO_RCVBUF			20
#define	SO_SNDBUF			21
#define	SO_REUSEADDR		22
#define	SO_LINGER			23
//#define	TCP_NODELAY			4
//#define	IP_MULTICAST_TTL	5

SOCKET th_socket_socket(int domain,int type,int protocol);
int	th_socket_close(SOCKET &s);
int th_socket_bind(SOCKET s,struct sockaddr *,int len);
int th_socket_listen(SOCKET s,int backlog);
SOCKET th_socket_accept(SOCKET s,struct sockaddr *,int *len);
int th_socket_connect(SOCKET s,struct sockaddr *,int len);
int th_socket_getsockname(SOCKET s,struct sockaddr *,int *len);
int th_socket_getpeername(SOCKET s,struct sockaddr *,int *len);
int th_socket_setsockopt(SOCKET s,int level,int name,char *val,int len);
int th_socket_getsockopt(SOCKET s,int level,int name,char *val,int *len);
int th_socket_send(SOCKET s,const char *buf,int len,int flags);
int th_socket_recv(SOCKET s,char *buf,int len,int flags);
int th_socket_sendto(SOCKET s,const char *buf,int len,int flags,
						struct sockaddr *,int slen);
int th_socket_recvfrom(SOCKET s,char *buf,int len,int flags,
						struct sockaddr *,int *slen);
int	th_socket_errno(void);
// intentionally unsafe, like Unix
struct hostent *th_socket_gethostbyname(const char *);
unsigned long th_socket_inet_addr(const char *name);

#endif
#endif
