/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	MEGAHEADERS_H_
#define MEGAHEADERS_H_

// duktypes provides us with U8, U16 etc
#ifndef NODUKTYPES
#include	<duktypes.h>
#else
typedef unsigned char U8;
typedef unsigned short U16;
typedef unsigned long U32;
typedef signed char I8;
typedef short I16;
typedef long I32;
/*
//typedef int Boolean;
*/
typedef unsigned char uchar;
/*typedef unsigned short ushort;*/
typedef unsigned long ulong;
#endif

#ifdef	WIN32
#define _wind_h
#ifdef	_AFXDLL
#include <afxwin.h>
#else
#include	<windows.h>
#endif
#include <mmsystem.h>
#include	<winsock.h>
#include	<io.h>
#include	<fcntl.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<process.h>
//#include	<strstrea.h>
//#include	<bool.h>
#include	<strtok_r.h>
#define NEEDS_INSTANTIATIONS
#define	IO_write	write
#define	IO_open		open
#define	IO_close	close
#define	IO_read		read
#define	IO_seek		lseek
#define	S_IREAD			_S_IREAD
#define	S_IWRITE		_S_IWRITE
#define	STDOUT_FILENO	1
typedef  __int64 I64;
typedef  unsigned __int64 U64;
// unix syslog constants
#define	LOG_ERR		0
#define	LOG_INFO	1
#define	LOG_DEBUG	2
#define invert2(x) (x)
#define invert4(x) (x)


#elif __POWERPC__
#define invert2(x) ( (((x)>>8)&0x00ff) | (((x)<<8)&0xff00) )
#define invert4(x) ( ((invert2(x)&0x0000ffff)<<16) | (invert2((x>>16))&0x0000ffff) )
#include	<unistd.h>
#include	<errno.h>
#include	<sstream>
#include	<strtok_r.h>
#include	<stdarg.h>
#include	<Mac_Sockets.h>
#include	<Mac_IO.h>
#define	IO_write	th_io_write
#define IO_open		th_io_open
#define	IO_close	th_io_close
#define	IO_read		th_io_read
#define	IO_seek		th_io_seek
#define	S_IREAD		0
#define	S_IWRITE	0
#define	STDOUT_FILENO	1
// unix syslog constants
#define	LOG_ERR		0
#define	LOG_INFO	1
#define	LOG_DEBUG	2

#define	NEEDS_STL_ALLOCATOR
#define NEEDS_INSTANTIATIONS
#define _REENTRANT
typedef	long long I64;
typedef unsigned long long U64;
typedef	unsigned char	u_char;
typedef unsigned short	u_short;
typedef unsigned long	u_long;

#else
// Unix headers
#include	<pthread.h>
#include	<unistd.h>
#include	<errno.h>
#include	<syslog.h>
#include	<strstream.h>
#include	<fcntl.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<sys/socket.h>
#include	<sys/uio.h>
#include	<sys/ioctl.h>
#include	<netinet/in_systm.h>
#include	<netinet/in.h>
#include	<netinet/ip.h>
#include	<netinet/ip_icmp.h>
#include	<netinet/tcp.h>
#include	<arpa/inet.h>
#include	<netdb.h>
#include	<signal.h>
#define	IO_write	write
#define	IO_open		open
#define	IO_close	close
#define	IO_read		read
#define	IO_seek		lseek
typedef long long I64;
typedef unsigned long long U64;

#define	DUCKSIGNAL	SIGUSR2

#ifdef	LINUX
#define invert2(x) (x)
#define invert4(x) (x)
#include	<strtok_r.h>
#include	<stdarg.h>
#include	<linux/fd.h>
#undef	DUCKSIGNAL
#define	DUCKSIGNAL	SIGUNUSED

#ifdef OLDLINUX
#include	<confname.h>
extern "C" { int getpeername(int,struct sockaddr*,int*);};
extern "C" { void usleep(unsigned long); };
extern "C" { int getsockname(int,struct sockaddr *,int *); };
extern "C" { int sendto(int,const void *,int, unsigned int, 
											const struct sockaddr *,int); };
extern "C" { int recvfrom(int,void *,int,unsigned int,
                                                struct sockaddr *,int *); };
// linux pthread fork is broken. Since we all this before
// starting any threads we can use the "raw" fork
extern "C" { int machdep_sys_fork(void); };
#define	fork	machdep_sys_fork
#include	<sched.h>
#endif


#define	NEEDS_INSTANTIATIONS
#endif

#ifdef	IRIX
#define invert2(x) ( (((x)>>8)&0x00ff) | (((x)<<8)&0xff00) )
#define invert4(x) ( ((invert2(x)&0x0000ffff)<<16) | (invert2((x>>16))&0x0000ffff) )
#include	<sched.h>
#endif

#ifdef	SOLARIS
#define invert2(x) ( (((x)>>8)&0x00ff) | (((x)<<8)&0xff00) )
#define invert4(x) ( ((invert2(x)&0x0000ffff)<<16) | (invert2((x>>16))&0x0000ffff) )
#include	<bool.h>
#include	<stropts.h>
// what happened to gethostid ???
extern "C" { long gethostid(void); };
#endif

#endif

// Everyone likes these headers
#include	<ctype.h>
#include	<string>
#include	<stdlib.h>
#include	<stdio.h>
#include	<time.h>
#include	<assert.h>
#include	<iostream>
#include	<fstream>

// Put this in a class to disable class copying
#define	CLASS_NOCOPY(x) \
private: \
	x(const x &); \
	x &operator=(const x &); \


#define VOXWARE_FORMAT_TAG 117
#define NEWDK3_FORMAT_TAG 0xFE0C
#define OLDDK3_FORMAT_TAG 98


#endif

