/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include	<MegaHeaders.h>
#include	<CSocket.h>
#include	<CMosMessage.h>
#include	<CMosMessageType.h>
#include	<CPacket.h>
#include	<CPacketType.h>
#include	<nmr_string.h>
#include	<CTCPSocket.h>
#include	<CDataList.h>
#include	<stack_aids.h>

#ifdef	NEEDS_INSTANTIATIONS
#define	INSTANTIATING

#include	<nmr_fraction.cpp>
#include	<CFifo.cpp>
#include	<stack_aids.cpp>
#include	<CMosMessageType.cpp>
#include	<CPacketSimple.h>
#include	<CPacketType.cpp>
#include	<CDataList.cpp>
#include	<CPortTransmitter.h>
#include	<CMessageReflectContainer.h>

template class nmr_fraction<I16>;
template class nmr_fraction<I32>;
template class nmr_fraction<I64>;

template class CFifo<CMosMessage *>;
template class stack_Deleter<CMosMessage>;
template class stack_ArrayDeleter<u_short>;
template class stack_ArrayDeleter<u_long>;
template class stack_ArrayDeleter< char >;

template class CDataList<I16>;
template class CDataList<I32>;

template class CMosMessageType<	I16			>;
template class CMosMessageType<	I32			>;
template class CMosMessageType< CDataList<I16>	>;
template class CMosMessageType< CDataList<I32>	>;
template class CMosMessageType<	SOCKET			>;
template class CMosMessageType< CPacket 		>;
template class CMosMessageType< CPTData 		>;
template class CMosMessageType< nmr_string 		>;
template class CMosMessageType< CMessageReflectContainer >;

template class CPacketType< I16 >;
template class CPacketType< I32 >;
template class CPacketType< CDataList<I16> >;
template class CPacketType< CDataList<I32>	>;
template class CPacketType< nmr_string		>;

template class CMosMessageType< CPacketSimple >;
template class CMosMessageType< CPacketType< I16	> 			>;
template class CMosMessageType< CPacketType< I32	> 			>;
template class CMosMessageType< CPacketType< CDataList<I16> > >;
template class CMosMessageType< CPacketType< CDataList<I32> >	>;
template class CMosMessageType< CPacketType < nmr_string > >;


#ifdef	WIN32
template <class T>
CFifo<T>::CFifo(const CFifo<T> &f)
{
	assert(0);
}

template <class T>
CFifo<T>&	
CFifo<T>::operator=(const CFifo<T> &f)
{
	assert(0);
	return (*this);
}
#endif

#endif

/////////////////////////////////////////////
/////////////////////////////////////////////

//// ANYTHING added here should have overloaded operators
// for TCPSocket<< TCPSocket>> and CalculateTCPSize()

const char *
CPacketType<I16>::Name(void)
{
	return "CPacketType<I16>";
}

const char *
CPacketType<I32>::Name(void)
{
	return "CPacketType<I32>";
}

const char *
CPacketType<nmr_string>::Name(void)
{
	return "CPacketType<nmr_string>";
}


const char*
CPacketType<CDataList<I16> >::Name(void)
{
	return "CPacketType<CDataList<I16>>";
}

const char *
CPacketType<CDataList<I32> >::Name(void)
{
	return "CPacketType<CDataList<I32> >";
}

const char *
CDataList<I16>::Name(void)
{
	return "CDataList<I16>";
}

const char *
CDataList<I32>::Name(void)
{
	return "CDataList<I32>";
}



