/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include	<MegaHeaders.h>
#include	<milli_sleep.h>
#include	<CError.h>
#ifdef	__POWERPC__
#include	<system_ticks.h>
#include	<CCThread.h>
#endif
#include	"danbug.h"

void milli_sleep(int milliseconds)
{
// dprintf("milli_sleep %d",milliseconds);
	// time is in millionths (micro) seconds
#if		(IRIX)
	long long naptime = (CLK_TCK * ((long long)milliseconds)) / 1000;
	if (sginap((int)naptime))
		throw MilliSleepException("milli_sleep error",-1);

#elif	(SOLARIS)
	struct	timespec	t;
	t.tv_sec = milliseconds / 1000;
	t.tv_nsec = (milliseconds - (t.tv_sec * 1000)) * 1000000;
	if (nanosleep(&t,NULL) == -1)  
		throw MilliSleepException("milli_sleep error",-1);

#elif	(WIN32)
	Sleep(milliseconds);
// dprintf("milli_sleep done");

#elif	(__POWERPC__)
	U32 start_time = timeGetTime();
	while (timeGetTime() - start_time < milliseconds) CCThread::Yield();
#else
	usleep(milliseconds * 1000);
#endif
}
