/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	NMR_ARRAY_H_
#define NMR_ARRAY_H_

class nmr_array_RangeException
{
public:
	int	mSize,mIndex;

	nmr_array_RangeException(int s,int i):mSize(s),mIndex(i){}
};


template <class T>
class nmr_array_1
{
protected:
	T*	mElements;
	int	mSize;

	nmr_array_1<T>& 
		operator=(const nmr_array_1<T> &){return *this;} // inaccessible

public:
	nmr_array_1(void) { mElements = 0; }
	void re_init(int s)
		{
		mSize = s;
		delete [] mElements;
		mElements = new T [s];
		}
	nmr_array_1(int s)
		{
		mSize = s;
		mElements = new T [s];
		}
	~nmr_array_1(void) { delete [] mElements; }
	T& operator[](const int i)
		{
		if (i >= mSize)
			throw nmr_array_RangeException(mSize,i);
		return mElements[i];
		}
	int	size(void) { return mSize;}
};

template <class T>
class nmr_array_2: public nmr_array_1<nmr_array_1<T> >
{
public:
	nmr_array_2(int s1,int s2):nmr_array_1<nmr_array_1<T> > (s1)
		{
		for (int x = 0; x < s1; ++x)
			mElements[x].re_init(s2);
		}

};


#endif

