/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#if 0
#include	<nmr_fraction.h>

	//// CONSTRUCTORS
template <class base_t>
nmr_fraction<base_t>::nmr_fraction(void)
		{
		mNumerator = 0;
		mDenominator = 1;
		}
template <class base_t>
nmr_fraction<base_t>::nmr_fraction(const nmr_fraction<base_t> &f)
		{
		mNumerator = f.mNumerator;
		mDenominator = f.mDenominator;
		}
template <class base_t>
nmr_fraction<base_t>::nmr_fraction(const base_t numerator,const base_t denominator)
		{
		mNumerator = numerator;
		mDenominator = denominator;
		}
template <class base_t>
nmr_fraction<base_t>::nmr_fraction(const base_t l)
		{
		mNumerator = l;
		mDenominator = 1;
		}

	///// ASSIGN
template <class base_t>
nmr_fraction<base_t>&	
nmr_fraction<base_t>::operator=(const nmr_fraction<base_t> &f)
		{
		mNumerator = f.mNumerator;
		mDenominator = f.mDenominator;
		return *this;
		}
template <class base_t>
nmr_fraction<base_t>&	
nmr_fraction<base_t>::operator=(const base_t l)
		{
		mNumerator = l;
		mDenominator = 1;
		return *this;
		}

	///// MATH
template <class base_t>
nmr_fraction<base_t>	
nmr_fraction<base_t>::operator+(const nmr_fraction<base_t> &f)
		{
		base_t	n1,n2;

		if (f.mDenominator == mDenominator)
			return nmr_fraction<base_t>(mNumerator + f.mNumerator,mDenominator);
		
		n1 = mNumerator * f.mDenominator;
		n2 = f.mNumerator * mDenominator;
		return nmr_fraction<base_t>(n1+n2,mDenominator * f.mDenominator);
		}
template <class base_t>
nmr_fraction<base_t>	
nmr_fraction<base_t>::operator+(base_t l)
		{
		return nmr_fraction<base_t>(mNumerator+(((base_t)l) * mDenominator),
															mDenominator);
		}

template <class base_t>
nmr_fraction<base_t>&	
nmr_fraction<base_t>::operator+=(const nmr_fraction<base_t> &f)
		{
		if (f.mDenominator == mDenominator)
			{
			mNumerator += f.mNumerator;
			}
		else
			{
			mNumerator = (mNumerator * f.mDenominator) + 
						(f.mNumerator * mDenominator);
			mDenominator *= f.mDenominator;
			}
		return *this;
		}
template <class base_t>
nmr_fraction<base_t>&	
nmr_fraction<base_t>::operator+=(base_t l)
		{
		mNumerator += (l * mDenominator);
		return *this;
		}


template <class base_t>
nmr_fraction<base_t>	
nmr_fraction<base_t>::operator-(const nmr_fraction<base_t> &f)
		{
		base_t	n1,n2;

		if (f.mDenominator == mDenominator)
			return nmr_fraction<base_t>(mNumerator - f.mNumerator,mDenominator);

		n1 = mNumerator * f.mDenominator;
		n2 = f.mNumerator * mDenominator;
		return nmr_fraction<base_t>(n1-n2,mDenominator * f.mDenominator);
		}
template <class base_t>
nmr_fraction<base_t>	
nmr_fraction<base_t>::operator-(base_t l)
		{
		return nmr_fraction<base_t>(mNumerator-(((base_t)l) * mDenominator),
															mDenominator);
		}


template <class base_t>
nmr_fraction<base_t>&	
nmr_fraction<base_t>::operator-=(const nmr_fraction<base_t> &f)
		{
		if (f.mDenominator == mDenominator)
			{
			mNumerator -= f.mNumerator;
			}
		else
			{
			mNumerator = (mNumerator * f.mDenominator) -
						(f.mNumerator * mDenominator);
			mDenominator *= f.mDenominator;
			}
		return *this;
		}
template <class base_t>
nmr_fraction<base_t>&	
nmr_fraction<base_t>::operator-=(base_t l)
		{
		mNumerator -= (l * mDenominator);
		return *this;
		}

template <class base_t>
nmr_fraction<base_t>	
nmr_fraction<base_t>::operator*(const nmr_fraction<base_t> &f)
		{
		return nmr_fraction<base_t>(mNumerator * f.mNumerator,
						mDenominator * f.mDenominator);
		}
template <class base_t>
nmr_fraction<base_t>	
nmr_fraction<base_t>::operator*(base_t l)
		{
		return nmr_fraction<base_t>(mNumerator * ((base_t)l),mDenominator);
		}


template <class base_t>
nmr_fraction<base_t>&	
nmr_fraction<base_t>::operator*=(const nmr_fraction<base_t> &f)
		{
		mNumerator *= f.mNumerator;
		mDenominator *= f.mDenominator;
		return *this;
		}
template <class base_t>
nmr_fraction<base_t>&	
nmr_fraction<base_t>::operator*=(base_t l)
		{
		mNumerator *= l;
		return *this;
		}


template <class base_t>
nmr_fraction<base_t>	
nmr_fraction<base_t>::operator/(const nmr_fraction<base_t> &f)
		{
		return nmr_fraction<base_t>(mNumerator * f.mDenominator,
						mDenominator * f.mNumerator);
		}
template <class base_t>
nmr_fraction<base_t>	
nmr_fraction<base_t>::operator/(base_t l)
		{
		return nmr_fraction<base_t>(mNumerator,mDenominator * ((base_t)l));
		}

template <class base_t>
nmr_fraction<base_t>&	
nmr_fraction<base_t>::operator/=(const nmr_fraction<base_t> &f)
		{
		mNumerator *= f.mDenominator;
		mDenominator *= f.mNumerator;
		return *this;
		}
template <class base_t>
nmr_fraction<base_t>&	
nmr_fraction<base_t>::operator/=(base_t l)
		{
		mDenominator *= l;
		return *this;
		}

template <class base_t>
nmr_fraction<base_t>	
nmr_fraction<base_t>::operator-(void)
		{
		return nmr_fraction<base_t>(-mNumerator,mDenominator);
		}
template <class base_t>
nmr_fraction<base_t>	
nmr_fraction<base_t>::operator~(void)
		{
		return nmr_fraction<base_t>(mDenominator,mNumerator);
		}


	///// EQUALITY

template <class base_t>
int		
nmr_fraction<base_t>::operator==(const nmr_fraction<base_t> &f) const
		{
		return ((mNumerator*f.mDenominator) == (f.mNumerator*mDenominator));
		}
template <class base_t>
int		
nmr_fraction<base_t>::operator==(base_t l) const
		{
		return (mNumerator == (l * mDenominator));
		}


template <class base_t>
int		
nmr_fraction<base_t>::operator>(const nmr_fraction<base_t> &f) const
		{
		return ((mNumerator*f.mDenominator) > (f.mNumerator*mDenominator));
		}
template <class base_t>
int		
nmr_fraction<base_t>::operator>(base_t l) const
		{
		return (mNumerator > (l * mDenominator));
		}

template <class base_t>
int		
nmr_fraction<base_t>::operator<(const nmr_fraction<base_t> &f) const
		{
		return ((mNumerator*f.mDenominator) < (f.mNumerator*mDenominator));
		}
template <class base_t>
int		
nmr_fraction<base_t>::operator<(base_t l) const
		{
		return (mNumerator < (l * mDenominator));
		}

template <class base_t>
int		
nmr_fraction<base_t>::operator>=(const nmr_fraction<base_t> &f) const
		{
		return ((mNumerator*f.mDenominator) >= (f.mNumerator*mDenominator));
		}
template <class base_t>
int		
nmr_fraction<base_t>::operator>=(base_t l) const
		{
		return (mNumerator >= (l * mDenominator));
		}

template <class base_t>
int		
nmr_fraction<base_t>::operator<=(const nmr_fraction<base_t> &f) const
		{
		return ((mNumerator*f.mDenominator) <= (f.mNumerator*mDenominator));
		}
template <class base_t>
int		
nmr_fraction<base_t>::operator<=(base_t l) const
		{
		return (mNumerator <= (l * mDenominator));
		}

template <class base_t>
int		
nmr_fraction<base_t>::operator!=(const nmr_fraction<base_t> &f) const
		{
		return ((mNumerator*f.mDenominator) != (f.mNumerator*mDenominator));
		}
template <class base_t>
int		
nmr_fraction<base_t>::operator!=(base_t l) const
		{
		return (mNumerator != (l * mDenominator));
		}


	//// CASTS
template <class base_t>
base_t	
nmr_fraction<base_t>::Numerator(void) const
		{
		return mNumerator;
		}
template <class base_t>
base_t	
nmr_fraction<base_t>::Denominator(void) const
		{
		return mDenominator;
		}


template <class base_t>
ostream& operator<<(ostream &o,const nmr_fraction<base_t> &f)
{
	o << f.Numerator() << "/" << f.Denominator();
	return o;
}

#endif