/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef	SAFE_OSTRSTREAM_H_
#define SAFE_OSTRSTREAM_H_

#include	<MegaHeaders.h>
#include <sstream>
using namespace std;

#if 1
class safe_ostrstream: public ostringstream
{

	CLASS_NOCOPY(safe_ostrstream)

public:
	safe_ostrstream(void);
	~safe_ostrstream(void);
	const char *str(void);

};

#else

// Metrowerks 11 forgot to include ostrstream. I hate them
#ifdef	__POWERPC__
class safe_ostrstream: public ostringstream
{
protected:
	basic_string<char,char_traits<char>, allocator<char> >	mResult;
#else
class safe_ostrstream: public ostrstream
{

protected:
	char	*mResult;
#endif

	CLASS_NOCOPY(safe_ostrstream)

public:
	safe_ostrstream(void);
	~safe_ostrstream(void);
	const char *str(void);

};
#endif

#endif

