/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include	<system_ticks.h>
#if ((!defined WIN32) && (!defined __POWERPC__))
#include	<sys/times.h>
#endif
#ifdef __POWERPC__
#include	<Timer.h>
#endif
#ifdef WIN32
#include <mmsystem.h>
#endif

#define MAC_MULTIPLIER	4294967296l

//////////////////////////////////////////////////////////////////////////////
// SystemTicks
//
// OUTPUT:
//	returns elapsed system ticks
///////////////////////////////////////////////////////////////////////////////
U32 SystemTicks(void)
{
#if (defined __POWERPC__)
	UnsignedWide	uw;
	Microseconds(&uw);
	double result = uw.hi;
	result *= MAC_MULTIPLIER;
	result += uw.lo;
	return (U32)result;
#elif (defined	WIN32)
	return timeGetTime();
#else
	{
	struct tms buf;
	return times(&buf); 
	}
#endif
}

U32 TicksPerSecond(void)
{
#if (defined __POWERPC__)
	return 1000000;
#elif (defined  WIN32)
	return 1000;
#else
	return sysconf(_SC_CLK_TCK);
#endif
}

// time in seconds
U32 SecondTime(void)
{
	return SystemTicks() / TicksPerSecond();
}

#ifndef	WIN32
U32 timeGetTime(void)
{
// return windows style time in milliseconds
#if (defined __POWERPC__)
	UnsignedWide	uw;
	Microseconds(&uw);
	double result = uw.hi;
	result *= MAC_MULTIPLIER;
	result += uw.lo;
	result /= 1000;
	return (U32) (result);
#else
	struct timeval	t;

	gettimeofday(&t,NULL);
	return ((t.tv_sec * 1000) + (t.tv_usec / 1000));
#endif
}
#endif



