/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*******************************************************************************\
*                                                                               *
* hfb_dpos.c -   multi-platform  AVI library                                    *
*               Copyright (c) 1994-99, The Duck Corp. All rights reserved.      * 
*
*                 Edited by:    Eric Ameres                                     *
*                 Version:      1.4                                             *
*                 Edited:       10/04/99                                        *
*						- added parameter checking and debug assertions
*
*
*                 Author:       Eric Ameres                                     *
*                 Version:      .95                                             *
*                 Created:      10/24/94                                        *
*                                                                               *
\*******************************************************************************/
#include <assert.h>
#include "dkpltfrm.h"
#include "duckwalk.h"

long lHFB_GetDataPosition(HFB_STREAM_HANDLE dckPtr,HFB_DATA_HANDLE chunkIndex)
{
	int i;
	long sampleCount=0,sampleSize;
	register DCKINDEXENTRY *lindx; 
	HFB_BUFFER_HANDLE bfr;
	int sNum;
	
	assert(dckPtr != NULL);
	if (!dckPtr) return -1L;

	assert(dckPtr->parent != NULL);
	if (!dckPtr->parent) return -1L;

	sampleSize = dckPtr->parent->sampleSize;
	bfr = dckPtr->parent->bfHnd;
	sNum = dckPtr->parent->streamNum;

	lindx = &(bfr->indx[0]);
    
	if (chunkIndex > -1)
	{ /* get the sample number of the specified chunk */
		if ( chunkIndex > bfr->indxCount)
			return -1L;

		for(i = 0; i <= chunkIndex; i++,lindx++)
			if (lindx->dckID == sNum)
			{
				if (sampleSize)
					sampleCount += lindx->dwChunkLength/sampleSize;
				else
					sampleCount++;
			}
		sampleCount--;
	}else
	{ /* get the position of the first unreleased sample */
		for(i = 0; i <= bfr->indxCount; i++,lindx++)
			if (lindx->dckID == sNum){
				if (!(lindx->dckFlags & DCKCHUNK_RELEASED))
					break;
				if (sampleSize)
					sampleCount += lindx->dwChunkLength/sampleSize;
				else
					sampleCount++;
			}
	}

	if (dckPtr->parent->streamType == DUK_AUDSTREAM) /* adjust for audio */
		if (dckPtr->parent->a.WaveformInfo.wFormatTag != 1)
			sampleCount *= dckPtr->parent->a.WaveformInfo.wSamplesPerBlock;
	
	return (sampleCount);
}
