/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*******************************************************************************\
*                                                                               *
* hfb_read.c -   multi-platform  AVI library                        *
*               Copyright (c) 1994-99, The Duck Corp. All rights reserved.      * 
*
*                 Edited by:    Eric Ameres                                     *
*                 Version:      1.4                                             *
*                 Edited:       10/04/99                                        *
                    - adding parameter checking and assertions
*                                                                               *
*                 Author:       Eric Ameres                                     *
*                 Version:      .95                                             *
*                 Created:      10/24/94                                        *
*                                                                               *
\*******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "dkpltfrm.h"
#include "duck_io.h"
#include "duckwalk.h"
#include "danbug.h"

/* unbuffered read from a stream, *Data and *MaxLength must be provided */
int lHFB_ReadData(HFB_STREAM_HANDLE dckPtr,void *data, long *length,enum dukDirect direction,int count)
{   
    int chunkIndex,ldirect;
    HFB_BUFFER_HANDLE bfr;
 dbgint1("HFB_ReadData:::::: A -- dckPtr = ",(int)dckPtr);
	if (direction == DUK_ABSOLUTE) {
 dbgout("about to try an 'fprintf', but I don't think so");

//	fprintf(stderr,"\n ABSOLUTE \n");
	dbgout("DUK_ABSOLUTE\n");
 dbgout("yaa, that suk'd");
	}

	assert(dckPtr != NULL);
 dbgout("HFB_ReadData: B\n");
	if (dckPtr == NULL)
		return HFB_ERROR;    /* -3 */
	
	assert(dckPtr->parent != NULL);
 dbgout("HFB_ReadData: C\n");
	if (dckPtr->parent == NULL)
		return HFB_ERROR;    /* -3 */

	assert(dckPtr->parent->fHnd != NULL);
 dbgout("HFB_ReadData: D\n");
	if (dckPtr->parent->fHnd == NULL)
		return HFB_ERROR;    /* -3 */

	bfr = dckPtr->parent->fHnd->bfHnd;

	if (direction == DUK_ABSOLUTE && count == 0)  /* MEW */
		dckPtr->lastSample = -1;
	else if (direction == DUK_ABSOLUTE)
		dckPtr->lastSample = 0;

	ldirect = direction ? direction : 1;
    
    do{
        chunkIndex = dckPtr->lastSample += ldirect;
    	            
        if (bfr->indx[chunkIndex].dckID == dckPtr->parent->streamNum)
            if (--count <= 0) break;
	                              
    }while((chunkIndex < bfr->indxCount) && (chunkIndex > -1));
	
	assert(length != NULL);
 dbgint1("HFB_ReadData: E -- length = ",(int)length); dbgout("\n");
	if ( !length )
		return HFB_ERROR;    /* -3 */

 dbgout("HFB_ReadData: E2\n");
	if ((chunkIndex > -1) && (chunkIndex < bfr->indxCount)){
		HFB_FILE_HANDLE fHnd = dckPtr->parent->fHnd;
 dbgout("HFB_ReadData: ---E2b\n");
    
		/* move to the record on the disk , please double check the error condition based on duck_seek */
///		if (slow_seek(fHnd->aviFile, fHnd->pos+bfr->indx[chunkIndex].dwChunkOffset+4, SEEK_SET) == -1) {
		if (duck_seek(fHnd->aviFile, fHnd->pos+bfr->indx[chunkIndex].dwChunkOffset+4, SEEK_SET) == -1) {
 dbgout("error: HFB_NOTREADY???\n");
			return HFB_NOTREADY; /* -2 */
		}

 dbgout("HFB_ReadData: E2c\n");
		/* limit the read to the size of the record */
		if (*length > (long)(bfr->indx[chunkIndex].dwChunkLength))
			*length = bfr->indx[chunkIndex].dwChunkLength;

 dbgout("HFB_ReadData: E2d\n");
		if (*length) /* if there is data and room, read the data */
		{
 dbgout("HFB_ReadData: E3\n");
   			gooseCD(fHnd->aviFile,*length);
			
			assert(data != NULL);
			
			if ( !data ) /* check for a "valid" (at least non-null) pointer */
				return HFB_ERROR;    /* -3 */

			if (duck_read(fHnd->aviFile, (unsigned char *) data, *length) == -1)
				return HFB_NOTREADY; /* -2 */
		}
		else /* if length is 0, just report the real length */
		{
 dbgout("HFB_ReadData: E4\n");
			*length = (long)(bfr->indx[chunkIndex].dwChunkLength);
		}

		/* if we didn't read a whole frame, return -2 (w/ data) */
 dbgout("HFB_ReadData: E5\n");
		if (*length < (long)(bfr->indx[chunkIndex].dwChunkLength))
			return HFB_PARTIALREAD;    /* -5 */
 dbgout("HFB_ReadData: E6\n");

    	return chunkIndex;
    }else {
 dbgout("HFB_ReadData: E7\n");
    	return HFB_ENDOFSTREAM; /* -1 */
	}
 dbgout("HFB_ReadData: exit\n");
}                                                                                      
