/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*******************************************************************************\
*                                                                               *
* windwalk.c -   multi-platform TrueMotion/S AVI library                        *
*               Copyright (c) 1994, The Duck Corp. All rights reserved.         * 
*
*                 Edited by:    Eric Ameres                                     *
*                 Version:      .97                                             *
*                 Edited:       01/25/94                                        *
                    - added adaptive datarate fill buffer routine
                    - removed unnecessary fillbuffering
*                                                                               *
*                 Author:       Eric Ameres                                     *
*                 Version:      .95                                             *
*                 Created:      10/24/94                                        *
*                                                                               *
\*******************************************************************************/
#include "dkpltfrm.h"
#include "duckwalk.h"

/* Routine counts the required number of chunks from here;
// Returns size of data.
// pass in count of frames, but this accumulates number of bytes in all relevant chunks
*/
int lHFB_WhatsAhead(HFB_STREAM_HANDLE sPtr, int StartChunk, int *horizon)
{
    HFB_BUFFER_HANDLE dckPtr = sPtr->parent->bfHnd;
    int i,frame = 0,streamNum = sPtr->parent->streamNum;
	int amountAhead = 0;
	int NumFrames = *horizon;

	++StartChunk;  /*start with next chunk in the buffer*/
	if (StartChunk > dckPtr->indxCount)	return 0;

	{
		DCKINDEXENTRY *lindx = &dckPtr->indx[StartChunk];
		
		for(i = 0; i < dckPtr->indxCount - StartChunk; i++,lindx++)	{ 
			/* find Index corresponding to frame */
    		amountAhead += lindx->dwChunkLength;
    		if (lindx->dckID == streamNum)
				if (++frame >= NumFrames) 
					break;
		}
	}

	if (frame != *horizon)	{
		int fred = 0;
	}
	*horizon = frame;		/* return number examined to build amount
							// could be cut down by end-of-file
							*/
	return amountAhead;
}
