/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/****************************************************************************

	Entry for "C" calls

****************************************************************************/
#ifndef WCOMPC_H
#define WCOMPC_H


#ifndef YUVINPUTBUFFERCONFIG
#define YUVINPUTBUFFERCONFIG
typedef struct
{
    int     YWidth;
    int     YHeight;
    int     YStride;

    int     UVWidth;
    int     UVHeight;
    int     UVStride;

    char *  YBuffer;
    char *  UBuffer;
    char *  VBuffer;

} YUV_INPUT_BUFFER_CONFIG;
#endif

#ifdef __cplusplus
extern "C" 
{
#endif

	void NewWC(void **wc);

	void DeleteWC(void **wc);

	int BeginCompressWC(
			void *wc,
			int ScreenWidth,
			int ScreenHeight,
			int Width,
			int Height,
			int XOffset,
			int YOffset);

	
	int CompressYUVWC(void *wc,
			YUV_INPUT_BUFFER_CONFIG *YuvInputData,
			unsigned char *OutputBufferPtr,
			unsigned char *ReconBufferPtr,
			int TargetSize);

	int CompressWC(void *wc,
			 unsigned char *InputData,
			 unsigned char *OutputBufferPtr,
			 unsigned char *ReconBufferPtr,
			 int TargetSize);

	int AnalyzeWC(void *wc,
			 unsigned char *InputData);


	void EndCompressWC(void *wc);


	int BeginDecompressWC(void *wc,
					  int ScreenWidth,
					  int ScreenHeight,
					  int Width,
					  int Height,
					  int XOffset,
					  int YOffset);

	int DecompressWC(void *wc,
			   unsigned char *InputBufferPtr,
			   unsigned char *OutputBufferPtr);


	void EndDecompressWC(void *wc);
#ifdef __cplusplus

	}
#endif

#endif