/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
//==========================================================================
//
//  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
//  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
//  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
//  PURPOSE.
//
//  Copyright (c) 1999 - 2001  On2 Technologies Inc. All Rights Reserved.
//
//--------------------------------------------------------------------------


#ifndef _duck_mem_h
#define _duck_mem_h

#include <stddef.h>

#include <assert.h>

#if defined(__cplusplus)
extern "C" {
#endif

typedef enum tmemtype {
	DMEM_GENERAL = 0,
	DMEM_TEMP,
	DMEM_CDBUFF,
	DMEM_FRAMEBUFF
} dmemType;

/* 
	size_t should be found in stddef.h on most compilers
	if necessary you can define this to be an unsigned int
*/

void *duck_malloc(size_t, dmemType);
void *duck_calloc(size_t, size_t, dmemType);
void duck_free(void *);

void *duck_memcpy(void *dest, const void *source, size_t length);
void *duck_memset(void *dest, int val , size_t length);
int duck_strcmp(const char *one, const char *two);


/* Open Sound made this necessary ... M.E.W. Nov 2001 */
void *duck_audiocpy(void *dest, const void *source, size_t length);



/* This is needed by Voxware and QDesign and is generally a good little routine to abstract ! */
void *duck_memmove( void *dest, const void *src, size_t count );



/**** applicable on some systems only ****/

void duck_MEM_Init(long dAddr,long dSize);
void duck_MEM_Reset(void);

/*****************************************/



/* use these defines if you want to check for memory leaks 			*/
/* will print info to stderr in such a way that it can easily be sorted out 	*/
/*------------------------------------------------------------------------------*/
#if 0
#define duck_calloc(size1,size2,type)   duck_calloc_log(size1,size2,type,__FILE__,__LINE__)
#define duck_malloc(size1,type)   duck_malloc_log(size1,type,__FILE__,__LINE__)
#define duck_free(ptr)		      duck_free_log(ptr,__FILE__,__LINE__)
#define LOG_ALLOC
#endif


#if defined(__cplusplus)
}
#endif
#endif
