/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/***********************************************\
??? duck_io.c
\***********************************************/

#include <stdio.h> 
#include <string.h>
/* #include <io.h> */
#include <fcntl.h>
#include "duck_io.h"
#include "duck_hfb.h"


int read_count;


int duck_readFinished(int han, int flag)
{
	return 1;
}


typedef  int (*DUCK_READ_FUNC)(int , unsigned char*, long)  ; 

DUCK_READ_FUNC s_read_special  = 0;



int duck_read_register(   DUCK_READ_FUNC read_special  )
{
	s_read_special = read_special;
}


int duck_open(const char *name, unsigned long userData)
{
    	int f;                                       
    	char filename[80];

	read_count = 0;

	f = open(name,O_RDONLY);
	return f;

}




void duck_close(int handle)
{
	close(handle);
}



long duck_read(int handle,unsigned char *buffer,long bytes)
{
	if (s_read_special)
		return s_read_special(handle, buffer, bytes);

	if (buffer == NULL){
		duck_seek(handle,bytes,SEEK_CUR);
		return bytes;
	}
		
	return(read(handle,buffer,bytes));
}


long duck_seek(int handle,long offset,int origin)
{

	return(lseek(handle,offset,origin));

	
}


