/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef IVAconvert_H_
#define IVAconvert_H_
#ifdef WIN32
#include "MegaHeaders.h"
#include "pmsio.h"
#include "pmsio_BITMAPINFO.h"

// converting IVA structs to windows structs and back again

// will not convert dynamic bits. Exception thrown if there are dynamic
// extensions
BITMAPINFO&			to_BITMAPINFO(BITMAPINFO &w,const pmsio_BITMAPINFO &iva);
BITMAPINFOHEADER&	to_BITMAPINFOHEADER(BITMAPINFOHEADER&,const pmsio_BITMAPINFOHEADER&);
WAVEFORMATEX&		to_WAVEFORMATEX(WAVEFORMATEX&,const pmsio_DKWAVEFORM&);

// "news" returned struct. WILL copy dynamic bits. You must delete it when you're done
// DANGER DANGER _ MUTANT. You must delete this as a char[] because that's how they're
// allocated (so they can be variable size)
BITMAPINFO*			to_BITMAPINFO(const pmsio_BITMAPINFO&);
BITMAPINFOHEADER*	to_BITMAPINFOHEADER(const pmsio_BITMAPINFOHEADER&);
WAVEFORMATEX*		to_WAVEFORMATEX(const pmsio_DKWAVEFORM&);

// WILL convert dynamic bits
pmsio_BITMAPINFO&		to_pmsio_BITMAPINFO(pmsio_BITMAPINFO&,const BITMAPINFO&);
pmsio_BITMAPINFOHEADER&	to_pmsio_BITMAPINFOHEADER(pmsio_BITMAPINFOHEADER&,const BITMAPINFOHEADER&);
pmsio_DKWAVEFORM&		to_pmsio_DKWAVEFORM(pmsio_DKWAVEFORM&,const WAVEFORMATEX&);

// "news" returned struct. You must delete it when you're done with it.
// (normal delete, it's not a mutant like the second set)
pmsio_BITMAPINFO*		to_pmsio_BITMAPINFO(const BITMAPINFO&);
pmsio_BITMAPINFOHEADER*	to_pmsio_BITMAPINFOHEADER(const BITMAPINFOHEADER &);
pmsio_DKWAVEFORM*		to_pmsio_DKWAVEFORM(const WAVEFORMATEX&);

#endif
#endif