ROOT=../..

include $(ROOT)/lib_makes/$(DIRECTORY)/header.mk


ifeq (WIN32,$(MACHINE))
INCSYM= /I
PERMANENT_FLAGS := $(PERMANENT_FLAGS) /DNODUKTYPES
else
PERMANENT_FLAGS := $(PERMANENT_FLAGS) -DNODUKTYPES
INCSYM= -I
endif

INCLUDES = 	\
			$(INCSYM)$(ROOT)/duckgeneral \

HEADER_FILES = \
	$(wildcard ../*.h) \
	$(wildcard $(ROOT)/duckgeneral/*.h) \

_LIB_NAME = iva
ifeq (WIN32,$(MACHINE))
DEBUG_LIB_NAME = $(_LIB_NAME)_g.lib
RELEASE_LIB_NAME = $(_LIB_NAME).lib
DEBUG_STATIC_LIB_NAME = $(_LIB_NAME)_gs.lib
RELEASE_STATIC_LIB_NAME = $(_LIB_NAME)_s.lib
else
DEBUG_LIB_NAME = lib$(_LIB_NAME)_g.a
RELEASE_LIB_NAME = lib$(_LIB_NAME).a
endif


SOURCE_FILES = \
	$(wildcard ../*.cxx) 

OBJECT_FILES = \
	$(addsuffix .o,$(basename $(notdir $(SOURCE_FILES))))

DEBUG_OBJECTS = \
	$(addprefix Debug/,$(OBJECT_FILES))

RELEASE_OBJECTS = \
	$(addprefix Release/,$(OBJECT_FILES))

ifeq (WIN32,$(MACHINE))

DEBUG_STATIC_OBJECTS = \
	$(addprefix Debug_Static/,$(OBJECT_FILES))

RELEASE_STATIC_OBJECTS = \
	$(addprefix Release_Static/,$(OBJECT_FILES))

endif


include $(ROOT)/lib_makes/$(DIRECTORY)/rules.mk
