/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef IVAIO_H_
#define IVAIO_H_

#ifndef WIN32
#include <unistd.h>
#endif

class ivaIO
{
public:
	typedef enum { SET, CUR, END } Seek_t;
	typedef enum { READ, WRITE, READWRITE } OpenMode_t;
	typedef long FilePosition_t;
	typedef long SeekOffset_t;
	static FilePosition_t	sFilePositionError;
	static SeekOffset_t		sSeekOffsetError;
		// return bytes read
	virtual int	Read(void *buffer,size_t amt) = 0;
		// return bytes written
	virtual int	Write(void *buffer,size_t amt) = 0;
		// return false if error
	virtual bool	Open(const char *filename,OpenMode_t mode) = 0;
		// return false if error
	virtual bool	Close(void) = 0;
		// return new offset or sSeekOffsetError
	virtual SeekOffset_t Seek(SeekOffset_t offset,Seek_t seek_type) = 0;
	// return sFilePositionError if failure
	virtual FilePosition_t Getpos(void) = 0;
	virtual bool	IsOpen(void) const = 0;
};

#endif
