/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef pmsio_h_included
#define pmsio_h_included

//	This is a generated file: DO NOT EDIT!
//	generated Mon Dec  8 03:32:18 EST 1997 by ./generate_io_classes for rojer

// *** tough noogies, I'm gonna edit it .... NMR
#ifndef WIN32
#include <unistd.h>
#endif

#include <stddef.h> //added for size_t definition

#include <iostream>
class ivaIO;

typedef unsigned long pmsio_FCC;
typedef unsigned long pmsio_dword;
typedef long pmsio_long;
typedef unsigned long pmsio_ulong;
typedef long pmsio_long;
typedef unsigned short pmsio_word;
typedef unsigned long pmsio_uint;
typedef short pmsio_short;
typedef unsigned short pmsio_ushort;
typedef long pmsio_int;
typedef unsigned char pmsio_byte;

struct pmsio_DKWAVEFORM {
public:
	// members...
	pmsio_ushort	wFormatTag;
	pmsio_ushort	nChannels;
	pmsio_ulong	nSamplesPerSec;
	pmsio_ulong	nAvgBytesPerSec;
	pmsio_ushort	nBlockAlign;
	pmsio_ushort	wBitsPerSample;
	pmsio_ushort	cbSize;
	char*			mExtraData;
private:
	void	copy_to_me(const pmsio_DKWAVEFORM &d);
	static int read_from_sub_buffer(const pmsio_byte*, pmsio_DKWAVEFORM*);
	int write_to_sub_buffer(pmsio_byte*) const;
public: // class members/methods...
	//enum {_size = 20};
	enum {_base_size = 18};

	pmsio_DKWAVEFORM();
	pmsio_DKWAVEFORM(const pmsio_DKWAVEFORM &);
	pmsio_DKWAVEFORM& operator=(const pmsio_DKWAVEFORM &p);
	~pmsio_DKWAVEFORM();
	pmsio_DKWAVEFORM *clone() const;

	//static int size() {return _base_size + cbSize;}
	static int read(ivaIO&, pmsio_DKWAVEFORM*);
	static int read_from_buffer(const pmsio_byte*, pmsio_DKWAVEFORM*);
	int write(ivaIO&) const;
	int write_to_buffer(pmsio_byte*) const;
	void show(std::ostream&, unsigned int level=0) const;
	// for compatibility with frame...
	size_t length() const {return _base_size + cbSize;}
};
inline std::ostream& operator<<(std::ostream &os, const pmsio_DKWAVEFORM& s) {
	s.show(os);
	return os;
}

struct pmsio_RECT {
public:
	// members...
	pmsio_ushort	left;
	pmsio_ushort	top;
	pmsio_ushort	right;
	pmsio_ushort	bottom;
public: // class members/methods...
	enum {_size = 8};
	static int size() {return _size;}
	static int read(ivaIO&, pmsio_RECT*);
	static int read_from_buffer(const pmsio_byte*, pmsio_RECT*);
	int write(ivaIO&) const;
	int write_to_buffer(pmsio_byte*) const;
	void show(std::ostream&, unsigned int level=0) const;
	// for compatibility with frame...
	size_t length() const {return _size;}
	pmsio_RECT *clone() const {return new pmsio_RECT(*this);}
};
inline std::ostream& operator<<(std::ostream &os, const pmsio_RECT& s) {
	s.show(os);
	return os;
}

struct pmsio_BITMAP {
public:
	// members...
	pmsio_int	bmType;
	pmsio_int	bmWidth;
	pmsio_int	bmHeight;
	pmsio_int	bmWidthBytes;
	pmsio_byte	bmPlanes;
	pmsio_byte	bmBitsPixel;
public: // class members/methods...
	enum {_size = 18};
	static int size() {return _size;}
	static int read(ivaIO&, pmsio_BITMAP*);
	static int read_from_buffer(const pmsio_byte*, pmsio_BITMAP*);
	int write(ivaIO&) const;
	int write_to_buffer(pmsio_byte*) const;
	void show(std::ostream&, unsigned int level=0) const;
	// for compatibility with frame...
	size_t length() const {return _size;}
	pmsio_BITMAP *clone() const {return new pmsio_BITMAP(*this);}
};
inline std::ostream& operator<<(std::ostream &os, const pmsio_BITMAP& s) {
	s.show(os);
	return os;
}

struct pmsio_RGBTRIPLE {
public:
	// members...
	pmsio_byte	rgbtBlue;
	pmsio_byte	rgbtGreen;
	pmsio_byte	rgbtRed;
public: // class members/methods...
	enum {_size = 3};
	static int size() {return _size;}
	static int read(ivaIO&, pmsio_RGBTRIPLE*);
	static int read_from_buffer(const pmsio_byte*, pmsio_RGBTRIPLE*);
	int write(ivaIO&) const;
	int write_to_buffer(pmsio_byte*) const;
	void show(std::ostream&, unsigned int level=0) const;
	// for compatibility with frame...
	size_t length() const {return _size;}
	pmsio_RGBTRIPLE *clone() const {return new pmsio_RGBTRIPLE(*this);}
};
inline std::ostream& operator<<(std::ostream &os, const pmsio_RGBTRIPLE& s) {
	s.show(os);
	return os;
}

struct pmsio_RGBQUAD {
public:
	// members...
	pmsio_byte	rgbBlue;
	pmsio_byte	rgbGreen;
	pmsio_byte	rgbRed;
	pmsio_byte	rgbReserved;
public: // class members/methods...
	enum {_size = 4};
	static int size() {return _size;}
	static int read(ivaIO&, pmsio_RGBQUAD*);
	static int read_from_buffer(const pmsio_byte*, pmsio_RGBQUAD*);
	int write(ivaIO&) const;
	int write_to_buffer(pmsio_byte*) const;
	void show(std::ostream&, unsigned int level=0) const;
	// for compatibility with frame...
	size_t length() const {return _size;}
	pmsio_RGBQUAD *clone() const {return new pmsio_RGBQUAD(*this);}
};
inline std::ostream& operator<<(std::ostream &os, const pmsio_RGBQUAD& s) {
	s.show(os);
	return os;
}

struct pmsio_BITMAPCOREHEADER {
public:
	// members...
	pmsio_dword	bcSize;
	pmsio_short	bcWidth;
	pmsio_short	bcHeight;
	pmsio_word	bcPlanes;
	pmsio_word	bcBitCount;
public: // class members/methods...
	enum {_size = 12};
	static int size() {return _size;}
	static int read(ivaIO&, pmsio_BITMAPCOREHEADER*);
	static int read_from_buffer(const pmsio_byte*, pmsio_BITMAPCOREHEADER*);
	int write(ivaIO&) const;
	int write_to_buffer(pmsio_byte*) const;
	void show(std::ostream&, unsigned int level=0) const;
	// for compatibility with frame...
	size_t length() const {return _size;}
	pmsio_BITMAPCOREHEADER *clone() const {return new pmsio_BITMAPCOREHEADER(*this);}
};
inline std::ostream& operator<<(std::ostream &os, const pmsio_BITMAPCOREHEADER& s) {
	s.show(os);
	return os;
}

struct pmsio_BITMAPINFOHEADER {
public:
	// members...
	pmsio_dword	biSize;
	pmsio_long	biWidth;
	pmsio_long	biHeight;
	pmsio_word	biPlanes;
	pmsio_word	biBitCount;
	pmsio_dword	biCompression;
	pmsio_dword	biSizeImage;
	pmsio_long	biXPelsPerMeter;
	pmsio_long	biYPelsPerMeter;
	pmsio_dword	biClrUsed;
	pmsio_dword	biClrImportant;
public: // class members/methods...
	enum {_size = 40};
	static int size() {return _size;}
	static int read(ivaIO&, pmsio_BITMAPINFOHEADER*);
	static int read_from_buffer(const pmsio_byte*, pmsio_BITMAPINFOHEADER*);
	int write(ivaIO&) const;
	int write_to_buffer(pmsio_byte*) const;
	void show(std::ostream&, unsigned int level=0) const;
	// for compatibility with frame...
	size_t length() const {return _size;}
	pmsio_BITMAPINFOHEADER *clone() const {return new pmsio_BITMAPINFOHEADER(*this);}
};
inline std::ostream& operator<<(std::ostream &os, const pmsio_BITMAPINFOHEADER& s) {
	s.show(os);
	return os;
}

struct pmsio_BITMAPCOREINFO {
public:
	// members...
	pmsio_BITMAPCOREHEADER	bmciHeader;
	pmsio_RGBTRIPLE	bmciColors[1];
public: // class members/methods...
	enum {_size = 15};
	static int size() {return _size;}
	static int read(ivaIO&, pmsio_BITMAPCOREINFO*);
	static int read_from_buffer(const pmsio_byte*, pmsio_BITMAPCOREINFO*);
	int write(ivaIO&) const;
	int write_to_buffer(pmsio_byte*) const;
	void show(std::ostream&, unsigned int level=0) const;
	// for compatibility with frame...
	size_t length() const {return _size;}
	pmsio_BITMAPCOREINFO *clone() const {return new pmsio_BITMAPCOREINFO(*this);}
};
inline std::ostream& operator<<(std::ostream &os, const pmsio_BITMAPCOREINFO& s) {
	s.show(os);
	return os;
}

struct pmsio_BITMAPFILEHEADER {
public:
	// members...
	pmsio_uint	bfType;
	pmsio_dword	bfSize;
	pmsio_uint	bfReserved1;
	pmsio_uint	bfReserved2;
	pmsio_dword	bfOffBits;
public: // class members/methods...
	enum {_size = 20};
	static int size() {return _size;}
	static int read(ivaIO&, pmsio_BITMAPFILEHEADER*);
	static int read_from_buffer(const pmsio_byte*, pmsio_BITMAPFILEHEADER*);
	int write(ivaIO&) const;
	int write_to_buffer(pmsio_byte*) const;
	void show(std::ostream&, unsigned int level=0) const;
	// for compatibility with frame...
	size_t length() const {return _size;}
	pmsio_BITMAPFILEHEADER *clone() const {return new pmsio_BITMAPFILEHEADER(*this);}
};
inline std::ostream& operator<<(std::ostream &os, const pmsio_BITMAPFILEHEADER& s) {
	s.show(os);
	return os;
}

struct pmsio_PALETTEENTRY {
public:
	// members...
	pmsio_byte	peRed;
	pmsio_byte	peGreen;
	pmsio_byte	peBlue;
	pmsio_byte	peFlags;
public: // class members/methods...
	enum {_size = 4};
	static int size() {return _size;}
	static int read(ivaIO&, pmsio_PALETTEENTRY*);
	static int read_from_buffer(const pmsio_byte*, pmsio_PALETTEENTRY*);
	int write(ivaIO&) const;
	int write_to_buffer(pmsio_byte*) const;
	void show(std::ostream&, unsigned int level=0) const;
	// for compatibility with frame...
	size_t length() const {return _size;}
	pmsio_PALETTEENTRY *clone() const {return new pmsio_PALETTEENTRY(*this);}
};
inline std::ostream& operator<<(std::ostream &os, const pmsio_PALETTEENTRY& s) {
	s.show(os);
	return os;
}

struct pmsio_MainAVIHeader {
public:
	// members...
	pmsio_dword	dwMicroSecPerFrame;
	pmsio_dword	dwMaxBytesPerSec;
	pmsio_dword	dwPaddingGranularity;
	pmsio_dword	dwFlags;
	pmsio_dword	dwTotalFrames;
	pmsio_dword	dwInitialFrames;
	pmsio_dword	dwStreams;
	pmsio_dword	dwSuggestedBufferSize;
	pmsio_dword	dwWidth;
	pmsio_dword	dwHeight;
	pmsio_dword	dwReserved[4];
public: // class members/methods...
	enum {_size = 56};
	static int size() {return _size;}
	static int read(ivaIO&, pmsio_MainAVIHeader*);
	static int read_from_buffer(const pmsio_byte*, pmsio_MainAVIHeader*);
	int write(ivaIO&) const;
	int write_to_buffer(pmsio_byte*) const;
	void show(std::ostream&, unsigned int level=0) const;
	// for compatibility with frame...
	size_t length() const {return _size;}
	pmsio_MainAVIHeader *clone() const {return new pmsio_MainAVIHeader(*this);}
};
inline std::ostream& operator<<(std::ostream &os, const pmsio_MainAVIHeader& s) {
	s.show(os);
	return os;
}

struct pmsio_AVIStreamHeader {
public:
	// members...
	pmsio_FCC	fccType;
	pmsio_FCC	fccHandler;
	pmsio_dword	dwFlags;
	pmsio_word	wPriority;
	pmsio_word	wLanguage;
	pmsio_dword	dwInitialFrames;
	pmsio_dword	dwScale;
	pmsio_dword	dwRate;
	pmsio_dword	dwStart;
	pmsio_dword	dwLength;
	pmsio_dword	dwSuggestedBufferSize;
	pmsio_dword	dwQuality;
	pmsio_dword	dwSampleSize;
	pmsio_RECT	rcFrame;
public: // class members/methods...
	enum {_size = 56};
	static int size() {return _size;}
	static int read(ivaIO&, pmsio_AVIStreamHeader*);
	static int read_from_buffer(const pmsio_byte*, pmsio_AVIStreamHeader*);
	int write(ivaIO&) const;
	int write_to_buffer(pmsio_byte*) const;
	void show(std::ostream&, unsigned int level=0) const;
	// for compatibility with frame...
	size_t length() const {return _size;}
	pmsio_AVIStreamHeader *clone() const {return new pmsio_AVIStreamHeader(*this);}
};
inline std::ostream& operator<<(std::ostream &os, const pmsio_AVIStreamHeader& s) {
	s.show(os);
	return os;
}

struct pmsio_AVIINDEXENTRY {
public:
	// members...
	pmsio_dword	ckid;
	pmsio_dword	dwFlags;
	pmsio_dword	dwChunkOffset;
	pmsio_dword	dwChunkLength;
public: // class members/methods...
	enum {_size = 16};
	static int size() {return _size;}
	static int read(ivaIO&, pmsio_AVIINDEXENTRY*);
	static int read_from_buffer(const pmsio_byte*, pmsio_AVIINDEXENTRY*);
	int write(ivaIO&) const;
	int write_to_buffer(pmsio_byte*) const;
	void show(std::ostream&, unsigned int level=0) const;
	// for compatibility with frame...
	size_t length() const {return _size;}
	pmsio_AVIINDEXENTRY *clone() const {return new pmsio_AVIINDEXENTRY(*this);}
};
inline std::ostream& operator<<(std::ostream &os, const pmsio_AVIINDEXENTRY& s) {
	s.show(os);
	return os;
}

struct pmsio_AVIPALCHANGE {
public:
	// members...
	pmsio_byte	bFirstEntry;
	pmsio_byte	bNumEntries;
	pmsio_word	wFlags;
	pmsio_PALETTEENTRY	peNew[1];
public: // class members/methods...
	enum {_size = 8};
	static int size() {return _size;}
	static int read(ivaIO&, pmsio_AVIPALCHANGE*);
	static int read_from_buffer(const pmsio_byte*, pmsio_AVIPALCHANGE*);
	int write(ivaIO&) const;
	int write_to_buffer(pmsio_byte*) const;
	void show(std::ostream&, unsigned int level=0) const;
	// for compatibility with frame...
	size_t length() const {return _size;}
	pmsio_AVIPALCHANGE *clone() const {return new pmsio_AVIPALCHANGE(*this);}
};
inline std::ostream& operator<<(std::ostream &os, const pmsio_AVIPALCHANGE& s) {
	s.show(os);
	return os;
}


#endif // pmsio_h_included
