/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef pmsio_BITMAPINFO_included
#define pmsio_BITMAPINFO_included

// $Id: pmsio_BITMAPINFO.h,v 1.1 2001/12/12 18:47:57 nradisch Exp $
// special handling for this dude since it's got a variably sized palette...
//
// Alan S. Rojer
// The Duck Corp.
// Thu Nov  6 06:03:08 EST 1997

#include "pmsio.h"

struct pmsio_BITMAPINFO {
public:
	// members...
	pmsio_BITMAPINFOHEADER	bmiHeader;
	pmsio_RGBQUAD	*bmiColors;
public:
	// factory...
	pmsio_BITMAPINFO();
	pmsio_BITMAPINFO(const pmsio_BITMAPINFO &);
	pmsio_BITMAPINFO& operator=(const pmsio_BITMAPINFO &p);
	~pmsio_BITMAPINFO();
	pmsio_BITMAPINFO *clone() const;
private:
	void clone_palette_from(const pmsio_BITMAPINFO &p);
public: // class members/methods...
	static int read(ivaIO&, pmsio_BITMAPINFO*);
	static int read_from_buffer(const pmsio_byte*, pmsio_BITMAPINFO*);
	int write(ivaIO&) const;
	void show(std::ostream&, unsigned int level=0) const;
	// for compatibility with frame...
	size_t length() const {
		return pmsio_BITMAPINFOHEADER::size() 
			+ bmiHeader.biClrUsed * pmsio_RGBQUAD::size();
	}
};
inline std::ostream& operator<<(std::ostream &os, const pmsio_BITMAPINFO& s) {
	s.show(os);
	return os;
}

#endif // pmsio_BITMAPINFO_included
