/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// $Id: sclrFormat.cxx,v 1.1 2001/12/12 18:47:57 nradisch Exp $ 
//
// Alan S. Rojer
// The Duck Corp.
// 23 Aug 1997

#include <memory.h>
#include "sclrFormat.h"

#ifdef __POWERPC__
#include <string.h>	//For mempcy
#endif

void
riffFormat::prefix(std::ostream &os, unsigned int level)
{
	for(unsigned int i=0; i<level; i++) os << '\t';
}


// the special case that makes all this garf necessary...
void riffFormat::a_FCC(std::ostream& os, unsigned long fcc, unsigned int level)
{
	prefix(os, level);
	char buffer[4];
	memcpy(buffer, &fcc, sizeof(buffer));
	for (int i=0; i<4; i++) os << buffer[i];
}

void riffFormat::a_dword(std::ostream& os, unsigned long u, unsigned int level)
{
	prefix(os, level);
	os << u;
}

void riffFormat::a_long(std::ostream& os, long i, unsigned int level)
{
	prefix(os, level);
	os << i;
}

void riffFormat::a_word(std::ostream& os, unsigned short u, unsigned int level)
{
	prefix(os, level);
	os << u;
}

void riffFormat::a_uint(std::ostream& os, unsigned long u, unsigned int level)
{
	prefix(os, level);
	os << u;
}

void riffFormat::a_short(std::ostream& os, short i, unsigned int level)
{
	prefix(os, level);
	os << i;
}

void riffFormat::a_int(std::ostream& os, long i, unsigned int level)
{
	prefix(os, level);
	os << i;
}

void riffFormat::a_byte(std::ostream& os, unsigned char u, unsigned int level)
{
	prefix(os, level);
	os << u;
}

void riffFormat::a_ushort(std::ostream& os, unsigned short u, unsigned int level)
{
	prefix(os, level);
	os << u;
}

void riffFormat::a_ulong(std::ostream& os, unsigned long u, unsigned int level)
{
	prefix(os, level);
	os << u;
}
