/*  Copyright (c) 1994-2002 by On2 Technologies, The Duck Corporation Inc.

    This file is part of VpVision.

    VpVision is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License ver. 2,
    as published by the Free Software Foundation (www.fsf.org).

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VpVision; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef IVAWRITERFAST_H_
#define IVAWRITERFAST_H_

#include "iva_Writer.h"
#include "ivaIOstandard.h"
#include "CCMutex.h"
#include "CConditionVariable.h"
#include "CCThread.h"

class ivaWriterFast: public iva_Writer
{
private:
	int		mAmtWrittenToDisk;
	ivaIOstandard	mIO;
	char		*mFileName;
	HANDLE		mFileHandle;
	char		*mMasterBuffer,*mBuffer,*mEndOfBuffer,*mDynamicEndOfBuffer;
	char		*mWritePtr;
	char		*mReadPtr;
	CConditionVariable	mWaitingForData;
	CConditionVariable	mWaitingForSpace;
	CCMutex				mBufferMutex;
	CCMutex				mOutstandingFrameLock;

	void	AddJunk(size_t basis,char* &where);


	class ivaWriterThread: public CCThread
	{

	public:
		ivaWriterFast	&mWriter;
		int				mStop;

		ivaWriterThread(ivaWriterFast &w)
			: mWriter(w),mStop(0){}
		virtual	void	Run();
	};
	ivaWriterThread		*mThread;

public:
	// factory methods...
	ivaWriterFast(const ivaHeader &header);
	~ivaWriterFast();
public:
	// ivaFile methods...
	virtual bool open(const char *fname);
	virtual int is_open() const; 
	virtual int close(int recalc = 0);
public:
	// for use by the other guys in here...
	virtual int put_frame(ffirFCC, const ivaFrame &, int is_key);
	virtual	ivaFrame *get_frame(size_t siz);
	virtual int		return_frame(ffirFCC, ivaFrame *f,int is_key);

	// needed for filter
	void	abort_outstanding_frame();

	friend ivaWriterThread;
};


#endif
